#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 5
#define STATE_COUNT 1717
#define SYMBOL_COUNT 120
#define ALIAS_COUNT 2
#define TOKEN_COUNT 77
#define EXTERNAL_TOKEN_COUNT 12
#define MAX_ALIAS_SEQUENCE_LENGTH 7

enum {
  sym__simple_heredoc = 1,
  sym__heredoc_beginning = 2,
  sym__heredoc_middle = 3,
  sym__heredoc_end = 4,
  sym_file_descriptor = 5,
  sym_word = 6,
  sym__empty_value = 7,
  sym__concat = 8,
  sym_variable_name = 9,
  anon_sym_for = 10,
  anon_sym_in = 11,
  anon_sym_while = 12,
  anon_sym_do = 13,
  anon_sym_done = 14,
  anon_sym_if = 15,
  anon_sym_then = 16,
  anon_sym_fi = 17,
  anon_sym_elif = 18,
  anon_sym_else = 19,
  anon_sym_case = 20,
  anon_sym_esac = 21,
  anon_sym_PIPE = 22,
  anon_sym_RPAREN = 23,
  anon_sym_SEMI_SEMI = 24,
  anon_sym_function = 25,
  anon_sym_LPAREN = 26,
  anon_sym_LBRACE = 27,
  anon_sym_RBRACE = 28,
  anon_sym_PIPE_AMP = 29,
  anon_sym_AMP_AMP = 30,
  anon_sym_PIPE_PIPE = 31,
  anon_sym_declare = 32,
  anon_sym_typeset = 33,
  anon_sym_export = 34,
  anon_sym_readonly = 35,
  anon_sym_local = 36,
  anon_sym_EQ = 37,
  anon_sym_PLUS_EQ = 38,
  anon_sym_LBRACK = 39,
  anon_sym_RBRACK = 40,
  anon_sym_LT = 41,
  anon_sym_GT = 42,
  anon_sym_GT_GT = 43,
  anon_sym_AMP_GT = 44,
  anon_sym_AMP_GT_GT = 45,
  anon_sym_LT_AMP = 46,
  anon_sym_GT_AMP = 47,
  anon_sym_LT_LT = 48,
  anon_sym_LT_LT_DASH = 49,
  anon_sym_DQUOTE = 50,
  sym__string_content = 51,
  sym_raw_string = 52,
  anon_sym_DOLLAR = 53,
  anon_sym_DOLLAR_LBRACE = 54,
  anon_sym_POUND = 55,
  anon_sym_AT = 56,
  anon_sym_COLON = 57,
  anon_sym_COLON_QMARK = 58,
  anon_sym_COLON_DASH = 59,
  anon_sym_PERCENT = 60,
  anon_sym_SLASH = 61,
  anon_sym_DOLLAR_LPAREN = 62,
  anon_sym_BQUOTE = 63,
  anon_sym_LT_LPAREN = 64,
  anon_sym_GT_LPAREN = 65,
  sym_comment = 66,
  sym_identifier = 67,
  anon_sym_STAR = 68,
  anon_sym_QMARK = 69,
  anon_sym_DASH = 70,
  anon_sym_BANG = 71,
  anon_sym_0 = 72,
  anon_sym__ = 73,
  anon_sym_SEMI = 74,
  anon_sym_LF = 75,
  anon_sym_AMP = 76,
  sym_program = 77,
  sym__terminated_statement = 78,
  sym_for_statement = 79,
  sym_while_statement = 80,
  sym_do_group = 81,
  sym_if_statement = 82,
  sym_elif_clause = 83,
  sym_else_clause = 84,
  sym_case_statement = 85,
  sym_case_item = 86,
  sym_function_definition = 87,
  sym_compound_statement = 88,
  sym_subshell = 89,
  sym_pipeline = 90,
  sym_list = 91,
  sym_command = 92,
  sym_command_name = 93,
  sym_variable_assignment = 94,
  sym_declaration_command = 95,
  sym__assignment = 96,
  sym_subscript = 97,
  sym_file_redirect = 98,
  sym_heredoc_redirect = 99,
  sym_heredoc = 100,
  sym_concatenation = 101,
  sym_string = 102,
  sym_array = 103,
  sym_simple_expansion = 104,
  sym_expansion = 105,
  sym_command_substitution = 106,
  sym_process_substitution = 107,
  sym_special_variable_name = 108,
  aux_sym_program_repeat1 = 109,
  aux_sym_for_statement_repeat1 = 110,
  aux_sym_if_statement_repeat1 = 111,
  aux_sym_case_statement_repeat1 = 112,
  aux_sym_case_item_repeat1 = 113,
  aux_sym_command_repeat1 = 114,
  aux_sym_command_repeat2 = 115,
  aux_sym_declaration_command_repeat1 = 116,
  aux_sym_heredoc_repeat1 = 117,
  aux_sym_concatenation_repeat1 = 118,
  aux_sym_string_repeat1 = 119,
  alias_sym_variable_name = 120,
  alias_sym_word = 121,
};

static const char *ts_symbol_names[] = {
  [sym__simple_heredoc] = "_simple_heredoc",
  [sym__heredoc_beginning] = "_heredoc_beginning",
  [sym__heredoc_middle] = "_heredoc_middle",
  [sym__heredoc_end] = "_heredoc_end",
  [sym_file_descriptor] = "file_descriptor",
  [sym_word] = "word",
  [sym__empty_value] = "_empty_value",
  [sym__concat] = "_concat",
  [sym_variable_name] = "variable_name",
  [ts_builtin_sym_end] = "END",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_done] = "done",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_fi] = "fi",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_case] = "case",
  [anon_sym_esac] = "esac",
  [anon_sym_PIPE] = "|",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SEMI_SEMI] = ";;",
  [anon_sym_function] = "function",
  [anon_sym_LPAREN] = "(",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_PIPE_AMP] = "|&",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_declare] = "declare",
  [anon_sym_typeset] = "typeset",
  [anon_sym_export] = "export",
  [anon_sym_readonly] = "readonly",
  [anon_sym_local] = "local",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_GT] = "&>",
  [anon_sym_AMP_GT_GT] = "&>>",
  [anon_sym_LT_AMP] = "<&",
  [anon_sym_GT_AMP] = ">&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_LT_LT_DASH] = "<<-",
  [anon_sym_DQUOTE] = "\"",
  [sym__string_content] = "_string_content",
  [sym_raw_string] = "raw_string",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_POUND] = "#",
  [anon_sym_AT] = "@",
  [anon_sym_COLON] = ":",
  [anon_sym_COLON_QMARK] = ":?",
  [anon_sym_COLON_DASH] = ":-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_SLASH] = "/",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_LT_LPAREN] = "<(",
  [anon_sym_GT_LPAREN] = ">(",
  [sym_comment] = "comment",
  [sym_identifier] = "identifier",
  [anon_sym_STAR] = "*",
  [anon_sym_QMARK] = "?",
  [anon_sym_DASH] = "-",
  [anon_sym_BANG] = "!",
  [anon_sym_0] = "0",
  [anon_sym__] = "_",
  [anon_sym_SEMI] = ";",
  [anon_sym_LF] = "\n",
  [anon_sym_AMP] = "&",
  [sym_program] = "program",
  [sym__terminated_statement] = "_terminated_statement",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_group] = "do_group",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_case_statement] = "case_statement",
  [sym_case_item] = "case_item",
  [sym_function_definition] = "function_definition",
  [sym_compound_statement] = "compound_statement",
  [sym_subshell] = "subshell",
  [sym_pipeline] = "pipeline",
  [sym_list] = "list",
  [sym_command] = "command",
  [sym_command_name] = "command_name",
  [sym_variable_assignment] = "variable_assignment",
  [sym_declaration_command] = "declaration_command",
  [sym__assignment] = "_assignment",
  [sym_subscript] = "subscript",
  [sym_file_redirect] = "file_redirect",
  [sym_heredoc_redirect] = "heredoc_redirect",
  [sym_heredoc] = "heredoc",
  [sym_concatenation] = "concatenation",
  [sym_string] = "string",
  [sym_array] = "array",
  [sym_simple_expansion] = "simple_expansion",
  [sym_expansion] = "expansion",
  [sym_command_substitution] = "command_substitution",
  [sym_process_substitution] = "process_substitution",
  [sym_special_variable_name] = "special_variable_name",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_case_item_repeat1] = "case_item_repeat1",
  [aux_sym_command_repeat1] = "command_repeat1",
  [aux_sym_command_repeat2] = "command_repeat2",
  [aux_sym_declaration_command_repeat1] = "declaration_command_repeat1",
  [aux_sym_heredoc_repeat1] = "heredoc_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [alias_sym_variable_name] = "variable_name",
  [alias_sym_word] = "word",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym__simple_heredoc] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_beginning] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_middle] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_end] = {
    .visible = false,
    .named = true,
  },
  [sym_file_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym_word] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_value] = {
    .visible = false,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_done] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_esac] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_raw_string] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__terminated_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_group] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_pipeline] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command_name] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_command] = {
    .visible = true,
    .named = true,
  },
  [sym__assignment] = {
    .visible = false,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_file_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_command_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_process_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_special_variable_name] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_item_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_word] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[9][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_word,
  },
  [2] = {
    [0] = alias_sym_variable_name,
  },
  [3] = {
    [1] = alias_sym_word,
  },
  [4] = {
    [1] = alias_sym_variable_name,
  },
  [5] = {
    [2] = alias_sym_word,
  },
  [6] = {
    [2] = alias_sym_variable_name,
  },
  [7] = {
    [1] = alias_sym_variable_name,
    [3] = alias_sym_word,
  },
  [8] = {
    [3] = alias_sym_word,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '%')
        ADVANCE(9);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '*')
        ADVANCE(18);
      if (lookahead == '+')
        ADVANCE(19);
      if (lookahead == '-')
        ADVANCE(21);
      if (lookahead == '/')
        ADVANCE(22);
      if (lookahead == '0')
        ADVANCE(23);
      if (lookahead == ':')
        ADVANCE(25);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(35);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '?')
        ADVANCE(40);
      if (lookahead == '@')
        ADVANCE(41);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        SKIP(43);
      if (lookahead == ']')
        ADVANCE(44);
      if (lookahead == '_')
        ADVANCE(45);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == 'c')
        ADVANCE(47);
      if (lookahead == 'd')
        ADVANCE(51);
      if (lookahead == 'e')
        ADVANCE(61);
      if (lookahead == 'f')
        ADVANCE(75);
      if (lookahead == 'i')
        ADVANCE(86);
      if (lookahead == 'l')
        ADVANCE(88);
      if (lookahead == 'r')
        ADVANCE(93);
      if (lookahead == 't')
        ADVANCE(101);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '{')
        ADVANCE(113);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '}')
        ADVANCE(117);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      if (('1' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(7);
      if (lookahead == '{')
        ADVANCE(8);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(11);
      if (lookahead == '>')
        ADVANCE(12);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_AMP_GT);
      if (lookahead == '>')
        ADVANCE(13);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_AMP_GT_GT);
      END_STATE();
    case 14:
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead != 0)
        ADVANCE(14);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(sym_raw_string);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 19:
      if (lookahead == '=')
        ADVANCE(20);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(26);
      if (lookahead == '?')
        ADVANCE(27);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == ';')
        ADVANCE(29);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_SEMI_SEMI);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(31);
      if (lookahead == '(')
        ADVANCE(32);
      if (lookahead == '<')
        ADVANCE(33);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_LT_AMP);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '-')
        ADVANCE(34);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(37);
      if (lookahead == '(')
        ADVANCE(38);
      if (lookahead == '>')
        ADVANCE(39);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_GT_AMP);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 43:
      if (lookahead == '\n')
        SKIP(0);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(50);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_case);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(52);
      if (lookahead == 'o')
        ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c')
        ADVANCE(53);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(54);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(56);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_declare);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_done);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(62);
      if (lookahead == 's')
        ADVANCE(67);
      if (lookahead == 'x')
        ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(63);
      if (lookahead == 's')
        ADVANCE(65);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f')
        ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_elif);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(66);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_else);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c')
        ADVANCE(69);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_esac);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p')
        ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(72);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_export);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(76);
      if (lookahead == 'o')
        ADVANCE(77);
      if (lookahead == 'u')
        ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_fi);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_for);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c')
        ADVANCE(81);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(82);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(83);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(84);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(85);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_function);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f')
        ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_if);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(89);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c')
        ADVANCE(90);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(91);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(92);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_local);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(94);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(95);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd')
        ADVANCE(96);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(97);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(99);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'y')
        ADVANCE(100);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_readonly);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'y')
        ADVANCE(102);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p')
        ADVANCE(103);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(104);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(106);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(107);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_typeset);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(109);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(110);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(111);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(112);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_while);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(115);
      if (lookahead == '|')
        ADVANCE(116);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_PIPE_AMP);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 118:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(120);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '\\')
        SKIP(122);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == 'c')
        ADVANCE(47);
      if (lookahead == 'd')
        ADVANCE(123);
      if (lookahead == 'e')
        ADVANCE(124);
      if (lookahead == 'f')
        ADVANCE(125);
      if (lookahead == 'i')
        ADVANCE(86);
      if (lookahead == 'l')
        ADVANCE(88);
      if (lookahead == 'r')
        ADVANCE(93);
      if (lookahead == 't')
        ADVANCE(101);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(118);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(119);
      END_STATE();
    case 120:
      if (lookahead == '>')
        ADVANCE(12);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(31);
      if (lookahead == '(')
        ADVANCE(32);
      END_STATE();
    case 122:
      if (lookahead == '\n')
        SKIP(118);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'x')
        ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(77);
      if (lookahead == 'u')
        ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 126:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '\\')
        SKIP(127);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(126);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 127:
      if (lookahead == '\n')
        SKIP(126);
      END_STATE();
    case 128:
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '%')
        ADVANCE(9);
      if (lookahead == '&')
        ADVANCE(129);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '+')
        ADVANCE(19);
      if (lookahead == '/')
        ADVANCE(22);
      if (lookahead == ':')
        ADVANCE(25);
      if (lookahead == '=')
        ADVANCE(35);
      if (lookahead == '@')
        ADVANCE(41);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        SKIP(130);
      if (lookahead == ']')
        ADVANCE(44);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == 'd')
        ADVANCE(131);
      if (lookahead == 'e')
        ADVANCE(133);
      if (lookahead == 'f')
        ADVANCE(139);
      if (lookahead == 'i')
        ADVANCE(141);
      if (lookahead == 't')
        ADVANCE(143);
      if (lookahead == '{')
        ADVANCE(113);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '}')
        ADVANCE(117);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(128);
      END_STATE();
    case 129:
      if (lookahead == '&')
        ADVANCE(11);
      END_STATE();
    case 130:
      if (lookahead == '\n')
        SKIP(128);
      END_STATE();
    case 131:
      if (lookahead == 'o')
        ADVANCE(132);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 133:
      if (lookahead == 'l')
        ADVANCE(134);
      END_STATE();
    case 134:
      if (lookahead == 'i')
        ADVANCE(135);
      if (lookahead == 's')
        ADVANCE(137);
      END_STATE();
    case 135:
      if (lookahead == 'f')
        ADVANCE(136);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 137:
      if (lookahead == 'e')
        ADVANCE(138);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 139:
      if (lookahead == 'i')
        ADVANCE(140);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_fi);
      END_STATE();
    case 141:
      if (lookahead == 'n')
        ADVANCE(142);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 143:
      if (lookahead == 'h')
        ADVANCE(144);
      END_STATE();
    case 144:
      if (lookahead == 'e')
        ADVANCE(145);
      END_STATE();
    case 145:
      if (lookahead == 'n')
        ADVANCE(146);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 147:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(148);
      if (lookahead == '>')
        ADVANCE(149);
      if (lookahead == '\\')
        SKIP(150);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(147);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 148:
      if (lookahead == '(')
        ADVANCE(32);
      END_STATE();
    case 149:
      if (lookahead == '(')
        ADVANCE(38);
      END_STATE();
    case 150:
      if (lookahead == '\n')
        SKIP(147);
      END_STATE();
    case 151:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '&')
        ADVANCE(152);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(153);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(151);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(11);
      END_STATE();
    case 153:
      if (lookahead == '\n')
        SKIP(151);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(155);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '\\')
        ADVANCE(159);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(160);
      if (lookahead != 0)
        ADVANCE(156);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(156);
      if (lookahead == '\\')
        ADVANCE(158);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(155);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\\')
        ADVANCE(157);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(156);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(156);
      if (lookahead == '\\')
        ADVANCE(157);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(156);
      if (lookahead != 0)
        ADVANCE(156);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(156);
      if (lookahead == '\\')
        ADVANCE(158);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(155);
      if (lookahead != 0)
        ADVANCE(155);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(160);
      if (lookahead == '\\')
        ADVANCE(157);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(156);
      if (lookahead != 0)
        ADVANCE(156);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '#')
        ADVANCE(155);
      if (lookahead == '\\')
        ADVANCE(159);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(160);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(156);
      END_STATE();
    case 161:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(162);
      if (lookahead == '%')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(21);
      if (lookahead == '/')
        ADVANCE(22);
      if (lookahead == '0')
        ADVANCE(23);
      if (lookahead == ':')
        ADVANCE(25);
      if (lookahead == '=')
        ADVANCE(35);
      if (lookahead == '?')
        ADVANCE(40);
      if (lookahead == '@')
        ADVANCE(41);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        SKIP(163);
      if (lookahead == '_')
        ADVANCE(45);
      if (lookahead == '}')
        ADVANCE(117);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(161);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 163:
      if (lookahead == '\n')
        SKIP(161);
      END_STATE();
    case 164:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '\\')
        SKIP(165);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(164);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 165:
      if (lookahead == '\n')
        SKIP(164);
      END_STATE();
    case 166:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(120);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '\\')
        SKIP(167);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == 'c')
        ADVANCE(47);
      if (lookahead == 'd')
        ADVANCE(123);
      if (lookahead == 'e')
        ADVANCE(124);
      if (lookahead == 'f')
        ADVANCE(125);
      if (lookahead == 'i')
        ADVANCE(86);
      if (lookahead == 'l')
        ADVANCE(88);
      if (lookahead == 'r')
        ADVANCE(93);
      if (lookahead == 't')
        ADVANCE(101);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '}')
        ADVANCE(117);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(166);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 167:
      if (lookahead == '\n')
        SKIP(166);
      END_STATE();
    case 168:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '\\')
        SKIP(169);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(168);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 169:
      if (lookahead == '\n')
        SKIP(168);
      END_STATE();
    case 170:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(120);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '\\')
        SKIP(171);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(170);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 171:
      if (lookahead == '\n')
        SKIP(170);
      END_STATE();
    case 172:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '\\')
        SKIP(173);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(172);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 173:
      if (lookahead == '\n')
        SKIP(172);
      END_STATE();
    case 174:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(148);
      if (lookahead == '>')
        ADVANCE(149);
      if (lookahead == '\\')
        SKIP(175);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(174);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 175:
      if (lookahead == '\n')
        SKIP(174);
      END_STATE();
    case 176:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '\\')
        SKIP(177);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(176);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 177:
      if (lookahead == '\n')
        SKIP(176);
      END_STATE();
    case 178:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '&')
        ADVANCE(179);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(180);
      if (lookahead == 'i')
        ADVANCE(141);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(178);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 180:
      if (lookahead == '\n')
        SKIP(178);
      END_STATE();
    case 181:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '&')
        ADVANCE(152);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(182);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 182:
      if (lookahead == '\n')
        SKIP(181);
      END_STATE();
    case 183:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '\\')
        SKIP(184);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(183);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 184:
      if (lookahead == '\n')
        SKIP(183);
      END_STATE();
    case 185:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(186);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '\\')
        SKIP(187);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(185);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 186:
      if (lookahead == '&')
        ADVANCE(11);
      if (lookahead == '>')
        ADVANCE(12);
      END_STATE();
    case 187:
      if (lookahead == '\n')
        SKIP(185);
      END_STATE();
    case 188:
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '&')
        ADVANCE(129);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '\\')
        SKIP(189);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(188);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 189:
      if (lookahead == '\n')
        SKIP(188);
      END_STATE();
    case 190:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(186);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '\\')
        SKIP(191);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(190);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 191:
      if (lookahead == '\n')
        SKIP(190);
      END_STATE();
    case 192:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(186);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '\\')
        SKIP(193);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(192);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 193:
      if (lookahead == '\n')
        SKIP(192);
      END_STATE();
    case 194:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(186);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '\\')
        SKIP(195);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(194);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 195:
      if (lookahead == '\n')
        SKIP(194);
      END_STATE();
    case 196:
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '&')
        ADVANCE(129);
      if (lookahead == '\\')
        SKIP(197);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(196);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 197:
      if (lookahead == '\n')
        SKIP(196);
      END_STATE();
    case 198:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(186);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '\\')
        SKIP(199);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(198);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 199:
      if (lookahead == '\n')
        SKIP(198);
      END_STATE();
    case 200:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(186);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '\\')
        SKIP(201);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(200);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 201:
      if (lookahead == '\n')
        SKIP(200);
      END_STATE();
    case 202:
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '\\')
        SKIP(203);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(202);
      END_STATE();
    case 203:
      if (lookahead == '\n')
        SKIP(202);
      END_STATE();
    case 204:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(205);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(207);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(204);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(31);
      if (lookahead == '<')
        ADVANCE(33);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(37);
      if (lookahead == '>')
        ADVANCE(39);
      END_STATE();
    case 207:
      if (lookahead == '\n')
        SKIP(204);
      END_STATE();
    case 208:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(205);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(209);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(208);
      END_STATE();
    case 209:
      if (lookahead == '\n')
        SKIP(208);
      END_STATE();
    case 210:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(148);
      if (lookahead == '>')
        ADVANCE(149);
      if (lookahead == '\\')
        SKIP(211);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(210);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 211:
      if (lookahead == '\n')
        SKIP(210);
      END_STATE();
    case 212:
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '\\')
        SKIP(213);
      if (lookahead == ']')
        ADVANCE(44);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(212);
      END_STATE();
    case 213:
      if (lookahead == '\n')
        SKIP(212);
      END_STATE();
    case 214:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(120);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '\\')
        SKIP(215);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == 'c')
        ADVANCE(47);
      if (lookahead == 'd')
        ADVANCE(51);
      if (lookahead == 'e')
        ADVANCE(124);
      if (lookahead == 'f')
        ADVANCE(125);
      if (lookahead == 'i')
        ADVANCE(86);
      if (lookahead == 'l')
        ADVANCE(88);
      if (lookahead == 'r')
        ADVANCE(93);
      if (lookahead == 't')
        ADVANCE(101);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(214);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 215:
      if (lookahead == '\n')
        SKIP(214);
      END_STATE();
    case 216:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(120);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '\\')
        SKIP(217);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == 'c')
        ADVANCE(47);
      if (lookahead == 'd')
        ADVANCE(123);
      if (lookahead == 'e')
        ADVANCE(218);
      if (lookahead == 'f')
        ADVANCE(75);
      if (lookahead == 'i')
        ADVANCE(86);
      if (lookahead == 'l')
        ADVANCE(88);
      if (lookahead == 'r')
        ADVANCE(93);
      if (lookahead == 't')
        ADVANCE(101);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(216);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 217:
      if (lookahead == '\n')
        SKIP(216);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(62);
      if (lookahead == 'x')
        ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 219:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(220);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(221);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(219);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(31);
      END_STATE();
    case 221:
      if (lookahead == '\n')
        SKIP(219);
      END_STATE();
    case 222:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(120);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '\\')
        SKIP(223);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == 'c')
        ADVANCE(47);
      if (lookahead == 'd')
        ADVANCE(123);
      if (lookahead == 'e')
        ADVANCE(124);
      if (lookahead == 'f')
        ADVANCE(125);
      if (lookahead == 'i')
        ADVANCE(86);
      if (lookahead == 'l')
        ADVANCE(88);
      if (lookahead == 'r')
        ADVANCE(93);
      if (lookahead == 't')
        ADVANCE(101);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(222);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 223:
      if (lookahead == '\n')
        SKIP(222);
      END_STATE();
    case 224:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(148);
      if (lookahead == '>')
        ADVANCE(149);
      if (lookahead == '\\')
        SKIP(225);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '}')
        ADVANCE(117);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 225:
      if (lookahead == '\n')
        SKIP(224);
      END_STATE();
    case 226:
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '&')
        ADVANCE(129);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '\\')
        SKIP(227);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(226);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 227:
      if (lookahead == '\n')
        SKIP(226);
      END_STATE();
    case 228:
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '&')
        ADVANCE(186);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(205);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(229);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(228);
      END_STATE();
    case 229:
      if (lookahead == '\n')
        SKIP(228);
      END_STATE();
    case 230:
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '&')
        ADVANCE(186);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(205);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(231);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(230);
      END_STATE();
    case 231:
      if (lookahead == '\n')
        SKIP(230);
      END_STATE();
    case 232:
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '&')
        ADVANCE(186);
      if (lookahead == '<')
        ADVANCE(205);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(233);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(232);
      END_STATE();
    case 233:
      if (lookahead == '\n')
        SKIP(232);
      END_STATE();
    case 234:
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(235);
      if (lookahead == '\\')
        SKIP(236);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(234);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '{')
        ADVANCE(8);
      END_STATE();
    case 236:
      if (lookahead == '\n')
        SKIP(234);
      END_STATE();
    case 237:
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '\\')
        SKIP(238);
      if (lookahead == ']')
        ADVANCE(44);
      if (lookahead == '|')
        ADVANCE(239);
      if (lookahead == '}')
        ADVANCE(117);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(237);
      END_STATE();
    case 238:
      if (lookahead == '\n')
        SKIP(237);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 240:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(179);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(148);
      if (lookahead == '>')
        ADVANCE(149);
      if (lookahead == '\\')
        SKIP(241);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(240);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 241:
      if (lookahead == '\n')
        SKIP(240);
      END_STATE();
    case 242:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(120);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '\\')
        SKIP(243);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == 'c')
        ADVANCE(47);
      if (lookahead == 'd')
        ADVANCE(123);
      if (lookahead == 'e')
        ADVANCE(124);
      if (lookahead == 'f')
        ADVANCE(75);
      if (lookahead == 'i')
        ADVANCE(86);
      if (lookahead == 'l')
        ADVANCE(88);
      if (lookahead == 'r')
        ADVANCE(93);
      if (lookahead == 't')
        ADVANCE(101);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(242);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 243:
      if (lookahead == '\n')
        SKIP(242);
      END_STATE();
    case 244:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(148);
      if (lookahead == '>')
        ADVANCE(149);
      if (lookahead == '\\')
        SKIP(245);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == 'e')
        ADVANCE(246);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(244);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 245:
      if (lookahead == '\n')
        SKIP(244);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 247:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(220);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(248);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(247);
      END_STATE();
    case 248:
      if (lookahead == '\n')
        SKIP(247);
      END_STATE();
    case 249:
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '\\')
        SKIP(250);
      if (lookahead == '}')
        ADVANCE(117);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(249);
      END_STATE();
    case 250:
      if (lookahead == '\n')
        SKIP(249);
      END_STATE();
    case 251:
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '&')
        ADVANCE(186);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(220);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(252);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(251);
      END_STATE();
    case 252:
      if (lookahead == '\n')
        SKIP(251);
      END_STATE();
    case 253:
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '&')
        ADVANCE(186);
      if (lookahead == '<')
        ADVANCE(220);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(254);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(253);
      END_STATE();
    case 254:
      if (lookahead == '\n')
        SKIP(253);
      END_STATE();
    case 255:
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '\\')
        SKIP(256);
      if (lookahead == '|')
        ADVANCE(239);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(255);
      END_STATE();
    case 256:
      if (lookahead == '\n')
        SKIP(255);
      END_STATE();
    case 257:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '&')
        ADVANCE(152);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(258);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(257);
      END_STATE();
    case 258:
      if (lookahead == '\n')
        SKIP(257);
      END_STATE();
    case 259:
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '&')
        ADVANCE(186);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(220);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(260);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(259);
      END_STATE();
    case 260:
      if (lookahead == '\n')
        SKIP(259);
      END_STATE();
    case 261:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(120);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(262);
      if (lookahead == '<')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '\\')
        SKIP(263);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == 'c')
        ADVANCE(47);
      if (lookahead == 'd')
        ADVANCE(123);
      if (lookahead == 'e')
        ADVANCE(124);
      if (lookahead == 'f')
        ADVANCE(125);
      if (lookahead == 'i')
        ADVANCE(86);
      if (lookahead == 'l')
        ADVANCE(88);
      if (lookahead == 'r')
        ADVANCE(93);
      if (lookahead == 't')
        ADVANCE(101);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(261);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 262:
      if (lookahead == ';')
        ADVANCE(29);
      END_STATE();
    case 263:
      if (lookahead == '\n')
        SKIP(261);
      END_STATE();
    case 264:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '&')
        ADVANCE(152);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(265);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(264);
      END_STATE();
    case 265:
      if (lookahead == '\n')
        SKIP(264);
      END_STATE();
    case 266:
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '&')
        ADVANCE(129);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '\\')
        SKIP(267);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(266);
      END_STATE();
    case 267:
      if (lookahead == '\n')
        SKIP(266);
      END_STATE();
    case 268:
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '&')
        ADVANCE(129);
      if (lookahead == '\\')
        SKIP(269);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(268);
      END_STATE();
    case 269:
      if (lookahead == '\n')
        SKIP(268);
      END_STATE();
    case 270:
      if (lookahead == '#')
        ADVANCE(119);
      if (lookahead == '&')
        ADVANCE(129);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '\\')
        SKIP(271);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(270);
      END_STATE();
    case 271:
      if (lookahead == '\n')
        SKIP(270);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 118, .external_lex_state = 2},
  [2] = {.lex_state = 118},
  [3] = {.lex_state = 126, .external_lex_state = 3},
  [4] = {.lex_state = 128},
  [5] = {.lex_state = 147},
  [6] = {.lex_state = 118, .external_lex_state = 2},
  [7] = {.lex_state = 118, .external_lex_state = 2},
  [8] = {.lex_state = 147, .external_lex_state = 4},
  [9] = {.lex_state = 147},
  [10] = {.lex_state = 118, .external_lex_state = 2},
  [11] = {.lex_state = 151, .external_lex_state = 5},
  [12] = {.lex_state = 147, .external_lex_state = 4},
  [13] = {.lex_state = 154},
  [14] = {.lex_state = 161},
  [15] = {.lex_state = 161},
  [16] = {.lex_state = 118, .external_lex_state = 2},
  [17] = {.lex_state = 118, .external_lex_state = 2},
  [18] = {.lex_state = 118, .external_lex_state = 2},
  [19] = {.lex_state = 164, .external_lex_state = 3},
  [20] = {.lex_state = 118},
  [21] = {.lex_state = 166, .external_lex_state = 6},
  [22] = {.lex_state = 151, .external_lex_state = 7},
  [23] = {.lex_state = 126, .external_lex_state = 8},
  [24] = {.lex_state = 168, .external_lex_state = 9},
  [25] = {.lex_state = 128},
  [26] = {.lex_state = 170, .external_lex_state = 2},
  [27] = {.lex_state = 172, .external_lex_state = 8},
  [28] = {.lex_state = 118, .external_lex_state = 2},
  [29] = {.lex_state = 170, .external_lex_state = 2},
  [30] = {.lex_state = 147, .external_lex_state = 4},
  [31] = {.lex_state = 147, .external_lex_state = 4},
  [32] = {.lex_state = 126, .external_lex_state = 3},
  [33] = {.lex_state = 174, .external_lex_state = 10},
  [34] = {.lex_state = 147, .external_lex_state = 4},
  [35] = {.lex_state = 176, .external_lex_state = 9},
  [36] = {.lex_state = 128},
  [37] = {.lex_state = 128},
  [38] = {.lex_state = 151, .external_lex_state = 7},
  [39] = {.lex_state = 168, .external_lex_state = 9},
  [40] = {.lex_state = 128},
  [41] = {.lex_state = 178, .external_lex_state = 11},
  [42] = {.lex_state = 154},
  [43] = {.lex_state = 161},
  [44] = {.lex_state = 161},
  [45] = {.lex_state = 118, .external_lex_state = 2},
  [46] = {.lex_state = 118, .external_lex_state = 2},
  [47] = {.lex_state = 118, .external_lex_state = 2},
  [48] = {.lex_state = 178, .external_lex_state = 11},
  [49] = {.lex_state = 178, .external_lex_state = 7},
  [50] = {.lex_state = 128},
  [51] = {.lex_state = 172, .external_lex_state = 3},
  [52] = {.lex_state = 128},
  [53] = {.lex_state = 147},
  [54] = {.lex_state = 181, .external_lex_state = 5},
  [55] = {.lex_state = 183, .external_lex_state = 3},
  [56] = {.lex_state = 181, .external_lex_state = 7},
  [57] = {.lex_state = 172, .external_lex_state = 8},
  [58] = {.lex_state = 176, .external_lex_state = 9},
  [59] = {.lex_state = 128},
  [60] = {.lex_state = 118, .external_lex_state = 2},
  [61] = {.lex_state = 170, .external_lex_state = 2},
  [62] = {.lex_state = 181, .external_lex_state = 5},
  [63] = {.lex_state = 128},
  [64] = {.lex_state = 181, .external_lex_state = 5},
  [65] = {.lex_state = 128},
  [66] = {.lex_state = 151, .external_lex_state = 5},
  [67] = {.lex_state = 170, .external_lex_state = 12},
  [68] = {.lex_state = 154},
  [69] = {.lex_state = 161},
  [70] = {.lex_state = 161},
  [71] = {.lex_state = 118, .external_lex_state = 2},
  [72] = {.lex_state = 118, .external_lex_state = 2},
  [73] = {.lex_state = 118, .external_lex_state = 2},
  [74] = {.lex_state = 170, .external_lex_state = 12},
  [75] = {.lex_state = 170, .external_lex_state = 2},
  [76] = {.lex_state = 172, .external_lex_state = 3},
  [77] = {.lex_state = 154},
  [78] = {.lex_state = 161},
  [79] = {.lex_state = 161},
  [80] = {.lex_state = 118, .external_lex_state = 2},
  [81] = {.lex_state = 118, .external_lex_state = 2},
  [82] = {.lex_state = 154},
  [83] = {.lex_state = 172, .external_lex_state = 3},
  [84] = {.lex_state = 172, .external_lex_state = 3},
  [85] = {.lex_state = 172, .external_lex_state = 3},
  [86] = {.lex_state = 128, .external_lex_state = 13},
  [87] = {.lex_state = 161, .external_lex_state = 13},
  [88] = {.lex_state = 128, .external_lex_state = 13},
  [89] = {.lex_state = 128, .external_lex_state = 13},
  [90] = {.lex_state = 185, .external_lex_state = 14},
  [91] = {.lex_state = 128},
  [92] = {.lex_state = 147},
  [93] = {.lex_state = 118, .external_lex_state = 2},
  [94] = {.lex_state = 118, .external_lex_state = 2},
  [95] = {.lex_state = 147, .external_lex_state = 4},
  [96] = {.lex_state = 147},
  [97] = {.lex_state = 118, .external_lex_state = 2},
  [98] = {.lex_state = 188, .external_lex_state = 15},
  [99] = {.lex_state = 154},
  [100] = {.lex_state = 161},
  [101] = {.lex_state = 161},
  [102] = {.lex_state = 118, .external_lex_state = 2},
  [103] = {.lex_state = 118, .external_lex_state = 2},
  [104] = {.lex_state = 118, .external_lex_state = 2},
  [105] = {.lex_state = 190, .external_lex_state = 14},
  [106] = {.lex_state = 128},
  [107] = {.lex_state = 185, .external_lex_state = 16},
  [108] = {.lex_state = 192, .external_lex_state = 2},
  [109] = {.lex_state = 128},
  [110] = {.lex_state = 185, .external_lex_state = 16},
  [111] = {.lex_state = 170, .external_lex_state = 2},
  [112] = {.lex_state = 194, .external_lex_state = 14},
  [113] = {.lex_state = 128},
  [114] = {.lex_state = 147},
  [115] = {.lex_state = 196, .external_lex_state = 15},
  [116] = {.lex_state = 198, .external_lex_state = 14},
  [117] = {.lex_state = 128},
  [118] = {.lex_state = 194, .external_lex_state = 16},
  [119] = {.lex_state = 200, .external_lex_state = 2},
  [120] = {.lex_state = 128},
  [121] = {.lex_state = 170, .external_lex_state = 2},
  [122] = {.lex_state = 128},
  [123] = {.lex_state = 192, .external_lex_state = 2},
  [124] = {.lex_state = 128},
  [125] = {.lex_state = 126, .external_lex_state = 3},
  [126] = {.lex_state = 118, .external_lex_state = 2},
  [127] = {.lex_state = 166, .external_lex_state = 6},
  [128] = {.lex_state = 118, .external_lex_state = 2},
  [129] = {.lex_state = 118},
  [130] = {.lex_state = 126, .external_lex_state = 3},
  [131] = {.lex_state = 147, .external_lex_state = 4},
  [132] = {.lex_state = 202, .external_lex_state = 17},
  [133] = {.lex_state = 126, .external_lex_state = 3},
  [134] = {.lex_state = 204, .external_lex_state = 18},
  [135] = {.lex_state = 172, .external_lex_state = 8},
  [136] = {.lex_state = 126, .external_lex_state = 8},
  [137] = {.lex_state = 208, .external_lex_state = 18},
  [138] = {.lex_state = 118, .external_lex_state = 2},
  [139] = {.lex_state = 128},
  [140] = {.lex_state = 126, .external_lex_state = 3},
  [141] = {.lex_state = 126, .external_lex_state = 8},
  [142] = {.lex_state = 128},
  [143] = {.lex_state = 170, .external_lex_state = 2},
  [144] = {.lex_state = 170, .external_lex_state = 12},
  [145] = {.lex_state = 170, .external_lex_state = 12},
  [146] = {.lex_state = 170, .external_lex_state = 2},
  [147] = {.lex_state = 172, .external_lex_state = 3},
  [148] = {.lex_state = 172, .external_lex_state = 3},
  [149] = {.lex_state = 126, .external_lex_state = 3},
  [150] = {.lex_state = 168, .external_lex_state = 19},
  [151] = {.lex_state = 176, .external_lex_state = 9},
  [152] = {.lex_state = 210, .external_lex_state = 4},
  [153] = {.lex_state = 154},
  [154] = {.lex_state = 161},
  [155] = {.lex_state = 161},
  [156] = {.lex_state = 118, .external_lex_state = 2},
  [157] = {.lex_state = 118, .external_lex_state = 2},
  [158] = {.lex_state = 118, .external_lex_state = 2},
  [159] = {.lex_state = 168, .external_lex_state = 19},
  [160] = {.lex_state = 212, .external_lex_state = 20},
  [161] = {.lex_state = 154},
  [162] = {.lex_state = 161},
  [163] = {.lex_state = 161},
  [164] = {.lex_state = 118, .external_lex_state = 2},
  [165] = {.lex_state = 118, .external_lex_state = 2},
  [166] = {.lex_state = 118, .external_lex_state = 2},
  [167] = {.lex_state = 212, .external_lex_state = 20},
  [168] = {.lex_state = 128, .external_lex_state = 21},
  [169] = {.lex_state = 147, .external_lex_state = 4},
  [170] = {.lex_state = 214, .external_lex_state = 2},
  [171] = {.lex_state = 181, .external_lex_state = 7},
  [172] = {.lex_state = 128},
  [173] = {.lex_state = 216, .external_lex_state = 2},
  [174] = {.lex_state = 147, .external_lex_state = 4},
  [175] = {.lex_state = 178, .external_lex_state = 7},
  [176] = {.lex_state = 128},
  [177] = {.lex_state = 178, .external_lex_state = 11},
  [178] = {.lex_state = 178, .external_lex_state = 11},
  [179] = {.lex_state = 154},
  [180] = {.lex_state = 178, .external_lex_state = 11},
  [181] = {.lex_state = 178, .external_lex_state = 11},
  [182] = {.lex_state = 178, .external_lex_state = 11},
  [183] = {.lex_state = 161, .external_lex_state = 13},
  [184] = {.lex_state = 128, .external_lex_state = 13},
  [185] = {.lex_state = 128, .external_lex_state = 13},
  [186] = {.lex_state = 128},
  [187] = {.lex_state = 192, .external_lex_state = 2},
  [188] = {.lex_state = 128},
  [189] = {.lex_state = 200, .external_lex_state = 2},
  [190] = {.lex_state = 128},
  [191] = {.lex_state = 192, .external_lex_state = 2},
  [192] = {.lex_state = 178, .external_lex_state = 7},
  [193] = {.lex_state = 128},
  [194] = {.lex_state = 178, .external_lex_state = 11},
  [195] = {.lex_state = 128},
  [196] = {.lex_state = 166, .external_lex_state = 6},
  [197] = {.lex_state = 219, .external_lex_state = 18},
  [198] = {.lex_state = 172, .external_lex_state = 3},
  [199] = {.lex_state = 174, .external_lex_state = 10},
  [200] = {.lex_state = 128},
  [201] = {.lex_state = 128},
  [202] = {.lex_state = 128},
  [203] = {.lex_state = 181, .external_lex_state = 5},
  [204] = {.lex_state = 128},
  [205] = {.lex_state = 172, .external_lex_state = 3},
  [206] = {.lex_state = 118, .external_lex_state = 2},
  [207] = {.lex_state = 181, .external_lex_state = 7},
  [208] = {.lex_state = 222, .external_lex_state = 2},
  [209] = {.lex_state = 118, .external_lex_state = 2},
  [210] = {.lex_state = 118},
  [211] = {.lex_state = 172, .external_lex_state = 3},
  [212] = {.lex_state = 147, .external_lex_state = 4},
  [213] = {.lex_state = 172, .external_lex_state = 3},
  [214] = {.lex_state = 172, .external_lex_state = 8},
  [215] = {.lex_state = 204, .external_lex_state = 18},
  [216] = {.lex_state = 181, .external_lex_state = 7},
  [217] = {.lex_state = 176, .external_lex_state = 9},
  [218] = {.lex_state = 118, .external_lex_state = 2},
  [219] = {.lex_state = 172, .external_lex_state = 3},
  [220] = {.lex_state = 172, .external_lex_state = 8},
  [221] = {.lex_state = 174, .external_lex_state = 10},
  [222] = {.lex_state = 181, .external_lex_state = 5},
  [223] = {.lex_state = 151, .external_lex_state = 5},
  [224] = {.lex_state = 147, .external_lex_state = 4},
  [225] = {.lex_state = 170, .external_lex_state = 12},
  [226] = {.lex_state = 170, .external_lex_state = 12},
  [227] = {.lex_state = 154},
  [228] = {.lex_state = 170, .external_lex_state = 12},
  [229] = {.lex_state = 170, .external_lex_state = 12},
  [230] = {.lex_state = 170, .external_lex_state = 12},
  [231] = {.lex_state = 161, .external_lex_state = 13},
  [232] = {.lex_state = 128, .external_lex_state = 13},
  [233] = {.lex_state = 128, .external_lex_state = 13},
  [234] = {.lex_state = 128},
  [235] = {.lex_state = 192, .external_lex_state = 2},
  [236] = {.lex_state = 128},
  [237] = {.lex_state = 200, .external_lex_state = 2},
  [238] = {.lex_state = 128},
  [239] = {.lex_state = 192, .external_lex_state = 2},
  [240] = {.lex_state = 170, .external_lex_state = 12},
  [241] = {.lex_state = 154},
  [242] = {.lex_state = 154},
  [243] = {.lex_state = 154},
  [244] = {.lex_state = 161, .external_lex_state = 13},
  [245] = {.lex_state = 128, .external_lex_state = 13},
  [246] = {.lex_state = 128, .external_lex_state = 13},
  [247] = {.lex_state = 128},
  [248] = {.lex_state = 192, .external_lex_state = 2},
  [249] = {.lex_state = 128},
  [250] = {.lex_state = 200, .external_lex_state = 2},
  [251] = {.lex_state = 172, .external_lex_state = 3},
  [252] = {.lex_state = 154},
  [253] = {.lex_state = 128, .external_lex_state = 13},
  [254] = {.lex_state = 128, .external_lex_state = 13},
  [255] = {.lex_state = 172, .external_lex_state = 3},
  [256] = {.lex_state = 224, .external_lex_state = 22},
  [257] = {.lex_state = 128},
  [258] = {.lex_state = 172, .external_lex_state = 3},
  [259] = {.lex_state = 224, .external_lex_state = 22},
  [260] = {.lex_state = 128},
  [261] = {.lex_state = 147, .external_lex_state = 4},
  [262] = {.lex_state = 185, .external_lex_state = 14},
  [263] = {.lex_state = 174, .external_lex_state = 10},
  [264] = {.lex_state = 192, .external_lex_state = 2},
  [265] = {.lex_state = 128},
  [266] = {.lex_state = 128},
  [267] = {.lex_state = 128},
  [268] = {.lex_state = 178, .external_lex_state = 11},
  [269] = {.lex_state = 178, .external_lex_state = 11},
  [270] = {.lex_state = 178, .external_lex_state = 7},
  [271] = {.lex_state = 128},
  [272] = {.lex_state = 181, .external_lex_state = 7},
  [273] = {.lex_state = 176, .external_lex_state = 9},
  [274] = {.lex_state = 118, .external_lex_state = 2},
  [275] = {.lex_state = 226, .external_lex_state = 15},
  [276] = {.lex_state = 128},
  [277] = {.lex_state = 226, .external_lex_state = 15},
  [278] = {.lex_state = 128},
  [279] = {.lex_state = 188, .external_lex_state = 15},
  [280] = {.lex_state = 185, .external_lex_state = 14},
  [281] = {.lex_state = 154},
  [282] = {.lex_state = 185, .external_lex_state = 14},
  [283] = {.lex_state = 185, .external_lex_state = 14},
  [284] = {.lex_state = 185, .external_lex_state = 14},
  [285] = {.lex_state = 161, .external_lex_state = 13},
  [286] = {.lex_state = 128, .external_lex_state = 13},
  [287] = {.lex_state = 128, .external_lex_state = 13},
  [288] = {.lex_state = 128},
  [289] = {.lex_state = 192, .external_lex_state = 2},
  [290] = {.lex_state = 128},
  [291] = {.lex_state = 200, .external_lex_state = 2},
  [292] = {.lex_state = 128},
  [293] = {.lex_state = 192, .external_lex_state = 2},
  [294] = {.lex_state = 128},
  [295] = {.lex_state = 185, .external_lex_state = 14},
  [296] = {.lex_state = 118, .external_lex_state = 2},
  [297] = {.lex_state = 172, .external_lex_state = 3},
  [298] = {.lex_state = 118, .external_lex_state = 2},
  [299] = {.lex_state = 118},
  [300] = {.lex_state = 185, .external_lex_state = 14},
  [301] = {.lex_state = 147, .external_lex_state = 4},
  [302] = {.lex_state = 202, .external_lex_state = 17},
  [303] = {.lex_state = 185, .external_lex_state = 14},
  [304] = {.lex_state = 228, .external_lex_state = 23},
  [305] = {.lex_state = 185, .external_lex_state = 16},
  [306] = {.lex_state = 185, .external_lex_state = 16},
  [307] = {.lex_state = 230, .external_lex_state = 23},
  [308] = {.lex_state = 185, .external_lex_state = 14},
  [309] = {.lex_state = 185, .external_lex_state = 16},
  [310] = {.lex_state = 194, .external_lex_state = 14},
  [311] = {.lex_state = 174, .external_lex_state = 10},
  [312] = {.lex_state = 128},
  [313] = {.lex_state = 128},
  [314] = {.lex_state = 128},
  [315] = {.lex_state = 196, .external_lex_state = 15},
  [316] = {.lex_state = 128},
  [317] = {.lex_state = 194, .external_lex_state = 14},
  [318] = {.lex_state = 118, .external_lex_state = 2},
  [319] = {.lex_state = 118, .external_lex_state = 2},
  [320] = {.lex_state = 118},
  [321] = {.lex_state = 194, .external_lex_state = 14},
  [322] = {.lex_state = 147, .external_lex_state = 4},
  [323] = {.lex_state = 194, .external_lex_state = 14},
  [324] = {.lex_state = 194, .external_lex_state = 16},
  [325] = {.lex_state = 232, .external_lex_state = 23},
  [326] = {.lex_state = 194, .external_lex_state = 14},
  [327] = {.lex_state = 194, .external_lex_state = 16},
  [328] = {.lex_state = 172, .external_lex_state = 3},
  [329] = {.lex_state = 128},
  [330] = {.lex_state = 181, .external_lex_state = 7},
  [331] = {.lex_state = 176, .external_lex_state = 9},
  [332] = {.lex_state = 151, .external_lex_state = 7},
  [333] = {.lex_state = 168, .external_lex_state = 9},
  [334] = {.lex_state = 147, .external_lex_state = 4},
  [335] = {.lex_state = 208, .external_lex_state = 24},
  [336] = {.lex_state = 154},
  [337] = {.lex_state = 161},
  [338] = {.lex_state = 161},
  [339] = {.lex_state = 118, .external_lex_state = 2},
  [340] = {.lex_state = 118, .external_lex_state = 2},
  [341] = {.lex_state = 118, .external_lex_state = 2},
  [342] = {.lex_state = 208, .external_lex_state = 24},
  [343] = {.lex_state = 204, .external_lex_state = 18},
  [344] = {.lex_state = 204, .external_lex_state = 18},
  [345] = {.lex_state = 234, .external_lex_state = 25},
  [346] = {.lex_state = 204, .external_lex_state = 18},
  [347] = {.lex_state = 126, .external_lex_state = 8},
  [348] = {.lex_state = 208, .external_lex_state = 18},
  [349] = {.lex_state = 208, .external_lex_state = 18},
  [350] = {.lex_state = 174, .external_lex_state = 10},
  [351] = {.lex_state = 170, .external_lex_state = 2},
  [352] = {.lex_state = 126, .external_lex_state = 8},
  [353] = {.lex_state = 147, .external_lex_state = 4},
  [354] = {.lex_state = 168, .external_lex_state = 19},
  [355] = {.lex_state = 210, .external_lex_state = 26},
  [356] = {.lex_state = 176, .external_lex_state = 9},
  [357] = {.lex_state = 154},
  [358] = {.lex_state = 161},
  [359] = {.lex_state = 161},
  [360] = {.lex_state = 118, .external_lex_state = 2},
  [361] = {.lex_state = 118, .external_lex_state = 2},
  [362] = {.lex_state = 118, .external_lex_state = 2},
  [363] = {.lex_state = 210, .external_lex_state = 26},
  [364] = {.lex_state = 210, .external_lex_state = 4},
  [365] = {.lex_state = 210, .external_lex_state = 4},
  [366] = {.lex_state = 176, .external_lex_state = 19},
  [367] = {.lex_state = 154},
  [368] = {.lex_state = 176, .external_lex_state = 19},
  [369] = {.lex_state = 176, .external_lex_state = 19},
  [370] = {.lex_state = 176, .external_lex_state = 19},
  [371] = {.lex_state = 161, .external_lex_state = 13},
  [372] = {.lex_state = 128, .external_lex_state = 13},
  [373] = {.lex_state = 128, .external_lex_state = 13},
  [374] = {.lex_state = 128},
  [375] = {.lex_state = 192, .external_lex_state = 2},
  [376] = {.lex_state = 128},
  [377] = {.lex_state = 200, .external_lex_state = 2},
  [378] = {.lex_state = 128},
  [379] = {.lex_state = 192, .external_lex_state = 2},
  [380] = {.lex_state = 168, .external_lex_state = 19},
  [381] = {.lex_state = 147, .external_lex_state = 4},
  [382] = {.lex_state = 128},
  [383] = {.lex_state = 212, .external_lex_state = 20},
  [384] = {.lex_state = 237, .external_lex_state = 27},
  [385] = {.lex_state = 154},
  [386] = {.lex_state = 237, .external_lex_state = 27},
  [387] = {.lex_state = 237, .external_lex_state = 27},
  [388] = {.lex_state = 237, .external_lex_state = 27},
  [389] = {.lex_state = 161, .external_lex_state = 13},
  [390] = {.lex_state = 128, .external_lex_state = 13},
  [391] = {.lex_state = 128, .external_lex_state = 13},
  [392] = {.lex_state = 128},
  [393] = {.lex_state = 192, .external_lex_state = 2},
  [394] = {.lex_state = 128},
  [395] = {.lex_state = 200, .external_lex_state = 2},
  [396] = {.lex_state = 128},
  [397] = {.lex_state = 192, .external_lex_state = 2},
  [398] = {.lex_state = 128},
  [399] = {.lex_state = 212, .external_lex_state = 20},
  [400] = {.lex_state = 240, .external_lex_state = 28},
  [401] = {.lex_state = 154},
  [402] = {.lex_state = 161},
  [403] = {.lex_state = 161},
  [404] = {.lex_state = 118, .external_lex_state = 2},
  [405] = {.lex_state = 118, .external_lex_state = 2},
  [406] = {.lex_state = 118, .external_lex_state = 2},
  [407] = {.lex_state = 240, .external_lex_state = 28},
  [408] = {.lex_state = 240, .external_lex_state = 29},
  [409] = {.lex_state = 240, .external_lex_state = 29},
  [410] = {.lex_state = 181, .external_lex_state = 7},
  [411] = {.lex_state = 214, .external_lex_state = 2},
  [412] = {.lex_state = 151, .external_lex_state = 7},
  [413] = {.lex_state = 168, .external_lex_state = 9},
  [414] = {.lex_state = 214, .external_lex_state = 2},
  [415] = {.lex_state = 181, .external_lex_state = 7},
  [416] = {.lex_state = 118, .external_lex_state = 2},
  [417] = {.lex_state = 242, .external_lex_state = 2},
  [418] = {.lex_state = 216, .external_lex_state = 2},
  [419] = {.lex_state = 151, .external_lex_state = 7},
  [420] = {.lex_state = 128},
  [421] = {.lex_state = 128},
  [422] = {.lex_state = 168, .external_lex_state = 9},
  [423] = {.lex_state = 216, .external_lex_state = 2},
  [424] = {.lex_state = 128},
  [425] = {.lex_state = 178, .external_lex_state = 11},
  [426] = {.lex_state = 178, .external_lex_state = 11},
  [427] = {.lex_state = 244, .external_lex_state = 4},
  [428] = {.lex_state = 178, .external_lex_state = 7},
  [429] = {.lex_state = 178, .external_lex_state = 11},
  [430] = {.lex_state = 178, .external_lex_state = 11},
  [431] = {.lex_state = 128, .external_lex_state = 13},
  [432] = {.lex_state = 128, .external_lex_state = 13},
  [433] = {.lex_state = 178, .external_lex_state = 11},
  [434] = {.lex_state = 224, .external_lex_state = 22},
  [435] = {.lex_state = 128},
  [436] = {.lex_state = 178, .external_lex_state = 11},
  [437] = {.lex_state = 224, .external_lex_state = 22},
  [438] = {.lex_state = 128},
  [439] = {.lex_state = 178, .external_lex_state = 11},
  [440] = {.lex_state = 178, .external_lex_state = 11},
  [441] = {.lex_state = 244, .external_lex_state = 4},
  [442] = {.lex_state = 178, .external_lex_state = 7},
  [443] = {.lex_state = 128},
  [444] = {.lex_state = 247, .external_lex_state = 18},
  [445] = {.lex_state = 166, .external_lex_state = 6},
  [446] = {.lex_state = 118},
  [447] = {.lex_state = 147, .external_lex_state = 4},
  [448] = {.lex_state = 181, .external_lex_state = 7},
  [449] = {.lex_state = 172, .external_lex_state = 3},
  [450] = {.lex_state = 176, .external_lex_state = 19},
  [451] = {.lex_state = 176, .external_lex_state = 19},
  [452] = {.lex_state = 128},
  [453] = {.lex_state = 247, .external_lex_state = 18},
  [454] = {.lex_state = 174, .external_lex_state = 10},
  [455] = {.lex_state = 181, .external_lex_state = 5},
  [456] = {.lex_state = 128},
  [457] = {.lex_state = 181, .external_lex_state = 7},
  [458] = {.lex_state = 181, .external_lex_state = 7},
  [459] = {.lex_state = 176, .external_lex_state = 9},
  [460] = {.lex_state = 147, .external_lex_state = 4},
  [461] = {.lex_state = 204, .external_lex_state = 24},
  [462] = {.lex_state = 204, .external_lex_state = 24},
  [463] = {.lex_state = 172, .external_lex_state = 8},
  [464] = {.lex_state = 204, .external_lex_state = 18},
  [465] = {.lex_state = 204, .external_lex_state = 18},
  [466] = {.lex_state = 222, .external_lex_state = 2},
  [467] = {.lex_state = 172, .external_lex_state = 8},
  [468] = {.lex_state = 151, .external_lex_state = 30},
  [469] = {.lex_state = 181, .external_lex_state = 5},
  [470] = {.lex_state = 210, .external_lex_state = 4},
  [471] = {.lex_state = 154},
  [472] = {.lex_state = 161},
  [473] = {.lex_state = 161},
  [474] = {.lex_state = 118, .external_lex_state = 2},
  [475] = {.lex_state = 118, .external_lex_state = 2},
  [476] = {.lex_state = 118, .external_lex_state = 2},
  [477] = {.lex_state = 151, .external_lex_state = 30},
  [478] = {.lex_state = 170, .external_lex_state = 12},
  [479] = {.lex_state = 170, .external_lex_state = 12},
  [480] = {.lex_state = 170, .external_lex_state = 12},
  [481] = {.lex_state = 170, .external_lex_state = 12},
  [482] = {.lex_state = 128, .external_lex_state = 13},
  [483] = {.lex_state = 128, .external_lex_state = 13},
  [484] = {.lex_state = 170, .external_lex_state = 12},
  [485] = {.lex_state = 224, .external_lex_state = 22},
  [486] = {.lex_state = 128},
  [487] = {.lex_state = 170, .external_lex_state = 12},
  [488] = {.lex_state = 224, .external_lex_state = 22},
  [489] = {.lex_state = 128},
  [490] = {.lex_state = 170, .external_lex_state = 12},
  [491] = {.lex_state = 170, .external_lex_state = 12},
  [492] = {.lex_state = 128, .external_lex_state = 13},
  [493] = {.lex_state = 128, .external_lex_state = 13},
  [494] = {.lex_state = 154},
  [495] = {.lex_state = 224, .external_lex_state = 22},
  [496] = {.lex_state = 128},
  [497] = {.lex_state = 154},
  [498] = {.lex_state = 224, .external_lex_state = 22},
  [499] = {.lex_state = 128},
  [500] = {.lex_state = 154},
  [501] = {.lex_state = 172, .external_lex_state = 3},
  [502] = {.lex_state = 128},
  [503] = {.lex_state = 172, .external_lex_state = 3},
  [504] = {.lex_state = 128},
  [505] = {.lex_state = 249, .external_lex_state = 31},
  [506] = {.lex_state = 172, .external_lex_state = 3},
  [507] = {.lex_state = 249, .external_lex_state = 31},
  [508] = {.lex_state = 249, .external_lex_state = 31},
  [509] = {.lex_state = 128, .external_lex_state = 21},
  [510] = {.lex_state = 249, .external_lex_state = 31},
  [511] = {.lex_state = 249, .external_lex_state = 31},
  [512] = {.lex_state = 249, .external_lex_state = 31},
  [513] = {.lex_state = 128, .external_lex_state = 21},
  [514] = {.lex_state = 185, .external_lex_state = 14},
  [515] = {.lex_state = 185, .external_lex_state = 14},
  [516] = {.lex_state = 185, .external_lex_state = 14},
  [517] = {.lex_state = 192, .external_lex_state = 12},
  [518] = {.lex_state = 192, .external_lex_state = 2},
  [519] = {.lex_state = 210, .external_lex_state = 4},
  [520] = {.lex_state = 154},
  [521] = {.lex_state = 161},
  [522] = {.lex_state = 161},
  [523] = {.lex_state = 118, .external_lex_state = 2},
  [524] = {.lex_state = 118, .external_lex_state = 2},
  [525] = {.lex_state = 118, .external_lex_state = 2},
  [526] = {.lex_state = 192, .external_lex_state = 12},
  [527] = {.lex_state = 147, .external_lex_state = 4},
  [528] = {.lex_state = 214, .external_lex_state = 2},
  [529] = {.lex_state = 128},
  [530] = {.lex_state = 216, .external_lex_state = 2},
  [531] = {.lex_state = 178, .external_lex_state = 7},
  [532] = {.lex_state = 128},
  [533] = {.lex_state = 178, .external_lex_state = 7},
  [534] = {.lex_state = 128},
  [535] = {.lex_state = 128},
  [536] = {.lex_state = 166, .external_lex_state = 6},
  [537] = {.lex_state = 251, .external_lex_state = 23},
  [538] = {.lex_state = 128},
  [539] = {.lex_state = 222, .external_lex_state = 2},
  [540] = {.lex_state = 181, .external_lex_state = 7},
  [541] = {.lex_state = 176, .external_lex_state = 9},
  [542] = {.lex_state = 174, .external_lex_state = 10},
  [543] = {.lex_state = 226, .external_lex_state = 15},
  [544] = {.lex_state = 188, .external_lex_state = 15},
  [545] = {.lex_state = 185, .external_lex_state = 14},
  [546] = {.lex_state = 128, .external_lex_state = 13},
  [547] = {.lex_state = 128, .external_lex_state = 13},
  [548] = {.lex_state = 185, .external_lex_state = 14},
  [549] = {.lex_state = 224, .external_lex_state = 22},
  [550] = {.lex_state = 128},
  [551] = {.lex_state = 185, .external_lex_state = 14},
  [552] = {.lex_state = 224, .external_lex_state = 22},
  [553] = {.lex_state = 128},
  [554] = {.lex_state = 185, .external_lex_state = 14},
  [555] = {.lex_state = 185, .external_lex_state = 14},
  [556] = {.lex_state = 128},
  [557] = {.lex_state = 128},
  [558] = {.lex_state = 192, .external_lex_state = 2},
  [559] = {.lex_state = 128},
  [560] = {.lex_state = 192, .external_lex_state = 2},
  [561] = {.lex_state = 147, .external_lex_state = 4},
  [562] = {.lex_state = 230, .external_lex_state = 32},
  [563] = {.lex_state = 154},
  [564] = {.lex_state = 161},
  [565] = {.lex_state = 161},
  [566] = {.lex_state = 118, .external_lex_state = 2},
  [567] = {.lex_state = 118, .external_lex_state = 2},
  [568] = {.lex_state = 118, .external_lex_state = 2},
  [569] = {.lex_state = 230, .external_lex_state = 32},
  [570] = {.lex_state = 228, .external_lex_state = 23},
  [571] = {.lex_state = 228, .external_lex_state = 23},
  [572] = {.lex_state = 234, .external_lex_state = 25},
  [573] = {.lex_state = 228, .external_lex_state = 23},
  [574] = {.lex_state = 185, .external_lex_state = 16},
  [575] = {.lex_state = 230, .external_lex_state = 23},
  [576] = {.lex_state = 230, .external_lex_state = 23},
  [577] = {.lex_state = 185, .external_lex_state = 16},
  [578] = {.lex_state = 194, .external_lex_state = 14},
  [579] = {.lex_state = 200, .external_lex_state = 12},
  [580] = {.lex_state = 200, .external_lex_state = 12},
  [581] = {.lex_state = 128},
  [582] = {.lex_state = 253, .external_lex_state = 23},
  [583] = {.lex_state = 174, .external_lex_state = 10},
  [584] = {.lex_state = 196, .external_lex_state = 15},
  [585] = {.lex_state = 128},
  [586] = {.lex_state = 200, .external_lex_state = 2},
  [587] = {.lex_state = 128},
  [588] = {.lex_state = 200, .external_lex_state = 2},
  [589] = {.lex_state = 147, .external_lex_state = 4},
  [590] = {.lex_state = 232, .external_lex_state = 32},
  [591] = {.lex_state = 232, .external_lex_state = 32},
  [592] = {.lex_state = 194, .external_lex_state = 16},
  [593] = {.lex_state = 232, .external_lex_state = 23},
  [594] = {.lex_state = 232, .external_lex_state = 23},
  [595] = {.lex_state = 194, .external_lex_state = 16},
  [596] = {.lex_state = 219, .external_lex_state = 18},
  [597] = {.lex_state = 208, .external_lex_state = 24},
  [598] = {.lex_state = 208, .external_lex_state = 24},
  [599] = {.lex_state = 204, .external_lex_state = 18},
  [600] = {.lex_state = 147, .external_lex_state = 4},
  [601] = {.lex_state = 208, .external_lex_state = 24},
  [602] = {.lex_state = 204, .external_lex_state = 24},
  [603] = {.lex_state = 154},
  [604] = {.lex_state = 204, .external_lex_state = 24},
  [605] = {.lex_state = 204, .external_lex_state = 24},
  [606] = {.lex_state = 204, .external_lex_state = 24},
  [607] = {.lex_state = 161, .external_lex_state = 13},
  [608] = {.lex_state = 128, .external_lex_state = 13},
  [609] = {.lex_state = 128, .external_lex_state = 13},
  [610] = {.lex_state = 128},
  [611] = {.lex_state = 192, .external_lex_state = 2},
  [612] = {.lex_state = 128},
  [613] = {.lex_state = 200, .external_lex_state = 2},
  [614] = {.lex_state = 128},
  [615] = {.lex_state = 192, .external_lex_state = 2},
  [616] = {.lex_state = 208, .external_lex_state = 24},
  [617] = {.lex_state = 234, .external_lex_state = 25},
  [618] = {.lex_state = 204, .external_lex_state = 18},
  [619] = {.lex_state = 161},
  [620] = {.lex_state = 161},
  [621] = {.lex_state = 234, .external_lex_state = 25},
  [622] = {.lex_state = 170, .external_lex_state = 12},
  [623] = {.lex_state = 170, .external_lex_state = 2},
  [624] = {.lex_state = 210, .external_lex_state = 4},
  [625] = {.lex_state = 170, .external_lex_state = 12},
  [626] = {.lex_state = 208, .external_lex_state = 18},
  [627] = {.lex_state = 176, .external_lex_state = 19},
  [628] = {.lex_state = 176, .external_lex_state = 19},
  [629] = {.lex_state = 168, .external_lex_state = 19},
  [630] = {.lex_state = 147, .external_lex_state = 4},
  [631] = {.lex_state = 210, .external_lex_state = 26},
  [632] = {.lex_state = 210, .external_lex_state = 26},
  [633] = {.lex_state = 154},
  [634] = {.lex_state = 210, .external_lex_state = 26},
  [635] = {.lex_state = 210, .external_lex_state = 26},
  [636] = {.lex_state = 210, .external_lex_state = 26},
  [637] = {.lex_state = 161, .external_lex_state = 13},
  [638] = {.lex_state = 128, .external_lex_state = 13},
  [639] = {.lex_state = 128, .external_lex_state = 13},
  [640] = {.lex_state = 128},
  [641] = {.lex_state = 192, .external_lex_state = 2},
  [642] = {.lex_state = 128},
  [643] = {.lex_state = 200, .external_lex_state = 2},
  [644] = {.lex_state = 128},
  [645] = {.lex_state = 192, .external_lex_state = 2},
  [646] = {.lex_state = 210, .external_lex_state = 26},
  [647] = {.lex_state = 176, .external_lex_state = 9},
  [648] = {.lex_state = 210, .external_lex_state = 4},
  [649] = {.lex_state = 176, .external_lex_state = 19},
  [650] = {.lex_state = 128, .external_lex_state = 13},
  [651] = {.lex_state = 128, .external_lex_state = 13},
  [652] = {.lex_state = 176, .external_lex_state = 19},
  [653] = {.lex_state = 224, .external_lex_state = 22},
  [654] = {.lex_state = 128},
  [655] = {.lex_state = 176, .external_lex_state = 19},
  [656] = {.lex_state = 224, .external_lex_state = 22},
  [657] = {.lex_state = 128},
  [658] = {.lex_state = 176, .external_lex_state = 19},
  [659] = {.lex_state = 176, .external_lex_state = 19},
  [660] = {.lex_state = 237, .external_lex_state = 27},
  [661] = {.lex_state = 237, .external_lex_state = 27},
  [662] = {.lex_state = 212, .external_lex_state = 20},
  [663] = {.lex_state = 237, .external_lex_state = 27},
  [664] = {.lex_state = 128, .external_lex_state = 13},
  [665] = {.lex_state = 128, .external_lex_state = 13},
  [666] = {.lex_state = 237, .external_lex_state = 27},
  [667] = {.lex_state = 224, .external_lex_state = 22},
  [668] = {.lex_state = 128},
  [669] = {.lex_state = 237, .external_lex_state = 27},
  [670] = {.lex_state = 224, .external_lex_state = 22},
  [671] = {.lex_state = 128},
  [672] = {.lex_state = 237, .external_lex_state = 27},
  [673] = {.lex_state = 237, .external_lex_state = 27},
  [674] = {.lex_state = 147, .external_lex_state = 4},
  [675] = {.lex_state = 240, .external_lex_state = 28},
  [676] = {.lex_state = 240, .external_lex_state = 28},
  [677] = {.lex_state = 154},
  [678] = {.lex_state = 240, .external_lex_state = 28},
  [679] = {.lex_state = 240, .external_lex_state = 28},
  [680] = {.lex_state = 240, .external_lex_state = 28},
  [681] = {.lex_state = 161, .external_lex_state = 13},
  [682] = {.lex_state = 128, .external_lex_state = 13},
  [683] = {.lex_state = 128, .external_lex_state = 13},
  [684] = {.lex_state = 128},
  [685] = {.lex_state = 192, .external_lex_state = 2},
  [686] = {.lex_state = 128},
  [687] = {.lex_state = 200, .external_lex_state = 2},
  [688] = {.lex_state = 128},
  [689] = {.lex_state = 192, .external_lex_state = 2},
  [690] = {.lex_state = 240, .external_lex_state = 28},
  [691] = {.lex_state = 128},
  [692] = {.lex_state = 240, .external_lex_state = 29},
  [693] = {.lex_state = 214, .external_lex_state = 2},
  [694] = {.lex_state = 181, .external_lex_state = 7},
  [695] = {.lex_state = 214, .external_lex_state = 2},
  [696] = {.lex_state = 128},
  [697] = {.lex_state = 242, .external_lex_state = 2},
  [698] = {.lex_state = 151, .external_lex_state = 7},
  [699] = {.lex_state = 168, .external_lex_state = 9},
  [700] = {.lex_state = 242, .external_lex_state = 2},
  [701] = {.lex_state = 216, .external_lex_state = 2},
  [702] = {.lex_state = 181, .external_lex_state = 7},
  [703] = {.lex_state = 128},
  [704] = {.lex_state = 216, .external_lex_state = 2},
  [705] = {.lex_state = 128},
  [706] = {.lex_state = 128},
  [707] = {.lex_state = 255, .external_lex_state = 33},
  [708] = {.lex_state = 181, .external_lex_state = 7},
  [709] = {.lex_state = 255, .external_lex_state = 33},
  [710] = {.lex_state = 244, .external_lex_state = 4},
  [711] = {.lex_state = 237},
  [712] = {.lex_state = 244, .external_lex_state = 4},
  [713] = {.lex_state = 244, .external_lex_state = 4},
  [714] = {.lex_state = 178, .external_lex_state = 11},
  [715] = {.lex_state = 128},
  [716] = {.lex_state = 178, .external_lex_state = 11},
  [717] = {.lex_state = 128},
  [718] = {.lex_state = 249, .external_lex_state = 31},
  [719] = {.lex_state = 178, .external_lex_state = 11},
  [720] = {.lex_state = 249, .external_lex_state = 31},
  [721] = {.lex_state = 249, .external_lex_state = 31},
  [722] = {.lex_state = 128, .external_lex_state = 21},
  [723] = {.lex_state = 249, .external_lex_state = 31},
  [724] = {.lex_state = 249, .external_lex_state = 31},
  [725] = {.lex_state = 249, .external_lex_state = 31},
  [726] = {.lex_state = 128, .external_lex_state = 21},
  [727] = {.lex_state = 181, .external_lex_state = 7},
  [728] = {.lex_state = 244, .external_lex_state = 4},
  [729] = {.lex_state = 244, .external_lex_state = 4},
  [730] = {.lex_state = 219, .external_lex_state = 18},
  [731] = {.lex_state = 247, .external_lex_state = 18},
  [732] = {.lex_state = 166, .external_lex_state = 6},
  [733] = {.lex_state = 147, .external_lex_state = 4},
  [734] = {.lex_state = 257, .external_lex_state = 11},
  [735] = {.lex_state = 154},
  [736] = {.lex_state = 161},
  [737] = {.lex_state = 161},
  [738] = {.lex_state = 118, .external_lex_state = 2},
  [739] = {.lex_state = 118, .external_lex_state = 2},
  [740] = {.lex_state = 118, .external_lex_state = 2},
  [741] = {.lex_state = 257, .external_lex_state = 11},
  [742] = {.lex_state = 181, .external_lex_state = 7},
  [743] = {.lex_state = 176, .external_lex_state = 19},
  [744] = {.lex_state = 176, .external_lex_state = 19},
  [745] = {.lex_state = 128},
  [746] = {.lex_state = 118},
  [747] = {.lex_state = 147, .external_lex_state = 4},
  [748] = {.lex_state = 181, .external_lex_state = 30},
  [749] = {.lex_state = 181, .external_lex_state = 30},
  [750] = {.lex_state = 247, .external_lex_state = 18},
  [751] = {.lex_state = 204, .external_lex_state = 24},
  [752] = {.lex_state = 204, .external_lex_state = 24},
  [753] = {.lex_state = 204, .external_lex_state = 24},
  [754] = {.lex_state = 204, .external_lex_state = 24},
  [755] = {.lex_state = 181, .external_lex_state = 7},
  [756] = {.lex_state = 204, .external_lex_state = 18},
  [757] = {.lex_state = 147, .external_lex_state = 4},
  [758] = {.lex_state = 151, .external_lex_state = 30},
  [759] = {.lex_state = 181, .external_lex_state = 5},
  [760] = {.lex_state = 210, .external_lex_state = 4},
  [761] = {.lex_state = 181, .external_lex_state = 30},
  [762] = {.lex_state = 154},
  [763] = {.lex_state = 181, .external_lex_state = 30},
  [764] = {.lex_state = 181, .external_lex_state = 30},
  [765] = {.lex_state = 181, .external_lex_state = 30},
  [766] = {.lex_state = 161, .external_lex_state = 13},
  [767] = {.lex_state = 128, .external_lex_state = 13},
  [768] = {.lex_state = 128, .external_lex_state = 13},
  [769] = {.lex_state = 128},
  [770] = {.lex_state = 192, .external_lex_state = 2},
  [771] = {.lex_state = 128},
  [772] = {.lex_state = 200, .external_lex_state = 2},
  [773] = {.lex_state = 128},
  [774] = {.lex_state = 192, .external_lex_state = 2},
  [775] = {.lex_state = 151, .external_lex_state = 30},
  [776] = {.lex_state = 170, .external_lex_state = 12},
  [777] = {.lex_state = 128},
  [778] = {.lex_state = 170, .external_lex_state = 12},
  [779] = {.lex_state = 128},
  [780] = {.lex_state = 249, .external_lex_state = 31},
  [781] = {.lex_state = 170, .external_lex_state = 12},
  [782] = {.lex_state = 249, .external_lex_state = 31},
  [783] = {.lex_state = 249, .external_lex_state = 31},
  [784] = {.lex_state = 128, .external_lex_state = 21},
  [785] = {.lex_state = 249, .external_lex_state = 31},
  [786] = {.lex_state = 249, .external_lex_state = 31},
  [787] = {.lex_state = 249, .external_lex_state = 31},
  [788] = {.lex_state = 128, .external_lex_state = 21},
  [789] = {.lex_state = 154},
  [790] = {.lex_state = 128},
  [791] = {.lex_state = 154},
  [792] = {.lex_state = 128},
  [793] = {.lex_state = 249, .external_lex_state = 31},
  [794] = {.lex_state = 154},
  [795] = {.lex_state = 249, .external_lex_state = 31},
  [796] = {.lex_state = 249, .external_lex_state = 31},
  [797] = {.lex_state = 128, .external_lex_state = 21},
  [798] = {.lex_state = 249, .external_lex_state = 31},
  [799] = {.lex_state = 249, .external_lex_state = 31},
  [800] = {.lex_state = 249, .external_lex_state = 31},
  [801] = {.lex_state = 128, .external_lex_state = 21},
  [802] = {.lex_state = 128, .external_lex_state = 21},
  [803] = {.lex_state = 128, .external_lex_state = 21},
  [804] = {.lex_state = 224, .external_lex_state = 22},
  [805] = {.lex_state = 172, .external_lex_state = 3},
  [806] = {.lex_state = 249, .external_lex_state = 31},
  [807] = {.lex_state = 224, .external_lex_state = 22},
  [808] = {.lex_state = 172, .external_lex_state = 3},
  [809] = {.lex_state = 249, .external_lex_state = 31},
  [810] = {.lex_state = 128, .external_lex_state = 13},
  [811] = {.lex_state = 224, .external_lex_state = 22},
  [812] = {.lex_state = 172, .external_lex_state = 3},
  [813] = {.lex_state = 224, .external_lex_state = 22},
  [814] = {.lex_state = 172, .external_lex_state = 3},
  [815] = {.lex_state = 128, .external_lex_state = 13},
  [816] = {.lex_state = 147, .external_lex_state = 4},
  [817] = {.lex_state = 192, .external_lex_state = 12},
  [818] = {.lex_state = 192, .external_lex_state = 2},
  [819] = {.lex_state = 210, .external_lex_state = 4},
  [820] = {.lex_state = 192, .external_lex_state = 12},
  [821] = {.lex_state = 154},
  [822] = {.lex_state = 192, .external_lex_state = 12},
  [823] = {.lex_state = 192, .external_lex_state = 12},
  [824] = {.lex_state = 192, .external_lex_state = 12},
  [825] = {.lex_state = 161, .external_lex_state = 13},
  [826] = {.lex_state = 128, .external_lex_state = 13},
  [827] = {.lex_state = 128, .external_lex_state = 13},
  [828] = {.lex_state = 128},
  [829] = {.lex_state = 192, .external_lex_state = 2},
  [830] = {.lex_state = 128},
  [831] = {.lex_state = 200, .external_lex_state = 2},
  [832] = {.lex_state = 128},
  [833] = {.lex_state = 192, .external_lex_state = 2},
  [834] = {.lex_state = 192, .external_lex_state = 12},
  [835] = {.lex_state = 240, .external_lex_state = 29},
  [836] = {.lex_state = 128},
  [837] = {.lex_state = 214, .external_lex_state = 2},
  [838] = {.lex_state = 128},
  [839] = {.lex_state = 128},
  [840] = {.lex_state = 216, .external_lex_state = 2},
  [841] = {.lex_state = 128},
  [842] = {.lex_state = 244, .external_lex_state = 4},
  [843] = {.lex_state = 178, .external_lex_state = 7},
  [844] = {.lex_state = 244, .external_lex_state = 4},
  [845] = {.lex_state = 178, .external_lex_state = 7},
  [846] = {.lex_state = 128},
  [847] = {.lex_state = 259, .external_lex_state = 23},
  [848] = {.lex_state = 166, .external_lex_state = 6},
  [849] = {.lex_state = 118},
  [850] = {.lex_state = 147, .external_lex_state = 4},
  [851] = {.lex_state = 128},
  [852] = {.lex_state = 128},
  [853] = {.lex_state = 222, .external_lex_state = 2},
  [854] = {.lex_state = 188, .external_lex_state = 34},
  [855] = {.lex_state = 226, .external_lex_state = 15},
  [856] = {.lex_state = 210, .external_lex_state = 4},
  [857] = {.lex_state = 154},
  [858] = {.lex_state = 161},
  [859] = {.lex_state = 161},
  [860] = {.lex_state = 118, .external_lex_state = 2},
  [861] = {.lex_state = 118, .external_lex_state = 2},
  [862] = {.lex_state = 118, .external_lex_state = 2},
  [863] = {.lex_state = 188, .external_lex_state = 34},
  [864] = {.lex_state = 185, .external_lex_state = 14},
  [865] = {.lex_state = 128},
  [866] = {.lex_state = 185, .external_lex_state = 14},
  [867] = {.lex_state = 128},
  [868] = {.lex_state = 249, .external_lex_state = 31},
  [869] = {.lex_state = 185, .external_lex_state = 14},
  [870] = {.lex_state = 249, .external_lex_state = 31},
  [871] = {.lex_state = 249, .external_lex_state = 31},
  [872] = {.lex_state = 128, .external_lex_state = 21},
  [873] = {.lex_state = 249, .external_lex_state = 31},
  [874] = {.lex_state = 249, .external_lex_state = 31},
  [875] = {.lex_state = 249, .external_lex_state = 31},
  [876] = {.lex_state = 128, .external_lex_state = 21},
  [877] = {.lex_state = 251, .external_lex_state = 23},
  [878] = {.lex_state = 230, .external_lex_state = 32},
  [879] = {.lex_state = 230, .external_lex_state = 32},
  [880] = {.lex_state = 228, .external_lex_state = 23},
  [881] = {.lex_state = 147, .external_lex_state = 4},
  [882] = {.lex_state = 230, .external_lex_state = 32},
  [883] = {.lex_state = 228, .external_lex_state = 32},
  [884] = {.lex_state = 154},
  [885] = {.lex_state = 228, .external_lex_state = 32},
  [886] = {.lex_state = 228, .external_lex_state = 32},
  [887] = {.lex_state = 228, .external_lex_state = 32},
  [888] = {.lex_state = 161, .external_lex_state = 13},
  [889] = {.lex_state = 128, .external_lex_state = 13},
  [890] = {.lex_state = 128, .external_lex_state = 13},
  [891] = {.lex_state = 128},
  [892] = {.lex_state = 192, .external_lex_state = 2},
  [893] = {.lex_state = 128},
  [894] = {.lex_state = 200, .external_lex_state = 2},
  [895] = {.lex_state = 128},
  [896] = {.lex_state = 192, .external_lex_state = 2},
  [897] = {.lex_state = 230, .external_lex_state = 32},
  [898] = {.lex_state = 228, .external_lex_state = 23},
  [899] = {.lex_state = 234, .external_lex_state = 25},
  [900] = {.lex_state = 230, .external_lex_state = 23},
  [901] = {.lex_state = 200, .external_lex_state = 12},
  [902] = {.lex_state = 200, .external_lex_state = 12},
  [903] = {.lex_state = 128},
  [904] = {.lex_state = 118},
  [905] = {.lex_state = 147, .external_lex_state = 4},
  [906] = {.lex_state = 196, .external_lex_state = 34},
  [907] = {.lex_state = 196, .external_lex_state = 34},
  [908] = {.lex_state = 253, .external_lex_state = 23},
  [909] = {.lex_state = 232, .external_lex_state = 32},
  [910] = {.lex_state = 232, .external_lex_state = 32},
  [911] = {.lex_state = 232, .external_lex_state = 32},
  [912] = {.lex_state = 232, .external_lex_state = 32},
  [913] = {.lex_state = 232, .external_lex_state = 23},
  [914] = {.lex_state = 181, .external_lex_state = 7},
  [915] = {.lex_state = 204, .external_lex_state = 24},
  [916] = {.lex_state = 204, .external_lex_state = 24},
  [917] = {.lex_state = 208, .external_lex_state = 24},
  [918] = {.lex_state = 204, .external_lex_state = 24},
  [919] = {.lex_state = 128, .external_lex_state = 13},
  [920] = {.lex_state = 128, .external_lex_state = 13},
  [921] = {.lex_state = 204, .external_lex_state = 24},
  [922] = {.lex_state = 224, .external_lex_state = 22},
  [923] = {.lex_state = 128},
  [924] = {.lex_state = 204, .external_lex_state = 24},
  [925] = {.lex_state = 224, .external_lex_state = 22},
  [926] = {.lex_state = 128},
  [927] = {.lex_state = 204, .external_lex_state = 24},
  [928] = {.lex_state = 204, .external_lex_state = 24},
  [929] = {.lex_state = 234, .external_lex_state = 25},
  [930] = {.lex_state = 234, .external_lex_state = 25},
  [931] = {.lex_state = 234, .external_lex_state = 25},
  [932] = {.lex_state = 161, .external_lex_state = 13},
  [933] = {.lex_state = 128, .external_lex_state = 13},
  [934] = {.lex_state = 128, .external_lex_state = 13},
  [935] = {.lex_state = 204, .external_lex_state = 18},
  [936] = {.lex_state = 234, .external_lex_state = 25},
  [937] = {.lex_state = 170, .external_lex_state = 2},
  [938] = {.lex_state = 210, .external_lex_state = 4},
  [939] = {.lex_state = 210, .external_lex_state = 26},
  [940] = {.lex_state = 210, .external_lex_state = 26},
  [941] = {.lex_state = 210, .external_lex_state = 26},
  [942] = {.lex_state = 210, .external_lex_state = 26},
  [943] = {.lex_state = 128, .external_lex_state = 13},
  [944] = {.lex_state = 128, .external_lex_state = 13},
  [945] = {.lex_state = 210, .external_lex_state = 26},
  [946] = {.lex_state = 224, .external_lex_state = 22},
  [947] = {.lex_state = 128},
  [948] = {.lex_state = 210, .external_lex_state = 26},
  [949] = {.lex_state = 224, .external_lex_state = 22},
  [950] = {.lex_state = 128},
  [951] = {.lex_state = 210, .external_lex_state = 26},
  [952] = {.lex_state = 210, .external_lex_state = 26},
  [953] = {.lex_state = 176, .external_lex_state = 19},
  [954] = {.lex_state = 128},
  [955] = {.lex_state = 176, .external_lex_state = 19},
  [956] = {.lex_state = 128},
  [957] = {.lex_state = 249, .external_lex_state = 31},
  [958] = {.lex_state = 176, .external_lex_state = 19},
  [959] = {.lex_state = 249, .external_lex_state = 31},
  [960] = {.lex_state = 249, .external_lex_state = 31},
  [961] = {.lex_state = 128, .external_lex_state = 21},
  [962] = {.lex_state = 249, .external_lex_state = 31},
  [963] = {.lex_state = 249, .external_lex_state = 31},
  [964] = {.lex_state = 249, .external_lex_state = 31},
  [965] = {.lex_state = 128, .external_lex_state = 21},
  [966] = {.lex_state = 237, .external_lex_state = 27},
  [967] = {.lex_state = 128},
  [968] = {.lex_state = 237, .external_lex_state = 27},
  [969] = {.lex_state = 128},
  [970] = {.lex_state = 249, .external_lex_state = 31},
  [971] = {.lex_state = 237, .external_lex_state = 27},
  [972] = {.lex_state = 249, .external_lex_state = 31},
  [973] = {.lex_state = 249, .external_lex_state = 31},
  [974] = {.lex_state = 128, .external_lex_state = 21},
  [975] = {.lex_state = 249, .external_lex_state = 31},
  [976] = {.lex_state = 249, .external_lex_state = 31},
  [977] = {.lex_state = 249, .external_lex_state = 31},
  [978] = {.lex_state = 128, .external_lex_state = 21},
  [979] = {.lex_state = 240, .external_lex_state = 28},
  [980] = {.lex_state = 240, .external_lex_state = 28},
  [981] = {.lex_state = 240, .external_lex_state = 28},
  [982] = {.lex_state = 240, .external_lex_state = 28},
  [983] = {.lex_state = 128, .external_lex_state = 13},
  [984] = {.lex_state = 128, .external_lex_state = 13},
  [985] = {.lex_state = 240, .external_lex_state = 28},
  [986] = {.lex_state = 224, .external_lex_state = 22},
  [987] = {.lex_state = 128},
  [988] = {.lex_state = 240, .external_lex_state = 28},
  [989] = {.lex_state = 224, .external_lex_state = 22},
  [990] = {.lex_state = 128},
  [991] = {.lex_state = 240, .external_lex_state = 28},
  [992] = {.lex_state = 240, .external_lex_state = 28},
  [993] = {.lex_state = 181, .external_lex_state = 7},
  [994] = {.lex_state = 216, .external_lex_state = 2},
  [995] = {.lex_state = 242, .external_lex_state = 2},
  [996] = {.lex_state = 242, .external_lex_state = 2},
  [997] = {.lex_state = 181, .external_lex_state = 7},
  [998] = {.lex_state = 128},
  [999] = {.lex_state = 147, .external_lex_state = 4},
  [1000] = {.lex_state = 261, .external_lex_state = 2},
  [1001] = {.lex_state = 237},
  [1002] = {.lex_state = 255, .external_lex_state = 33},
  [1003] = {.lex_state = 261, .external_lex_state = 2},
  [1004] = {.lex_state = 237},
  [1005] = {.lex_state = 255, .external_lex_state = 33},
  [1006] = {.lex_state = 181, .external_lex_state = 7},
  [1007] = {.lex_state = 244, .external_lex_state = 4},
  [1008] = {.lex_state = 244, .external_lex_state = 4},
  [1009] = {.lex_state = 128, .external_lex_state = 21},
  [1010] = {.lex_state = 128, .external_lex_state = 21},
  [1011] = {.lex_state = 224, .external_lex_state = 22},
  [1012] = {.lex_state = 178, .external_lex_state = 11},
  [1013] = {.lex_state = 224, .external_lex_state = 22},
  [1014] = {.lex_state = 178, .external_lex_state = 11},
  [1015] = {.lex_state = 128, .external_lex_state = 13},
  [1016] = {.lex_state = 224, .external_lex_state = 22},
  [1017] = {.lex_state = 178, .external_lex_state = 11},
  [1018] = {.lex_state = 224, .external_lex_state = 22},
  [1019] = {.lex_state = 178, .external_lex_state = 11},
  [1020] = {.lex_state = 128, .external_lex_state = 13},
  [1021] = {.lex_state = 181, .external_lex_state = 7},
  [1022] = {.lex_state = 244, .external_lex_state = 4},
  [1023] = {.lex_state = 181, .external_lex_state = 7},
  [1024] = {.lex_state = 257, .external_lex_state = 11},
  [1025] = {.lex_state = 257, .external_lex_state = 11},
  [1026] = {.lex_state = 181, .external_lex_state = 7},
  [1027] = {.lex_state = 147, .external_lex_state = 4},
  [1028] = {.lex_state = 257, .external_lex_state = 11},
  [1029] = {.lex_state = 264, .external_lex_state = 11},
  [1030] = {.lex_state = 154},
  [1031] = {.lex_state = 264, .external_lex_state = 11},
  [1032] = {.lex_state = 264, .external_lex_state = 11},
  [1033] = {.lex_state = 264, .external_lex_state = 11},
  [1034] = {.lex_state = 161, .external_lex_state = 13},
  [1035] = {.lex_state = 128, .external_lex_state = 13},
  [1036] = {.lex_state = 128, .external_lex_state = 13},
  [1037] = {.lex_state = 128},
  [1038] = {.lex_state = 192, .external_lex_state = 2},
  [1039] = {.lex_state = 128},
  [1040] = {.lex_state = 200, .external_lex_state = 2},
  [1041] = {.lex_state = 128},
  [1042] = {.lex_state = 192, .external_lex_state = 2},
  [1043] = {.lex_state = 257, .external_lex_state = 11},
  [1044] = {.lex_state = 176, .external_lex_state = 19},
  [1045] = {.lex_state = 247, .external_lex_state = 18},
  [1046] = {.lex_state = 147, .external_lex_state = 4},
  [1047] = {.lex_state = 264, .external_lex_state = 11},
  [1048] = {.lex_state = 264, .external_lex_state = 11},
  [1049] = {.lex_state = 181, .external_lex_state = 30},
  [1050] = {.lex_state = 181, .external_lex_state = 30},
  [1051] = {.lex_state = 204, .external_lex_state = 24},
  [1052] = {.lex_state = 181, .external_lex_state = 30},
  [1053] = {.lex_state = 181, .external_lex_state = 30},
  [1054] = {.lex_state = 151, .external_lex_state = 30},
  [1055] = {.lex_state = 181, .external_lex_state = 5},
  [1056] = {.lex_state = 181, .external_lex_state = 30},
  [1057] = {.lex_state = 128, .external_lex_state = 13},
  [1058] = {.lex_state = 128, .external_lex_state = 13},
  [1059] = {.lex_state = 181, .external_lex_state = 30},
  [1060] = {.lex_state = 224, .external_lex_state = 22},
  [1061] = {.lex_state = 128},
  [1062] = {.lex_state = 181, .external_lex_state = 30},
  [1063] = {.lex_state = 224, .external_lex_state = 22},
  [1064] = {.lex_state = 128},
  [1065] = {.lex_state = 181, .external_lex_state = 30},
  [1066] = {.lex_state = 181, .external_lex_state = 30},
  [1067] = {.lex_state = 128, .external_lex_state = 21},
  [1068] = {.lex_state = 128, .external_lex_state = 21},
  [1069] = {.lex_state = 224, .external_lex_state = 22},
  [1070] = {.lex_state = 170, .external_lex_state = 12},
  [1071] = {.lex_state = 224, .external_lex_state = 22},
  [1072] = {.lex_state = 170, .external_lex_state = 12},
  [1073] = {.lex_state = 128, .external_lex_state = 13},
  [1074] = {.lex_state = 224, .external_lex_state = 22},
  [1075] = {.lex_state = 170, .external_lex_state = 12},
  [1076] = {.lex_state = 224, .external_lex_state = 22},
  [1077] = {.lex_state = 170, .external_lex_state = 12},
  [1078] = {.lex_state = 128, .external_lex_state = 13},
  [1079] = {.lex_state = 128, .external_lex_state = 21},
  [1080] = {.lex_state = 128, .external_lex_state = 21},
  [1081] = {.lex_state = 224, .external_lex_state = 22},
  [1082] = {.lex_state = 154},
  [1083] = {.lex_state = 224, .external_lex_state = 22},
  [1084] = {.lex_state = 154},
  [1085] = {.lex_state = 128, .external_lex_state = 13},
  [1086] = {.lex_state = 224, .external_lex_state = 22},
  [1087] = {.lex_state = 154},
  [1088] = {.lex_state = 224, .external_lex_state = 22},
  [1089] = {.lex_state = 154},
  [1090] = {.lex_state = 128, .external_lex_state = 13},
  [1091] = {.lex_state = 128, .external_lex_state = 13},
  [1092] = {.lex_state = 128, .external_lex_state = 13},
  [1093] = {.lex_state = 172, .external_lex_state = 3},
  [1094] = {.lex_state = 249, .external_lex_state = 31},
  [1095] = {.lex_state = 172, .external_lex_state = 3},
  [1096] = {.lex_state = 172, .external_lex_state = 3},
  [1097] = {.lex_state = 172, .external_lex_state = 3},
  [1098] = {.lex_state = 192, .external_lex_state = 12},
  [1099] = {.lex_state = 192, .external_lex_state = 12},
  [1100] = {.lex_state = 192, .external_lex_state = 12},
  [1101] = {.lex_state = 192, .external_lex_state = 2},
  [1102] = {.lex_state = 192, .external_lex_state = 12},
  [1103] = {.lex_state = 128, .external_lex_state = 13},
  [1104] = {.lex_state = 128, .external_lex_state = 13},
  [1105] = {.lex_state = 192, .external_lex_state = 12},
  [1106] = {.lex_state = 224, .external_lex_state = 22},
  [1107] = {.lex_state = 128},
  [1108] = {.lex_state = 192, .external_lex_state = 12},
  [1109] = {.lex_state = 224, .external_lex_state = 22},
  [1110] = {.lex_state = 128},
  [1111] = {.lex_state = 192, .external_lex_state = 12},
  [1112] = {.lex_state = 192, .external_lex_state = 12},
  [1113] = {.lex_state = 128},
  [1114] = {.lex_state = 128},
  [1115] = {.lex_state = 128},
  [1116] = {.lex_state = 128},
  [1117] = {.lex_state = 128},
  [1118] = {.lex_state = 128},
  [1119] = {.lex_state = 244, .external_lex_state = 4},
  [1120] = {.lex_state = 244, .external_lex_state = 4},
  [1121] = {.lex_state = 128},
  [1122] = {.lex_state = 244, .external_lex_state = 4},
  [1123] = {.lex_state = 244, .external_lex_state = 4},
  [1124] = {.lex_state = 251, .external_lex_state = 23},
  [1125] = {.lex_state = 259, .external_lex_state = 23},
  [1126] = {.lex_state = 147, .external_lex_state = 4},
  [1127] = {.lex_state = 266, .external_lex_state = 33},
  [1128] = {.lex_state = 154},
  [1129] = {.lex_state = 161},
  [1130] = {.lex_state = 161},
  [1131] = {.lex_state = 118, .external_lex_state = 2},
  [1132] = {.lex_state = 118, .external_lex_state = 2},
  [1133] = {.lex_state = 118, .external_lex_state = 2},
  [1134] = {.lex_state = 266, .external_lex_state = 33},
  [1135] = {.lex_state = 128},
  [1136] = {.lex_state = 128},
  [1137] = {.lex_state = 147, .external_lex_state = 4},
  [1138] = {.lex_state = 188, .external_lex_state = 34},
  [1139] = {.lex_state = 226, .external_lex_state = 15},
  [1140] = {.lex_state = 210, .external_lex_state = 4},
  [1141] = {.lex_state = 226, .external_lex_state = 34},
  [1142] = {.lex_state = 154},
  [1143] = {.lex_state = 226, .external_lex_state = 34},
  [1144] = {.lex_state = 226, .external_lex_state = 34},
  [1145] = {.lex_state = 226, .external_lex_state = 34},
  [1146] = {.lex_state = 161, .external_lex_state = 13},
  [1147] = {.lex_state = 128, .external_lex_state = 13},
  [1148] = {.lex_state = 128, .external_lex_state = 13},
  [1149] = {.lex_state = 128},
  [1150] = {.lex_state = 192, .external_lex_state = 2},
  [1151] = {.lex_state = 128},
  [1152] = {.lex_state = 200, .external_lex_state = 2},
  [1153] = {.lex_state = 128},
  [1154] = {.lex_state = 192, .external_lex_state = 2},
  [1155] = {.lex_state = 188, .external_lex_state = 34},
  [1156] = {.lex_state = 128, .external_lex_state = 21},
  [1157] = {.lex_state = 128, .external_lex_state = 21},
  [1158] = {.lex_state = 224, .external_lex_state = 22},
  [1159] = {.lex_state = 185, .external_lex_state = 14},
  [1160] = {.lex_state = 224, .external_lex_state = 22},
  [1161] = {.lex_state = 185, .external_lex_state = 14},
  [1162] = {.lex_state = 128, .external_lex_state = 13},
  [1163] = {.lex_state = 224, .external_lex_state = 22},
  [1164] = {.lex_state = 185, .external_lex_state = 14},
  [1165] = {.lex_state = 224, .external_lex_state = 22},
  [1166] = {.lex_state = 185, .external_lex_state = 14},
  [1167] = {.lex_state = 128, .external_lex_state = 13},
  [1168] = {.lex_state = 128},
  [1169] = {.lex_state = 228, .external_lex_state = 32},
  [1170] = {.lex_state = 228, .external_lex_state = 32},
  [1171] = {.lex_state = 230, .external_lex_state = 32},
  [1172] = {.lex_state = 228, .external_lex_state = 32},
  [1173] = {.lex_state = 128, .external_lex_state = 13},
  [1174] = {.lex_state = 128, .external_lex_state = 13},
  [1175] = {.lex_state = 228, .external_lex_state = 32},
  [1176] = {.lex_state = 224, .external_lex_state = 22},
  [1177] = {.lex_state = 128},
  [1178] = {.lex_state = 228, .external_lex_state = 32},
  [1179] = {.lex_state = 224, .external_lex_state = 22},
  [1180] = {.lex_state = 128},
  [1181] = {.lex_state = 228, .external_lex_state = 32},
  [1182] = {.lex_state = 228, .external_lex_state = 32},
  [1183] = {.lex_state = 228, .external_lex_state = 23},
  [1184] = {.lex_state = 200, .external_lex_state = 12},
  [1185] = {.lex_state = 253, .external_lex_state = 23},
  [1186] = {.lex_state = 147, .external_lex_state = 4},
  [1187] = {.lex_state = 268, .external_lex_state = 33},
  [1188] = {.lex_state = 268, .external_lex_state = 33},
  [1189] = {.lex_state = 196, .external_lex_state = 34},
  [1190] = {.lex_state = 196, .external_lex_state = 34},
  [1191] = {.lex_state = 232, .external_lex_state = 32},
  [1192] = {.lex_state = 204, .external_lex_state = 24},
  [1193] = {.lex_state = 128},
  [1194] = {.lex_state = 204, .external_lex_state = 24},
  [1195] = {.lex_state = 128},
  [1196] = {.lex_state = 249, .external_lex_state = 31},
  [1197] = {.lex_state = 204, .external_lex_state = 24},
  [1198] = {.lex_state = 249, .external_lex_state = 31},
  [1199] = {.lex_state = 249, .external_lex_state = 31},
  [1200] = {.lex_state = 128, .external_lex_state = 21},
  [1201] = {.lex_state = 249, .external_lex_state = 31},
  [1202] = {.lex_state = 249, .external_lex_state = 31},
  [1203] = {.lex_state = 249, .external_lex_state = 31},
  [1204] = {.lex_state = 128, .external_lex_state = 21},
  [1205] = {.lex_state = 128, .external_lex_state = 13},
  [1206] = {.lex_state = 128, .external_lex_state = 13},
  [1207] = {.lex_state = 234, .external_lex_state = 25},
  [1208] = {.lex_state = 224, .external_lex_state = 22},
  [1209] = {.lex_state = 128},
  [1210] = {.lex_state = 234, .external_lex_state = 25},
  [1211] = {.lex_state = 224, .external_lex_state = 22},
  [1212] = {.lex_state = 128},
  [1213] = {.lex_state = 170, .external_lex_state = 2},
  [1214] = {.lex_state = 210, .external_lex_state = 26},
  [1215] = {.lex_state = 128},
  [1216] = {.lex_state = 210, .external_lex_state = 26},
  [1217] = {.lex_state = 128},
  [1218] = {.lex_state = 249, .external_lex_state = 31},
  [1219] = {.lex_state = 210, .external_lex_state = 26},
  [1220] = {.lex_state = 249, .external_lex_state = 31},
  [1221] = {.lex_state = 249, .external_lex_state = 31},
  [1222] = {.lex_state = 128, .external_lex_state = 21},
  [1223] = {.lex_state = 249, .external_lex_state = 31},
  [1224] = {.lex_state = 249, .external_lex_state = 31},
  [1225] = {.lex_state = 249, .external_lex_state = 31},
  [1226] = {.lex_state = 128, .external_lex_state = 21},
  [1227] = {.lex_state = 128, .external_lex_state = 21},
  [1228] = {.lex_state = 128, .external_lex_state = 21},
  [1229] = {.lex_state = 224, .external_lex_state = 22},
  [1230] = {.lex_state = 176, .external_lex_state = 19},
  [1231] = {.lex_state = 224, .external_lex_state = 22},
  [1232] = {.lex_state = 176, .external_lex_state = 19},
  [1233] = {.lex_state = 128, .external_lex_state = 13},
  [1234] = {.lex_state = 224, .external_lex_state = 22},
  [1235] = {.lex_state = 176, .external_lex_state = 19},
  [1236] = {.lex_state = 224, .external_lex_state = 22},
  [1237] = {.lex_state = 176, .external_lex_state = 19},
  [1238] = {.lex_state = 128, .external_lex_state = 13},
  [1239] = {.lex_state = 128, .external_lex_state = 21},
  [1240] = {.lex_state = 128, .external_lex_state = 21},
  [1241] = {.lex_state = 224, .external_lex_state = 22},
  [1242] = {.lex_state = 237, .external_lex_state = 27},
  [1243] = {.lex_state = 224, .external_lex_state = 22},
  [1244] = {.lex_state = 237, .external_lex_state = 27},
  [1245] = {.lex_state = 128, .external_lex_state = 13},
  [1246] = {.lex_state = 224, .external_lex_state = 22},
  [1247] = {.lex_state = 237, .external_lex_state = 27},
  [1248] = {.lex_state = 224, .external_lex_state = 22},
  [1249] = {.lex_state = 237, .external_lex_state = 27},
  [1250] = {.lex_state = 128, .external_lex_state = 13},
  [1251] = {.lex_state = 240, .external_lex_state = 28},
  [1252] = {.lex_state = 128},
  [1253] = {.lex_state = 240, .external_lex_state = 28},
  [1254] = {.lex_state = 128},
  [1255] = {.lex_state = 249, .external_lex_state = 31},
  [1256] = {.lex_state = 240, .external_lex_state = 28},
  [1257] = {.lex_state = 249, .external_lex_state = 31},
  [1258] = {.lex_state = 249, .external_lex_state = 31},
  [1259] = {.lex_state = 128, .external_lex_state = 21},
  [1260] = {.lex_state = 249, .external_lex_state = 31},
  [1261] = {.lex_state = 249, .external_lex_state = 31},
  [1262] = {.lex_state = 249, .external_lex_state = 31},
  [1263] = {.lex_state = 128, .external_lex_state = 21},
  [1264] = {.lex_state = 216, .external_lex_state = 2},
  [1265] = {.lex_state = 181, .external_lex_state = 7},
  [1266] = {.lex_state = 255, .external_lex_state = 33},
  [1267] = {.lex_state = 255, .external_lex_state = 33},
  [1268] = {.lex_state = 237},
  [1269] = {.lex_state = 244, .external_lex_state = 4},
  [1270] = {.lex_state = 261, .external_lex_state = 2},
  [1271] = {.lex_state = 151, .external_lex_state = 7},
  [1272] = {.lex_state = 168, .external_lex_state = 9},
  [1273] = {.lex_state = 261, .external_lex_state = 2},
  [1274] = {.lex_state = 261, .external_lex_state = 2},
  [1275] = {.lex_state = 237},
  [1276] = {.lex_state = 255, .external_lex_state = 33},
  [1277] = {.lex_state = 244, .external_lex_state = 4},
  [1278] = {.lex_state = 261, .external_lex_state = 2},
  [1279] = {.lex_state = 261, .external_lex_state = 2},
  [1280] = {.lex_state = 181, .external_lex_state = 7},
  [1281] = {.lex_state = 128, .external_lex_state = 13},
  [1282] = {.lex_state = 128, .external_lex_state = 13},
  [1283] = {.lex_state = 178, .external_lex_state = 11},
  [1284] = {.lex_state = 178, .external_lex_state = 11},
  [1285] = {.lex_state = 178, .external_lex_state = 11},
  [1286] = {.lex_state = 178, .external_lex_state = 11},
  [1287] = {.lex_state = 181, .external_lex_state = 7},
  [1288] = {.lex_state = 264, .external_lex_state = 11},
  [1289] = {.lex_state = 264, .external_lex_state = 11},
  [1290] = {.lex_state = 257, .external_lex_state = 11},
  [1291] = {.lex_state = 264, .external_lex_state = 11},
  [1292] = {.lex_state = 128, .external_lex_state = 13},
  [1293] = {.lex_state = 128, .external_lex_state = 13},
  [1294] = {.lex_state = 264, .external_lex_state = 11},
  [1295] = {.lex_state = 224, .external_lex_state = 22},
  [1296] = {.lex_state = 128},
  [1297] = {.lex_state = 264, .external_lex_state = 11},
  [1298] = {.lex_state = 224, .external_lex_state = 22},
  [1299] = {.lex_state = 128},
  [1300] = {.lex_state = 264, .external_lex_state = 11},
  [1301] = {.lex_state = 264, .external_lex_state = 11},
  [1302] = {.lex_state = 264, .external_lex_state = 11},
  [1303] = {.lex_state = 264, .external_lex_state = 11},
  [1304] = {.lex_state = 264, .external_lex_state = 11},
  [1305] = {.lex_state = 264, .external_lex_state = 11},
  [1306] = {.lex_state = 181, .external_lex_state = 30},
  [1307] = {.lex_state = 181, .external_lex_state = 30},
  [1308] = {.lex_state = 128},
  [1309] = {.lex_state = 181, .external_lex_state = 30},
  [1310] = {.lex_state = 128},
  [1311] = {.lex_state = 249, .external_lex_state = 31},
  [1312] = {.lex_state = 181, .external_lex_state = 30},
  [1313] = {.lex_state = 249, .external_lex_state = 31},
  [1314] = {.lex_state = 249, .external_lex_state = 31},
  [1315] = {.lex_state = 128, .external_lex_state = 21},
  [1316] = {.lex_state = 249, .external_lex_state = 31},
  [1317] = {.lex_state = 249, .external_lex_state = 31},
  [1318] = {.lex_state = 249, .external_lex_state = 31},
  [1319] = {.lex_state = 128, .external_lex_state = 21},
  [1320] = {.lex_state = 128, .external_lex_state = 13},
  [1321] = {.lex_state = 128, .external_lex_state = 13},
  [1322] = {.lex_state = 170, .external_lex_state = 12},
  [1323] = {.lex_state = 170, .external_lex_state = 12},
  [1324] = {.lex_state = 170, .external_lex_state = 12},
  [1325] = {.lex_state = 170, .external_lex_state = 12},
  [1326] = {.lex_state = 128, .external_lex_state = 13},
  [1327] = {.lex_state = 128, .external_lex_state = 13},
  [1328] = {.lex_state = 154},
  [1329] = {.lex_state = 154},
  [1330] = {.lex_state = 154},
  [1331] = {.lex_state = 154},
  [1332] = {.lex_state = 172, .external_lex_state = 3},
  [1333] = {.lex_state = 172, .external_lex_state = 3},
  [1334] = {.lex_state = 192, .external_lex_state = 12},
  [1335] = {.lex_state = 128},
  [1336] = {.lex_state = 192, .external_lex_state = 12},
  [1337] = {.lex_state = 128},
  [1338] = {.lex_state = 249, .external_lex_state = 31},
  [1339] = {.lex_state = 192, .external_lex_state = 12},
  [1340] = {.lex_state = 249, .external_lex_state = 31},
  [1341] = {.lex_state = 249, .external_lex_state = 31},
  [1342] = {.lex_state = 128, .external_lex_state = 21},
  [1343] = {.lex_state = 249, .external_lex_state = 31},
  [1344] = {.lex_state = 249, .external_lex_state = 31},
  [1345] = {.lex_state = 249, .external_lex_state = 31},
  [1346] = {.lex_state = 128, .external_lex_state = 21},
  [1347] = {.lex_state = 128},
  [1348] = {.lex_state = 128},
  [1349] = {.lex_state = 128},
  [1350] = {.lex_state = 128},
  [1351] = {.lex_state = 244, .external_lex_state = 4},
  [1352] = {.lex_state = 128},
  [1353] = {.lex_state = 244, .external_lex_state = 4},
  [1354] = {.lex_state = 128},
  [1355] = {.lex_state = 266, .external_lex_state = 33},
  [1356] = {.lex_state = 266, .external_lex_state = 33},
  [1357] = {.lex_state = 128},
  [1358] = {.lex_state = 147, .external_lex_state = 4},
  [1359] = {.lex_state = 266, .external_lex_state = 33},
  [1360] = {.lex_state = 270, .external_lex_state = 33},
  [1361] = {.lex_state = 154},
  [1362] = {.lex_state = 270, .external_lex_state = 33},
  [1363] = {.lex_state = 270, .external_lex_state = 33},
  [1364] = {.lex_state = 270, .external_lex_state = 33},
  [1365] = {.lex_state = 161, .external_lex_state = 13},
  [1366] = {.lex_state = 128, .external_lex_state = 13},
  [1367] = {.lex_state = 128, .external_lex_state = 13},
  [1368] = {.lex_state = 128},
  [1369] = {.lex_state = 192, .external_lex_state = 2},
  [1370] = {.lex_state = 128},
  [1371] = {.lex_state = 200, .external_lex_state = 2},
  [1372] = {.lex_state = 128},
  [1373] = {.lex_state = 192, .external_lex_state = 2},
  [1374] = {.lex_state = 266, .external_lex_state = 33},
  [1375] = {.lex_state = 226, .external_lex_state = 34},
  [1376] = {.lex_state = 226, .external_lex_state = 34},
  [1377] = {.lex_state = 188, .external_lex_state = 34},
  [1378] = {.lex_state = 226, .external_lex_state = 15},
  [1379] = {.lex_state = 226, .external_lex_state = 34},
  [1380] = {.lex_state = 128, .external_lex_state = 13},
  [1381] = {.lex_state = 128, .external_lex_state = 13},
  [1382] = {.lex_state = 226, .external_lex_state = 34},
  [1383] = {.lex_state = 224, .external_lex_state = 22},
  [1384] = {.lex_state = 128},
  [1385] = {.lex_state = 226, .external_lex_state = 34},
  [1386] = {.lex_state = 224, .external_lex_state = 22},
  [1387] = {.lex_state = 128},
  [1388] = {.lex_state = 226, .external_lex_state = 34},
  [1389] = {.lex_state = 226, .external_lex_state = 34},
  [1390] = {.lex_state = 128, .external_lex_state = 13},
  [1391] = {.lex_state = 128, .external_lex_state = 13},
  [1392] = {.lex_state = 185, .external_lex_state = 14},
  [1393] = {.lex_state = 185, .external_lex_state = 14},
  [1394] = {.lex_state = 185, .external_lex_state = 14},
  [1395] = {.lex_state = 185, .external_lex_state = 14},
  [1396] = {.lex_state = 228, .external_lex_state = 32},
  [1397] = {.lex_state = 128},
  [1398] = {.lex_state = 228, .external_lex_state = 32},
  [1399] = {.lex_state = 128},
  [1400] = {.lex_state = 249, .external_lex_state = 31},
  [1401] = {.lex_state = 228, .external_lex_state = 32},
  [1402] = {.lex_state = 249, .external_lex_state = 31},
  [1403] = {.lex_state = 249, .external_lex_state = 31},
  [1404] = {.lex_state = 128, .external_lex_state = 21},
  [1405] = {.lex_state = 249, .external_lex_state = 31},
  [1406] = {.lex_state = 249, .external_lex_state = 31},
  [1407] = {.lex_state = 249, .external_lex_state = 31},
  [1408] = {.lex_state = 128, .external_lex_state = 21},
  [1409] = {.lex_state = 268, .external_lex_state = 33},
  [1410] = {.lex_state = 268, .external_lex_state = 33},
  [1411] = {.lex_state = 268, .external_lex_state = 33},
  [1412] = {.lex_state = 268, .external_lex_state = 33},
  [1413] = {.lex_state = 196, .external_lex_state = 34},
  [1414] = {.lex_state = 128, .external_lex_state = 21},
  [1415] = {.lex_state = 128, .external_lex_state = 21},
  [1416] = {.lex_state = 224, .external_lex_state = 22},
  [1417] = {.lex_state = 204, .external_lex_state = 24},
  [1418] = {.lex_state = 224, .external_lex_state = 22},
  [1419] = {.lex_state = 204, .external_lex_state = 24},
  [1420] = {.lex_state = 128, .external_lex_state = 13},
  [1421] = {.lex_state = 224, .external_lex_state = 22},
  [1422] = {.lex_state = 204, .external_lex_state = 24},
  [1423] = {.lex_state = 224, .external_lex_state = 22},
  [1424] = {.lex_state = 204, .external_lex_state = 24},
  [1425] = {.lex_state = 128, .external_lex_state = 13},
  [1426] = {.lex_state = 234, .external_lex_state = 25},
  [1427] = {.lex_state = 128},
  [1428] = {.lex_state = 234, .external_lex_state = 25},
  [1429] = {.lex_state = 128},
  [1430] = {.lex_state = 249, .external_lex_state = 31},
  [1431] = {.lex_state = 234, .external_lex_state = 25},
  [1432] = {.lex_state = 249, .external_lex_state = 31},
  [1433] = {.lex_state = 249, .external_lex_state = 31},
  [1434] = {.lex_state = 128, .external_lex_state = 21},
  [1435] = {.lex_state = 249, .external_lex_state = 31},
  [1436] = {.lex_state = 249, .external_lex_state = 31},
  [1437] = {.lex_state = 249, .external_lex_state = 31},
  [1438] = {.lex_state = 128, .external_lex_state = 21},
  [1439] = {.lex_state = 128, .external_lex_state = 21},
  [1440] = {.lex_state = 128, .external_lex_state = 21},
  [1441] = {.lex_state = 224, .external_lex_state = 22},
  [1442] = {.lex_state = 210, .external_lex_state = 26},
  [1443] = {.lex_state = 224, .external_lex_state = 22},
  [1444] = {.lex_state = 210, .external_lex_state = 26},
  [1445] = {.lex_state = 128, .external_lex_state = 13},
  [1446] = {.lex_state = 224, .external_lex_state = 22},
  [1447] = {.lex_state = 210, .external_lex_state = 26},
  [1448] = {.lex_state = 224, .external_lex_state = 22},
  [1449] = {.lex_state = 210, .external_lex_state = 26},
  [1450] = {.lex_state = 128, .external_lex_state = 13},
  [1451] = {.lex_state = 128, .external_lex_state = 13},
  [1452] = {.lex_state = 128, .external_lex_state = 13},
  [1453] = {.lex_state = 176, .external_lex_state = 19},
  [1454] = {.lex_state = 176, .external_lex_state = 19},
  [1455] = {.lex_state = 176, .external_lex_state = 19},
  [1456] = {.lex_state = 176, .external_lex_state = 19},
  [1457] = {.lex_state = 128, .external_lex_state = 13},
  [1458] = {.lex_state = 128, .external_lex_state = 13},
  [1459] = {.lex_state = 237, .external_lex_state = 27},
  [1460] = {.lex_state = 237, .external_lex_state = 27},
  [1461] = {.lex_state = 237, .external_lex_state = 27},
  [1462] = {.lex_state = 237, .external_lex_state = 27},
  [1463] = {.lex_state = 128, .external_lex_state = 21},
  [1464] = {.lex_state = 128, .external_lex_state = 21},
  [1465] = {.lex_state = 224, .external_lex_state = 22},
  [1466] = {.lex_state = 240, .external_lex_state = 28},
  [1467] = {.lex_state = 224, .external_lex_state = 22},
  [1468] = {.lex_state = 240, .external_lex_state = 28},
  [1469] = {.lex_state = 128, .external_lex_state = 13},
  [1470] = {.lex_state = 224, .external_lex_state = 22},
  [1471] = {.lex_state = 240, .external_lex_state = 28},
  [1472] = {.lex_state = 224, .external_lex_state = 22},
  [1473] = {.lex_state = 240, .external_lex_state = 28},
  [1474] = {.lex_state = 128, .external_lex_state = 13},
  [1475] = {.lex_state = 261, .external_lex_state = 2},
  [1476] = {.lex_state = 244, .external_lex_state = 4},
  [1477] = {.lex_state = 261, .external_lex_state = 2},
  [1478] = {.lex_state = 261, .external_lex_state = 2},
  [1479] = {.lex_state = 244, .external_lex_state = 4},
  [1480] = {.lex_state = 261, .external_lex_state = 2},
  [1481] = {.lex_state = 178, .external_lex_state = 11},
  [1482] = {.lex_state = 178, .external_lex_state = 11},
  [1483] = {.lex_state = 264, .external_lex_state = 11},
  [1484] = {.lex_state = 128},
  [1485] = {.lex_state = 264, .external_lex_state = 11},
  [1486] = {.lex_state = 128},
  [1487] = {.lex_state = 249, .external_lex_state = 31},
  [1488] = {.lex_state = 264, .external_lex_state = 11},
  [1489] = {.lex_state = 249, .external_lex_state = 31},
  [1490] = {.lex_state = 249, .external_lex_state = 31},
  [1491] = {.lex_state = 128, .external_lex_state = 21},
  [1492] = {.lex_state = 249, .external_lex_state = 31},
  [1493] = {.lex_state = 249, .external_lex_state = 31},
  [1494] = {.lex_state = 249, .external_lex_state = 31},
  [1495] = {.lex_state = 128, .external_lex_state = 21},
  [1496] = {.lex_state = 264, .external_lex_state = 11},
  [1497] = {.lex_state = 128, .external_lex_state = 21},
  [1498] = {.lex_state = 128, .external_lex_state = 21},
  [1499] = {.lex_state = 224, .external_lex_state = 22},
  [1500] = {.lex_state = 181, .external_lex_state = 30},
  [1501] = {.lex_state = 224, .external_lex_state = 22},
  [1502] = {.lex_state = 181, .external_lex_state = 30},
  [1503] = {.lex_state = 128, .external_lex_state = 13},
  [1504] = {.lex_state = 224, .external_lex_state = 22},
  [1505] = {.lex_state = 181, .external_lex_state = 30},
  [1506] = {.lex_state = 224, .external_lex_state = 22},
  [1507] = {.lex_state = 181, .external_lex_state = 30},
  [1508] = {.lex_state = 128, .external_lex_state = 13},
  [1509] = {.lex_state = 170, .external_lex_state = 12},
  [1510] = {.lex_state = 170, .external_lex_state = 12},
  [1511] = {.lex_state = 154},
  [1512] = {.lex_state = 154},
  [1513] = {.lex_state = 128, .external_lex_state = 21},
  [1514] = {.lex_state = 128, .external_lex_state = 21},
  [1515] = {.lex_state = 224, .external_lex_state = 22},
  [1516] = {.lex_state = 192, .external_lex_state = 12},
  [1517] = {.lex_state = 224, .external_lex_state = 22},
  [1518] = {.lex_state = 192, .external_lex_state = 12},
  [1519] = {.lex_state = 128, .external_lex_state = 13},
  [1520] = {.lex_state = 224, .external_lex_state = 22},
  [1521] = {.lex_state = 192, .external_lex_state = 12},
  [1522] = {.lex_state = 224, .external_lex_state = 22},
  [1523] = {.lex_state = 192, .external_lex_state = 12},
  [1524] = {.lex_state = 128, .external_lex_state = 13},
  [1525] = {.lex_state = 128},
  [1526] = {.lex_state = 128},
  [1527] = {.lex_state = 128},
  [1528] = {.lex_state = 270, .external_lex_state = 33},
  [1529] = {.lex_state = 270, .external_lex_state = 33},
  [1530] = {.lex_state = 266, .external_lex_state = 33},
  [1531] = {.lex_state = 270, .external_lex_state = 33},
  [1532] = {.lex_state = 128, .external_lex_state = 13},
  [1533] = {.lex_state = 128, .external_lex_state = 13},
  [1534] = {.lex_state = 270, .external_lex_state = 33},
  [1535] = {.lex_state = 224, .external_lex_state = 22},
  [1536] = {.lex_state = 128},
  [1537] = {.lex_state = 270, .external_lex_state = 33},
  [1538] = {.lex_state = 224, .external_lex_state = 22},
  [1539] = {.lex_state = 128},
  [1540] = {.lex_state = 270, .external_lex_state = 33},
  [1541] = {.lex_state = 270, .external_lex_state = 33},
  [1542] = {.lex_state = 226, .external_lex_state = 34},
  [1543] = {.lex_state = 128},
  [1544] = {.lex_state = 226, .external_lex_state = 34},
  [1545] = {.lex_state = 128},
  [1546] = {.lex_state = 249, .external_lex_state = 31},
  [1547] = {.lex_state = 226, .external_lex_state = 34},
  [1548] = {.lex_state = 249, .external_lex_state = 31},
  [1549] = {.lex_state = 249, .external_lex_state = 31},
  [1550] = {.lex_state = 128, .external_lex_state = 21},
  [1551] = {.lex_state = 249, .external_lex_state = 31},
  [1552] = {.lex_state = 249, .external_lex_state = 31},
  [1553] = {.lex_state = 249, .external_lex_state = 31},
  [1554] = {.lex_state = 128, .external_lex_state = 21},
  [1555] = {.lex_state = 185, .external_lex_state = 14},
  [1556] = {.lex_state = 185, .external_lex_state = 14},
  [1557] = {.lex_state = 128, .external_lex_state = 21},
  [1558] = {.lex_state = 128, .external_lex_state = 21},
  [1559] = {.lex_state = 224, .external_lex_state = 22},
  [1560] = {.lex_state = 228, .external_lex_state = 32},
  [1561] = {.lex_state = 224, .external_lex_state = 22},
  [1562] = {.lex_state = 228, .external_lex_state = 32},
  [1563] = {.lex_state = 128, .external_lex_state = 13},
  [1564] = {.lex_state = 224, .external_lex_state = 22},
  [1565] = {.lex_state = 228, .external_lex_state = 32},
  [1566] = {.lex_state = 224, .external_lex_state = 22},
  [1567] = {.lex_state = 228, .external_lex_state = 32},
  [1568] = {.lex_state = 128, .external_lex_state = 13},
  [1569] = {.lex_state = 268, .external_lex_state = 33},
  [1570] = {.lex_state = 128, .external_lex_state = 13},
  [1571] = {.lex_state = 128, .external_lex_state = 13},
  [1572] = {.lex_state = 204, .external_lex_state = 24},
  [1573] = {.lex_state = 204, .external_lex_state = 24},
  [1574] = {.lex_state = 204, .external_lex_state = 24},
  [1575] = {.lex_state = 204, .external_lex_state = 24},
  [1576] = {.lex_state = 128, .external_lex_state = 21},
  [1577] = {.lex_state = 128, .external_lex_state = 21},
  [1578] = {.lex_state = 224, .external_lex_state = 22},
  [1579] = {.lex_state = 234, .external_lex_state = 25},
  [1580] = {.lex_state = 224, .external_lex_state = 22},
  [1581] = {.lex_state = 234, .external_lex_state = 25},
  [1582] = {.lex_state = 128, .external_lex_state = 13},
  [1583] = {.lex_state = 224, .external_lex_state = 22},
  [1584] = {.lex_state = 234, .external_lex_state = 25},
  [1585] = {.lex_state = 224, .external_lex_state = 22},
  [1586] = {.lex_state = 234, .external_lex_state = 25},
  [1587] = {.lex_state = 128, .external_lex_state = 13},
  [1588] = {.lex_state = 128, .external_lex_state = 13},
  [1589] = {.lex_state = 128, .external_lex_state = 13},
  [1590] = {.lex_state = 210, .external_lex_state = 26},
  [1591] = {.lex_state = 210, .external_lex_state = 26},
  [1592] = {.lex_state = 210, .external_lex_state = 26},
  [1593] = {.lex_state = 210, .external_lex_state = 26},
  [1594] = {.lex_state = 176, .external_lex_state = 19},
  [1595] = {.lex_state = 176, .external_lex_state = 19},
  [1596] = {.lex_state = 237, .external_lex_state = 27},
  [1597] = {.lex_state = 237, .external_lex_state = 27},
  [1598] = {.lex_state = 128, .external_lex_state = 13},
  [1599] = {.lex_state = 128, .external_lex_state = 13},
  [1600] = {.lex_state = 240, .external_lex_state = 28},
  [1601] = {.lex_state = 240, .external_lex_state = 28},
  [1602] = {.lex_state = 240, .external_lex_state = 28},
  [1603] = {.lex_state = 240, .external_lex_state = 28},
  [1604] = {.lex_state = 244, .external_lex_state = 4},
  [1605] = {.lex_state = 244, .external_lex_state = 4},
  [1606] = {.lex_state = 128, .external_lex_state = 21},
  [1607] = {.lex_state = 128, .external_lex_state = 21},
  [1608] = {.lex_state = 224, .external_lex_state = 22},
  [1609] = {.lex_state = 264, .external_lex_state = 11},
  [1610] = {.lex_state = 224, .external_lex_state = 22},
  [1611] = {.lex_state = 264, .external_lex_state = 11},
  [1612] = {.lex_state = 128, .external_lex_state = 13},
  [1613] = {.lex_state = 224, .external_lex_state = 22},
  [1614] = {.lex_state = 264, .external_lex_state = 11},
  [1615] = {.lex_state = 224, .external_lex_state = 22},
  [1616] = {.lex_state = 264, .external_lex_state = 11},
  [1617] = {.lex_state = 128, .external_lex_state = 13},
  [1618] = {.lex_state = 128, .external_lex_state = 13},
  [1619] = {.lex_state = 128, .external_lex_state = 13},
  [1620] = {.lex_state = 181, .external_lex_state = 30},
  [1621] = {.lex_state = 181, .external_lex_state = 30},
  [1622] = {.lex_state = 181, .external_lex_state = 30},
  [1623] = {.lex_state = 181, .external_lex_state = 30},
  [1624] = {.lex_state = 128, .external_lex_state = 13},
  [1625] = {.lex_state = 128, .external_lex_state = 13},
  [1626] = {.lex_state = 192, .external_lex_state = 12},
  [1627] = {.lex_state = 192, .external_lex_state = 12},
  [1628] = {.lex_state = 192, .external_lex_state = 12},
  [1629] = {.lex_state = 192, .external_lex_state = 12},
  [1630] = {.lex_state = 270, .external_lex_state = 33},
  [1631] = {.lex_state = 128},
  [1632] = {.lex_state = 270, .external_lex_state = 33},
  [1633] = {.lex_state = 128},
  [1634] = {.lex_state = 249, .external_lex_state = 31},
  [1635] = {.lex_state = 270, .external_lex_state = 33},
  [1636] = {.lex_state = 249, .external_lex_state = 31},
  [1637] = {.lex_state = 249, .external_lex_state = 31},
  [1638] = {.lex_state = 128, .external_lex_state = 21},
  [1639] = {.lex_state = 249, .external_lex_state = 31},
  [1640] = {.lex_state = 249, .external_lex_state = 31},
  [1641] = {.lex_state = 249, .external_lex_state = 31},
  [1642] = {.lex_state = 128, .external_lex_state = 21},
  [1643] = {.lex_state = 128, .external_lex_state = 21},
  [1644] = {.lex_state = 128, .external_lex_state = 21},
  [1645] = {.lex_state = 224, .external_lex_state = 22},
  [1646] = {.lex_state = 226, .external_lex_state = 34},
  [1647] = {.lex_state = 224, .external_lex_state = 22},
  [1648] = {.lex_state = 226, .external_lex_state = 34},
  [1649] = {.lex_state = 128, .external_lex_state = 13},
  [1650] = {.lex_state = 224, .external_lex_state = 22},
  [1651] = {.lex_state = 226, .external_lex_state = 34},
  [1652] = {.lex_state = 224, .external_lex_state = 22},
  [1653] = {.lex_state = 226, .external_lex_state = 34},
  [1654] = {.lex_state = 128, .external_lex_state = 13},
  [1655] = {.lex_state = 128, .external_lex_state = 13},
  [1656] = {.lex_state = 128, .external_lex_state = 13},
  [1657] = {.lex_state = 228, .external_lex_state = 32},
  [1658] = {.lex_state = 228, .external_lex_state = 32},
  [1659] = {.lex_state = 228, .external_lex_state = 32},
  [1660] = {.lex_state = 228, .external_lex_state = 32},
  [1661] = {.lex_state = 204, .external_lex_state = 24},
  [1662] = {.lex_state = 204, .external_lex_state = 24},
  [1663] = {.lex_state = 128, .external_lex_state = 13},
  [1664] = {.lex_state = 128, .external_lex_state = 13},
  [1665] = {.lex_state = 234, .external_lex_state = 25},
  [1666] = {.lex_state = 234, .external_lex_state = 25},
  [1667] = {.lex_state = 234, .external_lex_state = 25},
  [1668] = {.lex_state = 234, .external_lex_state = 25},
  [1669] = {.lex_state = 210, .external_lex_state = 26},
  [1670] = {.lex_state = 210, .external_lex_state = 26},
  [1671] = {.lex_state = 240, .external_lex_state = 28},
  [1672] = {.lex_state = 240, .external_lex_state = 28},
  [1673] = {.lex_state = 128, .external_lex_state = 13},
  [1674] = {.lex_state = 128, .external_lex_state = 13},
  [1675] = {.lex_state = 264, .external_lex_state = 11},
  [1676] = {.lex_state = 264, .external_lex_state = 11},
  [1677] = {.lex_state = 264, .external_lex_state = 11},
  [1678] = {.lex_state = 264, .external_lex_state = 11},
  [1679] = {.lex_state = 181, .external_lex_state = 30},
  [1680] = {.lex_state = 181, .external_lex_state = 30},
  [1681] = {.lex_state = 192, .external_lex_state = 12},
  [1682] = {.lex_state = 192, .external_lex_state = 12},
  [1683] = {.lex_state = 128, .external_lex_state = 21},
  [1684] = {.lex_state = 128, .external_lex_state = 21},
  [1685] = {.lex_state = 224, .external_lex_state = 22},
  [1686] = {.lex_state = 270, .external_lex_state = 33},
  [1687] = {.lex_state = 224, .external_lex_state = 22},
  [1688] = {.lex_state = 270, .external_lex_state = 33},
  [1689] = {.lex_state = 128, .external_lex_state = 13},
  [1690] = {.lex_state = 224, .external_lex_state = 22},
  [1691] = {.lex_state = 270, .external_lex_state = 33},
  [1692] = {.lex_state = 224, .external_lex_state = 22},
  [1693] = {.lex_state = 270, .external_lex_state = 33},
  [1694] = {.lex_state = 128, .external_lex_state = 13},
  [1695] = {.lex_state = 128, .external_lex_state = 13},
  [1696] = {.lex_state = 128, .external_lex_state = 13},
  [1697] = {.lex_state = 226, .external_lex_state = 34},
  [1698] = {.lex_state = 226, .external_lex_state = 34},
  [1699] = {.lex_state = 226, .external_lex_state = 34},
  [1700] = {.lex_state = 226, .external_lex_state = 34},
  [1701] = {.lex_state = 228, .external_lex_state = 32},
  [1702] = {.lex_state = 228, .external_lex_state = 32},
  [1703] = {.lex_state = 234, .external_lex_state = 25},
  [1704] = {.lex_state = 234, .external_lex_state = 25},
  [1705] = {.lex_state = 264, .external_lex_state = 11},
  [1706] = {.lex_state = 264, .external_lex_state = 11},
  [1707] = {.lex_state = 128, .external_lex_state = 13},
  [1708] = {.lex_state = 128, .external_lex_state = 13},
  [1709] = {.lex_state = 270, .external_lex_state = 33},
  [1710] = {.lex_state = 270, .external_lex_state = 33},
  [1711] = {.lex_state = 270, .external_lex_state = 33},
  [1712] = {.lex_state = 270, .external_lex_state = 33},
  [1713] = {.lex_state = 226, .external_lex_state = 34},
  [1714] = {.lex_state = 226, .external_lex_state = 34},
  [1715] = {.lex_state = 270, .external_lex_state = 33},
  [1716] = {.lex_state = 270, .external_lex_state = 33},
};

enum {
  ts_external_token__simple_heredoc,
  ts_external_token__heredoc_beginning,
  ts_external_token__heredoc_middle,
  ts_external_token__heredoc_end,
  ts_external_token_file_descriptor,
  ts_external_token_word,
  ts_external_token__empty_value,
  ts_external_token__concat,
  ts_external_token_variable_name,
  ts_external_token_LF,
  ts_external_token_RBRACK,
  ts_external_token_RBRACE,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__simple_heredoc] = sym__simple_heredoc,
  [ts_external_token__heredoc_beginning] = sym__heredoc_beginning,
  [ts_external_token__heredoc_middle] = sym__heredoc_middle,
  [ts_external_token__heredoc_end] = sym__heredoc_end,
  [ts_external_token_file_descriptor] = sym_file_descriptor,
  [ts_external_token_word] = sym_word,
  [ts_external_token__empty_value] = sym__empty_value,
  [ts_external_token__concat] = sym__concat,
  [ts_external_token_variable_name] = sym_variable_name,
  [ts_external_token_LF] = anon_sym_LF,
  [ts_external_token_RBRACK] = anon_sym_RBRACK,
  [ts_external_token_RBRACE] = anon_sym_RBRACE,
};

static bool ts_external_scanner_states[35][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__simple_heredoc] = true,
    [ts_external_token__heredoc_beginning] = true,
    [ts_external_token__heredoc_middle] = true,
    [ts_external_token__heredoc_end] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_word] = true,
    [ts_external_token__empty_value] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
    [ts_external_token_RBRACK] = true,
    [ts_external_token_RBRACE] = true,
  },
  [2] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_word] = true,
    [ts_external_token_variable_name] = true,
  },
  [3] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_word] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [4] = {
    [ts_external_token_word] = true,
  },
  [5] = {
    [ts_external_token_word] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [6] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_word] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
  },
  [7] = {
    [ts_external_token_LF] = true,
  },
  [8] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_word] = true,
    [ts_external_token_LF] = true,
  },
  [9] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_word] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [10] = {
    [ts_external_token_word] = true,
    [ts_external_token__empty_value] = true,
  },
  [11] = {
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [12] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_word] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
  [13] = {
    [ts_external_token_RBRACE] = true,
  },
  [14] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_word] = true,
    [ts_external_token__concat] = true,
  },
  [15] = {
    [ts_external_token_word] = true,
    [ts_external_token_variable_name] = true,
  },
  [16] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_word] = true,
  },
  [17] = {
    [ts_external_token__simple_heredoc] = true,
    [ts_external_token__heredoc_beginning] = true,
  },
  [18] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LF] = true,
  },
  [19] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_word] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [20] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACK] = true,
  },
  [21] = {
    [ts_external_token_RBRACK] = true,
  },
  [22] = {
    [ts_external_token_word] = true,
    [ts_external_token_RBRACE] = true,
  },
  [23] = {
    [ts_external_token_file_descriptor] = true,
  },
  [24] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [25] = {
    [ts_external_token__heredoc_middle] = true,
    [ts_external_token__heredoc_end] = true,
  },
  [26] = {
    [ts_external_token_word] = true,
    [ts_external_token__concat] = true,
  },
  [27] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACK] = true,
    [ts_external_token_RBRACE] = true,
  },
  [28] = {
    [ts_external_token_word] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [29] = {
    [ts_external_token_word] = true,
    [ts_external_token_LF] = true,
  },
  [30] = {
    [ts_external_token_word] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [31] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACE] = true,
  },
  [32] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
  },
  [33] = {
    [ts_external_token__concat] = true,
  },
  [34] = {
    [ts_external_token_word] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym__simple_heredoc] = ACTIONS(1),
    [sym__heredoc_beginning] = ACTIONS(1),
    [sym__heredoc_middle] = ACTIONS(1),
    [sym__heredoc_end] = ACTIONS(1),
    [sym_file_descriptor] = ACTIONS(1),
    [sym_word] = ACTIONS(1),
    [sym__empty_value] = ACTIONS(1),
    [sym__concat] = ACTIONS(1),
    [sym_variable_name] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(3),
    [anon_sym_for] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(3),
    [anon_sym_done] = ACTIONS(3),
    [anon_sym_if] = ACTIONS(3),
    [anon_sym_fi] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(3),
    [anon_sym_else] = ACTIONS(3),
    [anon_sym_case] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(3),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3),
    [anon_sym_RBRACE] = ACTIONS(3),
    [anon_sym_PIPE_AMP] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3),
    [anon_sym_PIPE_PIPE] = ACTIONS(3),
    [anon_sym_declare] = ACTIONS(3),
    [anon_sym_typeset] = ACTIONS(3),
    [anon_sym_export] = ACTIONS(3),
    [anon_sym_readonly] = ACTIONS(3),
    [anon_sym_local] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_PLUS_EQ] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(3),
    [anon_sym_RBRACK] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(3),
    [anon_sym_AMP_GT] = ACTIONS(3),
    [anon_sym_AMP_GT_GT] = ACTIONS(3),
    [anon_sym_LT_AMP] = ACTIONS(3),
    [anon_sym_GT_AMP] = ACTIONS(3),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_LT_LT_DASH] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(3),
    [sym_raw_string] = ACTIONS(3),
    [anon_sym_DOLLAR] = ACTIONS(3),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3),
    [anon_sym_COLON_QMARK] = ACTIONS(3),
    [anon_sym_COLON_DASH] = ACTIONS(3),
    [anon_sym_PERCENT] = ACTIONS(3),
    [anon_sym_SLASH] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3),
    [anon_sym_LT_LPAREN] = ACTIONS(3),
    [anon_sym_GT_LPAREN] = ACTIONS(3),
    [sym_comment] = ACTIONS(5),
    [sym_identifier] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(3),
    [anon_sym_QMARK] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(3),
    [anon_sym_0] = ACTIONS(3),
    [anon_sym__] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(3),
  },
  [1] = {
    [sym_program] = STATE(20),
    [sym__terminated_statement] = STATE(21),
    [sym_for_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_case_statement] = STATE(22),
    [sym_function_definition] = STATE(22),
    [sym_subshell] = STATE(22),
    [sym_pipeline] = STATE(22),
    [sym_list] = STATE(22),
    [sym_command] = STATE(22),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(24),
    [sym_declaration_command] = STATE(22),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(28),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [ts_builtin_sym_end] = ACTIONS(14),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [2] = {
    [anon_sym_LT] = ACTIONS(50),
    [anon_sym_GT] = ACTIONS(50),
    [anon_sym_GT_GT] = ACTIONS(52),
    [anon_sym_AMP_GT] = ACTIONS(50),
    [anon_sym_AMP_GT_GT] = ACTIONS(52),
    [anon_sym_LT_AMP] = ACTIONS(52),
    [anon_sym_GT_AMP] = ACTIONS(52),
    [sym_comment] = ACTIONS(46),
  },
  [3] = {
    [aux_sym_concatenation_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(54),
    [sym_word] = ACTIONS(54),
    [sym__concat] = ACTIONS(56),
    [anon_sym_PIPE] = ACTIONS(58),
    [anon_sym_SEMI_SEMI] = ACTIONS(58),
    [anon_sym_PIPE_AMP] = ACTIONS(58),
    [anon_sym_AMP_AMP] = ACTIONS(58),
    [anon_sym_PIPE_PIPE] = ACTIONS(58),
    [anon_sym_LT] = ACTIONS(58),
    [anon_sym_GT] = ACTIONS(58),
    [anon_sym_GT_GT] = ACTIONS(58),
    [anon_sym_AMP_GT] = ACTIONS(58),
    [anon_sym_AMP_GT_GT] = ACTIONS(58),
    [anon_sym_LT_AMP] = ACTIONS(58),
    [anon_sym_GT_AMP] = ACTIONS(58),
    [anon_sym_LT_LT] = ACTIONS(58),
    [anon_sym_LT_LT_DASH] = ACTIONS(58),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [sym_raw_string] = ACTIONS(58),
    [anon_sym_DOLLAR] = ACTIONS(58),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(58),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(58),
    [anon_sym_BQUOTE] = ACTIONS(58),
    [anon_sym_LT_LPAREN] = ACTIONS(58),
    [anon_sym_GT_LPAREN] = ACTIONS(58),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(58),
    [anon_sym_SEMI] = ACTIONS(58),
    [anon_sym_LF] = ACTIONS(58),
    [anon_sym_AMP] = ACTIONS(58),
  },
  [4] = {
    [sym__assignment] = STATE(35),
    [anon_sym_EQ] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(62),
    [anon_sym_LBRACK] = ACTIONS(64),
    [sym_comment] = ACTIONS(46),
  },
  [5] = {
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(66),
  },
  [6] = {
    [sym__terminated_statement] = STATE(37),
    [sym_for_statement] = STATE(38),
    [sym_while_statement] = STATE(38),
    [sym_if_statement] = STATE(38),
    [sym_case_statement] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_subshell] = STATE(38),
    [sym_pipeline] = STATE(38),
    [sym_list] = STATE(38),
    [sym_command] = STATE(38),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(39),
    [sym_declaration_command] = STATE(38),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [7] = {
    [sym__terminated_statement] = STATE(40),
    [sym_for_statement] = STATE(38),
    [sym_while_statement] = STATE(38),
    [sym_if_statement] = STATE(38),
    [sym_case_statement] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_subshell] = STATE(38),
    [sym_pipeline] = STATE(38),
    [sym_list] = STATE(38),
    [sym_command] = STATE(38),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(39),
    [sym_declaration_command] = STATE(38),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [8] = {
    [sym_concatenation] = STATE(49),
    [sym_string] = STATE(41),
    [sym_simple_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [sym_word] = ACTIONS(68),
    [anon_sym_DQUOTE] = ACTIONS(70),
    [sym_raw_string] = ACTIONS(68),
    [anon_sym_DOLLAR] = ACTIONS(72),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(74),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(76),
    [anon_sym_BQUOTE] = ACTIONS(78),
    [anon_sym_LT_LPAREN] = ACTIONS(80),
    [anon_sym_GT_LPAREN] = ACTIONS(80),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(82),
  },
  [9] = {
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(84),
  },
  [10] = {
    [sym__terminated_statement] = STATE(21),
    [sym_for_statement] = STATE(56),
    [sym_while_statement] = STATE(56),
    [sym_if_statement] = STATE(56),
    [sym_case_statement] = STATE(56),
    [sym_function_definition] = STATE(56),
    [sym_subshell] = STATE(56),
    [sym_pipeline] = STATE(56),
    [sym_list] = STATE(56),
    [sym_command] = STATE(56),
    [sym_command_name] = STATE(57),
    [sym_variable_assignment] = STATE(58),
    [sym_declaration_command] = STATE(56),
    [sym_subscript] = STATE(59),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(51),
    [sym_simple_expansion] = STATE(51),
    [sym_expansion] = STATE(51),
    [sym_command_substitution] = STATE(51),
    [sym_process_substitution] = STATE(51),
    [aux_sym_program_repeat1] = STATE(60),
    [aux_sym_command_repeat1] = STATE(61),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(86),
    [sym_variable_name] = ACTIONS(88),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(90),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(92),
    [anon_sym_typeset] = ACTIONS(92),
    [anon_sym_export] = ACTIONS(92),
    [anon_sym_readonly] = ACTIONS(92),
    [anon_sym_local] = ACTIONS(92),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(86),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(94),
  },
  [11] = {
    [sym_variable_assignment] = STATE(62),
    [sym_subscript] = STATE(65),
    [aux_sym_declaration_command_repeat1] = STATE(66),
    [sym_word] = ACTIONS(96),
    [sym_variable_name] = ACTIONS(98),
    [anon_sym_PIPE] = ACTIONS(100),
    [anon_sym_SEMI_SEMI] = ACTIONS(100),
    [anon_sym_PIPE_AMP] = ACTIONS(100),
    [anon_sym_AMP_AMP] = ACTIONS(100),
    [anon_sym_PIPE_PIPE] = ACTIONS(100),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(102),
    [anon_sym_SEMI] = ACTIONS(100),
    [anon_sym_LF] = ACTIONS(100),
    [anon_sym_AMP] = ACTIONS(100),
  },
  [12] = {
    [sym_concatenation] = STATE(75),
    [sym_string] = STATE(67),
    [sym_simple_expansion] = STATE(67),
    [sym_expansion] = STATE(67),
    [sym_command_substitution] = STATE(67),
    [sym_process_substitution] = STATE(67),
    [sym_word] = ACTIONS(104),
    [anon_sym_DQUOTE] = ACTIONS(106),
    [sym_raw_string] = ACTIONS(104),
    [anon_sym_DOLLAR] = ACTIONS(108),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(110),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(112),
    [anon_sym_BQUOTE] = ACTIONS(114),
    [anon_sym_LT_LPAREN] = ACTIONS(116),
    [anon_sym_GT_LPAREN] = ACTIONS(116),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(118),
  },
  [13] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(82),
    [anon_sym_DQUOTE] = ACTIONS(120),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [14] = {
    [sym_special_variable_name] = STATE(85),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [anon_sym_POUND] = ACTIONS(132),
    [anon_sym_AT] = ACTIONS(132),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(134),
    [anon_sym_STAR] = ACTIONS(132),
    [anon_sym_QMARK] = ACTIONS(132),
    [anon_sym_DASH] = ACTIONS(132),
    [anon_sym_BANG] = ACTIONS(132),
    [anon_sym_0] = ACTIONS(136),
    [anon_sym__] = ACTIONS(136),
  },
  [15] = {
    [sym_special_variable_name] = STATE(89),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(140),
    [anon_sym_AT] = ACTIONS(138),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(142),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [16] = {
    [sym_for_statement] = STATE(106),
    [sym_while_statement] = STATE(106),
    [sym_if_statement] = STATE(106),
    [sym_case_statement] = STATE(106),
    [sym_function_definition] = STATE(106),
    [sym_subshell] = STATE(106),
    [sym_pipeline] = STATE(106),
    [sym_list] = STATE(106),
    [sym_command] = STATE(106),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(108),
    [sym_declaration_command] = STATE(106),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [17] = {
    [sym_for_statement] = STATE(117),
    [sym_while_statement] = STATE(117),
    [sym_if_statement] = STATE(117),
    [sym_case_statement] = STATE(117),
    [sym_function_definition] = STATE(117),
    [sym_subshell] = STATE(117),
    [sym_pipeline] = STATE(117),
    [sym_list] = STATE(117),
    [sym_command] = STATE(117),
    [sym_command_name] = STATE(118),
    [sym_variable_assignment] = STATE(119),
    [sym_declaration_command] = STATE(117),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(112),
    [sym_simple_expansion] = STATE(112),
    [sym_expansion] = STATE(112),
    [sym_command_substitution] = STATE(112),
    [sym_process_substitution] = STATE(112),
    [aux_sym_command_repeat1] = STATE(121),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(178),
    [sym_variable_name] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(184),
    [anon_sym_typeset] = ACTIONS(184),
    [anon_sym_export] = ACTIONS(184),
    [anon_sym_readonly] = ACTIONS(184),
    [anon_sym_local] = ACTIONS(184),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(178),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(186),
  },
  [18] = {
    [sym_for_statement] = STATE(122),
    [sym_while_statement] = STATE(122),
    [sym_if_statement] = STATE(122),
    [sym_case_statement] = STATE(122),
    [sym_function_definition] = STATE(122),
    [sym_subshell] = STATE(122),
    [sym_pipeline] = STATE(122),
    [sym_list] = STATE(122),
    [sym_command] = STATE(122),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(123),
    [sym_declaration_command] = STATE(122),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [19] = {
    [aux_sym_concatenation_repeat1] = STATE(125),
    [sym_file_descriptor] = ACTIONS(188),
    [sym_word] = ACTIONS(188),
    [sym__concat] = ACTIONS(56),
    [anon_sym_PIPE] = ACTIONS(190),
    [anon_sym_SEMI_SEMI] = ACTIONS(190),
    [anon_sym_LPAREN] = ACTIONS(192),
    [anon_sym_PIPE_AMP] = ACTIONS(190),
    [anon_sym_AMP_AMP] = ACTIONS(190),
    [anon_sym_PIPE_PIPE] = ACTIONS(190),
    [anon_sym_LT] = ACTIONS(190),
    [anon_sym_GT] = ACTIONS(190),
    [anon_sym_GT_GT] = ACTIONS(190),
    [anon_sym_AMP_GT] = ACTIONS(190),
    [anon_sym_AMP_GT_GT] = ACTIONS(190),
    [anon_sym_LT_AMP] = ACTIONS(190),
    [anon_sym_GT_AMP] = ACTIONS(190),
    [anon_sym_LT_LT] = ACTIONS(190),
    [anon_sym_LT_LT_DASH] = ACTIONS(190),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(190),
    [anon_sym_DOLLAR] = ACTIONS(190),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(190),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(190),
    [anon_sym_BQUOTE] = ACTIONS(190),
    [anon_sym_LT_LPAREN] = ACTIONS(190),
    [anon_sym_GT_LPAREN] = ACTIONS(190),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(190),
    [anon_sym_SEMI] = ACTIONS(190),
    [anon_sym_LF] = ACTIONS(190),
    [anon_sym_AMP] = ACTIONS(190),
  },
  [20] = {
    [ts_builtin_sym_end] = ACTIONS(194),
    [sym_comment] = ACTIONS(46),
  },
  [21] = {
    [sym_file_descriptor] = ACTIONS(196),
    [sym_word] = ACTIONS(196),
    [sym_variable_name] = ACTIONS(196),
    [ts_builtin_sym_end] = ACTIONS(196),
    [anon_sym_for] = ACTIONS(198),
    [anon_sym_while] = ACTIONS(198),
    [anon_sym_if] = ACTIONS(198),
    [anon_sym_case] = ACTIONS(198),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(196),
    [anon_sym_RBRACE] = ACTIONS(196),
    [anon_sym_declare] = ACTIONS(198),
    [anon_sym_typeset] = ACTIONS(198),
    [anon_sym_export] = ACTIONS(198),
    [anon_sym_readonly] = ACTIONS(198),
    [anon_sym_local] = ACTIONS(198),
    [anon_sym_LT] = ACTIONS(198),
    [anon_sym_GT] = ACTIONS(198),
    [anon_sym_GT_GT] = ACTIONS(196),
    [anon_sym_AMP_GT] = ACTIONS(198),
    [anon_sym_AMP_GT_GT] = ACTIONS(196),
    [anon_sym_LT_AMP] = ACTIONS(196),
    [anon_sym_GT_AMP] = ACTIONS(196),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [sym_raw_string] = ACTIONS(196),
    [anon_sym_DOLLAR] = ACTIONS(198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(196),
    [anon_sym_BQUOTE] = ACTIONS(196),
    [anon_sym_LT_LPAREN] = ACTIONS(196),
    [anon_sym_GT_LPAREN] = ACTIONS(196),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(200),
  },
  [22] = {
    [anon_sym_PIPE] = ACTIONS(202),
    [anon_sym_SEMI_SEMI] = ACTIONS(204),
    [anon_sym_PIPE_AMP] = ACTIONS(202),
    [anon_sym_AMP_AMP] = ACTIONS(206),
    [anon_sym_PIPE_PIPE] = ACTIONS(206),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(204),
    [anon_sym_LF] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(204),
  },
  [23] = {
    [sym_file_redirect] = STATE(134),
    [sym_heredoc_redirect] = STATE(134),
    [sym_concatenation] = STATE(135),
    [sym_string] = STATE(130),
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [sym_process_substitution] = STATE(130),
    [aux_sym_for_statement_repeat1] = STATE(136),
    [aux_sym_command_repeat2] = STATE(137),
    [sym_file_descriptor] = ACTIONS(208),
    [sym_word] = ACTIONS(210),
    [anon_sym_PIPE] = ACTIONS(212),
    [anon_sym_SEMI_SEMI] = ACTIONS(212),
    [anon_sym_PIPE_AMP] = ACTIONS(212),
    [anon_sym_AMP_AMP] = ACTIONS(212),
    [anon_sym_PIPE_PIPE] = ACTIONS(212),
    [anon_sym_LT] = ACTIONS(214),
    [anon_sym_GT] = ACTIONS(214),
    [anon_sym_GT_GT] = ACTIONS(214),
    [anon_sym_AMP_GT] = ACTIONS(214),
    [anon_sym_AMP_GT_GT] = ACTIONS(214),
    [anon_sym_LT_AMP] = ACTIONS(214),
    [anon_sym_GT_AMP] = ACTIONS(214),
    [anon_sym_LT_LT] = ACTIONS(216),
    [anon_sym_LT_LT_DASH] = ACTIONS(216),
    [anon_sym_DQUOTE] = ACTIONS(218),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(222),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(224),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(226),
    [anon_sym_BQUOTE] = ACTIONS(228),
    [anon_sym_LT_LPAREN] = ACTIONS(230),
    [anon_sym_GT_LPAREN] = ACTIONS(230),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(232),
    [anon_sym_SEMI] = ACTIONS(212),
    [anon_sym_LF] = ACTIONS(212),
    [anon_sym_AMP] = ACTIONS(212),
  },
  [24] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(202),
    [anon_sym_SEMI_SEMI] = ACTIONS(204),
    [anon_sym_PIPE_AMP] = ACTIONS(202),
    [anon_sym_AMP_AMP] = ACTIONS(206),
    [anon_sym_PIPE_PIPE] = ACTIONS(206),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(236),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(236),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_DQUOTE] = ACTIONS(236),
    [sym_raw_string] = ACTIONS(236),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(236),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(236),
    [anon_sym_BQUOTE] = ACTIONS(236),
    [anon_sym_LT_LPAREN] = ACTIONS(236),
    [anon_sym_GT_LPAREN] = ACTIONS(236),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(204),
    [anon_sym_LF] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(204),
  },
  [25] = {
    [sym__assignment] = STATE(35),
    [anon_sym_EQ] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(62),
    [sym_comment] = ACTIONS(46),
  },
  [26] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [27] = {
    [sym_file_descriptor] = ACTIONS(54),
    [sym_word] = ACTIONS(54),
    [anon_sym_PIPE] = ACTIONS(58),
    [anon_sym_RPAREN] = ACTIONS(58),
    [anon_sym_SEMI_SEMI] = ACTIONS(58),
    [anon_sym_PIPE_AMP] = ACTIONS(58),
    [anon_sym_AMP_AMP] = ACTIONS(58),
    [anon_sym_PIPE_PIPE] = ACTIONS(58),
    [anon_sym_LT] = ACTIONS(58),
    [anon_sym_GT] = ACTIONS(58),
    [anon_sym_GT_GT] = ACTIONS(58),
    [anon_sym_AMP_GT] = ACTIONS(58),
    [anon_sym_AMP_GT_GT] = ACTIONS(58),
    [anon_sym_LT_AMP] = ACTIONS(58),
    [anon_sym_GT_AMP] = ACTIONS(58),
    [anon_sym_LT_LT] = ACTIONS(58),
    [anon_sym_LT_LT_DASH] = ACTIONS(58),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [sym_raw_string] = ACTIONS(58),
    [anon_sym_DOLLAR] = ACTIONS(58),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(58),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(58),
    [anon_sym_BQUOTE] = ACTIONS(58),
    [anon_sym_LT_LPAREN] = ACTIONS(58),
    [anon_sym_GT_LPAREN] = ACTIONS(58),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(58),
    [anon_sym_SEMI] = ACTIONS(58),
    [anon_sym_LF] = ACTIONS(58),
    [anon_sym_AMP] = ACTIONS(58),
  },
  [28] = {
    [sym__terminated_statement] = STATE(21),
    [sym_for_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_case_statement] = STATE(22),
    [sym_function_definition] = STATE(22),
    [sym_subshell] = STATE(22),
    [sym_pipeline] = STATE(22),
    [sym_list] = STATE(22),
    [sym_command] = STATE(22),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(24),
    [sym_declaration_command] = STATE(22),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(138),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [ts_builtin_sym_end] = ACTIONS(240),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [29] = {
    [sym_command_name] = STATE(141),
    [sym_variable_assignment] = STATE(26),
    [sym_subscript] = STATE(142),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_command_repeat1] = STATE(143),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(242),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(244),
  },
  [30] = {
    [sym_concatenation] = STATE(146),
    [sym_string] = STATE(144),
    [sym_simple_expansion] = STATE(144),
    [sym_expansion] = STATE(144),
    [sym_command_substitution] = STATE(144),
    [sym_process_substitution] = STATE(144),
    [sym_word] = ACTIONS(246),
    [anon_sym_DQUOTE] = ACTIONS(106),
    [sym_raw_string] = ACTIONS(246),
    [anon_sym_DOLLAR] = ACTIONS(108),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(110),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(112),
    [anon_sym_BQUOTE] = ACTIONS(114),
    [anon_sym_LT_LPAREN] = ACTIONS(116),
    [anon_sym_GT_LPAREN] = ACTIONS(116),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(248),
  },
  [31] = {
    [sym_string] = STATE(147),
    [sym_simple_expansion] = STATE(147),
    [sym_expansion] = STATE(147),
    [sym_command_substitution] = STATE(147),
    [sym_process_substitution] = STATE(147),
    [sym_word] = ACTIONS(250),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(250),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(252),
  },
  [32] = {
    [aux_sym_concatenation_repeat1] = STATE(149),
    [sym_file_descriptor] = ACTIONS(254),
    [sym_word] = ACTIONS(254),
    [sym__concat] = ACTIONS(56),
    [anon_sym_PIPE] = ACTIONS(256),
    [anon_sym_SEMI_SEMI] = ACTIONS(256),
    [anon_sym_PIPE_AMP] = ACTIONS(256),
    [anon_sym_AMP_AMP] = ACTIONS(256),
    [anon_sym_PIPE_PIPE] = ACTIONS(256),
    [anon_sym_LT] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(256),
    [anon_sym_GT_GT] = ACTIONS(256),
    [anon_sym_AMP_GT] = ACTIONS(256),
    [anon_sym_AMP_GT_GT] = ACTIONS(256),
    [anon_sym_LT_AMP] = ACTIONS(256),
    [anon_sym_GT_AMP] = ACTIONS(256),
    [anon_sym_LT_LT] = ACTIONS(256),
    [anon_sym_LT_LT_DASH] = ACTIONS(256),
    [anon_sym_DQUOTE] = ACTIONS(256),
    [sym_raw_string] = ACTIONS(256),
    [anon_sym_DOLLAR] = ACTIONS(256),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(256),
    [anon_sym_BQUOTE] = ACTIONS(256),
    [anon_sym_LT_LPAREN] = ACTIONS(256),
    [anon_sym_GT_LPAREN] = ACTIONS(256),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(256),
    [anon_sym_SEMI] = ACTIONS(256),
    [anon_sym_LF] = ACTIONS(256),
    [anon_sym_AMP] = ACTIONS(256),
  },
  [33] = {
    [sym_concatenation] = STATE(151),
    [sym_string] = STATE(150),
    [sym_array] = STATE(151),
    [sym_simple_expansion] = STATE(150),
    [sym_expansion] = STATE(150),
    [sym_command_substitution] = STATE(150),
    [sym_process_substitution] = STATE(150),
    [sym_word] = ACTIONS(258),
    [sym__empty_value] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(258),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(268),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(270),
    [anon_sym_BQUOTE] = ACTIONS(272),
    [anon_sym_LT_LPAREN] = ACTIONS(274),
    [anon_sym_GT_LPAREN] = ACTIONS(274),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(276),
  },
  [34] = {
    [sym_concatenation] = STATE(168),
    [sym_string] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [sym_expansion] = STATE(160),
    [sym_command_substitution] = STATE(160),
    [sym_process_substitution] = STATE(160),
    [sym_word] = ACTIONS(278),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(292),
  },
  [35] = {
    [sym_file_descriptor] = ACTIONS(294),
    [sym_word] = ACTIONS(294),
    [sym_variable_name] = ACTIONS(294),
    [anon_sym_PIPE] = ACTIONS(296),
    [anon_sym_RPAREN] = ACTIONS(296),
    [anon_sym_SEMI_SEMI] = ACTIONS(296),
    [anon_sym_PIPE_AMP] = ACTIONS(296),
    [anon_sym_AMP_AMP] = ACTIONS(296),
    [anon_sym_PIPE_PIPE] = ACTIONS(296),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_GT] = ACTIONS(296),
    [anon_sym_AMP_GT] = ACTIONS(296),
    [anon_sym_AMP_GT_GT] = ACTIONS(296),
    [anon_sym_LT_AMP] = ACTIONS(296),
    [anon_sym_GT_AMP] = ACTIONS(296),
    [anon_sym_DQUOTE] = ACTIONS(296),
    [sym_raw_string] = ACTIONS(296),
    [anon_sym_DOLLAR] = ACTIONS(296),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(296),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(296),
    [anon_sym_BQUOTE] = ACTIONS(296),
    [anon_sym_LT_LPAREN] = ACTIONS(296),
    [anon_sym_GT_LPAREN] = ACTIONS(296),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(296),
    [anon_sym_SEMI] = ACTIONS(296),
    [anon_sym_LF] = ACTIONS(296),
    [anon_sym_AMP] = ACTIONS(296),
  },
  [36] = {
    [anon_sym_in] = ACTIONS(298),
    [sym_comment] = ACTIONS(46),
  },
  [37] = {
    [sym_do_group] = STATE(171),
    [anon_sym_do] = ACTIONS(300),
    [sym_comment] = ACTIONS(46),
  },
  [38] = {
    [anon_sym_PIPE] = ACTIONS(202),
    [anon_sym_SEMI_SEMI] = ACTIONS(302),
    [anon_sym_PIPE_AMP] = ACTIONS(202),
    [anon_sym_AMP_AMP] = ACTIONS(206),
    [anon_sym_PIPE_PIPE] = ACTIONS(206),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(302),
    [anon_sym_LF] = ACTIONS(302),
    [anon_sym_AMP] = ACTIONS(302),
  },
  [39] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(202),
    [anon_sym_SEMI_SEMI] = ACTIONS(302),
    [anon_sym_PIPE_AMP] = ACTIONS(202),
    [anon_sym_AMP_AMP] = ACTIONS(206),
    [anon_sym_PIPE_PIPE] = ACTIONS(206),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(236),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(236),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_DQUOTE] = ACTIONS(236),
    [sym_raw_string] = ACTIONS(236),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(236),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(236),
    [anon_sym_BQUOTE] = ACTIONS(236),
    [anon_sym_LT_LPAREN] = ACTIONS(236),
    [anon_sym_GT_LPAREN] = ACTIONS(236),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(302),
    [anon_sym_LF] = ACTIONS(302),
    [anon_sym_AMP] = ACTIONS(302),
  },
  [40] = {
    [anon_sym_then] = ACTIONS(304),
    [sym_comment] = ACTIONS(46),
  },
  [41] = {
    [aux_sym_concatenation_repeat1] = STATE(177),
    [sym__concat] = ACTIONS(306),
    [anon_sym_in] = ACTIONS(308),
    [anon_sym_SEMI_SEMI] = ACTIONS(310),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(310),
    [anon_sym_LF] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
  },
  [42] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(179),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [43] = {
    [sym_special_variable_name] = STATE(182),
    [anon_sym_DOLLAR] = ACTIONS(314),
    [anon_sym_POUND] = ACTIONS(314),
    [anon_sym_AT] = ACTIONS(314),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(316),
    [anon_sym_STAR] = ACTIONS(314),
    [anon_sym_QMARK] = ACTIONS(314),
    [anon_sym_DASH] = ACTIONS(314),
    [anon_sym_BANG] = ACTIONS(314),
    [anon_sym_0] = ACTIONS(318),
    [anon_sym__] = ACTIONS(318),
  },
  [44] = {
    [sym_special_variable_name] = STATE(185),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(320),
    [anon_sym_AT] = ACTIONS(138),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(322),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [45] = {
    [sym_for_statement] = STATE(186),
    [sym_while_statement] = STATE(186),
    [sym_if_statement] = STATE(186),
    [sym_case_statement] = STATE(186),
    [sym_function_definition] = STATE(186),
    [sym_subshell] = STATE(186),
    [sym_pipeline] = STATE(186),
    [sym_list] = STATE(186),
    [sym_command] = STATE(186),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(187),
    [sym_declaration_command] = STATE(186),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [46] = {
    [sym_for_statement] = STATE(188),
    [sym_while_statement] = STATE(188),
    [sym_if_statement] = STATE(188),
    [sym_case_statement] = STATE(188),
    [sym_function_definition] = STATE(188),
    [sym_subshell] = STATE(188),
    [sym_pipeline] = STATE(188),
    [sym_list] = STATE(188),
    [sym_command] = STATE(188),
    [sym_command_name] = STATE(118),
    [sym_variable_assignment] = STATE(189),
    [sym_declaration_command] = STATE(188),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(112),
    [sym_simple_expansion] = STATE(112),
    [sym_expansion] = STATE(112),
    [sym_command_substitution] = STATE(112),
    [sym_process_substitution] = STATE(112),
    [aux_sym_command_repeat1] = STATE(121),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(178),
    [sym_variable_name] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(184),
    [anon_sym_typeset] = ACTIONS(184),
    [anon_sym_export] = ACTIONS(184),
    [anon_sym_readonly] = ACTIONS(184),
    [anon_sym_local] = ACTIONS(184),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(178),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(186),
  },
  [47] = {
    [sym_for_statement] = STATE(190),
    [sym_while_statement] = STATE(190),
    [sym_if_statement] = STATE(190),
    [sym_case_statement] = STATE(190),
    [sym_function_definition] = STATE(190),
    [sym_subshell] = STATE(190),
    [sym_pipeline] = STATE(190),
    [sym_list] = STATE(190),
    [sym_command] = STATE(190),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(191),
    [sym_declaration_command] = STATE(190),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [48] = {
    [aux_sym_concatenation_repeat1] = STATE(194),
    [sym__concat] = ACTIONS(306),
    [anon_sym_in] = ACTIONS(324),
    [anon_sym_SEMI_SEMI] = ACTIONS(326),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(326),
    [anon_sym_LF] = ACTIONS(326),
    [anon_sym_AMP] = ACTIONS(326),
  },
  [49] = {
    [anon_sym_in] = ACTIONS(308),
    [anon_sym_SEMI_SEMI] = ACTIONS(310),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(310),
    [anon_sym_LF] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
  },
  [50] = {
    [sym_compound_statement] = STATE(197),
    [anon_sym_LPAREN] = ACTIONS(328),
    [anon_sym_LBRACE] = ACTIONS(330),
    [sym_comment] = ACTIONS(46),
  },
  [51] = {
    [aux_sym_concatenation_repeat1] = STATE(198),
    [sym_file_descriptor] = ACTIONS(54),
    [sym_word] = ACTIONS(54),
    [sym__concat] = ACTIONS(56),
    [anon_sym_PIPE] = ACTIONS(58),
    [anon_sym_RPAREN] = ACTIONS(58),
    [anon_sym_SEMI_SEMI] = ACTIONS(58),
    [anon_sym_PIPE_AMP] = ACTIONS(58),
    [anon_sym_AMP_AMP] = ACTIONS(58),
    [anon_sym_PIPE_PIPE] = ACTIONS(58),
    [anon_sym_LT] = ACTIONS(58),
    [anon_sym_GT] = ACTIONS(58),
    [anon_sym_GT_GT] = ACTIONS(58),
    [anon_sym_AMP_GT] = ACTIONS(58),
    [anon_sym_AMP_GT_GT] = ACTIONS(58),
    [anon_sym_LT_AMP] = ACTIONS(58),
    [anon_sym_GT_AMP] = ACTIONS(58),
    [anon_sym_LT_LT] = ACTIONS(58),
    [anon_sym_LT_LT_DASH] = ACTIONS(58),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [sym_raw_string] = ACTIONS(58),
    [anon_sym_DOLLAR] = ACTIONS(58),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(58),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(58),
    [anon_sym_BQUOTE] = ACTIONS(58),
    [anon_sym_LT_LPAREN] = ACTIONS(58),
    [anon_sym_GT_LPAREN] = ACTIONS(58),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(58),
    [anon_sym_SEMI] = ACTIONS(58),
    [anon_sym_LF] = ACTIONS(58),
    [anon_sym_AMP] = ACTIONS(58),
  },
  [52] = {
    [sym__assignment] = STATE(35),
    [anon_sym_EQ] = ACTIONS(332),
    [anon_sym_PLUS_EQ] = ACTIONS(332),
    [anon_sym_LBRACK] = ACTIONS(64),
    [sym_comment] = ACTIONS(46),
  },
  [53] = {
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(334),
  },
  [54] = {
    [sym_variable_assignment] = STATE(62),
    [sym_subscript] = STATE(202),
    [aux_sym_declaration_command_repeat1] = STATE(203),
    [sym_word] = ACTIONS(96),
    [sym_variable_name] = ACTIONS(336),
    [anon_sym_PIPE] = ACTIONS(100),
    [anon_sym_RPAREN] = ACTIONS(100),
    [anon_sym_SEMI_SEMI] = ACTIONS(100),
    [anon_sym_PIPE_AMP] = ACTIONS(100),
    [anon_sym_AMP_AMP] = ACTIONS(100),
    [anon_sym_PIPE_PIPE] = ACTIONS(100),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(102),
    [anon_sym_SEMI] = ACTIONS(100),
    [anon_sym_LF] = ACTIONS(100),
    [anon_sym_AMP] = ACTIONS(100),
  },
  [55] = {
    [aux_sym_concatenation_repeat1] = STATE(205),
    [sym_file_descriptor] = ACTIONS(188),
    [sym_word] = ACTIONS(188),
    [sym__concat] = ACTIONS(56),
    [anon_sym_PIPE] = ACTIONS(190),
    [anon_sym_RPAREN] = ACTIONS(190),
    [anon_sym_SEMI_SEMI] = ACTIONS(190),
    [anon_sym_LPAREN] = ACTIONS(338),
    [anon_sym_PIPE_AMP] = ACTIONS(190),
    [anon_sym_AMP_AMP] = ACTIONS(190),
    [anon_sym_PIPE_PIPE] = ACTIONS(190),
    [anon_sym_LT] = ACTIONS(190),
    [anon_sym_GT] = ACTIONS(190),
    [anon_sym_GT_GT] = ACTIONS(190),
    [anon_sym_AMP_GT] = ACTIONS(190),
    [anon_sym_AMP_GT_GT] = ACTIONS(190),
    [anon_sym_LT_AMP] = ACTIONS(190),
    [anon_sym_GT_AMP] = ACTIONS(190),
    [anon_sym_LT_LT] = ACTIONS(190),
    [anon_sym_LT_LT_DASH] = ACTIONS(190),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(190),
    [anon_sym_DOLLAR] = ACTIONS(190),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(190),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(190),
    [anon_sym_BQUOTE] = ACTIONS(190),
    [anon_sym_LT_LPAREN] = ACTIONS(190),
    [anon_sym_GT_LPAREN] = ACTIONS(190),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(190),
    [anon_sym_SEMI] = ACTIONS(190),
    [anon_sym_LF] = ACTIONS(190),
    [anon_sym_AMP] = ACTIONS(190),
  },
  [56] = {
    [anon_sym_PIPE] = ACTIONS(340),
    [anon_sym_RPAREN] = ACTIONS(342),
    [anon_sym_SEMI_SEMI] = ACTIONS(344),
    [anon_sym_PIPE_AMP] = ACTIONS(340),
    [anon_sym_AMP_AMP] = ACTIONS(346),
    [anon_sym_PIPE_PIPE] = ACTIONS(346),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(344),
    [anon_sym_LF] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(344),
  },
  [57] = {
    [sym_file_redirect] = STATE(134),
    [sym_heredoc_redirect] = STATE(134),
    [sym_concatenation] = STATE(135),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym_for_statement_repeat1] = STATE(214),
    [aux_sym_command_repeat2] = STATE(215),
    [sym_file_descriptor] = ACTIONS(348),
    [sym_word] = ACTIONS(350),
    [anon_sym_PIPE] = ACTIONS(212),
    [anon_sym_RPAREN] = ACTIONS(212),
    [anon_sym_SEMI_SEMI] = ACTIONS(212),
    [anon_sym_PIPE_AMP] = ACTIONS(212),
    [anon_sym_AMP_AMP] = ACTIONS(212),
    [anon_sym_PIPE_PIPE] = ACTIONS(212),
    [anon_sym_LT] = ACTIONS(352),
    [anon_sym_GT] = ACTIONS(352),
    [anon_sym_GT_GT] = ACTIONS(352),
    [anon_sym_AMP_GT] = ACTIONS(352),
    [anon_sym_AMP_GT_GT] = ACTIONS(352),
    [anon_sym_LT_AMP] = ACTIONS(352),
    [anon_sym_GT_AMP] = ACTIONS(352),
    [anon_sym_LT_LT] = ACTIONS(216),
    [anon_sym_LT_LT_DASH] = ACTIONS(216),
    [anon_sym_DQUOTE] = ACTIONS(218),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(222),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(224),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(226),
    [anon_sym_BQUOTE] = ACTIONS(228),
    [anon_sym_LT_LPAREN] = ACTIONS(230),
    [anon_sym_GT_LPAREN] = ACTIONS(230),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(212),
    [anon_sym_LF] = ACTIONS(212),
    [anon_sym_AMP] = ACTIONS(212),
  },
  [58] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(340),
    [anon_sym_RPAREN] = ACTIONS(342),
    [anon_sym_SEMI_SEMI] = ACTIONS(344),
    [anon_sym_PIPE_AMP] = ACTIONS(340),
    [anon_sym_AMP_AMP] = ACTIONS(346),
    [anon_sym_PIPE_PIPE] = ACTIONS(346),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(236),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(236),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_DQUOTE] = ACTIONS(236),
    [sym_raw_string] = ACTIONS(236),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(236),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(236),
    [anon_sym_BQUOTE] = ACTIONS(236),
    [anon_sym_LT_LPAREN] = ACTIONS(236),
    [anon_sym_GT_LPAREN] = ACTIONS(236),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(344),
    [anon_sym_LF] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(344),
  },
  [59] = {
    [sym__assignment] = STATE(35),
    [anon_sym_EQ] = ACTIONS(332),
    [anon_sym_PLUS_EQ] = ACTIONS(332),
    [sym_comment] = ACTIONS(46),
  },
  [60] = {
    [sym__terminated_statement] = STATE(21),
    [sym_for_statement] = STATE(216),
    [sym_while_statement] = STATE(216),
    [sym_if_statement] = STATE(216),
    [sym_case_statement] = STATE(216),
    [sym_function_definition] = STATE(216),
    [sym_subshell] = STATE(216),
    [sym_pipeline] = STATE(216),
    [sym_list] = STATE(216),
    [sym_command] = STATE(216),
    [sym_command_name] = STATE(57),
    [sym_variable_assignment] = STATE(217),
    [sym_declaration_command] = STATE(216),
    [sym_subscript] = STATE(59),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(51),
    [sym_simple_expansion] = STATE(51),
    [sym_expansion] = STATE(51),
    [sym_command_substitution] = STATE(51),
    [sym_process_substitution] = STATE(51),
    [aux_sym_program_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(61),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(86),
    [sym_variable_name] = ACTIONS(88),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(90),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(92),
    [anon_sym_typeset] = ACTIONS(92),
    [anon_sym_export] = ACTIONS(92),
    [anon_sym_readonly] = ACTIONS(92),
    [anon_sym_local] = ACTIONS(92),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(86),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(94),
  },
  [61] = {
    [sym_command_name] = STATE(220),
    [sym_variable_assignment] = STATE(26),
    [sym_subscript] = STATE(142),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(51),
    [sym_simple_expansion] = STATE(51),
    [sym_expansion] = STATE(51),
    [sym_command_substitution] = STATE(51),
    [sym_process_substitution] = STATE(51),
    [aux_sym_command_repeat1] = STATE(143),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(86),
    [sym_variable_name] = ACTIONS(242),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(86),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(358),
  },
  [62] = {
    [sym_word] = ACTIONS(360),
    [sym_variable_name] = ACTIONS(360),
    [anon_sym_PIPE] = ACTIONS(362),
    [anon_sym_RPAREN] = ACTIONS(362),
    [anon_sym_SEMI_SEMI] = ACTIONS(362),
    [anon_sym_PIPE_AMP] = ACTIONS(362),
    [anon_sym_AMP_AMP] = ACTIONS(362),
    [anon_sym_PIPE_PIPE] = ACTIONS(362),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(362),
    [anon_sym_SEMI] = ACTIONS(362),
    [anon_sym_LF] = ACTIONS(362),
    [anon_sym_AMP] = ACTIONS(362),
  },
  [63] = {
    [sym__assignment] = STATE(222),
    [anon_sym_EQ] = ACTIONS(364),
    [anon_sym_PLUS_EQ] = ACTIONS(364),
    [anon_sym_LBRACK] = ACTIONS(64),
    [sym_comment] = ACTIONS(46),
  },
  [64] = {
    [sym_word] = ACTIONS(366),
    [sym_variable_name] = ACTIONS(366),
    [anon_sym_PIPE] = ACTIONS(368),
    [anon_sym_RPAREN] = ACTIONS(368),
    [anon_sym_SEMI_SEMI] = ACTIONS(368),
    [anon_sym_PIPE_AMP] = ACTIONS(368),
    [anon_sym_AMP_AMP] = ACTIONS(368),
    [anon_sym_PIPE_PIPE] = ACTIONS(368),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym_LF] = ACTIONS(368),
    [anon_sym_AMP] = ACTIONS(368),
  },
  [65] = {
    [sym__assignment] = STATE(222),
    [anon_sym_EQ] = ACTIONS(364),
    [anon_sym_PLUS_EQ] = ACTIONS(364),
    [sym_comment] = ACTIONS(46),
  },
  [66] = {
    [sym_variable_assignment] = STATE(62),
    [sym_subscript] = STATE(65),
    [aux_sym_declaration_command_repeat1] = STATE(223),
    [sym_word] = ACTIONS(96),
    [sym_variable_name] = ACTIONS(98),
    [anon_sym_PIPE] = ACTIONS(370),
    [anon_sym_SEMI_SEMI] = ACTIONS(370),
    [anon_sym_PIPE_AMP] = ACTIONS(370),
    [anon_sym_AMP_AMP] = ACTIONS(370),
    [anon_sym_PIPE_PIPE] = ACTIONS(370),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(102),
    [anon_sym_SEMI] = ACTIONS(370),
    [anon_sym_LF] = ACTIONS(370),
    [anon_sym_AMP] = ACTIONS(370),
  },
  [67] = {
    [aux_sym_concatenation_repeat1] = STATE(225),
    [sym_file_descriptor] = ACTIONS(372),
    [sym_word] = ACTIONS(372),
    [sym__concat] = ACTIONS(374),
    [sym_variable_name] = ACTIONS(372),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_GT] = ACTIONS(376),
    [anon_sym_GT_GT] = ACTIONS(372),
    [anon_sym_AMP_GT] = ACTIONS(376),
    [anon_sym_AMP_GT_GT] = ACTIONS(372),
    [anon_sym_LT_AMP] = ACTIONS(372),
    [anon_sym_GT_AMP] = ACTIONS(372),
    [anon_sym_DQUOTE] = ACTIONS(372),
    [sym_raw_string] = ACTIONS(372),
    [anon_sym_DOLLAR] = ACTIONS(376),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(372),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(372),
    [anon_sym_BQUOTE] = ACTIONS(372),
    [anon_sym_LT_LPAREN] = ACTIONS(372),
    [anon_sym_GT_LPAREN] = ACTIONS(372),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(376),
  },
  [68] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(227),
    [anon_sym_DQUOTE] = ACTIONS(378),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [69] = {
    [sym_special_variable_name] = STATE(230),
    [anon_sym_DOLLAR] = ACTIONS(380),
    [anon_sym_POUND] = ACTIONS(380),
    [anon_sym_AT] = ACTIONS(380),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(382),
    [anon_sym_STAR] = ACTIONS(380),
    [anon_sym_QMARK] = ACTIONS(380),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(380),
    [anon_sym_0] = ACTIONS(384),
    [anon_sym__] = ACTIONS(384),
  },
  [70] = {
    [sym_special_variable_name] = STATE(233),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(386),
    [anon_sym_AT] = ACTIONS(138),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(388),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [71] = {
    [sym_for_statement] = STATE(234),
    [sym_while_statement] = STATE(234),
    [sym_if_statement] = STATE(234),
    [sym_case_statement] = STATE(234),
    [sym_function_definition] = STATE(234),
    [sym_subshell] = STATE(234),
    [sym_pipeline] = STATE(234),
    [sym_list] = STATE(234),
    [sym_command] = STATE(234),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(235),
    [sym_declaration_command] = STATE(234),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [72] = {
    [sym_for_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_function_definition] = STATE(236),
    [sym_subshell] = STATE(236),
    [sym_pipeline] = STATE(236),
    [sym_list] = STATE(236),
    [sym_command] = STATE(236),
    [sym_command_name] = STATE(118),
    [sym_variable_assignment] = STATE(237),
    [sym_declaration_command] = STATE(236),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(112),
    [sym_simple_expansion] = STATE(112),
    [sym_expansion] = STATE(112),
    [sym_command_substitution] = STATE(112),
    [sym_process_substitution] = STATE(112),
    [aux_sym_command_repeat1] = STATE(121),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(178),
    [sym_variable_name] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(184),
    [anon_sym_typeset] = ACTIONS(184),
    [anon_sym_export] = ACTIONS(184),
    [anon_sym_readonly] = ACTIONS(184),
    [anon_sym_local] = ACTIONS(184),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(178),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(186),
  },
  [73] = {
    [sym_for_statement] = STATE(238),
    [sym_while_statement] = STATE(238),
    [sym_if_statement] = STATE(238),
    [sym_case_statement] = STATE(238),
    [sym_function_definition] = STATE(238),
    [sym_subshell] = STATE(238),
    [sym_pipeline] = STATE(238),
    [sym_list] = STATE(238),
    [sym_command] = STATE(238),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(239),
    [sym_declaration_command] = STATE(238),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [74] = {
    [aux_sym_concatenation_repeat1] = STATE(240),
    [sym_file_descriptor] = ACTIONS(390),
    [sym_word] = ACTIONS(390),
    [sym__concat] = ACTIONS(374),
    [sym_variable_name] = ACTIONS(390),
    [anon_sym_LT] = ACTIONS(392),
    [anon_sym_GT] = ACTIONS(392),
    [anon_sym_GT_GT] = ACTIONS(390),
    [anon_sym_AMP_GT] = ACTIONS(392),
    [anon_sym_AMP_GT_GT] = ACTIONS(390),
    [anon_sym_LT_AMP] = ACTIONS(390),
    [anon_sym_GT_AMP] = ACTIONS(390),
    [anon_sym_DQUOTE] = ACTIONS(390),
    [sym_raw_string] = ACTIONS(390),
    [anon_sym_DOLLAR] = ACTIONS(392),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(390),
    [anon_sym_BQUOTE] = ACTIONS(390),
    [anon_sym_LT_LPAREN] = ACTIONS(390),
    [anon_sym_GT_LPAREN] = ACTIONS(390),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(392),
  },
  [75] = {
    [sym_file_descriptor] = ACTIONS(372),
    [sym_word] = ACTIONS(372),
    [sym_variable_name] = ACTIONS(372),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_GT] = ACTIONS(376),
    [anon_sym_GT_GT] = ACTIONS(372),
    [anon_sym_AMP_GT] = ACTIONS(376),
    [anon_sym_AMP_GT_GT] = ACTIONS(372),
    [anon_sym_LT_AMP] = ACTIONS(372),
    [anon_sym_GT_AMP] = ACTIONS(372),
    [anon_sym_DQUOTE] = ACTIONS(372),
    [sym_raw_string] = ACTIONS(372),
    [anon_sym_DOLLAR] = ACTIONS(376),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(372),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(372),
    [anon_sym_BQUOTE] = ACTIONS(372),
    [anon_sym_LT_LPAREN] = ACTIONS(372),
    [anon_sym_GT_LPAREN] = ACTIONS(372),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(376),
  },
  [76] = {
    [sym_file_descriptor] = ACTIONS(394),
    [sym_word] = ACTIONS(394),
    [sym__concat] = ACTIONS(394),
    [anon_sym_PIPE] = ACTIONS(396),
    [anon_sym_RPAREN] = ACTIONS(396),
    [anon_sym_SEMI_SEMI] = ACTIONS(396),
    [anon_sym_PIPE_AMP] = ACTIONS(396),
    [anon_sym_AMP_AMP] = ACTIONS(396),
    [anon_sym_PIPE_PIPE] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(396),
    [anon_sym_GT] = ACTIONS(396),
    [anon_sym_GT_GT] = ACTIONS(396),
    [anon_sym_AMP_GT] = ACTIONS(396),
    [anon_sym_AMP_GT_GT] = ACTIONS(396),
    [anon_sym_LT_AMP] = ACTIONS(396),
    [anon_sym_GT_AMP] = ACTIONS(396),
    [anon_sym_LT_LT] = ACTIONS(396),
    [anon_sym_LT_LT_DASH] = ACTIONS(396),
    [anon_sym_DQUOTE] = ACTIONS(396),
    [sym_raw_string] = ACTIONS(396),
    [anon_sym_DOLLAR] = ACTIONS(396),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(396),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(396),
    [anon_sym_BQUOTE] = ACTIONS(396),
    [anon_sym_LT_LPAREN] = ACTIONS(396),
    [anon_sym_GT_LPAREN] = ACTIONS(396),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(396),
    [anon_sym_SEMI] = ACTIONS(396),
    [anon_sym_LF] = ACTIONS(396),
    [anon_sym_AMP] = ACTIONS(396),
  },
  [77] = {
    [anon_sym_DQUOTE] = ACTIONS(398),
    [sym__string_content] = ACTIONS(398),
    [anon_sym_DOLLAR] = ACTIONS(398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(398),
    [anon_sym_BQUOTE] = ACTIONS(398),
    [sym_comment] = ACTIONS(60),
  },
  [78] = {
    [sym_special_variable_name] = STATE(243),
    [anon_sym_DOLLAR] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(400),
    [anon_sym_AT] = ACTIONS(400),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_STAR] = ACTIONS(400),
    [anon_sym_QMARK] = ACTIONS(400),
    [anon_sym_DASH] = ACTIONS(400),
    [anon_sym_BANG] = ACTIONS(400),
    [anon_sym_0] = ACTIONS(404),
    [anon_sym__] = ACTIONS(404),
  },
  [79] = {
    [sym_special_variable_name] = STATE(246),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(406),
    [anon_sym_AT] = ACTIONS(138),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(408),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [80] = {
    [sym_for_statement] = STATE(247),
    [sym_while_statement] = STATE(247),
    [sym_if_statement] = STATE(247),
    [sym_case_statement] = STATE(247),
    [sym_function_definition] = STATE(247),
    [sym_subshell] = STATE(247),
    [sym_pipeline] = STATE(247),
    [sym_list] = STATE(247),
    [sym_command] = STATE(247),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(248),
    [sym_declaration_command] = STATE(247),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [81] = {
    [sym_for_statement] = STATE(249),
    [sym_while_statement] = STATE(249),
    [sym_if_statement] = STATE(249),
    [sym_case_statement] = STATE(249),
    [sym_function_definition] = STATE(249),
    [sym_subshell] = STATE(249),
    [sym_pipeline] = STATE(249),
    [sym_list] = STATE(249),
    [sym_command] = STATE(249),
    [sym_command_name] = STATE(118),
    [sym_variable_assignment] = STATE(250),
    [sym_declaration_command] = STATE(249),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(112),
    [sym_simple_expansion] = STATE(112),
    [sym_expansion] = STATE(112),
    [sym_command_substitution] = STATE(112),
    [sym_process_substitution] = STATE(112),
    [aux_sym_command_repeat1] = STATE(121),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(178),
    [sym_variable_name] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(184),
    [anon_sym_typeset] = ACTIONS(184),
    [anon_sym_export] = ACTIONS(184),
    [anon_sym_readonly] = ACTIONS(184),
    [anon_sym_local] = ACTIONS(184),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(178),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(186),
  },
  [82] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(252),
    [anon_sym_DQUOTE] = ACTIONS(410),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [83] = {
    [sym_file_descriptor] = ACTIONS(412),
    [sym_word] = ACTIONS(412),
    [sym__concat] = ACTIONS(412),
    [anon_sym_PIPE] = ACTIONS(414),
    [anon_sym_RPAREN] = ACTIONS(414),
    [anon_sym_SEMI_SEMI] = ACTIONS(414),
    [anon_sym_PIPE_AMP] = ACTIONS(414),
    [anon_sym_AMP_AMP] = ACTIONS(414),
    [anon_sym_PIPE_PIPE] = ACTIONS(414),
    [anon_sym_LT] = ACTIONS(414),
    [anon_sym_GT] = ACTIONS(414),
    [anon_sym_GT_GT] = ACTIONS(414),
    [anon_sym_AMP_GT] = ACTIONS(414),
    [anon_sym_AMP_GT_GT] = ACTIONS(414),
    [anon_sym_LT_AMP] = ACTIONS(414),
    [anon_sym_GT_AMP] = ACTIONS(414),
    [anon_sym_LT_LT] = ACTIONS(414),
    [anon_sym_LT_LT_DASH] = ACTIONS(414),
    [anon_sym_DQUOTE] = ACTIONS(414),
    [sym_raw_string] = ACTIONS(414),
    [anon_sym_DOLLAR] = ACTIONS(414),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(414),
    [anon_sym_BQUOTE] = ACTIONS(414),
    [anon_sym_LT_LPAREN] = ACTIONS(414),
    [anon_sym_GT_LPAREN] = ACTIONS(414),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(414),
    [anon_sym_SEMI] = ACTIONS(414),
    [anon_sym_LF] = ACTIONS(414),
    [anon_sym_AMP] = ACTIONS(414),
  },
  [84] = {
    [sym_file_descriptor] = ACTIONS(416),
    [sym_word] = ACTIONS(416),
    [sym__concat] = ACTIONS(416),
    [anon_sym_PIPE] = ACTIONS(418),
    [anon_sym_RPAREN] = ACTIONS(418),
    [anon_sym_SEMI_SEMI] = ACTIONS(418),
    [anon_sym_PIPE_AMP] = ACTIONS(418),
    [anon_sym_AMP_AMP] = ACTIONS(418),
    [anon_sym_PIPE_PIPE] = ACTIONS(418),
    [anon_sym_LT] = ACTIONS(418),
    [anon_sym_GT] = ACTIONS(418),
    [anon_sym_GT_GT] = ACTIONS(418),
    [anon_sym_AMP_GT] = ACTIONS(418),
    [anon_sym_AMP_GT_GT] = ACTIONS(418),
    [anon_sym_LT_AMP] = ACTIONS(418),
    [anon_sym_GT_AMP] = ACTIONS(418),
    [anon_sym_LT_LT] = ACTIONS(418),
    [anon_sym_LT_LT_DASH] = ACTIONS(418),
    [anon_sym_DQUOTE] = ACTIONS(418),
    [sym_raw_string] = ACTIONS(418),
    [anon_sym_DOLLAR] = ACTIONS(418),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(418),
    [anon_sym_BQUOTE] = ACTIONS(418),
    [anon_sym_LT_LPAREN] = ACTIONS(418),
    [anon_sym_GT_LPAREN] = ACTIONS(418),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(418),
    [anon_sym_SEMI] = ACTIONS(418),
    [anon_sym_LF] = ACTIONS(418),
    [anon_sym_AMP] = ACTIONS(418),
  },
  [85] = {
    [sym_file_descriptor] = ACTIONS(420),
    [sym_word] = ACTIONS(420),
    [sym__concat] = ACTIONS(420),
    [anon_sym_PIPE] = ACTIONS(422),
    [anon_sym_RPAREN] = ACTIONS(422),
    [anon_sym_SEMI_SEMI] = ACTIONS(422),
    [anon_sym_PIPE_AMP] = ACTIONS(422),
    [anon_sym_AMP_AMP] = ACTIONS(422),
    [anon_sym_PIPE_PIPE] = ACTIONS(422),
    [anon_sym_LT] = ACTIONS(422),
    [anon_sym_GT] = ACTIONS(422),
    [anon_sym_GT_GT] = ACTIONS(422),
    [anon_sym_AMP_GT] = ACTIONS(422),
    [anon_sym_AMP_GT_GT] = ACTIONS(422),
    [anon_sym_LT_AMP] = ACTIONS(422),
    [anon_sym_GT_AMP] = ACTIONS(422),
    [anon_sym_LT_LT] = ACTIONS(422),
    [anon_sym_LT_LT_DASH] = ACTIONS(422),
    [anon_sym_DQUOTE] = ACTIONS(422),
    [sym_raw_string] = ACTIONS(422),
    [anon_sym_DOLLAR] = ACTIONS(422),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(422),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(422),
    [anon_sym_BQUOTE] = ACTIONS(422),
    [anon_sym_LT_LPAREN] = ACTIONS(422),
    [anon_sym_GT_LPAREN] = ACTIONS(422),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(422),
    [anon_sym_SEMI] = ACTIONS(422),
    [anon_sym_LF] = ACTIONS(422),
    [anon_sym_AMP] = ACTIONS(422),
  },
  [86] = {
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_EQ] = ACTIONS(412),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_COLON] = ACTIONS(424),
    [anon_sym_COLON_QMARK] = ACTIONS(412),
    [anon_sym_COLON_DASH] = ACTIONS(412),
    [anon_sym_PERCENT] = ACTIONS(412),
    [anon_sym_SLASH] = ACTIONS(412),
    [sym_comment] = ACTIONS(46),
  },
  [87] = {
    [sym_special_variable_name] = STATE(254),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_EQ] = ACTIONS(412),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(138),
    [anon_sym_AT] = ACTIONS(138),
    [anon_sym_COLON] = ACTIONS(424),
    [anon_sym_COLON_QMARK] = ACTIONS(412),
    [anon_sym_COLON_DASH] = ACTIONS(412),
    [anon_sym_PERCENT] = ACTIONS(412),
    [anon_sym_SLASH] = ACTIONS(412),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(426),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [88] = {
    [anon_sym_RBRACE] = ACTIONS(428),
    [anon_sym_EQ] = ACTIONS(430),
    [anon_sym_LBRACK] = ACTIONS(432),
    [anon_sym_COLON] = ACTIONS(434),
    [anon_sym_COLON_QMARK] = ACTIONS(430),
    [anon_sym_COLON_DASH] = ACTIONS(430),
    [anon_sym_PERCENT] = ACTIONS(430),
    [anon_sym_SLASH] = ACTIONS(430),
    [sym_comment] = ACTIONS(46),
  },
  [89] = {
    [anon_sym_RBRACE] = ACTIONS(436),
    [anon_sym_EQ] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_COLON] = ACTIONS(442),
    [anon_sym_COLON_QMARK] = ACTIONS(438),
    [anon_sym_COLON_DASH] = ACTIONS(438),
    [anon_sym_PERCENT] = ACTIONS(438),
    [anon_sym_SLASH] = ACTIONS(438),
    [sym_comment] = ACTIONS(46),
  },
  [90] = {
    [aux_sym_concatenation_repeat1] = STATE(262),
    [sym_file_descriptor] = ACTIONS(54),
    [sym_word] = ACTIONS(54),
    [sym__concat] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(446),
    [anon_sym_RPAREN] = ACTIONS(54),
    [anon_sym_PIPE_AMP] = ACTIONS(54),
    [anon_sym_AMP_AMP] = ACTIONS(54),
    [anon_sym_PIPE_PIPE] = ACTIONS(54),
    [anon_sym_LT] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(446),
    [anon_sym_GT_GT] = ACTIONS(54),
    [anon_sym_AMP_GT] = ACTIONS(446),
    [anon_sym_AMP_GT_GT] = ACTIONS(54),
    [anon_sym_LT_AMP] = ACTIONS(54),
    [anon_sym_GT_AMP] = ACTIONS(54),
    [anon_sym_LT_LT] = ACTIONS(446),
    [anon_sym_LT_LT_DASH] = ACTIONS(54),
    [anon_sym_DQUOTE] = ACTIONS(54),
    [sym_raw_string] = ACTIONS(54),
    [anon_sym_DOLLAR] = ACTIONS(446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(54),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(54),
    [anon_sym_BQUOTE] = ACTIONS(54),
    [anon_sym_LT_LPAREN] = ACTIONS(54),
    [anon_sym_GT_LPAREN] = ACTIONS(54),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(446),
  },
  [91] = {
    [sym__assignment] = STATE(264),
    [anon_sym_EQ] = ACTIONS(448),
    [anon_sym_PLUS_EQ] = ACTIONS(448),
    [anon_sym_LBRACK] = ACTIONS(64),
    [sym_comment] = ACTIONS(46),
  },
  [92] = {
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(450),
  },
  [93] = {
    [sym__terminated_statement] = STATE(266),
    [sym_for_statement] = STATE(38),
    [sym_while_statement] = STATE(38),
    [sym_if_statement] = STATE(38),
    [sym_case_statement] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_subshell] = STATE(38),
    [sym_pipeline] = STATE(38),
    [sym_list] = STATE(38),
    [sym_command] = STATE(38),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(39),
    [sym_declaration_command] = STATE(38),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [94] = {
    [sym__terminated_statement] = STATE(267),
    [sym_for_statement] = STATE(38),
    [sym_while_statement] = STATE(38),
    [sym_if_statement] = STATE(38),
    [sym_case_statement] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_subshell] = STATE(38),
    [sym_pipeline] = STATE(38),
    [sym_list] = STATE(38),
    [sym_command] = STATE(38),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(39),
    [sym_declaration_command] = STATE(38),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [95] = {
    [sym_concatenation] = STATE(270),
    [sym_string] = STATE(268),
    [sym_simple_expansion] = STATE(268),
    [sym_expansion] = STATE(268),
    [sym_command_substitution] = STATE(268),
    [sym_process_substitution] = STATE(268),
    [sym_word] = ACTIONS(452),
    [anon_sym_DQUOTE] = ACTIONS(70),
    [sym_raw_string] = ACTIONS(452),
    [anon_sym_DOLLAR] = ACTIONS(72),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(74),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(76),
    [anon_sym_BQUOTE] = ACTIONS(78),
    [anon_sym_LT_LPAREN] = ACTIONS(80),
    [anon_sym_GT_LPAREN] = ACTIONS(80),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(454),
  },
  [96] = {
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(456),
  },
  [97] = {
    [sym__terminated_statement] = STATE(21),
    [sym_for_statement] = STATE(272),
    [sym_while_statement] = STATE(272),
    [sym_if_statement] = STATE(272),
    [sym_case_statement] = STATE(272),
    [sym_function_definition] = STATE(272),
    [sym_subshell] = STATE(272),
    [sym_pipeline] = STATE(272),
    [sym_list] = STATE(272),
    [sym_command] = STATE(272),
    [sym_command_name] = STATE(57),
    [sym_variable_assignment] = STATE(273),
    [sym_declaration_command] = STATE(272),
    [sym_subscript] = STATE(59),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(51),
    [sym_simple_expansion] = STATE(51),
    [sym_expansion] = STATE(51),
    [sym_command_substitution] = STATE(51),
    [sym_process_substitution] = STATE(51),
    [aux_sym_program_repeat1] = STATE(274),
    [aux_sym_command_repeat1] = STATE(61),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(86),
    [sym_variable_name] = ACTIONS(88),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(90),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(92),
    [anon_sym_typeset] = ACTIONS(92),
    [anon_sym_export] = ACTIONS(92),
    [anon_sym_readonly] = ACTIONS(92),
    [anon_sym_local] = ACTIONS(92),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(86),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(94),
  },
  [98] = {
    [sym_variable_assignment] = STATE(275),
    [sym_subscript] = STATE(278),
    [aux_sym_declaration_command_repeat1] = STATE(279),
    [sym_word] = ACTIONS(458),
    [sym_variable_name] = ACTIONS(460),
    [anon_sym_PIPE] = ACTIONS(462),
    [anon_sym_RPAREN] = ACTIONS(464),
    [anon_sym_PIPE_AMP] = ACTIONS(464),
    [anon_sym_AMP_AMP] = ACTIONS(464),
    [anon_sym_PIPE_PIPE] = ACTIONS(464),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(466),
  },
  [99] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(281),
    [anon_sym_DQUOTE] = ACTIONS(468),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [100] = {
    [sym_special_variable_name] = STATE(284),
    [anon_sym_DOLLAR] = ACTIONS(470),
    [anon_sym_POUND] = ACTIONS(470),
    [anon_sym_AT] = ACTIONS(470),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(472),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(470),
    [anon_sym_DASH] = ACTIONS(470),
    [anon_sym_BANG] = ACTIONS(470),
    [anon_sym_0] = ACTIONS(474),
    [anon_sym__] = ACTIONS(474),
  },
  [101] = {
    [sym_special_variable_name] = STATE(287),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(476),
    [anon_sym_AT] = ACTIONS(138),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [102] = {
    [sym_for_statement] = STATE(288),
    [sym_while_statement] = STATE(288),
    [sym_if_statement] = STATE(288),
    [sym_case_statement] = STATE(288),
    [sym_function_definition] = STATE(288),
    [sym_subshell] = STATE(288),
    [sym_pipeline] = STATE(288),
    [sym_list] = STATE(288),
    [sym_command] = STATE(288),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(289),
    [sym_declaration_command] = STATE(288),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [103] = {
    [sym_for_statement] = STATE(290),
    [sym_while_statement] = STATE(290),
    [sym_if_statement] = STATE(290),
    [sym_case_statement] = STATE(290),
    [sym_function_definition] = STATE(290),
    [sym_subshell] = STATE(290),
    [sym_pipeline] = STATE(290),
    [sym_list] = STATE(290),
    [sym_command] = STATE(290),
    [sym_command_name] = STATE(118),
    [sym_variable_assignment] = STATE(291),
    [sym_declaration_command] = STATE(290),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(112),
    [sym_simple_expansion] = STATE(112),
    [sym_expansion] = STATE(112),
    [sym_command_substitution] = STATE(112),
    [sym_process_substitution] = STATE(112),
    [aux_sym_command_repeat1] = STATE(121),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(178),
    [sym_variable_name] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(184),
    [anon_sym_typeset] = ACTIONS(184),
    [anon_sym_export] = ACTIONS(184),
    [anon_sym_readonly] = ACTIONS(184),
    [anon_sym_local] = ACTIONS(184),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(178),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(186),
  },
  [104] = {
    [sym_for_statement] = STATE(292),
    [sym_while_statement] = STATE(292),
    [sym_if_statement] = STATE(292),
    [sym_case_statement] = STATE(292),
    [sym_function_definition] = STATE(292),
    [sym_subshell] = STATE(292),
    [sym_pipeline] = STATE(292),
    [sym_list] = STATE(292),
    [sym_command] = STATE(292),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(293),
    [sym_declaration_command] = STATE(292),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [105] = {
    [aux_sym_concatenation_repeat1] = STATE(295),
    [sym_file_descriptor] = ACTIONS(188),
    [sym_word] = ACTIONS(188),
    [sym__concat] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(480),
    [anon_sym_RPAREN] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(482),
    [anon_sym_PIPE_AMP] = ACTIONS(188),
    [anon_sym_AMP_AMP] = ACTIONS(188),
    [anon_sym_PIPE_PIPE] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(480),
    [anon_sym_GT] = ACTIONS(480),
    [anon_sym_GT_GT] = ACTIONS(188),
    [anon_sym_AMP_GT] = ACTIONS(480),
    [anon_sym_AMP_GT_GT] = ACTIONS(188),
    [anon_sym_LT_AMP] = ACTIONS(188),
    [anon_sym_GT_AMP] = ACTIONS(188),
    [anon_sym_LT_LT] = ACTIONS(480),
    [anon_sym_LT_LT_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(188),
    [sym_raw_string] = ACTIONS(188),
    [anon_sym_DOLLAR] = ACTIONS(480),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(188),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(188),
    [anon_sym_BQUOTE] = ACTIONS(188),
    [anon_sym_LT_LPAREN] = ACTIONS(188),
    [anon_sym_GT_LPAREN] = ACTIONS(188),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(480),
  },
  [106] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(486),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [107] = {
    [sym_file_redirect] = STATE(304),
    [sym_heredoc_redirect] = STATE(304),
    [sym_concatenation] = STATE(305),
    [sym_string] = STATE(300),
    [sym_simple_expansion] = STATE(300),
    [sym_expansion] = STATE(300),
    [sym_command_substitution] = STATE(300),
    [sym_process_substitution] = STATE(300),
    [aux_sym_for_statement_repeat1] = STATE(306),
    [aux_sym_command_repeat2] = STATE(307),
    [sym_file_descriptor] = ACTIONS(492),
    [sym_word] = ACTIONS(494),
    [anon_sym_PIPE] = ACTIONS(496),
    [anon_sym_RPAREN] = ACTIONS(498),
    [anon_sym_PIPE_AMP] = ACTIONS(498),
    [anon_sym_AMP_AMP] = ACTIONS(498),
    [anon_sym_PIPE_PIPE] = ACTIONS(498),
    [anon_sym_LT] = ACTIONS(500),
    [anon_sym_GT] = ACTIONS(500),
    [anon_sym_GT_GT] = ACTIONS(502),
    [anon_sym_AMP_GT] = ACTIONS(500),
    [anon_sym_AMP_GT_GT] = ACTIONS(502),
    [anon_sym_LT_AMP] = ACTIONS(502),
    [anon_sym_GT_AMP] = ACTIONS(502),
    [anon_sym_LT_LT] = ACTIONS(504),
    [anon_sym_LT_LT_DASH] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(494),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(508),
  },
  [108] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(486),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [109] = {
    [sym__assignment] = STATE(264),
    [anon_sym_EQ] = ACTIONS(448),
    [anon_sym_PLUS_EQ] = ACTIONS(448),
    [sym_comment] = ACTIONS(46),
  },
  [110] = {
    [sym_file_descriptor] = ACTIONS(54),
    [sym_word] = ACTIONS(54),
    [anon_sym_PIPE] = ACTIONS(446),
    [anon_sym_RPAREN] = ACTIONS(54),
    [anon_sym_PIPE_AMP] = ACTIONS(54),
    [anon_sym_AMP_AMP] = ACTIONS(54),
    [anon_sym_PIPE_PIPE] = ACTIONS(54),
    [anon_sym_LT] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(446),
    [anon_sym_GT_GT] = ACTIONS(54),
    [anon_sym_AMP_GT] = ACTIONS(446),
    [anon_sym_AMP_GT_GT] = ACTIONS(54),
    [anon_sym_LT_AMP] = ACTIONS(54),
    [anon_sym_GT_AMP] = ACTIONS(54),
    [anon_sym_LT_LT] = ACTIONS(446),
    [anon_sym_LT_LT_DASH] = ACTIONS(54),
    [anon_sym_DQUOTE] = ACTIONS(54),
    [sym_raw_string] = ACTIONS(54),
    [anon_sym_DOLLAR] = ACTIONS(446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(54),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(54),
    [anon_sym_BQUOTE] = ACTIONS(54),
    [anon_sym_LT_LPAREN] = ACTIONS(54),
    [anon_sym_GT_LPAREN] = ACTIONS(54),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(446),
  },
  [111] = {
    [sym_command_name] = STATE(309),
    [sym_variable_assignment] = STATE(26),
    [sym_subscript] = STATE(142),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(143),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(242),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(510),
  },
  [112] = {
    [aux_sym_concatenation_repeat1] = STATE(310),
    [sym_file_descriptor] = ACTIONS(54),
    [sym_word] = ACTIONS(54),
    [sym__concat] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(446),
    [anon_sym_PIPE_AMP] = ACTIONS(54),
    [anon_sym_AMP_AMP] = ACTIONS(54),
    [anon_sym_PIPE_PIPE] = ACTIONS(54),
    [anon_sym_LT] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(446),
    [anon_sym_GT_GT] = ACTIONS(54),
    [anon_sym_AMP_GT] = ACTIONS(446),
    [anon_sym_AMP_GT_GT] = ACTIONS(54),
    [anon_sym_LT_AMP] = ACTIONS(54),
    [anon_sym_GT_AMP] = ACTIONS(54),
    [anon_sym_LT_LT] = ACTIONS(446),
    [anon_sym_LT_LT_DASH] = ACTIONS(54),
    [anon_sym_DQUOTE] = ACTIONS(54),
    [sym_raw_string] = ACTIONS(54),
    [anon_sym_DOLLAR] = ACTIONS(446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(54),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(54),
    [anon_sym_BQUOTE] = ACTIONS(54),
    [anon_sym_LT_LPAREN] = ACTIONS(54),
    [anon_sym_GT_LPAREN] = ACTIONS(54),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(446),
  },
  [113] = {
    [sym__assignment] = STATE(264),
    [anon_sym_EQ] = ACTIONS(512),
    [anon_sym_PLUS_EQ] = ACTIONS(512),
    [anon_sym_LBRACK] = ACTIONS(64),
    [sym_comment] = ACTIONS(46),
  },
  [114] = {
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(514),
  },
  [115] = {
    [sym_variable_assignment] = STATE(275),
    [sym_subscript] = STATE(314),
    [aux_sym_declaration_command_repeat1] = STATE(315),
    [sym_word] = ACTIONS(458),
    [sym_variable_name] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(462),
    [anon_sym_PIPE_AMP] = ACTIONS(464),
    [anon_sym_AMP_AMP] = ACTIONS(464),
    [anon_sym_PIPE_PIPE] = ACTIONS(464),
    [anon_sym_BQUOTE] = ACTIONS(464),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(466),
  },
  [116] = {
    [aux_sym_concatenation_repeat1] = STATE(317),
    [sym_file_descriptor] = ACTIONS(188),
    [sym_word] = ACTIONS(188),
    [sym__concat] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(518),
    [anon_sym_PIPE_AMP] = ACTIONS(188),
    [anon_sym_AMP_AMP] = ACTIONS(188),
    [anon_sym_PIPE_PIPE] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(480),
    [anon_sym_GT] = ACTIONS(480),
    [anon_sym_GT_GT] = ACTIONS(188),
    [anon_sym_AMP_GT] = ACTIONS(480),
    [anon_sym_AMP_GT_GT] = ACTIONS(188),
    [anon_sym_LT_AMP] = ACTIONS(188),
    [anon_sym_GT_AMP] = ACTIONS(188),
    [anon_sym_LT_LT] = ACTIONS(480),
    [anon_sym_LT_LT_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(188),
    [sym_raw_string] = ACTIONS(188),
    [anon_sym_DOLLAR] = ACTIONS(480),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(188),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(188),
    [anon_sym_BQUOTE] = ACTIONS(188),
    [anon_sym_LT_LPAREN] = ACTIONS(188),
    [anon_sym_GT_LPAREN] = ACTIONS(188),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(480),
  },
  [117] = {
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_comment] = ACTIONS(46),
  },
  [118] = {
    [sym_file_redirect] = STATE(304),
    [sym_heredoc_redirect] = STATE(304),
    [sym_concatenation] = STATE(305),
    [sym_string] = STATE(321),
    [sym_simple_expansion] = STATE(321),
    [sym_expansion] = STATE(321),
    [sym_command_substitution] = STATE(321),
    [sym_process_substitution] = STATE(321),
    [aux_sym_for_statement_repeat1] = STATE(324),
    [aux_sym_command_repeat2] = STATE(325),
    [sym_file_descriptor] = ACTIONS(526),
    [sym_word] = ACTIONS(528),
    [anon_sym_PIPE] = ACTIONS(496),
    [anon_sym_PIPE_AMP] = ACTIONS(498),
    [anon_sym_AMP_AMP] = ACTIONS(498),
    [anon_sym_PIPE_PIPE] = ACTIONS(498),
    [anon_sym_LT] = ACTIONS(530),
    [anon_sym_GT] = ACTIONS(530),
    [anon_sym_GT_GT] = ACTIONS(532),
    [anon_sym_AMP_GT] = ACTIONS(530),
    [anon_sym_AMP_GT_GT] = ACTIONS(532),
    [anon_sym_LT_AMP] = ACTIONS(532),
    [anon_sym_GT_AMP] = ACTIONS(532),
    [anon_sym_LT_LT] = ACTIONS(504),
    [anon_sym_LT_LT_DASH] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(528),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(498),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(534),
  },
  [119] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [120] = {
    [sym__assignment] = STATE(264),
    [anon_sym_EQ] = ACTIONS(512),
    [anon_sym_PLUS_EQ] = ACTIONS(512),
    [sym_comment] = ACTIONS(46),
  },
  [121] = {
    [sym_command_name] = STATE(327),
    [sym_variable_assignment] = STATE(26),
    [sym_subscript] = STATE(142),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(112),
    [sym_simple_expansion] = STATE(112),
    [sym_expansion] = STATE(112),
    [sym_command_substitution] = STATE(112),
    [sym_process_substitution] = STATE(112),
    [aux_sym_command_repeat1] = STATE(143),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(178),
    [sym_variable_name] = ACTIONS(242),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(178),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(536),
  },
  [122] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(538),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [123] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(538),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [124] = {
    [anon_sym_RPAREN] = ACTIONS(540),
    [sym_comment] = ACTIONS(46),
  },
  [125] = {
    [aux_sym_concatenation_repeat1] = STATE(149),
    [sym_file_descriptor] = ACTIONS(542),
    [sym_word] = ACTIONS(542),
    [sym__concat] = ACTIONS(56),
    [anon_sym_PIPE] = ACTIONS(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_PIPE_PIPE] = ACTIONS(544),
    [anon_sym_LT] = ACTIONS(544),
    [anon_sym_GT] = ACTIONS(544),
    [anon_sym_GT_GT] = ACTIONS(544),
    [anon_sym_AMP_GT] = ACTIONS(544),
    [anon_sym_AMP_GT_GT] = ACTIONS(544),
    [anon_sym_LT_AMP] = ACTIONS(544),
    [anon_sym_GT_AMP] = ACTIONS(544),
    [anon_sym_LT_LT] = ACTIONS(544),
    [anon_sym_LT_LT_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(544),
    [sym_raw_string] = ACTIONS(544),
    [anon_sym_DOLLAR] = ACTIONS(544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(544),
    [anon_sym_BQUOTE] = ACTIONS(544),
    [anon_sym_LT_LPAREN] = ACTIONS(544),
    [anon_sym_GT_LPAREN] = ACTIONS(544),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(544),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [126] = {
    [sym_for_statement] = STATE(330),
    [sym_while_statement] = STATE(330),
    [sym_if_statement] = STATE(330),
    [sym_case_statement] = STATE(330),
    [sym_function_definition] = STATE(330),
    [sym_subshell] = STATE(330),
    [sym_pipeline] = STATE(330),
    [sym_list] = STATE(330),
    [sym_command] = STATE(330),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(331),
    [sym_declaration_command] = STATE(330),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [127] = {
    [sym_file_descriptor] = ACTIONS(546),
    [sym_word] = ACTIONS(546),
    [sym_variable_name] = ACTIONS(546),
    [ts_builtin_sym_end] = ACTIONS(546),
    [anon_sym_for] = ACTIONS(548),
    [anon_sym_while] = ACTIONS(548),
    [anon_sym_if] = ACTIONS(548),
    [anon_sym_case] = ACTIONS(548),
    [anon_sym_function] = ACTIONS(548),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RBRACE] = ACTIONS(546),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeset] = ACTIONS(548),
    [anon_sym_export] = ACTIONS(548),
    [anon_sym_readonly] = ACTIONS(548),
    [anon_sym_local] = ACTIONS(548),
    [anon_sym_LT] = ACTIONS(548),
    [anon_sym_GT] = ACTIONS(548),
    [anon_sym_GT_GT] = ACTIONS(546),
    [anon_sym_AMP_GT] = ACTIONS(548),
    [anon_sym_AMP_GT_GT] = ACTIONS(546),
    [anon_sym_LT_AMP] = ACTIONS(546),
    [anon_sym_GT_AMP] = ACTIONS(546),
    [anon_sym_DQUOTE] = ACTIONS(546),
    [sym_raw_string] = ACTIONS(546),
    [anon_sym_DOLLAR] = ACTIONS(548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(546),
    [anon_sym_LT_LPAREN] = ACTIONS(546),
    [anon_sym_GT_LPAREN] = ACTIONS(546),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(550),
  },
  [128] = {
    [sym_for_statement] = STATE(332),
    [sym_while_statement] = STATE(332),
    [sym_if_statement] = STATE(332),
    [sym_case_statement] = STATE(332),
    [sym_function_definition] = STATE(332),
    [sym_subshell] = STATE(332),
    [sym_pipeline] = STATE(332),
    [sym_list] = STATE(332),
    [sym_command] = STATE(332),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(333),
    [sym_declaration_command] = STATE(332),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [129] = {
    [anon_sym_LT] = ACTIONS(552),
    [anon_sym_GT] = ACTIONS(552),
    [anon_sym_GT_GT] = ACTIONS(554),
    [anon_sym_AMP_GT] = ACTIONS(552),
    [anon_sym_AMP_GT_GT] = ACTIONS(554),
    [anon_sym_LT_AMP] = ACTIONS(554),
    [anon_sym_GT_AMP] = ACTIONS(554),
    [sym_comment] = ACTIONS(46),
  },
  [130] = {
    [aux_sym_concatenation_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(556),
    [sym_word] = ACTIONS(556),
    [sym__concat] = ACTIONS(56),
    [anon_sym_PIPE] = ACTIONS(558),
    [anon_sym_SEMI_SEMI] = ACTIONS(558),
    [anon_sym_PIPE_AMP] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(558),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(558),
    [anon_sym_GT_GT] = ACTIONS(558),
    [anon_sym_AMP_GT] = ACTIONS(558),
    [anon_sym_AMP_GT_GT] = ACTIONS(558),
    [anon_sym_LT_AMP] = ACTIONS(558),
    [anon_sym_GT_AMP] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(558),
    [anon_sym_LT_LT_DASH] = ACTIONS(558),
    [anon_sym_DQUOTE] = ACTIONS(558),
    [sym_raw_string] = ACTIONS(558),
    [anon_sym_DOLLAR] = ACTIONS(558),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(558),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(558),
    [anon_sym_BQUOTE] = ACTIONS(558),
    [anon_sym_LT_LPAREN] = ACTIONS(558),
    [anon_sym_GT_LPAREN] = ACTIONS(558),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(558),
    [anon_sym_SEMI] = ACTIONS(558),
    [anon_sym_LF] = ACTIONS(558),
    [anon_sym_AMP] = ACTIONS(558),
  },
  [131] = {
    [sym_concatenation] = STATE(343),
    [sym_string] = STATE(335),
    [sym_simple_expansion] = STATE(335),
    [sym_expansion] = STATE(335),
    [sym_command_substitution] = STATE(335),
    [sym_process_substitution] = STATE(335),
    [sym_word] = ACTIONS(560),
    [anon_sym_DQUOTE] = ACTIONS(562),
    [sym_raw_string] = ACTIONS(560),
    [anon_sym_DOLLAR] = ACTIONS(564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(566),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(568),
    [anon_sym_BQUOTE] = ACTIONS(570),
    [anon_sym_LT_LPAREN] = ACTIONS(572),
    [anon_sym_GT_LPAREN] = ACTIONS(572),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(574),
  },
  [132] = {
    [sym_heredoc] = STATE(346),
    [sym__simple_heredoc] = ACTIONS(576),
    [sym__heredoc_beginning] = ACTIONS(578),
    [sym_comment] = ACTIONS(46),
  },
  [133] = {
    [aux_sym_concatenation_repeat1] = STATE(125),
    [sym_file_descriptor] = ACTIONS(580),
    [sym_word] = ACTIONS(580),
    [sym__concat] = ACTIONS(56),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_SEMI_SEMI] = ACTIONS(582),
    [anon_sym_PIPE_AMP] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(582),
    [anon_sym_GT] = ACTIONS(582),
    [anon_sym_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_GT] = ACTIONS(582),
    [anon_sym_AMP_GT_GT] = ACTIONS(582),
    [anon_sym_LT_AMP] = ACTIONS(582),
    [anon_sym_GT_AMP] = ACTIONS(582),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_LT_LT_DASH] = ACTIONS(582),
    [anon_sym_DQUOTE] = ACTIONS(582),
    [sym_raw_string] = ACTIONS(582),
    [anon_sym_DOLLAR] = ACTIONS(582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(582),
    [anon_sym_BQUOTE] = ACTIONS(582),
    [anon_sym_LT_LPAREN] = ACTIONS(582),
    [anon_sym_GT_LPAREN] = ACTIONS(582),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(582),
    [anon_sym_LF] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(582),
  },
  [134] = {
    [sym_file_descriptor] = ACTIONS(584),
    [anon_sym_PIPE] = ACTIONS(586),
    [anon_sym_RPAREN] = ACTIONS(586),
    [anon_sym_SEMI_SEMI] = ACTIONS(586),
    [anon_sym_PIPE_AMP] = ACTIONS(586),
    [anon_sym_AMP_AMP] = ACTIONS(586),
    [anon_sym_PIPE_PIPE] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(586),
    [anon_sym_GT] = ACTIONS(586),
    [anon_sym_GT_GT] = ACTIONS(586),
    [anon_sym_AMP_GT] = ACTIONS(586),
    [anon_sym_AMP_GT_GT] = ACTIONS(586),
    [anon_sym_LT_AMP] = ACTIONS(586),
    [anon_sym_GT_AMP] = ACTIONS(586),
    [anon_sym_LT_LT] = ACTIONS(586),
    [anon_sym_LT_LT_DASH] = ACTIONS(586),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(586),
    [anon_sym_LF] = ACTIONS(586),
    [anon_sym_AMP] = ACTIONS(586),
  },
  [135] = {
    [sym_file_descriptor] = ACTIONS(556),
    [sym_word] = ACTIONS(556),
    [anon_sym_PIPE] = ACTIONS(558),
    [anon_sym_RPAREN] = ACTIONS(558),
    [anon_sym_SEMI_SEMI] = ACTIONS(558),
    [anon_sym_PIPE_AMP] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(558),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(558),
    [anon_sym_GT_GT] = ACTIONS(558),
    [anon_sym_AMP_GT] = ACTIONS(558),
    [anon_sym_AMP_GT_GT] = ACTIONS(558),
    [anon_sym_LT_AMP] = ACTIONS(558),
    [anon_sym_GT_AMP] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(558),
    [anon_sym_LT_LT_DASH] = ACTIONS(558),
    [anon_sym_DQUOTE] = ACTIONS(558),
    [sym_raw_string] = ACTIONS(558),
    [anon_sym_DOLLAR] = ACTIONS(558),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(558),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(558),
    [anon_sym_BQUOTE] = ACTIONS(558),
    [anon_sym_LT_LPAREN] = ACTIONS(558),
    [anon_sym_GT_LPAREN] = ACTIONS(558),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(558),
    [anon_sym_SEMI] = ACTIONS(558),
    [anon_sym_LF] = ACTIONS(558),
    [anon_sym_AMP] = ACTIONS(558),
  },
  [136] = {
    [sym_file_redirect] = STATE(134),
    [sym_heredoc_redirect] = STATE(134),
    [sym_concatenation] = STATE(135),
    [sym_string] = STATE(130),
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [sym_process_substitution] = STATE(130),
    [aux_sym_for_statement_repeat1] = STATE(347),
    [aux_sym_command_repeat2] = STATE(348),
    [sym_file_descriptor] = ACTIONS(208),
    [sym_word] = ACTIONS(210),
    [anon_sym_PIPE] = ACTIONS(588),
    [anon_sym_SEMI_SEMI] = ACTIONS(588),
    [anon_sym_PIPE_AMP] = ACTIONS(588),
    [anon_sym_AMP_AMP] = ACTIONS(588),
    [anon_sym_PIPE_PIPE] = ACTIONS(588),
    [anon_sym_LT] = ACTIONS(214),
    [anon_sym_GT] = ACTIONS(214),
    [anon_sym_GT_GT] = ACTIONS(214),
    [anon_sym_AMP_GT] = ACTIONS(214),
    [anon_sym_AMP_GT_GT] = ACTIONS(214),
    [anon_sym_LT_AMP] = ACTIONS(214),
    [anon_sym_GT_AMP] = ACTIONS(214),
    [anon_sym_LT_LT] = ACTIONS(216),
    [anon_sym_LT_LT_DASH] = ACTIONS(216),
    [anon_sym_DQUOTE] = ACTIONS(218),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(222),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(224),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(226),
    [anon_sym_BQUOTE] = ACTIONS(228),
    [anon_sym_LT_LPAREN] = ACTIONS(230),
    [anon_sym_GT_LPAREN] = ACTIONS(230),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(232),
    [anon_sym_SEMI] = ACTIONS(588),
    [anon_sym_LF] = ACTIONS(588),
    [anon_sym_AMP] = ACTIONS(588),
  },
  [137] = {
    [sym_file_redirect] = STATE(134),
    [sym_heredoc_redirect] = STATE(134),
    [aux_sym_command_repeat2] = STATE(349),
    [sym_file_descriptor] = ACTIONS(208),
    [anon_sym_PIPE] = ACTIONS(588),
    [anon_sym_SEMI_SEMI] = ACTIONS(588),
    [anon_sym_PIPE_AMP] = ACTIONS(588),
    [anon_sym_AMP_AMP] = ACTIONS(588),
    [anon_sym_PIPE_PIPE] = ACTIONS(588),
    [anon_sym_LT] = ACTIONS(214),
    [anon_sym_GT] = ACTIONS(214),
    [anon_sym_GT_GT] = ACTIONS(214),
    [anon_sym_AMP_GT] = ACTIONS(214),
    [anon_sym_AMP_GT_GT] = ACTIONS(214),
    [anon_sym_LT_AMP] = ACTIONS(214),
    [anon_sym_GT_AMP] = ACTIONS(214),
    [anon_sym_LT_LT] = ACTIONS(216),
    [anon_sym_LT_LT_DASH] = ACTIONS(216),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(588),
    [anon_sym_LF] = ACTIONS(588),
    [anon_sym_AMP] = ACTIONS(588),
  },
  [138] = {
    [sym__terminated_statement] = STATE(21),
    [sym_for_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_case_statement] = STATE(22),
    [sym_function_definition] = STATE(22),
    [sym_subshell] = STATE(22),
    [sym_pipeline] = STATE(22),
    [sym_list] = STATE(22),
    [sym_command] = STATE(22),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(24),
    [sym_declaration_command] = STATE(22),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(138),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(590),
    [sym_word] = ACTIONS(593),
    [sym_variable_name] = ACTIONS(596),
    [ts_builtin_sym_end] = ACTIONS(599),
    [anon_sym_for] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(604),
    [anon_sym_if] = ACTIONS(607),
    [anon_sym_case] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(619),
    [anon_sym_typeset] = ACTIONS(619),
    [anon_sym_export] = ACTIONS(619),
    [anon_sym_readonly] = ACTIONS(619),
    [anon_sym_local] = ACTIONS(619),
    [anon_sym_LT] = ACTIONS(622),
    [anon_sym_GT] = ACTIONS(622),
    [anon_sym_GT_GT] = ACTIONS(625),
    [anon_sym_AMP_GT] = ACTIONS(622),
    [anon_sym_AMP_GT_GT] = ACTIONS(625),
    [anon_sym_LT_AMP] = ACTIONS(625),
    [anon_sym_GT_AMP] = ACTIONS(625),
    [anon_sym_DQUOTE] = ACTIONS(628),
    [sym_raw_string] = ACTIONS(593),
    [anon_sym_DOLLAR] = ACTIONS(631),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(634),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(637),
    [anon_sym_BQUOTE] = ACTIONS(640),
    [anon_sym_LT_LPAREN] = ACTIONS(643),
    [anon_sym_GT_LPAREN] = ACTIONS(643),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(646),
  },
  [139] = {
    [sym__assignment] = STATE(351),
    [anon_sym_EQ] = ACTIONS(649),
    [anon_sym_PLUS_EQ] = ACTIONS(649),
    [anon_sym_LBRACK] = ACTIONS(64),
    [sym_comment] = ACTIONS(46),
  },
  [140] = {
    [aux_sym_concatenation_repeat1] = STATE(125),
    [sym_file_descriptor] = ACTIONS(188),
    [sym_word] = ACTIONS(188),
    [sym__concat] = ACTIONS(56),
    [anon_sym_PIPE] = ACTIONS(190),
    [anon_sym_SEMI_SEMI] = ACTIONS(190),
    [anon_sym_PIPE_AMP] = ACTIONS(190),
    [anon_sym_AMP_AMP] = ACTIONS(190),
    [anon_sym_PIPE_PIPE] = ACTIONS(190),
    [anon_sym_LT] = ACTIONS(190),
    [anon_sym_GT] = ACTIONS(190),
    [anon_sym_GT_GT] = ACTIONS(190),
    [anon_sym_AMP_GT] = ACTIONS(190),
    [anon_sym_AMP_GT_GT] = ACTIONS(190),
    [anon_sym_LT_AMP] = ACTIONS(190),
    [anon_sym_GT_AMP] = ACTIONS(190),
    [anon_sym_LT_LT] = ACTIONS(190),
    [anon_sym_LT_LT_DASH] = ACTIONS(190),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(190),
    [anon_sym_DOLLAR] = ACTIONS(190),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(190),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(190),
    [anon_sym_BQUOTE] = ACTIONS(190),
    [anon_sym_LT_LPAREN] = ACTIONS(190),
    [anon_sym_GT_LPAREN] = ACTIONS(190),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(190),
    [anon_sym_SEMI] = ACTIONS(190),
    [anon_sym_LF] = ACTIONS(190),
    [anon_sym_AMP] = ACTIONS(190),
  },
  [141] = {
    [sym_file_redirect] = STATE(134),
    [sym_heredoc_redirect] = STATE(134),
    [sym_concatenation] = STATE(135),
    [sym_string] = STATE(130),
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [sym_process_substitution] = STATE(130),
    [aux_sym_for_statement_repeat1] = STATE(352),
    [aux_sym_command_repeat2] = STATE(348),
    [sym_file_descriptor] = ACTIONS(208),
    [sym_word] = ACTIONS(210),
    [anon_sym_PIPE] = ACTIONS(588),
    [anon_sym_SEMI_SEMI] = ACTIONS(588),
    [anon_sym_PIPE_AMP] = ACTIONS(588),
    [anon_sym_AMP_AMP] = ACTIONS(588),
    [anon_sym_PIPE_PIPE] = ACTIONS(588),
    [anon_sym_LT] = ACTIONS(214),
    [anon_sym_GT] = ACTIONS(214),
    [anon_sym_GT_GT] = ACTIONS(214),
    [anon_sym_AMP_GT] = ACTIONS(214),
    [anon_sym_AMP_GT_GT] = ACTIONS(214),
    [anon_sym_LT_AMP] = ACTIONS(214),
    [anon_sym_GT_AMP] = ACTIONS(214),
    [anon_sym_LT_LT] = ACTIONS(216),
    [anon_sym_LT_LT_DASH] = ACTIONS(216),
    [anon_sym_DQUOTE] = ACTIONS(218),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(222),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(224),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(226),
    [anon_sym_BQUOTE] = ACTIONS(228),
    [anon_sym_LT_LPAREN] = ACTIONS(230),
    [anon_sym_GT_LPAREN] = ACTIONS(230),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(232),
    [anon_sym_SEMI] = ACTIONS(588),
    [anon_sym_LF] = ACTIONS(588),
    [anon_sym_AMP] = ACTIONS(588),
  },
  [142] = {
    [sym__assignment] = STATE(351),
    [anon_sym_EQ] = ACTIONS(649),
    [anon_sym_PLUS_EQ] = ACTIONS(649),
    [sym_comment] = ACTIONS(46),
  },
  [143] = {
    [sym_variable_assignment] = STATE(26),
    [sym_subscript] = STATE(142),
    [sym_file_redirect] = STATE(26),
    [aux_sym_command_repeat1] = STATE(143),
    [sym_file_descriptor] = ACTIONS(651),
    [sym_word] = ACTIONS(654),
    [sym_variable_name] = ACTIONS(656),
    [anon_sym_LT] = ACTIONS(659),
    [anon_sym_GT] = ACTIONS(659),
    [anon_sym_GT_GT] = ACTIONS(662),
    [anon_sym_AMP_GT] = ACTIONS(659),
    [anon_sym_AMP_GT_GT] = ACTIONS(662),
    [anon_sym_LT_AMP] = ACTIONS(662),
    [anon_sym_GT_AMP] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(654),
    [sym_raw_string] = ACTIONS(654),
    [anon_sym_DOLLAR] = ACTIONS(665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(654),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(654),
    [anon_sym_BQUOTE] = ACTIONS(654),
    [anon_sym_LT_LPAREN] = ACTIONS(654),
    [anon_sym_GT_LPAREN] = ACTIONS(654),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(665),
  },
  [144] = {
    [aux_sym_concatenation_repeat1] = STATE(225),
    [sym_file_descriptor] = ACTIONS(667),
    [sym_word] = ACTIONS(667),
    [sym__concat] = ACTIONS(374),
    [sym_variable_name] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(669),
    [anon_sym_GT] = ACTIONS(669),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(669),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_DQUOTE] = ACTIONS(667),
    [sym_raw_string] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(669),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(667),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(667),
    [anon_sym_BQUOTE] = ACTIONS(667),
    [anon_sym_LT_LPAREN] = ACTIONS(667),
    [anon_sym_GT_LPAREN] = ACTIONS(667),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(669),
  },
  [145] = {
    [aux_sym_concatenation_repeat1] = STATE(240),
    [sym_file_descriptor] = ACTIONS(671),
    [sym_word] = ACTIONS(671),
    [sym__concat] = ACTIONS(374),
    [sym_variable_name] = ACTIONS(671),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(671),
    [anon_sym_AMP_GT] = ACTIONS(673),
    [anon_sym_AMP_GT_GT] = ACTIONS(671),
    [anon_sym_LT_AMP] = ACTIONS(671),
    [anon_sym_GT_AMP] = ACTIONS(671),
    [anon_sym_DQUOTE] = ACTIONS(671),
    [sym_raw_string] = ACTIONS(671),
    [anon_sym_DOLLAR] = ACTIONS(673),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(671),
    [anon_sym_BQUOTE] = ACTIONS(671),
    [anon_sym_LT_LPAREN] = ACTIONS(671),
    [anon_sym_GT_LPAREN] = ACTIONS(671),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(673),
  },
  [146] = {
    [sym_file_descriptor] = ACTIONS(667),
    [sym_word] = ACTIONS(667),
    [sym_variable_name] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(669),
    [anon_sym_GT] = ACTIONS(669),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(669),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_DQUOTE] = ACTIONS(667),
    [sym_raw_string] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(669),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(667),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(667),
    [anon_sym_BQUOTE] = ACTIONS(667),
    [anon_sym_LT_LPAREN] = ACTIONS(667),
    [anon_sym_GT_LPAREN] = ACTIONS(667),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(669),
  },
  [147] = {
    [sym_file_descriptor] = ACTIONS(675),
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(675),
    [anon_sym_PIPE] = ACTIONS(677),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_SEMI_SEMI] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(677),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(677),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(677),
    [anon_sym_LT_LT_DASH] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(677),
    [sym_raw_string] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [anon_sym_LT_LPAREN] = ACTIONS(677),
    [anon_sym_GT_LPAREN] = ACTIONS(677),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(677),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(677),
  },
  [148] = {
    [sym_file_descriptor] = ACTIONS(679),
    [sym_word] = ACTIONS(679),
    [sym__concat] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_RPAREN] = ACTIONS(681),
    [anon_sym_SEMI_SEMI] = ACTIONS(681),
    [anon_sym_PIPE_AMP] = ACTIONS(681),
    [anon_sym_AMP_AMP] = ACTIONS(681),
    [anon_sym_PIPE_PIPE] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(681),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(681),
    [anon_sym_LT_LT_DASH] = ACTIONS(681),
    [anon_sym_DQUOTE] = ACTIONS(681),
    [sym_raw_string] = ACTIONS(681),
    [anon_sym_DOLLAR] = ACTIONS(681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(681),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(681),
    [anon_sym_BQUOTE] = ACTIONS(681),
    [anon_sym_LT_LPAREN] = ACTIONS(681),
    [anon_sym_GT_LPAREN] = ACTIONS(681),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(681),
    [anon_sym_AMP] = ACTIONS(681),
  },
  [149] = {
    [aux_sym_concatenation_repeat1] = STATE(149),
    [sym_file_descriptor] = ACTIONS(675),
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(677),
    [anon_sym_SEMI_SEMI] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(677),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(677),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(677),
    [anon_sym_LT_LT_DASH] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(677),
    [sym_raw_string] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [anon_sym_LT_LPAREN] = ACTIONS(677),
    [anon_sym_GT_LPAREN] = ACTIONS(677),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(677),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(677),
  },
  [150] = {
    [aux_sym_concatenation_repeat1] = STATE(354),
    [sym_file_descriptor] = ACTIONS(686),
    [sym_word] = ACTIONS(686),
    [sym__concat] = ACTIONS(688),
    [sym_variable_name] = ACTIONS(686),
    [anon_sym_PIPE] = ACTIONS(690),
    [anon_sym_SEMI_SEMI] = ACTIONS(690),
    [anon_sym_PIPE_AMP] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(690),
    [anon_sym_GT] = ACTIONS(690),
    [anon_sym_GT_GT] = ACTIONS(690),
    [anon_sym_AMP_GT] = ACTIONS(690),
    [anon_sym_AMP_GT_GT] = ACTIONS(690),
    [anon_sym_LT_AMP] = ACTIONS(690),
    [anon_sym_GT_AMP] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(690),
    [sym_raw_string] = ACTIONS(690),
    [anon_sym_DOLLAR] = ACTIONS(690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(690),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [anon_sym_LT_LPAREN] = ACTIONS(690),
    [anon_sym_GT_LPAREN] = ACTIONS(690),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(690),
    [anon_sym_SEMI] = ACTIONS(690),
    [anon_sym_LF] = ACTIONS(690),
    [anon_sym_AMP] = ACTIONS(690),
  },
  [151] = {
    [sym_file_descriptor] = ACTIONS(686),
    [sym_word] = ACTIONS(686),
    [sym_variable_name] = ACTIONS(686),
    [anon_sym_PIPE] = ACTIONS(690),
    [anon_sym_RPAREN] = ACTIONS(690),
    [anon_sym_SEMI_SEMI] = ACTIONS(690),
    [anon_sym_PIPE_AMP] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(690),
    [anon_sym_GT] = ACTIONS(690),
    [anon_sym_GT_GT] = ACTIONS(690),
    [anon_sym_AMP_GT] = ACTIONS(690),
    [anon_sym_AMP_GT_GT] = ACTIONS(690),
    [anon_sym_LT_AMP] = ACTIONS(690),
    [anon_sym_GT_AMP] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(690),
    [sym_raw_string] = ACTIONS(690),
    [anon_sym_DOLLAR] = ACTIONS(690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(690),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [anon_sym_LT_LPAREN] = ACTIONS(690),
    [anon_sym_GT_LPAREN] = ACTIONS(690),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(690),
    [anon_sym_SEMI] = ACTIONS(690),
    [anon_sym_LF] = ACTIONS(690),
    [anon_sym_AMP] = ACTIONS(690),
  },
  [152] = {
    [sym_concatenation] = STATE(364),
    [sym_string] = STATE(355),
    [sym_simple_expansion] = STATE(355),
    [sym_expansion] = STATE(355),
    [sym_command_substitution] = STATE(355),
    [sym_process_substitution] = STATE(355),
    [aux_sym_for_statement_repeat1] = STATE(365),
    [sym_word] = ACTIONS(692),
    [anon_sym_RPAREN] = ACTIONS(694),
    [anon_sym_DQUOTE] = ACTIONS(696),
    [sym_raw_string] = ACTIONS(692),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(700),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(702),
    [anon_sym_BQUOTE] = ACTIONS(704),
    [anon_sym_LT_LPAREN] = ACTIONS(706),
    [anon_sym_GT_LPAREN] = ACTIONS(706),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(708),
  },
  [153] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(367),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [154] = {
    [sym_special_variable_name] = STATE(370),
    [anon_sym_DOLLAR] = ACTIONS(712),
    [anon_sym_POUND] = ACTIONS(712),
    [anon_sym_AT] = ACTIONS(712),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(714),
    [anon_sym_STAR] = ACTIONS(712),
    [anon_sym_QMARK] = ACTIONS(712),
    [anon_sym_DASH] = ACTIONS(712),
    [anon_sym_BANG] = ACTIONS(712),
    [anon_sym_0] = ACTIONS(716),
    [anon_sym__] = ACTIONS(716),
  },
  [155] = {
    [sym_special_variable_name] = STATE(373),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(718),
    [anon_sym_AT] = ACTIONS(138),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [156] = {
    [sym_for_statement] = STATE(374),
    [sym_while_statement] = STATE(374),
    [sym_if_statement] = STATE(374),
    [sym_case_statement] = STATE(374),
    [sym_function_definition] = STATE(374),
    [sym_subshell] = STATE(374),
    [sym_pipeline] = STATE(374),
    [sym_list] = STATE(374),
    [sym_command] = STATE(374),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(375),
    [sym_declaration_command] = STATE(374),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [157] = {
    [sym_for_statement] = STATE(376),
    [sym_while_statement] = STATE(376),
    [sym_if_statement] = STATE(376),
    [sym_case_statement] = STATE(376),
    [sym_function_definition] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_pipeline] = STATE(376),
    [sym_list] = STATE(376),
    [sym_command] = STATE(376),
    [sym_command_name] = STATE(118),
    [sym_variable_assignment] = STATE(377),
    [sym_declaration_command] = STATE(376),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(112),
    [sym_simple_expansion] = STATE(112),
    [sym_expansion] = STATE(112),
    [sym_command_substitution] = STATE(112),
    [sym_process_substitution] = STATE(112),
    [aux_sym_command_repeat1] = STATE(121),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(178),
    [sym_variable_name] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(184),
    [anon_sym_typeset] = ACTIONS(184),
    [anon_sym_export] = ACTIONS(184),
    [anon_sym_readonly] = ACTIONS(184),
    [anon_sym_local] = ACTIONS(184),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(178),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(186),
  },
  [158] = {
    [sym_for_statement] = STATE(378),
    [sym_while_statement] = STATE(378),
    [sym_if_statement] = STATE(378),
    [sym_case_statement] = STATE(378),
    [sym_function_definition] = STATE(378),
    [sym_subshell] = STATE(378),
    [sym_pipeline] = STATE(378),
    [sym_list] = STATE(378),
    [sym_command] = STATE(378),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(379),
    [sym_declaration_command] = STATE(378),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [159] = {
    [aux_sym_concatenation_repeat1] = STATE(380),
    [sym_file_descriptor] = ACTIONS(722),
    [sym_word] = ACTIONS(722),
    [sym__concat] = ACTIONS(688),
    [sym_variable_name] = ACTIONS(722),
    [anon_sym_PIPE] = ACTIONS(724),
    [anon_sym_SEMI_SEMI] = ACTIONS(724),
    [anon_sym_PIPE_AMP] = ACTIONS(724),
    [anon_sym_AMP_AMP] = ACTIONS(724),
    [anon_sym_PIPE_PIPE] = ACTIONS(724),
    [anon_sym_LT] = ACTIONS(724),
    [anon_sym_GT] = ACTIONS(724),
    [anon_sym_GT_GT] = ACTIONS(724),
    [anon_sym_AMP_GT] = ACTIONS(724),
    [anon_sym_AMP_GT_GT] = ACTIONS(724),
    [anon_sym_LT_AMP] = ACTIONS(724),
    [anon_sym_GT_AMP] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(724),
    [sym_raw_string] = ACTIONS(724),
    [anon_sym_DOLLAR] = ACTIONS(724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(724),
    [anon_sym_BQUOTE] = ACTIONS(724),
    [anon_sym_LT_LPAREN] = ACTIONS(724),
    [anon_sym_GT_LPAREN] = ACTIONS(724),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(724),
    [anon_sym_LF] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(724),
  },
  [160] = {
    [aux_sym_concatenation_repeat1] = STATE(383),
    [sym__concat] = ACTIONS(726),
    [anon_sym_RBRACK] = ACTIONS(728),
    [sym_comment] = ACTIONS(46),
  },
  [161] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(385),
    [anon_sym_DQUOTE] = ACTIONS(730),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [162] = {
    [sym_special_variable_name] = STATE(388),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [anon_sym_POUND] = ACTIONS(732),
    [anon_sym_AT] = ACTIONS(732),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(734),
    [anon_sym_STAR] = ACTIONS(732),
    [anon_sym_QMARK] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_0] = ACTIONS(736),
    [anon_sym__] = ACTIONS(736),
  },
  [163] = {
    [sym_special_variable_name] = STATE(391),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(138),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(740),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [164] = {
    [sym_for_statement] = STATE(392),
    [sym_while_statement] = STATE(392),
    [sym_if_statement] = STATE(392),
    [sym_case_statement] = STATE(392),
    [sym_function_definition] = STATE(392),
    [sym_subshell] = STATE(392),
    [sym_pipeline] = STATE(392),
    [sym_list] = STATE(392),
    [sym_command] = STATE(392),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(393),
    [sym_declaration_command] = STATE(392),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [165] = {
    [sym_for_statement] = STATE(394),
    [sym_while_statement] = STATE(394),
    [sym_if_statement] = STATE(394),
    [sym_case_statement] = STATE(394),
    [sym_function_definition] = STATE(394),
    [sym_subshell] = STATE(394),
    [sym_pipeline] = STATE(394),
    [sym_list] = STATE(394),
    [sym_command] = STATE(394),
    [sym_command_name] = STATE(118),
    [sym_variable_assignment] = STATE(395),
    [sym_declaration_command] = STATE(394),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(112),
    [sym_simple_expansion] = STATE(112),
    [sym_expansion] = STATE(112),
    [sym_command_substitution] = STATE(112),
    [sym_process_substitution] = STATE(112),
    [aux_sym_command_repeat1] = STATE(121),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(178),
    [sym_variable_name] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(184),
    [anon_sym_typeset] = ACTIONS(184),
    [anon_sym_export] = ACTIONS(184),
    [anon_sym_readonly] = ACTIONS(184),
    [anon_sym_local] = ACTIONS(184),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(178),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(186),
  },
  [166] = {
    [sym_for_statement] = STATE(396),
    [sym_while_statement] = STATE(396),
    [sym_if_statement] = STATE(396),
    [sym_case_statement] = STATE(396),
    [sym_function_definition] = STATE(396),
    [sym_subshell] = STATE(396),
    [sym_pipeline] = STATE(396),
    [sym_list] = STATE(396),
    [sym_command] = STATE(396),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(397),
    [sym_declaration_command] = STATE(396),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [167] = {
    [aux_sym_concatenation_repeat1] = STATE(399),
    [sym__concat] = ACTIONS(726),
    [anon_sym_RBRACK] = ACTIONS(742),
    [sym_comment] = ACTIONS(46),
  },
  [168] = {
    [anon_sym_RBRACK] = ACTIONS(728),
    [sym_comment] = ACTIONS(46),
  },
  [169] = {
    [sym_concatenation] = STATE(408),
    [sym_string] = STATE(400),
    [sym_simple_expansion] = STATE(400),
    [sym_expansion] = STATE(400),
    [sym_command_substitution] = STATE(400),
    [sym_process_substitution] = STATE(400),
    [aux_sym_for_statement_repeat1] = STATE(409),
    [sym_word] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [sym_raw_string] = ACTIONS(744),
    [anon_sym_DOLLAR] = ACTIONS(748),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(750),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(752),
    [anon_sym_BQUOTE] = ACTIONS(754),
    [anon_sym_LT_LPAREN] = ACTIONS(756),
    [anon_sym_GT_LPAREN] = ACTIONS(756),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(758),
  },
  [170] = {
    [sym__terminated_statement] = STATE(411),
    [sym_for_statement] = STATE(412),
    [sym_while_statement] = STATE(412),
    [sym_if_statement] = STATE(412),
    [sym_case_statement] = STATE(412),
    [sym_function_definition] = STATE(412),
    [sym_subshell] = STATE(412),
    [sym_pipeline] = STATE(412),
    [sym_list] = STATE(412),
    [sym_command] = STATE(412),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(413),
    [sym_declaration_command] = STATE(412),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(414),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_done] = ACTIONS(760),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [171] = {
    [anon_sym_PIPE] = ACTIONS(762),
    [anon_sym_RPAREN] = ACTIONS(762),
    [anon_sym_SEMI_SEMI] = ACTIONS(762),
    [anon_sym_PIPE_AMP] = ACTIONS(762),
    [anon_sym_AMP_AMP] = ACTIONS(762),
    [anon_sym_PIPE_PIPE] = ACTIONS(762),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(762),
    [anon_sym_LF] = ACTIONS(762),
    [anon_sym_AMP] = ACTIONS(762),
  },
  [172] = {
    [anon_sym_do] = ACTIONS(546),
    [anon_sym_then] = ACTIONS(546),
    [sym_comment] = ACTIONS(46),
  },
  [173] = {
    [sym__terminated_statement] = STATE(418),
    [sym_for_statement] = STATE(419),
    [sym_while_statement] = STATE(419),
    [sym_if_statement] = STATE(419),
    [sym_elif_clause] = STATE(420),
    [sym_else_clause] = STATE(421),
    [sym_case_statement] = STATE(419),
    [sym_function_definition] = STATE(419),
    [sym_subshell] = STATE(419),
    [sym_pipeline] = STATE(419),
    [sym_list] = STATE(419),
    [sym_command] = STATE(419),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(422),
    [sym_declaration_command] = STATE(419),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(423),
    [aux_sym_if_statement_repeat1] = STATE(424),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(764),
    [anon_sym_elif] = ACTIONS(766),
    [anon_sym_else] = ACTIONS(768),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [174] = {
    [sym_string] = STATE(425),
    [sym_simple_expansion] = STATE(425),
    [sym_expansion] = STATE(425),
    [sym_command_substitution] = STATE(425),
    [sym_process_substitution] = STATE(425),
    [sym_word] = ACTIONS(770),
    [anon_sym_DQUOTE] = ACTIONS(70),
    [sym_raw_string] = ACTIONS(770),
    [anon_sym_DOLLAR] = ACTIONS(72),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(74),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(76),
    [anon_sym_BQUOTE] = ACTIONS(78),
    [anon_sym_LT_LPAREN] = ACTIONS(80),
    [anon_sym_GT_LPAREN] = ACTIONS(80),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(772),
  },
  [175] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(774),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(774),
    [anon_sym_LF] = ACTIONS(774),
    [anon_sym_AMP] = ACTIONS(774),
  },
  [176] = {
    [anon_sym_in] = ACTIONS(776),
    [sym_comment] = ACTIONS(46),
  },
  [177] = {
    [aux_sym_concatenation_repeat1] = STATE(429),
    [sym__concat] = ACTIONS(306),
    [anon_sym_in] = ACTIONS(256),
    [anon_sym_SEMI_SEMI] = ACTIONS(256),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(256),
    [anon_sym_LF] = ACTIONS(256),
    [anon_sym_AMP] = ACTIONS(256),
  },
  [178] = {
    [sym__concat] = ACTIONS(394),
    [anon_sym_in] = ACTIONS(396),
    [anon_sym_SEMI_SEMI] = ACTIONS(396),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(396),
    [anon_sym_LF] = ACTIONS(396),
    [anon_sym_AMP] = ACTIONS(396),
  },
  [179] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(252),
    [anon_sym_DQUOTE] = ACTIONS(778),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [180] = {
    [sym__concat] = ACTIONS(412),
    [anon_sym_in] = ACTIONS(414),
    [anon_sym_SEMI_SEMI] = ACTIONS(414),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(414),
    [anon_sym_LF] = ACTIONS(414),
    [anon_sym_AMP] = ACTIONS(414),
  },
  [181] = {
    [sym__concat] = ACTIONS(416),
    [anon_sym_in] = ACTIONS(418),
    [anon_sym_SEMI_SEMI] = ACTIONS(418),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(418),
    [anon_sym_LF] = ACTIONS(418),
    [anon_sym_AMP] = ACTIONS(418),
  },
  [182] = {
    [sym__concat] = ACTIONS(420),
    [anon_sym_in] = ACTIONS(422),
    [anon_sym_SEMI_SEMI] = ACTIONS(422),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(422),
    [anon_sym_LF] = ACTIONS(422),
    [anon_sym_AMP] = ACTIONS(422),
  },
  [183] = {
    [sym_special_variable_name] = STATE(432),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_EQ] = ACTIONS(412),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(138),
    [anon_sym_AT] = ACTIONS(138),
    [anon_sym_COLON] = ACTIONS(424),
    [anon_sym_COLON_QMARK] = ACTIONS(412),
    [anon_sym_COLON_DASH] = ACTIONS(412),
    [anon_sym_PERCENT] = ACTIONS(412),
    [anon_sym_SLASH] = ACTIONS(412),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(780),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [184] = {
    [anon_sym_RBRACE] = ACTIONS(782),
    [anon_sym_EQ] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(786),
    [anon_sym_COLON] = ACTIONS(788),
    [anon_sym_COLON_QMARK] = ACTIONS(784),
    [anon_sym_COLON_DASH] = ACTIONS(784),
    [anon_sym_PERCENT] = ACTIONS(784),
    [anon_sym_SLASH] = ACTIONS(784),
    [sym_comment] = ACTIONS(46),
  },
  [185] = {
    [anon_sym_RBRACE] = ACTIONS(790),
    [anon_sym_EQ] = ACTIONS(792),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_COLON] = ACTIONS(796),
    [anon_sym_COLON_QMARK] = ACTIONS(792),
    [anon_sym_COLON_DASH] = ACTIONS(792),
    [anon_sym_PERCENT] = ACTIONS(792),
    [anon_sym_SLASH] = ACTIONS(792),
    [sym_comment] = ACTIONS(46),
  },
  [186] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(798),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [187] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(798),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [188] = {
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_comment] = ACTIONS(46),
  },
  [189] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [190] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(800),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [191] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(800),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [192] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(802),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(802),
    [anon_sym_LF] = ACTIONS(802),
    [anon_sym_AMP] = ACTIONS(802),
  },
  [193] = {
    [anon_sym_in] = ACTIONS(804),
    [sym_comment] = ACTIONS(46),
  },
  [194] = {
    [aux_sym_concatenation_repeat1] = STATE(429),
    [sym__concat] = ACTIONS(306),
    [anon_sym_in] = ACTIONS(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [195] = {
    [anon_sym_RPAREN] = ACTIONS(806),
    [sym_comment] = ACTIONS(46),
  },
  [196] = {
    [sym__terminated_statement] = STATE(21),
    [sym_for_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_case_statement] = STATE(22),
    [sym_function_definition] = STATE(22),
    [sym_subshell] = STATE(22),
    [sym_pipeline] = STATE(22),
    [sym_list] = STATE(22),
    [sym_command] = STATE(22),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(24),
    [sym_declaration_command] = STATE(22),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(445),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_RBRACE] = ACTIONS(808),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [197] = {
    [sym_file_redirect] = STATE(448),
    [sym_file_descriptor] = ACTIONS(810),
    [anon_sym_PIPE] = ACTIONS(812),
    [anon_sym_SEMI_SEMI] = ACTIONS(812),
    [anon_sym_PIPE_AMP] = ACTIONS(812),
    [anon_sym_AMP_AMP] = ACTIONS(812),
    [anon_sym_PIPE_PIPE] = ACTIONS(812),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_GT_GT] = ACTIONS(814),
    [anon_sym_AMP_GT] = ACTIONS(814),
    [anon_sym_AMP_GT_GT] = ACTIONS(814),
    [anon_sym_LT_AMP] = ACTIONS(814),
    [anon_sym_GT_AMP] = ACTIONS(814),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(812),
    [anon_sym_LF] = ACTIONS(812),
    [anon_sym_AMP] = ACTIONS(812),
  },
  [198] = {
    [aux_sym_concatenation_repeat1] = STATE(449),
    [sym_file_descriptor] = ACTIONS(254),
    [sym_word] = ACTIONS(254),
    [sym__concat] = ACTIONS(56),
    [anon_sym_PIPE] = ACTIONS(256),
    [anon_sym_RPAREN] = ACTIONS(256),
    [anon_sym_SEMI_SEMI] = ACTIONS(256),
    [anon_sym_PIPE_AMP] = ACTIONS(256),
    [anon_sym_AMP_AMP] = ACTIONS(256),
    [anon_sym_PIPE_PIPE] = ACTIONS(256),
    [anon_sym_LT] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(256),
    [anon_sym_GT_GT] = ACTIONS(256),
    [anon_sym_AMP_GT] = ACTIONS(256),
    [anon_sym_AMP_GT_GT] = ACTIONS(256),
    [anon_sym_LT_AMP] = ACTIONS(256),
    [anon_sym_GT_AMP] = ACTIONS(256),
    [anon_sym_LT_LT] = ACTIONS(256),
    [anon_sym_LT_LT_DASH] = ACTIONS(256),
    [anon_sym_DQUOTE] = ACTIONS(256),
    [sym_raw_string] = ACTIONS(256),
    [anon_sym_DOLLAR] = ACTIONS(256),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(256),
    [anon_sym_BQUOTE] = ACTIONS(256),
    [anon_sym_LT_LPAREN] = ACTIONS(256),
    [anon_sym_GT_LPAREN] = ACTIONS(256),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(256),
    [anon_sym_SEMI] = ACTIONS(256),
    [anon_sym_LF] = ACTIONS(256),
    [anon_sym_AMP] = ACTIONS(256),
  },
  [199] = {
    [sym_concatenation] = STATE(151),
    [sym_string] = STATE(450),
    [sym_array] = STATE(151),
    [sym_simple_expansion] = STATE(450),
    [sym_expansion] = STATE(450),
    [sym_command_substitution] = STATE(450),
    [sym_process_substitution] = STATE(450),
    [sym_word] = ACTIONS(816),
    [sym__empty_value] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(816),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(268),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(270),
    [anon_sym_BQUOTE] = ACTIONS(272),
    [anon_sym_LT_LPAREN] = ACTIONS(274),
    [anon_sym_GT_LPAREN] = ACTIONS(274),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(818),
  },
  [200] = {
    [sym_compound_statement] = STATE(453),
    [anon_sym_LPAREN] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(330),
    [sym_comment] = ACTIONS(46),
  },
  [201] = {
    [sym__assignment] = STATE(222),
    [anon_sym_EQ] = ACTIONS(822),
    [anon_sym_PLUS_EQ] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(64),
    [sym_comment] = ACTIONS(46),
  },
  [202] = {
    [sym__assignment] = STATE(222),
    [anon_sym_EQ] = ACTIONS(822),
    [anon_sym_PLUS_EQ] = ACTIONS(822),
    [sym_comment] = ACTIONS(46),
  },
  [203] = {
    [sym_variable_assignment] = STATE(62),
    [sym_subscript] = STATE(202),
    [aux_sym_declaration_command_repeat1] = STATE(455),
    [sym_word] = ACTIONS(96),
    [sym_variable_name] = ACTIONS(336),
    [anon_sym_PIPE] = ACTIONS(370),
    [anon_sym_RPAREN] = ACTIONS(370),
    [anon_sym_SEMI_SEMI] = ACTIONS(370),
    [anon_sym_PIPE_AMP] = ACTIONS(370),
    [anon_sym_AMP_AMP] = ACTIONS(370),
    [anon_sym_PIPE_PIPE] = ACTIONS(370),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(102),
    [anon_sym_SEMI] = ACTIONS(370),
    [anon_sym_LF] = ACTIONS(370),
    [anon_sym_AMP] = ACTIONS(370),
  },
  [204] = {
    [anon_sym_RPAREN] = ACTIONS(824),
    [sym_comment] = ACTIONS(46),
  },
  [205] = {
    [aux_sym_concatenation_repeat1] = STATE(449),
    [sym_file_descriptor] = ACTIONS(542),
    [sym_word] = ACTIONS(542),
    [sym__concat] = ACTIONS(56),
    [anon_sym_PIPE] = ACTIONS(544),
    [anon_sym_RPAREN] = ACTIONS(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_PIPE_PIPE] = ACTIONS(544),
    [anon_sym_LT] = ACTIONS(544),
    [anon_sym_GT] = ACTIONS(544),
    [anon_sym_GT_GT] = ACTIONS(544),
    [anon_sym_AMP_GT] = ACTIONS(544),
    [anon_sym_AMP_GT_GT] = ACTIONS(544),
    [anon_sym_LT_AMP] = ACTIONS(544),
    [anon_sym_GT_AMP] = ACTIONS(544),
    [anon_sym_LT_LT] = ACTIONS(544),
    [anon_sym_LT_LT_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(544),
    [sym_raw_string] = ACTIONS(544),
    [anon_sym_DOLLAR] = ACTIONS(544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(544),
    [anon_sym_BQUOTE] = ACTIONS(544),
    [anon_sym_LT_LPAREN] = ACTIONS(544),
    [anon_sym_GT_LPAREN] = ACTIONS(544),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(544),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [206] = {
    [sym_for_statement] = STATE(330),
    [sym_while_statement] = STATE(330),
    [sym_if_statement] = STATE(330),
    [sym_case_statement] = STATE(330),
    [sym_function_definition] = STATE(330),
    [sym_subshell] = STATE(330),
    [sym_pipeline] = STATE(330),
    [sym_list] = STATE(330),
    [sym_command] = STATE(330),
    [sym_command_name] = STATE(57),
    [sym_variable_assignment] = STATE(331),
    [sym_declaration_command] = STATE(330),
    [sym_subscript] = STATE(59),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(51),
    [sym_simple_expansion] = STATE(51),
    [sym_expansion] = STATE(51),
    [sym_command_substitution] = STATE(51),
    [sym_process_substitution] = STATE(51),
    [aux_sym_command_repeat1] = STATE(61),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(86),
    [sym_variable_name] = ACTIONS(88),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(90),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(92),
    [anon_sym_typeset] = ACTIONS(92),
    [anon_sym_export] = ACTIONS(92),
    [anon_sym_readonly] = ACTIONS(92),
    [anon_sym_local] = ACTIONS(92),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(86),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(94),
  },
  [207] = {
    [anon_sym_PIPE] = ACTIONS(826),
    [anon_sym_RPAREN] = ACTIONS(826),
    [anon_sym_SEMI_SEMI] = ACTIONS(826),
    [anon_sym_PIPE_AMP] = ACTIONS(826),
    [anon_sym_AMP_AMP] = ACTIONS(826),
    [anon_sym_PIPE_PIPE] = ACTIONS(826),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(826),
    [anon_sym_LF] = ACTIONS(826),
    [anon_sym_AMP] = ACTIONS(826),
  },
  [208] = {
    [sym_file_descriptor] = ACTIONS(546),
    [sym_word] = ACTIONS(546),
    [sym_variable_name] = ACTIONS(546),
    [anon_sym_for] = ACTIONS(548),
    [anon_sym_while] = ACTIONS(548),
    [anon_sym_if] = ACTIONS(548),
    [anon_sym_case] = ACTIONS(548),
    [anon_sym_RPAREN] = ACTIONS(828),
    [anon_sym_function] = ACTIONS(548),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeset] = ACTIONS(548),
    [anon_sym_export] = ACTIONS(548),
    [anon_sym_readonly] = ACTIONS(548),
    [anon_sym_local] = ACTIONS(548),
    [anon_sym_LT] = ACTIONS(548),
    [anon_sym_GT] = ACTIONS(548),
    [anon_sym_GT_GT] = ACTIONS(546),
    [anon_sym_AMP_GT] = ACTIONS(548),
    [anon_sym_AMP_GT_GT] = ACTIONS(546),
    [anon_sym_LT_AMP] = ACTIONS(546),
    [anon_sym_GT_AMP] = ACTIONS(546),
    [anon_sym_DQUOTE] = ACTIONS(546),
    [sym_raw_string] = ACTIONS(546),
    [anon_sym_DOLLAR] = ACTIONS(548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(546),
    [anon_sym_LT_LPAREN] = ACTIONS(546),
    [anon_sym_GT_LPAREN] = ACTIONS(546),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(550),
  },
  [209] = {
    [sym_for_statement] = STATE(458),
    [sym_while_statement] = STATE(458),
    [sym_if_statement] = STATE(458),
    [sym_case_statement] = STATE(458),
    [sym_function_definition] = STATE(458),
    [sym_subshell] = STATE(458),
    [sym_pipeline] = STATE(458),
    [sym_list] = STATE(458),
    [sym_command] = STATE(458),
    [sym_command_name] = STATE(57),
    [sym_variable_assignment] = STATE(459),
    [sym_declaration_command] = STATE(458),
    [sym_subscript] = STATE(59),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(51),
    [sym_simple_expansion] = STATE(51),
    [sym_expansion] = STATE(51),
    [sym_command_substitution] = STATE(51),
    [sym_process_substitution] = STATE(51),
    [aux_sym_command_repeat1] = STATE(61),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(86),
    [sym_variable_name] = ACTIONS(88),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(90),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(92),
    [anon_sym_typeset] = ACTIONS(92),
    [anon_sym_export] = ACTIONS(92),
    [anon_sym_readonly] = ACTIONS(92),
    [anon_sym_local] = ACTIONS(92),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(86),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(94),
  },
  [210] = {
    [anon_sym_LT] = ACTIONS(830),
    [anon_sym_GT] = ACTIONS(830),
    [anon_sym_GT_GT] = ACTIONS(832),
    [anon_sym_AMP_GT] = ACTIONS(830),
    [anon_sym_AMP_GT_GT] = ACTIONS(832),
    [anon_sym_LT_AMP] = ACTIONS(832),
    [anon_sym_GT_AMP] = ACTIONS(832),
    [sym_comment] = ACTIONS(46),
  },
  [211] = {
    [aux_sym_concatenation_repeat1] = STATE(198),
    [sym_file_descriptor] = ACTIONS(556),
    [sym_word] = ACTIONS(556),
    [sym__concat] = ACTIONS(56),
    [anon_sym_PIPE] = ACTIONS(558),
    [anon_sym_RPAREN] = ACTIONS(558),
    [anon_sym_SEMI_SEMI] = ACTIONS(558),
    [anon_sym_PIPE_AMP] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(558),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(558),
    [anon_sym_GT_GT] = ACTIONS(558),
    [anon_sym_AMP_GT] = ACTIONS(558),
    [anon_sym_AMP_GT_GT] = ACTIONS(558),
    [anon_sym_LT_AMP] = ACTIONS(558),
    [anon_sym_GT_AMP] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(558),
    [anon_sym_LT_LT_DASH] = ACTIONS(558),
    [anon_sym_DQUOTE] = ACTIONS(558),
    [sym_raw_string] = ACTIONS(558),
    [anon_sym_DOLLAR] = ACTIONS(558),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(558),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(558),
    [anon_sym_BQUOTE] = ACTIONS(558),
    [anon_sym_LT_LPAREN] = ACTIONS(558),
    [anon_sym_GT_LPAREN] = ACTIONS(558),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(558),
    [anon_sym_SEMI] = ACTIONS(558),
    [anon_sym_LF] = ACTIONS(558),
    [anon_sym_AMP] = ACTIONS(558),
  },
  [212] = {
    [sym_concatenation] = STATE(343),
    [sym_string] = STATE(461),
    [sym_simple_expansion] = STATE(461),
    [sym_expansion] = STATE(461),
    [sym_command_substitution] = STATE(461),
    [sym_process_substitution] = STATE(461),
    [sym_word] = ACTIONS(834),
    [anon_sym_DQUOTE] = ACTIONS(562),
    [sym_raw_string] = ACTIONS(834),
    [anon_sym_DOLLAR] = ACTIONS(564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(566),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(568),
    [anon_sym_BQUOTE] = ACTIONS(570),
    [anon_sym_LT_LPAREN] = ACTIONS(572),
    [anon_sym_GT_LPAREN] = ACTIONS(572),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(836),
  },
  [213] = {
    [aux_sym_concatenation_repeat1] = STATE(205),
    [sym_file_descriptor] = ACTIONS(580),
    [sym_word] = ACTIONS(580),
    [sym__concat] = ACTIONS(56),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_RPAREN] = ACTIONS(582),
    [anon_sym_SEMI_SEMI] = ACTIONS(582),
    [anon_sym_PIPE_AMP] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(582),
    [anon_sym_GT] = ACTIONS(582),
    [anon_sym_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_GT] = ACTIONS(582),
    [anon_sym_AMP_GT_GT] = ACTIONS(582),
    [anon_sym_LT_AMP] = ACTIONS(582),
    [anon_sym_GT_AMP] = ACTIONS(582),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_LT_LT_DASH] = ACTIONS(582),
    [anon_sym_DQUOTE] = ACTIONS(582),
    [sym_raw_string] = ACTIONS(582),
    [anon_sym_DOLLAR] = ACTIONS(582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(582),
    [anon_sym_BQUOTE] = ACTIONS(582),
    [anon_sym_LT_LPAREN] = ACTIONS(582),
    [anon_sym_GT_LPAREN] = ACTIONS(582),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(582),
    [anon_sym_LF] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(582),
  },
  [214] = {
    [sym_file_redirect] = STATE(134),
    [sym_heredoc_redirect] = STATE(134),
    [sym_concatenation] = STATE(135),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym_for_statement_repeat1] = STATE(463),
    [aux_sym_command_repeat2] = STATE(464),
    [sym_file_descriptor] = ACTIONS(348),
    [sym_word] = ACTIONS(350),
    [anon_sym_PIPE] = ACTIONS(588),
    [anon_sym_RPAREN] = ACTIONS(588),
    [anon_sym_SEMI_SEMI] = ACTIONS(588),
    [anon_sym_PIPE_AMP] = ACTIONS(588),
    [anon_sym_AMP_AMP] = ACTIONS(588),
    [anon_sym_PIPE_PIPE] = ACTIONS(588),
    [anon_sym_LT] = ACTIONS(352),
    [anon_sym_GT] = ACTIONS(352),
    [anon_sym_GT_GT] = ACTIONS(352),
    [anon_sym_AMP_GT] = ACTIONS(352),
    [anon_sym_AMP_GT_GT] = ACTIONS(352),
    [anon_sym_LT_AMP] = ACTIONS(352),
    [anon_sym_GT_AMP] = ACTIONS(352),
    [anon_sym_LT_LT] = ACTIONS(216),
    [anon_sym_LT_LT_DASH] = ACTIONS(216),
    [anon_sym_DQUOTE] = ACTIONS(218),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(222),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(224),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(226),
    [anon_sym_BQUOTE] = ACTIONS(228),
    [anon_sym_LT_LPAREN] = ACTIONS(230),
    [anon_sym_GT_LPAREN] = ACTIONS(230),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(588),
    [anon_sym_LF] = ACTIONS(588),
    [anon_sym_AMP] = ACTIONS(588),
  },
  [215] = {
    [sym_file_redirect] = STATE(134),
    [sym_heredoc_redirect] = STATE(134),
    [aux_sym_command_repeat2] = STATE(465),
    [sym_file_descriptor] = ACTIONS(348),
    [anon_sym_PIPE] = ACTIONS(588),
    [anon_sym_RPAREN] = ACTIONS(588),
    [anon_sym_SEMI_SEMI] = ACTIONS(588),
    [anon_sym_PIPE_AMP] = ACTIONS(588),
    [anon_sym_AMP_AMP] = ACTIONS(588),
    [anon_sym_PIPE_PIPE] = ACTIONS(588),
    [anon_sym_LT] = ACTIONS(352),
    [anon_sym_GT] = ACTIONS(352),
    [anon_sym_GT_GT] = ACTIONS(352),
    [anon_sym_AMP_GT] = ACTIONS(352),
    [anon_sym_AMP_GT_GT] = ACTIONS(352),
    [anon_sym_LT_AMP] = ACTIONS(352),
    [anon_sym_GT_AMP] = ACTIONS(352),
    [anon_sym_LT_LT] = ACTIONS(216),
    [anon_sym_LT_LT_DASH] = ACTIONS(216),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(588),
    [anon_sym_LF] = ACTIONS(588),
    [anon_sym_AMP] = ACTIONS(588),
  },
  [216] = {
    [anon_sym_PIPE] = ACTIONS(340),
    [anon_sym_RPAREN] = ACTIONS(838),
    [anon_sym_SEMI_SEMI] = ACTIONS(840),
    [anon_sym_PIPE_AMP] = ACTIONS(340),
    [anon_sym_AMP_AMP] = ACTIONS(346),
    [anon_sym_PIPE_PIPE] = ACTIONS(346),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(840),
    [anon_sym_LF] = ACTIONS(840),
    [anon_sym_AMP] = ACTIONS(840),
  },
  [217] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(340),
    [anon_sym_RPAREN] = ACTIONS(838),
    [anon_sym_SEMI_SEMI] = ACTIONS(840),
    [anon_sym_PIPE_AMP] = ACTIONS(340),
    [anon_sym_AMP_AMP] = ACTIONS(346),
    [anon_sym_PIPE_PIPE] = ACTIONS(346),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(236),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(236),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_DQUOTE] = ACTIONS(236),
    [sym_raw_string] = ACTIONS(236),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(236),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(236),
    [anon_sym_BQUOTE] = ACTIONS(236),
    [anon_sym_LT_LPAREN] = ACTIONS(236),
    [anon_sym_GT_LPAREN] = ACTIONS(236),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(840),
    [anon_sym_LF] = ACTIONS(840),
    [anon_sym_AMP] = ACTIONS(840),
  },
  [218] = {
    [sym__terminated_statement] = STATE(21),
    [sym_for_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_case_statement] = STATE(22),
    [sym_function_definition] = STATE(22),
    [sym_subshell] = STATE(22),
    [sym_pipeline] = STATE(22),
    [sym_list] = STATE(22),
    [sym_command] = STATE(22),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(24),
    [sym_declaration_command] = STATE(22),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(590),
    [sym_word] = ACTIONS(593),
    [sym_variable_name] = ACTIONS(596),
    [anon_sym_for] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(604),
    [anon_sym_if] = ACTIONS(607),
    [anon_sym_case] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(619),
    [anon_sym_typeset] = ACTIONS(619),
    [anon_sym_export] = ACTIONS(619),
    [anon_sym_readonly] = ACTIONS(619),
    [anon_sym_local] = ACTIONS(619),
    [anon_sym_LT] = ACTIONS(622),
    [anon_sym_GT] = ACTIONS(622),
    [anon_sym_GT_GT] = ACTIONS(625),
    [anon_sym_AMP_GT] = ACTIONS(622),
    [anon_sym_AMP_GT_GT] = ACTIONS(625),
    [anon_sym_LT_AMP] = ACTIONS(625),
    [anon_sym_GT_AMP] = ACTIONS(625),
    [anon_sym_DQUOTE] = ACTIONS(628),
    [sym_raw_string] = ACTIONS(593),
    [anon_sym_DOLLAR] = ACTIONS(631),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(634),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(637),
    [anon_sym_BQUOTE] = ACTIONS(640),
    [anon_sym_LT_LPAREN] = ACTIONS(643),
    [anon_sym_GT_LPAREN] = ACTIONS(643),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(646),
  },
  [219] = {
    [aux_sym_concatenation_repeat1] = STATE(205),
    [sym_file_descriptor] = ACTIONS(188),
    [sym_word] = ACTIONS(188),
    [sym__concat] = ACTIONS(56),
    [anon_sym_PIPE] = ACTIONS(190),
    [anon_sym_RPAREN] = ACTIONS(190),
    [anon_sym_SEMI_SEMI] = ACTIONS(190),
    [anon_sym_PIPE_AMP] = ACTIONS(190),
    [anon_sym_AMP_AMP] = ACTIONS(190),
    [anon_sym_PIPE_PIPE] = ACTIONS(190),
    [anon_sym_LT] = ACTIONS(190),
    [anon_sym_GT] = ACTIONS(190),
    [anon_sym_GT_GT] = ACTIONS(190),
    [anon_sym_AMP_GT] = ACTIONS(190),
    [anon_sym_AMP_GT_GT] = ACTIONS(190),
    [anon_sym_LT_AMP] = ACTIONS(190),
    [anon_sym_GT_AMP] = ACTIONS(190),
    [anon_sym_LT_LT] = ACTIONS(190),
    [anon_sym_LT_LT_DASH] = ACTIONS(190),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(190),
    [anon_sym_DOLLAR] = ACTIONS(190),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(190),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(190),
    [anon_sym_BQUOTE] = ACTIONS(190),
    [anon_sym_LT_LPAREN] = ACTIONS(190),
    [anon_sym_GT_LPAREN] = ACTIONS(190),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(190),
    [anon_sym_SEMI] = ACTIONS(190),
    [anon_sym_LF] = ACTIONS(190),
    [anon_sym_AMP] = ACTIONS(190),
  },
  [220] = {
    [sym_file_redirect] = STATE(134),
    [sym_heredoc_redirect] = STATE(134),
    [sym_concatenation] = STATE(135),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym_for_statement_repeat1] = STATE(467),
    [aux_sym_command_repeat2] = STATE(464),
    [sym_file_descriptor] = ACTIONS(348),
    [sym_word] = ACTIONS(350),
    [anon_sym_PIPE] = ACTIONS(588),
    [anon_sym_RPAREN] = ACTIONS(588),
    [anon_sym_SEMI_SEMI] = ACTIONS(588),
    [anon_sym_PIPE_AMP] = ACTIONS(588),
    [anon_sym_AMP_AMP] = ACTIONS(588),
    [anon_sym_PIPE_PIPE] = ACTIONS(588),
    [anon_sym_LT] = ACTIONS(352),
    [anon_sym_GT] = ACTIONS(352),
    [anon_sym_GT_GT] = ACTIONS(352),
    [anon_sym_AMP_GT] = ACTIONS(352),
    [anon_sym_AMP_GT_GT] = ACTIONS(352),
    [anon_sym_LT_AMP] = ACTIONS(352),
    [anon_sym_GT_AMP] = ACTIONS(352),
    [anon_sym_LT_LT] = ACTIONS(216),
    [anon_sym_LT_LT_DASH] = ACTIONS(216),
    [anon_sym_DQUOTE] = ACTIONS(218),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(222),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(224),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(226),
    [anon_sym_BQUOTE] = ACTIONS(228),
    [anon_sym_LT_LPAREN] = ACTIONS(230),
    [anon_sym_GT_LPAREN] = ACTIONS(230),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(588),
    [anon_sym_LF] = ACTIONS(588),
    [anon_sym_AMP] = ACTIONS(588),
  },
  [221] = {
    [sym_concatenation] = STATE(469),
    [sym_string] = STATE(468),
    [sym_array] = STATE(469),
    [sym_simple_expansion] = STATE(468),
    [sym_expansion] = STATE(468),
    [sym_command_substitution] = STATE(468),
    [sym_process_substitution] = STATE(468),
    [sym_word] = ACTIONS(842),
    [sym__empty_value] = ACTIONS(844),
    [anon_sym_LPAREN] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_raw_string] = ACTIONS(842),
    [anon_sym_DOLLAR] = ACTIONS(850),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(852),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(854),
    [anon_sym_BQUOTE] = ACTIONS(856),
    [anon_sym_LT_LPAREN] = ACTIONS(858),
    [anon_sym_GT_LPAREN] = ACTIONS(858),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(860),
  },
  [222] = {
    [sym_word] = ACTIONS(294),
    [sym_variable_name] = ACTIONS(294),
    [anon_sym_PIPE] = ACTIONS(296),
    [anon_sym_RPAREN] = ACTIONS(296),
    [anon_sym_SEMI_SEMI] = ACTIONS(296),
    [anon_sym_PIPE_AMP] = ACTIONS(296),
    [anon_sym_AMP_AMP] = ACTIONS(296),
    [anon_sym_PIPE_PIPE] = ACTIONS(296),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(296),
    [anon_sym_SEMI] = ACTIONS(296),
    [anon_sym_LF] = ACTIONS(296),
    [anon_sym_AMP] = ACTIONS(296),
  },
  [223] = {
    [sym_variable_assignment] = STATE(62),
    [sym_subscript] = STATE(65),
    [aux_sym_declaration_command_repeat1] = STATE(223),
    [sym_word] = ACTIONS(862),
    [sym_variable_name] = ACTIONS(865),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_SEMI_SEMI] = ACTIONS(868),
    [anon_sym_PIPE_AMP] = ACTIONS(868),
    [anon_sym_AMP_AMP] = ACTIONS(868),
    [anon_sym_PIPE_PIPE] = ACTIONS(868),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(870),
    [anon_sym_SEMI] = ACTIONS(868),
    [anon_sym_LF] = ACTIONS(868),
    [anon_sym_AMP] = ACTIONS(868),
  },
  [224] = {
    [sym_string] = STATE(478),
    [sym_simple_expansion] = STATE(478),
    [sym_expansion] = STATE(478),
    [sym_command_substitution] = STATE(478),
    [sym_process_substitution] = STATE(478),
    [sym_word] = ACTIONS(873),
    [anon_sym_DQUOTE] = ACTIONS(106),
    [sym_raw_string] = ACTIONS(873),
    [anon_sym_DOLLAR] = ACTIONS(108),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(110),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(112),
    [anon_sym_BQUOTE] = ACTIONS(114),
    [anon_sym_LT_LPAREN] = ACTIONS(116),
    [anon_sym_GT_LPAREN] = ACTIONS(116),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(875),
  },
  [225] = {
    [aux_sym_concatenation_repeat1] = STATE(480),
    [sym_file_descriptor] = ACTIONS(254),
    [sym_word] = ACTIONS(254),
    [sym__concat] = ACTIONS(374),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(877),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(877),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(877),
  },
  [226] = {
    [sym_file_descriptor] = ACTIONS(394),
    [sym_word] = ACTIONS(394),
    [sym__concat] = ACTIONS(394),
    [sym_variable_name] = ACTIONS(394),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_GT_GT] = ACTIONS(394),
    [anon_sym_AMP_GT] = ACTIONS(879),
    [anon_sym_AMP_GT_GT] = ACTIONS(394),
    [anon_sym_LT_AMP] = ACTIONS(394),
    [anon_sym_GT_AMP] = ACTIONS(394),
    [anon_sym_DQUOTE] = ACTIONS(394),
    [sym_raw_string] = ACTIONS(394),
    [anon_sym_DOLLAR] = ACTIONS(879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(394),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(394),
    [anon_sym_BQUOTE] = ACTIONS(394),
    [anon_sym_LT_LPAREN] = ACTIONS(394),
    [anon_sym_GT_LPAREN] = ACTIONS(394),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(879),
  },
  [227] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(252),
    [anon_sym_DQUOTE] = ACTIONS(881),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [228] = {
    [sym_file_descriptor] = ACTIONS(412),
    [sym_word] = ACTIONS(412),
    [sym__concat] = ACTIONS(412),
    [sym_variable_name] = ACTIONS(412),
    [anon_sym_LT] = ACTIONS(424),
    [anon_sym_GT] = ACTIONS(424),
    [anon_sym_GT_GT] = ACTIONS(412),
    [anon_sym_AMP_GT] = ACTIONS(424),
    [anon_sym_AMP_GT_GT] = ACTIONS(412),
    [anon_sym_LT_AMP] = ACTIONS(412),
    [anon_sym_GT_AMP] = ACTIONS(412),
    [anon_sym_DQUOTE] = ACTIONS(412),
    [sym_raw_string] = ACTIONS(412),
    [anon_sym_DOLLAR] = ACTIONS(424),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(412),
    [anon_sym_BQUOTE] = ACTIONS(412),
    [anon_sym_LT_LPAREN] = ACTIONS(412),
    [anon_sym_GT_LPAREN] = ACTIONS(412),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(424),
  },
  [229] = {
    [sym_file_descriptor] = ACTIONS(416),
    [sym_word] = ACTIONS(416),
    [sym__concat] = ACTIONS(416),
    [sym_variable_name] = ACTIONS(416),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(416),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_AMP_GT_GT] = ACTIONS(416),
    [anon_sym_LT_AMP] = ACTIONS(416),
    [anon_sym_GT_AMP] = ACTIONS(416),
    [anon_sym_DQUOTE] = ACTIONS(416),
    [sym_raw_string] = ACTIONS(416),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(416),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(416),
    [anon_sym_BQUOTE] = ACTIONS(416),
    [anon_sym_LT_LPAREN] = ACTIONS(416),
    [anon_sym_GT_LPAREN] = ACTIONS(416),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(883),
  },
  [230] = {
    [sym_file_descriptor] = ACTIONS(420),
    [sym_word] = ACTIONS(420),
    [sym__concat] = ACTIONS(420),
    [sym_variable_name] = ACTIONS(420),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(420),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(420),
    [anon_sym_LT_AMP] = ACTIONS(420),
    [anon_sym_GT_AMP] = ACTIONS(420),
    [anon_sym_DQUOTE] = ACTIONS(420),
    [sym_raw_string] = ACTIONS(420),
    [anon_sym_DOLLAR] = ACTIONS(885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(420),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(420),
    [anon_sym_BQUOTE] = ACTIONS(420),
    [anon_sym_LT_LPAREN] = ACTIONS(420),
    [anon_sym_GT_LPAREN] = ACTIONS(420),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(885),
  },
  [231] = {
    [sym_special_variable_name] = STATE(483),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_EQ] = ACTIONS(412),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(138),
    [anon_sym_AT] = ACTIONS(138),
    [anon_sym_COLON] = ACTIONS(424),
    [anon_sym_COLON_QMARK] = ACTIONS(412),
    [anon_sym_COLON_DASH] = ACTIONS(412),
    [anon_sym_PERCENT] = ACTIONS(412),
    [anon_sym_SLASH] = ACTIONS(412),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [232] = {
    [anon_sym_RBRACE] = ACTIONS(889),
    [anon_sym_EQ] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(895),
    [anon_sym_COLON_QMARK] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(891),
    [anon_sym_SLASH] = ACTIONS(891),
    [sym_comment] = ACTIONS(46),
  },
  [233] = {
    [anon_sym_RBRACE] = ACTIONS(897),
    [anon_sym_EQ] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(901),
    [anon_sym_COLON] = ACTIONS(903),
    [anon_sym_COLON_QMARK] = ACTIONS(899),
    [anon_sym_COLON_DASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_SLASH] = ACTIONS(899),
    [sym_comment] = ACTIONS(46),
  },
  [234] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [235] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [236] = {
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [sym_comment] = ACTIONS(46),
  },
  [237] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [238] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(907),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [239] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(907),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [240] = {
    [aux_sym_concatenation_repeat1] = STATE(480),
    [sym_file_descriptor] = ACTIONS(542),
    [sym_word] = ACTIONS(542),
    [sym__concat] = ACTIONS(374),
    [sym_variable_name] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(909),
    [anon_sym_GT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(542),
    [anon_sym_AMP_GT] = ACTIONS(909),
    [anon_sym_AMP_GT_GT] = ACTIONS(542),
    [anon_sym_LT_AMP] = ACTIONS(542),
    [anon_sym_GT_AMP] = ACTIONS(542),
    [anon_sym_DQUOTE] = ACTIONS(542),
    [sym_raw_string] = ACTIONS(542),
    [anon_sym_DOLLAR] = ACTIONS(909),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(542),
    [anon_sym_BQUOTE] = ACTIONS(542),
    [anon_sym_LT_LPAREN] = ACTIONS(542),
    [anon_sym_GT_LPAREN] = ACTIONS(542),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(909),
  },
  [241] = {
    [anon_sym_DQUOTE] = ACTIONS(414),
    [sym__string_content] = ACTIONS(414),
    [anon_sym_DOLLAR] = ACTIONS(414),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(414),
    [anon_sym_BQUOTE] = ACTIONS(414),
    [sym_comment] = ACTIONS(60),
  },
  [242] = {
    [anon_sym_DQUOTE] = ACTIONS(418),
    [sym__string_content] = ACTIONS(418),
    [anon_sym_DOLLAR] = ACTIONS(418),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(418),
    [anon_sym_BQUOTE] = ACTIONS(418),
    [sym_comment] = ACTIONS(60),
  },
  [243] = {
    [anon_sym_DQUOTE] = ACTIONS(422),
    [sym__string_content] = ACTIONS(422),
    [anon_sym_DOLLAR] = ACTIONS(422),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(422),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(422),
    [anon_sym_BQUOTE] = ACTIONS(422),
    [sym_comment] = ACTIONS(60),
  },
  [244] = {
    [sym_special_variable_name] = STATE(493),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_EQ] = ACTIONS(412),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(138),
    [anon_sym_AT] = ACTIONS(138),
    [anon_sym_COLON] = ACTIONS(424),
    [anon_sym_COLON_QMARK] = ACTIONS(412),
    [anon_sym_COLON_DASH] = ACTIONS(412),
    [anon_sym_PERCENT] = ACTIONS(412),
    [anon_sym_SLASH] = ACTIONS(412),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [245] = {
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(917),
    [anon_sym_COLON] = ACTIONS(919),
    [anon_sym_COLON_QMARK] = ACTIONS(915),
    [anon_sym_COLON_DASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_SLASH] = ACTIONS(915),
    [sym_comment] = ACTIONS(46),
  },
  [246] = {
    [anon_sym_RBRACE] = ACTIONS(921),
    [anon_sym_EQ] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(925),
    [anon_sym_COLON] = ACTIONS(927),
    [anon_sym_COLON_QMARK] = ACTIONS(923),
    [anon_sym_COLON_DASH] = ACTIONS(923),
    [anon_sym_PERCENT] = ACTIONS(923),
    [anon_sym_SLASH] = ACTIONS(923),
    [sym_comment] = ACTIONS(46),
  },
  [247] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(929),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [248] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(929),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [249] = {
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_BQUOTE] = ACTIONS(929),
    [sym_comment] = ACTIONS(46),
  },
  [250] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(929),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [251] = {
    [sym_file_descriptor] = ACTIONS(931),
    [sym_word] = ACTIONS(931),
    [sym__concat] = ACTIONS(931),
    [anon_sym_PIPE] = ACTIONS(933),
    [anon_sym_RPAREN] = ACTIONS(933),
    [anon_sym_SEMI_SEMI] = ACTIONS(933),
    [anon_sym_PIPE_AMP] = ACTIONS(933),
    [anon_sym_AMP_AMP] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(933),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(933),
    [anon_sym_AMP_GT] = ACTIONS(933),
    [anon_sym_AMP_GT_GT] = ACTIONS(933),
    [anon_sym_LT_AMP] = ACTIONS(933),
    [anon_sym_GT_AMP] = ACTIONS(933),
    [anon_sym_LT_LT] = ACTIONS(933),
    [anon_sym_LT_LT_DASH] = ACTIONS(933),
    [anon_sym_DQUOTE] = ACTIONS(933),
    [sym_raw_string] = ACTIONS(933),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(933),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(933),
    [anon_sym_BQUOTE] = ACTIONS(933),
    [anon_sym_LT_LPAREN] = ACTIONS(933),
    [anon_sym_GT_LPAREN] = ACTIONS(933),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(933),
    [anon_sym_SEMI] = ACTIONS(933),
    [anon_sym_LF] = ACTIONS(933),
    [anon_sym_AMP] = ACTIONS(933),
  },
  [252] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(252),
    [anon_sym_DQUOTE] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [anon_sym_DOLLAR] = ACTIONS(940),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(943),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(946),
    [anon_sym_BQUOTE] = ACTIONS(949),
    [sym_comment] = ACTIONS(60),
  },
  [253] = {
    [anon_sym_RBRACE] = ACTIONS(952),
    [anon_sym_LBRACK] = ACTIONS(954),
    [sym_comment] = ACTIONS(46),
  },
  [254] = {
    [anon_sym_RBRACE] = ACTIONS(956),
    [anon_sym_LBRACK] = ACTIONS(958),
    [sym_comment] = ACTIONS(46),
  },
  [255] = {
    [sym_file_descriptor] = ACTIONS(960),
    [sym_word] = ACTIONS(960),
    [sym__concat] = ACTIONS(960),
    [anon_sym_PIPE] = ACTIONS(962),
    [anon_sym_RPAREN] = ACTIONS(962),
    [anon_sym_SEMI_SEMI] = ACTIONS(962),
    [anon_sym_PIPE_AMP] = ACTIONS(962),
    [anon_sym_AMP_AMP] = ACTIONS(962),
    [anon_sym_PIPE_PIPE] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(962),
    [anon_sym_GT] = ACTIONS(962),
    [anon_sym_GT_GT] = ACTIONS(962),
    [anon_sym_AMP_GT] = ACTIONS(962),
    [anon_sym_AMP_GT_GT] = ACTIONS(962),
    [anon_sym_LT_AMP] = ACTIONS(962),
    [anon_sym_GT_AMP] = ACTIONS(962),
    [anon_sym_LT_LT] = ACTIONS(962),
    [anon_sym_LT_LT_DASH] = ACTIONS(962),
    [anon_sym_DQUOTE] = ACTIONS(962),
    [sym_raw_string] = ACTIONS(962),
    [anon_sym_DOLLAR] = ACTIONS(962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(962),
    [anon_sym_BQUOTE] = ACTIONS(962),
    [anon_sym_LT_LPAREN] = ACTIONS(962),
    [anon_sym_GT_LPAREN] = ACTIONS(962),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(962),
    [anon_sym_SEMI] = ACTIONS(962),
    [anon_sym_LF] = ACTIONS(962),
    [anon_sym_AMP] = ACTIONS(962),
  },
  [256] = {
    [sym_concatenation] = STATE(508),
    [sym_string] = STATE(505),
    [sym_simple_expansion] = STATE(505),
    [sym_expansion] = STATE(505),
    [sym_command_substitution] = STATE(505),
    [sym_process_substitution] = STATE(505),
    [sym_word] = ACTIONS(964),
    [anon_sym_RBRACE] = ACTIONS(966),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(964),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(968),
  },
  [257] = {
    [anon_sym_AT] = ACTIONS(970),
    [sym_comment] = ACTIONS(46),
  },
  [258] = {
    [sym_file_descriptor] = ACTIONS(972),
    [sym_word] = ACTIONS(972),
    [sym__concat] = ACTIONS(972),
    [anon_sym_PIPE] = ACTIONS(974),
    [anon_sym_RPAREN] = ACTIONS(974),
    [anon_sym_SEMI_SEMI] = ACTIONS(974),
    [anon_sym_PIPE_AMP] = ACTIONS(974),
    [anon_sym_AMP_AMP] = ACTIONS(974),
    [anon_sym_PIPE_PIPE] = ACTIONS(974),
    [anon_sym_LT] = ACTIONS(974),
    [anon_sym_GT] = ACTIONS(974),
    [anon_sym_GT_GT] = ACTIONS(974),
    [anon_sym_AMP_GT] = ACTIONS(974),
    [anon_sym_AMP_GT_GT] = ACTIONS(974),
    [anon_sym_LT_AMP] = ACTIONS(974),
    [anon_sym_GT_AMP] = ACTIONS(974),
    [anon_sym_LT_LT] = ACTIONS(974),
    [anon_sym_LT_LT_DASH] = ACTIONS(974),
    [anon_sym_DQUOTE] = ACTIONS(974),
    [sym_raw_string] = ACTIONS(974),
    [anon_sym_DOLLAR] = ACTIONS(974),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(974),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(974),
    [anon_sym_BQUOTE] = ACTIONS(974),
    [anon_sym_LT_LPAREN] = ACTIONS(974),
    [anon_sym_GT_LPAREN] = ACTIONS(974),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(974),
    [anon_sym_SEMI] = ACTIONS(974),
    [anon_sym_LF] = ACTIONS(974),
    [anon_sym_AMP] = ACTIONS(974),
  },
  [259] = {
    [sym_concatenation] = STATE(512),
    [sym_string] = STATE(510),
    [sym_simple_expansion] = STATE(510),
    [sym_expansion] = STATE(510),
    [sym_command_substitution] = STATE(510),
    [sym_process_substitution] = STATE(510),
    [sym_word] = ACTIONS(976),
    [anon_sym_RBRACE] = ACTIONS(956),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(976),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(978),
  },
  [260] = {
    [anon_sym_AT] = ACTIONS(980),
    [sym_comment] = ACTIONS(46),
  },
  [261] = {
    [sym_string] = STATE(514),
    [sym_simple_expansion] = STATE(514),
    [sym_expansion] = STATE(514),
    [sym_command_substitution] = STATE(514),
    [sym_process_substitution] = STATE(514),
    [sym_word] = ACTIONS(982),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(982),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(984),
  },
  [262] = {
    [aux_sym_concatenation_repeat1] = STATE(516),
    [sym_file_descriptor] = ACTIONS(254),
    [sym_word] = ACTIONS(254),
    [sym__concat] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_RPAREN] = ACTIONS(254),
    [anon_sym_PIPE_AMP] = ACTIONS(254),
    [anon_sym_AMP_AMP] = ACTIONS(254),
    [anon_sym_PIPE_PIPE] = ACTIONS(254),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(877),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_LT_LT_DASH] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(877),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(877),
  },
  [263] = {
    [sym_concatenation] = STATE(518),
    [sym_string] = STATE(517),
    [sym_array] = STATE(518),
    [sym_simple_expansion] = STATE(517),
    [sym_expansion] = STATE(517),
    [sym_command_substitution] = STATE(517),
    [sym_process_substitution] = STATE(517),
    [sym_word] = ACTIONS(986),
    [sym__empty_value] = ACTIONS(988),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_DQUOTE] = ACTIONS(992),
    [sym_raw_string] = ACTIONS(986),
    [anon_sym_DOLLAR] = ACTIONS(994),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(996),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(998),
    [anon_sym_BQUOTE] = ACTIONS(1000),
    [anon_sym_LT_LPAREN] = ACTIONS(1002),
    [anon_sym_GT_LPAREN] = ACTIONS(1002),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1004),
  },
  [264] = {
    [sym_file_descriptor] = ACTIONS(294),
    [sym_word] = ACTIONS(294),
    [sym_variable_name] = ACTIONS(294),
    [anon_sym_PIPE] = ACTIONS(1006),
    [anon_sym_RPAREN] = ACTIONS(294),
    [anon_sym_PIPE_AMP] = ACTIONS(294),
    [anon_sym_AMP_AMP] = ACTIONS(294),
    [anon_sym_PIPE_PIPE] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(1006),
    [anon_sym_GT] = ACTIONS(1006),
    [anon_sym_GT_GT] = ACTIONS(294),
    [anon_sym_AMP_GT] = ACTIONS(1006),
    [anon_sym_AMP_GT_GT] = ACTIONS(294),
    [anon_sym_LT_AMP] = ACTIONS(294),
    [anon_sym_GT_AMP] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [sym_raw_string] = ACTIONS(294),
    [anon_sym_DOLLAR] = ACTIONS(1006),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(294),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(294),
    [anon_sym_BQUOTE] = ACTIONS(294),
    [anon_sym_LT_LPAREN] = ACTIONS(294),
    [anon_sym_GT_LPAREN] = ACTIONS(294),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1006),
  },
  [265] = {
    [anon_sym_in] = ACTIONS(1008),
    [sym_comment] = ACTIONS(46),
  },
  [266] = {
    [sym_do_group] = STATE(529),
    [anon_sym_do] = ACTIONS(1010),
    [sym_comment] = ACTIONS(46),
  },
  [267] = {
    [anon_sym_then] = ACTIONS(1012),
    [sym_comment] = ACTIONS(46),
  },
  [268] = {
    [aux_sym_concatenation_repeat1] = STATE(177),
    [sym__concat] = ACTIONS(306),
    [anon_sym_in] = ACTIONS(1014),
    [anon_sym_SEMI_SEMI] = ACTIONS(1016),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1016),
    [anon_sym_LF] = ACTIONS(1016),
    [anon_sym_AMP] = ACTIONS(1016),
  },
  [269] = {
    [aux_sym_concatenation_repeat1] = STATE(194),
    [sym__concat] = ACTIONS(306),
    [anon_sym_in] = ACTIONS(1018),
    [anon_sym_SEMI_SEMI] = ACTIONS(1020),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1020),
    [anon_sym_LF] = ACTIONS(1020),
    [anon_sym_AMP] = ACTIONS(1020),
  },
  [270] = {
    [anon_sym_in] = ACTIONS(1014),
    [anon_sym_SEMI_SEMI] = ACTIONS(1016),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1016),
    [anon_sym_LF] = ACTIONS(1016),
    [anon_sym_AMP] = ACTIONS(1016),
  },
  [271] = {
    [sym_compound_statement] = STATE(537),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [anon_sym_LBRACE] = ACTIONS(1024),
    [sym_comment] = ACTIONS(46),
  },
  [272] = {
    [anon_sym_PIPE] = ACTIONS(340),
    [anon_sym_RPAREN] = ACTIONS(1026),
    [anon_sym_SEMI_SEMI] = ACTIONS(1028),
    [anon_sym_PIPE_AMP] = ACTIONS(340),
    [anon_sym_AMP_AMP] = ACTIONS(346),
    [anon_sym_PIPE_PIPE] = ACTIONS(346),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1028),
    [anon_sym_LF] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(1028),
  },
  [273] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(340),
    [anon_sym_RPAREN] = ACTIONS(1026),
    [anon_sym_SEMI_SEMI] = ACTIONS(1028),
    [anon_sym_PIPE_AMP] = ACTIONS(340),
    [anon_sym_AMP_AMP] = ACTIONS(346),
    [anon_sym_PIPE_PIPE] = ACTIONS(346),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(236),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(236),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_DQUOTE] = ACTIONS(236),
    [sym_raw_string] = ACTIONS(236),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(236),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(236),
    [anon_sym_BQUOTE] = ACTIONS(236),
    [anon_sym_LT_LPAREN] = ACTIONS(236),
    [anon_sym_GT_LPAREN] = ACTIONS(236),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(1028),
    [anon_sym_LF] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(1028),
  },
  [274] = {
    [sym__terminated_statement] = STATE(21),
    [sym_for_statement] = STATE(540),
    [sym_while_statement] = STATE(540),
    [sym_if_statement] = STATE(540),
    [sym_case_statement] = STATE(540),
    [sym_function_definition] = STATE(540),
    [sym_subshell] = STATE(540),
    [sym_pipeline] = STATE(540),
    [sym_list] = STATE(540),
    [sym_command] = STATE(540),
    [sym_command_name] = STATE(57),
    [sym_variable_assignment] = STATE(541),
    [sym_declaration_command] = STATE(540),
    [sym_subscript] = STATE(59),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(51),
    [sym_simple_expansion] = STATE(51),
    [sym_expansion] = STATE(51),
    [sym_command_substitution] = STATE(51),
    [sym_process_substitution] = STATE(51),
    [aux_sym_program_repeat1] = STATE(218),
    [aux_sym_command_repeat1] = STATE(61),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(86),
    [sym_variable_name] = ACTIONS(88),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(90),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(92),
    [anon_sym_typeset] = ACTIONS(92),
    [anon_sym_export] = ACTIONS(92),
    [anon_sym_readonly] = ACTIONS(92),
    [anon_sym_local] = ACTIONS(92),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(86),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(94),
  },
  [275] = {
    [sym_word] = ACTIONS(360),
    [sym_variable_name] = ACTIONS(360),
    [anon_sym_PIPE] = ACTIONS(1030),
    [anon_sym_RPAREN] = ACTIONS(360),
    [anon_sym_PIPE_AMP] = ACTIONS(360),
    [anon_sym_AMP_AMP] = ACTIONS(360),
    [anon_sym_PIPE_PIPE] = ACTIONS(360),
    [anon_sym_BQUOTE] = ACTIONS(360),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1030),
  },
  [276] = {
    [sym__assignment] = STATE(543),
    [anon_sym_EQ] = ACTIONS(1032),
    [anon_sym_PLUS_EQ] = ACTIONS(1032),
    [anon_sym_LBRACK] = ACTIONS(64),
    [sym_comment] = ACTIONS(46),
  },
  [277] = {
    [sym_word] = ACTIONS(366),
    [sym_variable_name] = ACTIONS(366),
    [anon_sym_PIPE] = ACTIONS(1034),
    [anon_sym_RPAREN] = ACTIONS(366),
    [anon_sym_PIPE_AMP] = ACTIONS(366),
    [anon_sym_AMP_AMP] = ACTIONS(366),
    [anon_sym_PIPE_PIPE] = ACTIONS(366),
    [anon_sym_BQUOTE] = ACTIONS(366),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1034),
  },
  [278] = {
    [sym__assignment] = STATE(543),
    [anon_sym_EQ] = ACTIONS(1032),
    [anon_sym_PLUS_EQ] = ACTIONS(1032),
    [sym_comment] = ACTIONS(46),
  },
  [279] = {
    [sym_variable_assignment] = STATE(275),
    [sym_subscript] = STATE(278),
    [aux_sym_declaration_command_repeat1] = STATE(544),
    [sym_word] = ACTIONS(458),
    [sym_variable_name] = ACTIONS(460),
    [anon_sym_PIPE] = ACTIONS(1036),
    [anon_sym_RPAREN] = ACTIONS(1038),
    [anon_sym_PIPE_AMP] = ACTIONS(1038),
    [anon_sym_AMP_AMP] = ACTIONS(1038),
    [anon_sym_PIPE_PIPE] = ACTIONS(1038),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(466),
  },
  [280] = {
    [sym_file_descriptor] = ACTIONS(394),
    [sym_word] = ACTIONS(394),
    [sym__concat] = ACTIONS(394),
    [anon_sym_PIPE] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(394),
    [anon_sym_PIPE_AMP] = ACTIONS(394),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_GT_GT] = ACTIONS(394),
    [anon_sym_AMP_GT] = ACTIONS(879),
    [anon_sym_AMP_GT_GT] = ACTIONS(394),
    [anon_sym_LT_AMP] = ACTIONS(394),
    [anon_sym_GT_AMP] = ACTIONS(394),
    [anon_sym_LT_LT] = ACTIONS(879),
    [anon_sym_LT_LT_DASH] = ACTIONS(394),
    [anon_sym_DQUOTE] = ACTIONS(394),
    [sym_raw_string] = ACTIONS(394),
    [anon_sym_DOLLAR] = ACTIONS(879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(394),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(394),
    [anon_sym_BQUOTE] = ACTIONS(394),
    [anon_sym_LT_LPAREN] = ACTIONS(394),
    [anon_sym_GT_LPAREN] = ACTIONS(394),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(879),
  },
  [281] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(252),
    [anon_sym_DQUOTE] = ACTIONS(1040),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [282] = {
    [sym_file_descriptor] = ACTIONS(412),
    [sym_word] = ACTIONS(412),
    [sym__concat] = ACTIONS(412),
    [anon_sym_PIPE] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(412),
    [anon_sym_PIPE_AMP] = ACTIONS(412),
    [anon_sym_AMP_AMP] = ACTIONS(412),
    [anon_sym_PIPE_PIPE] = ACTIONS(412),
    [anon_sym_LT] = ACTIONS(424),
    [anon_sym_GT] = ACTIONS(424),
    [anon_sym_GT_GT] = ACTIONS(412),
    [anon_sym_AMP_GT] = ACTIONS(424),
    [anon_sym_AMP_GT_GT] = ACTIONS(412),
    [anon_sym_LT_AMP] = ACTIONS(412),
    [anon_sym_GT_AMP] = ACTIONS(412),
    [anon_sym_LT_LT] = ACTIONS(424),
    [anon_sym_LT_LT_DASH] = ACTIONS(412),
    [anon_sym_DQUOTE] = ACTIONS(412),
    [sym_raw_string] = ACTIONS(412),
    [anon_sym_DOLLAR] = ACTIONS(424),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(412),
    [anon_sym_BQUOTE] = ACTIONS(412),
    [anon_sym_LT_LPAREN] = ACTIONS(412),
    [anon_sym_GT_LPAREN] = ACTIONS(412),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(424),
  },
  [283] = {
    [sym_file_descriptor] = ACTIONS(416),
    [sym_word] = ACTIONS(416),
    [sym__concat] = ACTIONS(416),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_RPAREN] = ACTIONS(416),
    [anon_sym_PIPE_AMP] = ACTIONS(416),
    [anon_sym_AMP_AMP] = ACTIONS(416),
    [anon_sym_PIPE_PIPE] = ACTIONS(416),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(416),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_AMP_GT_GT] = ACTIONS(416),
    [anon_sym_LT_AMP] = ACTIONS(416),
    [anon_sym_GT_AMP] = ACTIONS(416),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_LT_LT_DASH] = ACTIONS(416),
    [anon_sym_DQUOTE] = ACTIONS(416),
    [sym_raw_string] = ACTIONS(416),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(416),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(416),
    [anon_sym_BQUOTE] = ACTIONS(416),
    [anon_sym_LT_LPAREN] = ACTIONS(416),
    [anon_sym_GT_LPAREN] = ACTIONS(416),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(883),
  },
  [284] = {
    [sym_file_descriptor] = ACTIONS(420),
    [sym_word] = ACTIONS(420),
    [sym__concat] = ACTIONS(420),
    [anon_sym_PIPE] = ACTIONS(885),
    [anon_sym_RPAREN] = ACTIONS(420),
    [anon_sym_PIPE_AMP] = ACTIONS(420),
    [anon_sym_AMP_AMP] = ACTIONS(420),
    [anon_sym_PIPE_PIPE] = ACTIONS(420),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(420),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(420),
    [anon_sym_LT_AMP] = ACTIONS(420),
    [anon_sym_GT_AMP] = ACTIONS(420),
    [anon_sym_LT_LT] = ACTIONS(885),
    [anon_sym_LT_LT_DASH] = ACTIONS(420),
    [anon_sym_DQUOTE] = ACTIONS(420),
    [sym_raw_string] = ACTIONS(420),
    [anon_sym_DOLLAR] = ACTIONS(885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(420),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(420),
    [anon_sym_BQUOTE] = ACTIONS(420),
    [anon_sym_LT_LPAREN] = ACTIONS(420),
    [anon_sym_GT_LPAREN] = ACTIONS(420),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(885),
  },
  [285] = {
    [sym_special_variable_name] = STATE(547),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_EQ] = ACTIONS(412),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(138),
    [anon_sym_AT] = ACTIONS(138),
    [anon_sym_COLON] = ACTIONS(424),
    [anon_sym_COLON_QMARK] = ACTIONS(412),
    [anon_sym_COLON_DASH] = ACTIONS(412),
    [anon_sym_PERCENT] = ACTIONS(412),
    [anon_sym_SLASH] = ACTIONS(412),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1042),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [286] = {
    [anon_sym_RBRACE] = ACTIONS(1044),
    [anon_sym_EQ] = ACTIONS(1046),
    [anon_sym_LBRACK] = ACTIONS(1048),
    [anon_sym_COLON] = ACTIONS(1050),
    [anon_sym_COLON_QMARK] = ACTIONS(1046),
    [anon_sym_COLON_DASH] = ACTIONS(1046),
    [anon_sym_PERCENT] = ACTIONS(1046),
    [anon_sym_SLASH] = ACTIONS(1046),
    [sym_comment] = ACTIONS(46),
  },
  [287] = {
    [anon_sym_RBRACE] = ACTIONS(1052),
    [anon_sym_EQ] = ACTIONS(1054),
    [anon_sym_LBRACK] = ACTIONS(1056),
    [anon_sym_COLON] = ACTIONS(1058),
    [anon_sym_COLON_QMARK] = ACTIONS(1054),
    [anon_sym_COLON_DASH] = ACTIONS(1054),
    [anon_sym_PERCENT] = ACTIONS(1054),
    [anon_sym_SLASH] = ACTIONS(1054),
    [sym_comment] = ACTIONS(46),
  },
  [288] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1060),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [289] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1060),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [290] = {
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_BQUOTE] = ACTIONS(1060),
    [sym_comment] = ACTIONS(46),
  },
  [291] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(1060),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [292] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1062),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [293] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1062),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [294] = {
    [anon_sym_RPAREN] = ACTIONS(1064),
    [sym_comment] = ACTIONS(46),
  },
  [295] = {
    [aux_sym_concatenation_repeat1] = STATE(516),
    [sym_file_descriptor] = ACTIONS(542),
    [sym_word] = ACTIONS(542),
    [sym__concat] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(542),
    [anon_sym_AMP_AMP] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(909),
    [anon_sym_GT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(542),
    [anon_sym_AMP_GT] = ACTIONS(909),
    [anon_sym_AMP_GT_GT] = ACTIONS(542),
    [anon_sym_LT_AMP] = ACTIONS(542),
    [anon_sym_GT_AMP] = ACTIONS(542),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_LT_LT_DASH] = ACTIONS(542),
    [anon_sym_DQUOTE] = ACTIONS(542),
    [sym_raw_string] = ACTIONS(542),
    [anon_sym_DOLLAR] = ACTIONS(909),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(542),
    [anon_sym_BQUOTE] = ACTIONS(542),
    [anon_sym_LT_LPAREN] = ACTIONS(542),
    [anon_sym_GT_LPAREN] = ACTIONS(542),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(909),
  },
  [296] = {
    [sym_for_statement] = STATE(557),
    [sym_while_statement] = STATE(557),
    [sym_if_statement] = STATE(557),
    [sym_case_statement] = STATE(557),
    [sym_function_definition] = STATE(557),
    [sym_subshell] = STATE(557),
    [sym_pipeline] = STATE(557),
    [sym_list] = STATE(557),
    [sym_command] = STATE(557),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(558),
    [sym_declaration_command] = STATE(557),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [297] = {
    [sym_file_descriptor] = ACTIONS(1066),
    [sym_word] = ACTIONS(1066),
    [sym__concat] = ACTIONS(1066),
    [anon_sym_PIPE] = ACTIONS(1068),
    [anon_sym_RPAREN] = ACTIONS(1068),
    [anon_sym_SEMI_SEMI] = ACTIONS(1068),
    [anon_sym_PIPE_AMP] = ACTIONS(1068),
    [anon_sym_AMP_AMP] = ACTIONS(1068),
    [anon_sym_PIPE_PIPE] = ACTIONS(1068),
    [anon_sym_LT] = ACTIONS(1068),
    [anon_sym_GT] = ACTIONS(1068),
    [anon_sym_GT_GT] = ACTIONS(1068),
    [anon_sym_AMP_GT] = ACTIONS(1068),
    [anon_sym_AMP_GT_GT] = ACTIONS(1068),
    [anon_sym_LT_AMP] = ACTIONS(1068),
    [anon_sym_GT_AMP] = ACTIONS(1068),
    [anon_sym_LT_LT] = ACTIONS(1068),
    [anon_sym_LT_LT_DASH] = ACTIONS(1068),
    [anon_sym_DQUOTE] = ACTIONS(1068),
    [sym_raw_string] = ACTIONS(1068),
    [anon_sym_DOLLAR] = ACTIONS(1068),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1068),
    [anon_sym_BQUOTE] = ACTIONS(1068),
    [anon_sym_LT_LPAREN] = ACTIONS(1068),
    [anon_sym_GT_LPAREN] = ACTIONS(1068),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1068),
    [anon_sym_SEMI] = ACTIONS(1068),
    [anon_sym_LF] = ACTIONS(1068),
    [anon_sym_AMP] = ACTIONS(1068),
  },
  [298] = {
    [sym_for_statement] = STATE(559),
    [sym_while_statement] = STATE(559),
    [sym_if_statement] = STATE(559),
    [sym_case_statement] = STATE(559),
    [sym_function_definition] = STATE(559),
    [sym_subshell] = STATE(559),
    [sym_pipeline] = STATE(559),
    [sym_list] = STATE(559),
    [sym_command] = STATE(559),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(560),
    [sym_declaration_command] = STATE(559),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [299] = {
    [anon_sym_LT] = ACTIONS(1070),
    [anon_sym_GT] = ACTIONS(1070),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_AMP_GT] = ACTIONS(1070),
    [anon_sym_AMP_GT_GT] = ACTIONS(1072),
    [anon_sym_LT_AMP] = ACTIONS(1072),
    [anon_sym_GT_AMP] = ACTIONS(1072),
    [sym_comment] = ACTIONS(46),
  },
  [300] = {
    [aux_sym_concatenation_repeat1] = STATE(262),
    [sym_file_descriptor] = ACTIONS(556),
    [sym_word] = ACTIONS(556),
    [sym__concat] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_RPAREN] = ACTIONS(556),
    [anon_sym_PIPE_AMP] = ACTIONS(556),
    [anon_sym_AMP_AMP] = ACTIONS(556),
    [anon_sym_PIPE_PIPE] = ACTIONS(556),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_GT_GT] = ACTIONS(556),
    [anon_sym_AMP_GT] = ACTIONS(1074),
    [anon_sym_AMP_GT_GT] = ACTIONS(556),
    [anon_sym_LT_AMP] = ACTIONS(556),
    [anon_sym_GT_AMP] = ACTIONS(556),
    [anon_sym_LT_LT] = ACTIONS(1074),
    [anon_sym_LT_LT_DASH] = ACTIONS(556),
    [anon_sym_DQUOTE] = ACTIONS(556),
    [sym_raw_string] = ACTIONS(556),
    [anon_sym_DOLLAR] = ACTIONS(1074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(556),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(556),
    [anon_sym_BQUOTE] = ACTIONS(556),
    [anon_sym_LT_LPAREN] = ACTIONS(556),
    [anon_sym_GT_LPAREN] = ACTIONS(556),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1074),
  },
  [301] = {
    [sym_concatenation] = STATE(570),
    [sym_string] = STATE(562),
    [sym_simple_expansion] = STATE(562),
    [sym_expansion] = STATE(562),
    [sym_command_substitution] = STATE(562),
    [sym_process_substitution] = STATE(562),
    [sym_word] = ACTIONS(1076),
    [anon_sym_DQUOTE] = ACTIONS(1078),
    [sym_raw_string] = ACTIONS(1076),
    [anon_sym_DOLLAR] = ACTIONS(1080),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1084),
    [anon_sym_BQUOTE] = ACTIONS(1086),
    [anon_sym_LT_LPAREN] = ACTIONS(1088),
    [anon_sym_GT_LPAREN] = ACTIONS(1088),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1090),
  },
  [302] = {
    [sym_heredoc] = STATE(573),
    [sym__simple_heredoc] = ACTIONS(1092),
    [sym__heredoc_beginning] = ACTIONS(1094),
    [sym_comment] = ACTIONS(46),
  },
  [303] = {
    [aux_sym_concatenation_repeat1] = STATE(295),
    [sym_file_descriptor] = ACTIONS(580),
    [sym_word] = ACTIONS(580),
    [sym__concat] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(1096),
    [anon_sym_RPAREN] = ACTIONS(580),
    [anon_sym_PIPE_AMP] = ACTIONS(580),
    [anon_sym_AMP_AMP] = ACTIONS(580),
    [anon_sym_PIPE_PIPE] = ACTIONS(580),
    [anon_sym_LT] = ACTIONS(1096),
    [anon_sym_GT] = ACTIONS(1096),
    [anon_sym_GT_GT] = ACTIONS(580),
    [anon_sym_AMP_GT] = ACTIONS(1096),
    [anon_sym_AMP_GT_GT] = ACTIONS(580),
    [anon_sym_LT_AMP] = ACTIONS(580),
    [anon_sym_GT_AMP] = ACTIONS(580),
    [anon_sym_LT_LT] = ACTIONS(1096),
    [anon_sym_LT_LT_DASH] = ACTIONS(580),
    [anon_sym_DQUOTE] = ACTIONS(580),
    [sym_raw_string] = ACTIONS(580),
    [anon_sym_DOLLAR] = ACTIONS(1096),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(580),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(580),
    [anon_sym_BQUOTE] = ACTIONS(580),
    [anon_sym_LT_LPAREN] = ACTIONS(580),
    [anon_sym_GT_LPAREN] = ACTIONS(580),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1096),
  },
  [304] = {
    [sym_file_descriptor] = ACTIONS(584),
    [anon_sym_PIPE] = ACTIONS(1098),
    [anon_sym_RPAREN] = ACTIONS(584),
    [anon_sym_PIPE_AMP] = ACTIONS(584),
    [anon_sym_AMP_AMP] = ACTIONS(584),
    [anon_sym_PIPE_PIPE] = ACTIONS(584),
    [anon_sym_LT] = ACTIONS(1098),
    [anon_sym_GT] = ACTIONS(1098),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_AMP_GT] = ACTIONS(1098),
    [anon_sym_AMP_GT_GT] = ACTIONS(584),
    [anon_sym_LT_AMP] = ACTIONS(584),
    [anon_sym_GT_AMP] = ACTIONS(584),
    [anon_sym_LT_LT] = ACTIONS(1098),
    [anon_sym_LT_LT_DASH] = ACTIONS(584),
    [anon_sym_BQUOTE] = ACTIONS(584),
    [sym_comment] = ACTIONS(46),
  },
  [305] = {
    [sym_file_descriptor] = ACTIONS(556),
    [sym_word] = ACTIONS(556),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_RPAREN] = ACTIONS(556),
    [anon_sym_PIPE_AMP] = ACTIONS(556),
    [anon_sym_AMP_AMP] = ACTIONS(556),
    [anon_sym_PIPE_PIPE] = ACTIONS(556),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_GT_GT] = ACTIONS(556),
    [anon_sym_AMP_GT] = ACTIONS(1074),
    [anon_sym_AMP_GT_GT] = ACTIONS(556),
    [anon_sym_LT_AMP] = ACTIONS(556),
    [anon_sym_GT_AMP] = ACTIONS(556),
    [anon_sym_LT_LT] = ACTIONS(1074),
    [anon_sym_LT_LT_DASH] = ACTIONS(556),
    [anon_sym_DQUOTE] = ACTIONS(556),
    [sym_raw_string] = ACTIONS(556),
    [anon_sym_DOLLAR] = ACTIONS(1074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(556),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(556),
    [anon_sym_BQUOTE] = ACTIONS(556),
    [anon_sym_LT_LPAREN] = ACTIONS(556),
    [anon_sym_GT_LPAREN] = ACTIONS(556),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1074),
  },
  [306] = {
    [sym_file_redirect] = STATE(304),
    [sym_heredoc_redirect] = STATE(304),
    [sym_concatenation] = STATE(305),
    [sym_string] = STATE(300),
    [sym_simple_expansion] = STATE(300),
    [sym_expansion] = STATE(300),
    [sym_command_substitution] = STATE(300),
    [sym_process_substitution] = STATE(300),
    [aux_sym_for_statement_repeat1] = STATE(574),
    [aux_sym_command_repeat2] = STATE(575),
    [sym_file_descriptor] = ACTIONS(492),
    [sym_word] = ACTIONS(494),
    [anon_sym_PIPE] = ACTIONS(1100),
    [anon_sym_RPAREN] = ACTIONS(1102),
    [anon_sym_PIPE_AMP] = ACTIONS(1102),
    [anon_sym_AMP_AMP] = ACTIONS(1102),
    [anon_sym_PIPE_PIPE] = ACTIONS(1102),
    [anon_sym_LT] = ACTIONS(500),
    [anon_sym_GT] = ACTIONS(500),
    [anon_sym_GT_GT] = ACTIONS(502),
    [anon_sym_AMP_GT] = ACTIONS(500),
    [anon_sym_AMP_GT_GT] = ACTIONS(502),
    [anon_sym_LT_AMP] = ACTIONS(502),
    [anon_sym_GT_AMP] = ACTIONS(502),
    [anon_sym_LT_LT] = ACTIONS(504),
    [anon_sym_LT_LT_DASH] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(494),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(508),
  },
  [307] = {
    [sym_file_redirect] = STATE(304),
    [sym_heredoc_redirect] = STATE(304),
    [aux_sym_command_repeat2] = STATE(576),
    [sym_file_descriptor] = ACTIONS(492),
    [anon_sym_PIPE] = ACTIONS(1100),
    [anon_sym_RPAREN] = ACTIONS(1102),
    [anon_sym_PIPE_AMP] = ACTIONS(1102),
    [anon_sym_AMP_AMP] = ACTIONS(1102),
    [anon_sym_PIPE_PIPE] = ACTIONS(1102),
    [anon_sym_LT] = ACTIONS(500),
    [anon_sym_GT] = ACTIONS(500),
    [anon_sym_GT_GT] = ACTIONS(502),
    [anon_sym_AMP_GT] = ACTIONS(500),
    [anon_sym_AMP_GT_GT] = ACTIONS(502),
    [anon_sym_LT_AMP] = ACTIONS(502),
    [anon_sym_GT_AMP] = ACTIONS(502),
    [anon_sym_LT_LT] = ACTIONS(504),
    [anon_sym_LT_LT_DASH] = ACTIONS(506),
    [sym_comment] = ACTIONS(46),
  },
  [308] = {
    [aux_sym_concatenation_repeat1] = STATE(295),
    [sym_file_descriptor] = ACTIONS(188),
    [sym_word] = ACTIONS(188),
    [sym__concat] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(480),
    [anon_sym_RPAREN] = ACTIONS(188),
    [anon_sym_PIPE_AMP] = ACTIONS(188),
    [anon_sym_AMP_AMP] = ACTIONS(188),
    [anon_sym_PIPE_PIPE] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(480),
    [anon_sym_GT] = ACTIONS(480),
    [anon_sym_GT_GT] = ACTIONS(188),
    [anon_sym_AMP_GT] = ACTIONS(480),
    [anon_sym_AMP_GT_GT] = ACTIONS(188),
    [anon_sym_LT_AMP] = ACTIONS(188),
    [anon_sym_GT_AMP] = ACTIONS(188),
    [anon_sym_LT_LT] = ACTIONS(480),
    [anon_sym_LT_LT_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(188),
    [sym_raw_string] = ACTIONS(188),
    [anon_sym_DOLLAR] = ACTIONS(480),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(188),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(188),
    [anon_sym_BQUOTE] = ACTIONS(188),
    [anon_sym_LT_LPAREN] = ACTIONS(188),
    [anon_sym_GT_LPAREN] = ACTIONS(188),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(480),
  },
  [309] = {
    [sym_file_redirect] = STATE(304),
    [sym_heredoc_redirect] = STATE(304),
    [sym_concatenation] = STATE(305),
    [sym_string] = STATE(300),
    [sym_simple_expansion] = STATE(300),
    [sym_expansion] = STATE(300),
    [sym_command_substitution] = STATE(300),
    [sym_process_substitution] = STATE(300),
    [aux_sym_for_statement_repeat1] = STATE(577),
    [aux_sym_command_repeat2] = STATE(575),
    [sym_file_descriptor] = ACTIONS(492),
    [sym_word] = ACTIONS(494),
    [anon_sym_PIPE] = ACTIONS(1100),
    [anon_sym_RPAREN] = ACTIONS(1102),
    [anon_sym_PIPE_AMP] = ACTIONS(1102),
    [anon_sym_AMP_AMP] = ACTIONS(1102),
    [anon_sym_PIPE_PIPE] = ACTIONS(1102),
    [anon_sym_LT] = ACTIONS(500),
    [anon_sym_GT] = ACTIONS(500),
    [anon_sym_GT_GT] = ACTIONS(502),
    [anon_sym_AMP_GT] = ACTIONS(500),
    [anon_sym_AMP_GT_GT] = ACTIONS(502),
    [anon_sym_LT_AMP] = ACTIONS(502),
    [anon_sym_GT_AMP] = ACTIONS(502),
    [anon_sym_LT_LT] = ACTIONS(504),
    [anon_sym_LT_LT_DASH] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(494),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(508),
  },
  [310] = {
    [aux_sym_concatenation_repeat1] = STATE(578),
    [sym_file_descriptor] = ACTIONS(254),
    [sym_word] = ACTIONS(254),
    [sym__concat] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_PIPE_AMP] = ACTIONS(254),
    [anon_sym_AMP_AMP] = ACTIONS(254),
    [anon_sym_PIPE_PIPE] = ACTIONS(254),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(877),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_LT_LT_DASH] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(877),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(877),
  },
  [311] = {
    [sym_concatenation] = STATE(518),
    [sym_string] = STATE(579),
    [sym_array] = STATE(518),
    [sym_simple_expansion] = STATE(579),
    [sym_expansion] = STATE(579),
    [sym_command_substitution] = STATE(579),
    [sym_process_substitution] = STATE(579),
    [sym_word] = ACTIONS(1104),
    [sym__empty_value] = ACTIONS(988),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_DQUOTE] = ACTIONS(992),
    [sym_raw_string] = ACTIONS(1104),
    [anon_sym_DOLLAR] = ACTIONS(994),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(996),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(998),
    [anon_sym_BQUOTE] = ACTIONS(1000),
    [anon_sym_LT_LPAREN] = ACTIONS(1002),
    [anon_sym_GT_LPAREN] = ACTIONS(1002),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1106),
  },
  [312] = {
    [sym_compound_statement] = STATE(582),
    [anon_sym_LPAREN] = ACTIONS(1108),
    [anon_sym_LBRACE] = ACTIONS(1024),
    [sym_comment] = ACTIONS(46),
  },
  [313] = {
    [sym__assignment] = STATE(543),
    [anon_sym_EQ] = ACTIONS(1110),
    [anon_sym_PLUS_EQ] = ACTIONS(1110),
    [anon_sym_LBRACK] = ACTIONS(64),
    [sym_comment] = ACTIONS(46),
  },
  [314] = {
    [sym__assignment] = STATE(543),
    [anon_sym_EQ] = ACTIONS(1110),
    [anon_sym_PLUS_EQ] = ACTIONS(1110),
    [sym_comment] = ACTIONS(46),
  },
  [315] = {
    [sym_variable_assignment] = STATE(275),
    [sym_subscript] = STATE(314),
    [aux_sym_declaration_command_repeat1] = STATE(584),
    [sym_word] = ACTIONS(458),
    [sym_variable_name] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(1036),
    [anon_sym_PIPE_AMP] = ACTIONS(1038),
    [anon_sym_AMP_AMP] = ACTIONS(1038),
    [anon_sym_PIPE_PIPE] = ACTIONS(1038),
    [anon_sym_BQUOTE] = ACTIONS(1038),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(466),
  },
  [316] = {
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym_comment] = ACTIONS(46),
  },
  [317] = {
    [aux_sym_concatenation_repeat1] = STATE(578),
    [sym_file_descriptor] = ACTIONS(542),
    [sym_word] = ACTIONS(542),
    [sym__concat] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(909),
    [anon_sym_PIPE_AMP] = ACTIONS(542),
    [anon_sym_AMP_AMP] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(909),
    [anon_sym_GT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(542),
    [anon_sym_AMP_GT] = ACTIONS(909),
    [anon_sym_AMP_GT_GT] = ACTIONS(542),
    [anon_sym_LT_AMP] = ACTIONS(542),
    [anon_sym_GT_AMP] = ACTIONS(542),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_LT_LT_DASH] = ACTIONS(542),
    [anon_sym_DQUOTE] = ACTIONS(542),
    [sym_raw_string] = ACTIONS(542),
    [anon_sym_DOLLAR] = ACTIONS(909),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(542),
    [anon_sym_BQUOTE] = ACTIONS(542),
    [anon_sym_LT_LPAREN] = ACTIONS(542),
    [anon_sym_GT_LPAREN] = ACTIONS(542),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(909),
  },
  [318] = {
    [sym_for_statement] = STATE(557),
    [sym_while_statement] = STATE(557),
    [sym_if_statement] = STATE(557),
    [sym_case_statement] = STATE(557),
    [sym_function_definition] = STATE(557),
    [sym_subshell] = STATE(557),
    [sym_pipeline] = STATE(557),
    [sym_list] = STATE(557),
    [sym_command] = STATE(557),
    [sym_command_name] = STATE(118),
    [sym_variable_assignment] = STATE(586),
    [sym_declaration_command] = STATE(557),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(112),
    [sym_simple_expansion] = STATE(112),
    [sym_expansion] = STATE(112),
    [sym_command_substitution] = STATE(112),
    [sym_process_substitution] = STATE(112),
    [aux_sym_command_repeat1] = STATE(121),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(178),
    [sym_variable_name] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(184),
    [anon_sym_typeset] = ACTIONS(184),
    [anon_sym_export] = ACTIONS(184),
    [anon_sym_readonly] = ACTIONS(184),
    [anon_sym_local] = ACTIONS(184),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(178),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(186),
  },
  [319] = {
    [sym_for_statement] = STATE(587),
    [sym_while_statement] = STATE(587),
    [sym_if_statement] = STATE(587),
    [sym_case_statement] = STATE(587),
    [sym_function_definition] = STATE(587),
    [sym_subshell] = STATE(587),
    [sym_pipeline] = STATE(587),
    [sym_list] = STATE(587),
    [sym_command] = STATE(587),
    [sym_command_name] = STATE(118),
    [sym_variable_assignment] = STATE(588),
    [sym_declaration_command] = STATE(587),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(112),
    [sym_simple_expansion] = STATE(112),
    [sym_expansion] = STATE(112),
    [sym_command_substitution] = STATE(112),
    [sym_process_substitution] = STATE(112),
    [aux_sym_command_repeat1] = STATE(121),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(178),
    [sym_variable_name] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(184),
    [anon_sym_typeset] = ACTIONS(184),
    [anon_sym_export] = ACTIONS(184),
    [anon_sym_readonly] = ACTIONS(184),
    [anon_sym_local] = ACTIONS(184),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(178),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(186),
  },
  [320] = {
    [anon_sym_LT] = ACTIONS(1114),
    [anon_sym_GT] = ACTIONS(1114),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_AMP_GT] = ACTIONS(1114),
    [anon_sym_AMP_GT_GT] = ACTIONS(1116),
    [anon_sym_LT_AMP] = ACTIONS(1116),
    [anon_sym_GT_AMP] = ACTIONS(1116),
    [sym_comment] = ACTIONS(46),
  },
  [321] = {
    [aux_sym_concatenation_repeat1] = STATE(310),
    [sym_file_descriptor] = ACTIONS(556),
    [sym_word] = ACTIONS(556),
    [sym__concat] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_PIPE_AMP] = ACTIONS(556),
    [anon_sym_AMP_AMP] = ACTIONS(556),
    [anon_sym_PIPE_PIPE] = ACTIONS(556),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_GT_GT] = ACTIONS(556),
    [anon_sym_AMP_GT] = ACTIONS(1074),
    [anon_sym_AMP_GT_GT] = ACTIONS(556),
    [anon_sym_LT_AMP] = ACTIONS(556),
    [anon_sym_GT_AMP] = ACTIONS(556),
    [anon_sym_LT_LT] = ACTIONS(1074),
    [anon_sym_LT_LT_DASH] = ACTIONS(556),
    [anon_sym_DQUOTE] = ACTIONS(556),
    [sym_raw_string] = ACTIONS(556),
    [anon_sym_DOLLAR] = ACTIONS(1074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(556),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(556),
    [anon_sym_BQUOTE] = ACTIONS(556),
    [anon_sym_LT_LPAREN] = ACTIONS(556),
    [anon_sym_GT_LPAREN] = ACTIONS(556),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1074),
  },
  [322] = {
    [sym_concatenation] = STATE(570),
    [sym_string] = STATE(590),
    [sym_simple_expansion] = STATE(590),
    [sym_expansion] = STATE(590),
    [sym_command_substitution] = STATE(590),
    [sym_process_substitution] = STATE(590),
    [sym_word] = ACTIONS(1118),
    [anon_sym_DQUOTE] = ACTIONS(1078),
    [sym_raw_string] = ACTIONS(1118),
    [anon_sym_DOLLAR] = ACTIONS(1080),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1084),
    [anon_sym_BQUOTE] = ACTIONS(1086),
    [anon_sym_LT_LPAREN] = ACTIONS(1088),
    [anon_sym_GT_LPAREN] = ACTIONS(1088),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1120),
  },
  [323] = {
    [aux_sym_concatenation_repeat1] = STATE(317),
    [sym_file_descriptor] = ACTIONS(580),
    [sym_word] = ACTIONS(580),
    [sym__concat] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(1096),
    [anon_sym_PIPE_AMP] = ACTIONS(580),
    [anon_sym_AMP_AMP] = ACTIONS(580),
    [anon_sym_PIPE_PIPE] = ACTIONS(580),
    [anon_sym_LT] = ACTIONS(1096),
    [anon_sym_GT] = ACTIONS(1096),
    [anon_sym_GT_GT] = ACTIONS(580),
    [anon_sym_AMP_GT] = ACTIONS(1096),
    [anon_sym_AMP_GT_GT] = ACTIONS(580),
    [anon_sym_LT_AMP] = ACTIONS(580),
    [anon_sym_GT_AMP] = ACTIONS(580),
    [anon_sym_LT_LT] = ACTIONS(1096),
    [anon_sym_LT_LT_DASH] = ACTIONS(580),
    [anon_sym_DQUOTE] = ACTIONS(580),
    [sym_raw_string] = ACTIONS(580),
    [anon_sym_DOLLAR] = ACTIONS(1096),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(580),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(580),
    [anon_sym_BQUOTE] = ACTIONS(580),
    [anon_sym_LT_LPAREN] = ACTIONS(580),
    [anon_sym_GT_LPAREN] = ACTIONS(580),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1096),
  },
  [324] = {
    [sym_file_redirect] = STATE(304),
    [sym_heredoc_redirect] = STATE(304),
    [sym_concatenation] = STATE(305),
    [sym_string] = STATE(321),
    [sym_simple_expansion] = STATE(321),
    [sym_expansion] = STATE(321),
    [sym_command_substitution] = STATE(321),
    [sym_process_substitution] = STATE(321),
    [aux_sym_for_statement_repeat1] = STATE(592),
    [aux_sym_command_repeat2] = STATE(593),
    [sym_file_descriptor] = ACTIONS(526),
    [sym_word] = ACTIONS(528),
    [anon_sym_PIPE] = ACTIONS(1100),
    [anon_sym_PIPE_AMP] = ACTIONS(1102),
    [anon_sym_AMP_AMP] = ACTIONS(1102),
    [anon_sym_PIPE_PIPE] = ACTIONS(1102),
    [anon_sym_LT] = ACTIONS(530),
    [anon_sym_GT] = ACTIONS(530),
    [anon_sym_GT_GT] = ACTIONS(532),
    [anon_sym_AMP_GT] = ACTIONS(530),
    [anon_sym_AMP_GT_GT] = ACTIONS(532),
    [anon_sym_LT_AMP] = ACTIONS(532),
    [anon_sym_GT_AMP] = ACTIONS(532),
    [anon_sym_LT_LT] = ACTIONS(504),
    [anon_sym_LT_LT_DASH] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(528),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(1102),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(534),
  },
  [325] = {
    [sym_file_redirect] = STATE(304),
    [sym_heredoc_redirect] = STATE(304),
    [aux_sym_command_repeat2] = STATE(594),
    [sym_file_descriptor] = ACTIONS(526),
    [anon_sym_PIPE] = ACTIONS(1100),
    [anon_sym_PIPE_AMP] = ACTIONS(1102),
    [anon_sym_AMP_AMP] = ACTIONS(1102),
    [anon_sym_PIPE_PIPE] = ACTIONS(1102),
    [anon_sym_LT] = ACTIONS(530),
    [anon_sym_GT] = ACTIONS(530),
    [anon_sym_GT_GT] = ACTIONS(532),
    [anon_sym_AMP_GT] = ACTIONS(530),
    [anon_sym_AMP_GT_GT] = ACTIONS(532),
    [anon_sym_LT_AMP] = ACTIONS(532),
    [anon_sym_GT_AMP] = ACTIONS(532),
    [anon_sym_LT_LT] = ACTIONS(504),
    [anon_sym_LT_LT_DASH] = ACTIONS(506),
    [anon_sym_BQUOTE] = ACTIONS(1102),
    [sym_comment] = ACTIONS(46),
  },
  [326] = {
    [aux_sym_concatenation_repeat1] = STATE(317),
    [sym_file_descriptor] = ACTIONS(188),
    [sym_word] = ACTIONS(188),
    [sym__concat] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(480),
    [anon_sym_PIPE_AMP] = ACTIONS(188),
    [anon_sym_AMP_AMP] = ACTIONS(188),
    [anon_sym_PIPE_PIPE] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(480),
    [anon_sym_GT] = ACTIONS(480),
    [anon_sym_GT_GT] = ACTIONS(188),
    [anon_sym_AMP_GT] = ACTIONS(480),
    [anon_sym_AMP_GT_GT] = ACTIONS(188),
    [anon_sym_LT_AMP] = ACTIONS(188),
    [anon_sym_GT_AMP] = ACTIONS(188),
    [anon_sym_LT_LT] = ACTIONS(480),
    [anon_sym_LT_LT_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(188),
    [sym_raw_string] = ACTIONS(188),
    [anon_sym_DOLLAR] = ACTIONS(480),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(188),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(188),
    [anon_sym_BQUOTE] = ACTIONS(188),
    [anon_sym_LT_LPAREN] = ACTIONS(188),
    [anon_sym_GT_LPAREN] = ACTIONS(188),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(480),
  },
  [327] = {
    [sym_file_redirect] = STATE(304),
    [sym_heredoc_redirect] = STATE(304),
    [sym_concatenation] = STATE(305),
    [sym_string] = STATE(321),
    [sym_simple_expansion] = STATE(321),
    [sym_expansion] = STATE(321),
    [sym_command_substitution] = STATE(321),
    [sym_process_substitution] = STATE(321),
    [aux_sym_for_statement_repeat1] = STATE(595),
    [aux_sym_command_repeat2] = STATE(593),
    [sym_file_descriptor] = ACTIONS(526),
    [sym_word] = ACTIONS(528),
    [anon_sym_PIPE] = ACTIONS(1100),
    [anon_sym_PIPE_AMP] = ACTIONS(1102),
    [anon_sym_AMP_AMP] = ACTIONS(1102),
    [anon_sym_PIPE_PIPE] = ACTIONS(1102),
    [anon_sym_LT] = ACTIONS(530),
    [anon_sym_GT] = ACTIONS(530),
    [anon_sym_GT_GT] = ACTIONS(532),
    [anon_sym_AMP_GT] = ACTIONS(530),
    [anon_sym_AMP_GT_GT] = ACTIONS(532),
    [anon_sym_LT_AMP] = ACTIONS(532),
    [anon_sym_GT_AMP] = ACTIONS(532),
    [anon_sym_LT_LT] = ACTIONS(504),
    [anon_sym_LT_LT_DASH] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(528),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(1102),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(534),
  },
  [328] = {
    [sym_file_descriptor] = ACTIONS(1122),
    [sym_word] = ACTIONS(1122),
    [sym__concat] = ACTIONS(1122),
    [anon_sym_PIPE] = ACTIONS(1124),
    [anon_sym_RPAREN] = ACTIONS(1124),
    [anon_sym_SEMI_SEMI] = ACTIONS(1124),
    [anon_sym_PIPE_AMP] = ACTIONS(1124),
    [anon_sym_AMP_AMP] = ACTIONS(1124),
    [anon_sym_PIPE_PIPE] = ACTIONS(1124),
    [anon_sym_LT] = ACTIONS(1124),
    [anon_sym_GT] = ACTIONS(1124),
    [anon_sym_GT_GT] = ACTIONS(1124),
    [anon_sym_AMP_GT] = ACTIONS(1124),
    [anon_sym_AMP_GT_GT] = ACTIONS(1124),
    [anon_sym_LT_AMP] = ACTIONS(1124),
    [anon_sym_GT_AMP] = ACTIONS(1124),
    [anon_sym_LT_LT] = ACTIONS(1124),
    [anon_sym_LT_LT_DASH] = ACTIONS(1124),
    [anon_sym_DQUOTE] = ACTIONS(1124),
    [sym_raw_string] = ACTIONS(1124),
    [anon_sym_DOLLAR] = ACTIONS(1124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1124),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1124),
    [anon_sym_BQUOTE] = ACTIONS(1124),
    [anon_sym_LT_LPAREN] = ACTIONS(1124),
    [anon_sym_GT_LPAREN] = ACTIONS(1124),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1124),
    [anon_sym_SEMI] = ACTIONS(1124),
    [anon_sym_LF] = ACTIONS(1124),
    [anon_sym_AMP] = ACTIONS(1124),
  },
  [329] = {
    [sym_compound_statement] = STATE(596),
    [anon_sym_LBRACE] = ACTIONS(330),
    [sym_comment] = ACTIONS(46),
  },
  [330] = {
    [anon_sym_PIPE] = ACTIONS(1126),
    [anon_sym_RPAREN] = ACTIONS(1126),
    [anon_sym_SEMI_SEMI] = ACTIONS(1126),
    [anon_sym_PIPE_AMP] = ACTIONS(1126),
    [anon_sym_AMP_AMP] = ACTIONS(1126),
    [anon_sym_PIPE_PIPE] = ACTIONS(1126),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1126),
    [anon_sym_LF] = ACTIONS(1126),
    [anon_sym_AMP] = ACTIONS(1126),
  },
  [331] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(1126),
    [anon_sym_RPAREN] = ACTIONS(1126),
    [anon_sym_SEMI_SEMI] = ACTIONS(1126),
    [anon_sym_PIPE_AMP] = ACTIONS(1126),
    [anon_sym_AMP_AMP] = ACTIONS(1126),
    [anon_sym_PIPE_PIPE] = ACTIONS(1126),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(236),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(236),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_DQUOTE] = ACTIONS(236),
    [sym_raw_string] = ACTIONS(236),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(236),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(236),
    [anon_sym_BQUOTE] = ACTIONS(236),
    [anon_sym_LT_LPAREN] = ACTIONS(236),
    [anon_sym_GT_LPAREN] = ACTIONS(236),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(1126),
    [anon_sym_LF] = ACTIONS(1126),
    [anon_sym_AMP] = ACTIONS(1126),
  },
  [332] = {
    [anon_sym_PIPE] = ACTIONS(202),
    [anon_sym_SEMI_SEMI] = ACTIONS(1128),
    [anon_sym_PIPE_AMP] = ACTIONS(202),
    [anon_sym_AMP_AMP] = ACTIONS(1128),
    [anon_sym_PIPE_PIPE] = ACTIONS(1128),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1128),
    [anon_sym_LF] = ACTIONS(1128),
    [anon_sym_AMP] = ACTIONS(1128),
  },
  [333] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(202),
    [anon_sym_SEMI_SEMI] = ACTIONS(1128),
    [anon_sym_PIPE_AMP] = ACTIONS(202),
    [anon_sym_AMP_AMP] = ACTIONS(1128),
    [anon_sym_PIPE_PIPE] = ACTIONS(1128),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(236),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(236),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_DQUOTE] = ACTIONS(236),
    [sym_raw_string] = ACTIONS(236),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(236),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(236),
    [anon_sym_BQUOTE] = ACTIONS(236),
    [anon_sym_LT_LPAREN] = ACTIONS(236),
    [anon_sym_GT_LPAREN] = ACTIONS(236),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(1128),
    [anon_sym_LF] = ACTIONS(1128),
    [anon_sym_AMP] = ACTIONS(1128),
  },
  [334] = {
    [sym_concatenation] = STATE(599),
    [sym_string] = STATE(597),
    [sym_simple_expansion] = STATE(597),
    [sym_expansion] = STATE(597),
    [sym_command_substitution] = STATE(597),
    [sym_process_substitution] = STATE(597),
    [sym_word] = ACTIONS(1130),
    [anon_sym_DQUOTE] = ACTIONS(562),
    [sym_raw_string] = ACTIONS(1130),
    [anon_sym_DOLLAR] = ACTIONS(564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(566),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(568),
    [anon_sym_BQUOTE] = ACTIONS(570),
    [anon_sym_LT_LPAREN] = ACTIONS(572),
    [anon_sym_GT_LPAREN] = ACTIONS(572),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1132),
  },
  [335] = {
    [aux_sym_concatenation_repeat1] = STATE(601),
    [sym_file_descriptor] = ACTIONS(372),
    [sym__concat] = ACTIONS(1134),
    [anon_sym_PIPE] = ACTIONS(1136),
    [anon_sym_SEMI_SEMI] = ACTIONS(1136),
    [anon_sym_PIPE_AMP] = ACTIONS(1136),
    [anon_sym_AMP_AMP] = ACTIONS(1136),
    [anon_sym_PIPE_PIPE] = ACTIONS(1136),
    [anon_sym_LT] = ACTIONS(1136),
    [anon_sym_GT] = ACTIONS(1136),
    [anon_sym_GT_GT] = ACTIONS(1136),
    [anon_sym_AMP_GT] = ACTIONS(1136),
    [anon_sym_AMP_GT_GT] = ACTIONS(1136),
    [anon_sym_LT_AMP] = ACTIONS(1136),
    [anon_sym_GT_AMP] = ACTIONS(1136),
    [anon_sym_LT_LT] = ACTIONS(1136),
    [anon_sym_LT_LT_DASH] = ACTIONS(1136),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1136),
    [anon_sym_LF] = ACTIONS(1136),
    [anon_sym_AMP] = ACTIONS(1136),
  },
  [336] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(603),
    [anon_sym_DQUOTE] = ACTIONS(1138),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [337] = {
    [sym_special_variable_name] = STATE(606),
    [anon_sym_DOLLAR] = ACTIONS(1140),
    [anon_sym_POUND] = ACTIONS(1140),
    [anon_sym_AT] = ACTIONS(1140),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1142),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_QMARK] = ACTIONS(1140),
    [anon_sym_DASH] = ACTIONS(1140),
    [anon_sym_BANG] = ACTIONS(1140),
    [anon_sym_0] = ACTIONS(1144),
    [anon_sym__] = ACTIONS(1144),
  },
  [338] = {
    [sym_special_variable_name] = STATE(609),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(138),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [339] = {
    [sym_for_statement] = STATE(610),
    [sym_while_statement] = STATE(610),
    [sym_if_statement] = STATE(610),
    [sym_case_statement] = STATE(610),
    [sym_function_definition] = STATE(610),
    [sym_subshell] = STATE(610),
    [sym_pipeline] = STATE(610),
    [sym_list] = STATE(610),
    [sym_command] = STATE(610),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(611),
    [sym_declaration_command] = STATE(610),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [340] = {
    [sym_for_statement] = STATE(612),
    [sym_while_statement] = STATE(612),
    [sym_if_statement] = STATE(612),
    [sym_case_statement] = STATE(612),
    [sym_function_definition] = STATE(612),
    [sym_subshell] = STATE(612),
    [sym_pipeline] = STATE(612),
    [sym_list] = STATE(612),
    [sym_command] = STATE(612),
    [sym_command_name] = STATE(118),
    [sym_variable_assignment] = STATE(613),
    [sym_declaration_command] = STATE(612),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(112),
    [sym_simple_expansion] = STATE(112),
    [sym_expansion] = STATE(112),
    [sym_command_substitution] = STATE(112),
    [sym_process_substitution] = STATE(112),
    [aux_sym_command_repeat1] = STATE(121),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(178),
    [sym_variable_name] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(184),
    [anon_sym_typeset] = ACTIONS(184),
    [anon_sym_export] = ACTIONS(184),
    [anon_sym_readonly] = ACTIONS(184),
    [anon_sym_local] = ACTIONS(184),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(178),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(186),
  },
  [341] = {
    [sym_for_statement] = STATE(614),
    [sym_while_statement] = STATE(614),
    [sym_if_statement] = STATE(614),
    [sym_case_statement] = STATE(614),
    [sym_function_definition] = STATE(614),
    [sym_subshell] = STATE(614),
    [sym_pipeline] = STATE(614),
    [sym_list] = STATE(614),
    [sym_command] = STATE(614),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(615),
    [sym_declaration_command] = STATE(614),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [342] = {
    [aux_sym_concatenation_repeat1] = STATE(616),
    [sym_file_descriptor] = ACTIONS(390),
    [sym__concat] = ACTIONS(1134),
    [anon_sym_PIPE] = ACTIONS(1150),
    [anon_sym_SEMI_SEMI] = ACTIONS(1150),
    [anon_sym_PIPE_AMP] = ACTIONS(1150),
    [anon_sym_AMP_AMP] = ACTIONS(1150),
    [anon_sym_PIPE_PIPE] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1150),
    [anon_sym_GT] = ACTIONS(1150),
    [anon_sym_GT_GT] = ACTIONS(1150),
    [anon_sym_AMP_GT] = ACTIONS(1150),
    [anon_sym_AMP_GT_GT] = ACTIONS(1150),
    [anon_sym_LT_AMP] = ACTIONS(1150),
    [anon_sym_GT_AMP] = ACTIONS(1150),
    [anon_sym_LT_LT] = ACTIONS(1150),
    [anon_sym_LT_LT_DASH] = ACTIONS(1150),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1150),
    [anon_sym_LF] = ACTIONS(1150),
    [anon_sym_AMP] = ACTIONS(1150),
  },
  [343] = {
    [sym_file_descriptor] = ACTIONS(372),
    [anon_sym_PIPE] = ACTIONS(1136),
    [anon_sym_RPAREN] = ACTIONS(1136),
    [anon_sym_SEMI_SEMI] = ACTIONS(1136),
    [anon_sym_PIPE_AMP] = ACTIONS(1136),
    [anon_sym_AMP_AMP] = ACTIONS(1136),
    [anon_sym_PIPE_PIPE] = ACTIONS(1136),
    [anon_sym_LT] = ACTIONS(1136),
    [anon_sym_GT] = ACTIONS(1136),
    [anon_sym_GT_GT] = ACTIONS(1136),
    [anon_sym_AMP_GT] = ACTIONS(1136),
    [anon_sym_AMP_GT_GT] = ACTIONS(1136),
    [anon_sym_LT_AMP] = ACTIONS(1136),
    [anon_sym_GT_AMP] = ACTIONS(1136),
    [anon_sym_LT_LT] = ACTIONS(1136),
    [anon_sym_LT_LT_DASH] = ACTIONS(1136),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1136),
    [anon_sym_LF] = ACTIONS(1136),
    [anon_sym_AMP] = ACTIONS(1136),
  },
  [344] = {
    [sym_file_descriptor] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1154),
    [anon_sym_RPAREN] = ACTIONS(1154),
    [anon_sym_SEMI_SEMI] = ACTIONS(1154),
    [anon_sym_PIPE_AMP] = ACTIONS(1154),
    [anon_sym_AMP_AMP] = ACTIONS(1154),
    [anon_sym_PIPE_PIPE] = ACTIONS(1154),
    [anon_sym_LT] = ACTIONS(1154),
    [anon_sym_GT] = ACTIONS(1154),
    [anon_sym_GT_GT] = ACTIONS(1154),
    [anon_sym_AMP_GT] = ACTIONS(1154),
    [anon_sym_AMP_GT_GT] = ACTIONS(1154),
    [anon_sym_LT_AMP] = ACTIONS(1154),
    [anon_sym_GT_AMP] = ACTIONS(1154),
    [anon_sym_LT_LT] = ACTIONS(1154),
    [anon_sym_LT_LT_DASH] = ACTIONS(1154),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1154),
    [anon_sym_LF] = ACTIONS(1154),
    [anon_sym_AMP] = ACTIONS(1154),
  },
  [345] = {
    [sym_simple_expansion] = STATE(617),
    [sym_expansion] = STATE(617),
    [aux_sym_heredoc_repeat1] = STATE(621),
    [sym__heredoc_middle] = ACTIONS(1156),
    [sym__heredoc_end] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(1160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1162),
    [sym_comment] = ACTIONS(46),
  },
  [346] = {
    [sym_file_descriptor] = ACTIONS(1164),
    [anon_sym_PIPE] = ACTIONS(1166),
    [anon_sym_RPAREN] = ACTIONS(1166),
    [anon_sym_SEMI_SEMI] = ACTIONS(1166),
    [anon_sym_PIPE_AMP] = ACTIONS(1166),
    [anon_sym_AMP_AMP] = ACTIONS(1166),
    [anon_sym_PIPE_PIPE] = ACTIONS(1166),
    [anon_sym_LT] = ACTIONS(1166),
    [anon_sym_GT] = ACTIONS(1166),
    [anon_sym_GT_GT] = ACTIONS(1166),
    [anon_sym_AMP_GT] = ACTIONS(1166),
    [anon_sym_AMP_GT_GT] = ACTIONS(1166),
    [anon_sym_LT_AMP] = ACTIONS(1166),
    [anon_sym_GT_AMP] = ACTIONS(1166),
    [anon_sym_LT_LT] = ACTIONS(1166),
    [anon_sym_LT_LT_DASH] = ACTIONS(1166),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1166),
    [anon_sym_LF] = ACTIONS(1166),
    [anon_sym_AMP] = ACTIONS(1166),
  },
  [347] = {
    [sym_concatenation] = STATE(135),
    [sym_string] = STATE(130),
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [sym_process_substitution] = STATE(130),
    [aux_sym_for_statement_repeat1] = STATE(347),
    [sym_file_descriptor] = ACTIONS(1168),
    [sym_word] = ACTIONS(1170),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_SEMI_SEMI] = ACTIONS(1173),
    [anon_sym_PIPE_AMP] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1173),
    [anon_sym_PIPE_PIPE] = ACTIONS(1173),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_AMP_GT] = ACTIONS(1173),
    [anon_sym_AMP_GT_GT] = ACTIONS(1173),
    [anon_sym_LT_AMP] = ACTIONS(1173),
    [anon_sym_GT_AMP] = ACTIONS(1173),
    [anon_sym_LT_LT] = ACTIONS(1173),
    [anon_sym_LT_LT_DASH] = ACTIONS(1173),
    [anon_sym_DQUOTE] = ACTIONS(1175),
    [sym_raw_string] = ACTIONS(1178),
    [anon_sym_DOLLAR] = ACTIONS(1181),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1190),
    [anon_sym_LT_LPAREN] = ACTIONS(1193),
    [anon_sym_GT_LPAREN] = ACTIONS(1193),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1196),
    [anon_sym_SEMI] = ACTIONS(1173),
    [anon_sym_LF] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1173),
  },
  [348] = {
    [sym_file_redirect] = STATE(134),
    [sym_heredoc_redirect] = STATE(134),
    [aux_sym_command_repeat2] = STATE(349),
    [sym_file_descriptor] = ACTIONS(208),
    [anon_sym_PIPE] = ACTIONS(1199),
    [anon_sym_SEMI_SEMI] = ACTIONS(1199),
    [anon_sym_PIPE_AMP] = ACTIONS(1199),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(214),
    [anon_sym_GT] = ACTIONS(214),
    [anon_sym_GT_GT] = ACTIONS(214),
    [anon_sym_AMP_GT] = ACTIONS(214),
    [anon_sym_AMP_GT_GT] = ACTIONS(214),
    [anon_sym_LT_AMP] = ACTIONS(214),
    [anon_sym_GT_AMP] = ACTIONS(214),
    [anon_sym_LT_LT] = ACTIONS(216),
    [anon_sym_LT_LT_DASH] = ACTIONS(216),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_LF] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1199),
  },
  [349] = {
    [sym_file_redirect] = STATE(134),
    [sym_heredoc_redirect] = STATE(134),
    [aux_sym_command_repeat2] = STATE(349),
    [sym_file_descriptor] = ACTIONS(1201),
    [anon_sym_PIPE] = ACTIONS(1204),
    [anon_sym_SEMI_SEMI] = ACTIONS(1204),
    [anon_sym_PIPE_AMP] = ACTIONS(1204),
    [anon_sym_AMP_AMP] = ACTIONS(1204),
    [anon_sym_PIPE_PIPE] = ACTIONS(1204),
    [anon_sym_LT] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1206),
    [anon_sym_GT_GT] = ACTIONS(1206),
    [anon_sym_AMP_GT] = ACTIONS(1206),
    [anon_sym_AMP_GT_GT] = ACTIONS(1206),
    [anon_sym_LT_AMP] = ACTIONS(1206),
    [anon_sym_GT_AMP] = ACTIONS(1206),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_LT_LT_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1204),
    [anon_sym_LF] = ACTIONS(1204),
    [anon_sym_AMP] = ACTIONS(1204),
  },
  [350] = {
    [sym_concatenation] = STATE(623),
    [sym_string] = STATE(622),
    [sym_array] = STATE(623),
    [sym_simple_expansion] = STATE(622),
    [sym_expansion] = STATE(622),
    [sym_command_substitution] = STATE(622),
    [sym_process_substitution] = STATE(622),
    [sym_word] = ACTIONS(1212),
    [sym__empty_value] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1216),
    [anon_sym_DQUOTE] = ACTIONS(106),
    [sym_raw_string] = ACTIONS(1212),
    [anon_sym_DOLLAR] = ACTIONS(108),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(110),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(112),
    [anon_sym_BQUOTE] = ACTIONS(114),
    [anon_sym_LT_LPAREN] = ACTIONS(116),
    [anon_sym_GT_LPAREN] = ACTIONS(116),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1218),
  },
  [351] = {
    [sym_file_descriptor] = ACTIONS(294),
    [sym_word] = ACTIONS(294),
    [sym_variable_name] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(1006),
    [anon_sym_GT] = ACTIONS(1006),
    [anon_sym_GT_GT] = ACTIONS(294),
    [anon_sym_AMP_GT] = ACTIONS(1006),
    [anon_sym_AMP_GT_GT] = ACTIONS(294),
    [anon_sym_LT_AMP] = ACTIONS(294),
    [anon_sym_GT_AMP] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [sym_raw_string] = ACTIONS(294),
    [anon_sym_DOLLAR] = ACTIONS(1006),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(294),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(294),
    [anon_sym_BQUOTE] = ACTIONS(294),
    [anon_sym_LT_LPAREN] = ACTIONS(294),
    [anon_sym_GT_LPAREN] = ACTIONS(294),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1006),
  },
  [352] = {
    [sym_file_redirect] = STATE(134),
    [sym_heredoc_redirect] = STATE(134),
    [sym_concatenation] = STATE(135),
    [sym_string] = STATE(130),
    [sym_simple_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [sym_process_substitution] = STATE(130),
    [aux_sym_for_statement_repeat1] = STATE(347),
    [aux_sym_command_repeat2] = STATE(626),
    [sym_file_descriptor] = ACTIONS(208),
    [sym_word] = ACTIONS(210),
    [anon_sym_PIPE] = ACTIONS(1199),
    [anon_sym_SEMI_SEMI] = ACTIONS(1199),
    [anon_sym_PIPE_AMP] = ACTIONS(1199),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(214),
    [anon_sym_GT] = ACTIONS(214),
    [anon_sym_GT_GT] = ACTIONS(214),
    [anon_sym_AMP_GT] = ACTIONS(214),
    [anon_sym_AMP_GT_GT] = ACTIONS(214),
    [anon_sym_LT_AMP] = ACTIONS(214),
    [anon_sym_GT_AMP] = ACTIONS(214),
    [anon_sym_LT_LT] = ACTIONS(216),
    [anon_sym_LT_LT_DASH] = ACTIONS(216),
    [anon_sym_DQUOTE] = ACTIONS(218),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(222),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(224),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(226),
    [anon_sym_BQUOTE] = ACTIONS(228),
    [anon_sym_LT_LPAREN] = ACTIONS(230),
    [anon_sym_GT_LPAREN] = ACTIONS(230),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(232),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_LF] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1199),
  },
  [353] = {
    [sym_string] = STATE(627),
    [sym_simple_expansion] = STATE(627),
    [sym_expansion] = STATE(627),
    [sym_command_substitution] = STATE(627),
    [sym_process_substitution] = STATE(627),
    [sym_word] = ACTIONS(1220),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(1220),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(268),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(270),
    [anon_sym_BQUOTE] = ACTIONS(272),
    [anon_sym_LT_LPAREN] = ACTIONS(274),
    [anon_sym_GT_LPAREN] = ACTIONS(274),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1222),
  },
  [354] = {
    [aux_sym_concatenation_repeat1] = STATE(629),
    [sym_file_descriptor] = ACTIONS(254),
    [sym_word] = ACTIONS(254),
    [sym__concat] = ACTIONS(688),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(256),
    [anon_sym_SEMI_SEMI] = ACTIONS(256),
    [anon_sym_PIPE_AMP] = ACTIONS(256),
    [anon_sym_AMP_AMP] = ACTIONS(256),
    [anon_sym_PIPE_PIPE] = ACTIONS(256),
    [anon_sym_LT] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(256),
    [anon_sym_GT_GT] = ACTIONS(256),
    [anon_sym_AMP_GT] = ACTIONS(256),
    [anon_sym_AMP_GT_GT] = ACTIONS(256),
    [anon_sym_LT_AMP] = ACTIONS(256),
    [anon_sym_GT_AMP] = ACTIONS(256),
    [anon_sym_DQUOTE] = ACTIONS(256),
    [sym_raw_string] = ACTIONS(256),
    [anon_sym_DOLLAR] = ACTIONS(256),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(256),
    [anon_sym_BQUOTE] = ACTIONS(256),
    [anon_sym_LT_LPAREN] = ACTIONS(256),
    [anon_sym_GT_LPAREN] = ACTIONS(256),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(256),
    [anon_sym_SEMI] = ACTIONS(256),
    [anon_sym_LF] = ACTIONS(256),
    [anon_sym_AMP] = ACTIONS(256),
  },
  [355] = {
    [aux_sym_concatenation_repeat1] = STATE(631),
    [sym_word] = ACTIONS(556),
    [sym__concat] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(556),
    [anon_sym_DQUOTE] = ACTIONS(556),
    [sym_raw_string] = ACTIONS(556),
    [anon_sym_DOLLAR] = ACTIONS(1074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(556),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(556),
    [anon_sym_BQUOTE] = ACTIONS(556),
    [anon_sym_LT_LPAREN] = ACTIONS(556),
    [anon_sym_GT_LPAREN] = ACTIONS(556),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1074),
  },
  [356] = {
    [sym_file_descriptor] = ACTIONS(1226),
    [sym_word] = ACTIONS(1226),
    [sym_variable_name] = ACTIONS(1226),
    [anon_sym_PIPE] = ACTIONS(1228),
    [anon_sym_RPAREN] = ACTIONS(1228),
    [anon_sym_SEMI_SEMI] = ACTIONS(1228),
    [anon_sym_PIPE_AMP] = ACTIONS(1228),
    [anon_sym_AMP_AMP] = ACTIONS(1228),
    [anon_sym_PIPE_PIPE] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(1228),
    [anon_sym_GT] = ACTIONS(1228),
    [anon_sym_GT_GT] = ACTIONS(1228),
    [anon_sym_AMP_GT] = ACTIONS(1228),
    [anon_sym_AMP_GT_GT] = ACTIONS(1228),
    [anon_sym_LT_AMP] = ACTIONS(1228),
    [anon_sym_GT_AMP] = ACTIONS(1228),
    [anon_sym_DQUOTE] = ACTIONS(1228),
    [sym_raw_string] = ACTIONS(1228),
    [anon_sym_DOLLAR] = ACTIONS(1228),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1228),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1228),
    [anon_sym_BQUOTE] = ACTIONS(1228),
    [anon_sym_LT_LPAREN] = ACTIONS(1228),
    [anon_sym_GT_LPAREN] = ACTIONS(1228),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1228),
    [anon_sym_SEMI] = ACTIONS(1228),
    [anon_sym_LF] = ACTIONS(1228),
    [anon_sym_AMP] = ACTIONS(1228),
  },
  [357] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(633),
    [anon_sym_DQUOTE] = ACTIONS(1230),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [358] = {
    [sym_special_variable_name] = STATE(636),
    [anon_sym_DOLLAR] = ACTIONS(1232),
    [anon_sym_POUND] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(1232),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1232),
    [anon_sym_DASH] = ACTIONS(1232),
    [anon_sym_BANG] = ACTIONS(1232),
    [anon_sym_0] = ACTIONS(1236),
    [anon_sym__] = ACTIONS(1236),
  },
  [359] = {
    [sym_special_variable_name] = STATE(639),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(1238),
    [anon_sym_AT] = ACTIONS(138),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [360] = {
    [sym_for_statement] = STATE(640),
    [sym_while_statement] = STATE(640),
    [sym_if_statement] = STATE(640),
    [sym_case_statement] = STATE(640),
    [sym_function_definition] = STATE(640),
    [sym_subshell] = STATE(640),
    [sym_pipeline] = STATE(640),
    [sym_list] = STATE(640),
    [sym_command] = STATE(640),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(641),
    [sym_declaration_command] = STATE(640),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [361] = {
    [sym_for_statement] = STATE(642),
    [sym_while_statement] = STATE(642),
    [sym_if_statement] = STATE(642),
    [sym_case_statement] = STATE(642),
    [sym_function_definition] = STATE(642),
    [sym_subshell] = STATE(642),
    [sym_pipeline] = STATE(642),
    [sym_list] = STATE(642),
    [sym_command] = STATE(642),
    [sym_command_name] = STATE(118),
    [sym_variable_assignment] = STATE(643),
    [sym_declaration_command] = STATE(642),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(112),
    [sym_simple_expansion] = STATE(112),
    [sym_expansion] = STATE(112),
    [sym_command_substitution] = STATE(112),
    [sym_process_substitution] = STATE(112),
    [aux_sym_command_repeat1] = STATE(121),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(178),
    [sym_variable_name] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(184),
    [anon_sym_typeset] = ACTIONS(184),
    [anon_sym_export] = ACTIONS(184),
    [anon_sym_readonly] = ACTIONS(184),
    [anon_sym_local] = ACTIONS(184),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(178),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(186),
  },
  [362] = {
    [sym_for_statement] = STATE(644),
    [sym_while_statement] = STATE(644),
    [sym_if_statement] = STATE(644),
    [sym_case_statement] = STATE(644),
    [sym_function_definition] = STATE(644),
    [sym_subshell] = STATE(644),
    [sym_pipeline] = STATE(644),
    [sym_list] = STATE(644),
    [sym_command] = STATE(644),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(645),
    [sym_declaration_command] = STATE(644),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [363] = {
    [aux_sym_concatenation_repeat1] = STATE(646),
    [sym_word] = ACTIONS(580),
    [sym__concat] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(580),
    [anon_sym_DQUOTE] = ACTIONS(580),
    [sym_raw_string] = ACTIONS(580),
    [anon_sym_DOLLAR] = ACTIONS(1096),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(580),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(580),
    [anon_sym_BQUOTE] = ACTIONS(580),
    [anon_sym_LT_LPAREN] = ACTIONS(580),
    [anon_sym_GT_LPAREN] = ACTIONS(580),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1096),
  },
  [364] = {
    [sym_word] = ACTIONS(556),
    [anon_sym_RPAREN] = ACTIONS(556),
    [anon_sym_DQUOTE] = ACTIONS(556),
    [sym_raw_string] = ACTIONS(556),
    [anon_sym_DOLLAR] = ACTIONS(1074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(556),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(556),
    [anon_sym_BQUOTE] = ACTIONS(556),
    [anon_sym_LT_LPAREN] = ACTIONS(556),
    [anon_sym_GT_LPAREN] = ACTIONS(556),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1074),
  },
  [365] = {
    [sym_concatenation] = STATE(364),
    [sym_string] = STATE(355),
    [sym_simple_expansion] = STATE(355),
    [sym_expansion] = STATE(355),
    [sym_command_substitution] = STATE(355),
    [sym_process_substitution] = STATE(355),
    [aux_sym_for_statement_repeat1] = STATE(648),
    [sym_word] = ACTIONS(692),
    [anon_sym_RPAREN] = ACTIONS(1242),
    [anon_sym_DQUOTE] = ACTIONS(696),
    [sym_raw_string] = ACTIONS(692),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(700),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(702),
    [anon_sym_BQUOTE] = ACTIONS(704),
    [anon_sym_LT_LPAREN] = ACTIONS(706),
    [anon_sym_GT_LPAREN] = ACTIONS(706),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(708),
  },
  [366] = {
    [sym_file_descriptor] = ACTIONS(394),
    [sym_word] = ACTIONS(394),
    [sym__concat] = ACTIONS(394),
    [sym_variable_name] = ACTIONS(394),
    [anon_sym_PIPE] = ACTIONS(396),
    [anon_sym_RPAREN] = ACTIONS(396),
    [anon_sym_SEMI_SEMI] = ACTIONS(396),
    [anon_sym_PIPE_AMP] = ACTIONS(396),
    [anon_sym_AMP_AMP] = ACTIONS(396),
    [anon_sym_PIPE_PIPE] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(396),
    [anon_sym_GT] = ACTIONS(396),
    [anon_sym_GT_GT] = ACTIONS(396),
    [anon_sym_AMP_GT] = ACTIONS(396),
    [anon_sym_AMP_GT_GT] = ACTIONS(396),
    [anon_sym_LT_AMP] = ACTIONS(396),
    [anon_sym_GT_AMP] = ACTIONS(396),
    [anon_sym_DQUOTE] = ACTIONS(396),
    [sym_raw_string] = ACTIONS(396),
    [anon_sym_DOLLAR] = ACTIONS(396),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(396),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(396),
    [anon_sym_BQUOTE] = ACTIONS(396),
    [anon_sym_LT_LPAREN] = ACTIONS(396),
    [anon_sym_GT_LPAREN] = ACTIONS(396),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(396),
    [anon_sym_SEMI] = ACTIONS(396),
    [anon_sym_LF] = ACTIONS(396),
    [anon_sym_AMP] = ACTIONS(396),
  },
  [367] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(252),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [368] = {
    [sym_file_descriptor] = ACTIONS(412),
    [sym_word] = ACTIONS(412),
    [sym__concat] = ACTIONS(412),
    [sym_variable_name] = ACTIONS(412),
    [anon_sym_PIPE] = ACTIONS(414),
    [anon_sym_RPAREN] = ACTIONS(414),
    [anon_sym_SEMI_SEMI] = ACTIONS(414),
    [anon_sym_PIPE_AMP] = ACTIONS(414),
    [anon_sym_AMP_AMP] = ACTIONS(414),
    [anon_sym_PIPE_PIPE] = ACTIONS(414),
    [anon_sym_LT] = ACTIONS(414),
    [anon_sym_GT] = ACTIONS(414),
    [anon_sym_GT_GT] = ACTIONS(414),
    [anon_sym_AMP_GT] = ACTIONS(414),
    [anon_sym_AMP_GT_GT] = ACTIONS(414),
    [anon_sym_LT_AMP] = ACTIONS(414),
    [anon_sym_GT_AMP] = ACTIONS(414),
    [anon_sym_DQUOTE] = ACTIONS(414),
    [sym_raw_string] = ACTIONS(414),
    [anon_sym_DOLLAR] = ACTIONS(414),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(414),
    [anon_sym_BQUOTE] = ACTIONS(414),
    [anon_sym_LT_LPAREN] = ACTIONS(414),
    [anon_sym_GT_LPAREN] = ACTIONS(414),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(414),
    [anon_sym_SEMI] = ACTIONS(414),
    [anon_sym_LF] = ACTIONS(414),
    [anon_sym_AMP] = ACTIONS(414),
  },
  [369] = {
    [sym_file_descriptor] = ACTIONS(416),
    [sym_word] = ACTIONS(416),
    [sym__concat] = ACTIONS(416),
    [sym_variable_name] = ACTIONS(416),
    [anon_sym_PIPE] = ACTIONS(418),
    [anon_sym_RPAREN] = ACTIONS(418),
    [anon_sym_SEMI_SEMI] = ACTIONS(418),
    [anon_sym_PIPE_AMP] = ACTIONS(418),
    [anon_sym_AMP_AMP] = ACTIONS(418),
    [anon_sym_PIPE_PIPE] = ACTIONS(418),
    [anon_sym_LT] = ACTIONS(418),
    [anon_sym_GT] = ACTIONS(418),
    [anon_sym_GT_GT] = ACTIONS(418),
    [anon_sym_AMP_GT] = ACTIONS(418),
    [anon_sym_AMP_GT_GT] = ACTIONS(418),
    [anon_sym_LT_AMP] = ACTIONS(418),
    [anon_sym_GT_AMP] = ACTIONS(418),
    [anon_sym_DQUOTE] = ACTIONS(418),
    [sym_raw_string] = ACTIONS(418),
    [anon_sym_DOLLAR] = ACTIONS(418),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(418),
    [anon_sym_BQUOTE] = ACTIONS(418),
    [anon_sym_LT_LPAREN] = ACTIONS(418),
    [anon_sym_GT_LPAREN] = ACTIONS(418),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(418),
    [anon_sym_SEMI] = ACTIONS(418),
    [anon_sym_LF] = ACTIONS(418),
    [anon_sym_AMP] = ACTIONS(418),
  },
  [370] = {
    [sym_file_descriptor] = ACTIONS(420),
    [sym_word] = ACTIONS(420),
    [sym__concat] = ACTIONS(420),
    [sym_variable_name] = ACTIONS(420),
    [anon_sym_PIPE] = ACTIONS(422),
    [anon_sym_RPAREN] = ACTIONS(422),
    [anon_sym_SEMI_SEMI] = ACTIONS(422),
    [anon_sym_PIPE_AMP] = ACTIONS(422),
    [anon_sym_AMP_AMP] = ACTIONS(422),
    [anon_sym_PIPE_PIPE] = ACTIONS(422),
    [anon_sym_LT] = ACTIONS(422),
    [anon_sym_GT] = ACTIONS(422),
    [anon_sym_GT_GT] = ACTIONS(422),
    [anon_sym_AMP_GT] = ACTIONS(422),
    [anon_sym_AMP_GT_GT] = ACTIONS(422),
    [anon_sym_LT_AMP] = ACTIONS(422),
    [anon_sym_GT_AMP] = ACTIONS(422),
    [anon_sym_DQUOTE] = ACTIONS(422),
    [sym_raw_string] = ACTIONS(422),
    [anon_sym_DOLLAR] = ACTIONS(422),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(422),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(422),
    [anon_sym_BQUOTE] = ACTIONS(422),
    [anon_sym_LT_LPAREN] = ACTIONS(422),
    [anon_sym_GT_LPAREN] = ACTIONS(422),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(422),
    [anon_sym_SEMI] = ACTIONS(422),
    [anon_sym_LF] = ACTIONS(422),
    [anon_sym_AMP] = ACTIONS(422),
  },
  [371] = {
    [sym_special_variable_name] = STATE(651),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_EQ] = ACTIONS(412),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(138),
    [anon_sym_AT] = ACTIONS(138),
    [anon_sym_COLON] = ACTIONS(424),
    [anon_sym_COLON_QMARK] = ACTIONS(412),
    [anon_sym_COLON_DASH] = ACTIONS(412),
    [anon_sym_PERCENT] = ACTIONS(412),
    [anon_sym_SLASH] = ACTIONS(412),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [372] = {
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_EQ] = ACTIONS(1250),
    [anon_sym_LBRACK] = ACTIONS(1252),
    [anon_sym_COLON] = ACTIONS(1254),
    [anon_sym_COLON_QMARK] = ACTIONS(1250),
    [anon_sym_COLON_DASH] = ACTIONS(1250),
    [anon_sym_PERCENT] = ACTIONS(1250),
    [anon_sym_SLASH] = ACTIONS(1250),
    [sym_comment] = ACTIONS(46),
  },
  [373] = {
    [anon_sym_RBRACE] = ACTIONS(1256),
    [anon_sym_EQ] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_COLON] = ACTIONS(1262),
    [anon_sym_COLON_QMARK] = ACTIONS(1258),
    [anon_sym_COLON_DASH] = ACTIONS(1258),
    [anon_sym_PERCENT] = ACTIONS(1258),
    [anon_sym_SLASH] = ACTIONS(1258),
    [sym_comment] = ACTIONS(46),
  },
  [374] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1264),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [375] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1264),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [376] = {
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_BQUOTE] = ACTIONS(1264),
    [sym_comment] = ACTIONS(46),
  },
  [377] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(1264),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [378] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1266),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [379] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1266),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [380] = {
    [aux_sym_concatenation_repeat1] = STATE(629),
    [sym_file_descriptor] = ACTIONS(542),
    [sym_word] = ACTIONS(542),
    [sym__concat] = ACTIONS(688),
    [sym_variable_name] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_PIPE_PIPE] = ACTIONS(544),
    [anon_sym_LT] = ACTIONS(544),
    [anon_sym_GT] = ACTIONS(544),
    [anon_sym_GT_GT] = ACTIONS(544),
    [anon_sym_AMP_GT] = ACTIONS(544),
    [anon_sym_AMP_GT_GT] = ACTIONS(544),
    [anon_sym_LT_AMP] = ACTIONS(544),
    [anon_sym_GT_AMP] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(544),
    [sym_raw_string] = ACTIONS(544),
    [anon_sym_DOLLAR] = ACTIONS(544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(544),
    [anon_sym_BQUOTE] = ACTIONS(544),
    [anon_sym_LT_LPAREN] = ACTIONS(544),
    [anon_sym_GT_LPAREN] = ACTIONS(544),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(544),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [381] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [382] = {
    [anon_sym_EQ] = ACTIONS(1272),
    [anon_sym_PLUS_EQ] = ACTIONS(1272),
    [sym_comment] = ACTIONS(46),
  },
  [383] = {
    [aux_sym_concatenation_repeat1] = STATE(662),
    [sym__concat] = ACTIONS(726),
    [anon_sym_RBRACK] = ACTIONS(254),
    [sym_comment] = ACTIONS(46),
  },
  [384] = {
    [sym__concat] = ACTIONS(394),
    [anon_sym_PIPE] = ACTIONS(394),
    [anon_sym_RPAREN] = ACTIONS(394),
    [anon_sym_RBRACE] = ACTIONS(394),
    [anon_sym_RBRACK] = ACTIONS(394),
    [sym_comment] = ACTIONS(46),
  },
  [385] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(252),
    [anon_sym_DQUOTE] = ACTIONS(1274),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [386] = {
    [sym__concat] = ACTIONS(412),
    [anon_sym_PIPE] = ACTIONS(412),
    [anon_sym_RPAREN] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_RBRACK] = ACTIONS(412),
    [sym_comment] = ACTIONS(46),
  },
  [387] = {
    [sym__concat] = ACTIONS(416),
    [anon_sym_PIPE] = ACTIONS(416),
    [anon_sym_RPAREN] = ACTIONS(416),
    [anon_sym_RBRACE] = ACTIONS(416),
    [anon_sym_RBRACK] = ACTIONS(416),
    [sym_comment] = ACTIONS(46),
  },
  [388] = {
    [sym__concat] = ACTIONS(420),
    [anon_sym_PIPE] = ACTIONS(420),
    [anon_sym_RPAREN] = ACTIONS(420),
    [anon_sym_RBRACE] = ACTIONS(420),
    [anon_sym_RBRACK] = ACTIONS(420),
    [sym_comment] = ACTIONS(46),
  },
  [389] = {
    [sym_special_variable_name] = STATE(665),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_EQ] = ACTIONS(412),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(138),
    [anon_sym_AT] = ACTIONS(138),
    [anon_sym_COLON] = ACTIONS(424),
    [anon_sym_COLON_QMARK] = ACTIONS(412),
    [anon_sym_COLON_DASH] = ACTIONS(412),
    [anon_sym_PERCENT] = ACTIONS(412),
    [anon_sym_SLASH] = ACTIONS(412),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [390] = {
    [anon_sym_RBRACE] = ACTIONS(1278),
    [anon_sym_EQ] = ACTIONS(1280),
    [anon_sym_LBRACK] = ACTIONS(1282),
    [anon_sym_COLON] = ACTIONS(1284),
    [anon_sym_COLON_QMARK] = ACTIONS(1280),
    [anon_sym_COLON_DASH] = ACTIONS(1280),
    [anon_sym_PERCENT] = ACTIONS(1280),
    [anon_sym_SLASH] = ACTIONS(1280),
    [sym_comment] = ACTIONS(46),
  },
  [391] = {
    [anon_sym_RBRACE] = ACTIONS(1286),
    [anon_sym_EQ] = ACTIONS(1288),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_COLON] = ACTIONS(1292),
    [anon_sym_COLON_QMARK] = ACTIONS(1288),
    [anon_sym_COLON_DASH] = ACTIONS(1288),
    [anon_sym_PERCENT] = ACTIONS(1288),
    [anon_sym_SLASH] = ACTIONS(1288),
    [sym_comment] = ACTIONS(46),
  },
  [392] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1294),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [393] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1294),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [394] = {
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_BQUOTE] = ACTIONS(1294),
    [sym_comment] = ACTIONS(46),
  },
  [395] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(1294),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [396] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1296),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [397] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1296),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [398] = {
    [anon_sym_EQ] = ACTIONS(1298),
    [anon_sym_PLUS_EQ] = ACTIONS(1298),
    [sym_comment] = ACTIONS(46),
  },
  [399] = {
    [aux_sym_concatenation_repeat1] = STATE(662),
    [sym__concat] = ACTIONS(726),
    [anon_sym_RBRACK] = ACTIONS(542),
    [sym_comment] = ACTIONS(46),
  },
  [400] = {
    [aux_sym_concatenation_repeat1] = STATE(675),
    [sym_word] = ACTIONS(556),
    [sym__concat] = ACTIONS(1300),
    [anon_sym_SEMI_SEMI] = ACTIONS(558),
    [anon_sym_DQUOTE] = ACTIONS(558),
    [sym_raw_string] = ACTIONS(558),
    [anon_sym_DOLLAR] = ACTIONS(558),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(558),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(558),
    [anon_sym_BQUOTE] = ACTIONS(558),
    [anon_sym_LT_LPAREN] = ACTIONS(558),
    [anon_sym_GT_LPAREN] = ACTIONS(558),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(558),
    [anon_sym_SEMI] = ACTIONS(558),
    [anon_sym_LF] = ACTIONS(558),
    [anon_sym_AMP] = ACTIONS(558),
  },
  [401] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(677),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [402] = {
    [sym_special_variable_name] = STATE(680),
    [anon_sym_DOLLAR] = ACTIONS(1304),
    [anon_sym_POUND] = ACTIONS(1304),
    [anon_sym_AT] = ACTIONS(1304),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_QMARK] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_0] = ACTIONS(1308),
    [anon_sym__] = ACTIONS(1308),
  },
  [403] = {
    [sym_special_variable_name] = STATE(683),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(1310),
    [anon_sym_AT] = ACTIONS(138),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1312),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [404] = {
    [sym_for_statement] = STATE(684),
    [sym_while_statement] = STATE(684),
    [sym_if_statement] = STATE(684),
    [sym_case_statement] = STATE(684),
    [sym_function_definition] = STATE(684),
    [sym_subshell] = STATE(684),
    [sym_pipeline] = STATE(684),
    [sym_list] = STATE(684),
    [sym_command] = STATE(684),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(685),
    [sym_declaration_command] = STATE(684),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [405] = {
    [sym_for_statement] = STATE(686),
    [sym_while_statement] = STATE(686),
    [sym_if_statement] = STATE(686),
    [sym_case_statement] = STATE(686),
    [sym_function_definition] = STATE(686),
    [sym_subshell] = STATE(686),
    [sym_pipeline] = STATE(686),
    [sym_list] = STATE(686),
    [sym_command] = STATE(686),
    [sym_command_name] = STATE(118),
    [sym_variable_assignment] = STATE(687),
    [sym_declaration_command] = STATE(686),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(112),
    [sym_simple_expansion] = STATE(112),
    [sym_expansion] = STATE(112),
    [sym_command_substitution] = STATE(112),
    [sym_process_substitution] = STATE(112),
    [aux_sym_command_repeat1] = STATE(121),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(178),
    [sym_variable_name] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(184),
    [anon_sym_typeset] = ACTIONS(184),
    [anon_sym_export] = ACTIONS(184),
    [anon_sym_readonly] = ACTIONS(184),
    [anon_sym_local] = ACTIONS(184),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(178),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(186),
  },
  [406] = {
    [sym_for_statement] = STATE(688),
    [sym_while_statement] = STATE(688),
    [sym_if_statement] = STATE(688),
    [sym_case_statement] = STATE(688),
    [sym_function_definition] = STATE(688),
    [sym_subshell] = STATE(688),
    [sym_pipeline] = STATE(688),
    [sym_list] = STATE(688),
    [sym_command] = STATE(688),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(689),
    [sym_declaration_command] = STATE(688),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [407] = {
    [aux_sym_concatenation_repeat1] = STATE(690),
    [sym_word] = ACTIONS(580),
    [sym__concat] = ACTIONS(1300),
    [anon_sym_SEMI_SEMI] = ACTIONS(582),
    [anon_sym_DQUOTE] = ACTIONS(582),
    [sym_raw_string] = ACTIONS(582),
    [anon_sym_DOLLAR] = ACTIONS(582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(582),
    [anon_sym_BQUOTE] = ACTIONS(582),
    [anon_sym_LT_LPAREN] = ACTIONS(582),
    [anon_sym_GT_LPAREN] = ACTIONS(582),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(582),
    [anon_sym_LF] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(582),
  },
  [408] = {
    [sym_word] = ACTIONS(556),
    [anon_sym_SEMI_SEMI] = ACTIONS(558),
    [anon_sym_DQUOTE] = ACTIONS(558),
    [sym_raw_string] = ACTIONS(558),
    [anon_sym_DOLLAR] = ACTIONS(558),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(558),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(558),
    [anon_sym_BQUOTE] = ACTIONS(558),
    [anon_sym_LT_LPAREN] = ACTIONS(558),
    [anon_sym_GT_LPAREN] = ACTIONS(558),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(558),
    [anon_sym_SEMI] = ACTIONS(558),
    [anon_sym_LF] = ACTIONS(558),
    [anon_sym_AMP] = ACTIONS(558),
  },
  [409] = {
    [sym_concatenation] = STATE(408),
    [sym_string] = STATE(400),
    [sym_simple_expansion] = STATE(400),
    [sym_expansion] = STATE(400),
    [sym_command_substitution] = STATE(400),
    [sym_process_substitution] = STATE(400),
    [aux_sym_for_statement_repeat1] = STATE(692),
    [sym_word] = ACTIONS(744),
    [anon_sym_SEMI_SEMI] = ACTIONS(1314),
    [anon_sym_DQUOTE] = ACTIONS(1316),
    [sym_raw_string] = ACTIONS(1318),
    [anon_sym_DOLLAR] = ACTIONS(1320),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1322),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1324),
    [anon_sym_BQUOTE] = ACTIONS(1326),
    [anon_sym_LT_LPAREN] = ACTIONS(1328),
    [anon_sym_GT_LPAREN] = ACTIONS(1328),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1330),
    [anon_sym_SEMI] = ACTIONS(1314),
    [anon_sym_LF] = ACTIONS(1314),
    [anon_sym_AMP] = ACTIONS(1314),
  },
  [410] = {
    [anon_sym_PIPE] = ACTIONS(1332),
    [anon_sym_RPAREN] = ACTIONS(1332),
    [anon_sym_SEMI_SEMI] = ACTIONS(1332),
    [anon_sym_PIPE_AMP] = ACTIONS(1332),
    [anon_sym_AMP_AMP] = ACTIONS(1332),
    [anon_sym_PIPE_PIPE] = ACTIONS(1332),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1332),
    [anon_sym_LF] = ACTIONS(1332),
    [anon_sym_AMP] = ACTIONS(1332),
  },
  [411] = {
    [sym_file_descriptor] = ACTIONS(196),
    [sym_word] = ACTIONS(196),
    [sym_variable_name] = ACTIONS(196),
    [anon_sym_for] = ACTIONS(198),
    [anon_sym_while] = ACTIONS(198),
    [anon_sym_done] = ACTIONS(198),
    [anon_sym_if] = ACTIONS(198),
    [anon_sym_case] = ACTIONS(198),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(196),
    [anon_sym_declare] = ACTIONS(198),
    [anon_sym_typeset] = ACTIONS(198),
    [anon_sym_export] = ACTIONS(198),
    [anon_sym_readonly] = ACTIONS(198),
    [anon_sym_local] = ACTIONS(198),
    [anon_sym_LT] = ACTIONS(198),
    [anon_sym_GT] = ACTIONS(198),
    [anon_sym_GT_GT] = ACTIONS(196),
    [anon_sym_AMP_GT] = ACTIONS(198),
    [anon_sym_AMP_GT_GT] = ACTIONS(196),
    [anon_sym_LT_AMP] = ACTIONS(196),
    [anon_sym_GT_AMP] = ACTIONS(196),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [sym_raw_string] = ACTIONS(196),
    [anon_sym_DOLLAR] = ACTIONS(198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(196),
    [anon_sym_BQUOTE] = ACTIONS(196),
    [anon_sym_LT_LPAREN] = ACTIONS(196),
    [anon_sym_GT_LPAREN] = ACTIONS(196),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(200),
  },
  [412] = {
    [anon_sym_PIPE] = ACTIONS(202),
    [anon_sym_SEMI_SEMI] = ACTIONS(1334),
    [anon_sym_PIPE_AMP] = ACTIONS(202),
    [anon_sym_AMP_AMP] = ACTIONS(206),
    [anon_sym_PIPE_PIPE] = ACTIONS(206),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1334),
    [anon_sym_LF] = ACTIONS(1334),
    [anon_sym_AMP] = ACTIONS(1334),
  },
  [413] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(202),
    [anon_sym_SEMI_SEMI] = ACTIONS(1334),
    [anon_sym_PIPE_AMP] = ACTIONS(202),
    [anon_sym_AMP_AMP] = ACTIONS(206),
    [anon_sym_PIPE_PIPE] = ACTIONS(206),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(236),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(236),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_DQUOTE] = ACTIONS(236),
    [sym_raw_string] = ACTIONS(236),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(236),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(236),
    [anon_sym_BQUOTE] = ACTIONS(236),
    [anon_sym_LT_LPAREN] = ACTIONS(236),
    [anon_sym_GT_LPAREN] = ACTIONS(236),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(1334),
    [anon_sym_LF] = ACTIONS(1334),
    [anon_sym_AMP] = ACTIONS(1334),
  },
  [414] = {
    [sym__terminated_statement] = STATE(411),
    [sym_for_statement] = STATE(412),
    [sym_while_statement] = STATE(412),
    [sym_if_statement] = STATE(412),
    [sym_case_statement] = STATE(412),
    [sym_function_definition] = STATE(412),
    [sym_subshell] = STATE(412),
    [sym_pipeline] = STATE(412),
    [sym_list] = STATE(412),
    [sym_command] = STATE(412),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(413),
    [sym_declaration_command] = STATE(412),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(695),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_done] = ACTIONS(1336),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [415] = {
    [anon_sym_PIPE] = ACTIONS(1338),
    [anon_sym_RPAREN] = ACTIONS(1338),
    [anon_sym_SEMI_SEMI] = ACTIONS(1338),
    [anon_sym_PIPE_AMP] = ACTIONS(1338),
    [anon_sym_AMP_AMP] = ACTIONS(1338),
    [anon_sym_PIPE_PIPE] = ACTIONS(1338),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1338),
    [anon_sym_LF] = ACTIONS(1338),
    [anon_sym_AMP] = ACTIONS(1338),
  },
  [416] = {
    [sym__terminated_statement] = STATE(696),
    [sym_for_statement] = STATE(38),
    [sym_while_statement] = STATE(38),
    [sym_if_statement] = STATE(38),
    [sym_case_statement] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_subshell] = STATE(38),
    [sym_pipeline] = STATE(38),
    [sym_list] = STATE(38),
    [sym_command] = STATE(38),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(39),
    [sym_declaration_command] = STATE(38),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [417] = {
    [sym__terminated_statement] = STATE(697),
    [sym_for_statement] = STATE(698),
    [sym_while_statement] = STATE(698),
    [sym_if_statement] = STATE(698),
    [sym_case_statement] = STATE(698),
    [sym_function_definition] = STATE(698),
    [sym_subshell] = STATE(698),
    [sym_pipeline] = STATE(698),
    [sym_list] = STATE(698),
    [sym_command] = STATE(698),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(699),
    [sym_declaration_command] = STATE(698),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(700),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(1340),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [418] = {
    [sym_file_descriptor] = ACTIONS(196),
    [sym_word] = ACTIONS(196),
    [sym_variable_name] = ACTIONS(196),
    [anon_sym_for] = ACTIONS(198),
    [anon_sym_while] = ACTIONS(198),
    [anon_sym_if] = ACTIONS(198),
    [anon_sym_fi] = ACTIONS(198),
    [anon_sym_elif] = ACTIONS(198),
    [anon_sym_else] = ACTIONS(198),
    [anon_sym_case] = ACTIONS(198),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(196),
    [anon_sym_declare] = ACTIONS(198),
    [anon_sym_typeset] = ACTIONS(198),
    [anon_sym_export] = ACTIONS(198),
    [anon_sym_readonly] = ACTIONS(198),
    [anon_sym_local] = ACTIONS(198),
    [anon_sym_LT] = ACTIONS(198),
    [anon_sym_GT] = ACTIONS(198),
    [anon_sym_GT_GT] = ACTIONS(196),
    [anon_sym_AMP_GT] = ACTIONS(198),
    [anon_sym_AMP_GT_GT] = ACTIONS(196),
    [anon_sym_LT_AMP] = ACTIONS(196),
    [anon_sym_GT_AMP] = ACTIONS(196),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [sym_raw_string] = ACTIONS(196),
    [anon_sym_DOLLAR] = ACTIONS(198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(196),
    [anon_sym_BQUOTE] = ACTIONS(196),
    [anon_sym_LT_LPAREN] = ACTIONS(196),
    [anon_sym_GT_LPAREN] = ACTIONS(196),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(200),
  },
  [419] = {
    [anon_sym_PIPE] = ACTIONS(202),
    [anon_sym_SEMI_SEMI] = ACTIONS(1342),
    [anon_sym_PIPE_AMP] = ACTIONS(202),
    [anon_sym_AMP_AMP] = ACTIONS(206),
    [anon_sym_PIPE_PIPE] = ACTIONS(206),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1342),
    [anon_sym_LF] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(1342),
  },
  [420] = {
    [anon_sym_fi] = ACTIONS(1344),
    [anon_sym_elif] = ACTIONS(1344),
    [anon_sym_else] = ACTIONS(1344),
    [sym_comment] = ACTIONS(46),
  },
  [421] = {
    [anon_sym_fi] = ACTIONS(1346),
    [sym_comment] = ACTIONS(46),
  },
  [422] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(202),
    [anon_sym_SEMI_SEMI] = ACTIONS(1342),
    [anon_sym_PIPE_AMP] = ACTIONS(202),
    [anon_sym_AMP_AMP] = ACTIONS(206),
    [anon_sym_PIPE_PIPE] = ACTIONS(206),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(236),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(236),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_DQUOTE] = ACTIONS(236),
    [sym_raw_string] = ACTIONS(236),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(236),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(236),
    [anon_sym_BQUOTE] = ACTIONS(236),
    [anon_sym_LT_LPAREN] = ACTIONS(236),
    [anon_sym_GT_LPAREN] = ACTIONS(236),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(1342),
    [anon_sym_LF] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(1342),
  },
  [423] = {
    [sym__terminated_statement] = STATE(418),
    [sym_for_statement] = STATE(419),
    [sym_while_statement] = STATE(419),
    [sym_if_statement] = STATE(419),
    [sym_elif_clause] = STATE(420),
    [sym_else_clause] = STATE(703),
    [sym_case_statement] = STATE(419),
    [sym_function_definition] = STATE(419),
    [sym_subshell] = STATE(419),
    [sym_pipeline] = STATE(419),
    [sym_list] = STATE(419),
    [sym_command] = STATE(419),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(422),
    [sym_declaration_command] = STATE(419),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(704),
    [aux_sym_if_statement_repeat1] = STATE(705),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(1348),
    [anon_sym_elif] = ACTIONS(766),
    [anon_sym_else] = ACTIONS(768),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [424] = {
    [sym_elif_clause] = STATE(420),
    [sym_else_clause] = STATE(703),
    [aux_sym_if_statement_repeat1] = STATE(706),
    [anon_sym_fi] = ACTIONS(1346),
    [anon_sym_elif] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1352),
    [sym_comment] = ACTIONS(46),
  },
  [425] = {
    [sym__concat] = ACTIONS(675),
    [anon_sym_in] = ACTIONS(677),
    [anon_sym_SEMI_SEMI] = ACTIONS(677),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(677),
  },
  [426] = {
    [sym__concat] = ACTIONS(679),
    [anon_sym_in] = ACTIONS(681),
    [anon_sym_SEMI_SEMI] = ACTIONS(681),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(681),
    [anon_sym_AMP] = ACTIONS(681),
  },
  [427] = {
    [sym_case_item] = STATE(710),
    [sym_concatenation] = STATE(711),
    [sym_string] = STATE(707),
    [sym_simple_expansion] = STATE(707),
    [sym_expansion] = STATE(707),
    [sym_command_substitution] = STATE(707),
    [sym_process_substitution] = STATE(707),
    [aux_sym_case_statement_repeat1] = STATE(712),
    [sym_word] = ACTIONS(1354),
    [anon_sym_esac] = ACTIONS(1356),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1354),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1358),
  },
  [428] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1360),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1360),
    [anon_sym_LF] = ACTIONS(1360),
    [anon_sym_AMP] = ACTIONS(1360),
  },
  [429] = {
    [aux_sym_concatenation_repeat1] = STATE(429),
    [sym__concat] = ACTIONS(1362),
    [anon_sym_in] = ACTIONS(677),
    [anon_sym_SEMI_SEMI] = ACTIONS(677),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(677),
  },
  [430] = {
    [sym__concat] = ACTIONS(931),
    [anon_sym_in] = ACTIONS(933),
    [anon_sym_SEMI_SEMI] = ACTIONS(933),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(933),
    [anon_sym_LF] = ACTIONS(933),
    [anon_sym_AMP] = ACTIONS(933),
  },
  [431] = {
    [anon_sym_RBRACE] = ACTIONS(1365),
    [anon_sym_LBRACK] = ACTIONS(1367),
    [sym_comment] = ACTIONS(46),
  },
  [432] = {
    [anon_sym_RBRACE] = ACTIONS(1369),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [sym_comment] = ACTIONS(46),
  },
  [433] = {
    [sym__concat] = ACTIONS(960),
    [anon_sym_in] = ACTIONS(962),
    [anon_sym_SEMI_SEMI] = ACTIONS(962),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(962),
    [anon_sym_LF] = ACTIONS(962),
    [anon_sym_AMP] = ACTIONS(962),
  },
  [434] = {
    [sym_concatenation] = STATE(721),
    [sym_string] = STATE(718),
    [sym_simple_expansion] = STATE(718),
    [sym_expansion] = STATE(718),
    [sym_command_substitution] = STATE(718),
    [sym_process_substitution] = STATE(718),
    [sym_word] = ACTIONS(1373),
    [anon_sym_RBRACE] = ACTIONS(1375),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1377),
  },
  [435] = {
    [anon_sym_AT] = ACTIONS(1379),
    [sym_comment] = ACTIONS(46),
  },
  [436] = {
    [sym__concat] = ACTIONS(972),
    [anon_sym_in] = ACTIONS(974),
    [anon_sym_SEMI_SEMI] = ACTIONS(974),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(974),
    [anon_sym_LF] = ACTIONS(974),
    [anon_sym_AMP] = ACTIONS(974),
  },
  [437] = {
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(723),
    [sym_simple_expansion] = STATE(723),
    [sym_expansion] = STATE(723),
    [sym_command_substitution] = STATE(723),
    [sym_process_substitution] = STATE(723),
    [sym_word] = ACTIONS(1381),
    [anon_sym_RBRACE] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1381),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1383),
  },
  [438] = {
    [anon_sym_AT] = ACTIONS(1385),
    [sym_comment] = ACTIONS(46),
  },
  [439] = {
    [sym__concat] = ACTIONS(1066),
    [anon_sym_in] = ACTIONS(1068),
    [anon_sym_SEMI_SEMI] = ACTIONS(1068),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1068),
    [anon_sym_LF] = ACTIONS(1068),
    [anon_sym_AMP] = ACTIONS(1068),
  },
  [440] = {
    [sym__concat] = ACTIONS(1122),
    [anon_sym_in] = ACTIONS(1124),
    [anon_sym_SEMI_SEMI] = ACTIONS(1124),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1124),
    [anon_sym_LF] = ACTIONS(1124),
    [anon_sym_AMP] = ACTIONS(1124),
  },
  [441] = {
    [sym_case_item] = STATE(710),
    [sym_concatenation] = STATE(711),
    [sym_string] = STATE(707),
    [sym_simple_expansion] = STATE(707),
    [sym_expansion] = STATE(707),
    [sym_command_substitution] = STATE(707),
    [sym_process_substitution] = STATE(707),
    [aux_sym_case_statement_repeat1] = STATE(728),
    [sym_word] = ACTIONS(1354),
    [anon_sym_esac] = ACTIONS(1387),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1354),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1358),
  },
  [442] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1389),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1389),
    [anon_sym_LF] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
  },
  [443] = {
    [sym_compound_statement] = STATE(730),
    [anon_sym_LBRACE] = ACTIONS(330),
    [sym_comment] = ACTIONS(46),
  },
  [444] = {
    [sym_file_descriptor] = ACTIONS(1391),
    [anon_sym_PIPE] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(1393),
    [anon_sym_SEMI_SEMI] = ACTIONS(1393),
    [anon_sym_PIPE_AMP] = ACTIONS(1393),
    [anon_sym_AMP_AMP] = ACTIONS(1393),
    [anon_sym_PIPE_PIPE] = ACTIONS(1393),
    [anon_sym_LT] = ACTIONS(1393),
    [anon_sym_GT] = ACTIONS(1393),
    [anon_sym_GT_GT] = ACTIONS(1393),
    [anon_sym_AMP_GT] = ACTIONS(1393),
    [anon_sym_AMP_GT_GT] = ACTIONS(1393),
    [anon_sym_LT_AMP] = ACTIONS(1393),
    [anon_sym_GT_AMP] = ACTIONS(1393),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1393),
    [anon_sym_LF] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1393),
  },
  [445] = {
    [sym__terminated_statement] = STATE(21),
    [sym_for_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_case_statement] = STATE(22),
    [sym_function_definition] = STATE(22),
    [sym_subshell] = STATE(22),
    [sym_pipeline] = STATE(22),
    [sym_list] = STATE(22),
    [sym_command] = STATE(22),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(24),
    [sym_declaration_command] = STATE(22),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(732),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_RBRACE] = ACTIONS(1395),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [446] = {
    [anon_sym_LT] = ACTIONS(1397),
    [anon_sym_GT] = ACTIONS(1397),
    [anon_sym_GT_GT] = ACTIONS(1399),
    [anon_sym_AMP_GT] = ACTIONS(1397),
    [anon_sym_AMP_GT_GT] = ACTIONS(1399),
    [anon_sym_LT_AMP] = ACTIONS(1399),
    [anon_sym_GT_AMP] = ACTIONS(1399),
    [sym_comment] = ACTIONS(46),
  },
  [447] = {
    [sym_concatenation] = STATE(742),
    [sym_string] = STATE(734),
    [sym_simple_expansion] = STATE(734),
    [sym_expansion] = STATE(734),
    [sym_command_substitution] = STATE(734),
    [sym_process_substitution] = STATE(734),
    [sym_word] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1403),
    [sym_raw_string] = ACTIONS(1401),
    [anon_sym_DOLLAR] = ACTIONS(1405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1411),
    [anon_sym_LT_LPAREN] = ACTIONS(1413),
    [anon_sym_GT_LPAREN] = ACTIONS(1413),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1415),
  },
  [448] = {
    [anon_sym_PIPE] = ACTIONS(1417),
    [anon_sym_RPAREN] = ACTIONS(1417),
    [anon_sym_SEMI_SEMI] = ACTIONS(1417),
    [anon_sym_PIPE_AMP] = ACTIONS(1417),
    [anon_sym_AMP_AMP] = ACTIONS(1417),
    [anon_sym_PIPE_PIPE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1417),
    [anon_sym_LF] = ACTIONS(1417),
    [anon_sym_AMP] = ACTIONS(1417),
  },
  [449] = {
    [aux_sym_concatenation_repeat1] = STATE(449),
    [sym_file_descriptor] = ACTIONS(675),
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(677),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_SEMI_SEMI] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(677),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(677),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(677),
    [anon_sym_LT_LT_DASH] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(677),
    [sym_raw_string] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [anon_sym_LT_LPAREN] = ACTIONS(677),
    [anon_sym_GT_LPAREN] = ACTIONS(677),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(677),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(677),
  },
  [450] = {
    [aux_sym_concatenation_repeat1] = STATE(743),
    [sym_file_descriptor] = ACTIONS(686),
    [sym_word] = ACTIONS(686),
    [sym__concat] = ACTIONS(688),
    [sym_variable_name] = ACTIONS(686),
    [anon_sym_PIPE] = ACTIONS(690),
    [anon_sym_RPAREN] = ACTIONS(690),
    [anon_sym_SEMI_SEMI] = ACTIONS(690),
    [anon_sym_PIPE_AMP] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(690),
    [anon_sym_GT] = ACTIONS(690),
    [anon_sym_GT_GT] = ACTIONS(690),
    [anon_sym_AMP_GT] = ACTIONS(690),
    [anon_sym_AMP_GT_GT] = ACTIONS(690),
    [anon_sym_LT_AMP] = ACTIONS(690),
    [anon_sym_GT_AMP] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(690),
    [sym_raw_string] = ACTIONS(690),
    [anon_sym_DOLLAR] = ACTIONS(690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(690),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [anon_sym_LT_LPAREN] = ACTIONS(690),
    [anon_sym_GT_LPAREN] = ACTIONS(690),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(690),
    [anon_sym_SEMI] = ACTIONS(690),
    [anon_sym_LF] = ACTIONS(690),
    [anon_sym_AMP] = ACTIONS(690),
  },
  [451] = {
    [aux_sym_concatenation_repeat1] = STATE(744),
    [sym_file_descriptor] = ACTIONS(722),
    [sym_word] = ACTIONS(722),
    [sym__concat] = ACTIONS(688),
    [sym_variable_name] = ACTIONS(722),
    [anon_sym_PIPE] = ACTIONS(724),
    [anon_sym_RPAREN] = ACTIONS(724),
    [anon_sym_SEMI_SEMI] = ACTIONS(724),
    [anon_sym_PIPE_AMP] = ACTIONS(724),
    [anon_sym_AMP_AMP] = ACTIONS(724),
    [anon_sym_PIPE_PIPE] = ACTIONS(724),
    [anon_sym_LT] = ACTIONS(724),
    [anon_sym_GT] = ACTIONS(724),
    [anon_sym_GT_GT] = ACTIONS(724),
    [anon_sym_AMP_GT] = ACTIONS(724),
    [anon_sym_AMP_GT_GT] = ACTIONS(724),
    [anon_sym_LT_AMP] = ACTIONS(724),
    [anon_sym_GT_AMP] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(724),
    [sym_raw_string] = ACTIONS(724),
    [anon_sym_DOLLAR] = ACTIONS(724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(724),
    [anon_sym_BQUOTE] = ACTIONS(724),
    [anon_sym_LT_LPAREN] = ACTIONS(724),
    [anon_sym_GT_LPAREN] = ACTIONS(724),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(724),
    [anon_sym_LF] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(724),
  },
  [452] = {
    [anon_sym_RPAREN] = ACTIONS(1419),
    [sym_comment] = ACTIONS(46),
  },
  [453] = {
    [sym_file_redirect] = STATE(448),
    [sym_file_descriptor] = ACTIONS(1421),
    [anon_sym_PIPE] = ACTIONS(812),
    [anon_sym_RPAREN] = ACTIONS(812),
    [anon_sym_SEMI_SEMI] = ACTIONS(812),
    [anon_sym_PIPE_AMP] = ACTIONS(812),
    [anon_sym_AMP_AMP] = ACTIONS(812),
    [anon_sym_PIPE_PIPE] = ACTIONS(812),
    [anon_sym_LT] = ACTIONS(1423),
    [anon_sym_GT] = ACTIONS(1423),
    [anon_sym_GT_GT] = ACTIONS(1423),
    [anon_sym_AMP_GT] = ACTIONS(1423),
    [anon_sym_AMP_GT_GT] = ACTIONS(1423),
    [anon_sym_LT_AMP] = ACTIONS(1423),
    [anon_sym_GT_AMP] = ACTIONS(1423),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(812),
    [anon_sym_LF] = ACTIONS(812),
    [anon_sym_AMP] = ACTIONS(812),
  },
  [454] = {
    [sym_concatenation] = STATE(469),
    [sym_string] = STATE(748),
    [sym_array] = STATE(469),
    [sym_simple_expansion] = STATE(748),
    [sym_expansion] = STATE(748),
    [sym_command_substitution] = STATE(748),
    [sym_process_substitution] = STATE(748),
    [sym_word] = ACTIONS(1425),
    [sym__empty_value] = ACTIONS(844),
    [anon_sym_LPAREN] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_raw_string] = ACTIONS(1425),
    [anon_sym_DOLLAR] = ACTIONS(850),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(852),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(854),
    [anon_sym_BQUOTE] = ACTIONS(856),
    [anon_sym_LT_LPAREN] = ACTIONS(858),
    [anon_sym_GT_LPAREN] = ACTIONS(858),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1427),
  },
  [455] = {
    [sym_variable_assignment] = STATE(62),
    [sym_subscript] = STATE(202),
    [aux_sym_declaration_command_repeat1] = STATE(455),
    [sym_word] = ACTIONS(862),
    [sym_variable_name] = ACTIONS(1429),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(868),
    [anon_sym_SEMI_SEMI] = ACTIONS(868),
    [anon_sym_PIPE_AMP] = ACTIONS(868),
    [anon_sym_AMP_AMP] = ACTIONS(868),
    [anon_sym_PIPE_PIPE] = ACTIONS(868),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(870),
    [anon_sym_SEMI] = ACTIONS(868),
    [anon_sym_LF] = ACTIONS(868),
    [anon_sym_AMP] = ACTIONS(868),
  },
  [456] = {
    [sym_compound_statement] = STATE(750),
    [anon_sym_LBRACE] = ACTIONS(330),
    [sym_comment] = ACTIONS(46),
  },
  [457] = {
    [anon_sym_PIPE] = ACTIONS(1432),
    [anon_sym_RPAREN] = ACTIONS(1432),
    [anon_sym_SEMI_SEMI] = ACTIONS(1432),
    [anon_sym_PIPE_AMP] = ACTIONS(1432),
    [anon_sym_AMP_AMP] = ACTIONS(1432),
    [anon_sym_PIPE_PIPE] = ACTIONS(1432),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1432),
    [anon_sym_LF] = ACTIONS(1432),
    [anon_sym_AMP] = ACTIONS(1432),
  },
  [458] = {
    [anon_sym_PIPE] = ACTIONS(340),
    [anon_sym_RPAREN] = ACTIONS(1128),
    [anon_sym_SEMI_SEMI] = ACTIONS(1128),
    [anon_sym_PIPE_AMP] = ACTIONS(340),
    [anon_sym_AMP_AMP] = ACTIONS(1128),
    [anon_sym_PIPE_PIPE] = ACTIONS(1128),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1128),
    [anon_sym_LF] = ACTIONS(1128),
    [anon_sym_AMP] = ACTIONS(1128),
  },
  [459] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(340),
    [anon_sym_RPAREN] = ACTIONS(1128),
    [anon_sym_SEMI_SEMI] = ACTIONS(1128),
    [anon_sym_PIPE_AMP] = ACTIONS(340),
    [anon_sym_AMP_AMP] = ACTIONS(1128),
    [anon_sym_PIPE_PIPE] = ACTIONS(1128),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(236),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(236),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_DQUOTE] = ACTIONS(236),
    [sym_raw_string] = ACTIONS(236),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(236),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(236),
    [anon_sym_BQUOTE] = ACTIONS(236),
    [anon_sym_LT_LPAREN] = ACTIONS(236),
    [anon_sym_GT_LPAREN] = ACTIONS(236),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(1128),
    [anon_sym_LF] = ACTIONS(1128),
    [anon_sym_AMP] = ACTIONS(1128),
  },
  [460] = {
    [sym_concatenation] = STATE(599),
    [sym_string] = STATE(751),
    [sym_simple_expansion] = STATE(751),
    [sym_expansion] = STATE(751),
    [sym_command_substitution] = STATE(751),
    [sym_process_substitution] = STATE(751),
    [sym_word] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(562),
    [sym_raw_string] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(566),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(568),
    [anon_sym_BQUOTE] = ACTIONS(570),
    [anon_sym_LT_LPAREN] = ACTIONS(572),
    [anon_sym_GT_LPAREN] = ACTIONS(572),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1436),
  },
  [461] = {
    [aux_sym_concatenation_repeat1] = STATE(753),
    [sym_file_descriptor] = ACTIONS(372),
    [sym__concat] = ACTIONS(1134),
    [anon_sym_PIPE] = ACTIONS(1136),
    [anon_sym_RPAREN] = ACTIONS(1136),
    [anon_sym_SEMI_SEMI] = ACTIONS(1136),
    [anon_sym_PIPE_AMP] = ACTIONS(1136),
    [anon_sym_AMP_AMP] = ACTIONS(1136),
    [anon_sym_PIPE_PIPE] = ACTIONS(1136),
    [anon_sym_LT] = ACTIONS(1136),
    [anon_sym_GT] = ACTIONS(1136),
    [anon_sym_GT_GT] = ACTIONS(1136),
    [anon_sym_AMP_GT] = ACTIONS(1136),
    [anon_sym_AMP_GT_GT] = ACTIONS(1136),
    [anon_sym_LT_AMP] = ACTIONS(1136),
    [anon_sym_GT_AMP] = ACTIONS(1136),
    [anon_sym_LT_LT] = ACTIONS(1136),
    [anon_sym_LT_LT_DASH] = ACTIONS(1136),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1136),
    [anon_sym_LF] = ACTIONS(1136),
    [anon_sym_AMP] = ACTIONS(1136),
  },
  [462] = {
    [aux_sym_concatenation_repeat1] = STATE(754),
    [sym_file_descriptor] = ACTIONS(390),
    [sym__concat] = ACTIONS(1134),
    [anon_sym_PIPE] = ACTIONS(1150),
    [anon_sym_RPAREN] = ACTIONS(1150),
    [anon_sym_SEMI_SEMI] = ACTIONS(1150),
    [anon_sym_PIPE_AMP] = ACTIONS(1150),
    [anon_sym_AMP_AMP] = ACTIONS(1150),
    [anon_sym_PIPE_PIPE] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1150),
    [anon_sym_GT] = ACTIONS(1150),
    [anon_sym_GT_GT] = ACTIONS(1150),
    [anon_sym_AMP_GT] = ACTIONS(1150),
    [anon_sym_AMP_GT_GT] = ACTIONS(1150),
    [anon_sym_LT_AMP] = ACTIONS(1150),
    [anon_sym_GT_AMP] = ACTIONS(1150),
    [anon_sym_LT_LT] = ACTIONS(1150),
    [anon_sym_LT_LT_DASH] = ACTIONS(1150),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1150),
    [anon_sym_LF] = ACTIONS(1150),
    [anon_sym_AMP] = ACTIONS(1150),
  },
  [463] = {
    [sym_concatenation] = STATE(135),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym_for_statement_repeat1] = STATE(463),
    [sym_file_descriptor] = ACTIONS(1168),
    [sym_word] = ACTIONS(1438),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_RPAREN] = ACTIONS(1173),
    [anon_sym_SEMI_SEMI] = ACTIONS(1173),
    [anon_sym_PIPE_AMP] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1173),
    [anon_sym_PIPE_PIPE] = ACTIONS(1173),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_AMP_GT] = ACTIONS(1173),
    [anon_sym_AMP_GT_GT] = ACTIONS(1173),
    [anon_sym_LT_AMP] = ACTIONS(1173),
    [anon_sym_GT_AMP] = ACTIONS(1173),
    [anon_sym_LT_LT] = ACTIONS(1173),
    [anon_sym_LT_LT_DASH] = ACTIONS(1173),
    [anon_sym_DQUOTE] = ACTIONS(1175),
    [sym_raw_string] = ACTIONS(1441),
    [anon_sym_DOLLAR] = ACTIONS(1181),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1190),
    [anon_sym_LT_LPAREN] = ACTIONS(1193),
    [anon_sym_GT_LPAREN] = ACTIONS(1193),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1173),
    [anon_sym_LF] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1173),
  },
  [464] = {
    [sym_file_redirect] = STATE(134),
    [sym_heredoc_redirect] = STATE(134),
    [aux_sym_command_repeat2] = STATE(465),
    [sym_file_descriptor] = ACTIONS(348),
    [anon_sym_PIPE] = ACTIONS(1199),
    [anon_sym_RPAREN] = ACTIONS(1199),
    [anon_sym_SEMI_SEMI] = ACTIONS(1199),
    [anon_sym_PIPE_AMP] = ACTIONS(1199),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(352),
    [anon_sym_GT] = ACTIONS(352),
    [anon_sym_GT_GT] = ACTIONS(352),
    [anon_sym_AMP_GT] = ACTIONS(352),
    [anon_sym_AMP_GT_GT] = ACTIONS(352),
    [anon_sym_LT_AMP] = ACTIONS(352),
    [anon_sym_GT_AMP] = ACTIONS(352),
    [anon_sym_LT_LT] = ACTIONS(216),
    [anon_sym_LT_LT_DASH] = ACTIONS(216),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_LF] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1199),
  },
  [465] = {
    [sym_file_redirect] = STATE(134),
    [sym_heredoc_redirect] = STATE(134),
    [aux_sym_command_repeat2] = STATE(465),
    [sym_file_descriptor] = ACTIONS(1447),
    [anon_sym_PIPE] = ACTIONS(1204),
    [anon_sym_RPAREN] = ACTIONS(1204),
    [anon_sym_SEMI_SEMI] = ACTIONS(1204),
    [anon_sym_PIPE_AMP] = ACTIONS(1204),
    [anon_sym_AMP_AMP] = ACTIONS(1204),
    [anon_sym_PIPE_PIPE] = ACTIONS(1204),
    [anon_sym_LT] = ACTIONS(1450),
    [anon_sym_GT] = ACTIONS(1450),
    [anon_sym_GT_GT] = ACTIONS(1450),
    [anon_sym_AMP_GT] = ACTIONS(1450),
    [anon_sym_AMP_GT_GT] = ACTIONS(1450),
    [anon_sym_LT_AMP] = ACTIONS(1450),
    [anon_sym_GT_AMP] = ACTIONS(1450),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_LT_LT_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1204),
    [anon_sym_LF] = ACTIONS(1204),
    [anon_sym_AMP] = ACTIONS(1204),
  },
  [466] = {
    [sym_file_descriptor] = ACTIONS(546),
    [sym_word] = ACTIONS(546),
    [sym_variable_name] = ACTIONS(546),
    [anon_sym_for] = ACTIONS(548),
    [anon_sym_while] = ACTIONS(548),
    [anon_sym_if] = ACTIONS(548),
    [anon_sym_case] = ACTIONS(548),
    [anon_sym_RPAREN] = ACTIONS(1453),
    [anon_sym_function] = ACTIONS(548),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeset] = ACTIONS(548),
    [anon_sym_export] = ACTIONS(548),
    [anon_sym_readonly] = ACTIONS(548),
    [anon_sym_local] = ACTIONS(548),
    [anon_sym_LT] = ACTIONS(548),
    [anon_sym_GT] = ACTIONS(548),
    [anon_sym_GT_GT] = ACTIONS(546),
    [anon_sym_AMP_GT] = ACTIONS(548),
    [anon_sym_AMP_GT_GT] = ACTIONS(546),
    [anon_sym_LT_AMP] = ACTIONS(546),
    [anon_sym_GT_AMP] = ACTIONS(546),
    [anon_sym_DQUOTE] = ACTIONS(546),
    [sym_raw_string] = ACTIONS(546),
    [anon_sym_DOLLAR] = ACTIONS(548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(546),
    [anon_sym_LT_LPAREN] = ACTIONS(546),
    [anon_sym_GT_LPAREN] = ACTIONS(546),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(550),
  },
  [467] = {
    [sym_file_redirect] = STATE(134),
    [sym_heredoc_redirect] = STATE(134),
    [sym_concatenation] = STATE(135),
    [sym_string] = STATE(211),
    [sym_simple_expansion] = STATE(211),
    [sym_expansion] = STATE(211),
    [sym_command_substitution] = STATE(211),
    [sym_process_substitution] = STATE(211),
    [aux_sym_for_statement_repeat1] = STATE(463),
    [aux_sym_command_repeat2] = STATE(756),
    [sym_file_descriptor] = ACTIONS(348),
    [sym_word] = ACTIONS(350),
    [anon_sym_PIPE] = ACTIONS(1199),
    [anon_sym_RPAREN] = ACTIONS(1199),
    [anon_sym_SEMI_SEMI] = ACTIONS(1199),
    [anon_sym_PIPE_AMP] = ACTIONS(1199),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(352),
    [anon_sym_GT] = ACTIONS(352),
    [anon_sym_GT_GT] = ACTIONS(352),
    [anon_sym_AMP_GT] = ACTIONS(352),
    [anon_sym_AMP_GT_GT] = ACTIONS(352),
    [anon_sym_LT_AMP] = ACTIONS(352),
    [anon_sym_GT_AMP] = ACTIONS(352),
    [anon_sym_LT_LT] = ACTIONS(216),
    [anon_sym_LT_LT_DASH] = ACTIONS(216),
    [anon_sym_DQUOTE] = ACTIONS(218),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(222),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(224),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(226),
    [anon_sym_BQUOTE] = ACTIONS(228),
    [anon_sym_LT_LPAREN] = ACTIONS(230),
    [anon_sym_GT_LPAREN] = ACTIONS(230),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_LF] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1199),
  },
  [468] = {
    [aux_sym_concatenation_repeat1] = STATE(758),
    [sym_word] = ACTIONS(686),
    [sym__concat] = ACTIONS(1455),
    [sym_variable_name] = ACTIONS(686),
    [anon_sym_PIPE] = ACTIONS(690),
    [anon_sym_SEMI_SEMI] = ACTIONS(690),
    [anon_sym_PIPE_AMP] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(690),
    [anon_sym_SEMI] = ACTIONS(690),
    [anon_sym_LF] = ACTIONS(690),
    [anon_sym_AMP] = ACTIONS(690),
  },
  [469] = {
    [sym_word] = ACTIONS(686),
    [sym_variable_name] = ACTIONS(686),
    [anon_sym_PIPE] = ACTIONS(690),
    [anon_sym_RPAREN] = ACTIONS(690),
    [anon_sym_SEMI_SEMI] = ACTIONS(690),
    [anon_sym_PIPE_AMP] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(690),
    [anon_sym_SEMI] = ACTIONS(690),
    [anon_sym_LF] = ACTIONS(690),
    [anon_sym_AMP] = ACTIONS(690),
  },
  [470] = {
    [sym_concatenation] = STATE(364),
    [sym_string] = STATE(355),
    [sym_simple_expansion] = STATE(355),
    [sym_expansion] = STATE(355),
    [sym_command_substitution] = STATE(355),
    [sym_process_substitution] = STATE(355),
    [aux_sym_for_statement_repeat1] = STATE(760),
    [sym_word] = ACTIONS(692),
    [anon_sym_RPAREN] = ACTIONS(1457),
    [anon_sym_DQUOTE] = ACTIONS(696),
    [sym_raw_string] = ACTIONS(692),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(700),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(702),
    [anon_sym_BQUOTE] = ACTIONS(704),
    [anon_sym_LT_LPAREN] = ACTIONS(706),
    [anon_sym_GT_LPAREN] = ACTIONS(706),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(708),
  },
  [471] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(762),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [472] = {
    [sym_special_variable_name] = STATE(765),
    [anon_sym_DOLLAR] = ACTIONS(1461),
    [anon_sym_POUND] = ACTIONS(1461),
    [anon_sym_AT] = ACTIONS(1461),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(1461),
    [anon_sym_QMARK] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_BANG] = ACTIONS(1461),
    [anon_sym_0] = ACTIONS(1465),
    [anon_sym__] = ACTIONS(1465),
  },
  [473] = {
    [sym_special_variable_name] = STATE(768),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(1467),
    [anon_sym_AT] = ACTIONS(138),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [474] = {
    [sym_for_statement] = STATE(769),
    [sym_while_statement] = STATE(769),
    [sym_if_statement] = STATE(769),
    [sym_case_statement] = STATE(769),
    [sym_function_definition] = STATE(769),
    [sym_subshell] = STATE(769),
    [sym_pipeline] = STATE(769),
    [sym_list] = STATE(769),
    [sym_command] = STATE(769),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(770),
    [sym_declaration_command] = STATE(769),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [475] = {
    [sym_for_statement] = STATE(771),
    [sym_while_statement] = STATE(771),
    [sym_if_statement] = STATE(771),
    [sym_case_statement] = STATE(771),
    [sym_function_definition] = STATE(771),
    [sym_subshell] = STATE(771),
    [sym_pipeline] = STATE(771),
    [sym_list] = STATE(771),
    [sym_command] = STATE(771),
    [sym_command_name] = STATE(118),
    [sym_variable_assignment] = STATE(772),
    [sym_declaration_command] = STATE(771),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(112),
    [sym_simple_expansion] = STATE(112),
    [sym_expansion] = STATE(112),
    [sym_command_substitution] = STATE(112),
    [sym_process_substitution] = STATE(112),
    [aux_sym_command_repeat1] = STATE(121),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(178),
    [sym_variable_name] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(184),
    [anon_sym_typeset] = ACTIONS(184),
    [anon_sym_export] = ACTIONS(184),
    [anon_sym_readonly] = ACTIONS(184),
    [anon_sym_local] = ACTIONS(184),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(178),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(186),
  },
  [476] = {
    [sym_for_statement] = STATE(773),
    [sym_while_statement] = STATE(773),
    [sym_if_statement] = STATE(773),
    [sym_case_statement] = STATE(773),
    [sym_function_definition] = STATE(773),
    [sym_subshell] = STATE(773),
    [sym_pipeline] = STATE(773),
    [sym_list] = STATE(773),
    [sym_command] = STATE(773),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(774),
    [sym_declaration_command] = STATE(773),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [477] = {
    [aux_sym_concatenation_repeat1] = STATE(775),
    [sym_word] = ACTIONS(722),
    [sym__concat] = ACTIONS(1455),
    [sym_variable_name] = ACTIONS(722),
    [anon_sym_PIPE] = ACTIONS(724),
    [anon_sym_SEMI_SEMI] = ACTIONS(724),
    [anon_sym_PIPE_AMP] = ACTIONS(724),
    [anon_sym_AMP_AMP] = ACTIONS(724),
    [anon_sym_PIPE_PIPE] = ACTIONS(724),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(724),
    [anon_sym_LF] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(724),
  },
  [478] = {
    [sym_file_descriptor] = ACTIONS(675),
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(675),
    [sym_variable_name] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_GT_GT] = ACTIONS(675),
    [anon_sym_AMP_GT] = ACTIONS(1471),
    [anon_sym_AMP_GT_GT] = ACTIONS(675),
    [anon_sym_LT_AMP] = ACTIONS(675),
    [anon_sym_GT_AMP] = ACTIONS(675),
    [anon_sym_DQUOTE] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(1471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(675),
    [anon_sym_BQUOTE] = ACTIONS(675),
    [anon_sym_LT_LPAREN] = ACTIONS(675),
    [anon_sym_GT_LPAREN] = ACTIONS(675),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1471),
  },
  [479] = {
    [sym_file_descriptor] = ACTIONS(679),
    [sym_word] = ACTIONS(679),
    [sym__concat] = ACTIONS(679),
    [sym_variable_name] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(1473),
    [anon_sym_GT] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(1473),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_DQUOTE] = ACTIONS(679),
    [sym_raw_string] = ACTIONS(679),
    [anon_sym_DOLLAR] = ACTIONS(1473),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(679),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(679),
    [anon_sym_LT_LPAREN] = ACTIONS(679),
    [anon_sym_GT_LPAREN] = ACTIONS(679),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1473),
  },
  [480] = {
    [aux_sym_concatenation_repeat1] = STATE(480),
    [sym_file_descriptor] = ACTIONS(675),
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(1475),
    [sym_variable_name] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_GT_GT] = ACTIONS(675),
    [anon_sym_AMP_GT] = ACTIONS(1471),
    [anon_sym_AMP_GT_GT] = ACTIONS(675),
    [anon_sym_LT_AMP] = ACTIONS(675),
    [anon_sym_GT_AMP] = ACTIONS(675),
    [anon_sym_DQUOTE] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(1471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(675),
    [anon_sym_BQUOTE] = ACTIONS(675),
    [anon_sym_LT_LPAREN] = ACTIONS(675),
    [anon_sym_GT_LPAREN] = ACTIONS(675),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1471),
  },
  [481] = {
    [sym_file_descriptor] = ACTIONS(931),
    [sym_word] = ACTIONS(931),
    [sym__concat] = ACTIONS(931),
    [sym_variable_name] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1478),
    [anon_sym_GT_GT] = ACTIONS(931),
    [anon_sym_AMP_GT] = ACTIONS(1478),
    [anon_sym_AMP_GT_GT] = ACTIONS(931),
    [anon_sym_LT_AMP] = ACTIONS(931),
    [anon_sym_GT_AMP] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(931),
    [anon_sym_DOLLAR] = ACTIONS(1478),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(931),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(931),
    [anon_sym_BQUOTE] = ACTIONS(931),
    [anon_sym_LT_LPAREN] = ACTIONS(931),
    [anon_sym_GT_LPAREN] = ACTIONS(931),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1478),
  },
  [482] = {
    [anon_sym_RBRACE] = ACTIONS(1480),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [sym_comment] = ACTIONS(46),
  },
  [483] = {
    [anon_sym_RBRACE] = ACTIONS(1484),
    [anon_sym_LBRACK] = ACTIONS(1486),
    [sym_comment] = ACTIONS(46),
  },
  [484] = {
    [sym_file_descriptor] = ACTIONS(960),
    [sym_word] = ACTIONS(960),
    [sym__concat] = ACTIONS(960),
    [sym_variable_name] = ACTIONS(960),
    [anon_sym_LT] = ACTIONS(1488),
    [anon_sym_GT] = ACTIONS(1488),
    [anon_sym_GT_GT] = ACTIONS(960),
    [anon_sym_AMP_GT] = ACTIONS(1488),
    [anon_sym_AMP_GT_GT] = ACTIONS(960),
    [anon_sym_LT_AMP] = ACTIONS(960),
    [anon_sym_GT_AMP] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(960),
    [sym_raw_string] = ACTIONS(960),
    [anon_sym_DOLLAR] = ACTIONS(1488),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(960),
    [anon_sym_BQUOTE] = ACTIONS(960),
    [anon_sym_LT_LPAREN] = ACTIONS(960),
    [anon_sym_GT_LPAREN] = ACTIONS(960),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1488),
  },
  [485] = {
    [sym_concatenation] = STATE(783),
    [sym_string] = STATE(780),
    [sym_simple_expansion] = STATE(780),
    [sym_expansion] = STATE(780),
    [sym_command_substitution] = STATE(780),
    [sym_process_substitution] = STATE(780),
    [sym_word] = ACTIONS(1490),
    [anon_sym_RBRACE] = ACTIONS(1492),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1490),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1494),
  },
  [486] = {
    [anon_sym_AT] = ACTIONS(1496),
    [sym_comment] = ACTIONS(46),
  },
  [487] = {
    [sym_file_descriptor] = ACTIONS(972),
    [sym_word] = ACTIONS(972),
    [sym__concat] = ACTIONS(972),
    [sym_variable_name] = ACTIONS(972),
    [anon_sym_LT] = ACTIONS(1498),
    [anon_sym_GT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(972),
    [anon_sym_AMP_GT] = ACTIONS(1498),
    [anon_sym_AMP_GT_GT] = ACTIONS(972),
    [anon_sym_LT_AMP] = ACTIONS(972),
    [anon_sym_GT_AMP] = ACTIONS(972),
    [anon_sym_DQUOTE] = ACTIONS(972),
    [sym_raw_string] = ACTIONS(972),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(972),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(972),
    [anon_sym_BQUOTE] = ACTIONS(972),
    [anon_sym_LT_LPAREN] = ACTIONS(972),
    [anon_sym_GT_LPAREN] = ACTIONS(972),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1498),
  },
  [488] = {
    [sym_concatenation] = STATE(787),
    [sym_string] = STATE(785),
    [sym_simple_expansion] = STATE(785),
    [sym_expansion] = STATE(785),
    [sym_command_substitution] = STATE(785),
    [sym_process_substitution] = STATE(785),
    [sym_word] = ACTIONS(1500),
    [anon_sym_RBRACE] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1500),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1502),
  },
  [489] = {
    [anon_sym_AT] = ACTIONS(1504),
    [sym_comment] = ACTIONS(46),
  },
  [490] = {
    [sym_file_descriptor] = ACTIONS(1066),
    [sym_word] = ACTIONS(1066),
    [sym__concat] = ACTIONS(1066),
    [sym_variable_name] = ACTIONS(1066),
    [anon_sym_LT] = ACTIONS(1506),
    [anon_sym_GT] = ACTIONS(1506),
    [anon_sym_GT_GT] = ACTIONS(1066),
    [anon_sym_AMP_GT] = ACTIONS(1506),
    [anon_sym_AMP_GT_GT] = ACTIONS(1066),
    [anon_sym_LT_AMP] = ACTIONS(1066),
    [anon_sym_GT_AMP] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(1066),
    [sym_raw_string] = ACTIONS(1066),
    [anon_sym_DOLLAR] = ACTIONS(1506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1066),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1066),
    [anon_sym_BQUOTE] = ACTIONS(1066),
    [anon_sym_LT_LPAREN] = ACTIONS(1066),
    [anon_sym_GT_LPAREN] = ACTIONS(1066),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1506),
  },
  [491] = {
    [sym_file_descriptor] = ACTIONS(1122),
    [sym_word] = ACTIONS(1122),
    [sym__concat] = ACTIONS(1122),
    [sym_variable_name] = ACTIONS(1122),
    [anon_sym_LT] = ACTIONS(1508),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_GT_GT] = ACTIONS(1122),
    [anon_sym_AMP_GT] = ACTIONS(1508),
    [anon_sym_AMP_GT_GT] = ACTIONS(1122),
    [anon_sym_LT_AMP] = ACTIONS(1122),
    [anon_sym_GT_AMP] = ACTIONS(1122),
    [anon_sym_DQUOTE] = ACTIONS(1122),
    [sym_raw_string] = ACTIONS(1122),
    [anon_sym_DOLLAR] = ACTIONS(1508),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1122),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1122),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [anon_sym_LT_LPAREN] = ACTIONS(1122),
    [anon_sym_GT_LPAREN] = ACTIONS(1122),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1508),
  },
  [492] = {
    [anon_sym_RBRACE] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1512),
    [sym_comment] = ACTIONS(46),
  },
  [493] = {
    [anon_sym_RBRACE] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1516),
    [sym_comment] = ACTIONS(46),
  },
  [494] = {
    [anon_sym_DQUOTE] = ACTIONS(962),
    [sym__string_content] = ACTIONS(962),
    [anon_sym_DOLLAR] = ACTIONS(962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(962),
    [anon_sym_BQUOTE] = ACTIONS(962),
    [sym_comment] = ACTIONS(60),
  },
  [495] = {
    [sym_concatenation] = STATE(796),
    [sym_string] = STATE(793),
    [sym_simple_expansion] = STATE(793),
    [sym_expansion] = STATE(793),
    [sym_command_substitution] = STATE(793),
    [sym_process_substitution] = STATE(793),
    [sym_word] = ACTIONS(1518),
    [anon_sym_RBRACE] = ACTIONS(1520),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1518),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1522),
  },
  [496] = {
    [anon_sym_AT] = ACTIONS(1524),
    [sym_comment] = ACTIONS(46),
  },
  [497] = {
    [anon_sym_DQUOTE] = ACTIONS(974),
    [sym__string_content] = ACTIONS(974),
    [anon_sym_DOLLAR] = ACTIONS(974),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(974),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(974),
    [anon_sym_BQUOTE] = ACTIONS(974),
    [sym_comment] = ACTIONS(60),
  },
  [498] = {
    [sym_concatenation] = STATE(800),
    [sym_string] = STATE(798),
    [sym_simple_expansion] = STATE(798),
    [sym_expansion] = STATE(798),
    [sym_command_substitution] = STATE(798),
    [sym_process_substitution] = STATE(798),
    [sym_word] = ACTIONS(1526),
    [anon_sym_RBRACE] = ACTIONS(1514),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1526),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1528),
  },
  [499] = {
    [anon_sym_AT] = ACTIONS(1530),
    [sym_comment] = ACTIONS(46),
  },
  [500] = {
    [anon_sym_DQUOTE] = ACTIONS(1068),
    [sym__string_content] = ACTIONS(1068),
    [anon_sym_DOLLAR] = ACTIONS(1068),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1068),
    [anon_sym_BQUOTE] = ACTIONS(1068),
    [sym_comment] = ACTIONS(60),
  },
  [501] = {
    [sym_file_descriptor] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1534),
    [anon_sym_RPAREN] = ACTIONS(1534),
    [anon_sym_SEMI_SEMI] = ACTIONS(1534),
    [anon_sym_PIPE_AMP] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1534),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_GT_GT] = ACTIONS(1534),
    [anon_sym_AMP_GT] = ACTIONS(1534),
    [anon_sym_AMP_GT_GT] = ACTIONS(1534),
    [anon_sym_LT_AMP] = ACTIONS(1534),
    [anon_sym_GT_AMP] = ACTIONS(1534),
    [anon_sym_LT_LT] = ACTIONS(1534),
    [anon_sym_LT_LT_DASH] = ACTIONS(1534),
    [anon_sym_DQUOTE] = ACTIONS(1534),
    [sym_raw_string] = ACTIONS(1534),
    [anon_sym_DOLLAR] = ACTIONS(1534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1534),
    [anon_sym_BQUOTE] = ACTIONS(1534),
    [anon_sym_LT_LPAREN] = ACTIONS(1534),
    [anon_sym_GT_LPAREN] = ACTIONS(1534),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1534),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_AMP] = ACTIONS(1534),
  },
  [502] = {
    [anon_sym_AT] = ACTIONS(1536),
    [sym_comment] = ACTIONS(46),
  },
  [503] = {
    [sym_file_descriptor] = ACTIONS(1538),
    [sym_word] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(1540),
    [anon_sym_RPAREN] = ACTIONS(1540),
    [anon_sym_SEMI_SEMI] = ACTIONS(1540),
    [anon_sym_PIPE_AMP] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1540),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1540),
    [anon_sym_GT_GT] = ACTIONS(1540),
    [anon_sym_AMP_GT] = ACTIONS(1540),
    [anon_sym_AMP_GT_GT] = ACTIONS(1540),
    [anon_sym_LT_AMP] = ACTIONS(1540),
    [anon_sym_GT_AMP] = ACTIONS(1540),
    [anon_sym_LT_LT] = ACTIONS(1540),
    [anon_sym_LT_LT_DASH] = ACTIONS(1540),
    [anon_sym_DQUOTE] = ACTIONS(1540),
    [sym_raw_string] = ACTIONS(1540),
    [anon_sym_DOLLAR] = ACTIONS(1540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1540),
    [anon_sym_BQUOTE] = ACTIONS(1540),
    [anon_sym_LT_LPAREN] = ACTIONS(1540),
    [anon_sym_GT_LPAREN] = ACTIONS(1540),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1540),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_LF] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1540),
  },
  [504] = {
    [anon_sym_AT] = ACTIONS(1542),
    [sym_comment] = ACTIONS(46),
  },
  [505] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(1544),
    [anon_sym_RBRACE] = ACTIONS(1546),
    [sym_comment] = ACTIONS(46),
  },
  [506] = {
    [sym_file_descriptor] = ACTIONS(1548),
    [sym_word] = ACTIONS(1548),
    [sym__concat] = ACTIONS(1548),
    [anon_sym_PIPE] = ACTIONS(1550),
    [anon_sym_RPAREN] = ACTIONS(1550),
    [anon_sym_SEMI_SEMI] = ACTIONS(1550),
    [anon_sym_PIPE_AMP] = ACTIONS(1550),
    [anon_sym_AMP_AMP] = ACTIONS(1550),
    [anon_sym_PIPE_PIPE] = ACTIONS(1550),
    [anon_sym_LT] = ACTIONS(1550),
    [anon_sym_GT] = ACTIONS(1550),
    [anon_sym_GT_GT] = ACTIONS(1550),
    [anon_sym_AMP_GT] = ACTIONS(1550),
    [anon_sym_AMP_GT_GT] = ACTIONS(1550),
    [anon_sym_LT_AMP] = ACTIONS(1550),
    [anon_sym_GT_AMP] = ACTIONS(1550),
    [anon_sym_LT_LT] = ACTIONS(1550),
    [anon_sym_LT_LT_DASH] = ACTIONS(1550),
    [anon_sym_DQUOTE] = ACTIONS(1550),
    [sym_raw_string] = ACTIONS(1550),
    [anon_sym_DOLLAR] = ACTIONS(1550),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1550),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1550),
    [anon_sym_BQUOTE] = ACTIONS(1550),
    [anon_sym_LT_LPAREN] = ACTIONS(1550),
    [anon_sym_GT_LPAREN] = ACTIONS(1550),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1550),
    [anon_sym_SEMI] = ACTIONS(1550),
    [anon_sym_LF] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(1550),
  },
  [507] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(1552),
    [anon_sym_RBRACE] = ACTIONS(1554),
    [sym_comment] = ACTIONS(46),
  },
  [508] = {
    [sym__concat] = ACTIONS(1556),
    [anon_sym_RBRACE] = ACTIONS(1546),
    [sym_comment] = ACTIONS(46),
  },
  [509] = {
    [anon_sym_RBRACK] = ACTIONS(1556),
    [sym_comment] = ACTIONS(46),
  },
  [510] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(1558),
    [anon_sym_RBRACE] = ACTIONS(1560),
    [sym_comment] = ACTIONS(46),
  },
  [511] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(1562),
    [anon_sym_RBRACE] = ACTIONS(1564),
    [sym_comment] = ACTIONS(46),
  },
  [512] = {
    [sym__concat] = ACTIONS(1566),
    [anon_sym_RBRACE] = ACTIONS(1560),
    [sym_comment] = ACTIONS(46),
  },
  [513] = {
    [anon_sym_RBRACK] = ACTIONS(1566),
    [sym_comment] = ACTIONS(46),
  },
  [514] = {
    [sym_file_descriptor] = ACTIONS(675),
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(675),
    [anon_sym_PIPE] = ACTIONS(1471),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_PIPE_AMP] = ACTIONS(675),
    [anon_sym_AMP_AMP] = ACTIONS(675),
    [anon_sym_PIPE_PIPE] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_GT_GT] = ACTIONS(675),
    [anon_sym_AMP_GT] = ACTIONS(1471),
    [anon_sym_AMP_GT_GT] = ACTIONS(675),
    [anon_sym_LT_AMP] = ACTIONS(675),
    [anon_sym_GT_AMP] = ACTIONS(675),
    [anon_sym_LT_LT] = ACTIONS(1471),
    [anon_sym_LT_LT_DASH] = ACTIONS(675),
    [anon_sym_DQUOTE] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(1471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(675),
    [anon_sym_BQUOTE] = ACTIONS(675),
    [anon_sym_LT_LPAREN] = ACTIONS(675),
    [anon_sym_GT_LPAREN] = ACTIONS(675),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1471),
  },
  [515] = {
    [sym_file_descriptor] = ACTIONS(679),
    [sym_word] = ACTIONS(679),
    [sym__concat] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(1473),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(1473),
    [anon_sym_GT] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(1473),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(1473),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_DQUOTE] = ACTIONS(679),
    [sym_raw_string] = ACTIONS(679),
    [anon_sym_DOLLAR] = ACTIONS(1473),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(679),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(679),
    [anon_sym_LT_LPAREN] = ACTIONS(679),
    [anon_sym_GT_LPAREN] = ACTIONS(679),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1473),
  },
  [516] = {
    [aux_sym_concatenation_repeat1] = STATE(516),
    [sym_file_descriptor] = ACTIONS(675),
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(1568),
    [anon_sym_PIPE] = ACTIONS(1471),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_PIPE_AMP] = ACTIONS(675),
    [anon_sym_AMP_AMP] = ACTIONS(675),
    [anon_sym_PIPE_PIPE] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_GT_GT] = ACTIONS(675),
    [anon_sym_AMP_GT] = ACTIONS(1471),
    [anon_sym_AMP_GT_GT] = ACTIONS(675),
    [anon_sym_LT_AMP] = ACTIONS(675),
    [anon_sym_GT_AMP] = ACTIONS(675),
    [anon_sym_LT_LT] = ACTIONS(1471),
    [anon_sym_LT_LT_DASH] = ACTIONS(675),
    [anon_sym_DQUOTE] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(1471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(675),
    [anon_sym_BQUOTE] = ACTIONS(675),
    [anon_sym_LT_LPAREN] = ACTIONS(675),
    [anon_sym_GT_LPAREN] = ACTIONS(675),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1471),
  },
  [517] = {
    [aux_sym_concatenation_repeat1] = STATE(817),
    [sym_file_descriptor] = ACTIONS(686),
    [sym_word] = ACTIONS(686),
    [sym__concat] = ACTIONS(1571),
    [sym_variable_name] = ACTIONS(686),
    [anon_sym_PIPE] = ACTIONS(1573),
    [anon_sym_RPAREN] = ACTIONS(686),
    [anon_sym_PIPE_AMP] = ACTIONS(686),
    [anon_sym_AMP_AMP] = ACTIONS(686),
    [anon_sym_PIPE_PIPE] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(1573),
    [anon_sym_GT] = ACTIONS(1573),
    [anon_sym_GT_GT] = ACTIONS(686),
    [anon_sym_AMP_GT] = ACTIONS(1573),
    [anon_sym_AMP_GT_GT] = ACTIONS(686),
    [anon_sym_LT_AMP] = ACTIONS(686),
    [anon_sym_GT_AMP] = ACTIONS(686),
    [anon_sym_DQUOTE] = ACTIONS(686),
    [sym_raw_string] = ACTIONS(686),
    [anon_sym_DOLLAR] = ACTIONS(1573),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(686),
    [anon_sym_BQUOTE] = ACTIONS(686),
    [anon_sym_LT_LPAREN] = ACTIONS(686),
    [anon_sym_GT_LPAREN] = ACTIONS(686),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1573),
  },
  [518] = {
    [sym_file_descriptor] = ACTIONS(686),
    [sym_word] = ACTIONS(686),
    [sym_variable_name] = ACTIONS(686),
    [anon_sym_PIPE] = ACTIONS(1573),
    [anon_sym_RPAREN] = ACTIONS(686),
    [anon_sym_PIPE_AMP] = ACTIONS(686),
    [anon_sym_AMP_AMP] = ACTIONS(686),
    [anon_sym_PIPE_PIPE] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(1573),
    [anon_sym_GT] = ACTIONS(1573),
    [anon_sym_GT_GT] = ACTIONS(686),
    [anon_sym_AMP_GT] = ACTIONS(1573),
    [anon_sym_AMP_GT_GT] = ACTIONS(686),
    [anon_sym_LT_AMP] = ACTIONS(686),
    [anon_sym_GT_AMP] = ACTIONS(686),
    [anon_sym_DQUOTE] = ACTIONS(686),
    [sym_raw_string] = ACTIONS(686),
    [anon_sym_DOLLAR] = ACTIONS(1573),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(686),
    [anon_sym_BQUOTE] = ACTIONS(686),
    [anon_sym_LT_LPAREN] = ACTIONS(686),
    [anon_sym_GT_LPAREN] = ACTIONS(686),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1573),
  },
  [519] = {
    [sym_concatenation] = STATE(364),
    [sym_string] = STATE(355),
    [sym_simple_expansion] = STATE(355),
    [sym_expansion] = STATE(355),
    [sym_command_substitution] = STATE(355),
    [sym_process_substitution] = STATE(355),
    [aux_sym_for_statement_repeat1] = STATE(819),
    [sym_word] = ACTIONS(692),
    [anon_sym_RPAREN] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(696),
    [sym_raw_string] = ACTIONS(692),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(700),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(702),
    [anon_sym_BQUOTE] = ACTIONS(704),
    [anon_sym_LT_LPAREN] = ACTIONS(706),
    [anon_sym_GT_LPAREN] = ACTIONS(706),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(708),
  },
  [520] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(821),
    [anon_sym_DQUOTE] = ACTIONS(1577),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [521] = {
    [sym_special_variable_name] = STATE(824),
    [anon_sym_DOLLAR] = ACTIONS(1579),
    [anon_sym_POUND] = ACTIONS(1579),
    [anon_sym_AT] = ACTIONS(1579),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_QMARK] = ACTIONS(1579),
    [anon_sym_DASH] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1579),
    [anon_sym_0] = ACTIONS(1583),
    [anon_sym__] = ACTIONS(1583),
  },
  [522] = {
    [sym_special_variable_name] = STATE(827),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(1585),
    [anon_sym_AT] = ACTIONS(138),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [523] = {
    [sym_for_statement] = STATE(828),
    [sym_while_statement] = STATE(828),
    [sym_if_statement] = STATE(828),
    [sym_case_statement] = STATE(828),
    [sym_function_definition] = STATE(828),
    [sym_subshell] = STATE(828),
    [sym_pipeline] = STATE(828),
    [sym_list] = STATE(828),
    [sym_command] = STATE(828),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(829),
    [sym_declaration_command] = STATE(828),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [524] = {
    [sym_for_statement] = STATE(830),
    [sym_while_statement] = STATE(830),
    [sym_if_statement] = STATE(830),
    [sym_case_statement] = STATE(830),
    [sym_function_definition] = STATE(830),
    [sym_subshell] = STATE(830),
    [sym_pipeline] = STATE(830),
    [sym_list] = STATE(830),
    [sym_command] = STATE(830),
    [sym_command_name] = STATE(118),
    [sym_variable_assignment] = STATE(831),
    [sym_declaration_command] = STATE(830),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(112),
    [sym_simple_expansion] = STATE(112),
    [sym_expansion] = STATE(112),
    [sym_command_substitution] = STATE(112),
    [sym_process_substitution] = STATE(112),
    [aux_sym_command_repeat1] = STATE(121),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(178),
    [sym_variable_name] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(184),
    [anon_sym_typeset] = ACTIONS(184),
    [anon_sym_export] = ACTIONS(184),
    [anon_sym_readonly] = ACTIONS(184),
    [anon_sym_local] = ACTIONS(184),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(178),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(186),
  },
  [525] = {
    [sym_for_statement] = STATE(832),
    [sym_while_statement] = STATE(832),
    [sym_if_statement] = STATE(832),
    [sym_case_statement] = STATE(832),
    [sym_function_definition] = STATE(832),
    [sym_subshell] = STATE(832),
    [sym_pipeline] = STATE(832),
    [sym_list] = STATE(832),
    [sym_command] = STATE(832),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(833),
    [sym_declaration_command] = STATE(832),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [526] = {
    [aux_sym_concatenation_repeat1] = STATE(834),
    [sym_file_descriptor] = ACTIONS(722),
    [sym_word] = ACTIONS(722),
    [sym__concat] = ACTIONS(1571),
    [sym_variable_name] = ACTIONS(722),
    [anon_sym_PIPE] = ACTIONS(1589),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_PIPE_AMP] = ACTIONS(722),
    [anon_sym_AMP_AMP] = ACTIONS(722),
    [anon_sym_PIPE_PIPE] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(1589),
    [anon_sym_GT] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(722),
    [anon_sym_AMP_GT] = ACTIONS(1589),
    [anon_sym_AMP_GT_GT] = ACTIONS(722),
    [anon_sym_LT_AMP] = ACTIONS(722),
    [anon_sym_GT_AMP] = ACTIONS(722),
    [anon_sym_DQUOTE] = ACTIONS(722),
    [sym_raw_string] = ACTIONS(722),
    [anon_sym_DOLLAR] = ACTIONS(1589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(722),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [anon_sym_LT_LPAREN] = ACTIONS(722),
    [anon_sym_GT_LPAREN] = ACTIONS(722),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1589),
  },
  [527] = {
    [sym_concatenation] = STATE(408),
    [sym_string] = STATE(400),
    [sym_simple_expansion] = STATE(400),
    [sym_expansion] = STATE(400),
    [sym_command_substitution] = STATE(400),
    [sym_process_substitution] = STATE(400),
    [aux_sym_for_statement_repeat1] = STATE(835),
    [sym_word] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [sym_raw_string] = ACTIONS(744),
    [anon_sym_DOLLAR] = ACTIONS(748),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(750),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(752),
    [anon_sym_BQUOTE] = ACTIONS(754),
    [anon_sym_LT_LPAREN] = ACTIONS(756),
    [anon_sym_GT_LPAREN] = ACTIONS(756),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(758),
  },
  [528] = {
    [sym__terminated_statement] = STATE(411),
    [sym_for_statement] = STATE(412),
    [sym_while_statement] = STATE(412),
    [sym_if_statement] = STATE(412),
    [sym_case_statement] = STATE(412),
    [sym_function_definition] = STATE(412),
    [sym_subshell] = STATE(412),
    [sym_pipeline] = STATE(412),
    [sym_list] = STATE(412),
    [sym_command] = STATE(412),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(413),
    [sym_declaration_command] = STATE(412),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(837),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_done] = ACTIONS(1591),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [529] = {
    [anon_sym_PIPE] = ACTIONS(1593),
    [anon_sym_RPAREN] = ACTIONS(1595),
    [anon_sym_PIPE_AMP] = ACTIONS(1595),
    [anon_sym_AMP_AMP] = ACTIONS(1595),
    [anon_sym_PIPE_PIPE] = ACTIONS(1595),
    [anon_sym_BQUOTE] = ACTIONS(1595),
    [sym_comment] = ACTIONS(46),
  },
  [530] = {
    [sym__terminated_statement] = STATE(418),
    [sym_for_statement] = STATE(419),
    [sym_while_statement] = STATE(419),
    [sym_if_statement] = STATE(419),
    [sym_elif_clause] = STATE(420),
    [sym_else_clause] = STATE(839),
    [sym_case_statement] = STATE(419),
    [sym_function_definition] = STATE(419),
    [sym_subshell] = STATE(419),
    [sym_pipeline] = STATE(419),
    [sym_list] = STATE(419),
    [sym_command] = STATE(419),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(422),
    [sym_declaration_command] = STATE(419),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(840),
    [aux_sym_if_statement_repeat1] = STATE(841),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(1597),
    [anon_sym_elif] = ACTIONS(766),
    [anon_sym_else] = ACTIONS(768),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [531] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1599),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1599),
    [anon_sym_LF] = ACTIONS(1599),
    [anon_sym_AMP] = ACTIONS(1599),
  },
  [532] = {
    [anon_sym_in] = ACTIONS(1601),
    [sym_comment] = ACTIONS(46),
  },
  [533] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1603),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1603),
    [anon_sym_LF] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
  },
  [534] = {
    [anon_sym_in] = ACTIONS(1605),
    [sym_comment] = ACTIONS(46),
  },
  [535] = {
    [anon_sym_RPAREN] = ACTIONS(1607),
    [sym_comment] = ACTIONS(46),
  },
  [536] = {
    [sym__terminated_statement] = STATE(21),
    [sym_for_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_case_statement] = STATE(22),
    [sym_function_definition] = STATE(22),
    [sym_subshell] = STATE(22),
    [sym_pipeline] = STATE(22),
    [sym_list] = STATE(22),
    [sym_command] = STATE(22),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(24),
    [sym_declaration_command] = STATE(22),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(848),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_RBRACE] = ACTIONS(1609),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [537] = {
    [sym_file_redirect] = STATE(851),
    [sym_file_descriptor] = ACTIONS(1611),
    [anon_sym_PIPE] = ACTIONS(1613),
    [anon_sym_RPAREN] = ACTIONS(1615),
    [anon_sym_PIPE_AMP] = ACTIONS(1615),
    [anon_sym_AMP_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1615),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT] = ACTIONS(1617),
    [anon_sym_AMP_GT_GT] = ACTIONS(1619),
    [anon_sym_LT_AMP] = ACTIONS(1619),
    [anon_sym_GT_AMP] = ACTIONS(1619),
    [sym_comment] = ACTIONS(46),
  },
  [538] = {
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_RPAREN] = ACTIONS(1623),
    [anon_sym_PIPE_AMP] = ACTIONS(1623),
    [anon_sym_AMP_AMP] = ACTIONS(1623),
    [anon_sym_PIPE_PIPE] = ACTIONS(1623),
    [anon_sym_BQUOTE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(46),
  },
  [539] = {
    [sym_file_descriptor] = ACTIONS(546),
    [sym_word] = ACTIONS(546),
    [sym_variable_name] = ACTIONS(546),
    [anon_sym_for] = ACTIONS(548),
    [anon_sym_while] = ACTIONS(548),
    [anon_sym_if] = ACTIONS(548),
    [anon_sym_case] = ACTIONS(548),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_function] = ACTIONS(548),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeset] = ACTIONS(548),
    [anon_sym_export] = ACTIONS(548),
    [anon_sym_readonly] = ACTIONS(548),
    [anon_sym_local] = ACTIONS(548),
    [anon_sym_LT] = ACTIONS(548),
    [anon_sym_GT] = ACTIONS(548),
    [anon_sym_GT_GT] = ACTIONS(546),
    [anon_sym_AMP_GT] = ACTIONS(548),
    [anon_sym_AMP_GT_GT] = ACTIONS(546),
    [anon_sym_LT_AMP] = ACTIONS(546),
    [anon_sym_GT_AMP] = ACTIONS(546),
    [anon_sym_DQUOTE] = ACTIONS(546),
    [sym_raw_string] = ACTIONS(546),
    [anon_sym_DOLLAR] = ACTIONS(548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(546),
    [anon_sym_LT_LPAREN] = ACTIONS(546),
    [anon_sym_GT_LPAREN] = ACTIONS(546),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(550),
  },
  [540] = {
    [anon_sym_PIPE] = ACTIONS(340),
    [anon_sym_RPAREN] = ACTIONS(1627),
    [anon_sym_SEMI_SEMI] = ACTIONS(1629),
    [anon_sym_PIPE_AMP] = ACTIONS(340),
    [anon_sym_AMP_AMP] = ACTIONS(346),
    [anon_sym_PIPE_PIPE] = ACTIONS(346),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1629),
    [anon_sym_LF] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1629),
  },
  [541] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(340),
    [anon_sym_RPAREN] = ACTIONS(1627),
    [anon_sym_SEMI_SEMI] = ACTIONS(1629),
    [anon_sym_PIPE_AMP] = ACTIONS(340),
    [anon_sym_AMP_AMP] = ACTIONS(346),
    [anon_sym_PIPE_PIPE] = ACTIONS(346),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(236),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(236),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_DQUOTE] = ACTIONS(236),
    [sym_raw_string] = ACTIONS(236),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(236),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(236),
    [anon_sym_BQUOTE] = ACTIONS(236),
    [anon_sym_LT_LPAREN] = ACTIONS(236),
    [anon_sym_GT_LPAREN] = ACTIONS(236),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(1629),
    [anon_sym_LF] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1629),
  },
  [542] = {
    [sym_concatenation] = STATE(855),
    [sym_string] = STATE(854),
    [sym_array] = STATE(855),
    [sym_simple_expansion] = STATE(854),
    [sym_expansion] = STATE(854),
    [sym_command_substitution] = STATE(854),
    [sym_process_substitution] = STATE(854),
    [sym_word] = ACTIONS(1631),
    [sym__empty_value] = ACTIONS(1633),
    [anon_sym_LPAREN] = ACTIONS(1635),
    [anon_sym_DQUOTE] = ACTIONS(1637),
    [sym_raw_string] = ACTIONS(1631),
    [anon_sym_DOLLAR] = ACTIONS(1639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1641),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1643),
    [anon_sym_BQUOTE] = ACTIONS(1645),
    [anon_sym_LT_LPAREN] = ACTIONS(1647),
    [anon_sym_GT_LPAREN] = ACTIONS(1647),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1649),
  },
  [543] = {
    [sym_word] = ACTIONS(294),
    [sym_variable_name] = ACTIONS(294),
    [anon_sym_PIPE] = ACTIONS(1006),
    [anon_sym_RPAREN] = ACTIONS(294),
    [anon_sym_PIPE_AMP] = ACTIONS(294),
    [anon_sym_AMP_AMP] = ACTIONS(294),
    [anon_sym_PIPE_PIPE] = ACTIONS(294),
    [anon_sym_BQUOTE] = ACTIONS(294),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1006),
  },
  [544] = {
    [sym_variable_assignment] = STATE(275),
    [sym_subscript] = STATE(278),
    [aux_sym_declaration_command_repeat1] = STATE(544),
    [sym_word] = ACTIONS(1651),
    [sym_variable_name] = ACTIONS(1654),
    [anon_sym_PIPE] = ACTIONS(1657),
    [anon_sym_RPAREN] = ACTIONS(1659),
    [anon_sym_PIPE_AMP] = ACTIONS(1659),
    [anon_sym_AMP_AMP] = ACTIONS(1659),
    [anon_sym_PIPE_PIPE] = ACTIONS(1659),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1661),
  },
  [545] = {
    [sym_file_descriptor] = ACTIONS(931),
    [sym_word] = ACTIONS(931),
    [sym__concat] = ACTIONS(931),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_RPAREN] = ACTIONS(931),
    [anon_sym_PIPE_AMP] = ACTIONS(931),
    [anon_sym_AMP_AMP] = ACTIONS(931),
    [anon_sym_PIPE_PIPE] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1478),
    [anon_sym_GT_GT] = ACTIONS(931),
    [anon_sym_AMP_GT] = ACTIONS(1478),
    [anon_sym_AMP_GT_GT] = ACTIONS(931),
    [anon_sym_LT_AMP] = ACTIONS(931),
    [anon_sym_GT_AMP] = ACTIONS(931),
    [anon_sym_LT_LT] = ACTIONS(1478),
    [anon_sym_LT_LT_DASH] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(931),
    [anon_sym_DOLLAR] = ACTIONS(1478),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(931),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(931),
    [anon_sym_BQUOTE] = ACTIONS(931),
    [anon_sym_LT_LPAREN] = ACTIONS(931),
    [anon_sym_GT_LPAREN] = ACTIONS(931),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1478),
  },
  [546] = {
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_LBRACK] = ACTIONS(1666),
    [sym_comment] = ACTIONS(46),
  },
  [547] = {
    [anon_sym_RBRACE] = ACTIONS(1668),
    [anon_sym_LBRACK] = ACTIONS(1670),
    [sym_comment] = ACTIONS(46),
  },
  [548] = {
    [sym_file_descriptor] = ACTIONS(960),
    [sym_word] = ACTIONS(960),
    [sym__concat] = ACTIONS(960),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_RPAREN] = ACTIONS(960),
    [anon_sym_PIPE_AMP] = ACTIONS(960),
    [anon_sym_AMP_AMP] = ACTIONS(960),
    [anon_sym_PIPE_PIPE] = ACTIONS(960),
    [anon_sym_LT] = ACTIONS(1488),
    [anon_sym_GT] = ACTIONS(1488),
    [anon_sym_GT_GT] = ACTIONS(960),
    [anon_sym_AMP_GT] = ACTIONS(1488),
    [anon_sym_AMP_GT_GT] = ACTIONS(960),
    [anon_sym_LT_AMP] = ACTIONS(960),
    [anon_sym_GT_AMP] = ACTIONS(960),
    [anon_sym_LT_LT] = ACTIONS(1488),
    [anon_sym_LT_LT_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(960),
    [sym_raw_string] = ACTIONS(960),
    [anon_sym_DOLLAR] = ACTIONS(1488),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(960),
    [anon_sym_BQUOTE] = ACTIONS(960),
    [anon_sym_LT_LPAREN] = ACTIONS(960),
    [anon_sym_GT_LPAREN] = ACTIONS(960),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1488),
  },
  [549] = {
    [sym_concatenation] = STATE(871),
    [sym_string] = STATE(868),
    [sym_simple_expansion] = STATE(868),
    [sym_expansion] = STATE(868),
    [sym_command_substitution] = STATE(868),
    [sym_process_substitution] = STATE(868),
    [sym_word] = ACTIONS(1672),
    [anon_sym_RBRACE] = ACTIONS(1674),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1672),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1676),
  },
  [550] = {
    [anon_sym_AT] = ACTIONS(1678),
    [sym_comment] = ACTIONS(46),
  },
  [551] = {
    [sym_file_descriptor] = ACTIONS(972),
    [sym_word] = ACTIONS(972),
    [sym__concat] = ACTIONS(972),
    [anon_sym_PIPE] = ACTIONS(1498),
    [anon_sym_RPAREN] = ACTIONS(972),
    [anon_sym_PIPE_AMP] = ACTIONS(972),
    [anon_sym_AMP_AMP] = ACTIONS(972),
    [anon_sym_PIPE_PIPE] = ACTIONS(972),
    [anon_sym_LT] = ACTIONS(1498),
    [anon_sym_GT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(972),
    [anon_sym_AMP_GT] = ACTIONS(1498),
    [anon_sym_AMP_GT_GT] = ACTIONS(972),
    [anon_sym_LT_AMP] = ACTIONS(972),
    [anon_sym_GT_AMP] = ACTIONS(972),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_LT_LT_DASH] = ACTIONS(972),
    [anon_sym_DQUOTE] = ACTIONS(972),
    [sym_raw_string] = ACTIONS(972),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(972),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(972),
    [anon_sym_BQUOTE] = ACTIONS(972),
    [anon_sym_LT_LPAREN] = ACTIONS(972),
    [anon_sym_GT_LPAREN] = ACTIONS(972),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1498),
  },
  [552] = {
    [sym_concatenation] = STATE(875),
    [sym_string] = STATE(873),
    [sym_simple_expansion] = STATE(873),
    [sym_expansion] = STATE(873),
    [sym_command_substitution] = STATE(873),
    [sym_process_substitution] = STATE(873),
    [sym_word] = ACTIONS(1680),
    [anon_sym_RBRACE] = ACTIONS(1668),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1680),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1682),
  },
  [553] = {
    [anon_sym_AT] = ACTIONS(1684),
    [sym_comment] = ACTIONS(46),
  },
  [554] = {
    [sym_file_descriptor] = ACTIONS(1066),
    [sym_word] = ACTIONS(1066),
    [sym__concat] = ACTIONS(1066),
    [anon_sym_PIPE] = ACTIONS(1506),
    [anon_sym_RPAREN] = ACTIONS(1066),
    [anon_sym_PIPE_AMP] = ACTIONS(1066),
    [anon_sym_AMP_AMP] = ACTIONS(1066),
    [anon_sym_PIPE_PIPE] = ACTIONS(1066),
    [anon_sym_LT] = ACTIONS(1506),
    [anon_sym_GT] = ACTIONS(1506),
    [anon_sym_GT_GT] = ACTIONS(1066),
    [anon_sym_AMP_GT] = ACTIONS(1506),
    [anon_sym_AMP_GT_GT] = ACTIONS(1066),
    [anon_sym_LT_AMP] = ACTIONS(1066),
    [anon_sym_GT_AMP] = ACTIONS(1066),
    [anon_sym_LT_LT] = ACTIONS(1506),
    [anon_sym_LT_LT_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(1066),
    [sym_raw_string] = ACTIONS(1066),
    [anon_sym_DOLLAR] = ACTIONS(1506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1066),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1066),
    [anon_sym_BQUOTE] = ACTIONS(1066),
    [anon_sym_LT_LPAREN] = ACTIONS(1066),
    [anon_sym_GT_LPAREN] = ACTIONS(1066),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1506),
  },
  [555] = {
    [sym_file_descriptor] = ACTIONS(1122),
    [sym_word] = ACTIONS(1122),
    [sym__concat] = ACTIONS(1122),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_RPAREN] = ACTIONS(1122),
    [anon_sym_PIPE_AMP] = ACTIONS(1122),
    [anon_sym_AMP_AMP] = ACTIONS(1122),
    [anon_sym_PIPE_PIPE] = ACTIONS(1122),
    [anon_sym_LT] = ACTIONS(1508),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_GT_GT] = ACTIONS(1122),
    [anon_sym_AMP_GT] = ACTIONS(1508),
    [anon_sym_AMP_GT_GT] = ACTIONS(1122),
    [anon_sym_LT_AMP] = ACTIONS(1122),
    [anon_sym_GT_AMP] = ACTIONS(1122),
    [anon_sym_LT_LT] = ACTIONS(1508),
    [anon_sym_LT_LT_DASH] = ACTIONS(1122),
    [anon_sym_DQUOTE] = ACTIONS(1122),
    [sym_raw_string] = ACTIONS(1122),
    [anon_sym_DOLLAR] = ACTIONS(1508),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1122),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1122),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [anon_sym_LT_LPAREN] = ACTIONS(1122),
    [anon_sym_GT_LPAREN] = ACTIONS(1122),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1508),
  },
  [556] = {
    [sym_compound_statement] = STATE(877),
    [anon_sym_LBRACE] = ACTIONS(1024),
    [sym_comment] = ACTIONS(46),
  },
  [557] = {
    [anon_sym_PIPE] = ACTIONS(1686),
    [anon_sym_RPAREN] = ACTIONS(1688),
    [anon_sym_PIPE_AMP] = ACTIONS(1688),
    [anon_sym_AMP_AMP] = ACTIONS(1688),
    [anon_sym_PIPE_PIPE] = ACTIONS(1688),
    [anon_sym_BQUOTE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(46),
  },
  [558] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(1686),
    [anon_sym_RPAREN] = ACTIONS(1688),
    [anon_sym_PIPE_AMP] = ACTIONS(1688),
    [anon_sym_AMP_AMP] = ACTIONS(1688),
    [anon_sym_PIPE_PIPE] = ACTIONS(1688),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [559] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1690),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(1690),
    [anon_sym_PIPE_PIPE] = ACTIONS(1690),
    [sym_comment] = ACTIONS(46),
  },
  [560] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1690),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(1690),
    [anon_sym_PIPE_PIPE] = ACTIONS(1690),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [561] = {
    [sym_concatenation] = STATE(880),
    [sym_string] = STATE(878),
    [sym_simple_expansion] = STATE(878),
    [sym_expansion] = STATE(878),
    [sym_command_substitution] = STATE(878),
    [sym_process_substitution] = STATE(878),
    [sym_word] = ACTIONS(1692),
    [anon_sym_DQUOTE] = ACTIONS(1078),
    [sym_raw_string] = ACTIONS(1692),
    [anon_sym_DOLLAR] = ACTIONS(1080),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1084),
    [anon_sym_BQUOTE] = ACTIONS(1086),
    [anon_sym_LT_LPAREN] = ACTIONS(1088),
    [anon_sym_GT_LPAREN] = ACTIONS(1088),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1694),
  },
  [562] = {
    [aux_sym_concatenation_repeat1] = STATE(882),
    [sym_file_descriptor] = ACTIONS(372),
    [sym__concat] = ACTIONS(1696),
    [anon_sym_PIPE] = ACTIONS(376),
    [anon_sym_RPAREN] = ACTIONS(372),
    [anon_sym_PIPE_AMP] = ACTIONS(372),
    [anon_sym_AMP_AMP] = ACTIONS(372),
    [anon_sym_PIPE_PIPE] = ACTIONS(372),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_GT] = ACTIONS(376),
    [anon_sym_GT_GT] = ACTIONS(372),
    [anon_sym_AMP_GT] = ACTIONS(376),
    [anon_sym_AMP_GT_GT] = ACTIONS(372),
    [anon_sym_LT_AMP] = ACTIONS(372),
    [anon_sym_GT_AMP] = ACTIONS(372),
    [anon_sym_LT_LT] = ACTIONS(376),
    [anon_sym_LT_LT_DASH] = ACTIONS(372),
    [sym_comment] = ACTIONS(46),
  },
  [563] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(884),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [564] = {
    [sym_special_variable_name] = STATE(887),
    [anon_sym_DOLLAR] = ACTIONS(1700),
    [anon_sym_POUND] = ACTIONS(1700),
    [anon_sym_AT] = ACTIONS(1700),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1702),
    [anon_sym_STAR] = ACTIONS(1700),
    [anon_sym_QMARK] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_BANG] = ACTIONS(1700),
    [anon_sym_0] = ACTIONS(1704),
    [anon_sym__] = ACTIONS(1704),
  },
  [565] = {
    [sym_special_variable_name] = STATE(890),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(1706),
    [anon_sym_AT] = ACTIONS(138),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1708),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [566] = {
    [sym_for_statement] = STATE(891),
    [sym_while_statement] = STATE(891),
    [sym_if_statement] = STATE(891),
    [sym_case_statement] = STATE(891),
    [sym_function_definition] = STATE(891),
    [sym_subshell] = STATE(891),
    [sym_pipeline] = STATE(891),
    [sym_list] = STATE(891),
    [sym_command] = STATE(891),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(892),
    [sym_declaration_command] = STATE(891),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [567] = {
    [sym_for_statement] = STATE(893),
    [sym_while_statement] = STATE(893),
    [sym_if_statement] = STATE(893),
    [sym_case_statement] = STATE(893),
    [sym_function_definition] = STATE(893),
    [sym_subshell] = STATE(893),
    [sym_pipeline] = STATE(893),
    [sym_list] = STATE(893),
    [sym_command] = STATE(893),
    [sym_command_name] = STATE(118),
    [sym_variable_assignment] = STATE(894),
    [sym_declaration_command] = STATE(893),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(112),
    [sym_simple_expansion] = STATE(112),
    [sym_expansion] = STATE(112),
    [sym_command_substitution] = STATE(112),
    [sym_process_substitution] = STATE(112),
    [aux_sym_command_repeat1] = STATE(121),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(178),
    [sym_variable_name] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(184),
    [anon_sym_typeset] = ACTIONS(184),
    [anon_sym_export] = ACTIONS(184),
    [anon_sym_readonly] = ACTIONS(184),
    [anon_sym_local] = ACTIONS(184),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(178),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(186),
  },
  [568] = {
    [sym_for_statement] = STATE(895),
    [sym_while_statement] = STATE(895),
    [sym_if_statement] = STATE(895),
    [sym_case_statement] = STATE(895),
    [sym_function_definition] = STATE(895),
    [sym_subshell] = STATE(895),
    [sym_pipeline] = STATE(895),
    [sym_list] = STATE(895),
    [sym_command] = STATE(895),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(896),
    [sym_declaration_command] = STATE(895),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [569] = {
    [aux_sym_concatenation_repeat1] = STATE(897),
    [sym_file_descriptor] = ACTIONS(390),
    [sym__concat] = ACTIONS(1696),
    [anon_sym_PIPE] = ACTIONS(392),
    [anon_sym_RPAREN] = ACTIONS(390),
    [anon_sym_PIPE_AMP] = ACTIONS(390),
    [anon_sym_AMP_AMP] = ACTIONS(390),
    [anon_sym_PIPE_PIPE] = ACTIONS(390),
    [anon_sym_LT] = ACTIONS(392),
    [anon_sym_GT] = ACTIONS(392),
    [anon_sym_GT_GT] = ACTIONS(390),
    [anon_sym_AMP_GT] = ACTIONS(392),
    [anon_sym_AMP_GT_GT] = ACTIONS(390),
    [anon_sym_LT_AMP] = ACTIONS(390),
    [anon_sym_GT_AMP] = ACTIONS(390),
    [anon_sym_LT_LT] = ACTIONS(392),
    [anon_sym_LT_LT_DASH] = ACTIONS(390),
    [sym_comment] = ACTIONS(46),
  },
  [570] = {
    [sym_file_descriptor] = ACTIONS(372),
    [anon_sym_PIPE] = ACTIONS(376),
    [anon_sym_RPAREN] = ACTIONS(372),
    [anon_sym_PIPE_AMP] = ACTIONS(372),
    [anon_sym_AMP_AMP] = ACTIONS(372),
    [anon_sym_PIPE_PIPE] = ACTIONS(372),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_GT] = ACTIONS(376),
    [anon_sym_GT_GT] = ACTIONS(372),
    [anon_sym_AMP_GT] = ACTIONS(376),
    [anon_sym_AMP_GT_GT] = ACTIONS(372),
    [anon_sym_LT_AMP] = ACTIONS(372),
    [anon_sym_GT_AMP] = ACTIONS(372),
    [anon_sym_LT_LT] = ACTIONS(376),
    [anon_sym_LT_LT_DASH] = ACTIONS(372),
    [anon_sym_BQUOTE] = ACTIONS(372),
    [sym_comment] = ACTIONS(46),
  },
  [571] = {
    [sym_file_descriptor] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1710),
    [anon_sym_RPAREN] = ACTIONS(1152),
    [anon_sym_PIPE_AMP] = ACTIONS(1152),
    [anon_sym_AMP_AMP] = ACTIONS(1152),
    [anon_sym_PIPE_PIPE] = ACTIONS(1152),
    [anon_sym_LT] = ACTIONS(1710),
    [anon_sym_GT] = ACTIONS(1710),
    [anon_sym_GT_GT] = ACTIONS(1152),
    [anon_sym_AMP_GT] = ACTIONS(1710),
    [anon_sym_AMP_GT_GT] = ACTIONS(1152),
    [anon_sym_LT_AMP] = ACTIONS(1152),
    [anon_sym_GT_AMP] = ACTIONS(1152),
    [anon_sym_LT_LT] = ACTIONS(1710),
    [anon_sym_LT_LT_DASH] = ACTIONS(1152),
    [anon_sym_BQUOTE] = ACTIONS(1152),
    [sym_comment] = ACTIONS(46),
  },
  [572] = {
    [sym_simple_expansion] = STATE(617),
    [sym_expansion] = STATE(617),
    [aux_sym_heredoc_repeat1] = STATE(899),
    [sym__heredoc_middle] = ACTIONS(1156),
    [sym__heredoc_end] = ACTIONS(1712),
    [anon_sym_DOLLAR] = ACTIONS(1160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1162),
    [sym_comment] = ACTIONS(46),
  },
  [573] = {
    [sym_file_descriptor] = ACTIONS(1164),
    [anon_sym_PIPE] = ACTIONS(1714),
    [anon_sym_RPAREN] = ACTIONS(1164),
    [anon_sym_PIPE_AMP] = ACTIONS(1164),
    [anon_sym_AMP_AMP] = ACTIONS(1164),
    [anon_sym_PIPE_PIPE] = ACTIONS(1164),
    [anon_sym_LT] = ACTIONS(1714),
    [anon_sym_GT] = ACTIONS(1714),
    [anon_sym_GT_GT] = ACTIONS(1164),
    [anon_sym_AMP_GT] = ACTIONS(1714),
    [anon_sym_AMP_GT_GT] = ACTIONS(1164),
    [anon_sym_LT_AMP] = ACTIONS(1164),
    [anon_sym_GT_AMP] = ACTIONS(1164),
    [anon_sym_LT_LT] = ACTIONS(1714),
    [anon_sym_LT_LT_DASH] = ACTIONS(1164),
    [anon_sym_BQUOTE] = ACTIONS(1164),
    [sym_comment] = ACTIONS(46),
  },
  [574] = {
    [sym_concatenation] = STATE(305),
    [sym_string] = STATE(300),
    [sym_simple_expansion] = STATE(300),
    [sym_expansion] = STATE(300),
    [sym_command_substitution] = STATE(300),
    [sym_process_substitution] = STATE(300),
    [aux_sym_for_statement_repeat1] = STATE(574),
    [sym_file_descriptor] = ACTIONS(1168),
    [sym_word] = ACTIONS(1716),
    [anon_sym_PIPE] = ACTIONS(1719),
    [anon_sym_RPAREN] = ACTIONS(1168),
    [anon_sym_PIPE_AMP] = ACTIONS(1168),
    [anon_sym_AMP_AMP] = ACTIONS(1168),
    [anon_sym_PIPE_PIPE] = ACTIONS(1168),
    [anon_sym_LT] = ACTIONS(1719),
    [anon_sym_GT] = ACTIONS(1719),
    [anon_sym_GT_GT] = ACTIONS(1168),
    [anon_sym_AMP_GT] = ACTIONS(1719),
    [anon_sym_AMP_GT_GT] = ACTIONS(1168),
    [anon_sym_LT_AMP] = ACTIONS(1168),
    [anon_sym_GT_AMP] = ACTIONS(1168),
    [anon_sym_LT_LT] = ACTIONS(1719),
    [anon_sym_LT_LT_DASH] = ACTIONS(1168),
    [anon_sym_DQUOTE] = ACTIONS(1721),
    [sym_raw_string] = ACTIONS(1716),
    [anon_sym_DOLLAR] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1727),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1730),
    [anon_sym_BQUOTE] = ACTIONS(1733),
    [anon_sym_LT_LPAREN] = ACTIONS(1736),
    [anon_sym_GT_LPAREN] = ACTIONS(1736),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1739),
  },
  [575] = {
    [sym_file_redirect] = STATE(304),
    [sym_heredoc_redirect] = STATE(304),
    [aux_sym_command_repeat2] = STATE(576),
    [sym_file_descriptor] = ACTIONS(492),
    [anon_sym_PIPE] = ACTIONS(1742),
    [anon_sym_RPAREN] = ACTIONS(1744),
    [anon_sym_PIPE_AMP] = ACTIONS(1744),
    [anon_sym_AMP_AMP] = ACTIONS(1744),
    [anon_sym_PIPE_PIPE] = ACTIONS(1744),
    [anon_sym_LT] = ACTIONS(500),
    [anon_sym_GT] = ACTIONS(500),
    [anon_sym_GT_GT] = ACTIONS(502),
    [anon_sym_AMP_GT] = ACTIONS(500),
    [anon_sym_AMP_GT_GT] = ACTIONS(502),
    [anon_sym_LT_AMP] = ACTIONS(502),
    [anon_sym_GT_AMP] = ACTIONS(502),
    [anon_sym_LT_LT] = ACTIONS(504),
    [anon_sym_LT_LT_DASH] = ACTIONS(506),
    [sym_comment] = ACTIONS(46),
  },
  [576] = {
    [sym_file_redirect] = STATE(304),
    [sym_heredoc_redirect] = STATE(304),
    [aux_sym_command_repeat2] = STATE(576),
    [sym_file_descriptor] = ACTIONS(1746),
    [anon_sym_PIPE] = ACTIONS(1749),
    [anon_sym_RPAREN] = ACTIONS(1751),
    [anon_sym_PIPE_AMP] = ACTIONS(1751),
    [anon_sym_AMP_AMP] = ACTIONS(1751),
    [anon_sym_PIPE_PIPE] = ACTIONS(1751),
    [anon_sym_LT] = ACTIONS(1753),
    [anon_sym_GT] = ACTIONS(1753),
    [anon_sym_GT_GT] = ACTIONS(1756),
    [anon_sym_AMP_GT] = ACTIONS(1753),
    [anon_sym_AMP_GT_GT] = ACTIONS(1756),
    [anon_sym_LT_AMP] = ACTIONS(1756),
    [anon_sym_GT_AMP] = ACTIONS(1756),
    [anon_sym_LT_LT] = ACTIONS(1759),
    [anon_sym_LT_LT_DASH] = ACTIONS(1762),
    [sym_comment] = ACTIONS(46),
  },
  [577] = {
    [sym_file_redirect] = STATE(304),
    [sym_heredoc_redirect] = STATE(304),
    [sym_concatenation] = STATE(305),
    [sym_string] = STATE(300),
    [sym_simple_expansion] = STATE(300),
    [sym_expansion] = STATE(300),
    [sym_command_substitution] = STATE(300),
    [sym_process_substitution] = STATE(300),
    [aux_sym_for_statement_repeat1] = STATE(574),
    [aux_sym_command_repeat2] = STATE(900),
    [sym_file_descriptor] = ACTIONS(492),
    [sym_word] = ACTIONS(494),
    [anon_sym_PIPE] = ACTIONS(1742),
    [anon_sym_RPAREN] = ACTIONS(1744),
    [anon_sym_PIPE_AMP] = ACTIONS(1744),
    [anon_sym_AMP_AMP] = ACTIONS(1744),
    [anon_sym_PIPE_PIPE] = ACTIONS(1744),
    [anon_sym_LT] = ACTIONS(500),
    [anon_sym_GT] = ACTIONS(500),
    [anon_sym_GT_GT] = ACTIONS(502),
    [anon_sym_AMP_GT] = ACTIONS(500),
    [anon_sym_AMP_GT_GT] = ACTIONS(502),
    [anon_sym_LT_AMP] = ACTIONS(502),
    [anon_sym_GT_AMP] = ACTIONS(502),
    [anon_sym_LT_LT] = ACTIONS(504),
    [anon_sym_LT_LT_DASH] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(494),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(508),
  },
  [578] = {
    [aux_sym_concatenation_repeat1] = STATE(578),
    [sym_file_descriptor] = ACTIONS(675),
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(1568),
    [anon_sym_PIPE] = ACTIONS(1471),
    [anon_sym_PIPE_AMP] = ACTIONS(675),
    [anon_sym_AMP_AMP] = ACTIONS(675),
    [anon_sym_PIPE_PIPE] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_GT_GT] = ACTIONS(675),
    [anon_sym_AMP_GT] = ACTIONS(1471),
    [anon_sym_AMP_GT_GT] = ACTIONS(675),
    [anon_sym_LT_AMP] = ACTIONS(675),
    [anon_sym_GT_AMP] = ACTIONS(675),
    [anon_sym_LT_LT] = ACTIONS(1471),
    [anon_sym_LT_LT_DASH] = ACTIONS(675),
    [anon_sym_DQUOTE] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(1471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(675),
    [anon_sym_BQUOTE] = ACTIONS(675),
    [anon_sym_LT_LPAREN] = ACTIONS(675),
    [anon_sym_GT_LPAREN] = ACTIONS(675),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1471),
  },
  [579] = {
    [aux_sym_concatenation_repeat1] = STATE(901),
    [sym_file_descriptor] = ACTIONS(686),
    [sym_word] = ACTIONS(686),
    [sym__concat] = ACTIONS(1571),
    [sym_variable_name] = ACTIONS(686),
    [anon_sym_PIPE] = ACTIONS(1573),
    [anon_sym_PIPE_AMP] = ACTIONS(686),
    [anon_sym_AMP_AMP] = ACTIONS(686),
    [anon_sym_PIPE_PIPE] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(1573),
    [anon_sym_GT] = ACTIONS(1573),
    [anon_sym_GT_GT] = ACTIONS(686),
    [anon_sym_AMP_GT] = ACTIONS(1573),
    [anon_sym_AMP_GT_GT] = ACTIONS(686),
    [anon_sym_LT_AMP] = ACTIONS(686),
    [anon_sym_GT_AMP] = ACTIONS(686),
    [anon_sym_DQUOTE] = ACTIONS(686),
    [sym_raw_string] = ACTIONS(686),
    [anon_sym_DOLLAR] = ACTIONS(1573),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(686),
    [anon_sym_BQUOTE] = ACTIONS(686),
    [anon_sym_LT_LPAREN] = ACTIONS(686),
    [anon_sym_GT_LPAREN] = ACTIONS(686),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1573),
  },
  [580] = {
    [aux_sym_concatenation_repeat1] = STATE(902),
    [sym_file_descriptor] = ACTIONS(722),
    [sym_word] = ACTIONS(722),
    [sym__concat] = ACTIONS(1571),
    [sym_variable_name] = ACTIONS(722),
    [anon_sym_PIPE] = ACTIONS(1589),
    [anon_sym_PIPE_AMP] = ACTIONS(722),
    [anon_sym_AMP_AMP] = ACTIONS(722),
    [anon_sym_PIPE_PIPE] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(1589),
    [anon_sym_GT] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(722),
    [anon_sym_AMP_GT] = ACTIONS(1589),
    [anon_sym_AMP_GT_GT] = ACTIONS(722),
    [anon_sym_LT_AMP] = ACTIONS(722),
    [anon_sym_GT_AMP] = ACTIONS(722),
    [anon_sym_DQUOTE] = ACTIONS(722),
    [sym_raw_string] = ACTIONS(722),
    [anon_sym_DOLLAR] = ACTIONS(1589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(722),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [anon_sym_LT_LPAREN] = ACTIONS(722),
    [anon_sym_GT_LPAREN] = ACTIONS(722),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1589),
  },
  [581] = {
    [anon_sym_RPAREN] = ACTIONS(1765),
    [sym_comment] = ACTIONS(46),
  },
  [582] = {
    [sym_file_redirect] = STATE(851),
    [sym_file_descriptor] = ACTIONS(1767),
    [anon_sym_PIPE] = ACTIONS(1613),
    [anon_sym_PIPE_AMP] = ACTIONS(1615),
    [anon_sym_AMP_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1615),
    [anon_sym_LT] = ACTIONS(1769),
    [anon_sym_GT] = ACTIONS(1769),
    [anon_sym_GT_GT] = ACTIONS(1771),
    [anon_sym_AMP_GT] = ACTIONS(1769),
    [anon_sym_AMP_GT_GT] = ACTIONS(1771),
    [anon_sym_LT_AMP] = ACTIONS(1771),
    [anon_sym_GT_AMP] = ACTIONS(1771),
    [anon_sym_BQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(46),
  },
  [583] = {
    [sym_concatenation] = STATE(855),
    [sym_string] = STATE(906),
    [sym_array] = STATE(855),
    [sym_simple_expansion] = STATE(906),
    [sym_expansion] = STATE(906),
    [sym_command_substitution] = STATE(906),
    [sym_process_substitution] = STATE(906),
    [sym_word] = ACTIONS(1773),
    [sym__empty_value] = ACTIONS(1633),
    [anon_sym_LPAREN] = ACTIONS(1635),
    [anon_sym_DQUOTE] = ACTIONS(1637),
    [sym_raw_string] = ACTIONS(1773),
    [anon_sym_DOLLAR] = ACTIONS(1639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1641),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1643),
    [anon_sym_BQUOTE] = ACTIONS(1645),
    [anon_sym_LT_LPAREN] = ACTIONS(1647),
    [anon_sym_GT_LPAREN] = ACTIONS(1647),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1775),
  },
  [584] = {
    [sym_variable_assignment] = STATE(275),
    [sym_subscript] = STATE(314),
    [aux_sym_declaration_command_repeat1] = STATE(584),
    [sym_word] = ACTIONS(1651),
    [sym_variable_name] = ACTIONS(1777),
    [anon_sym_PIPE] = ACTIONS(1657),
    [anon_sym_PIPE_AMP] = ACTIONS(1659),
    [anon_sym_AMP_AMP] = ACTIONS(1659),
    [anon_sym_PIPE_PIPE] = ACTIONS(1659),
    [anon_sym_BQUOTE] = ACTIONS(1659),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1661),
  },
  [585] = {
    [sym_compound_statement] = STATE(908),
    [anon_sym_LBRACE] = ACTIONS(1024),
    [sym_comment] = ACTIONS(46),
  },
  [586] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(1686),
    [anon_sym_PIPE_AMP] = ACTIONS(1688),
    [anon_sym_AMP_AMP] = ACTIONS(1688),
    [anon_sym_PIPE_PIPE] = ACTIONS(1688),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(1688),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [587] = {
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(1690),
    [anon_sym_PIPE_PIPE] = ACTIONS(1690),
    [anon_sym_BQUOTE] = ACTIONS(1690),
    [sym_comment] = ACTIONS(46),
  },
  [588] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(1690),
    [anon_sym_PIPE_PIPE] = ACTIONS(1690),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [589] = {
    [sym_concatenation] = STATE(880),
    [sym_string] = STATE(909),
    [sym_simple_expansion] = STATE(909),
    [sym_expansion] = STATE(909),
    [sym_command_substitution] = STATE(909),
    [sym_process_substitution] = STATE(909),
    [sym_word] = ACTIONS(1780),
    [anon_sym_DQUOTE] = ACTIONS(1078),
    [sym_raw_string] = ACTIONS(1780),
    [anon_sym_DOLLAR] = ACTIONS(1080),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1084),
    [anon_sym_BQUOTE] = ACTIONS(1086),
    [anon_sym_LT_LPAREN] = ACTIONS(1088),
    [anon_sym_GT_LPAREN] = ACTIONS(1088),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1782),
  },
  [590] = {
    [aux_sym_concatenation_repeat1] = STATE(911),
    [sym_file_descriptor] = ACTIONS(372),
    [sym__concat] = ACTIONS(1696),
    [anon_sym_PIPE] = ACTIONS(376),
    [anon_sym_PIPE_AMP] = ACTIONS(372),
    [anon_sym_AMP_AMP] = ACTIONS(372),
    [anon_sym_PIPE_PIPE] = ACTIONS(372),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_GT] = ACTIONS(376),
    [anon_sym_GT_GT] = ACTIONS(372),
    [anon_sym_AMP_GT] = ACTIONS(376),
    [anon_sym_AMP_GT_GT] = ACTIONS(372),
    [anon_sym_LT_AMP] = ACTIONS(372),
    [anon_sym_GT_AMP] = ACTIONS(372),
    [anon_sym_LT_LT] = ACTIONS(376),
    [anon_sym_LT_LT_DASH] = ACTIONS(372),
    [anon_sym_BQUOTE] = ACTIONS(372),
    [sym_comment] = ACTIONS(46),
  },
  [591] = {
    [aux_sym_concatenation_repeat1] = STATE(912),
    [sym_file_descriptor] = ACTIONS(390),
    [sym__concat] = ACTIONS(1696),
    [anon_sym_PIPE] = ACTIONS(392),
    [anon_sym_PIPE_AMP] = ACTIONS(390),
    [anon_sym_AMP_AMP] = ACTIONS(390),
    [anon_sym_PIPE_PIPE] = ACTIONS(390),
    [anon_sym_LT] = ACTIONS(392),
    [anon_sym_GT] = ACTIONS(392),
    [anon_sym_GT_GT] = ACTIONS(390),
    [anon_sym_AMP_GT] = ACTIONS(392),
    [anon_sym_AMP_GT_GT] = ACTIONS(390),
    [anon_sym_LT_AMP] = ACTIONS(390),
    [anon_sym_GT_AMP] = ACTIONS(390),
    [anon_sym_LT_LT] = ACTIONS(392),
    [anon_sym_LT_LT_DASH] = ACTIONS(390),
    [anon_sym_BQUOTE] = ACTIONS(390),
    [sym_comment] = ACTIONS(46),
  },
  [592] = {
    [sym_concatenation] = STATE(305),
    [sym_string] = STATE(321),
    [sym_simple_expansion] = STATE(321),
    [sym_expansion] = STATE(321),
    [sym_command_substitution] = STATE(321),
    [sym_process_substitution] = STATE(321),
    [aux_sym_for_statement_repeat1] = STATE(592),
    [sym_file_descriptor] = ACTIONS(1168),
    [sym_word] = ACTIONS(1784),
    [anon_sym_PIPE] = ACTIONS(1719),
    [anon_sym_PIPE_AMP] = ACTIONS(1168),
    [anon_sym_AMP_AMP] = ACTIONS(1168),
    [anon_sym_PIPE_PIPE] = ACTIONS(1168),
    [anon_sym_LT] = ACTIONS(1719),
    [anon_sym_GT] = ACTIONS(1719),
    [anon_sym_GT_GT] = ACTIONS(1168),
    [anon_sym_AMP_GT] = ACTIONS(1719),
    [anon_sym_AMP_GT_GT] = ACTIONS(1168),
    [anon_sym_LT_AMP] = ACTIONS(1168),
    [anon_sym_GT_AMP] = ACTIONS(1168),
    [anon_sym_LT_LT] = ACTIONS(1719),
    [anon_sym_LT_LT_DASH] = ACTIONS(1168),
    [anon_sym_DQUOTE] = ACTIONS(1721),
    [sym_raw_string] = ACTIONS(1784),
    [anon_sym_DOLLAR] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1727),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1730),
    [anon_sym_BQUOTE] = ACTIONS(1733),
    [anon_sym_LT_LPAREN] = ACTIONS(1736),
    [anon_sym_GT_LPAREN] = ACTIONS(1736),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1787),
  },
  [593] = {
    [sym_file_redirect] = STATE(304),
    [sym_heredoc_redirect] = STATE(304),
    [aux_sym_command_repeat2] = STATE(594),
    [sym_file_descriptor] = ACTIONS(526),
    [anon_sym_PIPE] = ACTIONS(1742),
    [anon_sym_PIPE_AMP] = ACTIONS(1744),
    [anon_sym_AMP_AMP] = ACTIONS(1744),
    [anon_sym_PIPE_PIPE] = ACTIONS(1744),
    [anon_sym_LT] = ACTIONS(530),
    [anon_sym_GT] = ACTIONS(530),
    [anon_sym_GT_GT] = ACTIONS(532),
    [anon_sym_AMP_GT] = ACTIONS(530),
    [anon_sym_AMP_GT_GT] = ACTIONS(532),
    [anon_sym_LT_AMP] = ACTIONS(532),
    [anon_sym_GT_AMP] = ACTIONS(532),
    [anon_sym_LT_LT] = ACTIONS(504),
    [anon_sym_LT_LT_DASH] = ACTIONS(506),
    [anon_sym_BQUOTE] = ACTIONS(1744),
    [sym_comment] = ACTIONS(46),
  },
  [594] = {
    [sym_file_redirect] = STATE(304),
    [sym_heredoc_redirect] = STATE(304),
    [aux_sym_command_repeat2] = STATE(594),
    [sym_file_descriptor] = ACTIONS(1790),
    [anon_sym_PIPE] = ACTIONS(1749),
    [anon_sym_PIPE_AMP] = ACTIONS(1751),
    [anon_sym_AMP_AMP] = ACTIONS(1751),
    [anon_sym_PIPE_PIPE] = ACTIONS(1751),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_GT_GT] = ACTIONS(1796),
    [anon_sym_AMP_GT] = ACTIONS(1793),
    [anon_sym_AMP_GT_GT] = ACTIONS(1796),
    [anon_sym_LT_AMP] = ACTIONS(1796),
    [anon_sym_GT_AMP] = ACTIONS(1796),
    [anon_sym_LT_LT] = ACTIONS(1759),
    [anon_sym_LT_LT_DASH] = ACTIONS(1762),
    [anon_sym_BQUOTE] = ACTIONS(1751),
    [sym_comment] = ACTIONS(46),
  },
  [595] = {
    [sym_file_redirect] = STATE(304),
    [sym_heredoc_redirect] = STATE(304),
    [sym_concatenation] = STATE(305),
    [sym_string] = STATE(321),
    [sym_simple_expansion] = STATE(321),
    [sym_expansion] = STATE(321),
    [sym_command_substitution] = STATE(321),
    [sym_process_substitution] = STATE(321),
    [aux_sym_for_statement_repeat1] = STATE(592),
    [aux_sym_command_repeat2] = STATE(913),
    [sym_file_descriptor] = ACTIONS(526),
    [sym_word] = ACTIONS(528),
    [anon_sym_PIPE] = ACTIONS(1742),
    [anon_sym_PIPE_AMP] = ACTIONS(1744),
    [anon_sym_AMP_AMP] = ACTIONS(1744),
    [anon_sym_PIPE_PIPE] = ACTIONS(1744),
    [anon_sym_LT] = ACTIONS(530),
    [anon_sym_GT] = ACTIONS(530),
    [anon_sym_GT_GT] = ACTIONS(532),
    [anon_sym_AMP_GT] = ACTIONS(530),
    [anon_sym_AMP_GT_GT] = ACTIONS(532),
    [anon_sym_LT_AMP] = ACTIONS(532),
    [anon_sym_GT_AMP] = ACTIONS(532),
    [anon_sym_LT_LT] = ACTIONS(504),
    [anon_sym_LT_LT_DASH] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(528),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(1744),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(534),
  },
  [596] = {
    [sym_file_redirect] = STATE(914),
    [sym_file_descriptor] = ACTIONS(810),
    [anon_sym_PIPE] = ACTIONS(1799),
    [anon_sym_SEMI_SEMI] = ACTIONS(1799),
    [anon_sym_PIPE_AMP] = ACTIONS(1799),
    [anon_sym_AMP_AMP] = ACTIONS(1799),
    [anon_sym_PIPE_PIPE] = ACTIONS(1799),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_GT_GT] = ACTIONS(814),
    [anon_sym_AMP_GT] = ACTIONS(814),
    [anon_sym_AMP_GT_GT] = ACTIONS(814),
    [anon_sym_LT_AMP] = ACTIONS(814),
    [anon_sym_GT_AMP] = ACTIONS(814),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1799),
    [anon_sym_LF] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
  },
  [597] = {
    [aux_sym_concatenation_repeat1] = STATE(601),
    [sym_file_descriptor] = ACTIONS(667),
    [sym__concat] = ACTIONS(1134),
    [anon_sym_PIPE] = ACTIONS(1801),
    [anon_sym_SEMI_SEMI] = ACTIONS(1801),
    [anon_sym_PIPE_AMP] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1801),
    [anon_sym_PIPE_PIPE] = ACTIONS(1801),
    [anon_sym_LT] = ACTIONS(1801),
    [anon_sym_GT] = ACTIONS(1801),
    [anon_sym_GT_GT] = ACTIONS(1801),
    [anon_sym_AMP_GT] = ACTIONS(1801),
    [anon_sym_AMP_GT_GT] = ACTIONS(1801),
    [anon_sym_LT_AMP] = ACTIONS(1801),
    [anon_sym_GT_AMP] = ACTIONS(1801),
    [anon_sym_LT_LT] = ACTIONS(1801),
    [anon_sym_LT_LT_DASH] = ACTIONS(1801),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1801),
    [anon_sym_LF] = ACTIONS(1801),
    [anon_sym_AMP] = ACTIONS(1801),
  },
  [598] = {
    [aux_sym_concatenation_repeat1] = STATE(616),
    [sym_file_descriptor] = ACTIONS(671),
    [sym__concat] = ACTIONS(1134),
    [anon_sym_PIPE] = ACTIONS(1803),
    [anon_sym_SEMI_SEMI] = ACTIONS(1803),
    [anon_sym_PIPE_AMP] = ACTIONS(1803),
    [anon_sym_AMP_AMP] = ACTIONS(1803),
    [anon_sym_PIPE_PIPE] = ACTIONS(1803),
    [anon_sym_LT] = ACTIONS(1803),
    [anon_sym_GT] = ACTIONS(1803),
    [anon_sym_GT_GT] = ACTIONS(1803),
    [anon_sym_AMP_GT] = ACTIONS(1803),
    [anon_sym_AMP_GT_GT] = ACTIONS(1803),
    [anon_sym_LT_AMP] = ACTIONS(1803),
    [anon_sym_GT_AMP] = ACTIONS(1803),
    [anon_sym_LT_LT] = ACTIONS(1803),
    [anon_sym_LT_LT_DASH] = ACTIONS(1803),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1803),
    [anon_sym_LF] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
  },
  [599] = {
    [sym_file_descriptor] = ACTIONS(667),
    [anon_sym_PIPE] = ACTIONS(1801),
    [anon_sym_RPAREN] = ACTIONS(1801),
    [anon_sym_SEMI_SEMI] = ACTIONS(1801),
    [anon_sym_PIPE_AMP] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1801),
    [anon_sym_PIPE_PIPE] = ACTIONS(1801),
    [anon_sym_LT] = ACTIONS(1801),
    [anon_sym_GT] = ACTIONS(1801),
    [anon_sym_GT_GT] = ACTIONS(1801),
    [anon_sym_AMP_GT] = ACTIONS(1801),
    [anon_sym_AMP_GT_GT] = ACTIONS(1801),
    [anon_sym_LT_AMP] = ACTIONS(1801),
    [anon_sym_GT_AMP] = ACTIONS(1801),
    [anon_sym_LT_LT] = ACTIONS(1801),
    [anon_sym_LT_LT_DASH] = ACTIONS(1801),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1801),
    [anon_sym_LF] = ACTIONS(1801),
    [anon_sym_AMP] = ACTIONS(1801),
  },
  [600] = {
    [sym_string] = STATE(915),
    [sym_simple_expansion] = STATE(915),
    [sym_expansion] = STATE(915),
    [sym_command_substitution] = STATE(915),
    [sym_process_substitution] = STATE(915),
    [sym_word] = ACTIONS(1805),
    [anon_sym_DQUOTE] = ACTIONS(562),
    [sym_raw_string] = ACTIONS(1805),
    [anon_sym_DOLLAR] = ACTIONS(564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(566),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(568),
    [anon_sym_BQUOTE] = ACTIONS(570),
    [anon_sym_LT_LPAREN] = ACTIONS(572),
    [anon_sym_GT_LPAREN] = ACTIONS(572),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1807),
  },
  [601] = {
    [aux_sym_concatenation_repeat1] = STATE(917),
    [sym_file_descriptor] = ACTIONS(254),
    [sym__concat] = ACTIONS(1134),
    [anon_sym_PIPE] = ACTIONS(256),
    [anon_sym_SEMI_SEMI] = ACTIONS(256),
    [anon_sym_PIPE_AMP] = ACTIONS(256),
    [anon_sym_AMP_AMP] = ACTIONS(256),
    [anon_sym_PIPE_PIPE] = ACTIONS(256),
    [anon_sym_LT] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(256),
    [anon_sym_GT_GT] = ACTIONS(256),
    [anon_sym_AMP_GT] = ACTIONS(256),
    [anon_sym_AMP_GT_GT] = ACTIONS(256),
    [anon_sym_LT_AMP] = ACTIONS(256),
    [anon_sym_GT_AMP] = ACTIONS(256),
    [anon_sym_LT_LT] = ACTIONS(256),
    [anon_sym_LT_LT_DASH] = ACTIONS(256),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(256),
    [anon_sym_LF] = ACTIONS(256),
    [anon_sym_AMP] = ACTIONS(256),
  },
  [602] = {
    [sym_file_descriptor] = ACTIONS(394),
    [sym__concat] = ACTIONS(394),
    [anon_sym_PIPE] = ACTIONS(396),
    [anon_sym_RPAREN] = ACTIONS(396),
    [anon_sym_SEMI_SEMI] = ACTIONS(396),
    [anon_sym_PIPE_AMP] = ACTIONS(396),
    [anon_sym_AMP_AMP] = ACTIONS(396),
    [anon_sym_PIPE_PIPE] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(396),
    [anon_sym_GT] = ACTIONS(396),
    [anon_sym_GT_GT] = ACTIONS(396),
    [anon_sym_AMP_GT] = ACTIONS(396),
    [anon_sym_AMP_GT_GT] = ACTIONS(396),
    [anon_sym_LT_AMP] = ACTIONS(396),
    [anon_sym_GT_AMP] = ACTIONS(396),
    [anon_sym_LT_LT] = ACTIONS(396),
    [anon_sym_LT_LT_DASH] = ACTIONS(396),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(396),
    [anon_sym_LF] = ACTIONS(396),
    [anon_sym_AMP] = ACTIONS(396),
  },
  [603] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(252),
    [anon_sym_DQUOTE] = ACTIONS(1809),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [604] = {
    [sym_file_descriptor] = ACTIONS(412),
    [sym__concat] = ACTIONS(412),
    [anon_sym_PIPE] = ACTIONS(414),
    [anon_sym_RPAREN] = ACTIONS(414),
    [anon_sym_SEMI_SEMI] = ACTIONS(414),
    [anon_sym_PIPE_AMP] = ACTIONS(414),
    [anon_sym_AMP_AMP] = ACTIONS(414),
    [anon_sym_PIPE_PIPE] = ACTIONS(414),
    [anon_sym_LT] = ACTIONS(414),
    [anon_sym_GT] = ACTIONS(414),
    [anon_sym_GT_GT] = ACTIONS(414),
    [anon_sym_AMP_GT] = ACTIONS(414),
    [anon_sym_AMP_GT_GT] = ACTIONS(414),
    [anon_sym_LT_AMP] = ACTIONS(414),
    [anon_sym_GT_AMP] = ACTIONS(414),
    [anon_sym_LT_LT] = ACTIONS(414),
    [anon_sym_LT_LT_DASH] = ACTIONS(414),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(414),
    [anon_sym_LF] = ACTIONS(414),
    [anon_sym_AMP] = ACTIONS(414),
  },
  [605] = {
    [sym_file_descriptor] = ACTIONS(416),
    [sym__concat] = ACTIONS(416),
    [anon_sym_PIPE] = ACTIONS(418),
    [anon_sym_RPAREN] = ACTIONS(418),
    [anon_sym_SEMI_SEMI] = ACTIONS(418),
    [anon_sym_PIPE_AMP] = ACTIONS(418),
    [anon_sym_AMP_AMP] = ACTIONS(418),
    [anon_sym_PIPE_PIPE] = ACTIONS(418),
    [anon_sym_LT] = ACTIONS(418),
    [anon_sym_GT] = ACTIONS(418),
    [anon_sym_GT_GT] = ACTIONS(418),
    [anon_sym_AMP_GT] = ACTIONS(418),
    [anon_sym_AMP_GT_GT] = ACTIONS(418),
    [anon_sym_LT_AMP] = ACTIONS(418),
    [anon_sym_GT_AMP] = ACTIONS(418),
    [anon_sym_LT_LT] = ACTIONS(418),
    [anon_sym_LT_LT_DASH] = ACTIONS(418),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(418),
    [anon_sym_LF] = ACTIONS(418),
    [anon_sym_AMP] = ACTIONS(418),
  },
  [606] = {
    [sym_file_descriptor] = ACTIONS(420),
    [sym__concat] = ACTIONS(420),
    [anon_sym_PIPE] = ACTIONS(422),
    [anon_sym_RPAREN] = ACTIONS(422),
    [anon_sym_SEMI_SEMI] = ACTIONS(422),
    [anon_sym_PIPE_AMP] = ACTIONS(422),
    [anon_sym_AMP_AMP] = ACTIONS(422),
    [anon_sym_PIPE_PIPE] = ACTIONS(422),
    [anon_sym_LT] = ACTIONS(422),
    [anon_sym_GT] = ACTIONS(422),
    [anon_sym_GT_GT] = ACTIONS(422),
    [anon_sym_AMP_GT] = ACTIONS(422),
    [anon_sym_AMP_GT_GT] = ACTIONS(422),
    [anon_sym_LT_AMP] = ACTIONS(422),
    [anon_sym_GT_AMP] = ACTIONS(422),
    [anon_sym_LT_LT] = ACTIONS(422),
    [anon_sym_LT_LT_DASH] = ACTIONS(422),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(422),
    [anon_sym_LF] = ACTIONS(422),
    [anon_sym_AMP] = ACTIONS(422),
  },
  [607] = {
    [sym_special_variable_name] = STATE(920),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_EQ] = ACTIONS(412),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(138),
    [anon_sym_AT] = ACTIONS(138),
    [anon_sym_COLON] = ACTIONS(424),
    [anon_sym_COLON_QMARK] = ACTIONS(412),
    [anon_sym_COLON_DASH] = ACTIONS(412),
    [anon_sym_PERCENT] = ACTIONS(412),
    [anon_sym_SLASH] = ACTIONS(412),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1811),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [608] = {
    [anon_sym_RBRACE] = ACTIONS(1813),
    [anon_sym_EQ] = ACTIONS(1815),
    [anon_sym_LBRACK] = ACTIONS(1817),
    [anon_sym_COLON] = ACTIONS(1819),
    [anon_sym_COLON_QMARK] = ACTIONS(1815),
    [anon_sym_COLON_DASH] = ACTIONS(1815),
    [anon_sym_PERCENT] = ACTIONS(1815),
    [anon_sym_SLASH] = ACTIONS(1815),
    [sym_comment] = ACTIONS(46),
  },
  [609] = {
    [anon_sym_RBRACE] = ACTIONS(1821),
    [anon_sym_EQ] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(1825),
    [anon_sym_COLON] = ACTIONS(1827),
    [anon_sym_COLON_QMARK] = ACTIONS(1823),
    [anon_sym_COLON_DASH] = ACTIONS(1823),
    [anon_sym_PERCENT] = ACTIONS(1823),
    [anon_sym_SLASH] = ACTIONS(1823),
    [sym_comment] = ACTIONS(46),
  },
  [610] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1829),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [611] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1829),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [612] = {
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_BQUOTE] = ACTIONS(1829),
    [sym_comment] = ACTIONS(46),
  },
  [613] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(1829),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [614] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1831),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [615] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1831),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [616] = {
    [aux_sym_concatenation_repeat1] = STATE(917),
    [sym_file_descriptor] = ACTIONS(542),
    [sym__concat] = ACTIONS(1134),
    [anon_sym_PIPE] = ACTIONS(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_PIPE_PIPE] = ACTIONS(544),
    [anon_sym_LT] = ACTIONS(544),
    [anon_sym_GT] = ACTIONS(544),
    [anon_sym_GT_GT] = ACTIONS(544),
    [anon_sym_AMP_GT] = ACTIONS(544),
    [anon_sym_AMP_GT_GT] = ACTIONS(544),
    [anon_sym_LT_AMP] = ACTIONS(544),
    [anon_sym_GT_AMP] = ACTIONS(544),
    [anon_sym_LT_LT] = ACTIONS(544),
    [anon_sym_LT_LT_DASH] = ACTIONS(544),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [617] = {
    [sym__heredoc_middle] = ACTIONS(1833),
    [sym__heredoc_end] = ACTIONS(1833),
    [anon_sym_DOLLAR] = ACTIONS(1835),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1833),
    [sym_comment] = ACTIONS(46),
  },
  [618] = {
    [sym_file_descriptor] = ACTIONS(1837),
    [anon_sym_PIPE] = ACTIONS(1839),
    [anon_sym_RPAREN] = ACTIONS(1839),
    [anon_sym_SEMI_SEMI] = ACTIONS(1839),
    [anon_sym_PIPE_AMP] = ACTIONS(1839),
    [anon_sym_AMP_AMP] = ACTIONS(1839),
    [anon_sym_PIPE_PIPE] = ACTIONS(1839),
    [anon_sym_LT] = ACTIONS(1839),
    [anon_sym_GT] = ACTIONS(1839),
    [anon_sym_GT_GT] = ACTIONS(1839),
    [anon_sym_AMP_GT] = ACTIONS(1839),
    [anon_sym_AMP_GT_GT] = ACTIONS(1839),
    [anon_sym_LT_AMP] = ACTIONS(1839),
    [anon_sym_GT_AMP] = ACTIONS(1839),
    [anon_sym_LT_LT] = ACTIONS(1839),
    [anon_sym_LT_LT_DASH] = ACTIONS(1839),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1839),
    [anon_sym_LF] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
  },
  [619] = {
    [sym_special_variable_name] = STATE(931),
    [anon_sym_DOLLAR] = ACTIONS(1841),
    [anon_sym_POUND] = ACTIONS(1841),
    [anon_sym_AT] = ACTIONS(1841),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1843),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_QMARK] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1841),
    [anon_sym_0] = ACTIONS(1845),
    [anon_sym__] = ACTIONS(1845),
  },
  [620] = {
    [sym_special_variable_name] = STATE(934),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(1847),
    [anon_sym_AT] = ACTIONS(138),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1849),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [621] = {
    [sym_simple_expansion] = STATE(617),
    [sym_expansion] = STATE(617),
    [aux_sym_heredoc_repeat1] = STATE(936),
    [sym__heredoc_middle] = ACTIONS(1156),
    [sym__heredoc_end] = ACTIONS(1851),
    [anon_sym_DOLLAR] = ACTIONS(1160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1162),
    [sym_comment] = ACTIONS(46),
  },
  [622] = {
    [aux_sym_concatenation_repeat1] = STATE(225),
    [sym_file_descriptor] = ACTIONS(686),
    [sym_word] = ACTIONS(686),
    [sym__concat] = ACTIONS(374),
    [sym_variable_name] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(1573),
    [anon_sym_GT] = ACTIONS(1573),
    [anon_sym_GT_GT] = ACTIONS(686),
    [anon_sym_AMP_GT] = ACTIONS(1573),
    [anon_sym_AMP_GT_GT] = ACTIONS(686),
    [anon_sym_LT_AMP] = ACTIONS(686),
    [anon_sym_GT_AMP] = ACTIONS(686),
    [anon_sym_DQUOTE] = ACTIONS(686),
    [sym_raw_string] = ACTIONS(686),
    [anon_sym_DOLLAR] = ACTIONS(1573),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(686),
    [anon_sym_BQUOTE] = ACTIONS(686),
    [anon_sym_LT_LPAREN] = ACTIONS(686),
    [anon_sym_GT_LPAREN] = ACTIONS(686),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1573),
  },
  [623] = {
    [sym_file_descriptor] = ACTIONS(686),
    [sym_word] = ACTIONS(686),
    [sym_variable_name] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(1573),
    [anon_sym_GT] = ACTIONS(1573),
    [anon_sym_GT_GT] = ACTIONS(686),
    [anon_sym_AMP_GT] = ACTIONS(1573),
    [anon_sym_AMP_GT_GT] = ACTIONS(686),
    [anon_sym_LT_AMP] = ACTIONS(686),
    [anon_sym_GT_AMP] = ACTIONS(686),
    [anon_sym_DQUOTE] = ACTIONS(686),
    [sym_raw_string] = ACTIONS(686),
    [anon_sym_DOLLAR] = ACTIONS(1573),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(686),
    [anon_sym_BQUOTE] = ACTIONS(686),
    [anon_sym_LT_LPAREN] = ACTIONS(686),
    [anon_sym_GT_LPAREN] = ACTIONS(686),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1573),
  },
  [624] = {
    [sym_concatenation] = STATE(364),
    [sym_string] = STATE(355),
    [sym_simple_expansion] = STATE(355),
    [sym_expansion] = STATE(355),
    [sym_command_substitution] = STATE(355),
    [sym_process_substitution] = STATE(355),
    [aux_sym_for_statement_repeat1] = STATE(938),
    [sym_word] = ACTIONS(692),
    [anon_sym_RPAREN] = ACTIONS(1853),
    [anon_sym_DQUOTE] = ACTIONS(696),
    [sym_raw_string] = ACTIONS(692),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(700),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(702),
    [anon_sym_BQUOTE] = ACTIONS(704),
    [anon_sym_LT_LPAREN] = ACTIONS(706),
    [anon_sym_GT_LPAREN] = ACTIONS(706),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(708),
  },
  [625] = {
    [aux_sym_concatenation_repeat1] = STATE(240),
    [sym_file_descriptor] = ACTIONS(722),
    [sym_word] = ACTIONS(722),
    [sym__concat] = ACTIONS(374),
    [sym_variable_name] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(1589),
    [anon_sym_GT] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(722),
    [anon_sym_AMP_GT] = ACTIONS(1589),
    [anon_sym_AMP_GT_GT] = ACTIONS(722),
    [anon_sym_LT_AMP] = ACTIONS(722),
    [anon_sym_GT_AMP] = ACTIONS(722),
    [anon_sym_DQUOTE] = ACTIONS(722),
    [sym_raw_string] = ACTIONS(722),
    [anon_sym_DOLLAR] = ACTIONS(1589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(722),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [anon_sym_LT_LPAREN] = ACTIONS(722),
    [anon_sym_GT_LPAREN] = ACTIONS(722),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1589),
  },
  [626] = {
    [sym_file_redirect] = STATE(134),
    [sym_heredoc_redirect] = STATE(134),
    [aux_sym_command_repeat2] = STATE(349),
    [sym_file_descriptor] = ACTIONS(208),
    [anon_sym_PIPE] = ACTIONS(1855),
    [anon_sym_SEMI_SEMI] = ACTIONS(1855),
    [anon_sym_PIPE_AMP] = ACTIONS(1855),
    [anon_sym_AMP_AMP] = ACTIONS(1855),
    [anon_sym_PIPE_PIPE] = ACTIONS(1855),
    [anon_sym_LT] = ACTIONS(214),
    [anon_sym_GT] = ACTIONS(214),
    [anon_sym_GT_GT] = ACTIONS(214),
    [anon_sym_AMP_GT] = ACTIONS(214),
    [anon_sym_AMP_GT_GT] = ACTIONS(214),
    [anon_sym_LT_AMP] = ACTIONS(214),
    [anon_sym_GT_AMP] = ACTIONS(214),
    [anon_sym_LT_LT] = ACTIONS(216),
    [anon_sym_LT_LT_DASH] = ACTIONS(216),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1855),
    [anon_sym_LF] = ACTIONS(1855),
    [anon_sym_AMP] = ACTIONS(1855),
  },
  [627] = {
    [sym_file_descriptor] = ACTIONS(675),
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(675),
    [sym_variable_name] = ACTIONS(675),
    [anon_sym_PIPE] = ACTIONS(677),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_SEMI_SEMI] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(677),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(677),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(677),
    [sym_raw_string] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [anon_sym_LT_LPAREN] = ACTIONS(677),
    [anon_sym_GT_LPAREN] = ACTIONS(677),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(677),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(677),
  },
  [628] = {
    [sym_file_descriptor] = ACTIONS(679),
    [sym_word] = ACTIONS(679),
    [sym__concat] = ACTIONS(679),
    [sym_variable_name] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_RPAREN] = ACTIONS(681),
    [anon_sym_SEMI_SEMI] = ACTIONS(681),
    [anon_sym_PIPE_AMP] = ACTIONS(681),
    [anon_sym_AMP_AMP] = ACTIONS(681),
    [anon_sym_PIPE_PIPE] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(681),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_DQUOTE] = ACTIONS(681),
    [sym_raw_string] = ACTIONS(681),
    [anon_sym_DOLLAR] = ACTIONS(681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(681),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(681),
    [anon_sym_BQUOTE] = ACTIONS(681),
    [anon_sym_LT_LPAREN] = ACTIONS(681),
    [anon_sym_GT_LPAREN] = ACTIONS(681),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(681),
    [anon_sym_AMP] = ACTIONS(681),
  },
  [629] = {
    [aux_sym_concatenation_repeat1] = STATE(629),
    [sym_file_descriptor] = ACTIONS(675),
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(1857),
    [sym_variable_name] = ACTIONS(675),
    [anon_sym_PIPE] = ACTIONS(677),
    [anon_sym_SEMI_SEMI] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(677),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(677),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(677),
    [sym_raw_string] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [anon_sym_LT_LPAREN] = ACTIONS(677),
    [anon_sym_GT_LPAREN] = ACTIONS(677),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(677),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(677),
  },
  [630] = {
    [sym_string] = STATE(939),
    [sym_simple_expansion] = STATE(939),
    [sym_expansion] = STATE(939),
    [sym_command_substitution] = STATE(939),
    [sym_process_substitution] = STATE(939),
    [sym_word] = ACTIONS(1860),
    [anon_sym_DQUOTE] = ACTIONS(696),
    [sym_raw_string] = ACTIONS(1860),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(700),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(702),
    [anon_sym_BQUOTE] = ACTIONS(704),
    [anon_sym_LT_LPAREN] = ACTIONS(706),
    [anon_sym_GT_LPAREN] = ACTIONS(706),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1862),
  },
  [631] = {
    [aux_sym_concatenation_repeat1] = STATE(941),
    [sym_word] = ACTIONS(254),
    [sym__concat] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(877),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(877),
  },
  [632] = {
    [sym_word] = ACTIONS(394),
    [sym__concat] = ACTIONS(394),
    [anon_sym_RPAREN] = ACTIONS(394),
    [anon_sym_DQUOTE] = ACTIONS(394),
    [sym_raw_string] = ACTIONS(394),
    [anon_sym_DOLLAR] = ACTIONS(879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(394),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(394),
    [anon_sym_BQUOTE] = ACTIONS(394),
    [anon_sym_LT_LPAREN] = ACTIONS(394),
    [anon_sym_GT_LPAREN] = ACTIONS(394),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(879),
  },
  [633] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(252),
    [anon_sym_DQUOTE] = ACTIONS(1864),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [634] = {
    [sym_word] = ACTIONS(412),
    [sym__concat] = ACTIONS(412),
    [anon_sym_RPAREN] = ACTIONS(412),
    [anon_sym_DQUOTE] = ACTIONS(412),
    [sym_raw_string] = ACTIONS(412),
    [anon_sym_DOLLAR] = ACTIONS(424),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(412),
    [anon_sym_BQUOTE] = ACTIONS(412),
    [anon_sym_LT_LPAREN] = ACTIONS(412),
    [anon_sym_GT_LPAREN] = ACTIONS(412),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(424),
  },
  [635] = {
    [sym_word] = ACTIONS(416),
    [sym__concat] = ACTIONS(416),
    [anon_sym_RPAREN] = ACTIONS(416),
    [anon_sym_DQUOTE] = ACTIONS(416),
    [sym_raw_string] = ACTIONS(416),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(416),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(416),
    [anon_sym_BQUOTE] = ACTIONS(416),
    [anon_sym_LT_LPAREN] = ACTIONS(416),
    [anon_sym_GT_LPAREN] = ACTIONS(416),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(883),
  },
  [636] = {
    [sym_word] = ACTIONS(420),
    [sym__concat] = ACTIONS(420),
    [anon_sym_RPAREN] = ACTIONS(420),
    [anon_sym_DQUOTE] = ACTIONS(420),
    [sym_raw_string] = ACTIONS(420),
    [anon_sym_DOLLAR] = ACTIONS(885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(420),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(420),
    [anon_sym_BQUOTE] = ACTIONS(420),
    [anon_sym_LT_LPAREN] = ACTIONS(420),
    [anon_sym_GT_LPAREN] = ACTIONS(420),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(885),
  },
  [637] = {
    [sym_special_variable_name] = STATE(944),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_EQ] = ACTIONS(412),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(138),
    [anon_sym_AT] = ACTIONS(138),
    [anon_sym_COLON] = ACTIONS(424),
    [anon_sym_COLON_QMARK] = ACTIONS(412),
    [anon_sym_COLON_DASH] = ACTIONS(412),
    [anon_sym_PERCENT] = ACTIONS(412),
    [anon_sym_SLASH] = ACTIONS(412),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [638] = {
    [anon_sym_RBRACE] = ACTIONS(1868),
    [anon_sym_EQ] = ACTIONS(1870),
    [anon_sym_LBRACK] = ACTIONS(1872),
    [anon_sym_COLON] = ACTIONS(1874),
    [anon_sym_COLON_QMARK] = ACTIONS(1870),
    [anon_sym_COLON_DASH] = ACTIONS(1870),
    [anon_sym_PERCENT] = ACTIONS(1870),
    [anon_sym_SLASH] = ACTIONS(1870),
    [sym_comment] = ACTIONS(46),
  },
  [639] = {
    [anon_sym_RBRACE] = ACTIONS(1876),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_LBRACK] = ACTIONS(1880),
    [anon_sym_COLON] = ACTIONS(1882),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_SLASH] = ACTIONS(1878),
    [sym_comment] = ACTIONS(46),
  },
  [640] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1884),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [641] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1884),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [642] = {
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_BQUOTE] = ACTIONS(1884),
    [sym_comment] = ACTIONS(46),
  },
  [643] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(1884),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [644] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1886),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [645] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1886),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [646] = {
    [aux_sym_concatenation_repeat1] = STATE(941),
    [sym_word] = ACTIONS(542),
    [sym__concat] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(542),
    [anon_sym_DQUOTE] = ACTIONS(542),
    [sym_raw_string] = ACTIONS(542),
    [anon_sym_DOLLAR] = ACTIONS(909),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(542),
    [anon_sym_BQUOTE] = ACTIONS(542),
    [anon_sym_LT_LPAREN] = ACTIONS(542),
    [anon_sym_GT_LPAREN] = ACTIONS(542),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(909),
  },
  [647] = {
    [sym_file_descriptor] = ACTIONS(1888),
    [sym_word] = ACTIONS(1888),
    [sym_variable_name] = ACTIONS(1888),
    [anon_sym_PIPE] = ACTIONS(1890),
    [anon_sym_RPAREN] = ACTIONS(1890),
    [anon_sym_SEMI_SEMI] = ACTIONS(1890),
    [anon_sym_PIPE_AMP] = ACTIONS(1890),
    [anon_sym_AMP_AMP] = ACTIONS(1890),
    [anon_sym_PIPE_PIPE] = ACTIONS(1890),
    [anon_sym_LT] = ACTIONS(1890),
    [anon_sym_GT] = ACTIONS(1890),
    [anon_sym_GT_GT] = ACTIONS(1890),
    [anon_sym_AMP_GT] = ACTIONS(1890),
    [anon_sym_AMP_GT_GT] = ACTIONS(1890),
    [anon_sym_LT_AMP] = ACTIONS(1890),
    [anon_sym_GT_AMP] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1890),
    [sym_raw_string] = ACTIONS(1890),
    [anon_sym_DOLLAR] = ACTIONS(1890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1890),
    [anon_sym_BQUOTE] = ACTIONS(1890),
    [anon_sym_LT_LPAREN] = ACTIONS(1890),
    [anon_sym_GT_LPAREN] = ACTIONS(1890),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1890),
    [anon_sym_SEMI] = ACTIONS(1890),
    [anon_sym_LF] = ACTIONS(1890),
    [anon_sym_AMP] = ACTIONS(1890),
  },
  [648] = {
    [sym_concatenation] = STATE(364),
    [sym_string] = STATE(355),
    [sym_simple_expansion] = STATE(355),
    [sym_expansion] = STATE(355),
    [sym_command_substitution] = STATE(355),
    [sym_process_substitution] = STATE(355),
    [aux_sym_for_statement_repeat1] = STATE(648),
    [sym_word] = ACTIONS(1892),
    [anon_sym_RPAREN] = ACTIONS(1168),
    [anon_sym_DQUOTE] = ACTIONS(1895),
    [sym_raw_string] = ACTIONS(1892),
    [anon_sym_DOLLAR] = ACTIONS(1898),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1904),
    [anon_sym_BQUOTE] = ACTIONS(1907),
    [anon_sym_LT_LPAREN] = ACTIONS(1910),
    [anon_sym_GT_LPAREN] = ACTIONS(1910),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1913),
  },
  [649] = {
    [sym_file_descriptor] = ACTIONS(931),
    [sym_word] = ACTIONS(931),
    [sym__concat] = ACTIONS(931),
    [sym_variable_name] = ACTIONS(931),
    [anon_sym_PIPE] = ACTIONS(933),
    [anon_sym_RPAREN] = ACTIONS(933),
    [anon_sym_SEMI_SEMI] = ACTIONS(933),
    [anon_sym_PIPE_AMP] = ACTIONS(933),
    [anon_sym_AMP_AMP] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(933),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(933),
    [anon_sym_AMP_GT] = ACTIONS(933),
    [anon_sym_AMP_GT_GT] = ACTIONS(933),
    [anon_sym_LT_AMP] = ACTIONS(933),
    [anon_sym_GT_AMP] = ACTIONS(933),
    [anon_sym_DQUOTE] = ACTIONS(933),
    [sym_raw_string] = ACTIONS(933),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(933),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(933),
    [anon_sym_BQUOTE] = ACTIONS(933),
    [anon_sym_LT_LPAREN] = ACTIONS(933),
    [anon_sym_GT_LPAREN] = ACTIONS(933),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(933),
    [anon_sym_SEMI] = ACTIONS(933),
    [anon_sym_LF] = ACTIONS(933),
    [anon_sym_AMP] = ACTIONS(933),
  },
  [650] = {
    [anon_sym_RBRACE] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [sym_comment] = ACTIONS(46),
  },
  [651] = {
    [anon_sym_RBRACE] = ACTIONS(1920),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [sym_comment] = ACTIONS(46),
  },
  [652] = {
    [sym_file_descriptor] = ACTIONS(960),
    [sym_word] = ACTIONS(960),
    [sym__concat] = ACTIONS(960),
    [sym_variable_name] = ACTIONS(960),
    [anon_sym_PIPE] = ACTIONS(962),
    [anon_sym_RPAREN] = ACTIONS(962),
    [anon_sym_SEMI_SEMI] = ACTIONS(962),
    [anon_sym_PIPE_AMP] = ACTIONS(962),
    [anon_sym_AMP_AMP] = ACTIONS(962),
    [anon_sym_PIPE_PIPE] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(962),
    [anon_sym_GT] = ACTIONS(962),
    [anon_sym_GT_GT] = ACTIONS(962),
    [anon_sym_AMP_GT] = ACTIONS(962),
    [anon_sym_AMP_GT_GT] = ACTIONS(962),
    [anon_sym_LT_AMP] = ACTIONS(962),
    [anon_sym_GT_AMP] = ACTIONS(962),
    [anon_sym_DQUOTE] = ACTIONS(962),
    [sym_raw_string] = ACTIONS(962),
    [anon_sym_DOLLAR] = ACTIONS(962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(962),
    [anon_sym_BQUOTE] = ACTIONS(962),
    [anon_sym_LT_LPAREN] = ACTIONS(962),
    [anon_sym_GT_LPAREN] = ACTIONS(962),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(962),
    [anon_sym_SEMI] = ACTIONS(962),
    [anon_sym_LF] = ACTIONS(962),
    [anon_sym_AMP] = ACTIONS(962),
  },
  [653] = {
    [sym_concatenation] = STATE(960),
    [sym_string] = STATE(957),
    [sym_simple_expansion] = STATE(957),
    [sym_expansion] = STATE(957),
    [sym_command_substitution] = STATE(957),
    [sym_process_substitution] = STATE(957),
    [sym_word] = ACTIONS(1924),
    [anon_sym_RBRACE] = ACTIONS(1926),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1924),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1928),
  },
  [654] = {
    [anon_sym_AT] = ACTIONS(1930),
    [sym_comment] = ACTIONS(46),
  },
  [655] = {
    [sym_file_descriptor] = ACTIONS(972),
    [sym_word] = ACTIONS(972),
    [sym__concat] = ACTIONS(972),
    [sym_variable_name] = ACTIONS(972),
    [anon_sym_PIPE] = ACTIONS(974),
    [anon_sym_RPAREN] = ACTIONS(974),
    [anon_sym_SEMI_SEMI] = ACTIONS(974),
    [anon_sym_PIPE_AMP] = ACTIONS(974),
    [anon_sym_AMP_AMP] = ACTIONS(974),
    [anon_sym_PIPE_PIPE] = ACTIONS(974),
    [anon_sym_LT] = ACTIONS(974),
    [anon_sym_GT] = ACTIONS(974),
    [anon_sym_GT_GT] = ACTIONS(974),
    [anon_sym_AMP_GT] = ACTIONS(974),
    [anon_sym_AMP_GT_GT] = ACTIONS(974),
    [anon_sym_LT_AMP] = ACTIONS(974),
    [anon_sym_GT_AMP] = ACTIONS(974),
    [anon_sym_DQUOTE] = ACTIONS(974),
    [sym_raw_string] = ACTIONS(974),
    [anon_sym_DOLLAR] = ACTIONS(974),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(974),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(974),
    [anon_sym_BQUOTE] = ACTIONS(974),
    [anon_sym_LT_LPAREN] = ACTIONS(974),
    [anon_sym_GT_LPAREN] = ACTIONS(974),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(974),
    [anon_sym_SEMI] = ACTIONS(974),
    [anon_sym_LF] = ACTIONS(974),
    [anon_sym_AMP] = ACTIONS(974),
  },
  [656] = {
    [sym_concatenation] = STATE(964),
    [sym_string] = STATE(962),
    [sym_simple_expansion] = STATE(962),
    [sym_expansion] = STATE(962),
    [sym_command_substitution] = STATE(962),
    [sym_process_substitution] = STATE(962),
    [sym_word] = ACTIONS(1932),
    [anon_sym_RBRACE] = ACTIONS(1920),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1932),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1934),
  },
  [657] = {
    [anon_sym_AT] = ACTIONS(1936),
    [sym_comment] = ACTIONS(46),
  },
  [658] = {
    [sym_file_descriptor] = ACTIONS(1066),
    [sym_word] = ACTIONS(1066),
    [sym__concat] = ACTIONS(1066),
    [sym_variable_name] = ACTIONS(1066),
    [anon_sym_PIPE] = ACTIONS(1068),
    [anon_sym_RPAREN] = ACTIONS(1068),
    [anon_sym_SEMI_SEMI] = ACTIONS(1068),
    [anon_sym_PIPE_AMP] = ACTIONS(1068),
    [anon_sym_AMP_AMP] = ACTIONS(1068),
    [anon_sym_PIPE_PIPE] = ACTIONS(1068),
    [anon_sym_LT] = ACTIONS(1068),
    [anon_sym_GT] = ACTIONS(1068),
    [anon_sym_GT_GT] = ACTIONS(1068),
    [anon_sym_AMP_GT] = ACTIONS(1068),
    [anon_sym_AMP_GT_GT] = ACTIONS(1068),
    [anon_sym_LT_AMP] = ACTIONS(1068),
    [anon_sym_GT_AMP] = ACTIONS(1068),
    [anon_sym_DQUOTE] = ACTIONS(1068),
    [sym_raw_string] = ACTIONS(1068),
    [anon_sym_DOLLAR] = ACTIONS(1068),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1068),
    [anon_sym_BQUOTE] = ACTIONS(1068),
    [anon_sym_LT_LPAREN] = ACTIONS(1068),
    [anon_sym_GT_LPAREN] = ACTIONS(1068),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1068),
    [anon_sym_SEMI] = ACTIONS(1068),
    [anon_sym_LF] = ACTIONS(1068),
    [anon_sym_AMP] = ACTIONS(1068),
  },
  [659] = {
    [sym_file_descriptor] = ACTIONS(1122),
    [sym_word] = ACTIONS(1122),
    [sym__concat] = ACTIONS(1122),
    [sym_variable_name] = ACTIONS(1122),
    [anon_sym_PIPE] = ACTIONS(1124),
    [anon_sym_RPAREN] = ACTIONS(1124),
    [anon_sym_SEMI_SEMI] = ACTIONS(1124),
    [anon_sym_PIPE_AMP] = ACTIONS(1124),
    [anon_sym_AMP_AMP] = ACTIONS(1124),
    [anon_sym_PIPE_PIPE] = ACTIONS(1124),
    [anon_sym_LT] = ACTIONS(1124),
    [anon_sym_GT] = ACTIONS(1124),
    [anon_sym_GT_GT] = ACTIONS(1124),
    [anon_sym_AMP_GT] = ACTIONS(1124),
    [anon_sym_AMP_GT_GT] = ACTIONS(1124),
    [anon_sym_LT_AMP] = ACTIONS(1124),
    [anon_sym_GT_AMP] = ACTIONS(1124),
    [anon_sym_DQUOTE] = ACTIONS(1124),
    [sym_raw_string] = ACTIONS(1124),
    [anon_sym_DOLLAR] = ACTIONS(1124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1124),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1124),
    [anon_sym_BQUOTE] = ACTIONS(1124),
    [anon_sym_LT_LPAREN] = ACTIONS(1124),
    [anon_sym_GT_LPAREN] = ACTIONS(1124),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1124),
    [anon_sym_SEMI] = ACTIONS(1124),
    [anon_sym_LF] = ACTIONS(1124),
    [anon_sym_AMP] = ACTIONS(1124),
  },
  [660] = {
    [sym__concat] = ACTIONS(675),
    [anon_sym_PIPE] = ACTIONS(675),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_RBRACE] = ACTIONS(675),
    [anon_sym_RBRACK] = ACTIONS(675),
    [sym_comment] = ACTIONS(46),
  },
  [661] = {
    [sym__concat] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(679),
    [anon_sym_RBRACK] = ACTIONS(679),
    [sym_comment] = ACTIONS(46),
  },
  [662] = {
    [aux_sym_concatenation_repeat1] = STATE(662),
    [sym__concat] = ACTIONS(1938),
    [anon_sym_RBRACK] = ACTIONS(675),
    [sym_comment] = ACTIONS(46),
  },
  [663] = {
    [sym__concat] = ACTIONS(931),
    [anon_sym_PIPE] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(931),
    [anon_sym_RBRACE] = ACTIONS(931),
    [anon_sym_RBRACK] = ACTIONS(931),
    [sym_comment] = ACTIONS(46),
  },
  [664] = {
    [anon_sym_RBRACE] = ACTIONS(1941),
    [anon_sym_LBRACK] = ACTIONS(1943),
    [sym_comment] = ACTIONS(46),
  },
  [665] = {
    [anon_sym_RBRACE] = ACTIONS(1945),
    [anon_sym_LBRACK] = ACTIONS(1947),
    [sym_comment] = ACTIONS(46),
  },
  [666] = {
    [sym__concat] = ACTIONS(960),
    [anon_sym_PIPE] = ACTIONS(960),
    [anon_sym_RPAREN] = ACTIONS(960),
    [anon_sym_RBRACE] = ACTIONS(960),
    [anon_sym_RBRACK] = ACTIONS(960),
    [sym_comment] = ACTIONS(46),
  },
  [667] = {
    [sym_concatenation] = STATE(973),
    [sym_string] = STATE(970),
    [sym_simple_expansion] = STATE(970),
    [sym_expansion] = STATE(970),
    [sym_command_substitution] = STATE(970),
    [sym_process_substitution] = STATE(970),
    [sym_word] = ACTIONS(1949),
    [anon_sym_RBRACE] = ACTIONS(1951),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1949),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1953),
  },
  [668] = {
    [anon_sym_AT] = ACTIONS(1955),
    [sym_comment] = ACTIONS(46),
  },
  [669] = {
    [sym__concat] = ACTIONS(972),
    [anon_sym_PIPE] = ACTIONS(972),
    [anon_sym_RPAREN] = ACTIONS(972),
    [anon_sym_RBRACE] = ACTIONS(972),
    [anon_sym_RBRACK] = ACTIONS(972),
    [sym_comment] = ACTIONS(46),
  },
  [670] = {
    [sym_concatenation] = STATE(977),
    [sym_string] = STATE(975),
    [sym_simple_expansion] = STATE(975),
    [sym_expansion] = STATE(975),
    [sym_command_substitution] = STATE(975),
    [sym_process_substitution] = STATE(975),
    [sym_word] = ACTIONS(1957),
    [anon_sym_RBRACE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1957),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1959),
  },
  [671] = {
    [anon_sym_AT] = ACTIONS(1961),
    [sym_comment] = ACTIONS(46),
  },
  [672] = {
    [sym__concat] = ACTIONS(1066),
    [anon_sym_PIPE] = ACTIONS(1066),
    [anon_sym_RPAREN] = ACTIONS(1066),
    [anon_sym_RBRACE] = ACTIONS(1066),
    [anon_sym_RBRACK] = ACTIONS(1066),
    [sym_comment] = ACTIONS(46),
  },
  [673] = {
    [sym__concat] = ACTIONS(1122),
    [anon_sym_PIPE] = ACTIONS(1122),
    [anon_sym_RPAREN] = ACTIONS(1122),
    [anon_sym_RBRACE] = ACTIONS(1122),
    [anon_sym_RBRACK] = ACTIONS(1122),
    [sym_comment] = ACTIONS(46),
  },
  [674] = {
    [sym_string] = STATE(979),
    [sym_simple_expansion] = STATE(979),
    [sym_expansion] = STATE(979),
    [sym_command_substitution] = STATE(979),
    [sym_process_substitution] = STATE(979),
    [sym_word] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [sym_raw_string] = ACTIONS(1963),
    [anon_sym_DOLLAR] = ACTIONS(748),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(750),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(752),
    [anon_sym_BQUOTE] = ACTIONS(754),
    [anon_sym_LT_LPAREN] = ACTIONS(756),
    [anon_sym_GT_LPAREN] = ACTIONS(756),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1965),
  },
  [675] = {
    [aux_sym_concatenation_repeat1] = STATE(981),
    [sym_word] = ACTIONS(254),
    [sym__concat] = ACTIONS(1300),
    [anon_sym_SEMI_SEMI] = ACTIONS(256),
    [anon_sym_DQUOTE] = ACTIONS(256),
    [sym_raw_string] = ACTIONS(256),
    [anon_sym_DOLLAR] = ACTIONS(256),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(256),
    [anon_sym_BQUOTE] = ACTIONS(256),
    [anon_sym_LT_LPAREN] = ACTIONS(256),
    [anon_sym_GT_LPAREN] = ACTIONS(256),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(256),
    [anon_sym_SEMI] = ACTIONS(256),
    [anon_sym_LF] = ACTIONS(256),
    [anon_sym_AMP] = ACTIONS(256),
  },
  [676] = {
    [sym_word] = ACTIONS(394),
    [sym__concat] = ACTIONS(394),
    [anon_sym_SEMI_SEMI] = ACTIONS(396),
    [anon_sym_DQUOTE] = ACTIONS(396),
    [sym_raw_string] = ACTIONS(396),
    [anon_sym_DOLLAR] = ACTIONS(396),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(396),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(396),
    [anon_sym_BQUOTE] = ACTIONS(396),
    [anon_sym_LT_LPAREN] = ACTIONS(396),
    [anon_sym_GT_LPAREN] = ACTIONS(396),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(396),
    [anon_sym_SEMI] = ACTIONS(396),
    [anon_sym_LF] = ACTIONS(396),
    [anon_sym_AMP] = ACTIONS(396),
  },
  [677] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(252),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [678] = {
    [sym_word] = ACTIONS(412),
    [sym__concat] = ACTIONS(412),
    [anon_sym_SEMI_SEMI] = ACTIONS(414),
    [anon_sym_DQUOTE] = ACTIONS(414),
    [sym_raw_string] = ACTIONS(414),
    [anon_sym_DOLLAR] = ACTIONS(414),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(414),
    [anon_sym_BQUOTE] = ACTIONS(414),
    [anon_sym_LT_LPAREN] = ACTIONS(414),
    [anon_sym_GT_LPAREN] = ACTIONS(414),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(414),
    [anon_sym_SEMI] = ACTIONS(414),
    [anon_sym_LF] = ACTIONS(414),
    [anon_sym_AMP] = ACTIONS(414),
  },
  [679] = {
    [sym_word] = ACTIONS(416),
    [sym__concat] = ACTIONS(416),
    [anon_sym_SEMI_SEMI] = ACTIONS(418),
    [anon_sym_DQUOTE] = ACTIONS(418),
    [sym_raw_string] = ACTIONS(418),
    [anon_sym_DOLLAR] = ACTIONS(418),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(418),
    [anon_sym_BQUOTE] = ACTIONS(418),
    [anon_sym_LT_LPAREN] = ACTIONS(418),
    [anon_sym_GT_LPAREN] = ACTIONS(418),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(418),
    [anon_sym_SEMI] = ACTIONS(418),
    [anon_sym_LF] = ACTIONS(418),
    [anon_sym_AMP] = ACTIONS(418),
  },
  [680] = {
    [sym_word] = ACTIONS(420),
    [sym__concat] = ACTIONS(420),
    [anon_sym_SEMI_SEMI] = ACTIONS(422),
    [anon_sym_DQUOTE] = ACTIONS(422),
    [sym_raw_string] = ACTIONS(422),
    [anon_sym_DOLLAR] = ACTIONS(422),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(422),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(422),
    [anon_sym_BQUOTE] = ACTIONS(422),
    [anon_sym_LT_LPAREN] = ACTIONS(422),
    [anon_sym_GT_LPAREN] = ACTIONS(422),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(422),
    [anon_sym_SEMI] = ACTIONS(422),
    [anon_sym_LF] = ACTIONS(422),
    [anon_sym_AMP] = ACTIONS(422),
  },
  [681] = {
    [sym_special_variable_name] = STATE(984),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_EQ] = ACTIONS(412),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(138),
    [anon_sym_AT] = ACTIONS(138),
    [anon_sym_COLON] = ACTIONS(424),
    [anon_sym_COLON_QMARK] = ACTIONS(412),
    [anon_sym_COLON_DASH] = ACTIONS(412),
    [anon_sym_PERCENT] = ACTIONS(412),
    [anon_sym_SLASH] = ACTIONS(412),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [682] = {
    [anon_sym_RBRACE] = ACTIONS(1971),
    [anon_sym_EQ] = ACTIONS(1973),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_COLON] = ACTIONS(1977),
    [anon_sym_COLON_QMARK] = ACTIONS(1973),
    [anon_sym_COLON_DASH] = ACTIONS(1973),
    [anon_sym_PERCENT] = ACTIONS(1973),
    [anon_sym_SLASH] = ACTIONS(1973),
    [sym_comment] = ACTIONS(46),
  },
  [683] = {
    [anon_sym_RBRACE] = ACTIONS(1979),
    [anon_sym_EQ] = ACTIONS(1981),
    [anon_sym_LBRACK] = ACTIONS(1983),
    [anon_sym_COLON] = ACTIONS(1985),
    [anon_sym_COLON_QMARK] = ACTIONS(1981),
    [anon_sym_COLON_DASH] = ACTIONS(1981),
    [anon_sym_PERCENT] = ACTIONS(1981),
    [anon_sym_SLASH] = ACTIONS(1981),
    [sym_comment] = ACTIONS(46),
  },
  [684] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1987),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [685] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1987),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [686] = {
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_BQUOTE] = ACTIONS(1987),
    [sym_comment] = ACTIONS(46),
  },
  [687] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(1987),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [688] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1989),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [689] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(1989),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [690] = {
    [aux_sym_concatenation_repeat1] = STATE(981),
    [sym_word] = ACTIONS(542),
    [sym__concat] = ACTIONS(1300),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(544),
    [sym_raw_string] = ACTIONS(544),
    [anon_sym_DOLLAR] = ACTIONS(544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(544),
    [anon_sym_BQUOTE] = ACTIONS(544),
    [anon_sym_LT_LPAREN] = ACTIONS(544),
    [anon_sym_GT_LPAREN] = ACTIONS(544),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(544),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [691] = {
    [sym_do_group] = STATE(993),
    [anon_sym_do] = ACTIONS(300),
    [sym_comment] = ACTIONS(46),
  },
  [692] = {
    [sym_concatenation] = STATE(408),
    [sym_string] = STATE(400),
    [sym_simple_expansion] = STATE(400),
    [sym_expansion] = STATE(400),
    [sym_command_substitution] = STATE(400),
    [sym_process_substitution] = STATE(400),
    [aux_sym_for_statement_repeat1] = STATE(692),
    [sym_word] = ACTIONS(1991),
    [anon_sym_SEMI_SEMI] = ACTIONS(1173),
    [anon_sym_DQUOTE] = ACTIONS(1994),
    [sym_raw_string] = ACTIONS(1997),
    [anon_sym_DOLLAR] = ACTIONS(2000),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2003),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2006),
    [anon_sym_BQUOTE] = ACTIONS(2009),
    [anon_sym_LT_LPAREN] = ACTIONS(2012),
    [anon_sym_GT_LPAREN] = ACTIONS(2012),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2015),
    [anon_sym_SEMI] = ACTIONS(1173),
    [anon_sym_LF] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1173),
  },
  [693] = {
    [sym_file_descriptor] = ACTIONS(546),
    [sym_word] = ACTIONS(546),
    [sym_variable_name] = ACTIONS(546),
    [anon_sym_for] = ACTIONS(548),
    [anon_sym_while] = ACTIONS(548),
    [anon_sym_done] = ACTIONS(548),
    [anon_sym_if] = ACTIONS(548),
    [anon_sym_case] = ACTIONS(548),
    [anon_sym_function] = ACTIONS(548),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeset] = ACTIONS(548),
    [anon_sym_export] = ACTIONS(548),
    [anon_sym_readonly] = ACTIONS(548),
    [anon_sym_local] = ACTIONS(548),
    [anon_sym_LT] = ACTIONS(548),
    [anon_sym_GT] = ACTIONS(548),
    [anon_sym_GT_GT] = ACTIONS(546),
    [anon_sym_AMP_GT] = ACTIONS(548),
    [anon_sym_AMP_GT_GT] = ACTIONS(546),
    [anon_sym_LT_AMP] = ACTIONS(546),
    [anon_sym_GT_AMP] = ACTIONS(546),
    [anon_sym_DQUOTE] = ACTIONS(546),
    [sym_raw_string] = ACTIONS(546),
    [anon_sym_DOLLAR] = ACTIONS(548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(546),
    [anon_sym_LT_LPAREN] = ACTIONS(546),
    [anon_sym_GT_LPAREN] = ACTIONS(546),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(550),
  },
  [694] = {
    [anon_sym_PIPE] = ACTIONS(2018),
    [anon_sym_RPAREN] = ACTIONS(2018),
    [anon_sym_SEMI_SEMI] = ACTIONS(2018),
    [anon_sym_PIPE_AMP] = ACTIONS(2018),
    [anon_sym_AMP_AMP] = ACTIONS(2018),
    [anon_sym_PIPE_PIPE] = ACTIONS(2018),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2018),
    [anon_sym_LF] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2018),
  },
  [695] = {
    [sym__terminated_statement] = STATE(411),
    [sym_for_statement] = STATE(412),
    [sym_while_statement] = STATE(412),
    [sym_if_statement] = STATE(412),
    [sym_case_statement] = STATE(412),
    [sym_function_definition] = STATE(412),
    [sym_subshell] = STATE(412),
    [sym_pipeline] = STATE(412),
    [sym_list] = STATE(412),
    [sym_command] = STATE(412),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(413),
    [sym_declaration_command] = STATE(412),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(695),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(590),
    [sym_word] = ACTIONS(593),
    [sym_variable_name] = ACTIONS(596),
    [anon_sym_for] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(604),
    [anon_sym_done] = ACTIONS(2020),
    [anon_sym_if] = ACTIONS(607),
    [anon_sym_case] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(619),
    [anon_sym_typeset] = ACTIONS(619),
    [anon_sym_export] = ACTIONS(619),
    [anon_sym_readonly] = ACTIONS(619),
    [anon_sym_local] = ACTIONS(619),
    [anon_sym_LT] = ACTIONS(622),
    [anon_sym_GT] = ACTIONS(622),
    [anon_sym_GT_GT] = ACTIONS(625),
    [anon_sym_AMP_GT] = ACTIONS(622),
    [anon_sym_AMP_GT_GT] = ACTIONS(625),
    [anon_sym_LT_AMP] = ACTIONS(625),
    [anon_sym_GT_AMP] = ACTIONS(625),
    [anon_sym_DQUOTE] = ACTIONS(628),
    [sym_raw_string] = ACTIONS(593),
    [anon_sym_DOLLAR] = ACTIONS(631),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(634),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(637),
    [anon_sym_BQUOTE] = ACTIONS(640),
    [anon_sym_LT_LPAREN] = ACTIONS(643),
    [anon_sym_GT_LPAREN] = ACTIONS(643),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(646),
  },
  [696] = {
    [anon_sym_then] = ACTIONS(2022),
    [sym_comment] = ACTIONS(46),
  },
  [697] = {
    [sym_file_descriptor] = ACTIONS(196),
    [sym_word] = ACTIONS(196),
    [sym_variable_name] = ACTIONS(196),
    [anon_sym_for] = ACTIONS(198),
    [anon_sym_while] = ACTIONS(198),
    [anon_sym_if] = ACTIONS(198),
    [anon_sym_fi] = ACTIONS(198),
    [anon_sym_case] = ACTIONS(198),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(196),
    [anon_sym_declare] = ACTIONS(198),
    [anon_sym_typeset] = ACTIONS(198),
    [anon_sym_export] = ACTIONS(198),
    [anon_sym_readonly] = ACTIONS(198),
    [anon_sym_local] = ACTIONS(198),
    [anon_sym_LT] = ACTIONS(198),
    [anon_sym_GT] = ACTIONS(198),
    [anon_sym_GT_GT] = ACTIONS(196),
    [anon_sym_AMP_GT] = ACTIONS(198),
    [anon_sym_AMP_GT_GT] = ACTIONS(196),
    [anon_sym_LT_AMP] = ACTIONS(196),
    [anon_sym_GT_AMP] = ACTIONS(196),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [sym_raw_string] = ACTIONS(196),
    [anon_sym_DOLLAR] = ACTIONS(198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(196),
    [anon_sym_BQUOTE] = ACTIONS(196),
    [anon_sym_LT_LPAREN] = ACTIONS(196),
    [anon_sym_GT_LPAREN] = ACTIONS(196),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(200),
  },
  [698] = {
    [anon_sym_PIPE] = ACTIONS(202),
    [anon_sym_SEMI_SEMI] = ACTIONS(2024),
    [anon_sym_PIPE_AMP] = ACTIONS(202),
    [anon_sym_AMP_AMP] = ACTIONS(206),
    [anon_sym_PIPE_PIPE] = ACTIONS(206),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2024),
    [anon_sym_LF] = ACTIONS(2024),
    [anon_sym_AMP] = ACTIONS(2024),
  },
  [699] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(202),
    [anon_sym_SEMI_SEMI] = ACTIONS(2024),
    [anon_sym_PIPE_AMP] = ACTIONS(202),
    [anon_sym_AMP_AMP] = ACTIONS(206),
    [anon_sym_PIPE_PIPE] = ACTIONS(206),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(236),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(236),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_DQUOTE] = ACTIONS(236),
    [sym_raw_string] = ACTIONS(236),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(236),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(236),
    [anon_sym_BQUOTE] = ACTIONS(236),
    [anon_sym_LT_LPAREN] = ACTIONS(236),
    [anon_sym_GT_LPAREN] = ACTIONS(236),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(2024),
    [anon_sym_LF] = ACTIONS(2024),
    [anon_sym_AMP] = ACTIONS(2024),
  },
  [700] = {
    [sym__terminated_statement] = STATE(697),
    [sym_for_statement] = STATE(698),
    [sym_while_statement] = STATE(698),
    [sym_if_statement] = STATE(698),
    [sym_case_statement] = STATE(698),
    [sym_function_definition] = STATE(698),
    [sym_subshell] = STATE(698),
    [sym_pipeline] = STATE(698),
    [sym_list] = STATE(698),
    [sym_command] = STATE(698),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(699),
    [sym_declaration_command] = STATE(698),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(996),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(2026),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [701] = {
    [sym_file_descriptor] = ACTIONS(546),
    [sym_word] = ACTIONS(546),
    [sym_variable_name] = ACTIONS(546),
    [anon_sym_for] = ACTIONS(548),
    [anon_sym_while] = ACTIONS(548),
    [anon_sym_if] = ACTIONS(548),
    [anon_sym_fi] = ACTIONS(548),
    [anon_sym_elif] = ACTIONS(548),
    [anon_sym_else] = ACTIONS(548),
    [anon_sym_case] = ACTIONS(548),
    [anon_sym_function] = ACTIONS(548),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeset] = ACTIONS(548),
    [anon_sym_export] = ACTIONS(548),
    [anon_sym_readonly] = ACTIONS(548),
    [anon_sym_local] = ACTIONS(548),
    [anon_sym_LT] = ACTIONS(548),
    [anon_sym_GT] = ACTIONS(548),
    [anon_sym_GT_GT] = ACTIONS(546),
    [anon_sym_AMP_GT] = ACTIONS(548),
    [anon_sym_AMP_GT_GT] = ACTIONS(546),
    [anon_sym_LT_AMP] = ACTIONS(546),
    [anon_sym_GT_AMP] = ACTIONS(546),
    [anon_sym_DQUOTE] = ACTIONS(546),
    [sym_raw_string] = ACTIONS(546),
    [anon_sym_DOLLAR] = ACTIONS(548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(546),
    [anon_sym_LT_LPAREN] = ACTIONS(546),
    [anon_sym_GT_LPAREN] = ACTIONS(546),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(550),
  },
  [702] = {
    [anon_sym_PIPE] = ACTIONS(2028),
    [anon_sym_RPAREN] = ACTIONS(2028),
    [anon_sym_SEMI_SEMI] = ACTIONS(2028),
    [anon_sym_PIPE_AMP] = ACTIONS(2028),
    [anon_sym_AMP_AMP] = ACTIONS(2028),
    [anon_sym_PIPE_PIPE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2028),
    [anon_sym_LF] = ACTIONS(2028),
    [anon_sym_AMP] = ACTIONS(2028),
  },
  [703] = {
    [anon_sym_fi] = ACTIONS(2030),
    [sym_comment] = ACTIONS(46),
  },
  [704] = {
    [sym__terminated_statement] = STATE(418),
    [sym_for_statement] = STATE(419),
    [sym_while_statement] = STATE(419),
    [sym_if_statement] = STATE(419),
    [sym_case_statement] = STATE(419),
    [sym_function_definition] = STATE(419),
    [sym_subshell] = STATE(419),
    [sym_pipeline] = STATE(419),
    [sym_list] = STATE(419),
    [sym_command] = STATE(419),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(422),
    [sym_declaration_command] = STATE(419),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(704),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(590),
    [sym_word] = ACTIONS(593),
    [sym_variable_name] = ACTIONS(596),
    [anon_sym_for] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(604),
    [anon_sym_if] = ACTIONS(607),
    [anon_sym_fi] = ACTIONS(2020),
    [anon_sym_elif] = ACTIONS(2020),
    [anon_sym_else] = ACTIONS(2020),
    [anon_sym_case] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(619),
    [anon_sym_typeset] = ACTIONS(619),
    [anon_sym_export] = ACTIONS(619),
    [anon_sym_readonly] = ACTIONS(619),
    [anon_sym_local] = ACTIONS(619),
    [anon_sym_LT] = ACTIONS(622),
    [anon_sym_GT] = ACTIONS(622),
    [anon_sym_GT_GT] = ACTIONS(625),
    [anon_sym_AMP_GT] = ACTIONS(622),
    [anon_sym_AMP_GT_GT] = ACTIONS(625),
    [anon_sym_LT_AMP] = ACTIONS(625),
    [anon_sym_GT_AMP] = ACTIONS(625),
    [anon_sym_DQUOTE] = ACTIONS(628),
    [sym_raw_string] = ACTIONS(593),
    [anon_sym_DOLLAR] = ACTIONS(631),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(634),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(637),
    [anon_sym_BQUOTE] = ACTIONS(640),
    [anon_sym_LT_LPAREN] = ACTIONS(643),
    [anon_sym_GT_LPAREN] = ACTIONS(643),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(646),
  },
  [705] = {
    [sym_elif_clause] = STATE(420),
    [sym_else_clause] = STATE(998),
    [aux_sym_if_statement_repeat1] = STATE(706),
    [anon_sym_fi] = ACTIONS(2030),
    [anon_sym_elif] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1352),
    [sym_comment] = ACTIONS(46),
  },
  [706] = {
    [sym_elif_clause] = STATE(420),
    [aux_sym_if_statement_repeat1] = STATE(706),
    [anon_sym_fi] = ACTIONS(2032),
    [anon_sym_elif] = ACTIONS(2034),
    [anon_sym_else] = ACTIONS(2032),
    [sym_comment] = ACTIONS(46),
  },
  [707] = {
    [aux_sym_case_item_repeat1] = STATE(1001),
    [aux_sym_concatenation_repeat1] = STATE(1002),
    [sym__concat] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_RPAREN] = ACTIONS(2039),
    [sym_comment] = ACTIONS(46),
  },
  [708] = {
    [anon_sym_PIPE] = ACTIONS(2041),
    [anon_sym_RPAREN] = ACTIONS(2041),
    [anon_sym_SEMI_SEMI] = ACTIONS(2041),
    [anon_sym_PIPE_AMP] = ACTIONS(2041),
    [anon_sym_AMP_AMP] = ACTIONS(2041),
    [anon_sym_PIPE_PIPE] = ACTIONS(2041),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2041),
    [anon_sym_LF] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
  },
  [709] = {
    [aux_sym_case_item_repeat1] = STATE(1004),
    [aux_sym_concatenation_repeat1] = STATE(1005),
    [sym__concat] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_RPAREN] = ACTIONS(2043),
    [sym_comment] = ACTIONS(46),
  },
  [710] = {
    [sym_word] = ACTIONS(2045),
    [anon_sym_esac] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2045),
    [sym_raw_string] = ACTIONS(2045),
    [anon_sym_DOLLAR] = ACTIONS(2047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2045),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2045),
    [anon_sym_BQUOTE] = ACTIONS(2045),
    [anon_sym_LT_LPAREN] = ACTIONS(2045),
    [anon_sym_GT_LPAREN] = ACTIONS(2045),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2049),
  },
  [711] = {
    [aux_sym_case_item_repeat1] = STATE(1001),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_RPAREN] = ACTIONS(2039),
    [sym_comment] = ACTIONS(46),
  },
  [712] = {
    [sym_case_item] = STATE(710),
    [sym_concatenation] = STATE(711),
    [sym_string] = STATE(707),
    [sym_simple_expansion] = STATE(707),
    [sym_expansion] = STATE(707),
    [sym_command_substitution] = STATE(707),
    [sym_process_substitution] = STATE(707),
    [aux_sym_case_statement_repeat1] = STATE(1007),
    [sym_word] = ACTIONS(1354),
    [anon_sym_esac] = ACTIONS(2051),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1354),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1358),
  },
  [713] = {
    [sym_case_item] = STATE(710),
    [sym_concatenation] = STATE(711),
    [sym_string] = STATE(707),
    [sym_simple_expansion] = STATE(707),
    [sym_expansion] = STATE(707),
    [sym_command_substitution] = STATE(707),
    [sym_process_substitution] = STATE(707),
    [aux_sym_case_statement_repeat1] = STATE(1008),
    [sym_word] = ACTIONS(1354),
    [anon_sym_esac] = ACTIONS(2051),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1354),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1358),
  },
  [714] = {
    [sym__concat] = ACTIONS(1532),
    [anon_sym_in] = ACTIONS(1534),
    [anon_sym_SEMI_SEMI] = ACTIONS(1534),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1534),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_AMP] = ACTIONS(1534),
  },
  [715] = {
    [anon_sym_AT] = ACTIONS(2053),
    [sym_comment] = ACTIONS(46),
  },
  [716] = {
    [sym__concat] = ACTIONS(1538),
    [anon_sym_in] = ACTIONS(1540),
    [anon_sym_SEMI_SEMI] = ACTIONS(1540),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_LF] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1540),
  },
  [717] = {
    [anon_sym_AT] = ACTIONS(2055),
    [sym_comment] = ACTIONS(46),
  },
  [718] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(2057),
    [anon_sym_RBRACE] = ACTIONS(2059),
    [sym_comment] = ACTIONS(46),
  },
  [719] = {
    [sym__concat] = ACTIONS(1548),
    [anon_sym_in] = ACTIONS(1550),
    [anon_sym_SEMI_SEMI] = ACTIONS(1550),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1550),
    [anon_sym_LF] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(1550),
  },
  [720] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2063),
    [sym_comment] = ACTIONS(46),
  },
  [721] = {
    [sym__concat] = ACTIONS(2065),
    [anon_sym_RBRACE] = ACTIONS(2059),
    [sym_comment] = ACTIONS(46),
  },
  [722] = {
    [anon_sym_RBRACK] = ACTIONS(2065),
    [sym_comment] = ACTIONS(46),
  },
  [723] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(2067),
    [anon_sym_RBRACE] = ACTIONS(2069),
    [sym_comment] = ACTIONS(46),
  },
  [724] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(2071),
    [anon_sym_RBRACE] = ACTIONS(2073),
    [sym_comment] = ACTIONS(46),
  },
  [725] = {
    [sym__concat] = ACTIONS(2075),
    [anon_sym_RBRACE] = ACTIONS(2069),
    [sym_comment] = ACTIONS(46),
  },
  [726] = {
    [anon_sym_RBRACK] = ACTIONS(2075),
    [sym_comment] = ACTIONS(46),
  },
  [727] = {
    [anon_sym_PIPE] = ACTIONS(2077),
    [anon_sym_RPAREN] = ACTIONS(2077),
    [anon_sym_SEMI_SEMI] = ACTIONS(2077),
    [anon_sym_PIPE_AMP] = ACTIONS(2077),
    [anon_sym_AMP_AMP] = ACTIONS(2077),
    [anon_sym_PIPE_PIPE] = ACTIONS(2077),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2077),
    [anon_sym_LF] = ACTIONS(2077),
    [anon_sym_AMP] = ACTIONS(2077),
  },
  [728] = {
    [sym_case_item] = STATE(710),
    [sym_concatenation] = STATE(711),
    [sym_string] = STATE(707),
    [sym_simple_expansion] = STATE(707),
    [sym_expansion] = STATE(707),
    [sym_command_substitution] = STATE(707),
    [sym_process_substitution] = STATE(707),
    [aux_sym_case_statement_repeat1] = STATE(1007),
    [sym_word] = ACTIONS(1354),
    [anon_sym_esac] = ACTIONS(2079),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1354),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1358),
  },
  [729] = {
    [sym_case_item] = STATE(710),
    [sym_concatenation] = STATE(711),
    [sym_string] = STATE(707),
    [sym_simple_expansion] = STATE(707),
    [sym_expansion] = STATE(707),
    [sym_command_substitution] = STATE(707),
    [sym_process_substitution] = STATE(707),
    [aux_sym_case_statement_repeat1] = STATE(1022),
    [sym_word] = ACTIONS(1354),
    [anon_sym_esac] = ACTIONS(2079),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1354),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1358),
  },
  [730] = {
    [sym_file_redirect] = STATE(1023),
    [sym_file_descriptor] = ACTIONS(810),
    [anon_sym_PIPE] = ACTIONS(2081),
    [anon_sym_SEMI_SEMI] = ACTIONS(2081),
    [anon_sym_PIPE_AMP] = ACTIONS(2081),
    [anon_sym_AMP_AMP] = ACTIONS(2081),
    [anon_sym_PIPE_PIPE] = ACTIONS(2081),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_GT_GT] = ACTIONS(814),
    [anon_sym_AMP_GT] = ACTIONS(814),
    [anon_sym_AMP_GT_GT] = ACTIONS(814),
    [anon_sym_LT_AMP] = ACTIONS(814),
    [anon_sym_GT_AMP] = ACTIONS(814),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2081),
    [anon_sym_LF] = ACTIONS(2081),
    [anon_sym_AMP] = ACTIONS(2081),
  },
  [731] = {
    [sym_file_descriptor] = ACTIONS(2083),
    [anon_sym_PIPE] = ACTIONS(2085),
    [anon_sym_RPAREN] = ACTIONS(2085),
    [anon_sym_SEMI_SEMI] = ACTIONS(2085),
    [anon_sym_PIPE_AMP] = ACTIONS(2085),
    [anon_sym_AMP_AMP] = ACTIONS(2085),
    [anon_sym_PIPE_PIPE] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_GT] = ACTIONS(2085),
    [anon_sym_GT_GT] = ACTIONS(2085),
    [anon_sym_AMP_GT] = ACTIONS(2085),
    [anon_sym_AMP_GT_GT] = ACTIONS(2085),
    [anon_sym_LT_AMP] = ACTIONS(2085),
    [anon_sym_GT_AMP] = ACTIONS(2085),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2085),
    [anon_sym_LF] = ACTIONS(2085),
    [anon_sym_AMP] = ACTIONS(2085),
  },
  [732] = {
    [sym__terminated_statement] = STATE(21),
    [sym_for_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_case_statement] = STATE(22),
    [sym_function_definition] = STATE(22),
    [sym_subshell] = STATE(22),
    [sym_pipeline] = STATE(22),
    [sym_list] = STATE(22),
    [sym_command] = STATE(22),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(24),
    [sym_declaration_command] = STATE(22),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(732),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(590),
    [sym_word] = ACTIONS(593),
    [sym_variable_name] = ACTIONS(596),
    [anon_sym_for] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(604),
    [anon_sym_if] = ACTIONS(607),
    [anon_sym_case] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(599),
    [anon_sym_declare] = ACTIONS(619),
    [anon_sym_typeset] = ACTIONS(619),
    [anon_sym_export] = ACTIONS(619),
    [anon_sym_readonly] = ACTIONS(619),
    [anon_sym_local] = ACTIONS(619),
    [anon_sym_LT] = ACTIONS(622),
    [anon_sym_GT] = ACTIONS(622),
    [anon_sym_GT_GT] = ACTIONS(625),
    [anon_sym_AMP_GT] = ACTIONS(622),
    [anon_sym_AMP_GT_GT] = ACTIONS(625),
    [anon_sym_LT_AMP] = ACTIONS(625),
    [anon_sym_GT_AMP] = ACTIONS(625),
    [anon_sym_DQUOTE] = ACTIONS(628),
    [sym_raw_string] = ACTIONS(593),
    [anon_sym_DOLLAR] = ACTIONS(631),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(634),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(637),
    [anon_sym_BQUOTE] = ACTIONS(640),
    [anon_sym_LT_LPAREN] = ACTIONS(643),
    [anon_sym_GT_LPAREN] = ACTIONS(643),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(646),
  },
  [733] = {
    [sym_concatenation] = STATE(1026),
    [sym_string] = STATE(1024),
    [sym_simple_expansion] = STATE(1024),
    [sym_expansion] = STATE(1024),
    [sym_command_substitution] = STATE(1024),
    [sym_process_substitution] = STATE(1024),
    [sym_word] = ACTIONS(2087),
    [anon_sym_DQUOTE] = ACTIONS(1403),
    [sym_raw_string] = ACTIONS(2087),
    [anon_sym_DOLLAR] = ACTIONS(1405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1411),
    [anon_sym_LT_LPAREN] = ACTIONS(1413),
    [anon_sym_GT_LPAREN] = ACTIONS(1413),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2089),
  },
  [734] = {
    [aux_sym_concatenation_repeat1] = STATE(1028),
    [sym__concat] = ACTIONS(2091),
    [anon_sym_PIPE] = ACTIONS(1136),
    [anon_sym_SEMI_SEMI] = ACTIONS(1136),
    [anon_sym_PIPE_AMP] = ACTIONS(1136),
    [anon_sym_AMP_AMP] = ACTIONS(1136),
    [anon_sym_PIPE_PIPE] = ACTIONS(1136),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1136),
    [anon_sym_LF] = ACTIONS(1136),
    [anon_sym_AMP] = ACTIONS(1136),
  },
  [735] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(1030),
    [anon_sym_DQUOTE] = ACTIONS(2093),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [736] = {
    [sym_special_variable_name] = STATE(1033),
    [anon_sym_DOLLAR] = ACTIONS(2095),
    [anon_sym_POUND] = ACTIONS(2095),
    [anon_sym_AT] = ACTIONS(2095),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2097),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_QMARK] = ACTIONS(2095),
    [anon_sym_DASH] = ACTIONS(2095),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_0] = ACTIONS(2099),
    [anon_sym__] = ACTIONS(2099),
  },
  [737] = {
    [sym_special_variable_name] = STATE(1036),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(2101),
    [anon_sym_AT] = ACTIONS(138),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [738] = {
    [sym_for_statement] = STATE(1037),
    [sym_while_statement] = STATE(1037),
    [sym_if_statement] = STATE(1037),
    [sym_case_statement] = STATE(1037),
    [sym_function_definition] = STATE(1037),
    [sym_subshell] = STATE(1037),
    [sym_pipeline] = STATE(1037),
    [sym_list] = STATE(1037),
    [sym_command] = STATE(1037),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(1038),
    [sym_declaration_command] = STATE(1037),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [739] = {
    [sym_for_statement] = STATE(1039),
    [sym_while_statement] = STATE(1039),
    [sym_if_statement] = STATE(1039),
    [sym_case_statement] = STATE(1039),
    [sym_function_definition] = STATE(1039),
    [sym_subshell] = STATE(1039),
    [sym_pipeline] = STATE(1039),
    [sym_list] = STATE(1039),
    [sym_command] = STATE(1039),
    [sym_command_name] = STATE(118),
    [sym_variable_assignment] = STATE(1040),
    [sym_declaration_command] = STATE(1039),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(112),
    [sym_simple_expansion] = STATE(112),
    [sym_expansion] = STATE(112),
    [sym_command_substitution] = STATE(112),
    [sym_process_substitution] = STATE(112),
    [aux_sym_command_repeat1] = STATE(121),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(178),
    [sym_variable_name] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(184),
    [anon_sym_typeset] = ACTIONS(184),
    [anon_sym_export] = ACTIONS(184),
    [anon_sym_readonly] = ACTIONS(184),
    [anon_sym_local] = ACTIONS(184),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(178),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(186),
  },
  [740] = {
    [sym_for_statement] = STATE(1041),
    [sym_while_statement] = STATE(1041),
    [sym_if_statement] = STATE(1041),
    [sym_case_statement] = STATE(1041),
    [sym_function_definition] = STATE(1041),
    [sym_subshell] = STATE(1041),
    [sym_pipeline] = STATE(1041),
    [sym_list] = STATE(1041),
    [sym_command] = STATE(1041),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(1042),
    [sym_declaration_command] = STATE(1041),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [741] = {
    [aux_sym_concatenation_repeat1] = STATE(1043),
    [sym__concat] = ACTIONS(2091),
    [anon_sym_PIPE] = ACTIONS(1150),
    [anon_sym_SEMI_SEMI] = ACTIONS(1150),
    [anon_sym_PIPE_AMP] = ACTIONS(1150),
    [anon_sym_AMP_AMP] = ACTIONS(1150),
    [anon_sym_PIPE_PIPE] = ACTIONS(1150),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1150),
    [anon_sym_LF] = ACTIONS(1150),
    [anon_sym_AMP] = ACTIONS(1150),
  },
  [742] = {
    [anon_sym_PIPE] = ACTIONS(1136),
    [anon_sym_RPAREN] = ACTIONS(1136),
    [anon_sym_SEMI_SEMI] = ACTIONS(1136),
    [anon_sym_PIPE_AMP] = ACTIONS(1136),
    [anon_sym_AMP_AMP] = ACTIONS(1136),
    [anon_sym_PIPE_PIPE] = ACTIONS(1136),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1136),
    [anon_sym_LF] = ACTIONS(1136),
    [anon_sym_AMP] = ACTIONS(1136),
  },
  [743] = {
    [aux_sym_concatenation_repeat1] = STATE(1044),
    [sym_file_descriptor] = ACTIONS(254),
    [sym_word] = ACTIONS(254),
    [sym__concat] = ACTIONS(688),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(256),
    [anon_sym_RPAREN] = ACTIONS(256),
    [anon_sym_SEMI_SEMI] = ACTIONS(256),
    [anon_sym_PIPE_AMP] = ACTIONS(256),
    [anon_sym_AMP_AMP] = ACTIONS(256),
    [anon_sym_PIPE_PIPE] = ACTIONS(256),
    [anon_sym_LT] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(256),
    [anon_sym_GT_GT] = ACTIONS(256),
    [anon_sym_AMP_GT] = ACTIONS(256),
    [anon_sym_AMP_GT_GT] = ACTIONS(256),
    [anon_sym_LT_AMP] = ACTIONS(256),
    [anon_sym_GT_AMP] = ACTIONS(256),
    [anon_sym_DQUOTE] = ACTIONS(256),
    [sym_raw_string] = ACTIONS(256),
    [anon_sym_DOLLAR] = ACTIONS(256),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(256),
    [anon_sym_BQUOTE] = ACTIONS(256),
    [anon_sym_LT_LPAREN] = ACTIONS(256),
    [anon_sym_GT_LPAREN] = ACTIONS(256),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(256),
    [anon_sym_SEMI] = ACTIONS(256),
    [anon_sym_LF] = ACTIONS(256),
    [anon_sym_AMP] = ACTIONS(256),
  },
  [744] = {
    [aux_sym_concatenation_repeat1] = STATE(1044),
    [sym_file_descriptor] = ACTIONS(542),
    [sym_word] = ACTIONS(542),
    [sym__concat] = ACTIONS(688),
    [sym_variable_name] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(544),
    [anon_sym_RPAREN] = ACTIONS(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_PIPE_PIPE] = ACTIONS(544),
    [anon_sym_LT] = ACTIONS(544),
    [anon_sym_GT] = ACTIONS(544),
    [anon_sym_GT_GT] = ACTIONS(544),
    [anon_sym_AMP_GT] = ACTIONS(544),
    [anon_sym_AMP_GT_GT] = ACTIONS(544),
    [anon_sym_LT_AMP] = ACTIONS(544),
    [anon_sym_GT_AMP] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(544),
    [sym_raw_string] = ACTIONS(544),
    [anon_sym_DOLLAR] = ACTIONS(544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(544),
    [anon_sym_BQUOTE] = ACTIONS(544),
    [anon_sym_LT_LPAREN] = ACTIONS(544),
    [anon_sym_GT_LPAREN] = ACTIONS(544),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(544),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [745] = {
    [sym_compound_statement] = STATE(1045),
    [anon_sym_LBRACE] = ACTIONS(330),
    [sym_comment] = ACTIONS(46),
  },
  [746] = {
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_GT] = ACTIONS(2105),
    [anon_sym_GT_GT] = ACTIONS(2107),
    [anon_sym_AMP_GT] = ACTIONS(2105),
    [anon_sym_AMP_GT_GT] = ACTIONS(2107),
    [anon_sym_LT_AMP] = ACTIONS(2107),
    [anon_sym_GT_AMP] = ACTIONS(2107),
    [sym_comment] = ACTIONS(46),
  },
  [747] = {
    [sym_concatenation] = STATE(742),
    [sym_string] = STATE(1047),
    [sym_simple_expansion] = STATE(1047),
    [sym_expansion] = STATE(1047),
    [sym_command_substitution] = STATE(1047),
    [sym_process_substitution] = STATE(1047),
    [sym_word] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(1403),
    [sym_raw_string] = ACTIONS(2109),
    [anon_sym_DOLLAR] = ACTIONS(1405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1411),
    [anon_sym_LT_LPAREN] = ACTIONS(1413),
    [anon_sym_GT_LPAREN] = ACTIONS(1413),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2111),
  },
  [748] = {
    [aux_sym_concatenation_repeat1] = STATE(1049),
    [sym_word] = ACTIONS(686),
    [sym__concat] = ACTIONS(1455),
    [sym_variable_name] = ACTIONS(686),
    [anon_sym_PIPE] = ACTIONS(690),
    [anon_sym_RPAREN] = ACTIONS(690),
    [anon_sym_SEMI_SEMI] = ACTIONS(690),
    [anon_sym_PIPE_AMP] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(690),
    [anon_sym_SEMI] = ACTIONS(690),
    [anon_sym_LF] = ACTIONS(690),
    [anon_sym_AMP] = ACTIONS(690),
  },
  [749] = {
    [aux_sym_concatenation_repeat1] = STATE(1050),
    [sym_word] = ACTIONS(722),
    [sym__concat] = ACTIONS(1455),
    [sym_variable_name] = ACTIONS(722),
    [anon_sym_PIPE] = ACTIONS(724),
    [anon_sym_RPAREN] = ACTIONS(724),
    [anon_sym_SEMI_SEMI] = ACTIONS(724),
    [anon_sym_PIPE_AMP] = ACTIONS(724),
    [anon_sym_AMP_AMP] = ACTIONS(724),
    [anon_sym_PIPE_PIPE] = ACTIONS(724),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(724),
    [anon_sym_LF] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(724),
  },
  [750] = {
    [sym_file_redirect] = STATE(914),
    [sym_file_descriptor] = ACTIONS(1421),
    [anon_sym_PIPE] = ACTIONS(1799),
    [anon_sym_RPAREN] = ACTIONS(1799),
    [anon_sym_SEMI_SEMI] = ACTIONS(1799),
    [anon_sym_PIPE_AMP] = ACTIONS(1799),
    [anon_sym_AMP_AMP] = ACTIONS(1799),
    [anon_sym_PIPE_PIPE] = ACTIONS(1799),
    [anon_sym_LT] = ACTIONS(1423),
    [anon_sym_GT] = ACTIONS(1423),
    [anon_sym_GT_GT] = ACTIONS(1423),
    [anon_sym_AMP_GT] = ACTIONS(1423),
    [anon_sym_AMP_GT_GT] = ACTIONS(1423),
    [anon_sym_LT_AMP] = ACTIONS(1423),
    [anon_sym_GT_AMP] = ACTIONS(1423),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1799),
    [anon_sym_LF] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
  },
  [751] = {
    [aux_sym_concatenation_repeat1] = STATE(753),
    [sym_file_descriptor] = ACTIONS(667),
    [sym__concat] = ACTIONS(1134),
    [anon_sym_PIPE] = ACTIONS(1801),
    [anon_sym_RPAREN] = ACTIONS(1801),
    [anon_sym_SEMI_SEMI] = ACTIONS(1801),
    [anon_sym_PIPE_AMP] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1801),
    [anon_sym_PIPE_PIPE] = ACTIONS(1801),
    [anon_sym_LT] = ACTIONS(1801),
    [anon_sym_GT] = ACTIONS(1801),
    [anon_sym_GT_GT] = ACTIONS(1801),
    [anon_sym_AMP_GT] = ACTIONS(1801),
    [anon_sym_AMP_GT_GT] = ACTIONS(1801),
    [anon_sym_LT_AMP] = ACTIONS(1801),
    [anon_sym_GT_AMP] = ACTIONS(1801),
    [anon_sym_LT_LT] = ACTIONS(1801),
    [anon_sym_LT_LT_DASH] = ACTIONS(1801),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1801),
    [anon_sym_LF] = ACTIONS(1801),
    [anon_sym_AMP] = ACTIONS(1801),
  },
  [752] = {
    [aux_sym_concatenation_repeat1] = STATE(754),
    [sym_file_descriptor] = ACTIONS(671),
    [sym__concat] = ACTIONS(1134),
    [anon_sym_PIPE] = ACTIONS(1803),
    [anon_sym_RPAREN] = ACTIONS(1803),
    [anon_sym_SEMI_SEMI] = ACTIONS(1803),
    [anon_sym_PIPE_AMP] = ACTIONS(1803),
    [anon_sym_AMP_AMP] = ACTIONS(1803),
    [anon_sym_PIPE_PIPE] = ACTIONS(1803),
    [anon_sym_LT] = ACTIONS(1803),
    [anon_sym_GT] = ACTIONS(1803),
    [anon_sym_GT_GT] = ACTIONS(1803),
    [anon_sym_AMP_GT] = ACTIONS(1803),
    [anon_sym_AMP_GT_GT] = ACTIONS(1803),
    [anon_sym_LT_AMP] = ACTIONS(1803),
    [anon_sym_GT_AMP] = ACTIONS(1803),
    [anon_sym_LT_LT] = ACTIONS(1803),
    [anon_sym_LT_LT_DASH] = ACTIONS(1803),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1803),
    [anon_sym_LF] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
  },
  [753] = {
    [aux_sym_concatenation_repeat1] = STATE(1051),
    [sym_file_descriptor] = ACTIONS(254),
    [sym__concat] = ACTIONS(1134),
    [anon_sym_PIPE] = ACTIONS(256),
    [anon_sym_RPAREN] = ACTIONS(256),
    [anon_sym_SEMI_SEMI] = ACTIONS(256),
    [anon_sym_PIPE_AMP] = ACTIONS(256),
    [anon_sym_AMP_AMP] = ACTIONS(256),
    [anon_sym_PIPE_PIPE] = ACTIONS(256),
    [anon_sym_LT] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(256),
    [anon_sym_GT_GT] = ACTIONS(256),
    [anon_sym_AMP_GT] = ACTIONS(256),
    [anon_sym_AMP_GT_GT] = ACTIONS(256),
    [anon_sym_LT_AMP] = ACTIONS(256),
    [anon_sym_GT_AMP] = ACTIONS(256),
    [anon_sym_LT_LT] = ACTIONS(256),
    [anon_sym_LT_LT_DASH] = ACTIONS(256),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(256),
    [anon_sym_LF] = ACTIONS(256),
    [anon_sym_AMP] = ACTIONS(256),
  },
  [754] = {
    [aux_sym_concatenation_repeat1] = STATE(1051),
    [sym_file_descriptor] = ACTIONS(542),
    [sym__concat] = ACTIONS(1134),
    [anon_sym_PIPE] = ACTIONS(544),
    [anon_sym_RPAREN] = ACTIONS(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_PIPE_PIPE] = ACTIONS(544),
    [anon_sym_LT] = ACTIONS(544),
    [anon_sym_GT] = ACTIONS(544),
    [anon_sym_GT_GT] = ACTIONS(544),
    [anon_sym_AMP_GT] = ACTIONS(544),
    [anon_sym_AMP_GT_GT] = ACTIONS(544),
    [anon_sym_LT_AMP] = ACTIONS(544),
    [anon_sym_GT_AMP] = ACTIONS(544),
    [anon_sym_LT_LT] = ACTIONS(544),
    [anon_sym_LT_LT_DASH] = ACTIONS(544),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [755] = {
    [anon_sym_PIPE] = ACTIONS(2113),
    [anon_sym_RPAREN] = ACTIONS(2113),
    [anon_sym_SEMI_SEMI] = ACTIONS(2113),
    [anon_sym_PIPE_AMP] = ACTIONS(2113),
    [anon_sym_AMP_AMP] = ACTIONS(2113),
    [anon_sym_PIPE_PIPE] = ACTIONS(2113),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_LF] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(2113),
  },
  [756] = {
    [sym_file_redirect] = STATE(134),
    [sym_heredoc_redirect] = STATE(134),
    [aux_sym_command_repeat2] = STATE(465),
    [sym_file_descriptor] = ACTIONS(348),
    [anon_sym_PIPE] = ACTIONS(1855),
    [anon_sym_RPAREN] = ACTIONS(1855),
    [anon_sym_SEMI_SEMI] = ACTIONS(1855),
    [anon_sym_PIPE_AMP] = ACTIONS(1855),
    [anon_sym_AMP_AMP] = ACTIONS(1855),
    [anon_sym_PIPE_PIPE] = ACTIONS(1855),
    [anon_sym_LT] = ACTIONS(352),
    [anon_sym_GT] = ACTIONS(352),
    [anon_sym_GT_GT] = ACTIONS(352),
    [anon_sym_AMP_GT] = ACTIONS(352),
    [anon_sym_AMP_GT_GT] = ACTIONS(352),
    [anon_sym_LT_AMP] = ACTIONS(352),
    [anon_sym_GT_AMP] = ACTIONS(352),
    [anon_sym_LT_LT] = ACTIONS(216),
    [anon_sym_LT_LT_DASH] = ACTIONS(216),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1855),
    [anon_sym_LF] = ACTIONS(1855),
    [anon_sym_AMP] = ACTIONS(1855),
  },
  [757] = {
    [sym_string] = STATE(1052),
    [sym_simple_expansion] = STATE(1052),
    [sym_expansion] = STATE(1052),
    [sym_command_substitution] = STATE(1052),
    [sym_process_substitution] = STATE(1052),
    [sym_word] = ACTIONS(2115),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_raw_string] = ACTIONS(2115),
    [anon_sym_DOLLAR] = ACTIONS(850),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(852),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(854),
    [anon_sym_BQUOTE] = ACTIONS(856),
    [anon_sym_LT_LPAREN] = ACTIONS(858),
    [anon_sym_GT_LPAREN] = ACTIONS(858),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2117),
  },
  [758] = {
    [aux_sym_concatenation_repeat1] = STATE(1054),
    [sym_word] = ACTIONS(254),
    [sym__concat] = ACTIONS(1455),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(256),
    [anon_sym_SEMI_SEMI] = ACTIONS(256),
    [anon_sym_PIPE_AMP] = ACTIONS(256),
    [anon_sym_AMP_AMP] = ACTIONS(256),
    [anon_sym_PIPE_PIPE] = ACTIONS(256),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(256),
    [anon_sym_SEMI] = ACTIONS(256),
    [anon_sym_LF] = ACTIONS(256),
    [anon_sym_AMP] = ACTIONS(256),
  },
  [759] = {
    [sym_word] = ACTIONS(1226),
    [sym_variable_name] = ACTIONS(1226),
    [anon_sym_PIPE] = ACTIONS(1228),
    [anon_sym_RPAREN] = ACTIONS(1228),
    [anon_sym_SEMI_SEMI] = ACTIONS(1228),
    [anon_sym_PIPE_AMP] = ACTIONS(1228),
    [anon_sym_AMP_AMP] = ACTIONS(1228),
    [anon_sym_PIPE_PIPE] = ACTIONS(1228),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1228),
    [anon_sym_SEMI] = ACTIONS(1228),
    [anon_sym_LF] = ACTIONS(1228),
    [anon_sym_AMP] = ACTIONS(1228),
  },
  [760] = {
    [sym_concatenation] = STATE(364),
    [sym_string] = STATE(355),
    [sym_simple_expansion] = STATE(355),
    [sym_expansion] = STATE(355),
    [sym_command_substitution] = STATE(355),
    [sym_process_substitution] = STATE(355),
    [aux_sym_for_statement_repeat1] = STATE(648),
    [sym_word] = ACTIONS(692),
    [anon_sym_RPAREN] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(696),
    [sym_raw_string] = ACTIONS(692),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(700),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(702),
    [anon_sym_BQUOTE] = ACTIONS(704),
    [anon_sym_LT_LPAREN] = ACTIONS(706),
    [anon_sym_GT_LPAREN] = ACTIONS(706),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(708),
  },
  [761] = {
    [sym_word] = ACTIONS(394),
    [sym__concat] = ACTIONS(394),
    [sym_variable_name] = ACTIONS(394),
    [anon_sym_PIPE] = ACTIONS(396),
    [anon_sym_RPAREN] = ACTIONS(396),
    [anon_sym_SEMI_SEMI] = ACTIONS(396),
    [anon_sym_PIPE_AMP] = ACTIONS(396),
    [anon_sym_AMP_AMP] = ACTIONS(396),
    [anon_sym_PIPE_PIPE] = ACTIONS(396),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(396),
    [anon_sym_SEMI] = ACTIONS(396),
    [anon_sym_LF] = ACTIONS(396),
    [anon_sym_AMP] = ACTIONS(396),
  },
  [762] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(252),
    [anon_sym_DQUOTE] = ACTIONS(2121),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [763] = {
    [sym_word] = ACTIONS(412),
    [sym__concat] = ACTIONS(412),
    [sym_variable_name] = ACTIONS(412),
    [anon_sym_PIPE] = ACTIONS(414),
    [anon_sym_RPAREN] = ACTIONS(414),
    [anon_sym_SEMI_SEMI] = ACTIONS(414),
    [anon_sym_PIPE_AMP] = ACTIONS(414),
    [anon_sym_AMP_AMP] = ACTIONS(414),
    [anon_sym_PIPE_PIPE] = ACTIONS(414),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(414),
    [anon_sym_SEMI] = ACTIONS(414),
    [anon_sym_LF] = ACTIONS(414),
    [anon_sym_AMP] = ACTIONS(414),
  },
  [764] = {
    [sym_word] = ACTIONS(416),
    [sym__concat] = ACTIONS(416),
    [sym_variable_name] = ACTIONS(416),
    [anon_sym_PIPE] = ACTIONS(418),
    [anon_sym_RPAREN] = ACTIONS(418),
    [anon_sym_SEMI_SEMI] = ACTIONS(418),
    [anon_sym_PIPE_AMP] = ACTIONS(418),
    [anon_sym_AMP_AMP] = ACTIONS(418),
    [anon_sym_PIPE_PIPE] = ACTIONS(418),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(418),
    [anon_sym_SEMI] = ACTIONS(418),
    [anon_sym_LF] = ACTIONS(418),
    [anon_sym_AMP] = ACTIONS(418),
  },
  [765] = {
    [sym_word] = ACTIONS(420),
    [sym__concat] = ACTIONS(420),
    [sym_variable_name] = ACTIONS(420),
    [anon_sym_PIPE] = ACTIONS(422),
    [anon_sym_RPAREN] = ACTIONS(422),
    [anon_sym_SEMI_SEMI] = ACTIONS(422),
    [anon_sym_PIPE_AMP] = ACTIONS(422),
    [anon_sym_AMP_AMP] = ACTIONS(422),
    [anon_sym_PIPE_PIPE] = ACTIONS(422),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(422),
    [anon_sym_SEMI] = ACTIONS(422),
    [anon_sym_LF] = ACTIONS(422),
    [anon_sym_AMP] = ACTIONS(422),
  },
  [766] = {
    [sym_special_variable_name] = STATE(1058),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_EQ] = ACTIONS(412),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(138),
    [anon_sym_AT] = ACTIONS(138),
    [anon_sym_COLON] = ACTIONS(424),
    [anon_sym_COLON_QMARK] = ACTIONS(412),
    [anon_sym_COLON_DASH] = ACTIONS(412),
    [anon_sym_PERCENT] = ACTIONS(412),
    [anon_sym_SLASH] = ACTIONS(412),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2123),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [767] = {
    [anon_sym_RBRACE] = ACTIONS(2125),
    [anon_sym_EQ] = ACTIONS(2127),
    [anon_sym_LBRACK] = ACTIONS(2129),
    [anon_sym_COLON] = ACTIONS(2131),
    [anon_sym_COLON_QMARK] = ACTIONS(2127),
    [anon_sym_COLON_DASH] = ACTIONS(2127),
    [anon_sym_PERCENT] = ACTIONS(2127),
    [anon_sym_SLASH] = ACTIONS(2127),
    [sym_comment] = ACTIONS(46),
  },
  [768] = {
    [anon_sym_RBRACE] = ACTIONS(2133),
    [anon_sym_EQ] = ACTIONS(2135),
    [anon_sym_LBRACK] = ACTIONS(2137),
    [anon_sym_COLON] = ACTIONS(2139),
    [anon_sym_COLON_QMARK] = ACTIONS(2135),
    [anon_sym_COLON_DASH] = ACTIONS(2135),
    [anon_sym_PERCENT] = ACTIONS(2135),
    [anon_sym_SLASH] = ACTIONS(2135),
    [sym_comment] = ACTIONS(46),
  },
  [769] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(2141),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [770] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(2141),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [771] = {
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_BQUOTE] = ACTIONS(2141),
    [sym_comment] = ACTIONS(46),
  },
  [772] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(2141),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [773] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(2143),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [774] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(2143),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [775] = {
    [aux_sym_concatenation_repeat1] = STATE(1054),
    [sym_word] = ACTIONS(542),
    [sym__concat] = ACTIONS(1455),
    [sym_variable_name] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_PIPE_PIPE] = ACTIONS(544),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(544),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [776] = {
    [sym_file_descriptor] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1532),
    [sym_variable_name] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_GT] = ACTIONS(2145),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(2145),
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(2145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2145),
  },
  [777] = {
    [anon_sym_AT] = ACTIONS(2147),
    [sym_comment] = ACTIONS(46),
  },
  [778] = {
    [sym_file_descriptor] = ACTIONS(1538),
    [sym_word] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [sym_variable_name] = ACTIONS(1538),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_GT] = ACTIONS(2149),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_AMP_GT] = ACTIONS(2149),
    [anon_sym_AMP_GT_GT] = ACTIONS(1538),
    [anon_sym_LT_AMP] = ACTIONS(1538),
    [anon_sym_GT_AMP] = ACTIONS(1538),
    [anon_sym_DQUOTE] = ACTIONS(1538),
    [sym_raw_string] = ACTIONS(1538),
    [anon_sym_DOLLAR] = ACTIONS(2149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1538),
    [anon_sym_BQUOTE] = ACTIONS(1538),
    [anon_sym_LT_LPAREN] = ACTIONS(1538),
    [anon_sym_GT_LPAREN] = ACTIONS(1538),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2149),
  },
  [779] = {
    [anon_sym_AT] = ACTIONS(2151),
    [sym_comment] = ACTIONS(46),
  },
  [780] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(2153),
    [anon_sym_RBRACE] = ACTIONS(2155),
    [sym_comment] = ACTIONS(46),
  },
  [781] = {
    [sym_file_descriptor] = ACTIONS(1548),
    [sym_word] = ACTIONS(1548),
    [sym__concat] = ACTIONS(1548),
    [sym_variable_name] = ACTIONS(1548),
    [anon_sym_LT] = ACTIONS(2157),
    [anon_sym_GT] = ACTIONS(2157),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_AMP_GT] = ACTIONS(2157),
    [anon_sym_AMP_GT_GT] = ACTIONS(1548),
    [anon_sym_LT_AMP] = ACTIONS(1548),
    [anon_sym_GT_AMP] = ACTIONS(1548),
    [anon_sym_DQUOTE] = ACTIONS(1548),
    [sym_raw_string] = ACTIONS(1548),
    [anon_sym_DOLLAR] = ACTIONS(2157),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1548),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(1548),
    [anon_sym_LT_LPAREN] = ACTIONS(1548),
    [anon_sym_GT_LPAREN] = ACTIONS(1548),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2157),
  },
  [782] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(2159),
    [anon_sym_RBRACE] = ACTIONS(2161),
    [sym_comment] = ACTIONS(46),
  },
  [783] = {
    [sym__concat] = ACTIONS(2163),
    [anon_sym_RBRACE] = ACTIONS(2155),
    [sym_comment] = ACTIONS(46),
  },
  [784] = {
    [anon_sym_RBRACK] = ACTIONS(2163),
    [sym_comment] = ACTIONS(46),
  },
  [785] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(2165),
    [anon_sym_RBRACE] = ACTIONS(2167),
    [sym_comment] = ACTIONS(46),
  },
  [786] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(2169),
    [anon_sym_RBRACE] = ACTIONS(2171),
    [sym_comment] = ACTIONS(46),
  },
  [787] = {
    [sym__concat] = ACTIONS(2173),
    [anon_sym_RBRACE] = ACTIONS(2167),
    [sym_comment] = ACTIONS(46),
  },
  [788] = {
    [anon_sym_RBRACK] = ACTIONS(2173),
    [sym_comment] = ACTIONS(46),
  },
  [789] = {
    [anon_sym_DQUOTE] = ACTIONS(1534),
    [sym__string_content] = ACTIONS(1534),
    [anon_sym_DOLLAR] = ACTIONS(1534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1534),
    [anon_sym_BQUOTE] = ACTIONS(1534),
    [sym_comment] = ACTIONS(60),
  },
  [790] = {
    [anon_sym_AT] = ACTIONS(2175),
    [sym_comment] = ACTIONS(46),
  },
  [791] = {
    [anon_sym_DQUOTE] = ACTIONS(1540),
    [sym__string_content] = ACTIONS(1540),
    [anon_sym_DOLLAR] = ACTIONS(1540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1540),
    [anon_sym_BQUOTE] = ACTIONS(1540),
    [sym_comment] = ACTIONS(60),
  },
  [792] = {
    [anon_sym_AT] = ACTIONS(2177),
    [sym_comment] = ACTIONS(46),
  },
  [793] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(2179),
    [anon_sym_RBRACE] = ACTIONS(2181),
    [sym_comment] = ACTIONS(46),
  },
  [794] = {
    [anon_sym_DQUOTE] = ACTIONS(1550),
    [sym__string_content] = ACTIONS(1550),
    [anon_sym_DOLLAR] = ACTIONS(1550),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1550),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1550),
    [anon_sym_BQUOTE] = ACTIONS(1550),
    [sym_comment] = ACTIONS(60),
  },
  [795] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(2183),
    [anon_sym_RBRACE] = ACTIONS(2185),
    [sym_comment] = ACTIONS(46),
  },
  [796] = {
    [sym__concat] = ACTIONS(2187),
    [anon_sym_RBRACE] = ACTIONS(2181),
    [sym_comment] = ACTIONS(46),
  },
  [797] = {
    [anon_sym_RBRACK] = ACTIONS(2187),
    [sym_comment] = ACTIONS(46),
  },
  [798] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(2189),
    [anon_sym_RBRACE] = ACTIONS(2191),
    [sym_comment] = ACTIONS(46),
  },
  [799] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(2193),
    [anon_sym_RBRACE] = ACTIONS(2195),
    [sym_comment] = ACTIONS(46),
  },
  [800] = {
    [sym__concat] = ACTIONS(2197),
    [anon_sym_RBRACE] = ACTIONS(2191),
    [sym_comment] = ACTIONS(46),
  },
  [801] = {
    [anon_sym_RBRACK] = ACTIONS(2197),
    [sym_comment] = ACTIONS(46),
  },
  [802] = {
    [anon_sym_RBRACK] = ACTIONS(2199),
    [sym_comment] = ACTIONS(46),
  },
  [803] = {
    [anon_sym_RBRACK] = ACTIONS(2201),
    [sym_comment] = ACTIONS(46),
  },
  [804] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2203),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [805] = {
    [sym_file_descriptor] = ACTIONS(2205),
    [sym_word] = ACTIONS(2205),
    [sym__concat] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2207),
    [anon_sym_RPAREN] = ACTIONS(2207),
    [anon_sym_SEMI_SEMI] = ACTIONS(2207),
    [anon_sym_PIPE_AMP] = ACTIONS(2207),
    [anon_sym_AMP_AMP] = ACTIONS(2207),
    [anon_sym_PIPE_PIPE] = ACTIONS(2207),
    [anon_sym_LT] = ACTIONS(2207),
    [anon_sym_GT] = ACTIONS(2207),
    [anon_sym_GT_GT] = ACTIONS(2207),
    [anon_sym_AMP_GT] = ACTIONS(2207),
    [anon_sym_AMP_GT_GT] = ACTIONS(2207),
    [anon_sym_LT_AMP] = ACTIONS(2207),
    [anon_sym_GT_AMP] = ACTIONS(2207),
    [anon_sym_LT_LT] = ACTIONS(2207),
    [anon_sym_LT_LT_DASH] = ACTIONS(2207),
    [anon_sym_DQUOTE] = ACTIONS(2207),
    [sym_raw_string] = ACTIONS(2207),
    [anon_sym_DOLLAR] = ACTIONS(2207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2207),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2207),
    [anon_sym_BQUOTE] = ACTIONS(2207),
    [anon_sym_LT_LPAREN] = ACTIONS(2207),
    [anon_sym_GT_LPAREN] = ACTIONS(2207),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2207),
    [anon_sym_SEMI] = ACTIONS(2207),
    [anon_sym_LF] = ACTIONS(2207),
    [anon_sym_AMP] = ACTIONS(2207),
  },
  [806] = {
    [aux_sym_concatenation_repeat1] = STATE(1094),
    [sym__concat] = ACTIONS(726),
    [anon_sym_RBRACE] = ACTIONS(254),
    [sym_comment] = ACTIONS(46),
  },
  [807] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [808] = {
    [sym_file_descriptor] = ACTIONS(2211),
    [sym_word] = ACTIONS(2211),
    [sym__concat] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2213),
    [anon_sym_RPAREN] = ACTIONS(2213),
    [anon_sym_SEMI_SEMI] = ACTIONS(2213),
    [anon_sym_PIPE_AMP] = ACTIONS(2213),
    [anon_sym_AMP_AMP] = ACTIONS(2213),
    [anon_sym_PIPE_PIPE] = ACTIONS(2213),
    [anon_sym_LT] = ACTIONS(2213),
    [anon_sym_GT] = ACTIONS(2213),
    [anon_sym_GT_GT] = ACTIONS(2213),
    [anon_sym_AMP_GT] = ACTIONS(2213),
    [anon_sym_AMP_GT_GT] = ACTIONS(2213),
    [anon_sym_LT_AMP] = ACTIONS(2213),
    [anon_sym_GT_AMP] = ACTIONS(2213),
    [anon_sym_LT_LT] = ACTIONS(2213),
    [anon_sym_LT_LT_DASH] = ACTIONS(2213),
    [anon_sym_DQUOTE] = ACTIONS(2213),
    [sym_raw_string] = ACTIONS(2213),
    [anon_sym_DOLLAR] = ACTIONS(2213),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2213),
    [anon_sym_BQUOTE] = ACTIONS(2213),
    [anon_sym_LT_LPAREN] = ACTIONS(2213),
    [anon_sym_GT_LPAREN] = ACTIONS(2213),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2213),
    [anon_sym_SEMI] = ACTIONS(2213),
    [anon_sym_LF] = ACTIONS(2213),
    [anon_sym_AMP] = ACTIONS(2213),
  },
  [809] = {
    [aux_sym_concatenation_repeat1] = STATE(1094),
    [sym__concat] = ACTIONS(726),
    [anon_sym_RBRACE] = ACTIONS(542),
    [sym_comment] = ACTIONS(46),
  },
  [810] = {
    [anon_sym_RBRACE] = ACTIONS(2203),
    [sym_comment] = ACTIONS(46),
  },
  [811] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2215),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [812] = {
    [sym_file_descriptor] = ACTIONS(2217),
    [sym_word] = ACTIONS(2217),
    [sym__concat] = ACTIONS(2217),
    [anon_sym_PIPE] = ACTIONS(2219),
    [anon_sym_RPAREN] = ACTIONS(2219),
    [anon_sym_SEMI_SEMI] = ACTIONS(2219),
    [anon_sym_PIPE_AMP] = ACTIONS(2219),
    [anon_sym_AMP_AMP] = ACTIONS(2219),
    [anon_sym_PIPE_PIPE] = ACTIONS(2219),
    [anon_sym_LT] = ACTIONS(2219),
    [anon_sym_GT] = ACTIONS(2219),
    [anon_sym_GT_GT] = ACTIONS(2219),
    [anon_sym_AMP_GT] = ACTIONS(2219),
    [anon_sym_AMP_GT_GT] = ACTIONS(2219),
    [anon_sym_LT_AMP] = ACTIONS(2219),
    [anon_sym_GT_AMP] = ACTIONS(2219),
    [anon_sym_LT_LT] = ACTIONS(2219),
    [anon_sym_LT_LT_DASH] = ACTIONS(2219),
    [anon_sym_DQUOTE] = ACTIONS(2219),
    [sym_raw_string] = ACTIONS(2219),
    [anon_sym_DOLLAR] = ACTIONS(2219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2219),
    [anon_sym_BQUOTE] = ACTIONS(2219),
    [anon_sym_LT_LPAREN] = ACTIONS(2219),
    [anon_sym_GT_LPAREN] = ACTIONS(2219),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2219),
    [anon_sym_SEMI] = ACTIONS(2219),
    [anon_sym_LF] = ACTIONS(2219),
    [anon_sym_AMP] = ACTIONS(2219),
  },
  [813] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [814] = {
    [sym_file_descriptor] = ACTIONS(2223),
    [sym_word] = ACTIONS(2223),
    [sym__concat] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_RPAREN] = ACTIONS(2225),
    [anon_sym_SEMI_SEMI] = ACTIONS(2225),
    [anon_sym_PIPE_AMP] = ACTIONS(2225),
    [anon_sym_AMP_AMP] = ACTIONS(2225),
    [anon_sym_PIPE_PIPE] = ACTIONS(2225),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_GT_GT] = ACTIONS(2225),
    [anon_sym_AMP_GT] = ACTIONS(2225),
    [anon_sym_AMP_GT_GT] = ACTIONS(2225),
    [anon_sym_LT_AMP] = ACTIONS(2225),
    [anon_sym_GT_AMP] = ACTIONS(2225),
    [anon_sym_LT_LT] = ACTIONS(2225),
    [anon_sym_LT_LT_DASH] = ACTIONS(2225),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [sym_raw_string] = ACTIONS(2225),
    [anon_sym_DOLLAR] = ACTIONS(2225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2225),
    [anon_sym_BQUOTE] = ACTIONS(2225),
    [anon_sym_LT_LPAREN] = ACTIONS(2225),
    [anon_sym_GT_LPAREN] = ACTIONS(2225),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2225),
    [anon_sym_LF] = ACTIONS(2225),
    [anon_sym_AMP] = ACTIONS(2225),
  },
  [815] = {
    [anon_sym_RBRACE] = ACTIONS(2215),
    [sym_comment] = ACTIONS(46),
  },
  [816] = {
    [sym_string] = STATE(1098),
    [sym_simple_expansion] = STATE(1098),
    [sym_expansion] = STATE(1098),
    [sym_command_substitution] = STATE(1098),
    [sym_process_substitution] = STATE(1098),
    [sym_word] = ACTIONS(2227),
    [anon_sym_DQUOTE] = ACTIONS(992),
    [sym_raw_string] = ACTIONS(2227),
    [anon_sym_DOLLAR] = ACTIONS(994),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(996),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(998),
    [anon_sym_BQUOTE] = ACTIONS(1000),
    [anon_sym_LT_LPAREN] = ACTIONS(1002),
    [anon_sym_GT_LPAREN] = ACTIONS(1002),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2229),
  },
  [817] = {
    [aux_sym_concatenation_repeat1] = STATE(1100),
    [sym_file_descriptor] = ACTIONS(254),
    [sym_word] = ACTIONS(254),
    [sym__concat] = ACTIONS(1571),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_RPAREN] = ACTIONS(254),
    [anon_sym_PIPE_AMP] = ACTIONS(254),
    [anon_sym_AMP_AMP] = ACTIONS(254),
    [anon_sym_PIPE_PIPE] = ACTIONS(254),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(877),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(877),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(877),
  },
  [818] = {
    [sym_file_descriptor] = ACTIONS(1226),
    [sym_word] = ACTIONS(1226),
    [sym_variable_name] = ACTIONS(1226),
    [anon_sym_PIPE] = ACTIONS(2231),
    [anon_sym_RPAREN] = ACTIONS(1226),
    [anon_sym_PIPE_AMP] = ACTIONS(1226),
    [anon_sym_AMP_AMP] = ACTIONS(1226),
    [anon_sym_PIPE_PIPE] = ACTIONS(1226),
    [anon_sym_LT] = ACTIONS(2231),
    [anon_sym_GT] = ACTIONS(2231),
    [anon_sym_GT_GT] = ACTIONS(1226),
    [anon_sym_AMP_GT] = ACTIONS(2231),
    [anon_sym_AMP_GT_GT] = ACTIONS(1226),
    [anon_sym_LT_AMP] = ACTIONS(1226),
    [anon_sym_GT_AMP] = ACTIONS(1226),
    [anon_sym_DQUOTE] = ACTIONS(1226),
    [sym_raw_string] = ACTIONS(1226),
    [anon_sym_DOLLAR] = ACTIONS(2231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1226),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1226),
    [anon_sym_BQUOTE] = ACTIONS(1226),
    [anon_sym_LT_LPAREN] = ACTIONS(1226),
    [anon_sym_GT_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2231),
  },
  [819] = {
    [sym_concatenation] = STATE(364),
    [sym_string] = STATE(355),
    [sym_simple_expansion] = STATE(355),
    [sym_expansion] = STATE(355),
    [sym_command_substitution] = STATE(355),
    [sym_process_substitution] = STATE(355),
    [aux_sym_for_statement_repeat1] = STATE(648),
    [sym_word] = ACTIONS(692),
    [anon_sym_RPAREN] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(696),
    [sym_raw_string] = ACTIONS(692),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(700),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(702),
    [anon_sym_BQUOTE] = ACTIONS(704),
    [anon_sym_LT_LPAREN] = ACTIONS(706),
    [anon_sym_GT_LPAREN] = ACTIONS(706),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(708),
  },
  [820] = {
    [sym_file_descriptor] = ACTIONS(394),
    [sym_word] = ACTIONS(394),
    [sym__concat] = ACTIONS(394),
    [sym_variable_name] = ACTIONS(394),
    [anon_sym_PIPE] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(394),
    [anon_sym_PIPE_AMP] = ACTIONS(394),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_GT_GT] = ACTIONS(394),
    [anon_sym_AMP_GT] = ACTIONS(879),
    [anon_sym_AMP_GT_GT] = ACTIONS(394),
    [anon_sym_LT_AMP] = ACTIONS(394),
    [anon_sym_GT_AMP] = ACTIONS(394),
    [anon_sym_DQUOTE] = ACTIONS(394),
    [sym_raw_string] = ACTIONS(394),
    [anon_sym_DOLLAR] = ACTIONS(879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(394),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(394),
    [anon_sym_BQUOTE] = ACTIONS(394),
    [anon_sym_LT_LPAREN] = ACTIONS(394),
    [anon_sym_GT_LPAREN] = ACTIONS(394),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(879),
  },
  [821] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(252),
    [anon_sym_DQUOTE] = ACTIONS(2235),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [822] = {
    [sym_file_descriptor] = ACTIONS(412),
    [sym_word] = ACTIONS(412),
    [sym__concat] = ACTIONS(412),
    [sym_variable_name] = ACTIONS(412),
    [anon_sym_PIPE] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(412),
    [anon_sym_PIPE_AMP] = ACTIONS(412),
    [anon_sym_AMP_AMP] = ACTIONS(412),
    [anon_sym_PIPE_PIPE] = ACTIONS(412),
    [anon_sym_LT] = ACTIONS(424),
    [anon_sym_GT] = ACTIONS(424),
    [anon_sym_GT_GT] = ACTIONS(412),
    [anon_sym_AMP_GT] = ACTIONS(424),
    [anon_sym_AMP_GT_GT] = ACTIONS(412),
    [anon_sym_LT_AMP] = ACTIONS(412),
    [anon_sym_GT_AMP] = ACTIONS(412),
    [anon_sym_DQUOTE] = ACTIONS(412),
    [sym_raw_string] = ACTIONS(412),
    [anon_sym_DOLLAR] = ACTIONS(424),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(412),
    [anon_sym_BQUOTE] = ACTIONS(412),
    [anon_sym_LT_LPAREN] = ACTIONS(412),
    [anon_sym_GT_LPAREN] = ACTIONS(412),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(424),
  },
  [823] = {
    [sym_file_descriptor] = ACTIONS(416),
    [sym_word] = ACTIONS(416),
    [sym__concat] = ACTIONS(416),
    [sym_variable_name] = ACTIONS(416),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_RPAREN] = ACTIONS(416),
    [anon_sym_PIPE_AMP] = ACTIONS(416),
    [anon_sym_AMP_AMP] = ACTIONS(416),
    [anon_sym_PIPE_PIPE] = ACTIONS(416),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(416),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_AMP_GT_GT] = ACTIONS(416),
    [anon_sym_LT_AMP] = ACTIONS(416),
    [anon_sym_GT_AMP] = ACTIONS(416),
    [anon_sym_DQUOTE] = ACTIONS(416),
    [sym_raw_string] = ACTIONS(416),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(416),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(416),
    [anon_sym_BQUOTE] = ACTIONS(416),
    [anon_sym_LT_LPAREN] = ACTIONS(416),
    [anon_sym_GT_LPAREN] = ACTIONS(416),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(883),
  },
  [824] = {
    [sym_file_descriptor] = ACTIONS(420),
    [sym_word] = ACTIONS(420),
    [sym__concat] = ACTIONS(420),
    [sym_variable_name] = ACTIONS(420),
    [anon_sym_PIPE] = ACTIONS(885),
    [anon_sym_RPAREN] = ACTIONS(420),
    [anon_sym_PIPE_AMP] = ACTIONS(420),
    [anon_sym_AMP_AMP] = ACTIONS(420),
    [anon_sym_PIPE_PIPE] = ACTIONS(420),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(420),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(420),
    [anon_sym_LT_AMP] = ACTIONS(420),
    [anon_sym_GT_AMP] = ACTIONS(420),
    [anon_sym_DQUOTE] = ACTIONS(420),
    [sym_raw_string] = ACTIONS(420),
    [anon_sym_DOLLAR] = ACTIONS(885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(420),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(420),
    [anon_sym_BQUOTE] = ACTIONS(420),
    [anon_sym_LT_LPAREN] = ACTIONS(420),
    [anon_sym_GT_LPAREN] = ACTIONS(420),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(885),
  },
  [825] = {
    [sym_special_variable_name] = STATE(1104),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_EQ] = ACTIONS(412),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(138),
    [anon_sym_AT] = ACTIONS(138),
    [anon_sym_COLON] = ACTIONS(424),
    [anon_sym_COLON_QMARK] = ACTIONS(412),
    [anon_sym_COLON_DASH] = ACTIONS(412),
    [anon_sym_PERCENT] = ACTIONS(412),
    [anon_sym_SLASH] = ACTIONS(412),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [826] = {
    [anon_sym_RBRACE] = ACTIONS(2239),
    [anon_sym_EQ] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2243),
    [anon_sym_COLON] = ACTIONS(2245),
    [anon_sym_COLON_QMARK] = ACTIONS(2241),
    [anon_sym_COLON_DASH] = ACTIONS(2241),
    [anon_sym_PERCENT] = ACTIONS(2241),
    [anon_sym_SLASH] = ACTIONS(2241),
    [sym_comment] = ACTIONS(46),
  },
  [827] = {
    [anon_sym_RBRACE] = ACTIONS(2247),
    [anon_sym_EQ] = ACTIONS(2249),
    [anon_sym_LBRACK] = ACTIONS(2251),
    [anon_sym_COLON] = ACTIONS(2253),
    [anon_sym_COLON_QMARK] = ACTIONS(2249),
    [anon_sym_COLON_DASH] = ACTIONS(2249),
    [anon_sym_PERCENT] = ACTIONS(2249),
    [anon_sym_SLASH] = ACTIONS(2249),
    [sym_comment] = ACTIONS(46),
  },
  [828] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(2255),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [829] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(2255),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [830] = {
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_BQUOTE] = ACTIONS(2255),
    [sym_comment] = ACTIONS(46),
  },
  [831] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(2255),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [832] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(2257),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [833] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(2257),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [834] = {
    [aux_sym_concatenation_repeat1] = STATE(1100),
    [sym_file_descriptor] = ACTIONS(542),
    [sym_word] = ACTIONS(542),
    [sym__concat] = ACTIONS(1571),
    [sym_variable_name] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(542),
    [anon_sym_AMP_AMP] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(909),
    [anon_sym_GT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(542),
    [anon_sym_AMP_GT] = ACTIONS(909),
    [anon_sym_AMP_GT_GT] = ACTIONS(542),
    [anon_sym_LT_AMP] = ACTIONS(542),
    [anon_sym_GT_AMP] = ACTIONS(542),
    [anon_sym_DQUOTE] = ACTIONS(542),
    [sym_raw_string] = ACTIONS(542),
    [anon_sym_DOLLAR] = ACTIONS(909),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(542),
    [anon_sym_BQUOTE] = ACTIONS(542),
    [anon_sym_LT_LPAREN] = ACTIONS(542),
    [anon_sym_GT_LPAREN] = ACTIONS(542),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(909),
  },
  [835] = {
    [sym_concatenation] = STATE(408),
    [sym_string] = STATE(400),
    [sym_simple_expansion] = STATE(400),
    [sym_expansion] = STATE(400),
    [sym_command_substitution] = STATE(400),
    [sym_process_substitution] = STATE(400),
    [aux_sym_for_statement_repeat1] = STATE(692),
    [sym_word] = ACTIONS(744),
    [anon_sym_SEMI_SEMI] = ACTIONS(2259),
    [anon_sym_DQUOTE] = ACTIONS(1316),
    [sym_raw_string] = ACTIONS(1318),
    [anon_sym_DOLLAR] = ACTIONS(1320),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1322),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1324),
    [anon_sym_BQUOTE] = ACTIONS(1326),
    [anon_sym_LT_LPAREN] = ACTIONS(1328),
    [anon_sym_GT_LPAREN] = ACTIONS(1328),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1330),
    [anon_sym_SEMI] = ACTIONS(2259),
    [anon_sym_LF] = ACTIONS(2259),
    [anon_sym_AMP] = ACTIONS(2259),
  },
  [836] = {
    [anon_sym_PIPE] = ACTIONS(2261),
    [anon_sym_RPAREN] = ACTIONS(2263),
    [anon_sym_PIPE_AMP] = ACTIONS(2263),
    [anon_sym_AMP_AMP] = ACTIONS(2263),
    [anon_sym_PIPE_PIPE] = ACTIONS(2263),
    [anon_sym_BQUOTE] = ACTIONS(2263),
    [sym_comment] = ACTIONS(46),
  },
  [837] = {
    [sym__terminated_statement] = STATE(411),
    [sym_for_statement] = STATE(412),
    [sym_while_statement] = STATE(412),
    [sym_if_statement] = STATE(412),
    [sym_case_statement] = STATE(412),
    [sym_function_definition] = STATE(412),
    [sym_subshell] = STATE(412),
    [sym_pipeline] = STATE(412),
    [sym_list] = STATE(412),
    [sym_command] = STATE(412),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(413),
    [sym_declaration_command] = STATE(412),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(695),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_done] = ACTIONS(2265),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [838] = {
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_RPAREN] = ACTIONS(2269),
    [anon_sym_PIPE_AMP] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_PIPE_PIPE] = ACTIONS(2269),
    [anon_sym_BQUOTE] = ACTIONS(2269),
    [sym_comment] = ACTIONS(46),
  },
  [839] = {
    [anon_sym_fi] = ACTIONS(2271),
    [sym_comment] = ACTIONS(46),
  },
  [840] = {
    [sym__terminated_statement] = STATE(418),
    [sym_for_statement] = STATE(419),
    [sym_while_statement] = STATE(419),
    [sym_if_statement] = STATE(419),
    [sym_elif_clause] = STATE(420),
    [sym_else_clause] = STATE(1116),
    [sym_case_statement] = STATE(419),
    [sym_function_definition] = STATE(419),
    [sym_subshell] = STATE(419),
    [sym_pipeline] = STATE(419),
    [sym_list] = STATE(419),
    [sym_command] = STATE(419),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(422),
    [sym_declaration_command] = STATE(419),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(704),
    [aux_sym_if_statement_repeat1] = STATE(1117),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(2273),
    [anon_sym_elif] = ACTIONS(766),
    [anon_sym_else] = ACTIONS(768),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [841] = {
    [sym_elif_clause] = STATE(420),
    [sym_else_clause] = STATE(1116),
    [aux_sym_if_statement_repeat1] = STATE(706),
    [anon_sym_fi] = ACTIONS(2271),
    [anon_sym_elif] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1352),
    [sym_comment] = ACTIONS(46),
  },
  [842] = {
    [sym_case_item] = STATE(710),
    [sym_concatenation] = STATE(711),
    [sym_string] = STATE(707),
    [sym_simple_expansion] = STATE(707),
    [sym_expansion] = STATE(707),
    [sym_command_substitution] = STATE(707),
    [sym_process_substitution] = STATE(707),
    [aux_sym_case_statement_repeat1] = STATE(1119),
    [sym_word] = ACTIONS(1354),
    [anon_sym_esac] = ACTIONS(2275),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1354),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1358),
  },
  [843] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2277),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2277),
    [anon_sym_LF] = ACTIONS(2277),
    [anon_sym_AMP] = ACTIONS(2277),
  },
  [844] = {
    [sym_case_item] = STATE(710),
    [sym_concatenation] = STATE(711),
    [sym_string] = STATE(707),
    [sym_simple_expansion] = STATE(707),
    [sym_expansion] = STATE(707),
    [sym_command_substitution] = STATE(707),
    [sym_process_substitution] = STATE(707),
    [aux_sym_case_statement_repeat1] = STATE(1122),
    [sym_word] = ACTIONS(1354),
    [anon_sym_esac] = ACTIONS(2279),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1354),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1358),
  },
  [845] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2281),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2281),
    [anon_sym_LF] = ACTIONS(2281),
    [anon_sym_AMP] = ACTIONS(2281),
  },
  [846] = {
    [sym_compound_statement] = STATE(1124),
    [anon_sym_LBRACE] = ACTIONS(1024),
    [sym_comment] = ACTIONS(46),
  },
  [847] = {
    [sym_file_descriptor] = ACTIONS(1391),
    [anon_sym_PIPE] = ACTIONS(2283),
    [anon_sym_RPAREN] = ACTIONS(1391),
    [anon_sym_PIPE_AMP] = ACTIONS(1391),
    [anon_sym_AMP_AMP] = ACTIONS(1391),
    [anon_sym_PIPE_PIPE] = ACTIONS(1391),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_GT_GT] = ACTIONS(1391),
    [anon_sym_AMP_GT] = ACTIONS(2283),
    [anon_sym_AMP_GT_GT] = ACTIONS(1391),
    [anon_sym_LT_AMP] = ACTIONS(1391),
    [anon_sym_GT_AMP] = ACTIONS(1391),
    [anon_sym_BQUOTE] = ACTIONS(1391),
    [sym_comment] = ACTIONS(46),
  },
  [848] = {
    [sym__terminated_statement] = STATE(21),
    [sym_for_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_case_statement] = STATE(22),
    [sym_function_definition] = STATE(22),
    [sym_subshell] = STATE(22),
    [sym_pipeline] = STATE(22),
    [sym_list] = STATE(22),
    [sym_command] = STATE(22),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(24),
    [sym_declaration_command] = STATE(22),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(732),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_RBRACE] = ACTIONS(2285),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [849] = {
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_AMP_GT] = ACTIONS(2287),
    [anon_sym_AMP_GT_GT] = ACTIONS(2289),
    [anon_sym_LT_AMP] = ACTIONS(2289),
    [anon_sym_GT_AMP] = ACTIONS(2289),
    [sym_comment] = ACTIONS(46),
  },
  [850] = {
    [sym_concatenation] = STATE(1135),
    [sym_string] = STATE(1127),
    [sym_simple_expansion] = STATE(1127),
    [sym_expansion] = STATE(1127),
    [sym_command_substitution] = STATE(1127),
    [sym_process_substitution] = STATE(1127),
    [sym_word] = ACTIONS(2291),
    [anon_sym_DQUOTE] = ACTIONS(2293),
    [sym_raw_string] = ACTIONS(2291),
    [anon_sym_DOLLAR] = ACTIONS(2295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2299),
    [anon_sym_BQUOTE] = ACTIONS(2301),
    [anon_sym_LT_LPAREN] = ACTIONS(2303),
    [anon_sym_GT_LPAREN] = ACTIONS(2303),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2305),
  },
  [851] = {
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_RPAREN] = ACTIONS(2309),
    [anon_sym_PIPE_AMP] = ACTIONS(2309),
    [anon_sym_AMP_AMP] = ACTIONS(2309),
    [anon_sym_PIPE_PIPE] = ACTIONS(2309),
    [anon_sym_BQUOTE] = ACTIONS(2309),
    [sym_comment] = ACTIONS(46),
  },
  [852] = {
    [anon_sym_PIPE] = ACTIONS(2311),
    [anon_sym_RPAREN] = ACTIONS(2313),
    [anon_sym_PIPE_AMP] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [sym_comment] = ACTIONS(46),
  },
  [853] = {
    [sym_file_descriptor] = ACTIONS(546),
    [sym_word] = ACTIONS(546),
    [sym_variable_name] = ACTIONS(546),
    [anon_sym_for] = ACTIONS(548),
    [anon_sym_while] = ACTIONS(548),
    [anon_sym_if] = ACTIONS(548),
    [anon_sym_case] = ACTIONS(548),
    [anon_sym_RPAREN] = ACTIONS(2315),
    [anon_sym_function] = ACTIONS(548),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeset] = ACTIONS(548),
    [anon_sym_export] = ACTIONS(548),
    [anon_sym_readonly] = ACTIONS(548),
    [anon_sym_local] = ACTIONS(548),
    [anon_sym_LT] = ACTIONS(548),
    [anon_sym_GT] = ACTIONS(548),
    [anon_sym_GT_GT] = ACTIONS(546),
    [anon_sym_AMP_GT] = ACTIONS(548),
    [anon_sym_AMP_GT_GT] = ACTIONS(546),
    [anon_sym_LT_AMP] = ACTIONS(546),
    [anon_sym_GT_AMP] = ACTIONS(546),
    [anon_sym_DQUOTE] = ACTIONS(546),
    [sym_raw_string] = ACTIONS(546),
    [anon_sym_DOLLAR] = ACTIONS(548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(546),
    [anon_sym_LT_LPAREN] = ACTIONS(546),
    [anon_sym_GT_LPAREN] = ACTIONS(546),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(550),
  },
  [854] = {
    [aux_sym_concatenation_repeat1] = STATE(1138),
    [sym_word] = ACTIONS(686),
    [sym__concat] = ACTIONS(2317),
    [sym_variable_name] = ACTIONS(686),
    [anon_sym_PIPE] = ACTIONS(1573),
    [anon_sym_RPAREN] = ACTIONS(686),
    [anon_sym_PIPE_AMP] = ACTIONS(686),
    [anon_sym_AMP_AMP] = ACTIONS(686),
    [anon_sym_PIPE_PIPE] = ACTIONS(686),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1573),
  },
  [855] = {
    [sym_word] = ACTIONS(686),
    [sym_variable_name] = ACTIONS(686),
    [anon_sym_PIPE] = ACTIONS(1573),
    [anon_sym_RPAREN] = ACTIONS(686),
    [anon_sym_PIPE_AMP] = ACTIONS(686),
    [anon_sym_AMP_AMP] = ACTIONS(686),
    [anon_sym_PIPE_PIPE] = ACTIONS(686),
    [anon_sym_BQUOTE] = ACTIONS(686),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1573),
  },
  [856] = {
    [sym_concatenation] = STATE(364),
    [sym_string] = STATE(355),
    [sym_simple_expansion] = STATE(355),
    [sym_expansion] = STATE(355),
    [sym_command_substitution] = STATE(355),
    [sym_process_substitution] = STATE(355),
    [aux_sym_for_statement_repeat1] = STATE(1140),
    [sym_word] = ACTIONS(692),
    [anon_sym_RPAREN] = ACTIONS(2319),
    [anon_sym_DQUOTE] = ACTIONS(696),
    [sym_raw_string] = ACTIONS(692),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(700),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(702),
    [anon_sym_BQUOTE] = ACTIONS(704),
    [anon_sym_LT_LPAREN] = ACTIONS(706),
    [anon_sym_GT_LPAREN] = ACTIONS(706),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(708),
  },
  [857] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(1142),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [858] = {
    [sym_special_variable_name] = STATE(1145),
    [anon_sym_DOLLAR] = ACTIONS(2323),
    [anon_sym_POUND] = ACTIONS(2323),
    [anon_sym_AT] = ACTIONS(2323),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2325),
    [anon_sym_STAR] = ACTIONS(2323),
    [anon_sym_QMARK] = ACTIONS(2323),
    [anon_sym_DASH] = ACTIONS(2323),
    [anon_sym_BANG] = ACTIONS(2323),
    [anon_sym_0] = ACTIONS(2327),
    [anon_sym__] = ACTIONS(2327),
  },
  [859] = {
    [sym_special_variable_name] = STATE(1148),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(2329),
    [anon_sym_AT] = ACTIONS(138),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2331),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [860] = {
    [sym_for_statement] = STATE(1149),
    [sym_while_statement] = STATE(1149),
    [sym_if_statement] = STATE(1149),
    [sym_case_statement] = STATE(1149),
    [sym_function_definition] = STATE(1149),
    [sym_subshell] = STATE(1149),
    [sym_pipeline] = STATE(1149),
    [sym_list] = STATE(1149),
    [sym_command] = STATE(1149),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(1150),
    [sym_declaration_command] = STATE(1149),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [861] = {
    [sym_for_statement] = STATE(1151),
    [sym_while_statement] = STATE(1151),
    [sym_if_statement] = STATE(1151),
    [sym_case_statement] = STATE(1151),
    [sym_function_definition] = STATE(1151),
    [sym_subshell] = STATE(1151),
    [sym_pipeline] = STATE(1151),
    [sym_list] = STATE(1151),
    [sym_command] = STATE(1151),
    [sym_command_name] = STATE(118),
    [sym_variable_assignment] = STATE(1152),
    [sym_declaration_command] = STATE(1151),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(112),
    [sym_simple_expansion] = STATE(112),
    [sym_expansion] = STATE(112),
    [sym_command_substitution] = STATE(112),
    [sym_process_substitution] = STATE(112),
    [aux_sym_command_repeat1] = STATE(121),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(178),
    [sym_variable_name] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(184),
    [anon_sym_typeset] = ACTIONS(184),
    [anon_sym_export] = ACTIONS(184),
    [anon_sym_readonly] = ACTIONS(184),
    [anon_sym_local] = ACTIONS(184),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(178),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(186),
  },
  [862] = {
    [sym_for_statement] = STATE(1153),
    [sym_while_statement] = STATE(1153),
    [sym_if_statement] = STATE(1153),
    [sym_case_statement] = STATE(1153),
    [sym_function_definition] = STATE(1153),
    [sym_subshell] = STATE(1153),
    [sym_pipeline] = STATE(1153),
    [sym_list] = STATE(1153),
    [sym_command] = STATE(1153),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(1154),
    [sym_declaration_command] = STATE(1153),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [863] = {
    [aux_sym_concatenation_repeat1] = STATE(1155),
    [sym_word] = ACTIONS(722),
    [sym__concat] = ACTIONS(2317),
    [sym_variable_name] = ACTIONS(722),
    [anon_sym_PIPE] = ACTIONS(1589),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_PIPE_AMP] = ACTIONS(722),
    [anon_sym_AMP_AMP] = ACTIONS(722),
    [anon_sym_PIPE_PIPE] = ACTIONS(722),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1589),
  },
  [864] = {
    [sym_file_descriptor] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(2145),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_GT] = ACTIONS(2145),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(2145),
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(2145),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(2145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2145),
  },
  [865] = {
    [anon_sym_AT] = ACTIONS(2333),
    [sym_comment] = ACTIONS(46),
  },
  [866] = {
    [sym_file_descriptor] = ACTIONS(1538),
    [sym_word] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(2149),
    [anon_sym_RPAREN] = ACTIONS(1538),
    [anon_sym_PIPE_AMP] = ACTIONS(1538),
    [anon_sym_AMP_AMP] = ACTIONS(1538),
    [anon_sym_PIPE_PIPE] = ACTIONS(1538),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_GT] = ACTIONS(2149),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_AMP_GT] = ACTIONS(2149),
    [anon_sym_AMP_GT_GT] = ACTIONS(1538),
    [anon_sym_LT_AMP] = ACTIONS(1538),
    [anon_sym_GT_AMP] = ACTIONS(1538),
    [anon_sym_LT_LT] = ACTIONS(2149),
    [anon_sym_LT_LT_DASH] = ACTIONS(1538),
    [anon_sym_DQUOTE] = ACTIONS(1538),
    [sym_raw_string] = ACTIONS(1538),
    [anon_sym_DOLLAR] = ACTIONS(2149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1538),
    [anon_sym_BQUOTE] = ACTIONS(1538),
    [anon_sym_LT_LPAREN] = ACTIONS(1538),
    [anon_sym_GT_LPAREN] = ACTIONS(1538),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2149),
  },
  [867] = {
    [anon_sym_AT] = ACTIONS(2335),
    [sym_comment] = ACTIONS(46),
  },
  [868] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(46),
  },
  [869] = {
    [sym_file_descriptor] = ACTIONS(1548),
    [sym_word] = ACTIONS(1548),
    [sym__concat] = ACTIONS(1548),
    [anon_sym_PIPE] = ACTIONS(2157),
    [anon_sym_RPAREN] = ACTIONS(1548),
    [anon_sym_PIPE_AMP] = ACTIONS(1548),
    [anon_sym_AMP_AMP] = ACTIONS(1548),
    [anon_sym_PIPE_PIPE] = ACTIONS(1548),
    [anon_sym_LT] = ACTIONS(2157),
    [anon_sym_GT] = ACTIONS(2157),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_AMP_GT] = ACTIONS(2157),
    [anon_sym_AMP_GT_GT] = ACTIONS(1548),
    [anon_sym_LT_AMP] = ACTIONS(1548),
    [anon_sym_GT_AMP] = ACTIONS(1548),
    [anon_sym_LT_LT] = ACTIONS(2157),
    [anon_sym_LT_LT_DASH] = ACTIONS(1548),
    [anon_sym_DQUOTE] = ACTIONS(1548),
    [sym_raw_string] = ACTIONS(1548),
    [anon_sym_DOLLAR] = ACTIONS(2157),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1548),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(1548),
    [anon_sym_LT_LPAREN] = ACTIONS(1548),
    [anon_sym_GT_LPAREN] = ACTIONS(1548),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2157),
  },
  [870] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(2341),
    [anon_sym_RBRACE] = ACTIONS(2343),
    [sym_comment] = ACTIONS(46),
  },
  [871] = {
    [sym__concat] = ACTIONS(2345),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(46),
  },
  [872] = {
    [anon_sym_RBRACK] = ACTIONS(2345),
    [sym_comment] = ACTIONS(46),
  },
  [873] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(2347),
    [anon_sym_RBRACE] = ACTIONS(2349),
    [sym_comment] = ACTIONS(46),
  },
  [874] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(2351),
    [anon_sym_RBRACE] = ACTIONS(2353),
    [sym_comment] = ACTIONS(46),
  },
  [875] = {
    [sym__concat] = ACTIONS(2355),
    [anon_sym_RBRACE] = ACTIONS(2349),
    [sym_comment] = ACTIONS(46),
  },
  [876] = {
    [anon_sym_RBRACK] = ACTIONS(2355),
    [sym_comment] = ACTIONS(46),
  },
  [877] = {
    [sym_file_redirect] = STATE(1168),
    [sym_file_descriptor] = ACTIONS(1611),
    [anon_sym_PIPE] = ACTIONS(2357),
    [anon_sym_RPAREN] = ACTIONS(2359),
    [anon_sym_PIPE_AMP] = ACTIONS(2359),
    [anon_sym_AMP_AMP] = ACTIONS(2359),
    [anon_sym_PIPE_PIPE] = ACTIONS(2359),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT] = ACTIONS(1617),
    [anon_sym_AMP_GT_GT] = ACTIONS(1619),
    [anon_sym_LT_AMP] = ACTIONS(1619),
    [anon_sym_GT_AMP] = ACTIONS(1619),
    [sym_comment] = ACTIONS(46),
  },
  [878] = {
    [aux_sym_concatenation_repeat1] = STATE(882),
    [sym_file_descriptor] = ACTIONS(667),
    [sym__concat] = ACTIONS(1696),
    [anon_sym_PIPE] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_PIPE_AMP] = ACTIONS(667),
    [anon_sym_AMP_AMP] = ACTIONS(667),
    [anon_sym_PIPE_PIPE] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(669),
    [anon_sym_GT] = ACTIONS(669),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(669),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_LT_LT] = ACTIONS(669),
    [anon_sym_LT_LT_DASH] = ACTIONS(667),
    [sym_comment] = ACTIONS(46),
  },
  [879] = {
    [aux_sym_concatenation_repeat1] = STATE(897),
    [sym_file_descriptor] = ACTIONS(671),
    [sym__concat] = ACTIONS(1696),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(671),
    [anon_sym_PIPE_AMP] = ACTIONS(671),
    [anon_sym_AMP_AMP] = ACTIONS(671),
    [anon_sym_PIPE_PIPE] = ACTIONS(671),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(671),
    [anon_sym_AMP_GT] = ACTIONS(673),
    [anon_sym_AMP_GT_GT] = ACTIONS(671),
    [anon_sym_LT_AMP] = ACTIONS(671),
    [anon_sym_GT_AMP] = ACTIONS(671),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_LT_LT_DASH] = ACTIONS(671),
    [sym_comment] = ACTIONS(46),
  },
  [880] = {
    [sym_file_descriptor] = ACTIONS(667),
    [anon_sym_PIPE] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_PIPE_AMP] = ACTIONS(667),
    [anon_sym_AMP_AMP] = ACTIONS(667),
    [anon_sym_PIPE_PIPE] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(669),
    [anon_sym_GT] = ACTIONS(669),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(669),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_LT_LT] = ACTIONS(669),
    [anon_sym_LT_LT_DASH] = ACTIONS(667),
    [anon_sym_BQUOTE] = ACTIONS(667),
    [sym_comment] = ACTIONS(46),
  },
  [881] = {
    [sym_string] = STATE(1169),
    [sym_simple_expansion] = STATE(1169),
    [sym_expansion] = STATE(1169),
    [sym_command_substitution] = STATE(1169),
    [sym_process_substitution] = STATE(1169),
    [sym_word] = ACTIONS(2361),
    [anon_sym_DQUOTE] = ACTIONS(1078),
    [sym_raw_string] = ACTIONS(2361),
    [anon_sym_DOLLAR] = ACTIONS(1080),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1084),
    [anon_sym_BQUOTE] = ACTIONS(1086),
    [anon_sym_LT_LPAREN] = ACTIONS(1088),
    [anon_sym_GT_LPAREN] = ACTIONS(1088),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2363),
  },
  [882] = {
    [aux_sym_concatenation_repeat1] = STATE(1171),
    [sym_file_descriptor] = ACTIONS(254),
    [sym__concat] = ACTIONS(1696),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_RPAREN] = ACTIONS(254),
    [anon_sym_PIPE_AMP] = ACTIONS(254),
    [anon_sym_AMP_AMP] = ACTIONS(254),
    [anon_sym_PIPE_PIPE] = ACTIONS(254),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(877),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_LT_LT_DASH] = ACTIONS(254),
    [sym_comment] = ACTIONS(46),
  },
  [883] = {
    [sym_file_descriptor] = ACTIONS(394),
    [sym__concat] = ACTIONS(394),
    [anon_sym_PIPE] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(394),
    [anon_sym_PIPE_AMP] = ACTIONS(394),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_GT_GT] = ACTIONS(394),
    [anon_sym_AMP_GT] = ACTIONS(879),
    [anon_sym_AMP_GT_GT] = ACTIONS(394),
    [anon_sym_LT_AMP] = ACTIONS(394),
    [anon_sym_GT_AMP] = ACTIONS(394),
    [anon_sym_LT_LT] = ACTIONS(879),
    [anon_sym_LT_LT_DASH] = ACTIONS(394),
    [anon_sym_BQUOTE] = ACTIONS(394),
    [sym_comment] = ACTIONS(46),
  },
  [884] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(252),
    [anon_sym_DQUOTE] = ACTIONS(2365),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [885] = {
    [sym_file_descriptor] = ACTIONS(412),
    [sym__concat] = ACTIONS(412),
    [anon_sym_PIPE] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(412),
    [anon_sym_PIPE_AMP] = ACTIONS(412),
    [anon_sym_AMP_AMP] = ACTIONS(412),
    [anon_sym_PIPE_PIPE] = ACTIONS(412),
    [anon_sym_LT] = ACTIONS(424),
    [anon_sym_GT] = ACTIONS(424),
    [anon_sym_GT_GT] = ACTIONS(412),
    [anon_sym_AMP_GT] = ACTIONS(424),
    [anon_sym_AMP_GT_GT] = ACTIONS(412),
    [anon_sym_LT_AMP] = ACTIONS(412),
    [anon_sym_GT_AMP] = ACTIONS(412),
    [anon_sym_LT_LT] = ACTIONS(424),
    [anon_sym_LT_LT_DASH] = ACTIONS(412),
    [anon_sym_BQUOTE] = ACTIONS(412),
    [sym_comment] = ACTIONS(46),
  },
  [886] = {
    [sym_file_descriptor] = ACTIONS(416),
    [sym__concat] = ACTIONS(416),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_RPAREN] = ACTIONS(416),
    [anon_sym_PIPE_AMP] = ACTIONS(416),
    [anon_sym_AMP_AMP] = ACTIONS(416),
    [anon_sym_PIPE_PIPE] = ACTIONS(416),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(416),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_AMP_GT_GT] = ACTIONS(416),
    [anon_sym_LT_AMP] = ACTIONS(416),
    [anon_sym_GT_AMP] = ACTIONS(416),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_LT_LT_DASH] = ACTIONS(416),
    [anon_sym_BQUOTE] = ACTIONS(416),
    [sym_comment] = ACTIONS(46),
  },
  [887] = {
    [sym_file_descriptor] = ACTIONS(420),
    [sym__concat] = ACTIONS(420),
    [anon_sym_PIPE] = ACTIONS(885),
    [anon_sym_RPAREN] = ACTIONS(420),
    [anon_sym_PIPE_AMP] = ACTIONS(420),
    [anon_sym_AMP_AMP] = ACTIONS(420),
    [anon_sym_PIPE_PIPE] = ACTIONS(420),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(420),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(420),
    [anon_sym_LT_AMP] = ACTIONS(420),
    [anon_sym_GT_AMP] = ACTIONS(420),
    [anon_sym_LT_LT] = ACTIONS(885),
    [anon_sym_LT_LT_DASH] = ACTIONS(420),
    [anon_sym_BQUOTE] = ACTIONS(420),
    [sym_comment] = ACTIONS(46),
  },
  [888] = {
    [sym_special_variable_name] = STATE(1174),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_EQ] = ACTIONS(412),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(138),
    [anon_sym_AT] = ACTIONS(138),
    [anon_sym_COLON] = ACTIONS(424),
    [anon_sym_COLON_QMARK] = ACTIONS(412),
    [anon_sym_COLON_DASH] = ACTIONS(412),
    [anon_sym_PERCENT] = ACTIONS(412),
    [anon_sym_SLASH] = ACTIONS(412),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [889] = {
    [anon_sym_RBRACE] = ACTIONS(2369),
    [anon_sym_EQ] = ACTIONS(2371),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2375),
    [anon_sym_COLON_QMARK] = ACTIONS(2371),
    [anon_sym_COLON_DASH] = ACTIONS(2371),
    [anon_sym_PERCENT] = ACTIONS(2371),
    [anon_sym_SLASH] = ACTIONS(2371),
    [sym_comment] = ACTIONS(46),
  },
  [890] = {
    [anon_sym_RBRACE] = ACTIONS(2377),
    [anon_sym_EQ] = ACTIONS(2379),
    [anon_sym_LBRACK] = ACTIONS(2381),
    [anon_sym_COLON] = ACTIONS(2383),
    [anon_sym_COLON_QMARK] = ACTIONS(2379),
    [anon_sym_COLON_DASH] = ACTIONS(2379),
    [anon_sym_PERCENT] = ACTIONS(2379),
    [anon_sym_SLASH] = ACTIONS(2379),
    [sym_comment] = ACTIONS(46),
  },
  [891] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(2385),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [892] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(2385),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [893] = {
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_BQUOTE] = ACTIONS(2385),
    [sym_comment] = ACTIONS(46),
  },
  [894] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(2385),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [895] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(2387),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [896] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(2387),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [897] = {
    [aux_sym_concatenation_repeat1] = STATE(1171),
    [sym_file_descriptor] = ACTIONS(542),
    [sym__concat] = ACTIONS(1696),
    [anon_sym_PIPE] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(542),
    [anon_sym_AMP_AMP] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(909),
    [anon_sym_GT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(542),
    [anon_sym_AMP_GT] = ACTIONS(909),
    [anon_sym_AMP_GT_GT] = ACTIONS(542),
    [anon_sym_LT_AMP] = ACTIONS(542),
    [anon_sym_GT_AMP] = ACTIONS(542),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_LT_LT_DASH] = ACTIONS(542),
    [sym_comment] = ACTIONS(46),
  },
  [898] = {
    [sym_file_descriptor] = ACTIONS(1837),
    [anon_sym_PIPE] = ACTIONS(2389),
    [anon_sym_RPAREN] = ACTIONS(1837),
    [anon_sym_PIPE_AMP] = ACTIONS(1837),
    [anon_sym_AMP_AMP] = ACTIONS(1837),
    [anon_sym_PIPE_PIPE] = ACTIONS(1837),
    [anon_sym_LT] = ACTIONS(2389),
    [anon_sym_GT] = ACTIONS(2389),
    [anon_sym_GT_GT] = ACTIONS(1837),
    [anon_sym_AMP_GT] = ACTIONS(2389),
    [anon_sym_AMP_GT_GT] = ACTIONS(1837),
    [anon_sym_LT_AMP] = ACTIONS(1837),
    [anon_sym_GT_AMP] = ACTIONS(1837),
    [anon_sym_LT_LT] = ACTIONS(2389),
    [anon_sym_LT_LT_DASH] = ACTIONS(1837),
    [anon_sym_BQUOTE] = ACTIONS(1837),
    [sym_comment] = ACTIONS(46),
  },
  [899] = {
    [sym_simple_expansion] = STATE(617),
    [sym_expansion] = STATE(617),
    [aux_sym_heredoc_repeat1] = STATE(936),
    [sym__heredoc_middle] = ACTIONS(1156),
    [sym__heredoc_end] = ACTIONS(2391),
    [anon_sym_DOLLAR] = ACTIONS(1160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1162),
    [sym_comment] = ACTIONS(46),
  },
  [900] = {
    [sym_file_redirect] = STATE(304),
    [sym_heredoc_redirect] = STATE(304),
    [aux_sym_command_repeat2] = STATE(576),
    [sym_file_descriptor] = ACTIONS(492),
    [anon_sym_PIPE] = ACTIONS(2393),
    [anon_sym_RPAREN] = ACTIONS(2395),
    [anon_sym_PIPE_AMP] = ACTIONS(2395),
    [anon_sym_AMP_AMP] = ACTIONS(2395),
    [anon_sym_PIPE_PIPE] = ACTIONS(2395),
    [anon_sym_LT] = ACTIONS(500),
    [anon_sym_GT] = ACTIONS(500),
    [anon_sym_GT_GT] = ACTIONS(502),
    [anon_sym_AMP_GT] = ACTIONS(500),
    [anon_sym_AMP_GT_GT] = ACTIONS(502),
    [anon_sym_LT_AMP] = ACTIONS(502),
    [anon_sym_GT_AMP] = ACTIONS(502),
    [anon_sym_LT_LT] = ACTIONS(504),
    [anon_sym_LT_LT_DASH] = ACTIONS(506),
    [sym_comment] = ACTIONS(46),
  },
  [901] = {
    [aux_sym_concatenation_repeat1] = STATE(1184),
    [sym_file_descriptor] = ACTIONS(254),
    [sym_word] = ACTIONS(254),
    [sym__concat] = ACTIONS(1571),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_PIPE_AMP] = ACTIONS(254),
    [anon_sym_AMP_AMP] = ACTIONS(254),
    [anon_sym_PIPE_PIPE] = ACTIONS(254),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(877),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(877),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(877),
  },
  [902] = {
    [aux_sym_concatenation_repeat1] = STATE(1184),
    [sym_file_descriptor] = ACTIONS(542),
    [sym_word] = ACTIONS(542),
    [sym__concat] = ACTIONS(1571),
    [sym_variable_name] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(909),
    [anon_sym_PIPE_AMP] = ACTIONS(542),
    [anon_sym_AMP_AMP] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(909),
    [anon_sym_GT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(542),
    [anon_sym_AMP_GT] = ACTIONS(909),
    [anon_sym_AMP_GT_GT] = ACTIONS(542),
    [anon_sym_LT_AMP] = ACTIONS(542),
    [anon_sym_GT_AMP] = ACTIONS(542),
    [anon_sym_DQUOTE] = ACTIONS(542),
    [sym_raw_string] = ACTIONS(542),
    [anon_sym_DOLLAR] = ACTIONS(909),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(542),
    [anon_sym_BQUOTE] = ACTIONS(542),
    [anon_sym_LT_LPAREN] = ACTIONS(542),
    [anon_sym_GT_LPAREN] = ACTIONS(542),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(909),
  },
  [903] = {
    [sym_compound_statement] = STATE(1185),
    [anon_sym_LBRACE] = ACTIONS(1024),
    [sym_comment] = ACTIONS(46),
  },
  [904] = {
    [anon_sym_LT] = ACTIONS(2397),
    [anon_sym_GT] = ACTIONS(2397),
    [anon_sym_GT_GT] = ACTIONS(2399),
    [anon_sym_AMP_GT] = ACTIONS(2397),
    [anon_sym_AMP_GT_GT] = ACTIONS(2399),
    [anon_sym_LT_AMP] = ACTIONS(2399),
    [anon_sym_GT_AMP] = ACTIONS(2399),
    [sym_comment] = ACTIONS(46),
  },
  [905] = {
    [sym_concatenation] = STATE(1135),
    [sym_string] = STATE(1187),
    [sym_simple_expansion] = STATE(1187),
    [sym_expansion] = STATE(1187),
    [sym_command_substitution] = STATE(1187),
    [sym_process_substitution] = STATE(1187),
    [sym_word] = ACTIONS(2401),
    [anon_sym_DQUOTE] = ACTIONS(2293),
    [sym_raw_string] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(2295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2299),
    [anon_sym_BQUOTE] = ACTIONS(2301),
    [anon_sym_LT_LPAREN] = ACTIONS(2303),
    [anon_sym_GT_LPAREN] = ACTIONS(2303),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2403),
  },
  [906] = {
    [aux_sym_concatenation_repeat1] = STATE(1189),
    [sym_word] = ACTIONS(686),
    [sym__concat] = ACTIONS(2317),
    [sym_variable_name] = ACTIONS(686),
    [anon_sym_PIPE] = ACTIONS(1573),
    [anon_sym_PIPE_AMP] = ACTIONS(686),
    [anon_sym_AMP_AMP] = ACTIONS(686),
    [anon_sym_PIPE_PIPE] = ACTIONS(686),
    [anon_sym_BQUOTE] = ACTIONS(686),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1573),
  },
  [907] = {
    [aux_sym_concatenation_repeat1] = STATE(1190),
    [sym_word] = ACTIONS(722),
    [sym__concat] = ACTIONS(2317),
    [sym_variable_name] = ACTIONS(722),
    [anon_sym_PIPE] = ACTIONS(1589),
    [anon_sym_PIPE_AMP] = ACTIONS(722),
    [anon_sym_AMP_AMP] = ACTIONS(722),
    [anon_sym_PIPE_PIPE] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(722),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1589),
  },
  [908] = {
    [sym_file_redirect] = STATE(1168),
    [sym_file_descriptor] = ACTIONS(1767),
    [anon_sym_PIPE] = ACTIONS(2357),
    [anon_sym_PIPE_AMP] = ACTIONS(2359),
    [anon_sym_AMP_AMP] = ACTIONS(2359),
    [anon_sym_PIPE_PIPE] = ACTIONS(2359),
    [anon_sym_LT] = ACTIONS(1769),
    [anon_sym_GT] = ACTIONS(1769),
    [anon_sym_GT_GT] = ACTIONS(1771),
    [anon_sym_AMP_GT] = ACTIONS(1769),
    [anon_sym_AMP_GT_GT] = ACTIONS(1771),
    [anon_sym_LT_AMP] = ACTIONS(1771),
    [anon_sym_GT_AMP] = ACTIONS(1771),
    [anon_sym_BQUOTE] = ACTIONS(2359),
    [sym_comment] = ACTIONS(46),
  },
  [909] = {
    [aux_sym_concatenation_repeat1] = STATE(911),
    [sym_file_descriptor] = ACTIONS(667),
    [sym__concat] = ACTIONS(1696),
    [anon_sym_PIPE] = ACTIONS(669),
    [anon_sym_PIPE_AMP] = ACTIONS(667),
    [anon_sym_AMP_AMP] = ACTIONS(667),
    [anon_sym_PIPE_PIPE] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(669),
    [anon_sym_GT] = ACTIONS(669),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(669),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_LT_LT] = ACTIONS(669),
    [anon_sym_LT_LT_DASH] = ACTIONS(667),
    [anon_sym_BQUOTE] = ACTIONS(667),
    [sym_comment] = ACTIONS(46),
  },
  [910] = {
    [aux_sym_concatenation_repeat1] = STATE(912),
    [sym_file_descriptor] = ACTIONS(671),
    [sym__concat] = ACTIONS(1696),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_PIPE_AMP] = ACTIONS(671),
    [anon_sym_AMP_AMP] = ACTIONS(671),
    [anon_sym_PIPE_PIPE] = ACTIONS(671),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(671),
    [anon_sym_AMP_GT] = ACTIONS(673),
    [anon_sym_AMP_GT_GT] = ACTIONS(671),
    [anon_sym_LT_AMP] = ACTIONS(671),
    [anon_sym_GT_AMP] = ACTIONS(671),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_LT_LT_DASH] = ACTIONS(671),
    [anon_sym_BQUOTE] = ACTIONS(671),
    [sym_comment] = ACTIONS(46),
  },
  [911] = {
    [aux_sym_concatenation_repeat1] = STATE(1191),
    [sym_file_descriptor] = ACTIONS(254),
    [sym__concat] = ACTIONS(1696),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_PIPE_AMP] = ACTIONS(254),
    [anon_sym_AMP_AMP] = ACTIONS(254),
    [anon_sym_PIPE_PIPE] = ACTIONS(254),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(877),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_LT_LT_DASH] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [sym_comment] = ACTIONS(46),
  },
  [912] = {
    [aux_sym_concatenation_repeat1] = STATE(1191),
    [sym_file_descriptor] = ACTIONS(542),
    [sym__concat] = ACTIONS(1696),
    [anon_sym_PIPE] = ACTIONS(909),
    [anon_sym_PIPE_AMP] = ACTIONS(542),
    [anon_sym_AMP_AMP] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(909),
    [anon_sym_GT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(542),
    [anon_sym_AMP_GT] = ACTIONS(909),
    [anon_sym_AMP_GT_GT] = ACTIONS(542),
    [anon_sym_LT_AMP] = ACTIONS(542),
    [anon_sym_GT_AMP] = ACTIONS(542),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_LT_LT_DASH] = ACTIONS(542),
    [anon_sym_BQUOTE] = ACTIONS(542),
    [sym_comment] = ACTIONS(46),
  },
  [913] = {
    [sym_file_redirect] = STATE(304),
    [sym_heredoc_redirect] = STATE(304),
    [aux_sym_command_repeat2] = STATE(594),
    [sym_file_descriptor] = ACTIONS(526),
    [anon_sym_PIPE] = ACTIONS(2393),
    [anon_sym_PIPE_AMP] = ACTIONS(2395),
    [anon_sym_AMP_AMP] = ACTIONS(2395),
    [anon_sym_PIPE_PIPE] = ACTIONS(2395),
    [anon_sym_LT] = ACTIONS(530),
    [anon_sym_GT] = ACTIONS(530),
    [anon_sym_GT_GT] = ACTIONS(532),
    [anon_sym_AMP_GT] = ACTIONS(530),
    [anon_sym_AMP_GT_GT] = ACTIONS(532),
    [anon_sym_LT_AMP] = ACTIONS(532),
    [anon_sym_GT_AMP] = ACTIONS(532),
    [anon_sym_LT_LT] = ACTIONS(504),
    [anon_sym_LT_LT_DASH] = ACTIONS(506),
    [anon_sym_BQUOTE] = ACTIONS(2395),
    [sym_comment] = ACTIONS(46),
  },
  [914] = {
    [anon_sym_PIPE] = ACTIONS(2405),
    [anon_sym_RPAREN] = ACTIONS(2405),
    [anon_sym_SEMI_SEMI] = ACTIONS(2405),
    [anon_sym_PIPE_AMP] = ACTIONS(2405),
    [anon_sym_AMP_AMP] = ACTIONS(2405),
    [anon_sym_PIPE_PIPE] = ACTIONS(2405),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2405),
    [anon_sym_LF] = ACTIONS(2405),
    [anon_sym_AMP] = ACTIONS(2405),
  },
  [915] = {
    [sym_file_descriptor] = ACTIONS(675),
    [sym__concat] = ACTIONS(675),
    [anon_sym_PIPE] = ACTIONS(677),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_SEMI_SEMI] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(677),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(677),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(677),
    [anon_sym_LT_LT_DASH] = ACTIONS(677),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(677),
  },
  [916] = {
    [sym_file_descriptor] = ACTIONS(679),
    [sym__concat] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_RPAREN] = ACTIONS(681),
    [anon_sym_SEMI_SEMI] = ACTIONS(681),
    [anon_sym_PIPE_AMP] = ACTIONS(681),
    [anon_sym_AMP_AMP] = ACTIONS(681),
    [anon_sym_PIPE_PIPE] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(681),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(681),
    [anon_sym_LT_LT_DASH] = ACTIONS(681),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(681),
    [anon_sym_AMP] = ACTIONS(681),
  },
  [917] = {
    [aux_sym_concatenation_repeat1] = STATE(917),
    [sym_file_descriptor] = ACTIONS(675),
    [sym__concat] = ACTIONS(2407),
    [anon_sym_PIPE] = ACTIONS(677),
    [anon_sym_SEMI_SEMI] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(677),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(677),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(677),
    [anon_sym_LT_LT_DASH] = ACTIONS(677),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(677),
  },
  [918] = {
    [sym_file_descriptor] = ACTIONS(931),
    [sym__concat] = ACTIONS(931),
    [anon_sym_PIPE] = ACTIONS(933),
    [anon_sym_RPAREN] = ACTIONS(933),
    [anon_sym_SEMI_SEMI] = ACTIONS(933),
    [anon_sym_PIPE_AMP] = ACTIONS(933),
    [anon_sym_AMP_AMP] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(933),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(933),
    [anon_sym_AMP_GT] = ACTIONS(933),
    [anon_sym_AMP_GT_GT] = ACTIONS(933),
    [anon_sym_LT_AMP] = ACTIONS(933),
    [anon_sym_GT_AMP] = ACTIONS(933),
    [anon_sym_LT_LT] = ACTIONS(933),
    [anon_sym_LT_LT_DASH] = ACTIONS(933),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(933),
    [anon_sym_LF] = ACTIONS(933),
    [anon_sym_AMP] = ACTIONS(933),
  },
  [919] = {
    [anon_sym_RBRACE] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2412),
    [sym_comment] = ACTIONS(46),
  },
  [920] = {
    [anon_sym_RBRACE] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2416),
    [sym_comment] = ACTIONS(46),
  },
  [921] = {
    [sym_file_descriptor] = ACTIONS(960),
    [sym__concat] = ACTIONS(960),
    [anon_sym_PIPE] = ACTIONS(962),
    [anon_sym_RPAREN] = ACTIONS(962),
    [anon_sym_SEMI_SEMI] = ACTIONS(962),
    [anon_sym_PIPE_AMP] = ACTIONS(962),
    [anon_sym_AMP_AMP] = ACTIONS(962),
    [anon_sym_PIPE_PIPE] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(962),
    [anon_sym_GT] = ACTIONS(962),
    [anon_sym_GT_GT] = ACTIONS(962),
    [anon_sym_AMP_GT] = ACTIONS(962),
    [anon_sym_AMP_GT_GT] = ACTIONS(962),
    [anon_sym_LT_AMP] = ACTIONS(962),
    [anon_sym_GT_AMP] = ACTIONS(962),
    [anon_sym_LT_LT] = ACTIONS(962),
    [anon_sym_LT_LT_DASH] = ACTIONS(962),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(962),
    [anon_sym_LF] = ACTIONS(962),
    [anon_sym_AMP] = ACTIONS(962),
  },
  [922] = {
    [sym_concatenation] = STATE(1199),
    [sym_string] = STATE(1196),
    [sym_simple_expansion] = STATE(1196),
    [sym_expansion] = STATE(1196),
    [sym_command_substitution] = STATE(1196),
    [sym_process_substitution] = STATE(1196),
    [sym_word] = ACTIONS(2418),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(2418),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2422),
  },
  [923] = {
    [anon_sym_AT] = ACTIONS(2424),
    [sym_comment] = ACTIONS(46),
  },
  [924] = {
    [sym_file_descriptor] = ACTIONS(972),
    [sym__concat] = ACTIONS(972),
    [anon_sym_PIPE] = ACTIONS(974),
    [anon_sym_RPAREN] = ACTIONS(974),
    [anon_sym_SEMI_SEMI] = ACTIONS(974),
    [anon_sym_PIPE_AMP] = ACTIONS(974),
    [anon_sym_AMP_AMP] = ACTIONS(974),
    [anon_sym_PIPE_PIPE] = ACTIONS(974),
    [anon_sym_LT] = ACTIONS(974),
    [anon_sym_GT] = ACTIONS(974),
    [anon_sym_GT_GT] = ACTIONS(974),
    [anon_sym_AMP_GT] = ACTIONS(974),
    [anon_sym_AMP_GT_GT] = ACTIONS(974),
    [anon_sym_LT_AMP] = ACTIONS(974),
    [anon_sym_GT_AMP] = ACTIONS(974),
    [anon_sym_LT_LT] = ACTIONS(974),
    [anon_sym_LT_LT_DASH] = ACTIONS(974),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(974),
    [anon_sym_LF] = ACTIONS(974),
    [anon_sym_AMP] = ACTIONS(974),
  },
  [925] = {
    [sym_concatenation] = STATE(1203),
    [sym_string] = STATE(1201),
    [sym_simple_expansion] = STATE(1201),
    [sym_expansion] = STATE(1201),
    [sym_command_substitution] = STATE(1201),
    [sym_process_substitution] = STATE(1201),
    [sym_word] = ACTIONS(2426),
    [anon_sym_RBRACE] = ACTIONS(2414),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(2426),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2428),
  },
  [926] = {
    [anon_sym_AT] = ACTIONS(2430),
    [sym_comment] = ACTIONS(46),
  },
  [927] = {
    [sym_file_descriptor] = ACTIONS(1066),
    [sym__concat] = ACTIONS(1066),
    [anon_sym_PIPE] = ACTIONS(1068),
    [anon_sym_RPAREN] = ACTIONS(1068),
    [anon_sym_SEMI_SEMI] = ACTIONS(1068),
    [anon_sym_PIPE_AMP] = ACTIONS(1068),
    [anon_sym_AMP_AMP] = ACTIONS(1068),
    [anon_sym_PIPE_PIPE] = ACTIONS(1068),
    [anon_sym_LT] = ACTIONS(1068),
    [anon_sym_GT] = ACTIONS(1068),
    [anon_sym_GT_GT] = ACTIONS(1068),
    [anon_sym_AMP_GT] = ACTIONS(1068),
    [anon_sym_AMP_GT_GT] = ACTIONS(1068),
    [anon_sym_LT_AMP] = ACTIONS(1068),
    [anon_sym_GT_AMP] = ACTIONS(1068),
    [anon_sym_LT_LT] = ACTIONS(1068),
    [anon_sym_LT_LT_DASH] = ACTIONS(1068),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1068),
    [anon_sym_LF] = ACTIONS(1068),
    [anon_sym_AMP] = ACTIONS(1068),
  },
  [928] = {
    [sym_file_descriptor] = ACTIONS(1122),
    [sym__concat] = ACTIONS(1122),
    [anon_sym_PIPE] = ACTIONS(1124),
    [anon_sym_RPAREN] = ACTIONS(1124),
    [anon_sym_SEMI_SEMI] = ACTIONS(1124),
    [anon_sym_PIPE_AMP] = ACTIONS(1124),
    [anon_sym_AMP_AMP] = ACTIONS(1124),
    [anon_sym_PIPE_PIPE] = ACTIONS(1124),
    [anon_sym_LT] = ACTIONS(1124),
    [anon_sym_GT] = ACTIONS(1124),
    [anon_sym_GT_GT] = ACTIONS(1124),
    [anon_sym_AMP_GT] = ACTIONS(1124),
    [anon_sym_AMP_GT_GT] = ACTIONS(1124),
    [anon_sym_LT_AMP] = ACTIONS(1124),
    [anon_sym_GT_AMP] = ACTIONS(1124),
    [anon_sym_LT_LT] = ACTIONS(1124),
    [anon_sym_LT_LT_DASH] = ACTIONS(1124),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1124),
    [anon_sym_LF] = ACTIONS(1124),
    [anon_sym_AMP] = ACTIONS(1124),
  },
  [929] = {
    [sym__heredoc_middle] = ACTIONS(412),
    [sym__heredoc_end] = ACTIONS(412),
    [anon_sym_DOLLAR] = ACTIONS(424),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(412),
    [sym_comment] = ACTIONS(46),
  },
  [930] = {
    [sym__heredoc_middle] = ACTIONS(416),
    [sym__heredoc_end] = ACTIONS(416),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(416),
    [sym_comment] = ACTIONS(46),
  },
  [931] = {
    [sym__heredoc_middle] = ACTIONS(420),
    [sym__heredoc_end] = ACTIONS(420),
    [anon_sym_DOLLAR] = ACTIONS(885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(420),
    [sym_comment] = ACTIONS(46),
  },
  [932] = {
    [sym_special_variable_name] = STATE(1206),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_EQ] = ACTIONS(412),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(138),
    [anon_sym_AT] = ACTIONS(138),
    [anon_sym_COLON] = ACTIONS(424),
    [anon_sym_COLON_QMARK] = ACTIONS(412),
    [anon_sym_COLON_DASH] = ACTIONS(412),
    [anon_sym_PERCENT] = ACTIONS(412),
    [anon_sym_SLASH] = ACTIONS(412),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2432),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [933] = {
    [anon_sym_RBRACE] = ACTIONS(2434),
    [anon_sym_EQ] = ACTIONS(2436),
    [anon_sym_LBRACK] = ACTIONS(2438),
    [anon_sym_COLON] = ACTIONS(2440),
    [anon_sym_COLON_QMARK] = ACTIONS(2436),
    [anon_sym_COLON_DASH] = ACTIONS(2436),
    [anon_sym_PERCENT] = ACTIONS(2436),
    [anon_sym_SLASH] = ACTIONS(2436),
    [sym_comment] = ACTIONS(46),
  },
  [934] = {
    [anon_sym_RBRACE] = ACTIONS(2442),
    [anon_sym_EQ] = ACTIONS(2444),
    [anon_sym_LBRACK] = ACTIONS(2446),
    [anon_sym_COLON] = ACTIONS(2448),
    [anon_sym_COLON_QMARK] = ACTIONS(2444),
    [anon_sym_COLON_DASH] = ACTIONS(2444),
    [anon_sym_PERCENT] = ACTIONS(2444),
    [anon_sym_SLASH] = ACTIONS(2444),
    [sym_comment] = ACTIONS(46),
  },
  [935] = {
    [sym_file_descriptor] = ACTIONS(2450),
    [anon_sym_PIPE] = ACTIONS(2452),
    [anon_sym_RPAREN] = ACTIONS(2452),
    [anon_sym_SEMI_SEMI] = ACTIONS(2452),
    [anon_sym_PIPE_AMP] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(2452),
    [anon_sym_PIPE_PIPE] = ACTIONS(2452),
    [anon_sym_LT] = ACTIONS(2452),
    [anon_sym_GT] = ACTIONS(2452),
    [anon_sym_GT_GT] = ACTIONS(2452),
    [anon_sym_AMP_GT] = ACTIONS(2452),
    [anon_sym_AMP_GT_GT] = ACTIONS(2452),
    [anon_sym_LT_AMP] = ACTIONS(2452),
    [anon_sym_GT_AMP] = ACTIONS(2452),
    [anon_sym_LT_LT] = ACTIONS(2452),
    [anon_sym_LT_LT_DASH] = ACTIONS(2452),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2452),
    [anon_sym_LF] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(2452),
  },
  [936] = {
    [sym_simple_expansion] = STATE(617),
    [sym_expansion] = STATE(617),
    [aux_sym_heredoc_repeat1] = STATE(936),
    [sym__heredoc_middle] = ACTIONS(2454),
    [sym__heredoc_end] = ACTIONS(2457),
    [anon_sym_DOLLAR] = ACTIONS(2459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(46),
  },
  [937] = {
    [sym_file_descriptor] = ACTIONS(1226),
    [sym_word] = ACTIONS(1226),
    [sym_variable_name] = ACTIONS(1226),
    [anon_sym_LT] = ACTIONS(2231),
    [anon_sym_GT] = ACTIONS(2231),
    [anon_sym_GT_GT] = ACTIONS(1226),
    [anon_sym_AMP_GT] = ACTIONS(2231),
    [anon_sym_AMP_GT_GT] = ACTIONS(1226),
    [anon_sym_LT_AMP] = ACTIONS(1226),
    [anon_sym_GT_AMP] = ACTIONS(1226),
    [anon_sym_DQUOTE] = ACTIONS(1226),
    [sym_raw_string] = ACTIONS(1226),
    [anon_sym_DOLLAR] = ACTIONS(2231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1226),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1226),
    [anon_sym_BQUOTE] = ACTIONS(1226),
    [anon_sym_LT_LPAREN] = ACTIONS(1226),
    [anon_sym_GT_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2231),
  },
  [938] = {
    [sym_concatenation] = STATE(364),
    [sym_string] = STATE(355),
    [sym_simple_expansion] = STATE(355),
    [sym_expansion] = STATE(355),
    [sym_command_substitution] = STATE(355),
    [sym_process_substitution] = STATE(355),
    [aux_sym_for_statement_repeat1] = STATE(648),
    [sym_word] = ACTIONS(692),
    [anon_sym_RPAREN] = ACTIONS(2465),
    [anon_sym_DQUOTE] = ACTIONS(696),
    [sym_raw_string] = ACTIONS(692),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(700),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(702),
    [anon_sym_BQUOTE] = ACTIONS(704),
    [anon_sym_LT_LPAREN] = ACTIONS(706),
    [anon_sym_GT_LPAREN] = ACTIONS(706),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(708),
  },
  [939] = {
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(675),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_DQUOTE] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(1471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(675),
    [anon_sym_BQUOTE] = ACTIONS(675),
    [anon_sym_LT_LPAREN] = ACTIONS(675),
    [anon_sym_GT_LPAREN] = ACTIONS(675),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1471),
  },
  [940] = {
    [sym_word] = ACTIONS(679),
    [sym__concat] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_DQUOTE] = ACTIONS(679),
    [sym_raw_string] = ACTIONS(679),
    [anon_sym_DOLLAR] = ACTIONS(1473),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(679),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(679),
    [anon_sym_LT_LPAREN] = ACTIONS(679),
    [anon_sym_GT_LPAREN] = ACTIONS(679),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1473),
  },
  [941] = {
    [aux_sym_concatenation_repeat1] = STATE(941),
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(2467),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_DQUOTE] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(1471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(675),
    [anon_sym_BQUOTE] = ACTIONS(675),
    [anon_sym_LT_LPAREN] = ACTIONS(675),
    [anon_sym_GT_LPAREN] = ACTIONS(675),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1471),
  },
  [942] = {
    [sym_word] = ACTIONS(931),
    [sym__concat] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(931),
    [anon_sym_DOLLAR] = ACTIONS(1478),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(931),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(931),
    [anon_sym_BQUOTE] = ACTIONS(931),
    [anon_sym_LT_LPAREN] = ACTIONS(931),
    [anon_sym_GT_LPAREN] = ACTIONS(931),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1478),
  },
  [943] = {
    [anon_sym_RBRACE] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2472),
    [sym_comment] = ACTIONS(46),
  },
  [944] = {
    [anon_sym_RBRACE] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [sym_comment] = ACTIONS(46),
  },
  [945] = {
    [sym_word] = ACTIONS(960),
    [sym__concat] = ACTIONS(960),
    [anon_sym_RPAREN] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(960),
    [sym_raw_string] = ACTIONS(960),
    [anon_sym_DOLLAR] = ACTIONS(1488),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(960),
    [anon_sym_BQUOTE] = ACTIONS(960),
    [anon_sym_LT_LPAREN] = ACTIONS(960),
    [anon_sym_GT_LPAREN] = ACTIONS(960),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1488),
  },
  [946] = {
    [sym_concatenation] = STATE(1221),
    [sym_string] = STATE(1218),
    [sym_simple_expansion] = STATE(1218),
    [sym_expansion] = STATE(1218),
    [sym_command_substitution] = STATE(1218),
    [sym_process_substitution] = STATE(1218),
    [sym_word] = ACTIONS(2478),
    [anon_sym_RBRACE] = ACTIONS(2480),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(2478),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2482),
  },
  [947] = {
    [anon_sym_AT] = ACTIONS(2484),
    [sym_comment] = ACTIONS(46),
  },
  [948] = {
    [sym_word] = ACTIONS(972),
    [sym__concat] = ACTIONS(972),
    [anon_sym_RPAREN] = ACTIONS(972),
    [anon_sym_DQUOTE] = ACTIONS(972),
    [sym_raw_string] = ACTIONS(972),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(972),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(972),
    [anon_sym_BQUOTE] = ACTIONS(972),
    [anon_sym_LT_LPAREN] = ACTIONS(972),
    [anon_sym_GT_LPAREN] = ACTIONS(972),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1498),
  },
  [949] = {
    [sym_concatenation] = STATE(1225),
    [sym_string] = STATE(1223),
    [sym_simple_expansion] = STATE(1223),
    [sym_expansion] = STATE(1223),
    [sym_command_substitution] = STATE(1223),
    [sym_process_substitution] = STATE(1223),
    [sym_word] = ACTIONS(2486),
    [anon_sym_RBRACE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(2486),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2488),
  },
  [950] = {
    [anon_sym_AT] = ACTIONS(2490),
    [sym_comment] = ACTIONS(46),
  },
  [951] = {
    [sym_word] = ACTIONS(1066),
    [sym__concat] = ACTIONS(1066),
    [anon_sym_RPAREN] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(1066),
    [sym_raw_string] = ACTIONS(1066),
    [anon_sym_DOLLAR] = ACTIONS(1506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1066),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1066),
    [anon_sym_BQUOTE] = ACTIONS(1066),
    [anon_sym_LT_LPAREN] = ACTIONS(1066),
    [anon_sym_GT_LPAREN] = ACTIONS(1066),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1506),
  },
  [952] = {
    [sym_word] = ACTIONS(1122),
    [sym__concat] = ACTIONS(1122),
    [anon_sym_RPAREN] = ACTIONS(1122),
    [anon_sym_DQUOTE] = ACTIONS(1122),
    [sym_raw_string] = ACTIONS(1122),
    [anon_sym_DOLLAR] = ACTIONS(1508),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1122),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1122),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [anon_sym_LT_LPAREN] = ACTIONS(1122),
    [anon_sym_GT_LPAREN] = ACTIONS(1122),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1508),
  },
  [953] = {
    [sym_file_descriptor] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1532),
    [sym_variable_name] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1534),
    [anon_sym_RPAREN] = ACTIONS(1534),
    [anon_sym_SEMI_SEMI] = ACTIONS(1534),
    [anon_sym_PIPE_AMP] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1534),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_GT_GT] = ACTIONS(1534),
    [anon_sym_AMP_GT] = ACTIONS(1534),
    [anon_sym_AMP_GT_GT] = ACTIONS(1534),
    [anon_sym_LT_AMP] = ACTIONS(1534),
    [anon_sym_GT_AMP] = ACTIONS(1534),
    [anon_sym_DQUOTE] = ACTIONS(1534),
    [sym_raw_string] = ACTIONS(1534),
    [anon_sym_DOLLAR] = ACTIONS(1534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1534),
    [anon_sym_BQUOTE] = ACTIONS(1534),
    [anon_sym_LT_LPAREN] = ACTIONS(1534),
    [anon_sym_GT_LPAREN] = ACTIONS(1534),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1534),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_AMP] = ACTIONS(1534),
  },
  [954] = {
    [anon_sym_AT] = ACTIONS(2492),
    [sym_comment] = ACTIONS(46),
  },
  [955] = {
    [sym_file_descriptor] = ACTIONS(1538),
    [sym_word] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [sym_variable_name] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(1540),
    [anon_sym_RPAREN] = ACTIONS(1540),
    [anon_sym_SEMI_SEMI] = ACTIONS(1540),
    [anon_sym_PIPE_AMP] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1540),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1540),
    [anon_sym_GT_GT] = ACTIONS(1540),
    [anon_sym_AMP_GT] = ACTIONS(1540),
    [anon_sym_AMP_GT_GT] = ACTIONS(1540),
    [anon_sym_LT_AMP] = ACTIONS(1540),
    [anon_sym_GT_AMP] = ACTIONS(1540),
    [anon_sym_DQUOTE] = ACTIONS(1540),
    [sym_raw_string] = ACTIONS(1540),
    [anon_sym_DOLLAR] = ACTIONS(1540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1540),
    [anon_sym_BQUOTE] = ACTIONS(1540),
    [anon_sym_LT_LPAREN] = ACTIONS(1540),
    [anon_sym_GT_LPAREN] = ACTIONS(1540),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1540),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_LF] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1540),
  },
  [956] = {
    [anon_sym_AT] = ACTIONS(2494),
    [sym_comment] = ACTIONS(46),
  },
  [957] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(2496),
    [anon_sym_RBRACE] = ACTIONS(2498),
    [sym_comment] = ACTIONS(46),
  },
  [958] = {
    [sym_file_descriptor] = ACTIONS(1548),
    [sym_word] = ACTIONS(1548),
    [sym__concat] = ACTIONS(1548),
    [sym_variable_name] = ACTIONS(1548),
    [anon_sym_PIPE] = ACTIONS(1550),
    [anon_sym_RPAREN] = ACTIONS(1550),
    [anon_sym_SEMI_SEMI] = ACTIONS(1550),
    [anon_sym_PIPE_AMP] = ACTIONS(1550),
    [anon_sym_AMP_AMP] = ACTIONS(1550),
    [anon_sym_PIPE_PIPE] = ACTIONS(1550),
    [anon_sym_LT] = ACTIONS(1550),
    [anon_sym_GT] = ACTIONS(1550),
    [anon_sym_GT_GT] = ACTIONS(1550),
    [anon_sym_AMP_GT] = ACTIONS(1550),
    [anon_sym_AMP_GT_GT] = ACTIONS(1550),
    [anon_sym_LT_AMP] = ACTIONS(1550),
    [anon_sym_GT_AMP] = ACTIONS(1550),
    [anon_sym_DQUOTE] = ACTIONS(1550),
    [sym_raw_string] = ACTIONS(1550),
    [anon_sym_DOLLAR] = ACTIONS(1550),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1550),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1550),
    [anon_sym_BQUOTE] = ACTIONS(1550),
    [anon_sym_LT_LPAREN] = ACTIONS(1550),
    [anon_sym_GT_LPAREN] = ACTIONS(1550),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1550),
    [anon_sym_SEMI] = ACTIONS(1550),
    [anon_sym_LF] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(1550),
  },
  [959] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(2500),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [sym_comment] = ACTIONS(46),
  },
  [960] = {
    [sym__concat] = ACTIONS(2504),
    [anon_sym_RBRACE] = ACTIONS(2498),
    [sym_comment] = ACTIONS(46),
  },
  [961] = {
    [anon_sym_RBRACK] = ACTIONS(2504),
    [sym_comment] = ACTIONS(46),
  },
  [962] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(2506),
    [anon_sym_RBRACE] = ACTIONS(2508),
    [sym_comment] = ACTIONS(46),
  },
  [963] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(2510),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [sym_comment] = ACTIONS(46),
  },
  [964] = {
    [sym__concat] = ACTIONS(2514),
    [anon_sym_RBRACE] = ACTIONS(2508),
    [sym_comment] = ACTIONS(46),
  },
  [965] = {
    [anon_sym_RBRACK] = ACTIONS(2514),
    [sym_comment] = ACTIONS(46),
  },
  [966] = {
    [sym__concat] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_RBRACE] = ACTIONS(1532),
    [anon_sym_RBRACK] = ACTIONS(1532),
    [sym_comment] = ACTIONS(46),
  },
  [967] = {
    [anon_sym_AT] = ACTIONS(2516),
    [sym_comment] = ACTIONS(46),
  },
  [968] = {
    [sym__concat] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_RPAREN] = ACTIONS(1538),
    [anon_sym_RBRACE] = ACTIONS(1538),
    [anon_sym_RBRACK] = ACTIONS(1538),
    [sym_comment] = ACTIONS(46),
  },
  [969] = {
    [anon_sym_AT] = ACTIONS(2518),
    [sym_comment] = ACTIONS(46),
  },
  [970] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(2520),
    [anon_sym_RBRACE] = ACTIONS(2522),
    [sym_comment] = ACTIONS(46),
  },
  [971] = {
    [sym__concat] = ACTIONS(1548),
    [anon_sym_PIPE] = ACTIONS(1548),
    [anon_sym_RPAREN] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1548),
    [sym_comment] = ACTIONS(46),
  },
  [972] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(2524),
    [anon_sym_RBRACE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(46),
  },
  [973] = {
    [sym__concat] = ACTIONS(2528),
    [anon_sym_RBRACE] = ACTIONS(2522),
    [sym_comment] = ACTIONS(46),
  },
  [974] = {
    [anon_sym_RBRACK] = ACTIONS(2528),
    [sym_comment] = ACTIONS(46),
  },
  [975] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(2530),
    [anon_sym_RBRACE] = ACTIONS(2532),
    [sym_comment] = ACTIONS(46),
  },
  [976] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(2534),
    [anon_sym_RBRACE] = ACTIONS(2536),
    [sym_comment] = ACTIONS(46),
  },
  [977] = {
    [sym__concat] = ACTIONS(2538),
    [anon_sym_RBRACE] = ACTIONS(2532),
    [sym_comment] = ACTIONS(46),
  },
  [978] = {
    [anon_sym_RBRACK] = ACTIONS(2538),
    [sym_comment] = ACTIONS(46),
  },
  [979] = {
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(675),
    [anon_sym_SEMI_SEMI] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(677),
    [sym_raw_string] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [anon_sym_LT_LPAREN] = ACTIONS(677),
    [anon_sym_GT_LPAREN] = ACTIONS(677),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(677),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(677),
  },
  [980] = {
    [sym_word] = ACTIONS(679),
    [sym__concat] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(681),
    [anon_sym_DQUOTE] = ACTIONS(681),
    [sym_raw_string] = ACTIONS(681),
    [anon_sym_DOLLAR] = ACTIONS(681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(681),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(681),
    [anon_sym_BQUOTE] = ACTIONS(681),
    [anon_sym_LT_LPAREN] = ACTIONS(681),
    [anon_sym_GT_LPAREN] = ACTIONS(681),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(681),
    [anon_sym_AMP] = ACTIONS(681),
  },
  [981] = {
    [aux_sym_concatenation_repeat1] = STATE(981),
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(2540),
    [anon_sym_SEMI_SEMI] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(677),
    [sym_raw_string] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [anon_sym_LT_LPAREN] = ACTIONS(677),
    [anon_sym_GT_LPAREN] = ACTIONS(677),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(677),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(677),
  },
  [982] = {
    [sym_word] = ACTIONS(931),
    [sym__concat] = ACTIONS(931),
    [anon_sym_SEMI_SEMI] = ACTIONS(933),
    [anon_sym_DQUOTE] = ACTIONS(933),
    [sym_raw_string] = ACTIONS(933),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(933),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(933),
    [anon_sym_BQUOTE] = ACTIONS(933),
    [anon_sym_LT_LPAREN] = ACTIONS(933),
    [anon_sym_GT_LPAREN] = ACTIONS(933),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(933),
    [anon_sym_SEMI] = ACTIONS(933),
    [anon_sym_LF] = ACTIONS(933),
    [anon_sym_AMP] = ACTIONS(933),
  },
  [983] = {
    [anon_sym_RBRACE] = ACTIONS(2543),
    [anon_sym_LBRACK] = ACTIONS(2545),
    [sym_comment] = ACTIONS(46),
  },
  [984] = {
    [anon_sym_RBRACE] = ACTIONS(2547),
    [anon_sym_LBRACK] = ACTIONS(2549),
    [sym_comment] = ACTIONS(46),
  },
  [985] = {
    [sym_word] = ACTIONS(960),
    [sym__concat] = ACTIONS(960),
    [anon_sym_SEMI_SEMI] = ACTIONS(962),
    [anon_sym_DQUOTE] = ACTIONS(962),
    [sym_raw_string] = ACTIONS(962),
    [anon_sym_DOLLAR] = ACTIONS(962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(962),
    [anon_sym_BQUOTE] = ACTIONS(962),
    [anon_sym_LT_LPAREN] = ACTIONS(962),
    [anon_sym_GT_LPAREN] = ACTIONS(962),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(962),
    [anon_sym_SEMI] = ACTIONS(962),
    [anon_sym_LF] = ACTIONS(962),
    [anon_sym_AMP] = ACTIONS(962),
  },
  [986] = {
    [sym_concatenation] = STATE(1258),
    [sym_string] = STATE(1255),
    [sym_simple_expansion] = STATE(1255),
    [sym_expansion] = STATE(1255),
    [sym_command_substitution] = STATE(1255),
    [sym_process_substitution] = STATE(1255),
    [sym_word] = ACTIONS(2551),
    [anon_sym_RBRACE] = ACTIONS(2553),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(2551),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2555),
  },
  [987] = {
    [anon_sym_AT] = ACTIONS(2557),
    [sym_comment] = ACTIONS(46),
  },
  [988] = {
    [sym_word] = ACTIONS(972),
    [sym__concat] = ACTIONS(972),
    [anon_sym_SEMI_SEMI] = ACTIONS(974),
    [anon_sym_DQUOTE] = ACTIONS(974),
    [sym_raw_string] = ACTIONS(974),
    [anon_sym_DOLLAR] = ACTIONS(974),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(974),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(974),
    [anon_sym_BQUOTE] = ACTIONS(974),
    [anon_sym_LT_LPAREN] = ACTIONS(974),
    [anon_sym_GT_LPAREN] = ACTIONS(974),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(974),
    [anon_sym_SEMI] = ACTIONS(974),
    [anon_sym_LF] = ACTIONS(974),
    [anon_sym_AMP] = ACTIONS(974),
  },
  [989] = {
    [sym_concatenation] = STATE(1262),
    [sym_string] = STATE(1260),
    [sym_simple_expansion] = STATE(1260),
    [sym_expansion] = STATE(1260),
    [sym_command_substitution] = STATE(1260),
    [sym_process_substitution] = STATE(1260),
    [sym_word] = ACTIONS(2559),
    [anon_sym_RBRACE] = ACTIONS(2547),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(2559),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2561),
  },
  [990] = {
    [anon_sym_AT] = ACTIONS(2563),
    [sym_comment] = ACTIONS(46),
  },
  [991] = {
    [sym_word] = ACTIONS(1066),
    [sym__concat] = ACTIONS(1066),
    [anon_sym_SEMI_SEMI] = ACTIONS(1068),
    [anon_sym_DQUOTE] = ACTIONS(1068),
    [sym_raw_string] = ACTIONS(1068),
    [anon_sym_DOLLAR] = ACTIONS(1068),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1068),
    [anon_sym_BQUOTE] = ACTIONS(1068),
    [anon_sym_LT_LPAREN] = ACTIONS(1068),
    [anon_sym_GT_LPAREN] = ACTIONS(1068),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1068),
    [anon_sym_SEMI] = ACTIONS(1068),
    [anon_sym_LF] = ACTIONS(1068),
    [anon_sym_AMP] = ACTIONS(1068),
  },
  [992] = {
    [sym_word] = ACTIONS(1122),
    [sym__concat] = ACTIONS(1122),
    [anon_sym_SEMI_SEMI] = ACTIONS(1124),
    [anon_sym_DQUOTE] = ACTIONS(1124),
    [sym_raw_string] = ACTIONS(1124),
    [anon_sym_DOLLAR] = ACTIONS(1124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1124),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1124),
    [anon_sym_BQUOTE] = ACTIONS(1124),
    [anon_sym_LT_LPAREN] = ACTIONS(1124),
    [anon_sym_GT_LPAREN] = ACTIONS(1124),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1124),
    [anon_sym_SEMI] = ACTIONS(1124),
    [anon_sym_LF] = ACTIONS(1124),
    [anon_sym_AMP] = ACTIONS(1124),
  },
  [993] = {
    [anon_sym_PIPE] = ACTIONS(2565),
    [anon_sym_RPAREN] = ACTIONS(2565),
    [anon_sym_SEMI_SEMI] = ACTIONS(2565),
    [anon_sym_PIPE_AMP] = ACTIONS(2565),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_PIPE_PIPE] = ACTIONS(2565),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2565),
    [anon_sym_LF] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2565),
  },
  [994] = {
    [sym__terminated_statement] = STATE(418),
    [sym_for_statement] = STATE(419),
    [sym_while_statement] = STATE(419),
    [sym_if_statement] = STATE(419),
    [sym_case_statement] = STATE(419),
    [sym_function_definition] = STATE(419),
    [sym_subshell] = STATE(419),
    [sym_pipeline] = STATE(419),
    [sym_list] = STATE(419),
    [sym_command] = STATE(419),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(422),
    [sym_declaration_command] = STATE(419),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(1264),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(2567),
    [anon_sym_elif] = ACTIONS(2567),
    [anon_sym_else] = ACTIONS(2567),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [995] = {
    [sym_file_descriptor] = ACTIONS(546),
    [sym_word] = ACTIONS(546),
    [sym_variable_name] = ACTIONS(546),
    [anon_sym_for] = ACTIONS(548),
    [anon_sym_while] = ACTIONS(548),
    [anon_sym_if] = ACTIONS(548),
    [anon_sym_fi] = ACTIONS(548),
    [anon_sym_case] = ACTIONS(548),
    [anon_sym_function] = ACTIONS(548),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeset] = ACTIONS(548),
    [anon_sym_export] = ACTIONS(548),
    [anon_sym_readonly] = ACTIONS(548),
    [anon_sym_local] = ACTIONS(548),
    [anon_sym_LT] = ACTIONS(548),
    [anon_sym_GT] = ACTIONS(548),
    [anon_sym_GT_GT] = ACTIONS(546),
    [anon_sym_AMP_GT] = ACTIONS(548),
    [anon_sym_AMP_GT_GT] = ACTIONS(546),
    [anon_sym_LT_AMP] = ACTIONS(546),
    [anon_sym_GT_AMP] = ACTIONS(546),
    [anon_sym_DQUOTE] = ACTIONS(546),
    [sym_raw_string] = ACTIONS(546),
    [anon_sym_DOLLAR] = ACTIONS(548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(546),
    [anon_sym_LT_LPAREN] = ACTIONS(546),
    [anon_sym_GT_LPAREN] = ACTIONS(546),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(550),
  },
  [996] = {
    [sym__terminated_statement] = STATE(697),
    [sym_for_statement] = STATE(698),
    [sym_while_statement] = STATE(698),
    [sym_if_statement] = STATE(698),
    [sym_case_statement] = STATE(698),
    [sym_function_definition] = STATE(698),
    [sym_subshell] = STATE(698),
    [sym_pipeline] = STATE(698),
    [sym_list] = STATE(698),
    [sym_command] = STATE(698),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(699),
    [sym_declaration_command] = STATE(698),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(996),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(590),
    [sym_word] = ACTIONS(593),
    [sym_variable_name] = ACTIONS(596),
    [anon_sym_for] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(604),
    [anon_sym_if] = ACTIONS(607),
    [anon_sym_fi] = ACTIONS(2020),
    [anon_sym_case] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(619),
    [anon_sym_typeset] = ACTIONS(619),
    [anon_sym_export] = ACTIONS(619),
    [anon_sym_readonly] = ACTIONS(619),
    [anon_sym_local] = ACTIONS(619),
    [anon_sym_LT] = ACTIONS(622),
    [anon_sym_GT] = ACTIONS(622),
    [anon_sym_GT_GT] = ACTIONS(625),
    [anon_sym_AMP_GT] = ACTIONS(622),
    [anon_sym_AMP_GT_GT] = ACTIONS(625),
    [anon_sym_LT_AMP] = ACTIONS(625),
    [anon_sym_GT_AMP] = ACTIONS(625),
    [anon_sym_DQUOTE] = ACTIONS(628),
    [sym_raw_string] = ACTIONS(593),
    [anon_sym_DOLLAR] = ACTIONS(631),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(634),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(637),
    [anon_sym_BQUOTE] = ACTIONS(640),
    [anon_sym_LT_LPAREN] = ACTIONS(643),
    [anon_sym_GT_LPAREN] = ACTIONS(643),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(646),
  },
  [997] = {
    [anon_sym_PIPE] = ACTIONS(2569),
    [anon_sym_RPAREN] = ACTIONS(2569),
    [anon_sym_SEMI_SEMI] = ACTIONS(2569),
    [anon_sym_PIPE_AMP] = ACTIONS(2569),
    [anon_sym_AMP_AMP] = ACTIONS(2569),
    [anon_sym_PIPE_PIPE] = ACTIONS(2569),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2569),
    [anon_sym_LF] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2569),
  },
  [998] = {
    [anon_sym_fi] = ACTIONS(2571),
    [sym_comment] = ACTIONS(46),
  },
  [999] = {
    [sym_concatenation] = STATE(1268),
    [sym_string] = STATE(1266),
    [sym_simple_expansion] = STATE(1266),
    [sym_expansion] = STATE(1266),
    [sym_command_substitution] = STATE(1266),
    [sym_process_substitution] = STATE(1266),
    [sym_word] = ACTIONS(2573),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(2573),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2575),
  },
  [1000] = {
    [sym__terminated_statement] = STATE(1270),
    [sym_for_statement] = STATE(1271),
    [sym_while_statement] = STATE(1271),
    [sym_if_statement] = STATE(1271),
    [sym_case_statement] = STATE(1271),
    [sym_function_definition] = STATE(1271),
    [sym_subshell] = STATE(1271),
    [sym_pipeline] = STATE(1271),
    [sym_list] = STATE(1271),
    [sym_command] = STATE(1271),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(1272),
    [sym_declaration_command] = STATE(1271),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(1273),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_SEMI_SEMI] = ACTIONS(2577),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [1001] = {
    [aux_sym_case_item_repeat1] = STATE(1275),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_RPAREN] = ACTIONS(2579),
    [sym_comment] = ACTIONS(46),
  },
  [1002] = {
    [aux_sym_concatenation_repeat1] = STATE(1276),
    [sym__concat] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(254),
    [anon_sym_RPAREN] = ACTIONS(254),
    [sym_comment] = ACTIONS(46),
  },
  [1003] = {
    [sym__terminated_statement] = STATE(1270),
    [sym_for_statement] = STATE(1271),
    [sym_while_statement] = STATE(1271),
    [sym_if_statement] = STATE(1271),
    [sym_case_statement] = STATE(1271),
    [sym_function_definition] = STATE(1271),
    [sym_subshell] = STATE(1271),
    [sym_pipeline] = STATE(1271),
    [sym_list] = STATE(1271),
    [sym_command] = STATE(1271),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(1272),
    [sym_declaration_command] = STATE(1271),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(1278),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_SEMI_SEMI] = ACTIONS(2581),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [1004] = {
    [aux_sym_case_item_repeat1] = STATE(1275),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_RPAREN] = ACTIONS(2583),
    [sym_comment] = ACTIONS(46),
  },
  [1005] = {
    [aux_sym_concatenation_repeat1] = STATE(1276),
    [sym__concat] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_RPAREN] = ACTIONS(542),
    [sym_comment] = ACTIONS(46),
  },
  [1006] = {
    [anon_sym_PIPE] = ACTIONS(2585),
    [anon_sym_RPAREN] = ACTIONS(2585),
    [anon_sym_SEMI_SEMI] = ACTIONS(2585),
    [anon_sym_PIPE_AMP] = ACTIONS(2585),
    [anon_sym_AMP_AMP] = ACTIONS(2585),
    [anon_sym_PIPE_PIPE] = ACTIONS(2585),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2585),
    [anon_sym_LF] = ACTIONS(2585),
    [anon_sym_AMP] = ACTIONS(2585),
  },
  [1007] = {
    [sym_case_item] = STATE(710),
    [sym_concatenation] = STATE(711),
    [sym_string] = STATE(707),
    [sym_simple_expansion] = STATE(707),
    [sym_expansion] = STATE(707),
    [sym_command_substitution] = STATE(707),
    [sym_process_substitution] = STATE(707),
    [aux_sym_case_statement_repeat1] = STATE(1007),
    [sym_word] = ACTIONS(2587),
    [anon_sym_esac] = ACTIONS(2590),
    [anon_sym_DQUOTE] = ACTIONS(2592),
    [sym_raw_string] = ACTIONS(2587),
    [anon_sym_DOLLAR] = ACTIONS(2595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2601),
    [anon_sym_BQUOTE] = ACTIONS(2604),
    [anon_sym_LT_LPAREN] = ACTIONS(2607),
    [anon_sym_GT_LPAREN] = ACTIONS(2607),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2610),
  },
  [1008] = {
    [sym_case_item] = STATE(710),
    [sym_concatenation] = STATE(711),
    [sym_string] = STATE(707),
    [sym_simple_expansion] = STATE(707),
    [sym_expansion] = STATE(707),
    [sym_command_substitution] = STATE(707),
    [sym_process_substitution] = STATE(707),
    [aux_sym_case_statement_repeat1] = STATE(1007),
    [sym_word] = ACTIONS(1354),
    [anon_sym_esac] = ACTIONS(2613),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1354),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1358),
  },
  [1009] = {
    [anon_sym_RBRACK] = ACTIONS(2615),
    [sym_comment] = ACTIONS(46),
  },
  [1010] = {
    [anon_sym_RBRACK] = ACTIONS(2617),
    [sym_comment] = ACTIONS(46),
  },
  [1011] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2619),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1012] = {
    [sym__concat] = ACTIONS(2205),
    [anon_sym_in] = ACTIONS(2207),
    [anon_sym_SEMI_SEMI] = ACTIONS(2207),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2207),
    [anon_sym_LF] = ACTIONS(2207),
    [anon_sym_AMP] = ACTIONS(2207),
  },
  [1013] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2621),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1014] = {
    [sym__concat] = ACTIONS(2211),
    [anon_sym_in] = ACTIONS(2213),
    [anon_sym_SEMI_SEMI] = ACTIONS(2213),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2213),
    [anon_sym_LF] = ACTIONS(2213),
    [anon_sym_AMP] = ACTIONS(2213),
  },
  [1015] = {
    [anon_sym_RBRACE] = ACTIONS(2619),
    [sym_comment] = ACTIONS(46),
  },
  [1016] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2623),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1017] = {
    [sym__concat] = ACTIONS(2217),
    [anon_sym_in] = ACTIONS(2219),
    [anon_sym_SEMI_SEMI] = ACTIONS(2219),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2219),
    [anon_sym_LF] = ACTIONS(2219),
    [anon_sym_AMP] = ACTIONS(2219),
  },
  [1018] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2625),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1019] = {
    [sym__concat] = ACTIONS(2223),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI_SEMI] = ACTIONS(2225),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2225),
    [anon_sym_LF] = ACTIONS(2225),
    [anon_sym_AMP] = ACTIONS(2225),
  },
  [1020] = {
    [anon_sym_RBRACE] = ACTIONS(2623),
    [sym_comment] = ACTIONS(46),
  },
  [1021] = {
    [anon_sym_PIPE] = ACTIONS(2627),
    [anon_sym_RPAREN] = ACTIONS(2627),
    [anon_sym_SEMI_SEMI] = ACTIONS(2627),
    [anon_sym_PIPE_AMP] = ACTIONS(2627),
    [anon_sym_AMP_AMP] = ACTIONS(2627),
    [anon_sym_PIPE_PIPE] = ACTIONS(2627),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2627),
    [anon_sym_LF] = ACTIONS(2627),
    [anon_sym_AMP] = ACTIONS(2627),
  },
  [1022] = {
    [sym_case_item] = STATE(710),
    [sym_concatenation] = STATE(711),
    [sym_string] = STATE(707),
    [sym_simple_expansion] = STATE(707),
    [sym_expansion] = STATE(707),
    [sym_command_substitution] = STATE(707),
    [sym_process_substitution] = STATE(707),
    [aux_sym_case_statement_repeat1] = STATE(1007),
    [sym_word] = ACTIONS(1354),
    [anon_sym_esac] = ACTIONS(2629),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1354),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1358),
  },
  [1023] = {
    [anon_sym_PIPE] = ACTIONS(2631),
    [anon_sym_RPAREN] = ACTIONS(2631),
    [anon_sym_SEMI_SEMI] = ACTIONS(2631),
    [anon_sym_PIPE_AMP] = ACTIONS(2631),
    [anon_sym_AMP_AMP] = ACTIONS(2631),
    [anon_sym_PIPE_PIPE] = ACTIONS(2631),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2631),
    [anon_sym_LF] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2631),
  },
  [1024] = {
    [aux_sym_concatenation_repeat1] = STATE(1028),
    [sym__concat] = ACTIONS(2091),
    [anon_sym_PIPE] = ACTIONS(1801),
    [anon_sym_SEMI_SEMI] = ACTIONS(1801),
    [anon_sym_PIPE_AMP] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1801),
    [anon_sym_PIPE_PIPE] = ACTIONS(1801),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1801),
    [anon_sym_LF] = ACTIONS(1801),
    [anon_sym_AMP] = ACTIONS(1801),
  },
  [1025] = {
    [aux_sym_concatenation_repeat1] = STATE(1043),
    [sym__concat] = ACTIONS(2091),
    [anon_sym_PIPE] = ACTIONS(1803),
    [anon_sym_SEMI_SEMI] = ACTIONS(1803),
    [anon_sym_PIPE_AMP] = ACTIONS(1803),
    [anon_sym_AMP_AMP] = ACTIONS(1803),
    [anon_sym_PIPE_PIPE] = ACTIONS(1803),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1803),
    [anon_sym_LF] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
  },
  [1026] = {
    [anon_sym_PIPE] = ACTIONS(1801),
    [anon_sym_RPAREN] = ACTIONS(1801),
    [anon_sym_SEMI_SEMI] = ACTIONS(1801),
    [anon_sym_PIPE_AMP] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1801),
    [anon_sym_PIPE_PIPE] = ACTIONS(1801),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1801),
    [anon_sym_LF] = ACTIONS(1801),
    [anon_sym_AMP] = ACTIONS(1801),
  },
  [1027] = {
    [sym_string] = STATE(1288),
    [sym_simple_expansion] = STATE(1288),
    [sym_expansion] = STATE(1288),
    [sym_command_substitution] = STATE(1288),
    [sym_process_substitution] = STATE(1288),
    [sym_word] = ACTIONS(2633),
    [anon_sym_DQUOTE] = ACTIONS(1403),
    [sym_raw_string] = ACTIONS(2633),
    [anon_sym_DOLLAR] = ACTIONS(1405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1411),
    [anon_sym_LT_LPAREN] = ACTIONS(1413),
    [anon_sym_GT_LPAREN] = ACTIONS(1413),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2635),
  },
  [1028] = {
    [aux_sym_concatenation_repeat1] = STATE(1290),
    [sym__concat] = ACTIONS(2091),
    [anon_sym_PIPE] = ACTIONS(256),
    [anon_sym_SEMI_SEMI] = ACTIONS(256),
    [anon_sym_PIPE_AMP] = ACTIONS(256),
    [anon_sym_AMP_AMP] = ACTIONS(256),
    [anon_sym_PIPE_PIPE] = ACTIONS(256),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(256),
    [anon_sym_LF] = ACTIONS(256),
    [anon_sym_AMP] = ACTIONS(256),
  },
  [1029] = {
    [sym__concat] = ACTIONS(394),
    [anon_sym_PIPE] = ACTIONS(396),
    [anon_sym_RPAREN] = ACTIONS(396),
    [anon_sym_SEMI_SEMI] = ACTIONS(396),
    [anon_sym_PIPE_AMP] = ACTIONS(396),
    [anon_sym_AMP_AMP] = ACTIONS(396),
    [anon_sym_PIPE_PIPE] = ACTIONS(396),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(396),
    [anon_sym_LF] = ACTIONS(396),
    [anon_sym_AMP] = ACTIONS(396),
  },
  [1030] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(252),
    [anon_sym_DQUOTE] = ACTIONS(2637),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [1031] = {
    [sym__concat] = ACTIONS(412),
    [anon_sym_PIPE] = ACTIONS(414),
    [anon_sym_RPAREN] = ACTIONS(414),
    [anon_sym_SEMI_SEMI] = ACTIONS(414),
    [anon_sym_PIPE_AMP] = ACTIONS(414),
    [anon_sym_AMP_AMP] = ACTIONS(414),
    [anon_sym_PIPE_PIPE] = ACTIONS(414),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(414),
    [anon_sym_LF] = ACTIONS(414),
    [anon_sym_AMP] = ACTIONS(414),
  },
  [1032] = {
    [sym__concat] = ACTIONS(416),
    [anon_sym_PIPE] = ACTIONS(418),
    [anon_sym_RPAREN] = ACTIONS(418),
    [anon_sym_SEMI_SEMI] = ACTIONS(418),
    [anon_sym_PIPE_AMP] = ACTIONS(418),
    [anon_sym_AMP_AMP] = ACTIONS(418),
    [anon_sym_PIPE_PIPE] = ACTIONS(418),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(418),
    [anon_sym_LF] = ACTIONS(418),
    [anon_sym_AMP] = ACTIONS(418),
  },
  [1033] = {
    [sym__concat] = ACTIONS(420),
    [anon_sym_PIPE] = ACTIONS(422),
    [anon_sym_RPAREN] = ACTIONS(422),
    [anon_sym_SEMI_SEMI] = ACTIONS(422),
    [anon_sym_PIPE_AMP] = ACTIONS(422),
    [anon_sym_AMP_AMP] = ACTIONS(422),
    [anon_sym_PIPE_PIPE] = ACTIONS(422),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(422),
    [anon_sym_LF] = ACTIONS(422),
    [anon_sym_AMP] = ACTIONS(422),
  },
  [1034] = {
    [sym_special_variable_name] = STATE(1293),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_EQ] = ACTIONS(412),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(138),
    [anon_sym_AT] = ACTIONS(138),
    [anon_sym_COLON] = ACTIONS(424),
    [anon_sym_COLON_QMARK] = ACTIONS(412),
    [anon_sym_COLON_DASH] = ACTIONS(412),
    [anon_sym_PERCENT] = ACTIONS(412),
    [anon_sym_SLASH] = ACTIONS(412),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [1035] = {
    [anon_sym_RBRACE] = ACTIONS(2641),
    [anon_sym_EQ] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_COLON] = ACTIONS(2647),
    [anon_sym_COLON_QMARK] = ACTIONS(2643),
    [anon_sym_COLON_DASH] = ACTIONS(2643),
    [anon_sym_PERCENT] = ACTIONS(2643),
    [anon_sym_SLASH] = ACTIONS(2643),
    [sym_comment] = ACTIONS(46),
  },
  [1036] = {
    [anon_sym_RBRACE] = ACTIONS(2649),
    [anon_sym_EQ] = ACTIONS(2651),
    [anon_sym_LBRACK] = ACTIONS(2653),
    [anon_sym_COLON] = ACTIONS(2655),
    [anon_sym_COLON_QMARK] = ACTIONS(2651),
    [anon_sym_COLON_DASH] = ACTIONS(2651),
    [anon_sym_PERCENT] = ACTIONS(2651),
    [anon_sym_SLASH] = ACTIONS(2651),
    [sym_comment] = ACTIONS(46),
  },
  [1037] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(2657),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [1038] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(2657),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [1039] = {
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_BQUOTE] = ACTIONS(2657),
    [sym_comment] = ACTIONS(46),
  },
  [1040] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(2657),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [1041] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(2659),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [1042] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(2659),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [1043] = {
    [aux_sym_concatenation_repeat1] = STATE(1290),
    [sym__concat] = ACTIONS(2091),
    [anon_sym_PIPE] = ACTIONS(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_PIPE_PIPE] = ACTIONS(544),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [1044] = {
    [aux_sym_concatenation_repeat1] = STATE(1044),
    [sym_file_descriptor] = ACTIONS(675),
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(1857),
    [sym_variable_name] = ACTIONS(675),
    [anon_sym_PIPE] = ACTIONS(677),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_SEMI_SEMI] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(677),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(677),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(677),
    [sym_raw_string] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [anon_sym_LT_LPAREN] = ACTIONS(677),
    [anon_sym_GT_LPAREN] = ACTIONS(677),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(677),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(677),
  },
  [1045] = {
    [sym_file_redirect] = STATE(1023),
    [sym_file_descriptor] = ACTIONS(1421),
    [anon_sym_PIPE] = ACTIONS(2081),
    [anon_sym_RPAREN] = ACTIONS(2081),
    [anon_sym_SEMI_SEMI] = ACTIONS(2081),
    [anon_sym_PIPE_AMP] = ACTIONS(2081),
    [anon_sym_AMP_AMP] = ACTIONS(2081),
    [anon_sym_PIPE_PIPE] = ACTIONS(2081),
    [anon_sym_LT] = ACTIONS(1423),
    [anon_sym_GT] = ACTIONS(1423),
    [anon_sym_GT_GT] = ACTIONS(1423),
    [anon_sym_AMP_GT] = ACTIONS(1423),
    [anon_sym_AMP_GT_GT] = ACTIONS(1423),
    [anon_sym_LT_AMP] = ACTIONS(1423),
    [anon_sym_GT_AMP] = ACTIONS(1423),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2081),
    [anon_sym_LF] = ACTIONS(2081),
    [anon_sym_AMP] = ACTIONS(2081),
  },
  [1046] = {
    [sym_concatenation] = STATE(1026),
    [sym_string] = STATE(1302),
    [sym_simple_expansion] = STATE(1302),
    [sym_expansion] = STATE(1302),
    [sym_command_substitution] = STATE(1302),
    [sym_process_substitution] = STATE(1302),
    [sym_word] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(1403),
    [sym_raw_string] = ACTIONS(2661),
    [anon_sym_DOLLAR] = ACTIONS(1405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1409),
    [anon_sym_BQUOTE] = ACTIONS(1411),
    [anon_sym_LT_LPAREN] = ACTIONS(1413),
    [anon_sym_GT_LPAREN] = ACTIONS(1413),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2663),
  },
  [1047] = {
    [aux_sym_concatenation_repeat1] = STATE(1304),
    [sym__concat] = ACTIONS(2091),
    [anon_sym_PIPE] = ACTIONS(1136),
    [anon_sym_RPAREN] = ACTIONS(1136),
    [anon_sym_SEMI_SEMI] = ACTIONS(1136),
    [anon_sym_PIPE_AMP] = ACTIONS(1136),
    [anon_sym_AMP_AMP] = ACTIONS(1136),
    [anon_sym_PIPE_PIPE] = ACTIONS(1136),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1136),
    [anon_sym_LF] = ACTIONS(1136),
    [anon_sym_AMP] = ACTIONS(1136),
  },
  [1048] = {
    [aux_sym_concatenation_repeat1] = STATE(1305),
    [sym__concat] = ACTIONS(2091),
    [anon_sym_PIPE] = ACTIONS(1150),
    [anon_sym_RPAREN] = ACTIONS(1150),
    [anon_sym_SEMI_SEMI] = ACTIONS(1150),
    [anon_sym_PIPE_AMP] = ACTIONS(1150),
    [anon_sym_AMP_AMP] = ACTIONS(1150),
    [anon_sym_PIPE_PIPE] = ACTIONS(1150),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1150),
    [anon_sym_LF] = ACTIONS(1150),
    [anon_sym_AMP] = ACTIONS(1150),
  },
  [1049] = {
    [aux_sym_concatenation_repeat1] = STATE(1306),
    [sym_word] = ACTIONS(254),
    [sym__concat] = ACTIONS(1455),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(256),
    [anon_sym_RPAREN] = ACTIONS(256),
    [anon_sym_SEMI_SEMI] = ACTIONS(256),
    [anon_sym_PIPE_AMP] = ACTIONS(256),
    [anon_sym_AMP_AMP] = ACTIONS(256),
    [anon_sym_PIPE_PIPE] = ACTIONS(256),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(256),
    [anon_sym_SEMI] = ACTIONS(256),
    [anon_sym_LF] = ACTIONS(256),
    [anon_sym_AMP] = ACTIONS(256),
  },
  [1050] = {
    [aux_sym_concatenation_repeat1] = STATE(1306),
    [sym_word] = ACTIONS(542),
    [sym__concat] = ACTIONS(1455),
    [sym_variable_name] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(544),
    [anon_sym_RPAREN] = ACTIONS(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_PIPE_PIPE] = ACTIONS(544),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(544),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [1051] = {
    [aux_sym_concatenation_repeat1] = STATE(1051),
    [sym_file_descriptor] = ACTIONS(675),
    [sym__concat] = ACTIONS(2407),
    [anon_sym_PIPE] = ACTIONS(677),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_SEMI_SEMI] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(677),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(677),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(677),
    [anon_sym_LT_LT_DASH] = ACTIONS(677),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(677),
  },
  [1052] = {
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(675),
    [sym_variable_name] = ACTIONS(675),
    [anon_sym_PIPE] = ACTIONS(677),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_SEMI_SEMI] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(677),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(677),
  },
  [1053] = {
    [sym_word] = ACTIONS(679),
    [sym__concat] = ACTIONS(679),
    [sym_variable_name] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_RPAREN] = ACTIONS(681),
    [anon_sym_SEMI_SEMI] = ACTIONS(681),
    [anon_sym_PIPE_AMP] = ACTIONS(681),
    [anon_sym_AMP_AMP] = ACTIONS(681),
    [anon_sym_PIPE_PIPE] = ACTIONS(681),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(681),
    [anon_sym_AMP] = ACTIONS(681),
  },
  [1054] = {
    [aux_sym_concatenation_repeat1] = STATE(1054),
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(2665),
    [sym_variable_name] = ACTIONS(675),
    [anon_sym_PIPE] = ACTIONS(677),
    [anon_sym_SEMI_SEMI] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(677),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(677),
  },
  [1055] = {
    [sym_word] = ACTIONS(1888),
    [sym_variable_name] = ACTIONS(1888),
    [anon_sym_PIPE] = ACTIONS(1890),
    [anon_sym_RPAREN] = ACTIONS(1890),
    [anon_sym_SEMI_SEMI] = ACTIONS(1890),
    [anon_sym_PIPE_AMP] = ACTIONS(1890),
    [anon_sym_AMP_AMP] = ACTIONS(1890),
    [anon_sym_PIPE_PIPE] = ACTIONS(1890),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1890),
    [anon_sym_SEMI] = ACTIONS(1890),
    [anon_sym_LF] = ACTIONS(1890),
    [anon_sym_AMP] = ACTIONS(1890),
  },
  [1056] = {
    [sym_word] = ACTIONS(931),
    [sym__concat] = ACTIONS(931),
    [sym_variable_name] = ACTIONS(931),
    [anon_sym_PIPE] = ACTIONS(933),
    [anon_sym_RPAREN] = ACTIONS(933),
    [anon_sym_SEMI_SEMI] = ACTIONS(933),
    [anon_sym_PIPE_AMP] = ACTIONS(933),
    [anon_sym_AMP_AMP] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(933),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(933),
    [anon_sym_SEMI] = ACTIONS(933),
    [anon_sym_LF] = ACTIONS(933),
    [anon_sym_AMP] = ACTIONS(933),
  },
  [1057] = {
    [anon_sym_RBRACE] = ACTIONS(2668),
    [anon_sym_LBRACK] = ACTIONS(2670),
    [sym_comment] = ACTIONS(46),
  },
  [1058] = {
    [anon_sym_RBRACE] = ACTIONS(2672),
    [anon_sym_LBRACK] = ACTIONS(2674),
    [sym_comment] = ACTIONS(46),
  },
  [1059] = {
    [sym_word] = ACTIONS(960),
    [sym__concat] = ACTIONS(960),
    [sym_variable_name] = ACTIONS(960),
    [anon_sym_PIPE] = ACTIONS(962),
    [anon_sym_RPAREN] = ACTIONS(962),
    [anon_sym_SEMI_SEMI] = ACTIONS(962),
    [anon_sym_PIPE_AMP] = ACTIONS(962),
    [anon_sym_AMP_AMP] = ACTIONS(962),
    [anon_sym_PIPE_PIPE] = ACTIONS(962),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(962),
    [anon_sym_SEMI] = ACTIONS(962),
    [anon_sym_LF] = ACTIONS(962),
    [anon_sym_AMP] = ACTIONS(962),
  },
  [1060] = {
    [sym_concatenation] = STATE(1314),
    [sym_string] = STATE(1311),
    [sym_simple_expansion] = STATE(1311),
    [sym_expansion] = STATE(1311),
    [sym_command_substitution] = STATE(1311),
    [sym_process_substitution] = STATE(1311),
    [sym_word] = ACTIONS(2676),
    [anon_sym_RBRACE] = ACTIONS(2678),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(2676),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2680),
  },
  [1061] = {
    [anon_sym_AT] = ACTIONS(2682),
    [sym_comment] = ACTIONS(46),
  },
  [1062] = {
    [sym_word] = ACTIONS(972),
    [sym__concat] = ACTIONS(972),
    [sym_variable_name] = ACTIONS(972),
    [anon_sym_PIPE] = ACTIONS(974),
    [anon_sym_RPAREN] = ACTIONS(974),
    [anon_sym_SEMI_SEMI] = ACTIONS(974),
    [anon_sym_PIPE_AMP] = ACTIONS(974),
    [anon_sym_AMP_AMP] = ACTIONS(974),
    [anon_sym_PIPE_PIPE] = ACTIONS(974),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(974),
    [anon_sym_SEMI] = ACTIONS(974),
    [anon_sym_LF] = ACTIONS(974),
    [anon_sym_AMP] = ACTIONS(974),
  },
  [1063] = {
    [sym_concatenation] = STATE(1318),
    [sym_string] = STATE(1316),
    [sym_simple_expansion] = STATE(1316),
    [sym_expansion] = STATE(1316),
    [sym_command_substitution] = STATE(1316),
    [sym_process_substitution] = STATE(1316),
    [sym_word] = ACTIONS(2684),
    [anon_sym_RBRACE] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(2684),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2686),
  },
  [1064] = {
    [anon_sym_AT] = ACTIONS(2688),
    [sym_comment] = ACTIONS(46),
  },
  [1065] = {
    [sym_word] = ACTIONS(1066),
    [sym__concat] = ACTIONS(1066),
    [sym_variable_name] = ACTIONS(1066),
    [anon_sym_PIPE] = ACTIONS(1068),
    [anon_sym_RPAREN] = ACTIONS(1068),
    [anon_sym_SEMI_SEMI] = ACTIONS(1068),
    [anon_sym_PIPE_AMP] = ACTIONS(1068),
    [anon_sym_AMP_AMP] = ACTIONS(1068),
    [anon_sym_PIPE_PIPE] = ACTIONS(1068),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1068),
    [anon_sym_SEMI] = ACTIONS(1068),
    [anon_sym_LF] = ACTIONS(1068),
    [anon_sym_AMP] = ACTIONS(1068),
  },
  [1066] = {
    [sym_word] = ACTIONS(1122),
    [sym__concat] = ACTIONS(1122),
    [sym_variable_name] = ACTIONS(1122),
    [anon_sym_PIPE] = ACTIONS(1124),
    [anon_sym_RPAREN] = ACTIONS(1124),
    [anon_sym_SEMI_SEMI] = ACTIONS(1124),
    [anon_sym_PIPE_AMP] = ACTIONS(1124),
    [anon_sym_AMP_AMP] = ACTIONS(1124),
    [anon_sym_PIPE_PIPE] = ACTIONS(1124),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1124),
    [anon_sym_SEMI] = ACTIONS(1124),
    [anon_sym_LF] = ACTIONS(1124),
    [anon_sym_AMP] = ACTIONS(1124),
  },
  [1067] = {
    [anon_sym_RBRACK] = ACTIONS(2690),
    [sym_comment] = ACTIONS(46),
  },
  [1068] = {
    [anon_sym_RBRACK] = ACTIONS(2692),
    [sym_comment] = ACTIONS(46),
  },
  [1069] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2694),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1070] = {
    [sym_file_descriptor] = ACTIONS(2205),
    [sym_word] = ACTIONS(2205),
    [sym__concat] = ACTIONS(2205),
    [sym_variable_name] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2696),
    [anon_sym_GT] = ACTIONS(2696),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [anon_sym_AMP_GT] = ACTIONS(2696),
    [anon_sym_AMP_GT_GT] = ACTIONS(2205),
    [anon_sym_LT_AMP] = ACTIONS(2205),
    [anon_sym_GT_AMP] = ACTIONS(2205),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [sym_raw_string] = ACTIONS(2205),
    [anon_sym_DOLLAR] = ACTIONS(2696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2205),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [anon_sym_LT_LPAREN] = ACTIONS(2205),
    [anon_sym_GT_LPAREN] = ACTIONS(2205),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2696),
  },
  [1071] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1072] = {
    [sym_file_descriptor] = ACTIONS(2211),
    [sym_word] = ACTIONS(2211),
    [sym__concat] = ACTIONS(2211),
    [sym_variable_name] = ACTIONS(2211),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_GT] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2211),
    [anon_sym_AMP_GT] = ACTIONS(2700),
    [anon_sym_AMP_GT_GT] = ACTIONS(2211),
    [anon_sym_LT_AMP] = ACTIONS(2211),
    [anon_sym_GT_AMP] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_raw_string] = ACTIONS(2211),
    [anon_sym_DOLLAR] = ACTIONS(2700),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2211),
    [anon_sym_BQUOTE] = ACTIONS(2211),
    [anon_sym_LT_LPAREN] = ACTIONS(2211),
    [anon_sym_GT_LPAREN] = ACTIONS(2211),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2700),
  },
  [1073] = {
    [anon_sym_RBRACE] = ACTIONS(2694),
    [sym_comment] = ACTIONS(46),
  },
  [1074] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2702),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1075] = {
    [sym_file_descriptor] = ACTIONS(2217),
    [sym_word] = ACTIONS(2217),
    [sym__concat] = ACTIONS(2217),
    [sym_variable_name] = ACTIONS(2217),
    [anon_sym_LT] = ACTIONS(2704),
    [anon_sym_GT] = ACTIONS(2704),
    [anon_sym_GT_GT] = ACTIONS(2217),
    [anon_sym_AMP_GT] = ACTIONS(2704),
    [anon_sym_AMP_GT_GT] = ACTIONS(2217),
    [anon_sym_LT_AMP] = ACTIONS(2217),
    [anon_sym_GT_AMP] = ACTIONS(2217),
    [anon_sym_DQUOTE] = ACTIONS(2217),
    [sym_raw_string] = ACTIONS(2217),
    [anon_sym_DOLLAR] = ACTIONS(2704),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2217),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2217),
    [anon_sym_BQUOTE] = ACTIONS(2217),
    [anon_sym_LT_LPAREN] = ACTIONS(2217),
    [anon_sym_GT_LPAREN] = ACTIONS(2217),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2704),
  },
  [1076] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2706),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1077] = {
    [sym_file_descriptor] = ACTIONS(2223),
    [sym_word] = ACTIONS(2223),
    [sym__concat] = ACTIONS(2223),
    [sym_variable_name] = ACTIONS(2223),
    [anon_sym_LT] = ACTIONS(2708),
    [anon_sym_GT] = ACTIONS(2708),
    [anon_sym_GT_GT] = ACTIONS(2223),
    [anon_sym_AMP_GT] = ACTIONS(2708),
    [anon_sym_AMP_GT_GT] = ACTIONS(2223),
    [anon_sym_LT_AMP] = ACTIONS(2223),
    [anon_sym_GT_AMP] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2223),
    [sym_raw_string] = ACTIONS(2223),
    [anon_sym_DOLLAR] = ACTIONS(2708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2223),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2223),
    [anon_sym_BQUOTE] = ACTIONS(2223),
    [anon_sym_LT_LPAREN] = ACTIONS(2223),
    [anon_sym_GT_LPAREN] = ACTIONS(2223),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2708),
  },
  [1078] = {
    [anon_sym_RBRACE] = ACTIONS(2702),
    [sym_comment] = ACTIONS(46),
  },
  [1079] = {
    [anon_sym_RBRACK] = ACTIONS(2710),
    [sym_comment] = ACTIONS(46),
  },
  [1080] = {
    [anon_sym_RBRACK] = ACTIONS(2712),
    [sym_comment] = ACTIONS(46),
  },
  [1081] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2714),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1082] = {
    [anon_sym_DQUOTE] = ACTIONS(2207),
    [sym__string_content] = ACTIONS(2207),
    [anon_sym_DOLLAR] = ACTIONS(2207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2207),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2207),
    [anon_sym_BQUOTE] = ACTIONS(2207),
    [sym_comment] = ACTIONS(60),
  },
  [1083] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2716),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1084] = {
    [anon_sym_DQUOTE] = ACTIONS(2213),
    [sym__string_content] = ACTIONS(2213),
    [anon_sym_DOLLAR] = ACTIONS(2213),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2213),
    [anon_sym_BQUOTE] = ACTIONS(2213),
    [sym_comment] = ACTIONS(60),
  },
  [1085] = {
    [anon_sym_RBRACE] = ACTIONS(2714),
    [sym_comment] = ACTIONS(46),
  },
  [1086] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2718),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1087] = {
    [anon_sym_DQUOTE] = ACTIONS(2219),
    [sym__string_content] = ACTIONS(2219),
    [anon_sym_DOLLAR] = ACTIONS(2219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2219),
    [anon_sym_BQUOTE] = ACTIONS(2219),
    [sym_comment] = ACTIONS(60),
  },
  [1088] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2720),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1089] = {
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [sym__string_content] = ACTIONS(2225),
    [anon_sym_DOLLAR] = ACTIONS(2225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2225),
    [anon_sym_BQUOTE] = ACTIONS(2225),
    [sym_comment] = ACTIONS(60),
  },
  [1090] = {
    [anon_sym_RBRACE] = ACTIONS(2718),
    [sym_comment] = ACTIONS(46),
  },
  [1091] = {
    [anon_sym_RBRACE] = ACTIONS(2722),
    [sym_comment] = ACTIONS(46),
  },
  [1092] = {
    [anon_sym_RBRACE] = ACTIONS(2724),
    [sym_comment] = ACTIONS(46),
  },
  [1093] = {
    [sym_file_descriptor] = ACTIONS(2726),
    [sym_word] = ACTIONS(2726),
    [sym__concat] = ACTIONS(2726),
    [anon_sym_PIPE] = ACTIONS(2728),
    [anon_sym_RPAREN] = ACTIONS(2728),
    [anon_sym_SEMI_SEMI] = ACTIONS(2728),
    [anon_sym_PIPE_AMP] = ACTIONS(2728),
    [anon_sym_AMP_AMP] = ACTIONS(2728),
    [anon_sym_PIPE_PIPE] = ACTIONS(2728),
    [anon_sym_LT] = ACTIONS(2728),
    [anon_sym_GT] = ACTIONS(2728),
    [anon_sym_GT_GT] = ACTIONS(2728),
    [anon_sym_AMP_GT] = ACTIONS(2728),
    [anon_sym_AMP_GT_GT] = ACTIONS(2728),
    [anon_sym_LT_AMP] = ACTIONS(2728),
    [anon_sym_GT_AMP] = ACTIONS(2728),
    [anon_sym_LT_LT] = ACTIONS(2728),
    [anon_sym_LT_LT_DASH] = ACTIONS(2728),
    [anon_sym_DQUOTE] = ACTIONS(2728),
    [sym_raw_string] = ACTIONS(2728),
    [anon_sym_DOLLAR] = ACTIONS(2728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2728),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2728),
    [anon_sym_BQUOTE] = ACTIONS(2728),
    [anon_sym_LT_LPAREN] = ACTIONS(2728),
    [anon_sym_GT_LPAREN] = ACTIONS(2728),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2728),
    [anon_sym_SEMI] = ACTIONS(2728),
    [anon_sym_LF] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(2728),
  },
  [1094] = {
    [aux_sym_concatenation_repeat1] = STATE(1094),
    [sym__concat] = ACTIONS(1938),
    [anon_sym_RBRACE] = ACTIONS(675),
    [sym_comment] = ACTIONS(46),
  },
  [1095] = {
    [sym_file_descriptor] = ACTIONS(2730),
    [sym_word] = ACTIONS(2730),
    [sym__concat] = ACTIONS(2730),
    [anon_sym_PIPE] = ACTIONS(2732),
    [anon_sym_RPAREN] = ACTIONS(2732),
    [anon_sym_SEMI_SEMI] = ACTIONS(2732),
    [anon_sym_PIPE_AMP] = ACTIONS(2732),
    [anon_sym_AMP_AMP] = ACTIONS(2732),
    [anon_sym_PIPE_PIPE] = ACTIONS(2732),
    [anon_sym_LT] = ACTIONS(2732),
    [anon_sym_GT] = ACTIONS(2732),
    [anon_sym_GT_GT] = ACTIONS(2732),
    [anon_sym_AMP_GT] = ACTIONS(2732),
    [anon_sym_AMP_GT_GT] = ACTIONS(2732),
    [anon_sym_LT_AMP] = ACTIONS(2732),
    [anon_sym_GT_AMP] = ACTIONS(2732),
    [anon_sym_LT_LT] = ACTIONS(2732),
    [anon_sym_LT_LT_DASH] = ACTIONS(2732),
    [anon_sym_DQUOTE] = ACTIONS(2732),
    [sym_raw_string] = ACTIONS(2732),
    [anon_sym_DOLLAR] = ACTIONS(2732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2732),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2732),
    [anon_sym_BQUOTE] = ACTIONS(2732),
    [anon_sym_LT_LPAREN] = ACTIONS(2732),
    [anon_sym_GT_LPAREN] = ACTIONS(2732),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2732),
    [anon_sym_SEMI] = ACTIONS(2732),
    [anon_sym_LF] = ACTIONS(2732),
    [anon_sym_AMP] = ACTIONS(2732),
  },
  [1096] = {
    [sym_file_descriptor] = ACTIONS(2734),
    [sym_word] = ACTIONS(2734),
    [sym__concat] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2736),
    [anon_sym_RPAREN] = ACTIONS(2736),
    [anon_sym_SEMI_SEMI] = ACTIONS(2736),
    [anon_sym_PIPE_AMP] = ACTIONS(2736),
    [anon_sym_AMP_AMP] = ACTIONS(2736),
    [anon_sym_PIPE_PIPE] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2736),
    [anon_sym_GT] = ACTIONS(2736),
    [anon_sym_GT_GT] = ACTIONS(2736),
    [anon_sym_AMP_GT] = ACTIONS(2736),
    [anon_sym_AMP_GT_GT] = ACTIONS(2736),
    [anon_sym_LT_AMP] = ACTIONS(2736),
    [anon_sym_GT_AMP] = ACTIONS(2736),
    [anon_sym_LT_LT] = ACTIONS(2736),
    [anon_sym_LT_LT_DASH] = ACTIONS(2736),
    [anon_sym_DQUOTE] = ACTIONS(2736),
    [sym_raw_string] = ACTIONS(2736),
    [anon_sym_DOLLAR] = ACTIONS(2736),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2736),
    [anon_sym_BQUOTE] = ACTIONS(2736),
    [anon_sym_LT_LPAREN] = ACTIONS(2736),
    [anon_sym_GT_LPAREN] = ACTIONS(2736),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2736),
    [anon_sym_SEMI] = ACTIONS(2736),
    [anon_sym_LF] = ACTIONS(2736),
    [anon_sym_AMP] = ACTIONS(2736),
  },
  [1097] = {
    [sym_file_descriptor] = ACTIONS(2738),
    [sym_word] = ACTIONS(2738),
    [sym__concat] = ACTIONS(2738),
    [anon_sym_PIPE] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [anon_sym_SEMI_SEMI] = ACTIONS(2740),
    [anon_sym_PIPE_AMP] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_PIPE_PIPE] = ACTIONS(2740),
    [anon_sym_LT] = ACTIONS(2740),
    [anon_sym_GT] = ACTIONS(2740),
    [anon_sym_GT_GT] = ACTIONS(2740),
    [anon_sym_AMP_GT] = ACTIONS(2740),
    [anon_sym_AMP_GT_GT] = ACTIONS(2740),
    [anon_sym_LT_AMP] = ACTIONS(2740),
    [anon_sym_GT_AMP] = ACTIONS(2740),
    [anon_sym_LT_LT] = ACTIONS(2740),
    [anon_sym_LT_LT_DASH] = ACTIONS(2740),
    [anon_sym_DQUOTE] = ACTIONS(2740),
    [sym_raw_string] = ACTIONS(2740),
    [anon_sym_DOLLAR] = ACTIONS(2740),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2740),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2740),
    [anon_sym_BQUOTE] = ACTIONS(2740),
    [anon_sym_LT_LPAREN] = ACTIONS(2740),
    [anon_sym_GT_LPAREN] = ACTIONS(2740),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2740),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym_LF] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2740),
  },
  [1098] = {
    [sym_file_descriptor] = ACTIONS(675),
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(675),
    [sym_variable_name] = ACTIONS(675),
    [anon_sym_PIPE] = ACTIONS(1471),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_PIPE_AMP] = ACTIONS(675),
    [anon_sym_AMP_AMP] = ACTIONS(675),
    [anon_sym_PIPE_PIPE] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_GT_GT] = ACTIONS(675),
    [anon_sym_AMP_GT] = ACTIONS(1471),
    [anon_sym_AMP_GT_GT] = ACTIONS(675),
    [anon_sym_LT_AMP] = ACTIONS(675),
    [anon_sym_GT_AMP] = ACTIONS(675),
    [anon_sym_DQUOTE] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(1471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(675),
    [anon_sym_BQUOTE] = ACTIONS(675),
    [anon_sym_LT_LPAREN] = ACTIONS(675),
    [anon_sym_GT_LPAREN] = ACTIONS(675),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1471),
  },
  [1099] = {
    [sym_file_descriptor] = ACTIONS(679),
    [sym_word] = ACTIONS(679),
    [sym__concat] = ACTIONS(679),
    [sym_variable_name] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(1473),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(1473),
    [anon_sym_GT] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(1473),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_DQUOTE] = ACTIONS(679),
    [sym_raw_string] = ACTIONS(679),
    [anon_sym_DOLLAR] = ACTIONS(1473),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(679),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(679),
    [anon_sym_LT_LPAREN] = ACTIONS(679),
    [anon_sym_GT_LPAREN] = ACTIONS(679),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1473),
  },
  [1100] = {
    [aux_sym_concatenation_repeat1] = STATE(1100),
    [sym_file_descriptor] = ACTIONS(675),
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(2742),
    [sym_variable_name] = ACTIONS(675),
    [anon_sym_PIPE] = ACTIONS(1471),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_PIPE_AMP] = ACTIONS(675),
    [anon_sym_AMP_AMP] = ACTIONS(675),
    [anon_sym_PIPE_PIPE] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_GT_GT] = ACTIONS(675),
    [anon_sym_AMP_GT] = ACTIONS(1471),
    [anon_sym_AMP_GT_GT] = ACTIONS(675),
    [anon_sym_LT_AMP] = ACTIONS(675),
    [anon_sym_GT_AMP] = ACTIONS(675),
    [anon_sym_DQUOTE] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(1471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(675),
    [anon_sym_BQUOTE] = ACTIONS(675),
    [anon_sym_LT_LPAREN] = ACTIONS(675),
    [anon_sym_GT_LPAREN] = ACTIONS(675),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1471),
  },
  [1101] = {
    [sym_file_descriptor] = ACTIONS(1888),
    [sym_word] = ACTIONS(1888),
    [sym_variable_name] = ACTIONS(1888),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_RPAREN] = ACTIONS(1888),
    [anon_sym_PIPE_AMP] = ACTIONS(1888),
    [anon_sym_AMP_AMP] = ACTIONS(1888),
    [anon_sym_PIPE_PIPE] = ACTIONS(1888),
    [anon_sym_LT] = ACTIONS(2745),
    [anon_sym_GT] = ACTIONS(2745),
    [anon_sym_GT_GT] = ACTIONS(1888),
    [anon_sym_AMP_GT] = ACTIONS(2745),
    [anon_sym_AMP_GT_GT] = ACTIONS(1888),
    [anon_sym_LT_AMP] = ACTIONS(1888),
    [anon_sym_GT_AMP] = ACTIONS(1888),
    [anon_sym_DQUOTE] = ACTIONS(1888),
    [sym_raw_string] = ACTIONS(1888),
    [anon_sym_DOLLAR] = ACTIONS(2745),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1888),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1888),
    [anon_sym_BQUOTE] = ACTIONS(1888),
    [anon_sym_LT_LPAREN] = ACTIONS(1888),
    [anon_sym_GT_LPAREN] = ACTIONS(1888),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2745),
  },
  [1102] = {
    [sym_file_descriptor] = ACTIONS(931),
    [sym_word] = ACTIONS(931),
    [sym__concat] = ACTIONS(931),
    [sym_variable_name] = ACTIONS(931),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_RPAREN] = ACTIONS(931),
    [anon_sym_PIPE_AMP] = ACTIONS(931),
    [anon_sym_AMP_AMP] = ACTIONS(931),
    [anon_sym_PIPE_PIPE] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1478),
    [anon_sym_GT_GT] = ACTIONS(931),
    [anon_sym_AMP_GT] = ACTIONS(1478),
    [anon_sym_AMP_GT_GT] = ACTIONS(931),
    [anon_sym_LT_AMP] = ACTIONS(931),
    [anon_sym_GT_AMP] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(931),
    [anon_sym_DOLLAR] = ACTIONS(1478),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(931),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(931),
    [anon_sym_BQUOTE] = ACTIONS(931),
    [anon_sym_LT_LPAREN] = ACTIONS(931),
    [anon_sym_GT_LPAREN] = ACTIONS(931),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1478),
  },
  [1103] = {
    [anon_sym_RBRACE] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2749),
    [sym_comment] = ACTIONS(46),
  },
  [1104] = {
    [anon_sym_RBRACE] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [sym_comment] = ACTIONS(46),
  },
  [1105] = {
    [sym_file_descriptor] = ACTIONS(960),
    [sym_word] = ACTIONS(960),
    [sym__concat] = ACTIONS(960),
    [sym_variable_name] = ACTIONS(960),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_RPAREN] = ACTIONS(960),
    [anon_sym_PIPE_AMP] = ACTIONS(960),
    [anon_sym_AMP_AMP] = ACTIONS(960),
    [anon_sym_PIPE_PIPE] = ACTIONS(960),
    [anon_sym_LT] = ACTIONS(1488),
    [anon_sym_GT] = ACTIONS(1488),
    [anon_sym_GT_GT] = ACTIONS(960),
    [anon_sym_AMP_GT] = ACTIONS(1488),
    [anon_sym_AMP_GT_GT] = ACTIONS(960),
    [anon_sym_LT_AMP] = ACTIONS(960),
    [anon_sym_GT_AMP] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(960),
    [sym_raw_string] = ACTIONS(960),
    [anon_sym_DOLLAR] = ACTIONS(1488),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(960),
    [anon_sym_BQUOTE] = ACTIONS(960),
    [anon_sym_LT_LPAREN] = ACTIONS(960),
    [anon_sym_GT_LPAREN] = ACTIONS(960),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1488),
  },
  [1106] = {
    [sym_concatenation] = STATE(1341),
    [sym_string] = STATE(1338),
    [sym_simple_expansion] = STATE(1338),
    [sym_expansion] = STATE(1338),
    [sym_command_substitution] = STATE(1338),
    [sym_process_substitution] = STATE(1338),
    [sym_word] = ACTIONS(2755),
    [anon_sym_RBRACE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(2755),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2759),
  },
  [1107] = {
    [anon_sym_AT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(46),
  },
  [1108] = {
    [sym_file_descriptor] = ACTIONS(972),
    [sym_word] = ACTIONS(972),
    [sym__concat] = ACTIONS(972),
    [sym_variable_name] = ACTIONS(972),
    [anon_sym_PIPE] = ACTIONS(1498),
    [anon_sym_RPAREN] = ACTIONS(972),
    [anon_sym_PIPE_AMP] = ACTIONS(972),
    [anon_sym_AMP_AMP] = ACTIONS(972),
    [anon_sym_PIPE_PIPE] = ACTIONS(972),
    [anon_sym_LT] = ACTIONS(1498),
    [anon_sym_GT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(972),
    [anon_sym_AMP_GT] = ACTIONS(1498),
    [anon_sym_AMP_GT_GT] = ACTIONS(972),
    [anon_sym_LT_AMP] = ACTIONS(972),
    [anon_sym_GT_AMP] = ACTIONS(972),
    [anon_sym_DQUOTE] = ACTIONS(972),
    [sym_raw_string] = ACTIONS(972),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(972),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(972),
    [anon_sym_BQUOTE] = ACTIONS(972),
    [anon_sym_LT_LPAREN] = ACTIONS(972),
    [anon_sym_GT_LPAREN] = ACTIONS(972),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1498),
  },
  [1109] = {
    [sym_concatenation] = STATE(1345),
    [sym_string] = STATE(1343),
    [sym_simple_expansion] = STATE(1343),
    [sym_expansion] = STATE(1343),
    [sym_command_substitution] = STATE(1343),
    [sym_process_substitution] = STATE(1343),
    [sym_word] = ACTIONS(2763),
    [anon_sym_RBRACE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(2763),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2765),
  },
  [1110] = {
    [anon_sym_AT] = ACTIONS(2767),
    [sym_comment] = ACTIONS(46),
  },
  [1111] = {
    [sym_file_descriptor] = ACTIONS(1066),
    [sym_word] = ACTIONS(1066),
    [sym__concat] = ACTIONS(1066),
    [sym_variable_name] = ACTIONS(1066),
    [anon_sym_PIPE] = ACTIONS(1506),
    [anon_sym_RPAREN] = ACTIONS(1066),
    [anon_sym_PIPE_AMP] = ACTIONS(1066),
    [anon_sym_AMP_AMP] = ACTIONS(1066),
    [anon_sym_PIPE_PIPE] = ACTIONS(1066),
    [anon_sym_LT] = ACTIONS(1506),
    [anon_sym_GT] = ACTIONS(1506),
    [anon_sym_GT_GT] = ACTIONS(1066),
    [anon_sym_AMP_GT] = ACTIONS(1506),
    [anon_sym_AMP_GT_GT] = ACTIONS(1066),
    [anon_sym_LT_AMP] = ACTIONS(1066),
    [anon_sym_GT_AMP] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(1066),
    [sym_raw_string] = ACTIONS(1066),
    [anon_sym_DOLLAR] = ACTIONS(1506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1066),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1066),
    [anon_sym_BQUOTE] = ACTIONS(1066),
    [anon_sym_LT_LPAREN] = ACTIONS(1066),
    [anon_sym_GT_LPAREN] = ACTIONS(1066),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1506),
  },
  [1112] = {
    [sym_file_descriptor] = ACTIONS(1122),
    [sym_word] = ACTIONS(1122),
    [sym__concat] = ACTIONS(1122),
    [sym_variable_name] = ACTIONS(1122),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_RPAREN] = ACTIONS(1122),
    [anon_sym_PIPE_AMP] = ACTIONS(1122),
    [anon_sym_AMP_AMP] = ACTIONS(1122),
    [anon_sym_PIPE_PIPE] = ACTIONS(1122),
    [anon_sym_LT] = ACTIONS(1508),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_GT_GT] = ACTIONS(1122),
    [anon_sym_AMP_GT] = ACTIONS(1508),
    [anon_sym_AMP_GT_GT] = ACTIONS(1122),
    [anon_sym_LT_AMP] = ACTIONS(1122),
    [anon_sym_GT_AMP] = ACTIONS(1122),
    [anon_sym_DQUOTE] = ACTIONS(1122),
    [sym_raw_string] = ACTIONS(1122),
    [anon_sym_DOLLAR] = ACTIONS(1508),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1122),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1122),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [anon_sym_LT_LPAREN] = ACTIONS(1122),
    [anon_sym_GT_LPAREN] = ACTIONS(1122),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1508),
  },
  [1113] = {
    [sym_do_group] = STATE(1347),
    [anon_sym_do] = ACTIONS(1010),
    [sym_comment] = ACTIONS(46),
  },
  [1114] = {
    [anon_sym_PIPE] = ACTIONS(2769),
    [anon_sym_RPAREN] = ACTIONS(2771),
    [anon_sym_PIPE_AMP] = ACTIONS(2771),
    [anon_sym_AMP_AMP] = ACTIONS(2771),
    [anon_sym_PIPE_PIPE] = ACTIONS(2771),
    [anon_sym_BQUOTE] = ACTIONS(2771),
    [sym_comment] = ACTIONS(46),
  },
  [1115] = {
    [anon_sym_PIPE] = ACTIONS(2773),
    [anon_sym_RPAREN] = ACTIONS(2775),
    [anon_sym_PIPE_AMP] = ACTIONS(2775),
    [anon_sym_AMP_AMP] = ACTIONS(2775),
    [anon_sym_PIPE_PIPE] = ACTIONS(2775),
    [anon_sym_BQUOTE] = ACTIONS(2775),
    [sym_comment] = ACTIONS(46),
  },
  [1116] = {
    [anon_sym_fi] = ACTIONS(2777),
    [sym_comment] = ACTIONS(46),
  },
  [1117] = {
    [sym_elif_clause] = STATE(420),
    [sym_else_clause] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(706),
    [anon_sym_fi] = ACTIONS(2777),
    [anon_sym_elif] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1352),
    [sym_comment] = ACTIONS(46),
  },
  [1118] = {
    [anon_sym_PIPE] = ACTIONS(2779),
    [anon_sym_RPAREN] = ACTIONS(2781),
    [anon_sym_PIPE_AMP] = ACTIONS(2781),
    [anon_sym_AMP_AMP] = ACTIONS(2781),
    [anon_sym_PIPE_PIPE] = ACTIONS(2781),
    [anon_sym_BQUOTE] = ACTIONS(2781),
    [sym_comment] = ACTIONS(46),
  },
  [1119] = {
    [sym_case_item] = STATE(710),
    [sym_concatenation] = STATE(711),
    [sym_string] = STATE(707),
    [sym_simple_expansion] = STATE(707),
    [sym_expansion] = STATE(707),
    [sym_command_substitution] = STATE(707),
    [sym_process_substitution] = STATE(707),
    [aux_sym_case_statement_repeat1] = STATE(1007),
    [sym_word] = ACTIONS(1354),
    [anon_sym_esac] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1354),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1358),
  },
  [1120] = {
    [sym_case_item] = STATE(710),
    [sym_concatenation] = STATE(711),
    [sym_string] = STATE(707),
    [sym_simple_expansion] = STATE(707),
    [sym_expansion] = STATE(707),
    [sym_command_substitution] = STATE(707),
    [sym_process_substitution] = STATE(707),
    [aux_sym_case_statement_repeat1] = STATE(1351),
    [sym_word] = ACTIONS(1354),
    [anon_sym_esac] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1354),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1358),
  },
  [1121] = {
    [anon_sym_PIPE] = ACTIONS(2785),
    [anon_sym_RPAREN] = ACTIONS(2787),
    [anon_sym_PIPE_AMP] = ACTIONS(2787),
    [anon_sym_AMP_AMP] = ACTIONS(2787),
    [anon_sym_PIPE_PIPE] = ACTIONS(2787),
    [anon_sym_BQUOTE] = ACTIONS(2787),
    [sym_comment] = ACTIONS(46),
  },
  [1122] = {
    [sym_case_item] = STATE(710),
    [sym_concatenation] = STATE(711),
    [sym_string] = STATE(707),
    [sym_simple_expansion] = STATE(707),
    [sym_expansion] = STATE(707),
    [sym_command_substitution] = STATE(707),
    [sym_process_substitution] = STATE(707),
    [aux_sym_case_statement_repeat1] = STATE(1007),
    [sym_word] = ACTIONS(1354),
    [anon_sym_esac] = ACTIONS(2789),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1354),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1358),
  },
  [1123] = {
    [sym_case_item] = STATE(710),
    [sym_concatenation] = STATE(711),
    [sym_string] = STATE(707),
    [sym_simple_expansion] = STATE(707),
    [sym_expansion] = STATE(707),
    [sym_command_substitution] = STATE(707),
    [sym_process_substitution] = STATE(707),
    [aux_sym_case_statement_repeat1] = STATE(1353),
    [sym_word] = ACTIONS(1354),
    [anon_sym_esac] = ACTIONS(2789),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1354),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1358),
  },
  [1124] = {
    [sym_file_redirect] = STATE(1354),
    [sym_file_descriptor] = ACTIONS(1611),
    [anon_sym_PIPE] = ACTIONS(2791),
    [anon_sym_RPAREN] = ACTIONS(2793),
    [anon_sym_PIPE_AMP] = ACTIONS(2793),
    [anon_sym_AMP_AMP] = ACTIONS(2793),
    [anon_sym_PIPE_PIPE] = ACTIONS(2793),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT] = ACTIONS(1617),
    [anon_sym_AMP_GT_GT] = ACTIONS(1619),
    [anon_sym_LT_AMP] = ACTIONS(1619),
    [anon_sym_GT_AMP] = ACTIONS(1619),
    [sym_comment] = ACTIONS(46),
  },
  [1125] = {
    [sym_file_descriptor] = ACTIONS(2083),
    [anon_sym_PIPE] = ACTIONS(2795),
    [anon_sym_RPAREN] = ACTIONS(2083),
    [anon_sym_PIPE_AMP] = ACTIONS(2083),
    [anon_sym_AMP_AMP] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(2083),
    [anon_sym_LT] = ACTIONS(2795),
    [anon_sym_GT] = ACTIONS(2795),
    [anon_sym_GT_GT] = ACTIONS(2083),
    [anon_sym_AMP_GT] = ACTIONS(2795),
    [anon_sym_AMP_GT_GT] = ACTIONS(2083),
    [anon_sym_LT_AMP] = ACTIONS(2083),
    [anon_sym_GT_AMP] = ACTIONS(2083),
    [anon_sym_BQUOTE] = ACTIONS(2083),
    [sym_comment] = ACTIONS(46),
  },
  [1126] = {
    [sym_concatenation] = STATE(1357),
    [sym_string] = STATE(1355),
    [sym_simple_expansion] = STATE(1355),
    [sym_expansion] = STATE(1355),
    [sym_command_substitution] = STATE(1355),
    [sym_process_substitution] = STATE(1355),
    [sym_word] = ACTIONS(2797),
    [anon_sym_DQUOTE] = ACTIONS(2293),
    [sym_raw_string] = ACTIONS(2797),
    [anon_sym_DOLLAR] = ACTIONS(2295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2299),
    [anon_sym_BQUOTE] = ACTIONS(2301),
    [anon_sym_LT_LPAREN] = ACTIONS(2303),
    [anon_sym_GT_LPAREN] = ACTIONS(2303),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2799),
  },
  [1127] = {
    [aux_sym_concatenation_repeat1] = STATE(1359),
    [sym__concat] = ACTIONS(2801),
    [anon_sym_PIPE] = ACTIONS(376),
    [anon_sym_RPAREN] = ACTIONS(372),
    [anon_sym_PIPE_AMP] = ACTIONS(372),
    [anon_sym_AMP_AMP] = ACTIONS(372),
    [anon_sym_PIPE_PIPE] = ACTIONS(372),
    [sym_comment] = ACTIONS(46),
  },
  [1128] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(1361),
    [anon_sym_DQUOTE] = ACTIONS(2803),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [1129] = {
    [sym_special_variable_name] = STATE(1364),
    [anon_sym_DOLLAR] = ACTIONS(2805),
    [anon_sym_POUND] = ACTIONS(2805),
    [anon_sym_AT] = ACTIONS(2805),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2805),
    [anon_sym_QMARK] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_BANG] = ACTIONS(2805),
    [anon_sym_0] = ACTIONS(2809),
    [anon_sym__] = ACTIONS(2809),
  },
  [1130] = {
    [sym_special_variable_name] = STATE(1367),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(2811),
    [anon_sym_AT] = ACTIONS(138),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [1131] = {
    [sym_for_statement] = STATE(1368),
    [sym_while_statement] = STATE(1368),
    [sym_if_statement] = STATE(1368),
    [sym_case_statement] = STATE(1368),
    [sym_function_definition] = STATE(1368),
    [sym_subshell] = STATE(1368),
    [sym_pipeline] = STATE(1368),
    [sym_list] = STATE(1368),
    [sym_command] = STATE(1368),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(1369),
    [sym_declaration_command] = STATE(1368),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [1132] = {
    [sym_for_statement] = STATE(1370),
    [sym_while_statement] = STATE(1370),
    [sym_if_statement] = STATE(1370),
    [sym_case_statement] = STATE(1370),
    [sym_function_definition] = STATE(1370),
    [sym_subshell] = STATE(1370),
    [sym_pipeline] = STATE(1370),
    [sym_list] = STATE(1370),
    [sym_command] = STATE(1370),
    [sym_command_name] = STATE(118),
    [sym_variable_assignment] = STATE(1371),
    [sym_declaration_command] = STATE(1370),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(112),
    [sym_simple_expansion] = STATE(112),
    [sym_expansion] = STATE(112),
    [sym_command_substitution] = STATE(112),
    [sym_process_substitution] = STATE(112),
    [aux_sym_command_repeat1] = STATE(121),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(178),
    [sym_variable_name] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(184),
    [anon_sym_typeset] = ACTIONS(184),
    [anon_sym_export] = ACTIONS(184),
    [anon_sym_readonly] = ACTIONS(184),
    [anon_sym_local] = ACTIONS(184),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(178),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(186),
  },
  [1133] = {
    [sym_for_statement] = STATE(1372),
    [sym_while_statement] = STATE(1372),
    [sym_if_statement] = STATE(1372),
    [sym_case_statement] = STATE(1372),
    [sym_function_definition] = STATE(1372),
    [sym_subshell] = STATE(1372),
    [sym_pipeline] = STATE(1372),
    [sym_list] = STATE(1372),
    [sym_command] = STATE(1372),
    [sym_command_name] = STATE(107),
    [sym_variable_assignment] = STATE(1373),
    [sym_declaration_command] = STATE(1372),
    [sym_subscript] = STATE(109),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(90),
    [sym_simple_expansion] = STATE(90),
    [sym_expansion] = STATE(90),
    [sym_command_substitution] = STATE(90),
    [sym_process_substitution] = STATE(90),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(146),
    [sym_variable_name] = ACTIONS(148),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_while] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(154),
    [anon_sym_case] = ACTIONS(156),
    [anon_sym_function] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_declare] = ACTIONS(162),
    [anon_sym_typeset] = ACTIONS(162),
    [anon_sym_export] = ACTIONS(162),
    [anon_sym_readonly] = ACTIONS(162),
    [anon_sym_local] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(164),
    [sym_raw_string] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [anon_sym_LT_LPAREN] = ACTIONS(174),
    [anon_sym_GT_LPAREN] = ACTIONS(174),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(176),
  },
  [1134] = {
    [aux_sym_concatenation_repeat1] = STATE(1374),
    [sym__concat] = ACTIONS(2801),
    [anon_sym_PIPE] = ACTIONS(392),
    [anon_sym_RPAREN] = ACTIONS(390),
    [anon_sym_PIPE_AMP] = ACTIONS(390),
    [anon_sym_AMP_AMP] = ACTIONS(390),
    [anon_sym_PIPE_PIPE] = ACTIONS(390),
    [sym_comment] = ACTIONS(46),
  },
  [1135] = {
    [anon_sym_PIPE] = ACTIONS(376),
    [anon_sym_RPAREN] = ACTIONS(372),
    [anon_sym_PIPE_AMP] = ACTIONS(372),
    [anon_sym_AMP_AMP] = ACTIONS(372),
    [anon_sym_PIPE_PIPE] = ACTIONS(372),
    [anon_sym_BQUOTE] = ACTIONS(372),
    [sym_comment] = ACTIONS(46),
  },
  [1136] = {
    [anon_sym_PIPE] = ACTIONS(2815),
    [anon_sym_RPAREN] = ACTIONS(2817),
    [anon_sym_PIPE_AMP] = ACTIONS(2817),
    [anon_sym_AMP_AMP] = ACTIONS(2817),
    [anon_sym_PIPE_PIPE] = ACTIONS(2817),
    [anon_sym_BQUOTE] = ACTIONS(2817),
    [sym_comment] = ACTIONS(46),
  },
  [1137] = {
    [sym_string] = STATE(1375),
    [sym_simple_expansion] = STATE(1375),
    [sym_expansion] = STATE(1375),
    [sym_command_substitution] = STATE(1375),
    [sym_process_substitution] = STATE(1375),
    [sym_word] = ACTIONS(2819),
    [anon_sym_DQUOTE] = ACTIONS(1637),
    [sym_raw_string] = ACTIONS(2819),
    [anon_sym_DOLLAR] = ACTIONS(1639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1641),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1643),
    [anon_sym_BQUOTE] = ACTIONS(1645),
    [anon_sym_LT_LPAREN] = ACTIONS(1647),
    [anon_sym_GT_LPAREN] = ACTIONS(1647),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2821),
  },
  [1138] = {
    [aux_sym_concatenation_repeat1] = STATE(1377),
    [sym_word] = ACTIONS(254),
    [sym__concat] = ACTIONS(2317),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_RPAREN] = ACTIONS(254),
    [anon_sym_PIPE_AMP] = ACTIONS(254),
    [anon_sym_AMP_AMP] = ACTIONS(254),
    [anon_sym_PIPE_PIPE] = ACTIONS(254),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(877),
  },
  [1139] = {
    [sym_word] = ACTIONS(1226),
    [sym_variable_name] = ACTIONS(1226),
    [anon_sym_PIPE] = ACTIONS(2231),
    [anon_sym_RPAREN] = ACTIONS(1226),
    [anon_sym_PIPE_AMP] = ACTIONS(1226),
    [anon_sym_AMP_AMP] = ACTIONS(1226),
    [anon_sym_PIPE_PIPE] = ACTIONS(1226),
    [anon_sym_BQUOTE] = ACTIONS(1226),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2231),
  },
  [1140] = {
    [sym_concatenation] = STATE(364),
    [sym_string] = STATE(355),
    [sym_simple_expansion] = STATE(355),
    [sym_expansion] = STATE(355),
    [sym_command_substitution] = STATE(355),
    [sym_process_substitution] = STATE(355),
    [aux_sym_for_statement_repeat1] = STATE(648),
    [sym_word] = ACTIONS(692),
    [anon_sym_RPAREN] = ACTIONS(2823),
    [anon_sym_DQUOTE] = ACTIONS(696),
    [sym_raw_string] = ACTIONS(692),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(700),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(702),
    [anon_sym_BQUOTE] = ACTIONS(704),
    [anon_sym_LT_LPAREN] = ACTIONS(706),
    [anon_sym_GT_LPAREN] = ACTIONS(706),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(708),
  },
  [1141] = {
    [sym_word] = ACTIONS(394),
    [sym__concat] = ACTIONS(394),
    [sym_variable_name] = ACTIONS(394),
    [anon_sym_PIPE] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(394),
    [anon_sym_PIPE_AMP] = ACTIONS(394),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_BQUOTE] = ACTIONS(394),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(879),
  },
  [1142] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(252),
    [anon_sym_DQUOTE] = ACTIONS(2825),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [1143] = {
    [sym_word] = ACTIONS(412),
    [sym__concat] = ACTIONS(412),
    [sym_variable_name] = ACTIONS(412),
    [anon_sym_PIPE] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(412),
    [anon_sym_PIPE_AMP] = ACTIONS(412),
    [anon_sym_AMP_AMP] = ACTIONS(412),
    [anon_sym_PIPE_PIPE] = ACTIONS(412),
    [anon_sym_BQUOTE] = ACTIONS(412),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(424),
  },
  [1144] = {
    [sym_word] = ACTIONS(416),
    [sym__concat] = ACTIONS(416),
    [sym_variable_name] = ACTIONS(416),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_RPAREN] = ACTIONS(416),
    [anon_sym_PIPE_AMP] = ACTIONS(416),
    [anon_sym_AMP_AMP] = ACTIONS(416),
    [anon_sym_PIPE_PIPE] = ACTIONS(416),
    [anon_sym_BQUOTE] = ACTIONS(416),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(883),
  },
  [1145] = {
    [sym_word] = ACTIONS(420),
    [sym__concat] = ACTIONS(420),
    [sym_variable_name] = ACTIONS(420),
    [anon_sym_PIPE] = ACTIONS(885),
    [anon_sym_RPAREN] = ACTIONS(420),
    [anon_sym_PIPE_AMP] = ACTIONS(420),
    [anon_sym_AMP_AMP] = ACTIONS(420),
    [anon_sym_PIPE_PIPE] = ACTIONS(420),
    [anon_sym_BQUOTE] = ACTIONS(420),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(885),
  },
  [1146] = {
    [sym_special_variable_name] = STATE(1381),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_EQ] = ACTIONS(412),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(138),
    [anon_sym_AT] = ACTIONS(138),
    [anon_sym_COLON] = ACTIONS(424),
    [anon_sym_COLON_QMARK] = ACTIONS(412),
    [anon_sym_COLON_DASH] = ACTIONS(412),
    [anon_sym_PERCENT] = ACTIONS(412),
    [anon_sym_SLASH] = ACTIONS(412),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [1147] = {
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_EQ] = ACTIONS(2831),
    [anon_sym_LBRACK] = ACTIONS(2833),
    [anon_sym_COLON] = ACTIONS(2835),
    [anon_sym_COLON_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_DASH] = ACTIONS(2831),
    [anon_sym_PERCENT] = ACTIONS(2831),
    [anon_sym_SLASH] = ACTIONS(2831),
    [sym_comment] = ACTIONS(46),
  },
  [1148] = {
    [anon_sym_RBRACE] = ACTIONS(2837),
    [anon_sym_EQ] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(2841),
    [anon_sym_COLON] = ACTIONS(2843),
    [anon_sym_COLON_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_DASH] = ACTIONS(2839),
    [anon_sym_PERCENT] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(2839),
    [sym_comment] = ACTIONS(46),
  },
  [1149] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(2845),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [1150] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(2845),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [1151] = {
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_BQUOTE] = ACTIONS(2845),
    [sym_comment] = ACTIONS(46),
  },
  [1152] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(2845),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [1153] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(2847),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [1154] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(2847),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [1155] = {
    [aux_sym_concatenation_repeat1] = STATE(1377),
    [sym_word] = ACTIONS(542),
    [sym__concat] = ACTIONS(2317),
    [sym_variable_name] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(542),
    [anon_sym_AMP_AMP] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(909),
  },
  [1156] = {
    [anon_sym_RBRACK] = ACTIONS(2849),
    [sym_comment] = ACTIONS(46),
  },
  [1157] = {
    [anon_sym_RBRACK] = ACTIONS(2851),
    [sym_comment] = ACTIONS(46),
  },
  [1158] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2853),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1159] = {
    [sym_file_descriptor] = ACTIONS(2205),
    [sym_word] = ACTIONS(2205),
    [sym__concat] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2696),
    [anon_sym_RPAREN] = ACTIONS(2205),
    [anon_sym_PIPE_AMP] = ACTIONS(2205),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_PIPE_PIPE] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2696),
    [anon_sym_GT] = ACTIONS(2696),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [anon_sym_AMP_GT] = ACTIONS(2696),
    [anon_sym_AMP_GT_GT] = ACTIONS(2205),
    [anon_sym_LT_AMP] = ACTIONS(2205),
    [anon_sym_GT_AMP] = ACTIONS(2205),
    [anon_sym_LT_LT] = ACTIONS(2696),
    [anon_sym_LT_LT_DASH] = ACTIONS(2205),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [sym_raw_string] = ACTIONS(2205),
    [anon_sym_DOLLAR] = ACTIONS(2696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2205),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [anon_sym_LT_LPAREN] = ACTIONS(2205),
    [anon_sym_GT_LPAREN] = ACTIONS(2205),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2696),
  },
  [1160] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1161] = {
    [sym_file_descriptor] = ACTIONS(2211),
    [sym_word] = ACTIONS(2211),
    [sym__concat] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2700),
    [anon_sym_RPAREN] = ACTIONS(2211),
    [anon_sym_PIPE_AMP] = ACTIONS(2211),
    [anon_sym_AMP_AMP] = ACTIONS(2211),
    [anon_sym_PIPE_PIPE] = ACTIONS(2211),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_GT] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2211),
    [anon_sym_AMP_GT] = ACTIONS(2700),
    [anon_sym_AMP_GT_GT] = ACTIONS(2211),
    [anon_sym_LT_AMP] = ACTIONS(2211),
    [anon_sym_GT_AMP] = ACTIONS(2211),
    [anon_sym_LT_LT] = ACTIONS(2700),
    [anon_sym_LT_LT_DASH] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_raw_string] = ACTIONS(2211),
    [anon_sym_DOLLAR] = ACTIONS(2700),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2211),
    [anon_sym_BQUOTE] = ACTIONS(2211),
    [anon_sym_LT_LPAREN] = ACTIONS(2211),
    [anon_sym_GT_LPAREN] = ACTIONS(2211),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2700),
  },
  [1162] = {
    [anon_sym_RBRACE] = ACTIONS(2853),
    [sym_comment] = ACTIONS(46),
  },
  [1163] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1164] = {
    [sym_file_descriptor] = ACTIONS(2217),
    [sym_word] = ACTIONS(2217),
    [sym__concat] = ACTIONS(2217),
    [anon_sym_PIPE] = ACTIONS(2704),
    [anon_sym_RPAREN] = ACTIONS(2217),
    [anon_sym_PIPE_AMP] = ACTIONS(2217),
    [anon_sym_AMP_AMP] = ACTIONS(2217),
    [anon_sym_PIPE_PIPE] = ACTIONS(2217),
    [anon_sym_LT] = ACTIONS(2704),
    [anon_sym_GT] = ACTIONS(2704),
    [anon_sym_GT_GT] = ACTIONS(2217),
    [anon_sym_AMP_GT] = ACTIONS(2704),
    [anon_sym_AMP_GT_GT] = ACTIONS(2217),
    [anon_sym_LT_AMP] = ACTIONS(2217),
    [anon_sym_GT_AMP] = ACTIONS(2217),
    [anon_sym_LT_LT] = ACTIONS(2704),
    [anon_sym_LT_LT_DASH] = ACTIONS(2217),
    [anon_sym_DQUOTE] = ACTIONS(2217),
    [sym_raw_string] = ACTIONS(2217),
    [anon_sym_DOLLAR] = ACTIONS(2704),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2217),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2217),
    [anon_sym_BQUOTE] = ACTIONS(2217),
    [anon_sym_LT_LPAREN] = ACTIONS(2217),
    [anon_sym_GT_LPAREN] = ACTIONS(2217),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2704),
  },
  [1165] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1166] = {
    [sym_file_descriptor] = ACTIONS(2223),
    [sym_word] = ACTIONS(2223),
    [sym__concat] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2708),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_PIPE_AMP] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_LT] = ACTIONS(2708),
    [anon_sym_GT] = ACTIONS(2708),
    [anon_sym_GT_GT] = ACTIONS(2223),
    [anon_sym_AMP_GT] = ACTIONS(2708),
    [anon_sym_AMP_GT_GT] = ACTIONS(2223),
    [anon_sym_LT_AMP] = ACTIONS(2223),
    [anon_sym_GT_AMP] = ACTIONS(2223),
    [anon_sym_LT_LT] = ACTIONS(2708),
    [anon_sym_LT_LT_DASH] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2223),
    [sym_raw_string] = ACTIONS(2223),
    [anon_sym_DOLLAR] = ACTIONS(2708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2223),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2223),
    [anon_sym_BQUOTE] = ACTIONS(2223),
    [anon_sym_LT_LPAREN] = ACTIONS(2223),
    [anon_sym_GT_LPAREN] = ACTIONS(2223),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2708),
  },
  [1167] = {
    [anon_sym_RBRACE] = ACTIONS(2857),
    [sym_comment] = ACTIONS(46),
  },
  [1168] = {
    [anon_sym_PIPE] = ACTIONS(2861),
    [anon_sym_RPAREN] = ACTIONS(2863),
    [anon_sym_PIPE_AMP] = ACTIONS(2863),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_BQUOTE] = ACTIONS(2863),
    [sym_comment] = ACTIONS(46),
  },
  [1169] = {
    [sym_file_descriptor] = ACTIONS(675),
    [sym__concat] = ACTIONS(675),
    [anon_sym_PIPE] = ACTIONS(1471),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_PIPE_AMP] = ACTIONS(675),
    [anon_sym_AMP_AMP] = ACTIONS(675),
    [anon_sym_PIPE_PIPE] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_GT_GT] = ACTIONS(675),
    [anon_sym_AMP_GT] = ACTIONS(1471),
    [anon_sym_AMP_GT_GT] = ACTIONS(675),
    [anon_sym_LT_AMP] = ACTIONS(675),
    [anon_sym_GT_AMP] = ACTIONS(675),
    [anon_sym_LT_LT] = ACTIONS(1471),
    [anon_sym_LT_LT_DASH] = ACTIONS(675),
    [anon_sym_BQUOTE] = ACTIONS(675),
    [sym_comment] = ACTIONS(46),
  },
  [1170] = {
    [sym_file_descriptor] = ACTIONS(679),
    [sym__concat] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(1473),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(1473),
    [anon_sym_GT] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(1473),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(1473),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(679),
    [sym_comment] = ACTIONS(46),
  },
  [1171] = {
    [aux_sym_concatenation_repeat1] = STATE(1171),
    [sym_file_descriptor] = ACTIONS(675),
    [sym__concat] = ACTIONS(2865),
    [anon_sym_PIPE] = ACTIONS(1471),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_PIPE_AMP] = ACTIONS(675),
    [anon_sym_AMP_AMP] = ACTIONS(675),
    [anon_sym_PIPE_PIPE] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_GT_GT] = ACTIONS(675),
    [anon_sym_AMP_GT] = ACTIONS(1471),
    [anon_sym_AMP_GT_GT] = ACTIONS(675),
    [anon_sym_LT_AMP] = ACTIONS(675),
    [anon_sym_GT_AMP] = ACTIONS(675),
    [anon_sym_LT_LT] = ACTIONS(1471),
    [anon_sym_LT_LT_DASH] = ACTIONS(675),
    [sym_comment] = ACTIONS(46),
  },
  [1172] = {
    [sym_file_descriptor] = ACTIONS(931),
    [sym__concat] = ACTIONS(931),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_RPAREN] = ACTIONS(931),
    [anon_sym_PIPE_AMP] = ACTIONS(931),
    [anon_sym_AMP_AMP] = ACTIONS(931),
    [anon_sym_PIPE_PIPE] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1478),
    [anon_sym_GT_GT] = ACTIONS(931),
    [anon_sym_AMP_GT] = ACTIONS(1478),
    [anon_sym_AMP_GT_GT] = ACTIONS(931),
    [anon_sym_LT_AMP] = ACTIONS(931),
    [anon_sym_GT_AMP] = ACTIONS(931),
    [anon_sym_LT_LT] = ACTIONS(1478),
    [anon_sym_LT_LT_DASH] = ACTIONS(931),
    [anon_sym_BQUOTE] = ACTIONS(931),
    [sym_comment] = ACTIONS(46),
  },
  [1173] = {
    [anon_sym_RBRACE] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [sym_comment] = ACTIONS(46),
  },
  [1174] = {
    [anon_sym_RBRACE] = ACTIONS(2872),
    [anon_sym_LBRACK] = ACTIONS(2874),
    [sym_comment] = ACTIONS(46),
  },
  [1175] = {
    [sym_file_descriptor] = ACTIONS(960),
    [sym__concat] = ACTIONS(960),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_RPAREN] = ACTIONS(960),
    [anon_sym_PIPE_AMP] = ACTIONS(960),
    [anon_sym_AMP_AMP] = ACTIONS(960),
    [anon_sym_PIPE_PIPE] = ACTIONS(960),
    [anon_sym_LT] = ACTIONS(1488),
    [anon_sym_GT] = ACTIONS(1488),
    [anon_sym_GT_GT] = ACTIONS(960),
    [anon_sym_AMP_GT] = ACTIONS(1488),
    [anon_sym_AMP_GT_GT] = ACTIONS(960),
    [anon_sym_LT_AMP] = ACTIONS(960),
    [anon_sym_GT_AMP] = ACTIONS(960),
    [anon_sym_LT_LT] = ACTIONS(1488),
    [anon_sym_LT_LT_DASH] = ACTIONS(960),
    [anon_sym_BQUOTE] = ACTIONS(960),
    [sym_comment] = ACTIONS(46),
  },
  [1176] = {
    [sym_concatenation] = STATE(1403),
    [sym_string] = STATE(1400),
    [sym_simple_expansion] = STATE(1400),
    [sym_expansion] = STATE(1400),
    [sym_command_substitution] = STATE(1400),
    [sym_process_substitution] = STATE(1400),
    [sym_word] = ACTIONS(2876),
    [anon_sym_RBRACE] = ACTIONS(2878),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2880),
  },
  [1177] = {
    [anon_sym_AT] = ACTIONS(2882),
    [sym_comment] = ACTIONS(46),
  },
  [1178] = {
    [sym_file_descriptor] = ACTIONS(972),
    [sym__concat] = ACTIONS(972),
    [anon_sym_PIPE] = ACTIONS(1498),
    [anon_sym_RPAREN] = ACTIONS(972),
    [anon_sym_PIPE_AMP] = ACTIONS(972),
    [anon_sym_AMP_AMP] = ACTIONS(972),
    [anon_sym_PIPE_PIPE] = ACTIONS(972),
    [anon_sym_LT] = ACTIONS(1498),
    [anon_sym_GT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(972),
    [anon_sym_AMP_GT] = ACTIONS(1498),
    [anon_sym_AMP_GT_GT] = ACTIONS(972),
    [anon_sym_LT_AMP] = ACTIONS(972),
    [anon_sym_GT_AMP] = ACTIONS(972),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_LT_LT_DASH] = ACTIONS(972),
    [anon_sym_BQUOTE] = ACTIONS(972),
    [sym_comment] = ACTIONS(46),
  },
  [1179] = {
    [sym_concatenation] = STATE(1407),
    [sym_string] = STATE(1405),
    [sym_simple_expansion] = STATE(1405),
    [sym_expansion] = STATE(1405),
    [sym_command_substitution] = STATE(1405),
    [sym_process_substitution] = STATE(1405),
    [sym_word] = ACTIONS(2884),
    [anon_sym_RBRACE] = ACTIONS(2872),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(2884),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2886),
  },
  [1180] = {
    [anon_sym_AT] = ACTIONS(2888),
    [sym_comment] = ACTIONS(46),
  },
  [1181] = {
    [sym_file_descriptor] = ACTIONS(1066),
    [sym__concat] = ACTIONS(1066),
    [anon_sym_PIPE] = ACTIONS(1506),
    [anon_sym_RPAREN] = ACTIONS(1066),
    [anon_sym_PIPE_AMP] = ACTIONS(1066),
    [anon_sym_AMP_AMP] = ACTIONS(1066),
    [anon_sym_PIPE_PIPE] = ACTIONS(1066),
    [anon_sym_LT] = ACTIONS(1506),
    [anon_sym_GT] = ACTIONS(1506),
    [anon_sym_GT_GT] = ACTIONS(1066),
    [anon_sym_AMP_GT] = ACTIONS(1506),
    [anon_sym_AMP_GT_GT] = ACTIONS(1066),
    [anon_sym_LT_AMP] = ACTIONS(1066),
    [anon_sym_GT_AMP] = ACTIONS(1066),
    [anon_sym_LT_LT] = ACTIONS(1506),
    [anon_sym_LT_LT_DASH] = ACTIONS(1066),
    [anon_sym_BQUOTE] = ACTIONS(1066),
    [sym_comment] = ACTIONS(46),
  },
  [1182] = {
    [sym_file_descriptor] = ACTIONS(1122),
    [sym__concat] = ACTIONS(1122),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_RPAREN] = ACTIONS(1122),
    [anon_sym_PIPE_AMP] = ACTIONS(1122),
    [anon_sym_AMP_AMP] = ACTIONS(1122),
    [anon_sym_PIPE_PIPE] = ACTIONS(1122),
    [anon_sym_LT] = ACTIONS(1508),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_GT_GT] = ACTIONS(1122),
    [anon_sym_AMP_GT] = ACTIONS(1508),
    [anon_sym_AMP_GT_GT] = ACTIONS(1122),
    [anon_sym_LT_AMP] = ACTIONS(1122),
    [anon_sym_GT_AMP] = ACTIONS(1122),
    [anon_sym_LT_LT] = ACTIONS(1508),
    [anon_sym_LT_LT_DASH] = ACTIONS(1122),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_comment] = ACTIONS(46),
  },
  [1183] = {
    [sym_file_descriptor] = ACTIONS(2450),
    [anon_sym_PIPE] = ACTIONS(2890),
    [anon_sym_RPAREN] = ACTIONS(2450),
    [anon_sym_PIPE_AMP] = ACTIONS(2450),
    [anon_sym_AMP_AMP] = ACTIONS(2450),
    [anon_sym_PIPE_PIPE] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2890),
    [anon_sym_GT] = ACTIONS(2890),
    [anon_sym_GT_GT] = ACTIONS(2450),
    [anon_sym_AMP_GT] = ACTIONS(2890),
    [anon_sym_AMP_GT_GT] = ACTIONS(2450),
    [anon_sym_LT_AMP] = ACTIONS(2450),
    [anon_sym_GT_AMP] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2890),
    [anon_sym_LT_LT_DASH] = ACTIONS(2450),
    [anon_sym_BQUOTE] = ACTIONS(2450),
    [sym_comment] = ACTIONS(46),
  },
  [1184] = {
    [aux_sym_concatenation_repeat1] = STATE(1184),
    [sym_file_descriptor] = ACTIONS(675),
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(2742),
    [sym_variable_name] = ACTIONS(675),
    [anon_sym_PIPE] = ACTIONS(1471),
    [anon_sym_PIPE_AMP] = ACTIONS(675),
    [anon_sym_AMP_AMP] = ACTIONS(675),
    [anon_sym_PIPE_PIPE] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_GT_GT] = ACTIONS(675),
    [anon_sym_AMP_GT] = ACTIONS(1471),
    [anon_sym_AMP_GT_GT] = ACTIONS(675),
    [anon_sym_LT_AMP] = ACTIONS(675),
    [anon_sym_GT_AMP] = ACTIONS(675),
    [anon_sym_DQUOTE] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(1471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(675),
    [anon_sym_BQUOTE] = ACTIONS(675),
    [anon_sym_LT_LPAREN] = ACTIONS(675),
    [anon_sym_GT_LPAREN] = ACTIONS(675),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1471),
  },
  [1185] = {
    [sym_file_redirect] = STATE(1354),
    [sym_file_descriptor] = ACTIONS(1767),
    [anon_sym_PIPE] = ACTIONS(2791),
    [anon_sym_PIPE_AMP] = ACTIONS(2793),
    [anon_sym_AMP_AMP] = ACTIONS(2793),
    [anon_sym_PIPE_PIPE] = ACTIONS(2793),
    [anon_sym_LT] = ACTIONS(1769),
    [anon_sym_GT] = ACTIONS(1769),
    [anon_sym_GT_GT] = ACTIONS(1771),
    [anon_sym_AMP_GT] = ACTIONS(1769),
    [anon_sym_AMP_GT_GT] = ACTIONS(1771),
    [anon_sym_LT_AMP] = ACTIONS(1771),
    [anon_sym_GT_AMP] = ACTIONS(1771),
    [anon_sym_BQUOTE] = ACTIONS(2793),
    [sym_comment] = ACTIONS(46),
  },
  [1186] = {
    [sym_concatenation] = STATE(1357),
    [sym_string] = STATE(1409),
    [sym_simple_expansion] = STATE(1409),
    [sym_expansion] = STATE(1409),
    [sym_command_substitution] = STATE(1409),
    [sym_process_substitution] = STATE(1409),
    [sym_word] = ACTIONS(2892),
    [anon_sym_DQUOTE] = ACTIONS(2293),
    [sym_raw_string] = ACTIONS(2892),
    [anon_sym_DOLLAR] = ACTIONS(2295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2299),
    [anon_sym_BQUOTE] = ACTIONS(2301),
    [anon_sym_LT_LPAREN] = ACTIONS(2303),
    [anon_sym_GT_LPAREN] = ACTIONS(2303),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2894),
  },
  [1187] = {
    [aux_sym_concatenation_repeat1] = STATE(1411),
    [sym__concat] = ACTIONS(2801),
    [anon_sym_PIPE] = ACTIONS(376),
    [anon_sym_PIPE_AMP] = ACTIONS(372),
    [anon_sym_AMP_AMP] = ACTIONS(372),
    [anon_sym_PIPE_PIPE] = ACTIONS(372),
    [anon_sym_BQUOTE] = ACTIONS(372),
    [sym_comment] = ACTIONS(46),
  },
  [1188] = {
    [aux_sym_concatenation_repeat1] = STATE(1412),
    [sym__concat] = ACTIONS(2801),
    [anon_sym_PIPE] = ACTIONS(392),
    [anon_sym_PIPE_AMP] = ACTIONS(390),
    [anon_sym_AMP_AMP] = ACTIONS(390),
    [anon_sym_PIPE_PIPE] = ACTIONS(390),
    [anon_sym_BQUOTE] = ACTIONS(390),
    [sym_comment] = ACTIONS(46),
  },
  [1189] = {
    [aux_sym_concatenation_repeat1] = STATE(1413),
    [sym_word] = ACTIONS(254),
    [sym__concat] = ACTIONS(2317),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_PIPE_AMP] = ACTIONS(254),
    [anon_sym_AMP_AMP] = ACTIONS(254),
    [anon_sym_PIPE_PIPE] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(877),
  },
  [1190] = {
    [aux_sym_concatenation_repeat1] = STATE(1413),
    [sym_word] = ACTIONS(542),
    [sym__concat] = ACTIONS(2317),
    [sym_variable_name] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(909),
    [anon_sym_PIPE_AMP] = ACTIONS(542),
    [anon_sym_AMP_AMP] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [anon_sym_BQUOTE] = ACTIONS(542),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(909),
  },
  [1191] = {
    [aux_sym_concatenation_repeat1] = STATE(1191),
    [sym_file_descriptor] = ACTIONS(675),
    [sym__concat] = ACTIONS(2865),
    [anon_sym_PIPE] = ACTIONS(1471),
    [anon_sym_PIPE_AMP] = ACTIONS(675),
    [anon_sym_AMP_AMP] = ACTIONS(675),
    [anon_sym_PIPE_PIPE] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_GT_GT] = ACTIONS(675),
    [anon_sym_AMP_GT] = ACTIONS(1471),
    [anon_sym_AMP_GT_GT] = ACTIONS(675),
    [anon_sym_LT_AMP] = ACTIONS(675),
    [anon_sym_GT_AMP] = ACTIONS(675),
    [anon_sym_LT_LT] = ACTIONS(1471),
    [anon_sym_LT_LT_DASH] = ACTIONS(675),
    [anon_sym_BQUOTE] = ACTIONS(675),
    [sym_comment] = ACTIONS(46),
  },
  [1192] = {
    [sym_file_descriptor] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1534),
    [anon_sym_RPAREN] = ACTIONS(1534),
    [anon_sym_SEMI_SEMI] = ACTIONS(1534),
    [anon_sym_PIPE_AMP] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1534),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_GT_GT] = ACTIONS(1534),
    [anon_sym_AMP_GT] = ACTIONS(1534),
    [anon_sym_AMP_GT_GT] = ACTIONS(1534),
    [anon_sym_LT_AMP] = ACTIONS(1534),
    [anon_sym_GT_AMP] = ACTIONS(1534),
    [anon_sym_LT_LT] = ACTIONS(1534),
    [anon_sym_LT_LT_DASH] = ACTIONS(1534),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1534),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_AMP] = ACTIONS(1534),
  },
  [1193] = {
    [anon_sym_AT] = ACTIONS(2896),
    [sym_comment] = ACTIONS(46),
  },
  [1194] = {
    [sym_file_descriptor] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(1540),
    [anon_sym_RPAREN] = ACTIONS(1540),
    [anon_sym_SEMI_SEMI] = ACTIONS(1540),
    [anon_sym_PIPE_AMP] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1540),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1540),
    [anon_sym_GT_GT] = ACTIONS(1540),
    [anon_sym_AMP_GT] = ACTIONS(1540),
    [anon_sym_AMP_GT_GT] = ACTIONS(1540),
    [anon_sym_LT_AMP] = ACTIONS(1540),
    [anon_sym_GT_AMP] = ACTIONS(1540),
    [anon_sym_LT_LT] = ACTIONS(1540),
    [anon_sym_LT_LT_DASH] = ACTIONS(1540),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_LF] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1540),
  },
  [1195] = {
    [anon_sym_AT] = ACTIONS(2898),
    [sym_comment] = ACTIONS(46),
  },
  [1196] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(2900),
    [anon_sym_RBRACE] = ACTIONS(2902),
    [sym_comment] = ACTIONS(46),
  },
  [1197] = {
    [sym_file_descriptor] = ACTIONS(1548),
    [sym__concat] = ACTIONS(1548),
    [anon_sym_PIPE] = ACTIONS(1550),
    [anon_sym_RPAREN] = ACTIONS(1550),
    [anon_sym_SEMI_SEMI] = ACTIONS(1550),
    [anon_sym_PIPE_AMP] = ACTIONS(1550),
    [anon_sym_AMP_AMP] = ACTIONS(1550),
    [anon_sym_PIPE_PIPE] = ACTIONS(1550),
    [anon_sym_LT] = ACTIONS(1550),
    [anon_sym_GT] = ACTIONS(1550),
    [anon_sym_GT_GT] = ACTIONS(1550),
    [anon_sym_AMP_GT] = ACTIONS(1550),
    [anon_sym_AMP_GT_GT] = ACTIONS(1550),
    [anon_sym_LT_AMP] = ACTIONS(1550),
    [anon_sym_GT_AMP] = ACTIONS(1550),
    [anon_sym_LT_LT] = ACTIONS(1550),
    [anon_sym_LT_LT_DASH] = ACTIONS(1550),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1550),
    [anon_sym_LF] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(1550),
  },
  [1198] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(2904),
    [anon_sym_RBRACE] = ACTIONS(2906),
    [sym_comment] = ACTIONS(46),
  },
  [1199] = {
    [sym__concat] = ACTIONS(2908),
    [anon_sym_RBRACE] = ACTIONS(2902),
    [sym_comment] = ACTIONS(46),
  },
  [1200] = {
    [anon_sym_RBRACK] = ACTIONS(2908),
    [sym_comment] = ACTIONS(46),
  },
  [1201] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(2910),
    [anon_sym_RBRACE] = ACTIONS(2912),
    [sym_comment] = ACTIONS(46),
  },
  [1202] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(2914),
    [anon_sym_RBRACE] = ACTIONS(2916),
    [sym_comment] = ACTIONS(46),
  },
  [1203] = {
    [sym__concat] = ACTIONS(2918),
    [anon_sym_RBRACE] = ACTIONS(2912),
    [sym_comment] = ACTIONS(46),
  },
  [1204] = {
    [anon_sym_RBRACK] = ACTIONS(2918),
    [sym_comment] = ACTIONS(46),
  },
  [1205] = {
    [anon_sym_RBRACE] = ACTIONS(2920),
    [anon_sym_LBRACK] = ACTIONS(2922),
    [sym_comment] = ACTIONS(46),
  },
  [1206] = {
    [anon_sym_RBRACE] = ACTIONS(2924),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [sym_comment] = ACTIONS(46),
  },
  [1207] = {
    [sym__heredoc_middle] = ACTIONS(960),
    [sym__heredoc_end] = ACTIONS(960),
    [anon_sym_DOLLAR] = ACTIONS(1488),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(960),
    [sym_comment] = ACTIONS(46),
  },
  [1208] = {
    [sym_concatenation] = STATE(1433),
    [sym_string] = STATE(1430),
    [sym_simple_expansion] = STATE(1430),
    [sym_expansion] = STATE(1430),
    [sym_command_substitution] = STATE(1430),
    [sym_process_substitution] = STATE(1430),
    [sym_word] = ACTIONS(2928),
    [anon_sym_RBRACE] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(2928),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2932),
  },
  [1209] = {
    [anon_sym_AT] = ACTIONS(2934),
    [sym_comment] = ACTIONS(46),
  },
  [1210] = {
    [sym__heredoc_middle] = ACTIONS(972),
    [sym__heredoc_end] = ACTIONS(972),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(972),
    [sym_comment] = ACTIONS(46),
  },
  [1211] = {
    [sym_concatenation] = STATE(1437),
    [sym_string] = STATE(1435),
    [sym_simple_expansion] = STATE(1435),
    [sym_expansion] = STATE(1435),
    [sym_command_substitution] = STATE(1435),
    [sym_process_substitution] = STATE(1435),
    [sym_word] = ACTIONS(2936),
    [anon_sym_RBRACE] = ACTIONS(2924),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(2936),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2938),
  },
  [1212] = {
    [anon_sym_AT] = ACTIONS(2940),
    [sym_comment] = ACTIONS(46),
  },
  [1213] = {
    [sym_file_descriptor] = ACTIONS(1888),
    [sym_word] = ACTIONS(1888),
    [sym_variable_name] = ACTIONS(1888),
    [anon_sym_LT] = ACTIONS(2745),
    [anon_sym_GT] = ACTIONS(2745),
    [anon_sym_GT_GT] = ACTIONS(1888),
    [anon_sym_AMP_GT] = ACTIONS(2745),
    [anon_sym_AMP_GT_GT] = ACTIONS(1888),
    [anon_sym_LT_AMP] = ACTIONS(1888),
    [anon_sym_GT_AMP] = ACTIONS(1888),
    [anon_sym_DQUOTE] = ACTIONS(1888),
    [sym_raw_string] = ACTIONS(1888),
    [anon_sym_DOLLAR] = ACTIONS(2745),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1888),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1888),
    [anon_sym_BQUOTE] = ACTIONS(1888),
    [anon_sym_LT_LPAREN] = ACTIONS(1888),
    [anon_sym_GT_LPAREN] = ACTIONS(1888),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2745),
  },
  [1214] = {
    [sym_word] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1532),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(2145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2145),
  },
  [1215] = {
    [anon_sym_AT] = ACTIONS(2942),
    [sym_comment] = ACTIONS(46),
  },
  [1216] = {
    [sym_word] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [anon_sym_RPAREN] = ACTIONS(1538),
    [anon_sym_DQUOTE] = ACTIONS(1538),
    [sym_raw_string] = ACTIONS(1538),
    [anon_sym_DOLLAR] = ACTIONS(2149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1538),
    [anon_sym_BQUOTE] = ACTIONS(1538),
    [anon_sym_LT_LPAREN] = ACTIONS(1538),
    [anon_sym_GT_LPAREN] = ACTIONS(1538),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2149),
  },
  [1217] = {
    [anon_sym_AT] = ACTIONS(2944),
    [sym_comment] = ACTIONS(46),
  },
  [1218] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(2946),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [sym_comment] = ACTIONS(46),
  },
  [1219] = {
    [sym_word] = ACTIONS(1548),
    [sym__concat] = ACTIONS(1548),
    [anon_sym_RPAREN] = ACTIONS(1548),
    [anon_sym_DQUOTE] = ACTIONS(1548),
    [sym_raw_string] = ACTIONS(1548),
    [anon_sym_DOLLAR] = ACTIONS(2157),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1548),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(1548),
    [anon_sym_LT_LPAREN] = ACTIONS(1548),
    [anon_sym_GT_LPAREN] = ACTIONS(1548),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2157),
  },
  [1220] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(2950),
    [anon_sym_RBRACE] = ACTIONS(2952),
    [sym_comment] = ACTIONS(46),
  },
  [1221] = {
    [sym__concat] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [sym_comment] = ACTIONS(46),
  },
  [1222] = {
    [anon_sym_RBRACK] = ACTIONS(2954),
    [sym_comment] = ACTIONS(46),
  },
  [1223] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(2956),
    [anon_sym_RBRACE] = ACTIONS(2958),
    [sym_comment] = ACTIONS(46),
  },
  [1224] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(2960),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [sym_comment] = ACTIONS(46),
  },
  [1225] = {
    [sym__concat] = ACTIONS(2964),
    [anon_sym_RBRACE] = ACTIONS(2958),
    [sym_comment] = ACTIONS(46),
  },
  [1226] = {
    [anon_sym_RBRACK] = ACTIONS(2964),
    [sym_comment] = ACTIONS(46),
  },
  [1227] = {
    [anon_sym_RBRACK] = ACTIONS(2966),
    [sym_comment] = ACTIONS(46),
  },
  [1228] = {
    [anon_sym_RBRACK] = ACTIONS(2968),
    [sym_comment] = ACTIONS(46),
  },
  [1229] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1230] = {
    [sym_file_descriptor] = ACTIONS(2205),
    [sym_word] = ACTIONS(2205),
    [sym__concat] = ACTIONS(2205),
    [sym_variable_name] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2207),
    [anon_sym_RPAREN] = ACTIONS(2207),
    [anon_sym_SEMI_SEMI] = ACTIONS(2207),
    [anon_sym_PIPE_AMP] = ACTIONS(2207),
    [anon_sym_AMP_AMP] = ACTIONS(2207),
    [anon_sym_PIPE_PIPE] = ACTIONS(2207),
    [anon_sym_LT] = ACTIONS(2207),
    [anon_sym_GT] = ACTIONS(2207),
    [anon_sym_GT_GT] = ACTIONS(2207),
    [anon_sym_AMP_GT] = ACTIONS(2207),
    [anon_sym_AMP_GT_GT] = ACTIONS(2207),
    [anon_sym_LT_AMP] = ACTIONS(2207),
    [anon_sym_GT_AMP] = ACTIONS(2207),
    [anon_sym_DQUOTE] = ACTIONS(2207),
    [sym_raw_string] = ACTIONS(2207),
    [anon_sym_DOLLAR] = ACTIONS(2207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2207),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2207),
    [anon_sym_BQUOTE] = ACTIONS(2207),
    [anon_sym_LT_LPAREN] = ACTIONS(2207),
    [anon_sym_GT_LPAREN] = ACTIONS(2207),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2207),
    [anon_sym_SEMI] = ACTIONS(2207),
    [anon_sym_LF] = ACTIONS(2207),
    [anon_sym_AMP] = ACTIONS(2207),
  },
  [1231] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1232] = {
    [sym_file_descriptor] = ACTIONS(2211),
    [sym_word] = ACTIONS(2211),
    [sym__concat] = ACTIONS(2211),
    [sym_variable_name] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2213),
    [anon_sym_RPAREN] = ACTIONS(2213),
    [anon_sym_SEMI_SEMI] = ACTIONS(2213),
    [anon_sym_PIPE_AMP] = ACTIONS(2213),
    [anon_sym_AMP_AMP] = ACTIONS(2213),
    [anon_sym_PIPE_PIPE] = ACTIONS(2213),
    [anon_sym_LT] = ACTIONS(2213),
    [anon_sym_GT] = ACTIONS(2213),
    [anon_sym_GT_GT] = ACTIONS(2213),
    [anon_sym_AMP_GT] = ACTIONS(2213),
    [anon_sym_AMP_GT_GT] = ACTIONS(2213),
    [anon_sym_LT_AMP] = ACTIONS(2213),
    [anon_sym_GT_AMP] = ACTIONS(2213),
    [anon_sym_DQUOTE] = ACTIONS(2213),
    [sym_raw_string] = ACTIONS(2213),
    [anon_sym_DOLLAR] = ACTIONS(2213),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2213),
    [anon_sym_BQUOTE] = ACTIONS(2213),
    [anon_sym_LT_LPAREN] = ACTIONS(2213),
    [anon_sym_GT_LPAREN] = ACTIONS(2213),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2213),
    [anon_sym_SEMI] = ACTIONS(2213),
    [anon_sym_LF] = ACTIONS(2213),
    [anon_sym_AMP] = ACTIONS(2213),
  },
  [1233] = {
    [anon_sym_RBRACE] = ACTIONS(2970),
    [sym_comment] = ACTIONS(46),
  },
  [1234] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1235] = {
    [sym_file_descriptor] = ACTIONS(2217),
    [sym_word] = ACTIONS(2217),
    [sym__concat] = ACTIONS(2217),
    [sym_variable_name] = ACTIONS(2217),
    [anon_sym_PIPE] = ACTIONS(2219),
    [anon_sym_RPAREN] = ACTIONS(2219),
    [anon_sym_SEMI_SEMI] = ACTIONS(2219),
    [anon_sym_PIPE_AMP] = ACTIONS(2219),
    [anon_sym_AMP_AMP] = ACTIONS(2219),
    [anon_sym_PIPE_PIPE] = ACTIONS(2219),
    [anon_sym_LT] = ACTIONS(2219),
    [anon_sym_GT] = ACTIONS(2219),
    [anon_sym_GT_GT] = ACTIONS(2219),
    [anon_sym_AMP_GT] = ACTIONS(2219),
    [anon_sym_AMP_GT_GT] = ACTIONS(2219),
    [anon_sym_LT_AMP] = ACTIONS(2219),
    [anon_sym_GT_AMP] = ACTIONS(2219),
    [anon_sym_DQUOTE] = ACTIONS(2219),
    [sym_raw_string] = ACTIONS(2219),
    [anon_sym_DOLLAR] = ACTIONS(2219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2219),
    [anon_sym_BQUOTE] = ACTIONS(2219),
    [anon_sym_LT_LPAREN] = ACTIONS(2219),
    [anon_sym_GT_LPAREN] = ACTIONS(2219),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2219),
    [anon_sym_SEMI] = ACTIONS(2219),
    [anon_sym_LF] = ACTIONS(2219),
    [anon_sym_AMP] = ACTIONS(2219),
  },
  [1236] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2976),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1237] = {
    [sym_file_descriptor] = ACTIONS(2223),
    [sym_word] = ACTIONS(2223),
    [sym__concat] = ACTIONS(2223),
    [sym_variable_name] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_RPAREN] = ACTIONS(2225),
    [anon_sym_SEMI_SEMI] = ACTIONS(2225),
    [anon_sym_PIPE_AMP] = ACTIONS(2225),
    [anon_sym_AMP_AMP] = ACTIONS(2225),
    [anon_sym_PIPE_PIPE] = ACTIONS(2225),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_GT_GT] = ACTIONS(2225),
    [anon_sym_AMP_GT] = ACTIONS(2225),
    [anon_sym_AMP_GT_GT] = ACTIONS(2225),
    [anon_sym_LT_AMP] = ACTIONS(2225),
    [anon_sym_GT_AMP] = ACTIONS(2225),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [sym_raw_string] = ACTIONS(2225),
    [anon_sym_DOLLAR] = ACTIONS(2225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2225),
    [anon_sym_BQUOTE] = ACTIONS(2225),
    [anon_sym_LT_LPAREN] = ACTIONS(2225),
    [anon_sym_GT_LPAREN] = ACTIONS(2225),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2225),
    [anon_sym_LF] = ACTIONS(2225),
    [anon_sym_AMP] = ACTIONS(2225),
  },
  [1238] = {
    [anon_sym_RBRACE] = ACTIONS(2974),
    [sym_comment] = ACTIONS(46),
  },
  [1239] = {
    [anon_sym_RBRACK] = ACTIONS(2978),
    [sym_comment] = ACTIONS(46),
  },
  [1240] = {
    [anon_sym_RBRACK] = ACTIONS(2980),
    [sym_comment] = ACTIONS(46),
  },
  [1241] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2982),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1242] = {
    [sym__concat] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2205),
    [anon_sym_RPAREN] = ACTIONS(2205),
    [anon_sym_RBRACE] = ACTIONS(2205),
    [anon_sym_RBRACK] = ACTIONS(2205),
    [sym_comment] = ACTIONS(46),
  },
  [1243] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1244] = {
    [sym__concat] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2211),
    [anon_sym_RPAREN] = ACTIONS(2211),
    [anon_sym_RBRACE] = ACTIONS(2211),
    [anon_sym_RBRACK] = ACTIONS(2211),
    [sym_comment] = ACTIONS(46),
  },
  [1245] = {
    [anon_sym_RBRACE] = ACTIONS(2982),
    [sym_comment] = ACTIONS(46),
  },
  [1246] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2986),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1247] = {
    [sym__concat] = ACTIONS(2217),
    [anon_sym_PIPE] = ACTIONS(2217),
    [anon_sym_RPAREN] = ACTIONS(2217),
    [anon_sym_RBRACE] = ACTIONS(2217),
    [anon_sym_RBRACK] = ACTIONS(2217),
    [sym_comment] = ACTIONS(46),
  },
  [1248] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(2988),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1249] = {
    [sym__concat] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2223),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_RBRACK] = ACTIONS(2223),
    [sym_comment] = ACTIONS(46),
  },
  [1250] = {
    [anon_sym_RBRACE] = ACTIONS(2986),
    [sym_comment] = ACTIONS(46),
  },
  [1251] = {
    [sym_word] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1534),
    [anon_sym_DQUOTE] = ACTIONS(1534),
    [sym_raw_string] = ACTIONS(1534),
    [anon_sym_DOLLAR] = ACTIONS(1534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1534),
    [anon_sym_BQUOTE] = ACTIONS(1534),
    [anon_sym_LT_LPAREN] = ACTIONS(1534),
    [anon_sym_GT_LPAREN] = ACTIONS(1534),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1534),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_AMP] = ACTIONS(1534),
  },
  [1252] = {
    [anon_sym_AT] = ACTIONS(2990),
    [sym_comment] = ACTIONS(46),
  },
  [1253] = {
    [sym_word] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [anon_sym_SEMI_SEMI] = ACTIONS(1540),
    [anon_sym_DQUOTE] = ACTIONS(1540),
    [sym_raw_string] = ACTIONS(1540),
    [anon_sym_DOLLAR] = ACTIONS(1540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1540),
    [anon_sym_BQUOTE] = ACTIONS(1540),
    [anon_sym_LT_LPAREN] = ACTIONS(1540),
    [anon_sym_GT_LPAREN] = ACTIONS(1540),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1540),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_LF] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1540),
  },
  [1254] = {
    [anon_sym_AT] = ACTIONS(2992),
    [sym_comment] = ACTIONS(46),
  },
  [1255] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(2994),
    [anon_sym_RBRACE] = ACTIONS(2996),
    [sym_comment] = ACTIONS(46),
  },
  [1256] = {
    [sym_word] = ACTIONS(1548),
    [sym__concat] = ACTIONS(1548),
    [anon_sym_SEMI_SEMI] = ACTIONS(1550),
    [anon_sym_DQUOTE] = ACTIONS(1550),
    [sym_raw_string] = ACTIONS(1550),
    [anon_sym_DOLLAR] = ACTIONS(1550),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1550),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1550),
    [anon_sym_BQUOTE] = ACTIONS(1550),
    [anon_sym_LT_LPAREN] = ACTIONS(1550),
    [anon_sym_GT_LPAREN] = ACTIONS(1550),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1550),
    [anon_sym_SEMI] = ACTIONS(1550),
    [anon_sym_LF] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(1550),
  },
  [1257] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(2998),
    [anon_sym_RBRACE] = ACTIONS(3000),
    [sym_comment] = ACTIONS(46),
  },
  [1258] = {
    [sym__concat] = ACTIONS(3002),
    [anon_sym_RBRACE] = ACTIONS(2996),
    [sym_comment] = ACTIONS(46),
  },
  [1259] = {
    [anon_sym_RBRACK] = ACTIONS(3002),
    [sym_comment] = ACTIONS(46),
  },
  [1260] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(3004),
    [anon_sym_RBRACE] = ACTIONS(3006),
    [sym_comment] = ACTIONS(46),
  },
  [1261] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(3008),
    [anon_sym_RBRACE] = ACTIONS(3010),
    [sym_comment] = ACTIONS(46),
  },
  [1262] = {
    [sym__concat] = ACTIONS(3012),
    [anon_sym_RBRACE] = ACTIONS(3006),
    [sym_comment] = ACTIONS(46),
  },
  [1263] = {
    [anon_sym_RBRACK] = ACTIONS(3012),
    [sym_comment] = ACTIONS(46),
  },
  [1264] = {
    [sym__terminated_statement] = STATE(418),
    [sym_for_statement] = STATE(419),
    [sym_while_statement] = STATE(419),
    [sym_if_statement] = STATE(419),
    [sym_case_statement] = STATE(419),
    [sym_function_definition] = STATE(419),
    [sym_subshell] = STATE(419),
    [sym_pipeline] = STATE(419),
    [sym_list] = STATE(419),
    [sym_command] = STATE(419),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(422),
    [sym_declaration_command] = STATE(419),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(704),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(3014),
    [anon_sym_elif] = ACTIONS(3014),
    [anon_sym_else] = ACTIONS(3014),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [1265] = {
    [anon_sym_PIPE] = ACTIONS(3016),
    [anon_sym_RPAREN] = ACTIONS(3016),
    [anon_sym_SEMI_SEMI] = ACTIONS(3016),
    [anon_sym_PIPE_AMP] = ACTIONS(3016),
    [anon_sym_AMP_AMP] = ACTIONS(3016),
    [anon_sym_PIPE_PIPE] = ACTIONS(3016),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(3016),
    [anon_sym_LF] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3016),
  },
  [1266] = {
    [aux_sym_concatenation_repeat1] = STATE(1002),
    [sym__concat] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(3018),
    [anon_sym_RPAREN] = ACTIONS(3018),
    [sym_comment] = ACTIONS(46),
  },
  [1267] = {
    [aux_sym_concatenation_repeat1] = STATE(1005),
    [sym__concat] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(3020),
    [anon_sym_RPAREN] = ACTIONS(3020),
    [sym_comment] = ACTIONS(46),
  },
  [1268] = {
    [anon_sym_PIPE] = ACTIONS(3018),
    [anon_sym_RPAREN] = ACTIONS(3018),
    [sym_comment] = ACTIONS(46),
  },
  [1269] = {
    [sym_word] = ACTIONS(3022),
    [anon_sym_esac] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3022),
    [sym_raw_string] = ACTIONS(3022),
    [anon_sym_DOLLAR] = ACTIONS(3024),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3022),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3022),
    [anon_sym_BQUOTE] = ACTIONS(3022),
    [anon_sym_LT_LPAREN] = ACTIONS(3022),
    [anon_sym_GT_LPAREN] = ACTIONS(3022),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3026),
  },
  [1270] = {
    [sym_file_descriptor] = ACTIONS(196),
    [sym_word] = ACTIONS(196),
    [sym_variable_name] = ACTIONS(196),
    [anon_sym_for] = ACTIONS(198),
    [anon_sym_while] = ACTIONS(198),
    [anon_sym_if] = ACTIONS(198),
    [anon_sym_case] = ACTIONS(198),
    [anon_sym_SEMI_SEMI] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(196),
    [anon_sym_declare] = ACTIONS(198),
    [anon_sym_typeset] = ACTIONS(198),
    [anon_sym_export] = ACTIONS(198),
    [anon_sym_readonly] = ACTIONS(198),
    [anon_sym_local] = ACTIONS(198),
    [anon_sym_LT] = ACTIONS(198),
    [anon_sym_GT] = ACTIONS(198),
    [anon_sym_GT_GT] = ACTIONS(196),
    [anon_sym_AMP_GT] = ACTIONS(198),
    [anon_sym_AMP_GT_GT] = ACTIONS(196),
    [anon_sym_LT_AMP] = ACTIONS(196),
    [anon_sym_GT_AMP] = ACTIONS(196),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [sym_raw_string] = ACTIONS(196),
    [anon_sym_DOLLAR] = ACTIONS(198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(196),
    [anon_sym_BQUOTE] = ACTIONS(196),
    [anon_sym_LT_LPAREN] = ACTIONS(196),
    [anon_sym_GT_LPAREN] = ACTIONS(196),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(200),
  },
  [1271] = {
    [anon_sym_PIPE] = ACTIONS(202),
    [anon_sym_SEMI_SEMI] = ACTIONS(3028),
    [anon_sym_PIPE_AMP] = ACTIONS(202),
    [anon_sym_AMP_AMP] = ACTIONS(206),
    [anon_sym_PIPE_PIPE] = ACTIONS(206),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym_LF] = ACTIONS(3028),
    [anon_sym_AMP] = ACTIONS(3028),
  },
  [1272] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(202),
    [anon_sym_SEMI_SEMI] = ACTIONS(3028),
    [anon_sym_PIPE_AMP] = ACTIONS(202),
    [anon_sym_AMP_AMP] = ACTIONS(206),
    [anon_sym_PIPE_PIPE] = ACTIONS(206),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(236),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(236),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_DQUOTE] = ACTIONS(236),
    [sym_raw_string] = ACTIONS(236),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(236),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(236),
    [anon_sym_BQUOTE] = ACTIONS(236),
    [anon_sym_LT_LPAREN] = ACTIONS(236),
    [anon_sym_GT_LPAREN] = ACTIONS(236),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym_LF] = ACTIONS(3028),
    [anon_sym_AMP] = ACTIONS(3028),
  },
  [1273] = {
    [sym__terminated_statement] = STATE(1270),
    [sym_for_statement] = STATE(1271),
    [sym_while_statement] = STATE(1271),
    [sym_if_statement] = STATE(1271),
    [sym_case_statement] = STATE(1271),
    [sym_function_definition] = STATE(1271),
    [sym_subshell] = STATE(1271),
    [sym_pipeline] = STATE(1271),
    [sym_list] = STATE(1271),
    [sym_command] = STATE(1271),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(1272),
    [sym_declaration_command] = STATE(1271),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(1477),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_SEMI_SEMI] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [1274] = {
    [sym__terminated_statement] = STATE(1270),
    [sym_for_statement] = STATE(1271),
    [sym_while_statement] = STATE(1271),
    [sym_if_statement] = STATE(1271),
    [sym_case_statement] = STATE(1271),
    [sym_function_definition] = STATE(1271),
    [sym_subshell] = STATE(1271),
    [sym_pipeline] = STATE(1271),
    [sym_list] = STATE(1271),
    [sym_command] = STATE(1271),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(1272),
    [sym_declaration_command] = STATE(1271),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(1478),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_SEMI_SEMI] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [1275] = {
    [aux_sym_case_item_repeat1] = STATE(1275),
    [anon_sym_PIPE] = ACTIONS(3032),
    [anon_sym_RPAREN] = ACTIONS(3018),
    [sym_comment] = ACTIONS(46),
  },
  [1276] = {
    [aux_sym_concatenation_repeat1] = STATE(1276),
    [sym__concat] = ACTIONS(1938),
    [anon_sym_PIPE] = ACTIONS(675),
    [anon_sym_RPAREN] = ACTIONS(675),
    [sym_comment] = ACTIONS(46),
  },
  [1277] = {
    [sym_word] = ACTIONS(3035),
    [anon_sym_esac] = ACTIONS(3037),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [sym_raw_string] = ACTIONS(3035),
    [anon_sym_DOLLAR] = ACTIONS(3037),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3035),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3035),
    [anon_sym_BQUOTE] = ACTIONS(3035),
    [anon_sym_LT_LPAREN] = ACTIONS(3035),
    [anon_sym_GT_LPAREN] = ACTIONS(3035),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3039),
  },
  [1278] = {
    [sym__terminated_statement] = STATE(1270),
    [sym_for_statement] = STATE(1271),
    [sym_while_statement] = STATE(1271),
    [sym_if_statement] = STATE(1271),
    [sym_case_statement] = STATE(1271),
    [sym_function_definition] = STATE(1271),
    [sym_subshell] = STATE(1271),
    [sym_pipeline] = STATE(1271),
    [sym_list] = STATE(1271),
    [sym_command] = STATE(1271),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(1272),
    [sym_declaration_command] = STATE(1271),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(1477),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_SEMI_SEMI] = ACTIONS(3041),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [1279] = {
    [sym__terminated_statement] = STATE(1270),
    [sym_for_statement] = STATE(1271),
    [sym_while_statement] = STATE(1271),
    [sym_if_statement] = STATE(1271),
    [sym_case_statement] = STATE(1271),
    [sym_function_definition] = STATE(1271),
    [sym_subshell] = STATE(1271),
    [sym_pipeline] = STATE(1271),
    [sym_list] = STATE(1271),
    [sym_command] = STATE(1271),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(1272),
    [sym_declaration_command] = STATE(1271),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(1480),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_SEMI_SEMI] = ACTIONS(3041),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [1280] = {
    [anon_sym_PIPE] = ACTIONS(3043),
    [anon_sym_RPAREN] = ACTIONS(3043),
    [anon_sym_SEMI_SEMI] = ACTIONS(3043),
    [anon_sym_PIPE_AMP] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_PIPE_PIPE] = ACTIONS(3043),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(3043),
    [anon_sym_LF] = ACTIONS(3043),
    [anon_sym_AMP] = ACTIONS(3043),
  },
  [1281] = {
    [anon_sym_RBRACE] = ACTIONS(3045),
    [sym_comment] = ACTIONS(46),
  },
  [1282] = {
    [anon_sym_RBRACE] = ACTIONS(3047),
    [sym_comment] = ACTIONS(46),
  },
  [1283] = {
    [sym__concat] = ACTIONS(2726),
    [anon_sym_in] = ACTIONS(2728),
    [anon_sym_SEMI_SEMI] = ACTIONS(2728),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2728),
    [anon_sym_LF] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(2728),
  },
  [1284] = {
    [sym__concat] = ACTIONS(2730),
    [anon_sym_in] = ACTIONS(2732),
    [anon_sym_SEMI_SEMI] = ACTIONS(2732),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2732),
    [anon_sym_LF] = ACTIONS(2732),
    [anon_sym_AMP] = ACTIONS(2732),
  },
  [1285] = {
    [sym__concat] = ACTIONS(2734),
    [anon_sym_in] = ACTIONS(2736),
    [anon_sym_SEMI_SEMI] = ACTIONS(2736),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2736),
    [anon_sym_LF] = ACTIONS(2736),
    [anon_sym_AMP] = ACTIONS(2736),
  },
  [1286] = {
    [sym__concat] = ACTIONS(2738),
    [anon_sym_in] = ACTIONS(2740),
    [anon_sym_SEMI_SEMI] = ACTIONS(2740),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym_LF] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2740),
  },
  [1287] = {
    [anon_sym_PIPE] = ACTIONS(3049),
    [anon_sym_RPAREN] = ACTIONS(3049),
    [anon_sym_SEMI_SEMI] = ACTIONS(3049),
    [anon_sym_PIPE_AMP] = ACTIONS(3049),
    [anon_sym_AMP_AMP] = ACTIONS(3049),
    [anon_sym_PIPE_PIPE] = ACTIONS(3049),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(3049),
    [anon_sym_LF] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3049),
  },
  [1288] = {
    [sym__concat] = ACTIONS(675),
    [anon_sym_PIPE] = ACTIONS(677),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_SEMI_SEMI] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(677),
  },
  [1289] = {
    [sym__concat] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_RPAREN] = ACTIONS(681),
    [anon_sym_SEMI_SEMI] = ACTIONS(681),
    [anon_sym_PIPE_AMP] = ACTIONS(681),
    [anon_sym_AMP_AMP] = ACTIONS(681),
    [anon_sym_PIPE_PIPE] = ACTIONS(681),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(681),
    [anon_sym_AMP] = ACTIONS(681),
  },
  [1290] = {
    [aux_sym_concatenation_repeat1] = STATE(1290),
    [sym__concat] = ACTIONS(3051),
    [anon_sym_PIPE] = ACTIONS(677),
    [anon_sym_SEMI_SEMI] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(677),
  },
  [1291] = {
    [sym__concat] = ACTIONS(931),
    [anon_sym_PIPE] = ACTIONS(933),
    [anon_sym_RPAREN] = ACTIONS(933),
    [anon_sym_SEMI_SEMI] = ACTIONS(933),
    [anon_sym_PIPE_AMP] = ACTIONS(933),
    [anon_sym_AMP_AMP] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(933),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(933),
    [anon_sym_LF] = ACTIONS(933),
    [anon_sym_AMP] = ACTIONS(933),
  },
  [1292] = {
    [anon_sym_RBRACE] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [sym_comment] = ACTIONS(46),
  },
  [1293] = {
    [anon_sym_RBRACE] = ACTIONS(3058),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [sym_comment] = ACTIONS(46),
  },
  [1294] = {
    [sym__concat] = ACTIONS(960),
    [anon_sym_PIPE] = ACTIONS(962),
    [anon_sym_RPAREN] = ACTIONS(962),
    [anon_sym_SEMI_SEMI] = ACTIONS(962),
    [anon_sym_PIPE_AMP] = ACTIONS(962),
    [anon_sym_AMP_AMP] = ACTIONS(962),
    [anon_sym_PIPE_PIPE] = ACTIONS(962),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(962),
    [anon_sym_LF] = ACTIONS(962),
    [anon_sym_AMP] = ACTIONS(962),
  },
  [1295] = {
    [sym_concatenation] = STATE(1490),
    [sym_string] = STATE(1487),
    [sym_simple_expansion] = STATE(1487),
    [sym_expansion] = STATE(1487),
    [sym_command_substitution] = STATE(1487),
    [sym_process_substitution] = STATE(1487),
    [sym_word] = ACTIONS(3062),
    [anon_sym_RBRACE] = ACTIONS(3064),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(3062),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3066),
  },
  [1296] = {
    [anon_sym_AT] = ACTIONS(3068),
    [sym_comment] = ACTIONS(46),
  },
  [1297] = {
    [sym__concat] = ACTIONS(972),
    [anon_sym_PIPE] = ACTIONS(974),
    [anon_sym_RPAREN] = ACTIONS(974),
    [anon_sym_SEMI_SEMI] = ACTIONS(974),
    [anon_sym_PIPE_AMP] = ACTIONS(974),
    [anon_sym_AMP_AMP] = ACTIONS(974),
    [anon_sym_PIPE_PIPE] = ACTIONS(974),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(974),
    [anon_sym_LF] = ACTIONS(974),
    [anon_sym_AMP] = ACTIONS(974),
  },
  [1298] = {
    [sym_concatenation] = STATE(1494),
    [sym_string] = STATE(1492),
    [sym_simple_expansion] = STATE(1492),
    [sym_expansion] = STATE(1492),
    [sym_command_substitution] = STATE(1492),
    [sym_process_substitution] = STATE(1492),
    [sym_word] = ACTIONS(3070),
    [anon_sym_RBRACE] = ACTIONS(3058),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(3070),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3072),
  },
  [1299] = {
    [anon_sym_AT] = ACTIONS(3074),
    [sym_comment] = ACTIONS(46),
  },
  [1300] = {
    [sym__concat] = ACTIONS(1066),
    [anon_sym_PIPE] = ACTIONS(1068),
    [anon_sym_RPAREN] = ACTIONS(1068),
    [anon_sym_SEMI_SEMI] = ACTIONS(1068),
    [anon_sym_PIPE_AMP] = ACTIONS(1068),
    [anon_sym_AMP_AMP] = ACTIONS(1068),
    [anon_sym_PIPE_PIPE] = ACTIONS(1068),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1068),
    [anon_sym_LF] = ACTIONS(1068),
    [anon_sym_AMP] = ACTIONS(1068),
  },
  [1301] = {
    [sym__concat] = ACTIONS(1122),
    [anon_sym_PIPE] = ACTIONS(1124),
    [anon_sym_RPAREN] = ACTIONS(1124),
    [anon_sym_SEMI_SEMI] = ACTIONS(1124),
    [anon_sym_PIPE_AMP] = ACTIONS(1124),
    [anon_sym_AMP_AMP] = ACTIONS(1124),
    [anon_sym_PIPE_PIPE] = ACTIONS(1124),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1124),
    [anon_sym_LF] = ACTIONS(1124),
    [anon_sym_AMP] = ACTIONS(1124),
  },
  [1302] = {
    [aux_sym_concatenation_repeat1] = STATE(1304),
    [sym__concat] = ACTIONS(2091),
    [anon_sym_PIPE] = ACTIONS(1801),
    [anon_sym_RPAREN] = ACTIONS(1801),
    [anon_sym_SEMI_SEMI] = ACTIONS(1801),
    [anon_sym_PIPE_AMP] = ACTIONS(1801),
    [anon_sym_AMP_AMP] = ACTIONS(1801),
    [anon_sym_PIPE_PIPE] = ACTIONS(1801),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1801),
    [anon_sym_LF] = ACTIONS(1801),
    [anon_sym_AMP] = ACTIONS(1801),
  },
  [1303] = {
    [aux_sym_concatenation_repeat1] = STATE(1305),
    [sym__concat] = ACTIONS(2091),
    [anon_sym_PIPE] = ACTIONS(1803),
    [anon_sym_RPAREN] = ACTIONS(1803),
    [anon_sym_SEMI_SEMI] = ACTIONS(1803),
    [anon_sym_PIPE_AMP] = ACTIONS(1803),
    [anon_sym_AMP_AMP] = ACTIONS(1803),
    [anon_sym_PIPE_PIPE] = ACTIONS(1803),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1803),
    [anon_sym_LF] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
  },
  [1304] = {
    [aux_sym_concatenation_repeat1] = STATE(1496),
    [sym__concat] = ACTIONS(2091),
    [anon_sym_PIPE] = ACTIONS(256),
    [anon_sym_RPAREN] = ACTIONS(256),
    [anon_sym_SEMI_SEMI] = ACTIONS(256),
    [anon_sym_PIPE_AMP] = ACTIONS(256),
    [anon_sym_AMP_AMP] = ACTIONS(256),
    [anon_sym_PIPE_PIPE] = ACTIONS(256),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(256),
    [anon_sym_LF] = ACTIONS(256),
    [anon_sym_AMP] = ACTIONS(256),
  },
  [1305] = {
    [aux_sym_concatenation_repeat1] = STATE(1496),
    [sym__concat] = ACTIONS(2091),
    [anon_sym_PIPE] = ACTIONS(544),
    [anon_sym_RPAREN] = ACTIONS(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_PIPE_PIPE] = ACTIONS(544),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [1306] = {
    [aux_sym_concatenation_repeat1] = STATE(1306),
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(2665),
    [sym_variable_name] = ACTIONS(675),
    [anon_sym_PIPE] = ACTIONS(677),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_SEMI_SEMI] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(677),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(677),
  },
  [1307] = {
    [sym_word] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1532),
    [sym_variable_name] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1534),
    [anon_sym_RPAREN] = ACTIONS(1534),
    [anon_sym_SEMI_SEMI] = ACTIONS(1534),
    [anon_sym_PIPE_AMP] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1534),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1534),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_AMP] = ACTIONS(1534),
  },
  [1308] = {
    [anon_sym_AT] = ACTIONS(3076),
    [sym_comment] = ACTIONS(46),
  },
  [1309] = {
    [sym_word] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [sym_variable_name] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(1540),
    [anon_sym_RPAREN] = ACTIONS(1540),
    [anon_sym_SEMI_SEMI] = ACTIONS(1540),
    [anon_sym_PIPE_AMP] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1540),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1540),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_LF] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1540),
  },
  [1310] = {
    [anon_sym_AT] = ACTIONS(3078),
    [sym_comment] = ACTIONS(46),
  },
  [1311] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(3080),
    [anon_sym_RBRACE] = ACTIONS(3082),
    [sym_comment] = ACTIONS(46),
  },
  [1312] = {
    [sym_word] = ACTIONS(1548),
    [sym__concat] = ACTIONS(1548),
    [sym_variable_name] = ACTIONS(1548),
    [anon_sym_PIPE] = ACTIONS(1550),
    [anon_sym_RPAREN] = ACTIONS(1550),
    [anon_sym_SEMI_SEMI] = ACTIONS(1550),
    [anon_sym_PIPE_AMP] = ACTIONS(1550),
    [anon_sym_AMP_AMP] = ACTIONS(1550),
    [anon_sym_PIPE_PIPE] = ACTIONS(1550),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(1550),
    [anon_sym_SEMI] = ACTIONS(1550),
    [anon_sym_LF] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(1550),
  },
  [1313] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(3084),
    [anon_sym_RBRACE] = ACTIONS(3086),
    [sym_comment] = ACTIONS(46),
  },
  [1314] = {
    [sym__concat] = ACTIONS(3088),
    [anon_sym_RBRACE] = ACTIONS(3082),
    [sym_comment] = ACTIONS(46),
  },
  [1315] = {
    [anon_sym_RBRACK] = ACTIONS(3088),
    [sym_comment] = ACTIONS(46),
  },
  [1316] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(3090),
    [anon_sym_RBRACE] = ACTIONS(3092),
    [sym_comment] = ACTIONS(46),
  },
  [1317] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(3094),
    [anon_sym_RBRACE] = ACTIONS(3096),
    [sym_comment] = ACTIONS(46),
  },
  [1318] = {
    [sym__concat] = ACTIONS(3098),
    [anon_sym_RBRACE] = ACTIONS(3092),
    [sym_comment] = ACTIONS(46),
  },
  [1319] = {
    [anon_sym_RBRACK] = ACTIONS(3098),
    [sym_comment] = ACTIONS(46),
  },
  [1320] = {
    [anon_sym_RBRACE] = ACTIONS(3100),
    [sym_comment] = ACTIONS(46),
  },
  [1321] = {
    [anon_sym_RBRACE] = ACTIONS(3102),
    [sym_comment] = ACTIONS(46),
  },
  [1322] = {
    [sym_file_descriptor] = ACTIONS(2726),
    [sym_word] = ACTIONS(2726),
    [sym__concat] = ACTIONS(2726),
    [sym_variable_name] = ACTIONS(2726),
    [anon_sym_LT] = ACTIONS(3104),
    [anon_sym_GT] = ACTIONS(3104),
    [anon_sym_GT_GT] = ACTIONS(2726),
    [anon_sym_AMP_GT] = ACTIONS(3104),
    [anon_sym_AMP_GT_GT] = ACTIONS(2726),
    [anon_sym_LT_AMP] = ACTIONS(2726),
    [anon_sym_GT_AMP] = ACTIONS(2726),
    [anon_sym_DQUOTE] = ACTIONS(2726),
    [sym_raw_string] = ACTIONS(2726),
    [anon_sym_DOLLAR] = ACTIONS(3104),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2726),
    [anon_sym_BQUOTE] = ACTIONS(2726),
    [anon_sym_LT_LPAREN] = ACTIONS(2726),
    [anon_sym_GT_LPAREN] = ACTIONS(2726),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3104),
  },
  [1323] = {
    [sym_file_descriptor] = ACTIONS(2730),
    [sym_word] = ACTIONS(2730),
    [sym__concat] = ACTIONS(2730),
    [sym_variable_name] = ACTIONS(2730),
    [anon_sym_LT] = ACTIONS(3106),
    [anon_sym_GT] = ACTIONS(3106),
    [anon_sym_GT_GT] = ACTIONS(2730),
    [anon_sym_AMP_GT] = ACTIONS(3106),
    [anon_sym_AMP_GT_GT] = ACTIONS(2730),
    [anon_sym_LT_AMP] = ACTIONS(2730),
    [anon_sym_GT_AMP] = ACTIONS(2730),
    [anon_sym_DQUOTE] = ACTIONS(2730),
    [sym_raw_string] = ACTIONS(2730),
    [anon_sym_DOLLAR] = ACTIONS(3106),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2730),
    [anon_sym_BQUOTE] = ACTIONS(2730),
    [anon_sym_LT_LPAREN] = ACTIONS(2730),
    [anon_sym_GT_LPAREN] = ACTIONS(2730),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3106),
  },
  [1324] = {
    [sym_file_descriptor] = ACTIONS(2734),
    [sym_word] = ACTIONS(2734),
    [sym__concat] = ACTIONS(2734),
    [sym_variable_name] = ACTIONS(2734),
    [anon_sym_LT] = ACTIONS(3108),
    [anon_sym_GT] = ACTIONS(3108),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_AMP_GT] = ACTIONS(3108),
    [anon_sym_AMP_GT_GT] = ACTIONS(2734),
    [anon_sym_LT_AMP] = ACTIONS(2734),
    [anon_sym_GT_AMP] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(2734),
    [sym_raw_string] = ACTIONS(2734),
    [anon_sym_DOLLAR] = ACTIONS(3108),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2734),
    [anon_sym_BQUOTE] = ACTIONS(2734),
    [anon_sym_LT_LPAREN] = ACTIONS(2734),
    [anon_sym_GT_LPAREN] = ACTIONS(2734),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3108),
  },
  [1325] = {
    [sym_file_descriptor] = ACTIONS(2738),
    [sym_word] = ACTIONS(2738),
    [sym__concat] = ACTIONS(2738),
    [sym_variable_name] = ACTIONS(2738),
    [anon_sym_LT] = ACTIONS(3110),
    [anon_sym_GT] = ACTIONS(3110),
    [anon_sym_GT_GT] = ACTIONS(2738),
    [anon_sym_AMP_GT] = ACTIONS(3110),
    [anon_sym_AMP_GT_GT] = ACTIONS(2738),
    [anon_sym_LT_AMP] = ACTIONS(2738),
    [anon_sym_GT_AMP] = ACTIONS(2738),
    [anon_sym_DQUOTE] = ACTIONS(2738),
    [sym_raw_string] = ACTIONS(2738),
    [anon_sym_DOLLAR] = ACTIONS(3110),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2738),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2738),
    [anon_sym_BQUOTE] = ACTIONS(2738),
    [anon_sym_LT_LPAREN] = ACTIONS(2738),
    [anon_sym_GT_LPAREN] = ACTIONS(2738),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3110),
  },
  [1326] = {
    [anon_sym_RBRACE] = ACTIONS(3112),
    [sym_comment] = ACTIONS(46),
  },
  [1327] = {
    [anon_sym_RBRACE] = ACTIONS(3114),
    [sym_comment] = ACTIONS(46),
  },
  [1328] = {
    [anon_sym_DQUOTE] = ACTIONS(2728),
    [sym__string_content] = ACTIONS(2728),
    [anon_sym_DOLLAR] = ACTIONS(2728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2728),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2728),
    [anon_sym_BQUOTE] = ACTIONS(2728),
    [sym_comment] = ACTIONS(60),
  },
  [1329] = {
    [anon_sym_DQUOTE] = ACTIONS(2732),
    [sym__string_content] = ACTIONS(2732),
    [anon_sym_DOLLAR] = ACTIONS(2732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2732),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2732),
    [anon_sym_BQUOTE] = ACTIONS(2732),
    [sym_comment] = ACTIONS(60),
  },
  [1330] = {
    [anon_sym_DQUOTE] = ACTIONS(2736),
    [sym__string_content] = ACTIONS(2736),
    [anon_sym_DOLLAR] = ACTIONS(2736),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2736),
    [anon_sym_BQUOTE] = ACTIONS(2736),
    [sym_comment] = ACTIONS(60),
  },
  [1331] = {
    [anon_sym_DQUOTE] = ACTIONS(2740),
    [sym__string_content] = ACTIONS(2740),
    [anon_sym_DOLLAR] = ACTIONS(2740),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2740),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2740),
    [anon_sym_BQUOTE] = ACTIONS(2740),
    [sym_comment] = ACTIONS(60),
  },
  [1332] = {
    [sym_file_descriptor] = ACTIONS(3116),
    [sym_word] = ACTIONS(3116),
    [sym__concat] = ACTIONS(3116),
    [anon_sym_PIPE] = ACTIONS(3118),
    [anon_sym_RPAREN] = ACTIONS(3118),
    [anon_sym_SEMI_SEMI] = ACTIONS(3118),
    [anon_sym_PIPE_AMP] = ACTIONS(3118),
    [anon_sym_AMP_AMP] = ACTIONS(3118),
    [anon_sym_PIPE_PIPE] = ACTIONS(3118),
    [anon_sym_LT] = ACTIONS(3118),
    [anon_sym_GT] = ACTIONS(3118),
    [anon_sym_GT_GT] = ACTIONS(3118),
    [anon_sym_AMP_GT] = ACTIONS(3118),
    [anon_sym_AMP_GT_GT] = ACTIONS(3118),
    [anon_sym_LT_AMP] = ACTIONS(3118),
    [anon_sym_GT_AMP] = ACTIONS(3118),
    [anon_sym_LT_LT] = ACTIONS(3118),
    [anon_sym_LT_LT_DASH] = ACTIONS(3118),
    [anon_sym_DQUOTE] = ACTIONS(3118),
    [sym_raw_string] = ACTIONS(3118),
    [anon_sym_DOLLAR] = ACTIONS(3118),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3118),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3118),
    [anon_sym_BQUOTE] = ACTIONS(3118),
    [anon_sym_LT_LPAREN] = ACTIONS(3118),
    [anon_sym_GT_LPAREN] = ACTIONS(3118),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(3118),
    [anon_sym_SEMI] = ACTIONS(3118),
    [anon_sym_LF] = ACTIONS(3118),
    [anon_sym_AMP] = ACTIONS(3118),
  },
  [1333] = {
    [sym_file_descriptor] = ACTIONS(3120),
    [sym_word] = ACTIONS(3120),
    [sym__concat] = ACTIONS(3120),
    [anon_sym_PIPE] = ACTIONS(3122),
    [anon_sym_RPAREN] = ACTIONS(3122),
    [anon_sym_SEMI_SEMI] = ACTIONS(3122),
    [anon_sym_PIPE_AMP] = ACTIONS(3122),
    [anon_sym_AMP_AMP] = ACTIONS(3122),
    [anon_sym_PIPE_PIPE] = ACTIONS(3122),
    [anon_sym_LT] = ACTIONS(3122),
    [anon_sym_GT] = ACTIONS(3122),
    [anon_sym_GT_GT] = ACTIONS(3122),
    [anon_sym_AMP_GT] = ACTIONS(3122),
    [anon_sym_AMP_GT_GT] = ACTIONS(3122),
    [anon_sym_LT_AMP] = ACTIONS(3122),
    [anon_sym_GT_AMP] = ACTIONS(3122),
    [anon_sym_LT_LT] = ACTIONS(3122),
    [anon_sym_LT_LT_DASH] = ACTIONS(3122),
    [anon_sym_DQUOTE] = ACTIONS(3122),
    [sym_raw_string] = ACTIONS(3122),
    [anon_sym_DOLLAR] = ACTIONS(3122),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3122),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3122),
    [anon_sym_BQUOTE] = ACTIONS(3122),
    [anon_sym_LT_LPAREN] = ACTIONS(3122),
    [anon_sym_GT_LPAREN] = ACTIONS(3122),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(3122),
    [anon_sym_SEMI] = ACTIONS(3122),
    [anon_sym_LF] = ACTIONS(3122),
    [anon_sym_AMP] = ACTIONS(3122),
  },
  [1334] = {
    [sym_file_descriptor] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1532),
    [sym_variable_name] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(2145),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_GT] = ACTIONS(2145),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(2145),
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(2145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2145),
  },
  [1335] = {
    [anon_sym_AT] = ACTIONS(3124),
    [sym_comment] = ACTIONS(46),
  },
  [1336] = {
    [sym_file_descriptor] = ACTIONS(1538),
    [sym_word] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [sym_variable_name] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(2149),
    [anon_sym_RPAREN] = ACTIONS(1538),
    [anon_sym_PIPE_AMP] = ACTIONS(1538),
    [anon_sym_AMP_AMP] = ACTIONS(1538),
    [anon_sym_PIPE_PIPE] = ACTIONS(1538),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_GT] = ACTIONS(2149),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_AMP_GT] = ACTIONS(2149),
    [anon_sym_AMP_GT_GT] = ACTIONS(1538),
    [anon_sym_LT_AMP] = ACTIONS(1538),
    [anon_sym_GT_AMP] = ACTIONS(1538),
    [anon_sym_DQUOTE] = ACTIONS(1538),
    [sym_raw_string] = ACTIONS(1538),
    [anon_sym_DOLLAR] = ACTIONS(2149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1538),
    [anon_sym_BQUOTE] = ACTIONS(1538),
    [anon_sym_LT_LPAREN] = ACTIONS(1538),
    [anon_sym_GT_LPAREN] = ACTIONS(1538),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2149),
  },
  [1337] = {
    [anon_sym_AT] = ACTIONS(3126),
    [sym_comment] = ACTIONS(46),
  },
  [1338] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(3128),
    [anon_sym_RBRACE] = ACTIONS(3130),
    [sym_comment] = ACTIONS(46),
  },
  [1339] = {
    [sym_file_descriptor] = ACTIONS(1548),
    [sym_word] = ACTIONS(1548),
    [sym__concat] = ACTIONS(1548),
    [sym_variable_name] = ACTIONS(1548),
    [anon_sym_PIPE] = ACTIONS(2157),
    [anon_sym_RPAREN] = ACTIONS(1548),
    [anon_sym_PIPE_AMP] = ACTIONS(1548),
    [anon_sym_AMP_AMP] = ACTIONS(1548),
    [anon_sym_PIPE_PIPE] = ACTIONS(1548),
    [anon_sym_LT] = ACTIONS(2157),
    [anon_sym_GT] = ACTIONS(2157),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_AMP_GT] = ACTIONS(2157),
    [anon_sym_AMP_GT_GT] = ACTIONS(1548),
    [anon_sym_LT_AMP] = ACTIONS(1548),
    [anon_sym_GT_AMP] = ACTIONS(1548),
    [anon_sym_DQUOTE] = ACTIONS(1548),
    [sym_raw_string] = ACTIONS(1548),
    [anon_sym_DOLLAR] = ACTIONS(2157),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1548),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(1548),
    [anon_sym_LT_LPAREN] = ACTIONS(1548),
    [anon_sym_GT_LPAREN] = ACTIONS(1548),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2157),
  },
  [1340] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(3132),
    [anon_sym_RBRACE] = ACTIONS(3134),
    [sym_comment] = ACTIONS(46),
  },
  [1341] = {
    [sym__concat] = ACTIONS(3136),
    [anon_sym_RBRACE] = ACTIONS(3130),
    [sym_comment] = ACTIONS(46),
  },
  [1342] = {
    [anon_sym_RBRACK] = ACTIONS(3136),
    [sym_comment] = ACTIONS(46),
  },
  [1343] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(3138),
    [anon_sym_RBRACE] = ACTIONS(3140),
    [sym_comment] = ACTIONS(46),
  },
  [1344] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(3142),
    [anon_sym_RBRACE] = ACTIONS(3144),
    [sym_comment] = ACTIONS(46),
  },
  [1345] = {
    [sym__concat] = ACTIONS(3146),
    [anon_sym_RBRACE] = ACTIONS(3140),
    [sym_comment] = ACTIONS(46),
  },
  [1346] = {
    [anon_sym_RBRACK] = ACTIONS(3146),
    [sym_comment] = ACTIONS(46),
  },
  [1347] = {
    [anon_sym_PIPE] = ACTIONS(3148),
    [anon_sym_RPAREN] = ACTIONS(3150),
    [anon_sym_PIPE_AMP] = ACTIONS(3150),
    [anon_sym_AMP_AMP] = ACTIONS(3150),
    [anon_sym_PIPE_PIPE] = ACTIONS(3150),
    [anon_sym_BQUOTE] = ACTIONS(3150),
    [sym_comment] = ACTIONS(46),
  },
  [1348] = {
    [anon_sym_PIPE] = ACTIONS(3152),
    [anon_sym_RPAREN] = ACTIONS(3154),
    [anon_sym_PIPE_AMP] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_PIPE_PIPE] = ACTIONS(3154),
    [anon_sym_BQUOTE] = ACTIONS(3154),
    [sym_comment] = ACTIONS(46),
  },
  [1349] = {
    [anon_sym_fi] = ACTIONS(3156),
    [sym_comment] = ACTIONS(46),
  },
  [1350] = {
    [anon_sym_PIPE] = ACTIONS(3158),
    [anon_sym_RPAREN] = ACTIONS(3160),
    [anon_sym_PIPE_AMP] = ACTIONS(3160),
    [anon_sym_AMP_AMP] = ACTIONS(3160),
    [anon_sym_PIPE_PIPE] = ACTIONS(3160),
    [anon_sym_BQUOTE] = ACTIONS(3160),
    [sym_comment] = ACTIONS(46),
  },
  [1351] = {
    [sym_case_item] = STATE(710),
    [sym_concatenation] = STATE(711),
    [sym_string] = STATE(707),
    [sym_simple_expansion] = STATE(707),
    [sym_expansion] = STATE(707),
    [sym_command_substitution] = STATE(707),
    [sym_process_substitution] = STATE(707),
    [aux_sym_case_statement_repeat1] = STATE(1007),
    [sym_word] = ACTIONS(1354),
    [anon_sym_esac] = ACTIONS(3162),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1354),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1358),
  },
  [1352] = {
    [anon_sym_PIPE] = ACTIONS(3164),
    [anon_sym_RPAREN] = ACTIONS(3166),
    [anon_sym_PIPE_AMP] = ACTIONS(3166),
    [anon_sym_AMP_AMP] = ACTIONS(3166),
    [anon_sym_PIPE_PIPE] = ACTIONS(3166),
    [anon_sym_BQUOTE] = ACTIONS(3166),
    [sym_comment] = ACTIONS(46),
  },
  [1353] = {
    [sym_case_item] = STATE(710),
    [sym_concatenation] = STATE(711),
    [sym_string] = STATE(707),
    [sym_simple_expansion] = STATE(707),
    [sym_expansion] = STATE(707),
    [sym_command_substitution] = STATE(707),
    [sym_process_substitution] = STATE(707),
    [aux_sym_case_statement_repeat1] = STATE(1007),
    [sym_word] = ACTIONS(1354),
    [anon_sym_esac] = ACTIONS(3168),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1354),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1358),
  },
  [1354] = {
    [anon_sym_PIPE] = ACTIONS(3170),
    [anon_sym_RPAREN] = ACTIONS(3172),
    [anon_sym_PIPE_AMP] = ACTIONS(3172),
    [anon_sym_AMP_AMP] = ACTIONS(3172),
    [anon_sym_PIPE_PIPE] = ACTIONS(3172),
    [anon_sym_BQUOTE] = ACTIONS(3172),
    [sym_comment] = ACTIONS(46),
  },
  [1355] = {
    [aux_sym_concatenation_repeat1] = STATE(1359),
    [sym__concat] = ACTIONS(2801),
    [anon_sym_PIPE] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_PIPE_AMP] = ACTIONS(667),
    [anon_sym_AMP_AMP] = ACTIONS(667),
    [anon_sym_PIPE_PIPE] = ACTIONS(667),
    [sym_comment] = ACTIONS(46),
  },
  [1356] = {
    [aux_sym_concatenation_repeat1] = STATE(1374),
    [sym__concat] = ACTIONS(2801),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(671),
    [anon_sym_PIPE_AMP] = ACTIONS(671),
    [anon_sym_AMP_AMP] = ACTIONS(671),
    [anon_sym_PIPE_PIPE] = ACTIONS(671),
    [sym_comment] = ACTIONS(46),
  },
  [1357] = {
    [anon_sym_PIPE] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_PIPE_AMP] = ACTIONS(667),
    [anon_sym_AMP_AMP] = ACTIONS(667),
    [anon_sym_PIPE_PIPE] = ACTIONS(667),
    [anon_sym_BQUOTE] = ACTIONS(667),
    [sym_comment] = ACTIONS(46),
  },
  [1358] = {
    [sym_string] = STATE(1528),
    [sym_simple_expansion] = STATE(1528),
    [sym_expansion] = STATE(1528),
    [sym_command_substitution] = STATE(1528),
    [sym_process_substitution] = STATE(1528),
    [sym_word] = ACTIONS(3174),
    [anon_sym_DQUOTE] = ACTIONS(2293),
    [sym_raw_string] = ACTIONS(3174),
    [anon_sym_DOLLAR] = ACTIONS(2295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2299),
    [anon_sym_BQUOTE] = ACTIONS(2301),
    [anon_sym_LT_LPAREN] = ACTIONS(2303),
    [anon_sym_GT_LPAREN] = ACTIONS(2303),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3176),
  },
  [1359] = {
    [aux_sym_concatenation_repeat1] = STATE(1530),
    [sym__concat] = ACTIONS(2801),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_RPAREN] = ACTIONS(254),
    [anon_sym_PIPE_AMP] = ACTIONS(254),
    [anon_sym_AMP_AMP] = ACTIONS(254),
    [anon_sym_PIPE_PIPE] = ACTIONS(254),
    [sym_comment] = ACTIONS(46),
  },
  [1360] = {
    [sym__concat] = ACTIONS(394),
    [anon_sym_PIPE] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(394),
    [anon_sym_PIPE_AMP] = ACTIONS(394),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_BQUOTE] = ACTIONS(394),
    [sym_comment] = ACTIONS(46),
  },
  [1361] = {
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [aux_sym_string_repeat1] = STATE(252),
    [anon_sym_DQUOTE] = ACTIONS(3178),
    [sym__string_content] = ACTIONS(122),
    [anon_sym_DOLLAR] = ACTIONS(124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(126),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(128),
    [anon_sym_BQUOTE] = ACTIONS(130),
    [sym_comment] = ACTIONS(60),
  },
  [1362] = {
    [sym__concat] = ACTIONS(412),
    [anon_sym_PIPE] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(412),
    [anon_sym_PIPE_AMP] = ACTIONS(412),
    [anon_sym_AMP_AMP] = ACTIONS(412),
    [anon_sym_PIPE_PIPE] = ACTIONS(412),
    [anon_sym_BQUOTE] = ACTIONS(412),
    [sym_comment] = ACTIONS(46),
  },
  [1363] = {
    [sym__concat] = ACTIONS(416),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_RPAREN] = ACTIONS(416),
    [anon_sym_PIPE_AMP] = ACTIONS(416),
    [anon_sym_AMP_AMP] = ACTIONS(416),
    [anon_sym_PIPE_PIPE] = ACTIONS(416),
    [anon_sym_BQUOTE] = ACTIONS(416),
    [sym_comment] = ACTIONS(46),
  },
  [1364] = {
    [sym__concat] = ACTIONS(420),
    [anon_sym_PIPE] = ACTIONS(885),
    [anon_sym_RPAREN] = ACTIONS(420),
    [anon_sym_PIPE_AMP] = ACTIONS(420),
    [anon_sym_AMP_AMP] = ACTIONS(420),
    [anon_sym_PIPE_PIPE] = ACTIONS(420),
    [anon_sym_BQUOTE] = ACTIONS(420),
    [sym_comment] = ACTIONS(46),
  },
  [1365] = {
    [sym_special_variable_name] = STATE(1533),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_EQ] = ACTIONS(412),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_POUND] = ACTIONS(138),
    [anon_sym_AT] = ACTIONS(138),
    [anon_sym_COLON] = ACTIONS(424),
    [anon_sym_COLON_QMARK] = ACTIONS(412),
    [anon_sym_COLON_DASH] = ACTIONS(412),
    [anon_sym_PERCENT] = ACTIONS(412),
    [anon_sym_SLASH] = ACTIONS(412),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(3180),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_QMARK] = ACTIONS(138),
    [anon_sym_DASH] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_0] = ACTIONS(144),
    [anon_sym__] = ACTIONS(144),
  },
  [1366] = {
    [anon_sym_RBRACE] = ACTIONS(3182),
    [anon_sym_EQ] = ACTIONS(3184),
    [anon_sym_LBRACK] = ACTIONS(3186),
    [anon_sym_COLON] = ACTIONS(3188),
    [anon_sym_COLON_QMARK] = ACTIONS(3184),
    [anon_sym_COLON_DASH] = ACTIONS(3184),
    [anon_sym_PERCENT] = ACTIONS(3184),
    [anon_sym_SLASH] = ACTIONS(3184),
    [sym_comment] = ACTIONS(46),
  },
  [1367] = {
    [anon_sym_RBRACE] = ACTIONS(3190),
    [anon_sym_EQ] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3194),
    [anon_sym_COLON] = ACTIONS(3196),
    [anon_sym_COLON_QMARK] = ACTIONS(3192),
    [anon_sym_COLON_DASH] = ACTIONS(3192),
    [anon_sym_PERCENT] = ACTIONS(3192),
    [anon_sym_SLASH] = ACTIONS(3192),
    [sym_comment] = ACTIONS(46),
  },
  [1368] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(3198),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [1369] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(3198),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [1370] = {
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_comment] = ACTIONS(46),
  },
  [1371] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [1372] = {
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(3200),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [sym_comment] = ACTIONS(46),
  },
  [1373] = {
    [sym_file_descriptor] = ACTIONS(234),
    [sym_word] = ACTIONS(234),
    [sym_variable_name] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_RPAREN] = ACTIONS(3200),
    [anon_sym_PIPE_AMP] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(234),
    [anon_sym_LT_AMP] = ACTIONS(234),
    [anon_sym_GT_AMP] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(234),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(234),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [anon_sym_LT_LPAREN] = ACTIONS(234),
    [anon_sym_GT_LPAREN] = ACTIONS(234),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(238),
  },
  [1374] = {
    [aux_sym_concatenation_repeat1] = STATE(1530),
    [sym__concat] = ACTIONS(2801),
    [anon_sym_PIPE] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(542),
    [anon_sym_AMP_AMP] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [sym_comment] = ACTIONS(46),
  },
  [1375] = {
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(675),
    [sym_variable_name] = ACTIONS(675),
    [anon_sym_PIPE] = ACTIONS(1471),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_PIPE_AMP] = ACTIONS(675),
    [anon_sym_AMP_AMP] = ACTIONS(675),
    [anon_sym_PIPE_PIPE] = ACTIONS(675),
    [anon_sym_BQUOTE] = ACTIONS(675),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1471),
  },
  [1376] = {
    [sym_word] = ACTIONS(679),
    [sym__concat] = ACTIONS(679),
    [sym_variable_name] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(1473),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(679),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1473),
  },
  [1377] = {
    [aux_sym_concatenation_repeat1] = STATE(1377),
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(3202),
    [sym_variable_name] = ACTIONS(675),
    [anon_sym_PIPE] = ACTIONS(1471),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_PIPE_AMP] = ACTIONS(675),
    [anon_sym_AMP_AMP] = ACTIONS(675),
    [anon_sym_PIPE_PIPE] = ACTIONS(675),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1471),
  },
  [1378] = {
    [sym_word] = ACTIONS(1888),
    [sym_variable_name] = ACTIONS(1888),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_RPAREN] = ACTIONS(1888),
    [anon_sym_PIPE_AMP] = ACTIONS(1888),
    [anon_sym_AMP_AMP] = ACTIONS(1888),
    [anon_sym_PIPE_PIPE] = ACTIONS(1888),
    [anon_sym_BQUOTE] = ACTIONS(1888),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2745),
  },
  [1379] = {
    [sym_word] = ACTIONS(931),
    [sym__concat] = ACTIONS(931),
    [sym_variable_name] = ACTIONS(931),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_RPAREN] = ACTIONS(931),
    [anon_sym_PIPE_AMP] = ACTIONS(931),
    [anon_sym_AMP_AMP] = ACTIONS(931),
    [anon_sym_PIPE_PIPE] = ACTIONS(931),
    [anon_sym_BQUOTE] = ACTIONS(931),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1478),
  },
  [1380] = {
    [anon_sym_RBRACE] = ACTIONS(3205),
    [anon_sym_LBRACK] = ACTIONS(3207),
    [sym_comment] = ACTIONS(46),
  },
  [1381] = {
    [anon_sym_RBRACE] = ACTIONS(3209),
    [anon_sym_LBRACK] = ACTIONS(3211),
    [sym_comment] = ACTIONS(46),
  },
  [1382] = {
    [sym_word] = ACTIONS(960),
    [sym__concat] = ACTIONS(960),
    [sym_variable_name] = ACTIONS(960),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_RPAREN] = ACTIONS(960),
    [anon_sym_PIPE_AMP] = ACTIONS(960),
    [anon_sym_AMP_AMP] = ACTIONS(960),
    [anon_sym_PIPE_PIPE] = ACTIONS(960),
    [anon_sym_BQUOTE] = ACTIONS(960),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1488),
  },
  [1383] = {
    [sym_concatenation] = STATE(1549),
    [sym_string] = STATE(1546),
    [sym_simple_expansion] = STATE(1546),
    [sym_expansion] = STATE(1546),
    [sym_command_substitution] = STATE(1546),
    [sym_process_substitution] = STATE(1546),
    [sym_word] = ACTIONS(3213),
    [anon_sym_RBRACE] = ACTIONS(3215),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(3213),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3217),
  },
  [1384] = {
    [anon_sym_AT] = ACTIONS(3219),
    [sym_comment] = ACTIONS(46),
  },
  [1385] = {
    [sym_word] = ACTIONS(972),
    [sym__concat] = ACTIONS(972),
    [sym_variable_name] = ACTIONS(972),
    [anon_sym_PIPE] = ACTIONS(1498),
    [anon_sym_RPAREN] = ACTIONS(972),
    [anon_sym_PIPE_AMP] = ACTIONS(972),
    [anon_sym_AMP_AMP] = ACTIONS(972),
    [anon_sym_PIPE_PIPE] = ACTIONS(972),
    [anon_sym_BQUOTE] = ACTIONS(972),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1498),
  },
  [1386] = {
    [sym_concatenation] = STATE(1553),
    [sym_string] = STATE(1551),
    [sym_simple_expansion] = STATE(1551),
    [sym_expansion] = STATE(1551),
    [sym_command_substitution] = STATE(1551),
    [sym_process_substitution] = STATE(1551),
    [sym_word] = ACTIONS(3221),
    [anon_sym_RBRACE] = ACTIONS(3209),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(3221),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3223),
  },
  [1387] = {
    [anon_sym_AT] = ACTIONS(3225),
    [sym_comment] = ACTIONS(46),
  },
  [1388] = {
    [sym_word] = ACTIONS(1066),
    [sym__concat] = ACTIONS(1066),
    [sym_variable_name] = ACTIONS(1066),
    [anon_sym_PIPE] = ACTIONS(1506),
    [anon_sym_RPAREN] = ACTIONS(1066),
    [anon_sym_PIPE_AMP] = ACTIONS(1066),
    [anon_sym_AMP_AMP] = ACTIONS(1066),
    [anon_sym_PIPE_PIPE] = ACTIONS(1066),
    [anon_sym_BQUOTE] = ACTIONS(1066),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1506),
  },
  [1389] = {
    [sym_word] = ACTIONS(1122),
    [sym__concat] = ACTIONS(1122),
    [sym_variable_name] = ACTIONS(1122),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_RPAREN] = ACTIONS(1122),
    [anon_sym_PIPE_AMP] = ACTIONS(1122),
    [anon_sym_AMP_AMP] = ACTIONS(1122),
    [anon_sym_PIPE_PIPE] = ACTIONS(1122),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1508),
  },
  [1390] = {
    [anon_sym_RBRACE] = ACTIONS(3227),
    [sym_comment] = ACTIONS(46),
  },
  [1391] = {
    [anon_sym_RBRACE] = ACTIONS(3229),
    [sym_comment] = ACTIONS(46),
  },
  [1392] = {
    [sym_file_descriptor] = ACTIONS(2726),
    [sym_word] = ACTIONS(2726),
    [sym__concat] = ACTIONS(2726),
    [anon_sym_PIPE] = ACTIONS(3104),
    [anon_sym_RPAREN] = ACTIONS(2726),
    [anon_sym_PIPE_AMP] = ACTIONS(2726),
    [anon_sym_AMP_AMP] = ACTIONS(2726),
    [anon_sym_PIPE_PIPE] = ACTIONS(2726),
    [anon_sym_LT] = ACTIONS(3104),
    [anon_sym_GT] = ACTIONS(3104),
    [anon_sym_GT_GT] = ACTIONS(2726),
    [anon_sym_AMP_GT] = ACTIONS(3104),
    [anon_sym_AMP_GT_GT] = ACTIONS(2726),
    [anon_sym_LT_AMP] = ACTIONS(2726),
    [anon_sym_GT_AMP] = ACTIONS(2726),
    [anon_sym_LT_LT] = ACTIONS(3104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2726),
    [anon_sym_DQUOTE] = ACTIONS(2726),
    [sym_raw_string] = ACTIONS(2726),
    [anon_sym_DOLLAR] = ACTIONS(3104),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2726),
    [anon_sym_BQUOTE] = ACTIONS(2726),
    [anon_sym_LT_LPAREN] = ACTIONS(2726),
    [anon_sym_GT_LPAREN] = ACTIONS(2726),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3104),
  },
  [1393] = {
    [sym_file_descriptor] = ACTIONS(2730),
    [sym_word] = ACTIONS(2730),
    [sym__concat] = ACTIONS(2730),
    [anon_sym_PIPE] = ACTIONS(3106),
    [anon_sym_RPAREN] = ACTIONS(2730),
    [anon_sym_PIPE_AMP] = ACTIONS(2730),
    [anon_sym_AMP_AMP] = ACTIONS(2730),
    [anon_sym_PIPE_PIPE] = ACTIONS(2730),
    [anon_sym_LT] = ACTIONS(3106),
    [anon_sym_GT] = ACTIONS(3106),
    [anon_sym_GT_GT] = ACTIONS(2730),
    [anon_sym_AMP_GT] = ACTIONS(3106),
    [anon_sym_AMP_GT_GT] = ACTIONS(2730),
    [anon_sym_LT_AMP] = ACTIONS(2730),
    [anon_sym_GT_AMP] = ACTIONS(2730),
    [anon_sym_LT_LT] = ACTIONS(3106),
    [anon_sym_LT_LT_DASH] = ACTIONS(2730),
    [anon_sym_DQUOTE] = ACTIONS(2730),
    [sym_raw_string] = ACTIONS(2730),
    [anon_sym_DOLLAR] = ACTIONS(3106),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2730),
    [anon_sym_BQUOTE] = ACTIONS(2730),
    [anon_sym_LT_LPAREN] = ACTIONS(2730),
    [anon_sym_GT_LPAREN] = ACTIONS(2730),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3106),
  },
  [1394] = {
    [sym_file_descriptor] = ACTIONS(2734),
    [sym_word] = ACTIONS(2734),
    [sym__concat] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(3108),
    [anon_sym_RPAREN] = ACTIONS(2734),
    [anon_sym_PIPE_AMP] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2734),
    [anon_sym_PIPE_PIPE] = ACTIONS(2734),
    [anon_sym_LT] = ACTIONS(3108),
    [anon_sym_GT] = ACTIONS(3108),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_AMP_GT] = ACTIONS(3108),
    [anon_sym_AMP_GT_GT] = ACTIONS(2734),
    [anon_sym_LT_AMP] = ACTIONS(2734),
    [anon_sym_GT_AMP] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(3108),
    [anon_sym_LT_LT_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(2734),
    [sym_raw_string] = ACTIONS(2734),
    [anon_sym_DOLLAR] = ACTIONS(3108),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2734),
    [anon_sym_BQUOTE] = ACTIONS(2734),
    [anon_sym_LT_LPAREN] = ACTIONS(2734),
    [anon_sym_GT_LPAREN] = ACTIONS(2734),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3108),
  },
  [1395] = {
    [sym_file_descriptor] = ACTIONS(2738),
    [sym_word] = ACTIONS(2738),
    [sym__concat] = ACTIONS(2738),
    [anon_sym_PIPE] = ACTIONS(3110),
    [anon_sym_RPAREN] = ACTIONS(2738),
    [anon_sym_PIPE_AMP] = ACTIONS(2738),
    [anon_sym_AMP_AMP] = ACTIONS(2738),
    [anon_sym_PIPE_PIPE] = ACTIONS(2738),
    [anon_sym_LT] = ACTIONS(3110),
    [anon_sym_GT] = ACTIONS(3110),
    [anon_sym_GT_GT] = ACTIONS(2738),
    [anon_sym_AMP_GT] = ACTIONS(3110),
    [anon_sym_AMP_GT_GT] = ACTIONS(2738),
    [anon_sym_LT_AMP] = ACTIONS(2738),
    [anon_sym_GT_AMP] = ACTIONS(2738),
    [anon_sym_LT_LT] = ACTIONS(3110),
    [anon_sym_LT_LT_DASH] = ACTIONS(2738),
    [anon_sym_DQUOTE] = ACTIONS(2738),
    [sym_raw_string] = ACTIONS(2738),
    [anon_sym_DOLLAR] = ACTIONS(3110),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2738),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2738),
    [anon_sym_BQUOTE] = ACTIONS(2738),
    [anon_sym_LT_LPAREN] = ACTIONS(2738),
    [anon_sym_GT_LPAREN] = ACTIONS(2738),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3110),
  },
  [1396] = {
    [sym_file_descriptor] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(2145),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_GT] = ACTIONS(2145),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(2145),
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(2145),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [sym_comment] = ACTIONS(46),
  },
  [1397] = {
    [anon_sym_AT] = ACTIONS(3231),
    [sym_comment] = ACTIONS(46),
  },
  [1398] = {
    [sym_file_descriptor] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(2149),
    [anon_sym_RPAREN] = ACTIONS(1538),
    [anon_sym_PIPE_AMP] = ACTIONS(1538),
    [anon_sym_AMP_AMP] = ACTIONS(1538),
    [anon_sym_PIPE_PIPE] = ACTIONS(1538),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_GT] = ACTIONS(2149),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_AMP_GT] = ACTIONS(2149),
    [anon_sym_AMP_GT_GT] = ACTIONS(1538),
    [anon_sym_LT_AMP] = ACTIONS(1538),
    [anon_sym_GT_AMP] = ACTIONS(1538),
    [anon_sym_LT_LT] = ACTIONS(2149),
    [anon_sym_LT_LT_DASH] = ACTIONS(1538),
    [anon_sym_BQUOTE] = ACTIONS(1538),
    [sym_comment] = ACTIONS(46),
  },
  [1399] = {
    [anon_sym_AT] = ACTIONS(3233),
    [sym_comment] = ACTIONS(46),
  },
  [1400] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(3235),
    [anon_sym_RBRACE] = ACTIONS(3237),
    [sym_comment] = ACTIONS(46),
  },
  [1401] = {
    [sym_file_descriptor] = ACTIONS(1548),
    [sym__concat] = ACTIONS(1548),
    [anon_sym_PIPE] = ACTIONS(2157),
    [anon_sym_RPAREN] = ACTIONS(1548),
    [anon_sym_PIPE_AMP] = ACTIONS(1548),
    [anon_sym_AMP_AMP] = ACTIONS(1548),
    [anon_sym_PIPE_PIPE] = ACTIONS(1548),
    [anon_sym_LT] = ACTIONS(2157),
    [anon_sym_GT] = ACTIONS(2157),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_AMP_GT] = ACTIONS(2157),
    [anon_sym_AMP_GT_GT] = ACTIONS(1548),
    [anon_sym_LT_AMP] = ACTIONS(1548),
    [anon_sym_GT_AMP] = ACTIONS(1548),
    [anon_sym_LT_LT] = ACTIONS(2157),
    [anon_sym_LT_LT_DASH] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(1548),
    [sym_comment] = ACTIONS(46),
  },
  [1402] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(3239),
    [anon_sym_RBRACE] = ACTIONS(3241),
    [sym_comment] = ACTIONS(46),
  },
  [1403] = {
    [sym__concat] = ACTIONS(3243),
    [anon_sym_RBRACE] = ACTIONS(3237),
    [sym_comment] = ACTIONS(46),
  },
  [1404] = {
    [anon_sym_RBRACK] = ACTIONS(3243),
    [sym_comment] = ACTIONS(46),
  },
  [1405] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(3245),
    [anon_sym_RBRACE] = ACTIONS(3247),
    [sym_comment] = ACTIONS(46),
  },
  [1406] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(3249),
    [anon_sym_RBRACE] = ACTIONS(3251),
    [sym_comment] = ACTIONS(46),
  },
  [1407] = {
    [sym__concat] = ACTIONS(3253),
    [anon_sym_RBRACE] = ACTIONS(3247),
    [sym_comment] = ACTIONS(46),
  },
  [1408] = {
    [anon_sym_RBRACK] = ACTIONS(3253),
    [sym_comment] = ACTIONS(46),
  },
  [1409] = {
    [aux_sym_concatenation_repeat1] = STATE(1411),
    [sym__concat] = ACTIONS(2801),
    [anon_sym_PIPE] = ACTIONS(669),
    [anon_sym_PIPE_AMP] = ACTIONS(667),
    [anon_sym_AMP_AMP] = ACTIONS(667),
    [anon_sym_PIPE_PIPE] = ACTIONS(667),
    [anon_sym_BQUOTE] = ACTIONS(667),
    [sym_comment] = ACTIONS(46),
  },
  [1410] = {
    [aux_sym_concatenation_repeat1] = STATE(1412),
    [sym__concat] = ACTIONS(2801),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_PIPE_AMP] = ACTIONS(671),
    [anon_sym_AMP_AMP] = ACTIONS(671),
    [anon_sym_PIPE_PIPE] = ACTIONS(671),
    [anon_sym_BQUOTE] = ACTIONS(671),
    [sym_comment] = ACTIONS(46),
  },
  [1411] = {
    [aux_sym_concatenation_repeat1] = STATE(1569),
    [sym__concat] = ACTIONS(2801),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_PIPE_AMP] = ACTIONS(254),
    [anon_sym_AMP_AMP] = ACTIONS(254),
    [anon_sym_PIPE_PIPE] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [sym_comment] = ACTIONS(46),
  },
  [1412] = {
    [aux_sym_concatenation_repeat1] = STATE(1569),
    [sym__concat] = ACTIONS(2801),
    [anon_sym_PIPE] = ACTIONS(909),
    [anon_sym_PIPE_AMP] = ACTIONS(542),
    [anon_sym_AMP_AMP] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [anon_sym_BQUOTE] = ACTIONS(542),
    [sym_comment] = ACTIONS(46),
  },
  [1413] = {
    [aux_sym_concatenation_repeat1] = STATE(1413),
    [sym_word] = ACTIONS(675),
    [sym__concat] = ACTIONS(3202),
    [sym_variable_name] = ACTIONS(675),
    [anon_sym_PIPE] = ACTIONS(1471),
    [anon_sym_PIPE_AMP] = ACTIONS(675),
    [anon_sym_AMP_AMP] = ACTIONS(675),
    [anon_sym_PIPE_PIPE] = ACTIONS(675),
    [anon_sym_BQUOTE] = ACTIONS(675),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1471),
  },
  [1414] = {
    [anon_sym_RBRACK] = ACTIONS(3255),
    [sym_comment] = ACTIONS(46),
  },
  [1415] = {
    [anon_sym_RBRACK] = ACTIONS(3257),
    [sym_comment] = ACTIONS(46),
  },
  [1416] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3259),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1417] = {
    [sym_file_descriptor] = ACTIONS(2205),
    [sym__concat] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2207),
    [anon_sym_RPAREN] = ACTIONS(2207),
    [anon_sym_SEMI_SEMI] = ACTIONS(2207),
    [anon_sym_PIPE_AMP] = ACTIONS(2207),
    [anon_sym_AMP_AMP] = ACTIONS(2207),
    [anon_sym_PIPE_PIPE] = ACTIONS(2207),
    [anon_sym_LT] = ACTIONS(2207),
    [anon_sym_GT] = ACTIONS(2207),
    [anon_sym_GT_GT] = ACTIONS(2207),
    [anon_sym_AMP_GT] = ACTIONS(2207),
    [anon_sym_AMP_GT_GT] = ACTIONS(2207),
    [anon_sym_LT_AMP] = ACTIONS(2207),
    [anon_sym_GT_AMP] = ACTIONS(2207),
    [anon_sym_LT_LT] = ACTIONS(2207),
    [anon_sym_LT_LT_DASH] = ACTIONS(2207),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2207),
    [anon_sym_LF] = ACTIONS(2207),
    [anon_sym_AMP] = ACTIONS(2207),
  },
  [1418] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1419] = {
    [sym_file_descriptor] = ACTIONS(2211),
    [sym__concat] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2213),
    [anon_sym_RPAREN] = ACTIONS(2213),
    [anon_sym_SEMI_SEMI] = ACTIONS(2213),
    [anon_sym_PIPE_AMP] = ACTIONS(2213),
    [anon_sym_AMP_AMP] = ACTIONS(2213),
    [anon_sym_PIPE_PIPE] = ACTIONS(2213),
    [anon_sym_LT] = ACTIONS(2213),
    [anon_sym_GT] = ACTIONS(2213),
    [anon_sym_GT_GT] = ACTIONS(2213),
    [anon_sym_AMP_GT] = ACTIONS(2213),
    [anon_sym_AMP_GT_GT] = ACTIONS(2213),
    [anon_sym_LT_AMP] = ACTIONS(2213),
    [anon_sym_GT_AMP] = ACTIONS(2213),
    [anon_sym_LT_LT] = ACTIONS(2213),
    [anon_sym_LT_LT_DASH] = ACTIONS(2213),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2213),
    [anon_sym_LF] = ACTIONS(2213),
    [anon_sym_AMP] = ACTIONS(2213),
  },
  [1420] = {
    [anon_sym_RBRACE] = ACTIONS(3259),
    [sym_comment] = ACTIONS(46),
  },
  [1421] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3263),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1422] = {
    [sym_file_descriptor] = ACTIONS(2217),
    [sym__concat] = ACTIONS(2217),
    [anon_sym_PIPE] = ACTIONS(2219),
    [anon_sym_RPAREN] = ACTIONS(2219),
    [anon_sym_SEMI_SEMI] = ACTIONS(2219),
    [anon_sym_PIPE_AMP] = ACTIONS(2219),
    [anon_sym_AMP_AMP] = ACTIONS(2219),
    [anon_sym_PIPE_PIPE] = ACTIONS(2219),
    [anon_sym_LT] = ACTIONS(2219),
    [anon_sym_GT] = ACTIONS(2219),
    [anon_sym_GT_GT] = ACTIONS(2219),
    [anon_sym_AMP_GT] = ACTIONS(2219),
    [anon_sym_AMP_GT_GT] = ACTIONS(2219),
    [anon_sym_LT_AMP] = ACTIONS(2219),
    [anon_sym_GT_AMP] = ACTIONS(2219),
    [anon_sym_LT_LT] = ACTIONS(2219),
    [anon_sym_LT_LT_DASH] = ACTIONS(2219),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2219),
    [anon_sym_LF] = ACTIONS(2219),
    [anon_sym_AMP] = ACTIONS(2219),
  },
  [1423] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3265),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1424] = {
    [sym_file_descriptor] = ACTIONS(2223),
    [sym__concat] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_RPAREN] = ACTIONS(2225),
    [anon_sym_SEMI_SEMI] = ACTIONS(2225),
    [anon_sym_PIPE_AMP] = ACTIONS(2225),
    [anon_sym_AMP_AMP] = ACTIONS(2225),
    [anon_sym_PIPE_PIPE] = ACTIONS(2225),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_GT_GT] = ACTIONS(2225),
    [anon_sym_AMP_GT] = ACTIONS(2225),
    [anon_sym_AMP_GT_GT] = ACTIONS(2225),
    [anon_sym_LT_AMP] = ACTIONS(2225),
    [anon_sym_GT_AMP] = ACTIONS(2225),
    [anon_sym_LT_LT] = ACTIONS(2225),
    [anon_sym_LT_LT_DASH] = ACTIONS(2225),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2225),
    [anon_sym_LF] = ACTIONS(2225),
    [anon_sym_AMP] = ACTIONS(2225),
  },
  [1425] = {
    [anon_sym_RBRACE] = ACTIONS(3263),
    [sym_comment] = ACTIONS(46),
  },
  [1426] = {
    [sym__heredoc_middle] = ACTIONS(1532),
    [sym__heredoc_end] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(2145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [sym_comment] = ACTIONS(46),
  },
  [1427] = {
    [anon_sym_AT] = ACTIONS(3267),
    [sym_comment] = ACTIONS(46),
  },
  [1428] = {
    [sym__heredoc_middle] = ACTIONS(1538),
    [sym__heredoc_end] = ACTIONS(1538),
    [anon_sym_DOLLAR] = ACTIONS(2149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1538),
    [sym_comment] = ACTIONS(46),
  },
  [1429] = {
    [anon_sym_AT] = ACTIONS(3269),
    [sym_comment] = ACTIONS(46),
  },
  [1430] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(3271),
    [anon_sym_RBRACE] = ACTIONS(3273),
    [sym_comment] = ACTIONS(46),
  },
  [1431] = {
    [sym__heredoc_middle] = ACTIONS(1548),
    [sym__heredoc_end] = ACTIONS(1548),
    [anon_sym_DOLLAR] = ACTIONS(2157),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1548),
    [sym_comment] = ACTIONS(46),
  },
  [1432] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(3275),
    [anon_sym_RBRACE] = ACTIONS(3277),
    [sym_comment] = ACTIONS(46),
  },
  [1433] = {
    [sym__concat] = ACTIONS(3279),
    [anon_sym_RBRACE] = ACTIONS(3273),
    [sym_comment] = ACTIONS(46),
  },
  [1434] = {
    [anon_sym_RBRACK] = ACTIONS(3279),
    [sym_comment] = ACTIONS(46),
  },
  [1435] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(3281),
    [anon_sym_RBRACE] = ACTIONS(3283),
    [sym_comment] = ACTIONS(46),
  },
  [1436] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3287),
    [sym_comment] = ACTIONS(46),
  },
  [1437] = {
    [sym__concat] = ACTIONS(3289),
    [anon_sym_RBRACE] = ACTIONS(3283),
    [sym_comment] = ACTIONS(46),
  },
  [1438] = {
    [anon_sym_RBRACK] = ACTIONS(3289),
    [sym_comment] = ACTIONS(46),
  },
  [1439] = {
    [anon_sym_RBRACK] = ACTIONS(3291),
    [sym_comment] = ACTIONS(46),
  },
  [1440] = {
    [anon_sym_RBRACK] = ACTIONS(3293),
    [sym_comment] = ACTIONS(46),
  },
  [1441] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1442] = {
    [sym_word] = ACTIONS(2205),
    [sym__concat] = ACTIONS(2205),
    [anon_sym_RPAREN] = ACTIONS(2205),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [sym_raw_string] = ACTIONS(2205),
    [anon_sym_DOLLAR] = ACTIONS(2696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2205),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [anon_sym_LT_LPAREN] = ACTIONS(2205),
    [anon_sym_GT_LPAREN] = ACTIONS(2205),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2696),
  },
  [1443] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3297),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1444] = {
    [sym_word] = ACTIONS(2211),
    [sym__concat] = ACTIONS(2211),
    [anon_sym_RPAREN] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_raw_string] = ACTIONS(2211),
    [anon_sym_DOLLAR] = ACTIONS(2700),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2211),
    [anon_sym_BQUOTE] = ACTIONS(2211),
    [anon_sym_LT_LPAREN] = ACTIONS(2211),
    [anon_sym_GT_LPAREN] = ACTIONS(2211),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2700),
  },
  [1445] = {
    [anon_sym_RBRACE] = ACTIONS(3295),
    [sym_comment] = ACTIONS(46),
  },
  [1446] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3299),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1447] = {
    [sym_word] = ACTIONS(2217),
    [sym__concat] = ACTIONS(2217),
    [anon_sym_RPAREN] = ACTIONS(2217),
    [anon_sym_DQUOTE] = ACTIONS(2217),
    [sym_raw_string] = ACTIONS(2217),
    [anon_sym_DOLLAR] = ACTIONS(2704),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2217),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2217),
    [anon_sym_BQUOTE] = ACTIONS(2217),
    [anon_sym_LT_LPAREN] = ACTIONS(2217),
    [anon_sym_GT_LPAREN] = ACTIONS(2217),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2704),
  },
  [1448] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3301),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1449] = {
    [sym_word] = ACTIONS(2223),
    [sym__concat] = ACTIONS(2223),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2223),
    [sym_raw_string] = ACTIONS(2223),
    [anon_sym_DOLLAR] = ACTIONS(2708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2223),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2223),
    [anon_sym_BQUOTE] = ACTIONS(2223),
    [anon_sym_LT_LPAREN] = ACTIONS(2223),
    [anon_sym_GT_LPAREN] = ACTIONS(2223),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2708),
  },
  [1450] = {
    [anon_sym_RBRACE] = ACTIONS(3299),
    [sym_comment] = ACTIONS(46),
  },
  [1451] = {
    [anon_sym_RBRACE] = ACTIONS(3303),
    [sym_comment] = ACTIONS(46),
  },
  [1452] = {
    [anon_sym_RBRACE] = ACTIONS(3305),
    [sym_comment] = ACTIONS(46),
  },
  [1453] = {
    [sym_file_descriptor] = ACTIONS(2726),
    [sym_word] = ACTIONS(2726),
    [sym__concat] = ACTIONS(2726),
    [sym_variable_name] = ACTIONS(2726),
    [anon_sym_PIPE] = ACTIONS(2728),
    [anon_sym_RPAREN] = ACTIONS(2728),
    [anon_sym_SEMI_SEMI] = ACTIONS(2728),
    [anon_sym_PIPE_AMP] = ACTIONS(2728),
    [anon_sym_AMP_AMP] = ACTIONS(2728),
    [anon_sym_PIPE_PIPE] = ACTIONS(2728),
    [anon_sym_LT] = ACTIONS(2728),
    [anon_sym_GT] = ACTIONS(2728),
    [anon_sym_GT_GT] = ACTIONS(2728),
    [anon_sym_AMP_GT] = ACTIONS(2728),
    [anon_sym_AMP_GT_GT] = ACTIONS(2728),
    [anon_sym_LT_AMP] = ACTIONS(2728),
    [anon_sym_GT_AMP] = ACTIONS(2728),
    [anon_sym_DQUOTE] = ACTIONS(2728),
    [sym_raw_string] = ACTIONS(2728),
    [anon_sym_DOLLAR] = ACTIONS(2728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2728),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2728),
    [anon_sym_BQUOTE] = ACTIONS(2728),
    [anon_sym_LT_LPAREN] = ACTIONS(2728),
    [anon_sym_GT_LPAREN] = ACTIONS(2728),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2728),
    [anon_sym_SEMI] = ACTIONS(2728),
    [anon_sym_LF] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(2728),
  },
  [1454] = {
    [sym_file_descriptor] = ACTIONS(2730),
    [sym_word] = ACTIONS(2730),
    [sym__concat] = ACTIONS(2730),
    [sym_variable_name] = ACTIONS(2730),
    [anon_sym_PIPE] = ACTIONS(2732),
    [anon_sym_RPAREN] = ACTIONS(2732),
    [anon_sym_SEMI_SEMI] = ACTIONS(2732),
    [anon_sym_PIPE_AMP] = ACTIONS(2732),
    [anon_sym_AMP_AMP] = ACTIONS(2732),
    [anon_sym_PIPE_PIPE] = ACTIONS(2732),
    [anon_sym_LT] = ACTIONS(2732),
    [anon_sym_GT] = ACTIONS(2732),
    [anon_sym_GT_GT] = ACTIONS(2732),
    [anon_sym_AMP_GT] = ACTIONS(2732),
    [anon_sym_AMP_GT_GT] = ACTIONS(2732),
    [anon_sym_LT_AMP] = ACTIONS(2732),
    [anon_sym_GT_AMP] = ACTIONS(2732),
    [anon_sym_DQUOTE] = ACTIONS(2732),
    [sym_raw_string] = ACTIONS(2732),
    [anon_sym_DOLLAR] = ACTIONS(2732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2732),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2732),
    [anon_sym_BQUOTE] = ACTIONS(2732),
    [anon_sym_LT_LPAREN] = ACTIONS(2732),
    [anon_sym_GT_LPAREN] = ACTIONS(2732),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2732),
    [anon_sym_SEMI] = ACTIONS(2732),
    [anon_sym_LF] = ACTIONS(2732),
    [anon_sym_AMP] = ACTIONS(2732),
  },
  [1455] = {
    [sym_file_descriptor] = ACTIONS(2734),
    [sym_word] = ACTIONS(2734),
    [sym__concat] = ACTIONS(2734),
    [sym_variable_name] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2736),
    [anon_sym_RPAREN] = ACTIONS(2736),
    [anon_sym_SEMI_SEMI] = ACTIONS(2736),
    [anon_sym_PIPE_AMP] = ACTIONS(2736),
    [anon_sym_AMP_AMP] = ACTIONS(2736),
    [anon_sym_PIPE_PIPE] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2736),
    [anon_sym_GT] = ACTIONS(2736),
    [anon_sym_GT_GT] = ACTIONS(2736),
    [anon_sym_AMP_GT] = ACTIONS(2736),
    [anon_sym_AMP_GT_GT] = ACTIONS(2736),
    [anon_sym_LT_AMP] = ACTIONS(2736),
    [anon_sym_GT_AMP] = ACTIONS(2736),
    [anon_sym_DQUOTE] = ACTIONS(2736),
    [sym_raw_string] = ACTIONS(2736),
    [anon_sym_DOLLAR] = ACTIONS(2736),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2736),
    [anon_sym_BQUOTE] = ACTIONS(2736),
    [anon_sym_LT_LPAREN] = ACTIONS(2736),
    [anon_sym_GT_LPAREN] = ACTIONS(2736),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2736),
    [anon_sym_SEMI] = ACTIONS(2736),
    [anon_sym_LF] = ACTIONS(2736),
    [anon_sym_AMP] = ACTIONS(2736),
  },
  [1456] = {
    [sym_file_descriptor] = ACTIONS(2738),
    [sym_word] = ACTIONS(2738),
    [sym__concat] = ACTIONS(2738),
    [sym_variable_name] = ACTIONS(2738),
    [anon_sym_PIPE] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [anon_sym_SEMI_SEMI] = ACTIONS(2740),
    [anon_sym_PIPE_AMP] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_PIPE_PIPE] = ACTIONS(2740),
    [anon_sym_LT] = ACTIONS(2740),
    [anon_sym_GT] = ACTIONS(2740),
    [anon_sym_GT_GT] = ACTIONS(2740),
    [anon_sym_AMP_GT] = ACTIONS(2740),
    [anon_sym_AMP_GT_GT] = ACTIONS(2740),
    [anon_sym_LT_AMP] = ACTIONS(2740),
    [anon_sym_GT_AMP] = ACTIONS(2740),
    [anon_sym_DQUOTE] = ACTIONS(2740),
    [sym_raw_string] = ACTIONS(2740),
    [anon_sym_DOLLAR] = ACTIONS(2740),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2740),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2740),
    [anon_sym_BQUOTE] = ACTIONS(2740),
    [anon_sym_LT_LPAREN] = ACTIONS(2740),
    [anon_sym_GT_LPAREN] = ACTIONS(2740),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2740),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym_LF] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2740),
  },
  [1457] = {
    [anon_sym_RBRACE] = ACTIONS(3307),
    [sym_comment] = ACTIONS(46),
  },
  [1458] = {
    [anon_sym_RBRACE] = ACTIONS(3309),
    [sym_comment] = ACTIONS(46),
  },
  [1459] = {
    [sym__concat] = ACTIONS(2726),
    [anon_sym_PIPE] = ACTIONS(2726),
    [anon_sym_RPAREN] = ACTIONS(2726),
    [anon_sym_RBRACE] = ACTIONS(2726),
    [anon_sym_RBRACK] = ACTIONS(2726),
    [sym_comment] = ACTIONS(46),
  },
  [1460] = {
    [sym__concat] = ACTIONS(2730),
    [anon_sym_PIPE] = ACTIONS(2730),
    [anon_sym_RPAREN] = ACTIONS(2730),
    [anon_sym_RBRACE] = ACTIONS(2730),
    [anon_sym_RBRACK] = ACTIONS(2730),
    [sym_comment] = ACTIONS(46),
  },
  [1461] = {
    [sym__concat] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2734),
    [anon_sym_RPAREN] = ACTIONS(2734),
    [anon_sym_RBRACE] = ACTIONS(2734),
    [anon_sym_RBRACK] = ACTIONS(2734),
    [sym_comment] = ACTIONS(46),
  },
  [1462] = {
    [sym__concat] = ACTIONS(2738),
    [anon_sym_PIPE] = ACTIONS(2738),
    [anon_sym_RPAREN] = ACTIONS(2738),
    [anon_sym_RBRACE] = ACTIONS(2738),
    [anon_sym_RBRACK] = ACTIONS(2738),
    [sym_comment] = ACTIONS(46),
  },
  [1463] = {
    [anon_sym_RBRACK] = ACTIONS(3311),
    [sym_comment] = ACTIONS(46),
  },
  [1464] = {
    [anon_sym_RBRACK] = ACTIONS(3313),
    [sym_comment] = ACTIONS(46),
  },
  [1465] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3315),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1466] = {
    [sym_word] = ACTIONS(2205),
    [sym__concat] = ACTIONS(2205),
    [anon_sym_SEMI_SEMI] = ACTIONS(2207),
    [anon_sym_DQUOTE] = ACTIONS(2207),
    [sym_raw_string] = ACTIONS(2207),
    [anon_sym_DOLLAR] = ACTIONS(2207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2207),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2207),
    [anon_sym_BQUOTE] = ACTIONS(2207),
    [anon_sym_LT_LPAREN] = ACTIONS(2207),
    [anon_sym_GT_LPAREN] = ACTIONS(2207),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2207),
    [anon_sym_SEMI] = ACTIONS(2207),
    [anon_sym_LF] = ACTIONS(2207),
    [anon_sym_AMP] = ACTIONS(2207),
  },
  [1467] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3317),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1468] = {
    [sym_word] = ACTIONS(2211),
    [sym__concat] = ACTIONS(2211),
    [anon_sym_SEMI_SEMI] = ACTIONS(2213),
    [anon_sym_DQUOTE] = ACTIONS(2213),
    [sym_raw_string] = ACTIONS(2213),
    [anon_sym_DOLLAR] = ACTIONS(2213),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2213),
    [anon_sym_BQUOTE] = ACTIONS(2213),
    [anon_sym_LT_LPAREN] = ACTIONS(2213),
    [anon_sym_GT_LPAREN] = ACTIONS(2213),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2213),
    [anon_sym_SEMI] = ACTIONS(2213),
    [anon_sym_LF] = ACTIONS(2213),
    [anon_sym_AMP] = ACTIONS(2213),
  },
  [1469] = {
    [anon_sym_RBRACE] = ACTIONS(3315),
    [sym_comment] = ACTIONS(46),
  },
  [1470] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3319),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1471] = {
    [sym_word] = ACTIONS(2217),
    [sym__concat] = ACTIONS(2217),
    [anon_sym_SEMI_SEMI] = ACTIONS(2219),
    [anon_sym_DQUOTE] = ACTIONS(2219),
    [sym_raw_string] = ACTIONS(2219),
    [anon_sym_DOLLAR] = ACTIONS(2219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2219),
    [anon_sym_BQUOTE] = ACTIONS(2219),
    [anon_sym_LT_LPAREN] = ACTIONS(2219),
    [anon_sym_GT_LPAREN] = ACTIONS(2219),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2219),
    [anon_sym_SEMI] = ACTIONS(2219),
    [anon_sym_LF] = ACTIONS(2219),
    [anon_sym_AMP] = ACTIONS(2219),
  },
  [1472] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3321),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1473] = {
    [sym_word] = ACTIONS(2223),
    [sym__concat] = ACTIONS(2223),
    [anon_sym_SEMI_SEMI] = ACTIONS(2225),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [sym_raw_string] = ACTIONS(2225),
    [anon_sym_DOLLAR] = ACTIONS(2225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2225),
    [anon_sym_BQUOTE] = ACTIONS(2225),
    [anon_sym_LT_LPAREN] = ACTIONS(2225),
    [anon_sym_GT_LPAREN] = ACTIONS(2225),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2225),
    [anon_sym_LF] = ACTIONS(2225),
    [anon_sym_AMP] = ACTIONS(2225),
  },
  [1474] = {
    [anon_sym_RBRACE] = ACTIONS(3319),
    [sym_comment] = ACTIONS(46),
  },
  [1475] = {
    [sym_file_descriptor] = ACTIONS(546),
    [sym_word] = ACTIONS(546),
    [sym_variable_name] = ACTIONS(546),
    [anon_sym_for] = ACTIONS(548),
    [anon_sym_while] = ACTIONS(548),
    [anon_sym_if] = ACTIONS(548),
    [anon_sym_case] = ACTIONS(548),
    [anon_sym_SEMI_SEMI] = ACTIONS(546),
    [anon_sym_function] = ACTIONS(548),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeset] = ACTIONS(548),
    [anon_sym_export] = ACTIONS(548),
    [anon_sym_readonly] = ACTIONS(548),
    [anon_sym_local] = ACTIONS(548),
    [anon_sym_LT] = ACTIONS(548),
    [anon_sym_GT] = ACTIONS(548),
    [anon_sym_GT_GT] = ACTIONS(546),
    [anon_sym_AMP_GT] = ACTIONS(548),
    [anon_sym_AMP_GT_GT] = ACTIONS(546),
    [anon_sym_LT_AMP] = ACTIONS(546),
    [anon_sym_GT_AMP] = ACTIONS(546),
    [anon_sym_DQUOTE] = ACTIONS(546),
    [sym_raw_string] = ACTIONS(546),
    [anon_sym_DOLLAR] = ACTIONS(548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(546),
    [anon_sym_LT_LPAREN] = ACTIONS(546),
    [anon_sym_GT_LPAREN] = ACTIONS(546),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(550),
  },
  [1476] = {
    [sym_word] = ACTIONS(3323),
    [anon_sym_esac] = ACTIONS(3325),
    [anon_sym_DQUOTE] = ACTIONS(3323),
    [sym_raw_string] = ACTIONS(3323),
    [anon_sym_DOLLAR] = ACTIONS(3325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3323),
    [anon_sym_BQUOTE] = ACTIONS(3323),
    [anon_sym_LT_LPAREN] = ACTIONS(3323),
    [anon_sym_GT_LPAREN] = ACTIONS(3323),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3327),
  },
  [1477] = {
    [sym__terminated_statement] = STATE(1270),
    [sym_for_statement] = STATE(1271),
    [sym_while_statement] = STATE(1271),
    [sym_if_statement] = STATE(1271),
    [sym_case_statement] = STATE(1271),
    [sym_function_definition] = STATE(1271),
    [sym_subshell] = STATE(1271),
    [sym_pipeline] = STATE(1271),
    [sym_list] = STATE(1271),
    [sym_command] = STATE(1271),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(1272),
    [sym_declaration_command] = STATE(1271),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(1477),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(590),
    [sym_word] = ACTIONS(593),
    [sym_variable_name] = ACTIONS(596),
    [anon_sym_for] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(604),
    [anon_sym_if] = ACTIONS(607),
    [anon_sym_case] = ACTIONS(610),
    [anon_sym_SEMI_SEMI] = ACTIONS(599),
    [anon_sym_function] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(619),
    [anon_sym_typeset] = ACTIONS(619),
    [anon_sym_export] = ACTIONS(619),
    [anon_sym_readonly] = ACTIONS(619),
    [anon_sym_local] = ACTIONS(619),
    [anon_sym_LT] = ACTIONS(622),
    [anon_sym_GT] = ACTIONS(622),
    [anon_sym_GT_GT] = ACTIONS(625),
    [anon_sym_AMP_GT] = ACTIONS(622),
    [anon_sym_AMP_GT_GT] = ACTIONS(625),
    [anon_sym_LT_AMP] = ACTIONS(625),
    [anon_sym_GT_AMP] = ACTIONS(625),
    [anon_sym_DQUOTE] = ACTIONS(628),
    [sym_raw_string] = ACTIONS(593),
    [anon_sym_DOLLAR] = ACTIONS(631),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(634),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(637),
    [anon_sym_BQUOTE] = ACTIONS(640),
    [anon_sym_LT_LPAREN] = ACTIONS(643),
    [anon_sym_GT_LPAREN] = ACTIONS(643),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(646),
  },
  [1478] = {
    [sym__terminated_statement] = STATE(1270),
    [sym_for_statement] = STATE(1271),
    [sym_while_statement] = STATE(1271),
    [sym_if_statement] = STATE(1271),
    [sym_case_statement] = STATE(1271),
    [sym_function_definition] = STATE(1271),
    [sym_subshell] = STATE(1271),
    [sym_pipeline] = STATE(1271),
    [sym_list] = STATE(1271),
    [sym_command] = STATE(1271),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(1272),
    [sym_declaration_command] = STATE(1271),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(1477),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_SEMI_SEMI] = ACTIONS(3329),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [1479] = {
    [sym_word] = ACTIONS(3331),
    [anon_sym_esac] = ACTIONS(3333),
    [anon_sym_DQUOTE] = ACTIONS(3331),
    [sym_raw_string] = ACTIONS(3331),
    [anon_sym_DOLLAR] = ACTIONS(3333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3331),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3331),
    [anon_sym_BQUOTE] = ACTIONS(3331),
    [anon_sym_LT_LPAREN] = ACTIONS(3331),
    [anon_sym_GT_LPAREN] = ACTIONS(3331),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3335),
  },
  [1480] = {
    [sym__terminated_statement] = STATE(1270),
    [sym_for_statement] = STATE(1271),
    [sym_while_statement] = STATE(1271),
    [sym_if_statement] = STATE(1271),
    [sym_case_statement] = STATE(1271),
    [sym_function_definition] = STATE(1271),
    [sym_subshell] = STATE(1271),
    [sym_pipeline] = STATE(1271),
    [sym_list] = STATE(1271),
    [sym_command] = STATE(1271),
    [sym_command_name] = STATE(23),
    [sym_variable_assignment] = STATE(1272),
    [sym_declaration_command] = STATE(1271),
    [sym_subscript] = STATE(25),
    [sym_file_redirect] = STATE(26),
    [sym_concatenation] = STATE(27),
    [sym_string] = STATE(3),
    [sym_simple_expansion] = STATE(3),
    [sym_expansion] = STATE(3),
    [sym_command_substitution] = STATE(3),
    [sym_process_substitution] = STATE(3),
    [aux_sym_program_repeat1] = STATE(1477),
    [aux_sym_command_repeat1] = STATE(29),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_word] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_SEMI_SEMI] = ACTIONS(3337),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_declare] = ACTIONS(28),
    [anon_sym_typeset] = ACTIONS(28),
    [anon_sym_export] = ACTIONS(28),
    [anon_sym_readonly] = ACTIONS(28),
    [anon_sym_local] = ACTIONS(28),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(32),
    [anon_sym_AMP_GT] = ACTIONS(30),
    [anon_sym_AMP_GT_GT] = ACTIONS(32),
    [anon_sym_LT_AMP] = ACTIONS(32),
    [anon_sym_GT_AMP] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(10),
    [anon_sym_DOLLAR] = ACTIONS(36),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(38),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(40),
    [anon_sym_BQUOTE] = ACTIONS(42),
    [anon_sym_LT_LPAREN] = ACTIONS(44),
    [anon_sym_GT_LPAREN] = ACTIONS(44),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(48),
  },
  [1481] = {
    [sym__concat] = ACTIONS(3116),
    [anon_sym_in] = ACTIONS(3118),
    [anon_sym_SEMI_SEMI] = ACTIONS(3118),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(3118),
    [anon_sym_LF] = ACTIONS(3118),
    [anon_sym_AMP] = ACTIONS(3118),
  },
  [1482] = {
    [sym__concat] = ACTIONS(3120),
    [anon_sym_in] = ACTIONS(3122),
    [anon_sym_SEMI_SEMI] = ACTIONS(3122),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(3122),
    [anon_sym_LF] = ACTIONS(3122),
    [anon_sym_AMP] = ACTIONS(3122),
  },
  [1483] = {
    [sym__concat] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1534),
    [anon_sym_RPAREN] = ACTIONS(1534),
    [anon_sym_SEMI_SEMI] = ACTIONS(1534),
    [anon_sym_PIPE_AMP] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1534),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1534),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_AMP] = ACTIONS(1534),
  },
  [1484] = {
    [anon_sym_AT] = ACTIONS(3339),
    [sym_comment] = ACTIONS(46),
  },
  [1485] = {
    [sym__concat] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(1540),
    [anon_sym_RPAREN] = ACTIONS(1540),
    [anon_sym_SEMI_SEMI] = ACTIONS(1540),
    [anon_sym_PIPE_AMP] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1540),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_LF] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1540),
  },
  [1486] = {
    [anon_sym_AT] = ACTIONS(3341),
    [sym_comment] = ACTIONS(46),
  },
  [1487] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(3343),
    [anon_sym_RBRACE] = ACTIONS(3345),
    [sym_comment] = ACTIONS(46),
  },
  [1488] = {
    [sym__concat] = ACTIONS(1548),
    [anon_sym_PIPE] = ACTIONS(1550),
    [anon_sym_RPAREN] = ACTIONS(1550),
    [anon_sym_SEMI_SEMI] = ACTIONS(1550),
    [anon_sym_PIPE_AMP] = ACTIONS(1550),
    [anon_sym_AMP_AMP] = ACTIONS(1550),
    [anon_sym_PIPE_PIPE] = ACTIONS(1550),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(1550),
    [anon_sym_LF] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(1550),
  },
  [1489] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(3347),
    [anon_sym_RBRACE] = ACTIONS(3349),
    [sym_comment] = ACTIONS(46),
  },
  [1490] = {
    [sym__concat] = ACTIONS(3351),
    [anon_sym_RBRACE] = ACTIONS(3345),
    [sym_comment] = ACTIONS(46),
  },
  [1491] = {
    [anon_sym_RBRACK] = ACTIONS(3351),
    [sym_comment] = ACTIONS(46),
  },
  [1492] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(3353),
    [anon_sym_RBRACE] = ACTIONS(3355),
    [sym_comment] = ACTIONS(46),
  },
  [1493] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(3357),
    [anon_sym_RBRACE] = ACTIONS(3359),
    [sym_comment] = ACTIONS(46),
  },
  [1494] = {
    [sym__concat] = ACTIONS(3361),
    [anon_sym_RBRACE] = ACTIONS(3355),
    [sym_comment] = ACTIONS(46),
  },
  [1495] = {
    [anon_sym_RBRACK] = ACTIONS(3361),
    [sym_comment] = ACTIONS(46),
  },
  [1496] = {
    [aux_sym_concatenation_repeat1] = STATE(1496),
    [sym__concat] = ACTIONS(3051),
    [anon_sym_PIPE] = ACTIONS(677),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_SEMI_SEMI] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(677),
  },
  [1497] = {
    [anon_sym_RBRACK] = ACTIONS(3363),
    [sym_comment] = ACTIONS(46),
  },
  [1498] = {
    [anon_sym_RBRACK] = ACTIONS(3365),
    [sym_comment] = ACTIONS(46),
  },
  [1499] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3367),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1500] = {
    [sym_word] = ACTIONS(2205),
    [sym__concat] = ACTIONS(2205),
    [sym_variable_name] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2207),
    [anon_sym_RPAREN] = ACTIONS(2207),
    [anon_sym_SEMI_SEMI] = ACTIONS(2207),
    [anon_sym_PIPE_AMP] = ACTIONS(2207),
    [anon_sym_AMP_AMP] = ACTIONS(2207),
    [anon_sym_PIPE_PIPE] = ACTIONS(2207),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2207),
    [anon_sym_SEMI] = ACTIONS(2207),
    [anon_sym_LF] = ACTIONS(2207),
    [anon_sym_AMP] = ACTIONS(2207),
  },
  [1501] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3369),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1502] = {
    [sym_word] = ACTIONS(2211),
    [sym__concat] = ACTIONS(2211),
    [sym_variable_name] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2213),
    [anon_sym_RPAREN] = ACTIONS(2213),
    [anon_sym_SEMI_SEMI] = ACTIONS(2213),
    [anon_sym_PIPE_AMP] = ACTIONS(2213),
    [anon_sym_AMP_AMP] = ACTIONS(2213),
    [anon_sym_PIPE_PIPE] = ACTIONS(2213),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2213),
    [anon_sym_SEMI] = ACTIONS(2213),
    [anon_sym_LF] = ACTIONS(2213),
    [anon_sym_AMP] = ACTIONS(2213),
  },
  [1503] = {
    [anon_sym_RBRACE] = ACTIONS(3367),
    [sym_comment] = ACTIONS(46),
  },
  [1504] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3371),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1505] = {
    [sym_word] = ACTIONS(2217),
    [sym__concat] = ACTIONS(2217),
    [sym_variable_name] = ACTIONS(2217),
    [anon_sym_PIPE] = ACTIONS(2219),
    [anon_sym_RPAREN] = ACTIONS(2219),
    [anon_sym_SEMI_SEMI] = ACTIONS(2219),
    [anon_sym_PIPE_AMP] = ACTIONS(2219),
    [anon_sym_AMP_AMP] = ACTIONS(2219),
    [anon_sym_PIPE_PIPE] = ACTIONS(2219),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2219),
    [anon_sym_SEMI] = ACTIONS(2219),
    [anon_sym_LF] = ACTIONS(2219),
    [anon_sym_AMP] = ACTIONS(2219),
  },
  [1506] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3373),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1507] = {
    [sym_word] = ACTIONS(2223),
    [sym__concat] = ACTIONS(2223),
    [sym_variable_name] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_RPAREN] = ACTIONS(2225),
    [anon_sym_SEMI_SEMI] = ACTIONS(2225),
    [anon_sym_PIPE_AMP] = ACTIONS(2225),
    [anon_sym_AMP_AMP] = ACTIONS(2225),
    [anon_sym_PIPE_PIPE] = ACTIONS(2225),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2225),
    [anon_sym_LF] = ACTIONS(2225),
    [anon_sym_AMP] = ACTIONS(2225),
  },
  [1508] = {
    [anon_sym_RBRACE] = ACTIONS(3371),
    [sym_comment] = ACTIONS(46),
  },
  [1509] = {
    [sym_file_descriptor] = ACTIONS(3116),
    [sym_word] = ACTIONS(3116),
    [sym__concat] = ACTIONS(3116),
    [sym_variable_name] = ACTIONS(3116),
    [anon_sym_LT] = ACTIONS(3375),
    [anon_sym_GT] = ACTIONS(3375),
    [anon_sym_GT_GT] = ACTIONS(3116),
    [anon_sym_AMP_GT] = ACTIONS(3375),
    [anon_sym_AMP_GT_GT] = ACTIONS(3116),
    [anon_sym_LT_AMP] = ACTIONS(3116),
    [anon_sym_GT_AMP] = ACTIONS(3116),
    [anon_sym_DQUOTE] = ACTIONS(3116),
    [sym_raw_string] = ACTIONS(3116),
    [anon_sym_DOLLAR] = ACTIONS(3375),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3116),
    [anon_sym_BQUOTE] = ACTIONS(3116),
    [anon_sym_LT_LPAREN] = ACTIONS(3116),
    [anon_sym_GT_LPAREN] = ACTIONS(3116),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3375),
  },
  [1510] = {
    [sym_file_descriptor] = ACTIONS(3120),
    [sym_word] = ACTIONS(3120),
    [sym__concat] = ACTIONS(3120),
    [sym_variable_name] = ACTIONS(3120),
    [anon_sym_LT] = ACTIONS(3377),
    [anon_sym_GT] = ACTIONS(3377),
    [anon_sym_GT_GT] = ACTIONS(3120),
    [anon_sym_AMP_GT] = ACTIONS(3377),
    [anon_sym_AMP_GT_GT] = ACTIONS(3120),
    [anon_sym_LT_AMP] = ACTIONS(3120),
    [anon_sym_GT_AMP] = ACTIONS(3120),
    [anon_sym_DQUOTE] = ACTIONS(3120),
    [sym_raw_string] = ACTIONS(3120),
    [anon_sym_DOLLAR] = ACTIONS(3377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3120),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3120),
    [anon_sym_BQUOTE] = ACTIONS(3120),
    [anon_sym_LT_LPAREN] = ACTIONS(3120),
    [anon_sym_GT_LPAREN] = ACTIONS(3120),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3377),
  },
  [1511] = {
    [anon_sym_DQUOTE] = ACTIONS(3118),
    [sym__string_content] = ACTIONS(3118),
    [anon_sym_DOLLAR] = ACTIONS(3118),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3118),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3118),
    [anon_sym_BQUOTE] = ACTIONS(3118),
    [sym_comment] = ACTIONS(60),
  },
  [1512] = {
    [anon_sym_DQUOTE] = ACTIONS(3122),
    [sym__string_content] = ACTIONS(3122),
    [anon_sym_DOLLAR] = ACTIONS(3122),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3122),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3122),
    [anon_sym_BQUOTE] = ACTIONS(3122),
    [sym_comment] = ACTIONS(60),
  },
  [1513] = {
    [anon_sym_RBRACK] = ACTIONS(3379),
    [sym_comment] = ACTIONS(46),
  },
  [1514] = {
    [anon_sym_RBRACK] = ACTIONS(3381),
    [sym_comment] = ACTIONS(46),
  },
  [1515] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3383),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1516] = {
    [sym_file_descriptor] = ACTIONS(2205),
    [sym_word] = ACTIONS(2205),
    [sym__concat] = ACTIONS(2205),
    [sym_variable_name] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2696),
    [anon_sym_RPAREN] = ACTIONS(2205),
    [anon_sym_PIPE_AMP] = ACTIONS(2205),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_PIPE_PIPE] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2696),
    [anon_sym_GT] = ACTIONS(2696),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [anon_sym_AMP_GT] = ACTIONS(2696),
    [anon_sym_AMP_GT_GT] = ACTIONS(2205),
    [anon_sym_LT_AMP] = ACTIONS(2205),
    [anon_sym_GT_AMP] = ACTIONS(2205),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [sym_raw_string] = ACTIONS(2205),
    [anon_sym_DOLLAR] = ACTIONS(2696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2205),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [anon_sym_LT_LPAREN] = ACTIONS(2205),
    [anon_sym_GT_LPAREN] = ACTIONS(2205),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2696),
  },
  [1517] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1518] = {
    [sym_file_descriptor] = ACTIONS(2211),
    [sym_word] = ACTIONS(2211),
    [sym__concat] = ACTIONS(2211),
    [sym_variable_name] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2700),
    [anon_sym_RPAREN] = ACTIONS(2211),
    [anon_sym_PIPE_AMP] = ACTIONS(2211),
    [anon_sym_AMP_AMP] = ACTIONS(2211),
    [anon_sym_PIPE_PIPE] = ACTIONS(2211),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_GT] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2211),
    [anon_sym_AMP_GT] = ACTIONS(2700),
    [anon_sym_AMP_GT_GT] = ACTIONS(2211),
    [anon_sym_LT_AMP] = ACTIONS(2211),
    [anon_sym_GT_AMP] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_raw_string] = ACTIONS(2211),
    [anon_sym_DOLLAR] = ACTIONS(2700),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2211),
    [anon_sym_BQUOTE] = ACTIONS(2211),
    [anon_sym_LT_LPAREN] = ACTIONS(2211),
    [anon_sym_GT_LPAREN] = ACTIONS(2211),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2700),
  },
  [1519] = {
    [anon_sym_RBRACE] = ACTIONS(3383),
    [sym_comment] = ACTIONS(46),
  },
  [1520] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1521] = {
    [sym_file_descriptor] = ACTIONS(2217),
    [sym_word] = ACTIONS(2217),
    [sym__concat] = ACTIONS(2217),
    [sym_variable_name] = ACTIONS(2217),
    [anon_sym_PIPE] = ACTIONS(2704),
    [anon_sym_RPAREN] = ACTIONS(2217),
    [anon_sym_PIPE_AMP] = ACTIONS(2217),
    [anon_sym_AMP_AMP] = ACTIONS(2217),
    [anon_sym_PIPE_PIPE] = ACTIONS(2217),
    [anon_sym_LT] = ACTIONS(2704),
    [anon_sym_GT] = ACTIONS(2704),
    [anon_sym_GT_GT] = ACTIONS(2217),
    [anon_sym_AMP_GT] = ACTIONS(2704),
    [anon_sym_AMP_GT_GT] = ACTIONS(2217),
    [anon_sym_LT_AMP] = ACTIONS(2217),
    [anon_sym_GT_AMP] = ACTIONS(2217),
    [anon_sym_DQUOTE] = ACTIONS(2217),
    [sym_raw_string] = ACTIONS(2217),
    [anon_sym_DOLLAR] = ACTIONS(2704),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2217),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2217),
    [anon_sym_BQUOTE] = ACTIONS(2217),
    [anon_sym_LT_LPAREN] = ACTIONS(2217),
    [anon_sym_GT_LPAREN] = ACTIONS(2217),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2704),
  },
  [1522] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1523] = {
    [sym_file_descriptor] = ACTIONS(2223),
    [sym_word] = ACTIONS(2223),
    [sym__concat] = ACTIONS(2223),
    [sym_variable_name] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2708),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_PIPE_AMP] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_LT] = ACTIONS(2708),
    [anon_sym_GT] = ACTIONS(2708),
    [anon_sym_GT_GT] = ACTIONS(2223),
    [anon_sym_AMP_GT] = ACTIONS(2708),
    [anon_sym_AMP_GT_GT] = ACTIONS(2223),
    [anon_sym_LT_AMP] = ACTIONS(2223),
    [anon_sym_GT_AMP] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2223),
    [sym_raw_string] = ACTIONS(2223),
    [anon_sym_DOLLAR] = ACTIONS(2708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2223),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2223),
    [anon_sym_BQUOTE] = ACTIONS(2223),
    [anon_sym_LT_LPAREN] = ACTIONS(2223),
    [anon_sym_GT_LPAREN] = ACTIONS(2223),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2708),
  },
  [1524] = {
    [anon_sym_RBRACE] = ACTIONS(3387),
    [sym_comment] = ACTIONS(46),
  },
  [1525] = {
    [anon_sym_PIPE] = ACTIONS(3391),
    [anon_sym_RPAREN] = ACTIONS(3393),
    [anon_sym_PIPE_AMP] = ACTIONS(3393),
    [anon_sym_AMP_AMP] = ACTIONS(3393),
    [anon_sym_PIPE_PIPE] = ACTIONS(3393),
    [anon_sym_BQUOTE] = ACTIONS(3393),
    [sym_comment] = ACTIONS(46),
  },
  [1526] = {
    [anon_sym_PIPE] = ACTIONS(3395),
    [anon_sym_RPAREN] = ACTIONS(3397),
    [anon_sym_PIPE_AMP] = ACTIONS(3397),
    [anon_sym_AMP_AMP] = ACTIONS(3397),
    [anon_sym_PIPE_PIPE] = ACTIONS(3397),
    [anon_sym_BQUOTE] = ACTIONS(3397),
    [sym_comment] = ACTIONS(46),
  },
  [1527] = {
    [anon_sym_PIPE] = ACTIONS(3399),
    [anon_sym_RPAREN] = ACTIONS(3401),
    [anon_sym_PIPE_AMP] = ACTIONS(3401),
    [anon_sym_AMP_AMP] = ACTIONS(3401),
    [anon_sym_PIPE_PIPE] = ACTIONS(3401),
    [anon_sym_BQUOTE] = ACTIONS(3401),
    [sym_comment] = ACTIONS(46),
  },
  [1528] = {
    [sym__concat] = ACTIONS(675),
    [anon_sym_PIPE] = ACTIONS(1471),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_PIPE_AMP] = ACTIONS(675),
    [anon_sym_AMP_AMP] = ACTIONS(675),
    [anon_sym_PIPE_PIPE] = ACTIONS(675),
    [anon_sym_BQUOTE] = ACTIONS(675),
    [sym_comment] = ACTIONS(46),
  },
  [1529] = {
    [sym__concat] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(1473),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(679),
    [sym_comment] = ACTIONS(46),
  },
  [1530] = {
    [aux_sym_concatenation_repeat1] = STATE(1530),
    [sym__concat] = ACTIONS(3403),
    [anon_sym_PIPE] = ACTIONS(1471),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_PIPE_AMP] = ACTIONS(675),
    [anon_sym_AMP_AMP] = ACTIONS(675),
    [anon_sym_PIPE_PIPE] = ACTIONS(675),
    [sym_comment] = ACTIONS(46),
  },
  [1531] = {
    [sym__concat] = ACTIONS(931),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_RPAREN] = ACTIONS(931),
    [anon_sym_PIPE_AMP] = ACTIONS(931),
    [anon_sym_AMP_AMP] = ACTIONS(931),
    [anon_sym_PIPE_PIPE] = ACTIONS(931),
    [anon_sym_BQUOTE] = ACTIONS(931),
    [sym_comment] = ACTIONS(46),
  },
  [1532] = {
    [anon_sym_RBRACE] = ACTIONS(3406),
    [anon_sym_LBRACK] = ACTIONS(3408),
    [sym_comment] = ACTIONS(46),
  },
  [1533] = {
    [anon_sym_RBRACE] = ACTIONS(3410),
    [anon_sym_LBRACK] = ACTIONS(3412),
    [sym_comment] = ACTIONS(46),
  },
  [1534] = {
    [sym__concat] = ACTIONS(960),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_RPAREN] = ACTIONS(960),
    [anon_sym_PIPE_AMP] = ACTIONS(960),
    [anon_sym_AMP_AMP] = ACTIONS(960),
    [anon_sym_PIPE_PIPE] = ACTIONS(960),
    [anon_sym_BQUOTE] = ACTIONS(960),
    [sym_comment] = ACTIONS(46),
  },
  [1535] = {
    [sym_concatenation] = STATE(1637),
    [sym_string] = STATE(1634),
    [sym_simple_expansion] = STATE(1634),
    [sym_expansion] = STATE(1634),
    [sym_command_substitution] = STATE(1634),
    [sym_process_substitution] = STATE(1634),
    [sym_word] = ACTIONS(3414),
    [anon_sym_RBRACE] = ACTIONS(3416),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(3414),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3418),
  },
  [1536] = {
    [anon_sym_AT] = ACTIONS(3420),
    [sym_comment] = ACTIONS(46),
  },
  [1537] = {
    [sym__concat] = ACTIONS(972),
    [anon_sym_PIPE] = ACTIONS(1498),
    [anon_sym_RPAREN] = ACTIONS(972),
    [anon_sym_PIPE_AMP] = ACTIONS(972),
    [anon_sym_AMP_AMP] = ACTIONS(972),
    [anon_sym_PIPE_PIPE] = ACTIONS(972),
    [anon_sym_BQUOTE] = ACTIONS(972),
    [sym_comment] = ACTIONS(46),
  },
  [1538] = {
    [sym_concatenation] = STATE(1641),
    [sym_string] = STATE(1639),
    [sym_simple_expansion] = STATE(1639),
    [sym_expansion] = STATE(1639),
    [sym_command_substitution] = STATE(1639),
    [sym_process_substitution] = STATE(1639),
    [sym_word] = ACTIONS(3422),
    [anon_sym_RBRACE] = ACTIONS(3410),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(3422),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3424),
  },
  [1539] = {
    [anon_sym_AT] = ACTIONS(3426),
    [sym_comment] = ACTIONS(46),
  },
  [1540] = {
    [sym__concat] = ACTIONS(1066),
    [anon_sym_PIPE] = ACTIONS(1506),
    [anon_sym_RPAREN] = ACTIONS(1066),
    [anon_sym_PIPE_AMP] = ACTIONS(1066),
    [anon_sym_AMP_AMP] = ACTIONS(1066),
    [anon_sym_PIPE_PIPE] = ACTIONS(1066),
    [anon_sym_BQUOTE] = ACTIONS(1066),
    [sym_comment] = ACTIONS(46),
  },
  [1541] = {
    [sym__concat] = ACTIONS(1122),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_RPAREN] = ACTIONS(1122),
    [anon_sym_PIPE_AMP] = ACTIONS(1122),
    [anon_sym_AMP_AMP] = ACTIONS(1122),
    [anon_sym_PIPE_PIPE] = ACTIONS(1122),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_comment] = ACTIONS(46),
  },
  [1542] = {
    [sym_word] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1532),
    [sym_variable_name] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(2145),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2145),
  },
  [1543] = {
    [anon_sym_AT] = ACTIONS(3428),
    [sym_comment] = ACTIONS(46),
  },
  [1544] = {
    [sym_word] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [sym_variable_name] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(2149),
    [anon_sym_RPAREN] = ACTIONS(1538),
    [anon_sym_PIPE_AMP] = ACTIONS(1538),
    [anon_sym_AMP_AMP] = ACTIONS(1538),
    [anon_sym_PIPE_PIPE] = ACTIONS(1538),
    [anon_sym_BQUOTE] = ACTIONS(1538),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2149),
  },
  [1545] = {
    [anon_sym_AT] = ACTIONS(3430),
    [sym_comment] = ACTIONS(46),
  },
  [1546] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(3432),
    [anon_sym_RBRACE] = ACTIONS(3434),
    [sym_comment] = ACTIONS(46),
  },
  [1547] = {
    [sym_word] = ACTIONS(1548),
    [sym__concat] = ACTIONS(1548),
    [sym_variable_name] = ACTIONS(1548),
    [anon_sym_PIPE] = ACTIONS(2157),
    [anon_sym_RPAREN] = ACTIONS(1548),
    [anon_sym_PIPE_AMP] = ACTIONS(1548),
    [anon_sym_AMP_AMP] = ACTIONS(1548),
    [anon_sym_PIPE_PIPE] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(1548),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2157),
  },
  [1548] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(3436),
    [anon_sym_RBRACE] = ACTIONS(3438),
    [sym_comment] = ACTIONS(46),
  },
  [1549] = {
    [sym__concat] = ACTIONS(3440),
    [anon_sym_RBRACE] = ACTIONS(3434),
    [sym_comment] = ACTIONS(46),
  },
  [1550] = {
    [anon_sym_RBRACK] = ACTIONS(3440),
    [sym_comment] = ACTIONS(46),
  },
  [1551] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(3442),
    [anon_sym_RBRACE] = ACTIONS(3444),
    [sym_comment] = ACTIONS(46),
  },
  [1552] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(3446),
    [anon_sym_RBRACE] = ACTIONS(3448),
    [sym_comment] = ACTIONS(46),
  },
  [1553] = {
    [sym__concat] = ACTIONS(3450),
    [anon_sym_RBRACE] = ACTIONS(3444),
    [sym_comment] = ACTIONS(46),
  },
  [1554] = {
    [anon_sym_RBRACK] = ACTIONS(3450),
    [sym_comment] = ACTIONS(46),
  },
  [1555] = {
    [sym_file_descriptor] = ACTIONS(3116),
    [sym_word] = ACTIONS(3116),
    [sym__concat] = ACTIONS(3116),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_RPAREN] = ACTIONS(3116),
    [anon_sym_PIPE_AMP] = ACTIONS(3116),
    [anon_sym_AMP_AMP] = ACTIONS(3116),
    [anon_sym_PIPE_PIPE] = ACTIONS(3116),
    [anon_sym_LT] = ACTIONS(3375),
    [anon_sym_GT] = ACTIONS(3375),
    [anon_sym_GT_GT] = ACTIONS(3116),
    [anon_sym_AMP_GT] = ACTIONS(3375),
    [anon_sym_AMP_GT_GT] = ACTIONS(3116),
    [anon_sym_LT_AMP] = ACTIONS(3116),
    [anon_sym_GT_AMP] = ACTIONS(3116),
    [anon_sym_LT_LT] = ACTIONS(3375),
    [anon_sym_LT_LT_DASH] = ACTIONS(3116),
    [anon_sym_DQUOTE] = ACTIONS(3116),
    [sym_raw_string] = ACTIONS(3116),
    [anon_sym_DOLLAR] = ACTIONS(3375),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3116),
    [anon_sym_BQUOTE] = ACTIONS(3116),
    [anon_sym_LT_LPAREN] = ACTIONS(3116),
    [anon_sym_GT_LPAREN] = ACTIONS(3116),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3375),
  },
  [1556] = {
    [sym_file_descriptor] = ACTIONS(3120),
    [sym_word] = ACTIONS(3120),
    [sym__concat] = ACTIONS(3120),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_RPAREN] = ACTIONS(3120),
    [anon_sym_PIPE_AMP] = ACTIONS(3120),
    [anon_sym_AMP_AMP] = ACTIONS(3120),
    [anon_sym_PIPE_PIPE] = ACTIONS(3120),
    [anon_sym_LT] = ACTIONS(3377),
    [anon_sym_GT] = ACTIONS(3377),
    [anon_sym_GT_GT] = ACTIONS(3120),
    [anon_sym_AMP_GT] = ACTIONS(3377),
    [anon_sym_AMP_GT_GT] = ACTIONS(3120),
    [anon_sym_LT_AMP] = ACTIONS(3120),
    [anon_sym_GT_AMP] = ACTIONS(3120),
    [anon_sym_LT_LT] = ACTIONS(3377),
    [anon_sym_LT_LT_DASH] = ACTIONS(3120),
    [anon_sym_DQUOTE] = ACTIONS(3120),
    [sym_raw_string] = ACTIONS(3120),
    [anon_sym_DOLLAR] = ACTIONS(3377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3120),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3120),
    [anon_sym_BQUOTE] = ACTIONS(3120),
    [anon_sym_LT_LPAREN] = ACTIONS(3120),
    [anon_sym_GT_LPAREN] = ACTIONS(3120),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3377),
  },
  [1557] = {
    [anon_sym_RBRACK] = ACTIONS(3452),
    [sym_comment] = ACTIONS(46),
  },
  [1558] = {
    [anon_sym_RBRACK] = ACTIONS(3454),
    [sym_comment] = ACTIONS(46),
  },
  [1559] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3456),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1560] = {
    [sym_file_descriptor] = ACTIONS(2205),
    [sym__concat] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2696),
    [anon_sym_RPAREN] = ACTIONS(2205),
    [anon_sym_PIPE_AMP] = ACTIONS(2205),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_PIPE_PIPE] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2696),
    [anon_sym_GT] = ACTIONS(2696),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [anon_sym_AMP_GT] = ACTIONS(2696),
    [anon_sym_AMP_GT_GT] = ACTIONS(2205),
    [anon_sym_LT_AMP] = ACTIONS(2205),
    [anon_sym_GT_AMP] = ACTIONS(2205),
    [anon_sym_LT_LT] = ACTIONS(2696),
    [anon_sym_LT_LT_DASH] = ACTIONS(2205),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [sym_comment] = ACTIONS(46),
  },
  [1561] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3458),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1562] = {
    [sym_file_descriptor] = ACTIONS(2211),
    [sym__concat] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2700),
    [anon_sym_RPAREN] = ACTIONS(2211),
    [anon_sym_PIPE_AMP] = ACTIONS(2211),
    [anon_sym_AMP_AMP] = ACTIONS(2211),
    [anon_sym_PIPE_PIPE] = ACTIONS(2211),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_GT] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2211),
    [anon_sym_AMP_GT] = ACTIONS(2700),
    [anon_sym_AMP_GT_GT] = ACTIONS(2211),
    [anon_sym_LT_AMP] = ACTIONS(2211),
    [anon_sym_GT_AMP] = ACTIONS(2211),
    [anon_sym_LT_LT] = ACTIONS(2700),
    [anon_sym_LT_LT_DASH] = ACTIONS(2211),
    [anon_sym_BQUOTE] = ACTIONS(2211),
    [sym_comment] = ACTIONS(46),
  },
  [1563] = {
    [anon_sym_RBRACE] = ACTIONS(3456),
    [sym_comment] = ACTIONS(46),
  },
  [1564] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3460),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1565] = {
    [sym_file_descriptor] = ACTIONS(2217),
    [sym__concat] = ACTIONS(2217),
    [anon_sym_PIPE] = ACTIONS(2704),
    [anon_sym_RPAREN] = ACTIONS(2217),
    [anon_sym_PIPE_AMP] = ACTIONS(2217),
    [anon_sym_AMP_AMP] = ACTIONS(2217),
    [anon_sym_PIPE_PIPE] = ACTIONS(2217),
    [anon_sym_LT] = ACTIONS(2704),
    [anon_sym_GT] = ACTIONS(2704),
    [anon_sym_GT_GT] = ACTIONS(2217),
    [anon_sym_AMP_GT] = ACTIONS(2704),
    [anon_sym_AMP_GT_GT] = ACTIONS(2217),
    [anon_sym_LT_AMP] = ACTIONS(2217),
    [anon_sym_GT_AMP] = ACTIONS(2217),
    [anon_sym_LT_LT] = ACTIONS(2704),
    [anon_sym_LT_LT_DASH] = ACTIONS(2217),
    [anon_sym_BQUOTE] = ACTIONS(2217),
    [sym_comment] = ACTIONS(46),
  },
  [1566] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3462),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1567] = {
    [sym_file_descriptor] = ACTIONS(2223),
    [sym__concat] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2708),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_PIPE_AMP] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_LT] = ACTIONS(2708),
    [anon_sym_GT] = ACTIONS(2708),
    [anon_sym_GT_GT] = ACTIONS(2223),
    [anon_sym_AMP_GT] = ACTIONS(2708),
    [anon_sym_AMP_GT_GT] = ACTIONS(2223),
    [anon_sym_LT_AMP] = ACTIONS(2223),
    [anon_sym_GT_AMP] = ACTIONS(2223),
    [anon_sym_LT_LT] = ACTIONS(2708),
    [anon_sym_LT_LT_DASH] = ACTIONS(2223),
    [anon_sym_BQUOTE] = ACTIONS(2223),
    [sym_comment] = ACTIONS(46),
  },
  [1568] = {
    [anon_sym_RBRACE] = ACTIONS(3460),
    [sym_comment] = ACTIONS(46),
  },
  [1569] = {
    [aux_sym_concatenation_repeat1] = STATE(1569),
    [sym__concat] = ACTIONS(3403),
    [anon_sym_PIPE] = ACTIONS(1471),
    [anon_sym_PIPE_AMP] = ACTIONS(675),
    [anon_sym_AMP_AMP] = ACTIONS(675),
    [anon_sym_PIPE_PIPE] = ACTIONS(675),
    [anon_sym_BQUOTE] = ACTIONS(675),
    [sym_comment] = ACTIONS(46),
  },
  [1570] = {
    [anon_sym_RBRACE] = ACTIONS(3464),
    [sym_comment] = ACTIONS(46),
  },
  [1571] = {
    [anon_sym_RBRACE] = ACTIONS(3466),
    [sym_comment] = ACTIONS(46),
  },
  [1572] = {
    [sym_file_descriptor] = ACTIONS(2726),
    [sym__concat] = ACTIONS(2726),
    [anon_sym_PIPE] = ACTIONS(2728),
    [anon_sym_RPAREN] = ACTIONS(2728),
    [anon_sym_SEMI_SEMI] = ACTIONS(2728),
    [anon_sym_PIPE_AMP] = ACTIONS(2728),
    [anon_sym_AMP_AMP] = ACTIONS(2728),
    [anon_sym_PIPE_PIPE] = ACTIONS(2728),
    [anon_sym_LT] = ACTIONS(2728),
    [anon_sym_GT] = ACTIONS(2728),
    [anon_sym_GT_GT] = ACTIONS(2728),
    [anon_sym_AMP_GT] = ACTIONS(2728),
    [anon_sym_AMP_GT_GT] = ACTIONS(2728),
    [anon_sym_LT_AMP] = ACTIONS(2728),
    [anon_sym_GT_AMP] = ACTIONS(2728),
    [anon_sym_LT_LT] = ACTIONS(2728),
    [anon_sym_LT_LT_DASH] = ACTIONS(2728),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2728),
    [anon_sym_LF] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(2728),
  },
  [1573] = {
    [sym_file_descriptor] = ACTIONS(2730),
    [sym__concat] = ACTIONS(2730),
    [anon_sym_PIPE] = ACTIONS(2732),
    [anon_sym_RPAREN] = ACTIONS(2732),
    [anon_sym_SEMI_SEMI] = ACTIONS(2732),
    [anon_sym_PIPE_AMP] = ACTIONS(2732),
    [anon_sym_AMP_AMP] = ACTIONS(2732),
    [anon_sym_PIPE_PIPE] = ACTIONS(2732),
    [anon_sym_LT] = ACTIONS(2732),
    [anon_sym_GT] = ACTIONS(2732),
    [anon_sym_GT_GT] = ACTIONS(2732),
    [anon_sym_AMP_GT] = ACTIONS(2732),
    [anon_sym_AMP_GT_GT] = ACTIONS(2732),
    [anon_sym_LT_AMP] = ACTIONS(2732),
    [anon_sym_GT_AMP] = ACTIONS(2732),
    [anon_sym_LT_LT] = ACTIONS(2732),
    [anon_sym_LT_LT_DASH] = ACTIONS(2732),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2732),
    [anon_sym_LF] = ACTIONS(2732),
    [anon_sym_AMP] = ACTIONS(2732),
  },
  [1574] = {
    [sym_file_descriptor] = ACTIONS(2734),
    [sym__concat] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2736),
    [anon_sym_RPAREN] = ACTIONS(2736),
    [anon_sym_SEMI_SEMI] = ACTIONS(2736),
    [anon_sym_PIPE_AMP] = ACTIONS(2736),
    [anon_sym_AMP_AMP] = ACTIONS(2736),
    [anon_sym_PIPE_PIPE] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2736),
    [anon_sym_GT] = ACTIONS(2736),
    [anon_sym_GT_GT] = ACTIONS(2736),
    [anon_sym_AMP_GT] = ACTIONS(2736),
    [anon_sym_AMP_GT_GT] = ACTIONS(2736),
    [anon_sym_LT_AMP] = ACTIONS(2736),
    [anon_sym_GT_AMP] = ACTIONS(2736),
    [anon_sym_LT_LT] = ACTIONS(2736),
    [anon_sym_LT_LT_DASH] = ACTIONS(2736),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2736),
    [anon_sym_LF] = ACTIONS(2736),
    [anon_sym_AMP] = ACTIONS(2736),
  },
  [1575] = {
    [sym_file_descriptor] = ACTIONS(2738),
    [sym__concat] = ACTIONS(2738),
    [anon_sym_PIPE] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [anon_sym_SEMI_SEMI] = ACTIONS(2740),
    [anon_sym_PIPE_AMP] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_PIPE_PIPE] = ACTIONS(2740),
    [anon_sym_LT] = ACTIONS(2740),
    [anon_sym_GT] = ACTIONS(2740),
    [anon_sym_GT_GT] = ACTIONS(2740),
    [anon_sym_AMP_GT] = ACTIONS(2740),
    [anon_sym_AMP_GT_GT] = ACTIONS(2740),
    [anon_sym_LT_AMP] = ACTIONS(2740),
    [anon_sym_GT_AMP] = ACTIONS(2740),
    [anon_sym_LT_LT] = ACTIONS(2740),
    [anon_sym_LT_LT_DASH] = ACTIONS(2740),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym_LF] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2740),
  },
  [1576] = {
    [anon_sym_RBRACK] = ACTIONS(3468),
    [sym_comment] = ACTIONS(46),
  },
  [1577] = {
    [anon_sym_RBRACK] = ACTIONS(3470),
    [sym_comment] = ACTIONS(46),
  },
  [1578] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1579] = {
    [sym__heredoc_middle] = ACTIONS(2205),
    [sym__heredoc_end] = ACTIONS(2205),
    [anon_sym_DOLLAR] = ACTIONS(2696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2205),
    [sym_comment] = ACTIONS(46),
  },
  [1580] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1581] = {
    [sym__heredoc_middle] = ACTIONS(2211),
    [sym__heredoc_end] = ACTIONS(2211),
    [anon_sym_DOLLAR] = ACTIONS(2700),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2211),
    [sym_comment] = ACTIONS(46),
  },
  [1582] = {
    [anon_sym_RBRACE] = ACTIONS(3472),
    [sym_comment] = ACTIONS(46),
  },
  [1583] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1584] = {
    [sym__heredoc_middle] = ACTIONS(2217),
    [sym__heredoc_end] = ACTIONS(2217),
    [anon_sym_DOLLAR] = ACTIONS(2704),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2217),
    [sym_comment] = ACTIONS(46),
  },
  [1585] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3478),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1586] = {
    [sym__heredoc_middle] = ACTIONS(2223),
    [sym__heredoc_end] = ACTIONS(2223),
    [anon_sym_DOLLAR] = ACTIONS(2708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2223),
    [sym_comment] = ACTIONS(46),
  },
  [1587] = {
    [anon_sym_RBRACE] = ACTIONS(3476),
    [sym_comment] = ACTIONS(46),
  },
  [1588] = {
    [anon_sym_RBRACE] = ACTIONS(3480),
    [sym_comment] = ACTIONS(46),
  },
  [1589] = {
    [anon_sym_RBRACE] = ACTIONS(3482),
    [sym_comment] = ACTIONS(46),
  },
  [1590] = {
    [sym_word] = ACTIONS(2726),
    [sym__concat] = ACTIONS(2726),
    [anon_sym_RPAREN] = ACTIONS(2726),
    [anon_sym_DQUOTE] = ACTIONS(2726),
    [sym_raw_string] = ACTIONS(2726),
    [anon_sym_DOLLAR] = ACTIONS(3104),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2726),
    [anon_sym_BQUOTE] = ACTIONS(2726),
    [anon_sym_LT_LPAREN] = ACTIONS(2726),
    [anon_sym_GT_LPAREN] = ACTIONS(2726),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3104),
  },
  [1591] = {
    [sym_word] = ACTIONS(2730),
    [sym__concat] = ACTIONS(2730),
    [anon_sym_RPAREN] = ACTIONS(2730),
    [anon_sym_DQUOTE] = ACTIONS(2730),
    [sym_raw_string] = ACTIONS(2730),
    [anon_sym_DOLLAR] = ACTIONS(3106),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2730),
    [anon_sym_BQUOTE] = ACTIONS(2730),
    [anon_sym_LT_LPAREN] = ACTIONS(2730),
    [anon_sym_GT_LPAREN] = ACTIONS(2730),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3106),
  },
  [1592] = {
    [sym_word] = ACTIONS(2734),
    [sym__concat] = ACTIONS(2734),
    [anon_sym_RPAREN] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(2734),
    [sym_raw_string] = ACTIONS(2734),
    [anon_sym_DOLLAR] = ACTIONS(3108),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2734),
    [anon_sym_BQUOTE] = ACTIONS(2734),
    [anon_sym_LT_LPAREN] = ACTIONS(2734),
    [anon_sym_GT_LPAREN] = ACTIONS(2734),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3108),
  },
  [1593] = {
    [sym_word] = ACTIONS(2738),
    [sym__concat] = ACTIONS(2738),
    [anon_sym_RPAREN] = ACTIONS(2738),
    [anon_sym_DQUOTE] = ACTIONS(2738),
    [sym_raw_string] = ACTIONS(2738),
    [anon_sym_DOLLAR] = ACTIONS(3110),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2738),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2738),
    [anon_sym_BQUOTE] = ACTIONS(2738),
    [anon_sym_LT_LPAREN] = ACTIONS(2738),
    [anon_sym_GT_LPAREN] = ACTIONS(2738),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3110),
  },
  [1594] = {
    [sym_file_descriptor] = ACTIONS(3116),
    [sym_word] = ACTIONS(3116),
    [sym__concat] = ACTIONS(3116),
    [sym_variable_name] = ACTIONS(3116),
    [anon_sym_PIPE] = ACTIONS(3118),
    [anon_sym_RPAREN] = ACTIONS(3118),
    [anon_sym_SEMI_SEMI] = ACTIONS(3118),
    [anon_sym_PIPE_AMP] = ACTIONS(3118),
    [anon_sym_AMP_AMP] = ACTIONS(3118),
    [anon_sym_PIPE_PIPE] = ACTIONS(3118),
    [anon_sym_LT] = ACTIONS(3118),
    [anon_sym_GT] = ACTIONS(3118),
    [anon_sym_GT_GT] = ACTIONS(3118),
    [anon_sym_AMP_GT] = ACTIONS(3118),
    [anon_sym_AMP_GT_GT] = ACTIONS(3118),
    [anon_sym_LT_AMP] = ACTIONS(3118),
    [anon_sym_GT_AMP] = ACTIONS(3118),
    [anon_sym_DQUOTE] = ACTIONS(3118),
    [sym_raw_string] = ACTIONS(3118),
    [anon_sym_DOLLAR] = ACTIONS(3118),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3118),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3118),
    [anon_sym_BQUOTE] = ACTIONS(3118),
    [anon_sym_LT_LPAREN] = ACTIONS(3118),
    [anon_sym_GT_LPAREN] = ACTIONS(3118),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(3118),
    [anon_sym_SEMI] = ACTIONS(3118),
    [anon_sym_LF] = ACTIONS(3118),
    [anon_sym_AMP] = ACTIONS(3118),
  },
  [1595] = {
    [sym_file_descriptor] = ACTIONS(3120),
    [sym_word] = ACTIONS(3120),
    [sym__concat] = ACTIONS(3120),
    [sym_variable_name] = ACTIONS(3120),
    [anon_sym_PIPE] = ACTIONS(3122),
    [anon_sym_RPAREN] = ACTIONS(3122),
    [anon_sym_SEMI_SEMI] = ACTIONS(3122),
    [anon_sym_PIPE_AMP] = ACTIONS(3122),
    [anon_sym_AMP_AMP] = ACTIONS(3122),
    [anon_sym_PIPE_PIPE] = ACTIONS(3122),
    [anon_sym_LT] = ACTIONS(3122),
    [anon_sym_GT] = ACTIONS(3122),
    [anon_sym_GT_GT] = ACTIONS(3122),
    [anon_sym_AMP_GT] = ACTIONS(3122),
    [anon_sym_AMP_GT_GT] = ACTIONS(3122),
    [anon_sym_LT_AMP] = ACTIONS(3122),
    [anon_sym_GT_AMP] = ACTIONS(3122),
    [anon_sym_DQUOTE] = ACTIONS(3122),
    [sym_raw_string] = ACTIONS(3122),
    [anon_sym_DOLLAR] = ACTIONS(3122),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3122),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3122),
    [anon_sym_BQUOTE] = ACTIONS(3122),
    [anon_sym_LT_LPAREN] = ACTIONS(3122),
    [anon_sym_GT_LPAREN] = ACTIONS(3122),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(3122),
    [anon_sym_SEMI] = ACTIONS(3122),
    [anon_sym_LF] = ACTIONS(3122),
    [anon_sym_AMP] = ACTIONS(3122),
  },
  [1596] = {
    [sym__concat] = ACTIONS(3116),
    [anon_sym_PIPE] = ACTIONS(3116),
    [anon_sym_RPAREN] = ACTIONS(3116),
    [anon_sym_RBRACE] = ACTIONS(3116),
    [anon_sym_RBRACK] = ACTIONS(3116),
    [sym_comment] = ACTIONS(46),
  },
  [1597] = {
    [sym__concat] = ACTIONS(3120),
    [anon_sym_PIPE] = ACTIONS(3120),
    [anon_sym_RPAREN] = ACTIONS(3120),
    [anon_sym_RBRACE] = ACTIONS(3120),
    [anon_sym_RBRACK] = ACTIONS(3120),
    [sym_comment] = ACTIONS(46),
  },
  [1598] = {
    [anon_sym_RBRACE] = ACTIONS(3484),
    [sym_comment] = ACTIONS(46),
  },
  [1599] = {
    [anon_sym_RBRACE] = ACTIONS(3486),
    [sym_comment] = ACTIONS(46),
  },
  [1600] = {
    [sym_word] = ACTIONS(2726),
    [sym__concat] = ACTIONS(2726),
    [anon_sym_SEMI_SEMI] = ACTIONS(2728),
    [anon_sym_DQUOTE] = ACTIONS(2728),
    [sym_raw_string] = ACTIONS(2728),
    [anon_sym_DOLLAR] = ACTIONS(2728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2728),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2728),
    [anon_sym_BQUOTE] = ACTIONS(2728),
    [anon_sym_LT_LPAREN] = ACTIONS(2728),
    [anon_sym_GT_LPAREN] = ACTIONS(2728),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2728),
    [anon_sym_SEMI] = ACTIONS(2728),
    [anon_sym_LF] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(2728),
  },
  [1601] = {
    [sym_word] = ACTIONS(2730),
    [sym__concat] = ACTIONS(2730),
    [anon_sym_SEMI_SEMI] = ACTIONS(2732),
    [anon_sym_DQUOTE] = ACTIONS(2732),
    [sym_raw_string] = ACTIONS(2732),
    [anon_sym_DOLLAR] = ACTIONS(2732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2732),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2732),
    [anon_sym_BQUOTE] = ACTIONS(2732),
    [anon_sym_LT_LPAREN] = ACTIONS(2732),
    [anon_sym_GT_LPAREN] = ACTIONS(2732),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2732),
    [anon_sym_SEMI] = ACTIONS(2732),
    [anon_sym_LF] = ACTIONS(2732),
    [anon_sym_AMP] = ACTIONS(2732),
  },
  [1602] = {
    [sym_word] = ACTIONS(2734),
    [sym__concat] = ACTIONS(2734),
    [anon_sym_SEMI_SEMI] = ACTIONS(2736),
    [anon_sym_DQUOTE] = ACTIONS(2736),
    [sym_raw_string] = ACTIONS(2736),
    [anon_sym_DOLLAR] = ACTIONS(2736),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2736),
    [anon_sym_BQUOTE] = ACTIONS(2736),
    [anon_sym_LT_LPAREN] = ACTIONS(2736),
    [anon_sym_GT_LPAREN] = ACTIONS(2736),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2736),
    [anon_sym_SEMI] = ACTIONS(2736),
    [anon_sym_LF] = ACTIONS(2736),
    [anon_sym_AMP] = ACTIONS(2736),
  },
  [1603] = {
    [sym_word] = ACTIONS(2738),
    [sym__concat] = ACTIONS(2738),
    [anon_sym_SEMI_SEMI] = ACTIONS(2740),
    [anon_sym_DQUOTE] = ACTIONS(2740),
    [sym_raw_string] = ACTIONS(2740),
    [anon_sym_DOLLAR] = ACTIONS(2740),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2740),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2740),
    [anon_sym_BQUOTE] = ACTIONS(2740),
    [anon_sym_LT_LPAREN] = ACTIONS(2740),
    [anon_sym_GT_LPAREN] = ACTIONS(2740),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2740),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym_LF] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2740),
  },
  [1604] = {
    [sym_word] = ACTIONS(3488),
    [anon_sym_esac] = ACTIONS(3490),
    [anon_sym_DQUOTE] = ACTIONS(3488),
    [sym_raw_string] = ACTIONS(3488),
    [anon_sym_DOLLAR] = ACTIONS(3490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3488),
    [anon_sym_BQUOTE] = ACTIONS(3488),
    [anon_sym_LT_LPAREN] = ACTIONS(3488),
    [anon_sym_GT_LPAREN] = ACTIONS(3488),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3492),
  },
  [1605] = {
    [sym_word] = ACTIONS(3494),
    [anon_sym_esac] = ACTIONS(3496),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [sym_raw_string] = ACTIONS(3494),
    [anon_sym_DOLLAR] = ACTIONS(3496),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3494),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3494),
    [anon_sym_BQUOTE] = ACTIONS(3494),
    [anon_sym_LT_LPAREN] = ACTIONS(3494),
    [anon_sym_GT_LPAREN] = ACTIONS(3494),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3498),
  },
  [1606] = {
    [anon_sym_RBRACK] = ACTIONS(3500),
    [sym_comment] = ACTIONS(46),
  },
  [1607] = {
    [anon_sym_RBRACK] = ACTIONS(3502),
    [sym_comment] = ACTIONS(46),
  },
  [1608] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3504),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1609] = {
    [sym__concat] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2207),
    [anon_sym_RPAREN] = ACTIONS(2207),
    [anon_sym_SEMI_SEMI] = ACTIONS(2207),
    [anon_sym_PIPE_AMP] = ACTIONS(2207),
    [anon_sym_AMP_AMP] = ACTIONS(2207),
    [anon_sym_PIPE_PIPE] = ACTIONS(2207),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2207),
    [anon_sym_LF] = ACTIONS(2207),
    [anon_sym_AMP] = ACTIONS(2207),
  },
  [1610] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3506),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1611] = {
    [sym__concat] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2213),
    [anon_sym_RPAREN] = ACTIONS(2213),
    [anon_sym_SEMI_SEMI] = ACTIONS(2213),
    [anon_sym_PIPE_AMP] = ACTIONS(2213),
    [anon_sym_AMP_AMP] = ACTIONS(2213),
    [anon_sym_PIPE_PIPE] = ACTIONS(2213),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2213),
    [anon_sym_LF] = ACTIONS(2213),
    [anon_sym_AMP] = ACTIONS(2213),
  },
  [1612] = {
    [anon_sym_RBRACE] = ACTIONS(3504),
    [sym_comment] = ACTIONS(46),
  },
  [1613] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3508),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1614] = {
    [sym__concat] = ACTIONS(2217),
    [anon_sym_PIPE] = ACTIONS(2219),
    [anon_sym_RPAREN] = ACTIONS(2219),
    [anon_sym_SEMI_SEMI] = ACTIONS(2219),
    [anon_sym_PIPE_AMP] = ACTIONS(2219),
    [anon_sym_AMP_AMP] = ACTIONS(2219),
    [anon_sym_PIPE_PIPE] = ACTIONS(2219),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2219),
    [anon_sym_LF] = ACTIONS(2219),
    [anon_sym_AMP] = ACTIONS(2219),
  },
  [1615] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1616] = {
    [sym__concat] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_RPAREN] = ACTIONS(2225),
    [anon_sym_SEMI_SEMI] = ACTIONS(2225),
    [anon_sym_PIPE_AMP] = ACTIONS(2225),
    [anon_sym_AMP_AMP] = ACTIONS(2225),
    [anon_sym_PIPE_PIPE] = ACTIONS(2225),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2225),
    [anon_sym_LF] = ACTIONS(2225),
    [anon_sym_AMP] = ACTIONS(2225),
  },
  [1617] = {
    [anon_sym_RBRACE] = ACTIONS(3508),
    [sym_comment] = ACTIONS(46),
  },
  [1618] = {
    [anon_sym_RBRACE] = ACTIONS(3512),
    [sym_comment] = ACTIONS(46),
  },
  [1619] = {
    [anon_sym_RBRACE] = ACTIONS(3514),
    [sym_comment] = ACTIONS(46),
  },
  [1620] = {
    [sym_word] = ACTIONS(2726),
    [sym__concat] = ACTIONS(2726),
    [sym_variable_name] = ACTIONS(2726),
    [anon_sym_PIPE] = ACTIONS(2728),
    [anon_sym_RPAREN] = ACTIONS(2728),
    [anon_sym_SEMI_SEMI] = ACTIONS(2728),
    [anon_sym_PIPE_AMP] = ACTIONS(2728),
    [anon_sym_AMP_AMP] = ACTIONS(2728),
    [anon_sym_PIPE_PIPE] = ACTIONS(2728),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2728),
    [anon_sym_SEMI] = ACTIONS(2728),
    [anon_sym_LF] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(2728),
  },
  [1621] = {
    [sym_word] = ACTIONS(2730),
    [sym__concat] = ACTIONS(2730),
    [sym_variable_name] = ACTIONS(2730),
    [anon_sym_PIPE] = ACTIONS(2732),
    [anon_sym_RPAREN] = ACTIONS(2732),
    [anon_sym_SEMI_SEMI] = ACTIONS(2732),
    [anon_sym_PIPE_AMP] = ACTIONS(2732),
    [anon_sym_AMP_AMP] = ACTIONS(2732),
    [anon_sym_PIPE_PIPE] = ACTIONS(2732),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2732),
    [anon_sym_SEMI] = ACTIONS(2732),
    [anon_sym_LF] = ACTIONS(2732),
    [anon_sym_AMP] = ACTIONS(2732),
  },
  [1622] = {
    [sym_word] = ACTIONS(2734),
    [sym__concat] = ACTIONS(2734),
    [sym_variable_name] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2736),
    [anon_sym_RPAREN] = ACTIONS(2736),
    [anon_sym_SEMI_SEMI] = ACTIONS(2736),
    [anon_sym_PIPE_AMP] = ACTIONS(2736),
    [anon_sym_AMP_AMP] = ACTIONS(2736),
    [anon_sym_PIPE_PIPE] = ACTIONS(2736),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2736),
    [anon_sym_SEMI] = ACTIONS(2736),
    [anon_sym_LF] = ACTIONS(2736),
    [anon_sym_AMP] = ACTIONS(2736),
  },
  [1623] = {
    [sym_word] = ACTIONS(2738),
    [sym__concat] = ACTIONS(2738),
    [sym_variable_name] = ACTIONS(2738),
    [anon_sym_PIPE] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [anon_sym_SEMI_SEMI] = ACTIONS(2740),
    [anon_sym_PIPE_AMP] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_PIPE_PIPE] = ACTIONS(2740),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(2740),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym_LF] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2740),
  },
  [1624] = {
    [anon_sym_RBRACE] = ACTIONS(3516),
    [sym_comment] = ACTIONS(46),
  },
  [1625] = {
    [anon_sym_RBRACE] = ACTIONS(3518),
    [sym_comment] = ACTIONS(46),
  },
  [1626] = {
    [sym_file_descriptor] = ACTIONS(2726),
    [sym_word] = ACTIONS(2726),
    [sym__concat] = ACTIONS(2726),
    [sym_variable_name] = ACTIONS(2726),
    [anon_sym_PIPE] = ACTIONS(3104),
    [anon_sym_RPAREN] = ACTIONS(2726),
    [anon_sym_PIPE_AMP] = ACTIONS(2726),
    [anon_sym_AMP_AMP] = ACTIONS(2726),
    [anon_sym_PIPE_PIPE] = ACTIONS(2726),
    [anon_sym_LT] = ACTIONS(3104),
    [anon_sym_GT] = ACTIONS(3104),
    [anon_sym_GT_GT] = ACTIONS(2726),
    [anon_sym_AMP_GT] = ACTIONS(3104),
    [anon_sym_AMP_GT_GT] = ACTIONS(2726),
    [anon_sym_LT_AMP] = ACTIONS(2726),
    [anon_sym_GT_AMP] = ACTIONS(2726),
    [anon_sym_DQUOTE] = ACTIONS(2726),
    [sym_raw_string] = ACTIONS(2726),
    [anon_sym_DOLLAR] = ACTIONS(3104),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2726),
    [anon_sym_BQUOTE] = ACTIONS(2726),
    [anon_sym_LT_LPAREN] = ACTIONS(2726),
    [anon_sym_GT_LPAREN] = ACTIONS(2726),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3104),
  },
  [1627] = {
    [sym_file_descriptor] = ACTIONS(2730),
    [sym_word] = ACTIONS(2730),
    [sym__concat] = ACTIONS(2730),
    [sym_variable_name] = ACTIONS(2730),
    [anon_sym_PIPE] = ACTIONS(3106),
    [anon_sym_RPAREN] = ACTIONS(2730),
    [anon_sym_PIPE_AMP] = ACTIONS(2730),
    [anon_sym_AMP_AMP] = ACTIONS(2730),
    [anon_sym_PIPE_PIPE] = ACTIONS(2730),
    [anon_sym_LT] = ACTIONS(3106),
    [anon_sym_GT] = ACTIONS(3106),
    [anon_sym_GT_GT] = ACTIONS(2730),
    [anon_sym_AMP_GT] = ACTIONS(3106),
    [anon_sym_AMP_GT_GT] = ACTIONS(2730),
    [anon_sym_LT_AMP] = ACTIONS(2730),
    [anon_sym_GT_AMP] = ACTIONS(2730),
    [anon_sym_DQUOTE] = ACTIONS(2730),
    [sym_raw_string] = ACTIONS(2730),
    [anon_sym_DOLLAR] = ACTIONS(3106),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2730),
    [anon_sym_BQUOTE] = ACTIONS(2730),
    [anon_sym_LT_LPAREN] = ACTIONS(2730),
    [anon_sym_GT_LPAREN] = ACTIONS(2730),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3106),
  },
  [1628] = {
    [sym_file_descriptor] = ACTIONS(2734),
    [sym_word] = ACTIONS(2734),
    [sym__concat] = ACTIONS(2734),
    [sym_variable_name] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(3108),
    [anon_sym_RPAREN] = ACTIONS(2734),
    [anon_sym_PIPE_AMP] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2734),
    [anon_sym_PIPE_PIPE] = ACTIONS(2734),
    [anon_sym_LT] = ACTIONS(3108),
    [anon_sym_GT] = ACTIONS(3108),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_AMP_GT] = ACTIONS(3108),
    [anon_sym_AMP_GT_GT] = ACTIONS(2734),
    [anon_sym_LT_AMP] = ACTIONS(2734),
    [anon_sym_GT_AMP] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(2734),
    [sym_raw_string] = ACTIONS(2734),
    [anon_sym_DOLLAR] = ACTIONS(3108),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2734),
    [anon_sym_BQUOTE] = ACTIONS(2734),
    [anon_sym_LT_LPAREN] = ACTIONS(2734),
    [anon_sym_GT_LPAREN] = ACTIONS(2734),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3108),
  },
  [1629] = {
    [sym_file_descriptor] = ACTIONS(2738),
    [sym_word] = ACTIONS(2738),
    [sym__concat] = ACTIONS(2738),
    [sym_variable_name] = ACTIONS(2738),
    [anon_sym_PIPE] = ACTIONS(3110),
    [anon_sym_RPAREN] = ACTIONS(2738),
    [anon_sym_PIPE_AMP] = ACTIONS(2738),
    [anon_sym_AMP_AMP] = ACTIONS(2738),
    [anon_sym_PIPE_PIPE] = ACTIONS(2738),
    [anon_sym_LT] = ACTIONS(3110),
    [anon_sym_GT] = ACTIONS(3110),
    [anon_sym_GT_GT] = ACTIONS(2738),
    [anon_sym_AMP_GT] = ACTIONS(3110),
    [anon_sym_AMP_GT_GT] = ACTIONS(2738),
    [anon_sym_LT_AMP] = ACTIONS(2738),
    [anon_sym_GT_AMP] = ACTIONS(2738),
    [anon_sym_DQUOTE] = ACTIONS(2738),
    [sym_raw_string] = ACTIONS(2738),
    [anon_sym_DOLLAR] = ACTIONS(3110),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2738),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2738),
    [anon_sym_BQUOTE] = ACTIONS(2738),
    [anon_sym_LT_LPAREN] = ACTIONS(2738),
    [anon_sym_GT_LPAREN] = ACTIONS(2738),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3110),
  },
  [1630] = {
    [sym__concat] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(2145),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [sym_comment] = ACTIONS(46),
  },
  [1631] = {
    [anon_sym_AT] = ACTIONS(3520),
    [sym_comment] = ACTIONS(46),
  },
  [1632] = {
    [sym__concat] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(2149),
    [anon_sym_RPAREN] = ACTIONS(1538),
    [anon_sym_PIPE_AMP] = ACTIONS(1538),
    [anon_sym_AMP_AMP] = ACTIONS(1538),
    [anon_sym_PIPE_PIPE] = ACTIONS(1538),
    [anon_sym_BQUOTE] = ACTIONS(1538),
    [sym_comment] = ACTIONS(46),
  },
  [1633] = {
    [anon_sym_AT] = ACTIONS(3522),
    [sym_comment] = ACTIONS(46),
  },
  [1634] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(3524),
    [anon_sym_RBRACE] = ACTIONS(3526),
    [sym_comment] = ACTIONS(46),
  },
  [1635] = {
    [sym__concat] = ACTIONS(1548),
    [anon_sym_PIPE] = ACTIONS(2157),
    [anon_sym_RPAREN] = ACTIONS(1548),
    [anon_sym_PIPE_AMP] = ACTIONS(1548),
    [anon_sym_AMP_AMP] = ACTIONS(1548),
    [anon_sym_PIPE_PIPE] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(1548),
    [sym_comment] = ACTIONS(46),
  },
  [1636] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(3528),
    [anon_sym_RBRACE] = ACTIONS(3530),
    [sym_comment] = ACTIONS(46),
  },
  [1637] = {
    [sym__concat] = ACTIONS(3532),
    [anon_sym_RBRACE] = ACTIONS(3526),
    [sym_comment] = ACTIONS(46),
  },
  [1638] = {
    [anon_sym_RBRACK] = ACTIONS(3532),
    [sym_comment] = ACTIONS(46),
  },
  [1639] = {
    [aux_sym_concatenation_repeat1] = STATE(806),
    [sym__concat] = ACTIONS(3534),
    [anon_sym_RBRACE] = ACTIONS(3536),
    [sym_comment] = ACTIONS(46),
  },
  [1640] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [sym__concat] = ACTIONS(3538),
    [anon_sym_RBRACE] = ACTIONS(3540),
    [sym_comment] = ACTIONS(46),
  },
  [1641] = {
    [sym__concat] = ACTIONS(3542),
    [anon_sym_RBRACE] = ACTIONS(3536),
    [sym_comment] = ACTIONS(46),
  },
  [1642] = {
    [anon_sym_RBRACK] = ACTIONS(3542),
    [sym_comment] = ACTIONS(46),
  },
  [1643] = {
    [anon_sym_RBRACK] = ACTIONS(3544),
    [sym_comment] = ACTIONS(46),
  },
  [1644] = {
    [anon_sym_RBRACK] = ACTIONS(3546),
    [sym_comment] = ACTIONS(46),
  },
  [1645] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3548),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1646] = {
    [sym_word] = ACTIONS(2205),
    [sym__concat] = ACTIONS(2205),
    [sym_variable_name] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2696),
    [anon_sym_RPAREN] = ACTIONS(2205),
    [anon_sym_PIPE_AMP] = ACTIONS(2205),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_PIPE_PIPE] = ACTIONS(2205),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2696),
  },
  [1647] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3550),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1648] = {
    [sym_word] = ACTIONS(2211),
    [sym__concat] = ACTIONS(2211),
    [sym_variable_name] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2700),
    [anon_sym_RPAREN] = ACTIONS(2211),
    [anon_sym_PIPE_AMP] = ACTIONS(2211),
    [anon_sym_AMP_AMP] = ACTIONS(2211),
    [anon_sym_PIPE_PIPE] = ACTIONS(2211),
    [anon_sym_BQUOTE] = ACTIONS(2211),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2700),
  },
  [1649] = {
    [anon_sym_RBRACE] = ACTIONS(3548),
    [sym_comment] = ACTIONS(46),
  },
  [1650] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3552),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1651] = {
    [sym_word] = ACTIONS(2217),
    [sym__concat] = ACTIONS(2217),
    [sym_variable_name] = ACTIONS(2217),
    [anon_sym_PIPE] = ACTIONS(2704),
    [anon_sym_RPAREN] = ACTIONS(2217),
    [anon_sym_PIPE_AMP] = ACTIONS(2217),
    [anon_sym_AMP_AMP] = ACTIONS(2217),
    [anon_sym_PIPE_PIPE] = ACTIONS(2217),
    [anon_sym_BQUOTE] = ACTIONS(2217),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2704),
  },
  [1652] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3554),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1653] = {
    [sym_word] = ACTIONS(2223),
    [sym__concat] = ACTIONS(2223),
    [sym_variable_name] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2708),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_PIPE_AMP] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_BQUOTE] = ACTIONS(2223),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(2708),
  },
  [1654] = {
    [anon_sym_RBRACE] = ACTIONS(3552),
    [sym_comment] = ACTIONS(46),
  },
  [1655] = {
    [anon_sym_RBRACE] = ACTIONS(3556),
    [sym_comment] = ACTIONS(46),
  },
  [1656] = {
    [anon_sym_RBRACE] = ACTIONS(3558),
    [sym_comment] = ACTIONS(46),
  },
  [1657] = {
    [sym_file_descriptor] = ACTIONS(2726),
    [sym__concat] = ACTIONS(2726),
    [anon_sym_PIPE] = ACTIONS(3104),
    [anon_sym_RPAREN] = ACTIONS(2726),
    [anon_sym_PIPE_AMP] = ACTIONS(2726),
    [anon_sym_AMP_AMP] = ACTIONS(2726),
    [anon_sym_PIPE_PIPE] = ACTIONS(2726),
    [anon_sym_LT] = ACTIONS(3104),
    [anon_sym_GT] = ACTIONS(3104),
    [anon_sym_GT_GT] = ACTIONS(2726),
    [anon_sym_AMP_GT] = ACTIONS(3104),
    [anon_sym_AMP_GT_GT] = ACTIONS(2726),
    [anon_sym_LT_AMP] = ACTIONS(2726),
    [anon_sym_GT_AMP] = ACTIONS(2726),
    [anon_sym_LT_LT] = ACTIONS(3104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2726),
    [anon_sym_BQUOTE] = ACTIONS(2726),
    [sym_comment] = ACTIONS(46),
  },
  [1658] = {
    [sym_file_descriptor] = ACTIONS(2730),
    [sym__concat] = ACTIONS(2730),
    [anon_sym_PIPE] = ACTIONS(3106),
    [anon_sym_RPAREN] = ACTIONS(2730),
    [anon_sym_PIPE_AMP] = ACTIONS(2730),
    [anon_sym_AMP_AMP] = ACTIONS(2730),
    [anon_sym_PIPE_PIPE] = ACTIONS(2730),
    [anon_sym_LT] = ACTIONS(3106),
    [anon_sym_GT] = ACTIONS(3106),
    [anon_sym_GT_GT] = ACTIONS(2730),
    [anon_sym_AMP_GT] = ACTIONS(3106),
    [anon_sym_AMP_GT_GT] = ACTIONS(2730),
    [anon_sym_LT_AMP] = ACTIONS(2730),
    [anon_sym_GT_AMP] = ACTIONS(2730),
    [anon_sym_LT_LT] = ACTIONS(3106),
    [anon_sym_LT_LT_DASH] = ACTIONS(2730),
    [anon_sym_BQUOTE] = ACTIONS(2730),
    [sym_comment] = ACTIONS(46),
  },
  [1659] = {
    [sym_file_descriptor] = ACTIONS(2734),
    [sym__concat] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(3108),
    [anon_sym_RPAREN] = ACTIONS(2734),
    [anon_sym_PIPE_AMP] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2734),
    [anon_sym_PIPE_PIPE] = ACTIONS(2734),
    [anon_sym_LT] = ACTIONS(3108),
    [anon_sym_GT] = ACTIONS(3108),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_AMP_GT] = ACTIONS(3108),
    [anon_sym_AMP_GT_GT] = ACTIONS(2734),
    [anon_sym_LT_AMP] = ACTIONS(2734),
    [anon_sym_GT_AMP] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(3108),
    [anon_sym_LT_LT_DASH] = ACTIONS(2734),
    [anon_sym_BQUOTE] = ACTIONS(2734),
    [sym_comment] = ACTIONS(46),
  },
  [1660] = {
    [sym_file_descriptor] = ACTIONS(2738),
    [sym__concat] = ACTIONS(2738),
    [anon_sym_PIPE] = ACTIONS(3110),
    [anon_sym_RPAREN] = ACTIONS(2738),
    [anon_sym_PIPE_AMP] = ACTIONS(2738),
    [anon_sym_AMP_AMP] = ACTIONS(2738),
    [anon_sym_PIPE_PIPE] = ACTIONS(2738),
    [anon_sym_LT] = ACTIONS(3110),
    [anon_sym_GT] = ACTIONS(3110),
    [anon_sym_GT_GT] = ACTIONS(2738),
    [anon_sym_AMP_GT] = ACTIONS(3110),
    [anon_sym_AMP_GT_GT] = ACTIONS(2738),
    [anon_sym_LT_AMP] = ACTIONS(2738),
    [anon_sym_GT_AMP] = ACTIONS(2738),
    [anon_sym_LT_LT] = ACTIONS(3110),
    [anon_sym_LT_LT_DASH] = ACTIONS(2738),
    [anon_sym_BQUOTE] = ACTIONS(2738),
    [sym_comment] = ACTIONS(46),
  },
  [1661] = {
    [sym_file_descriptor] = ACTIONS(3116),
    [sym__concat] = ACTIONS(3116),
    [anon_sym_PIPE] = ACTIONS(3118),
    [anon_sym_RPAREN] = ACTIONS(3118),
    [anon_sym_SEMI_SEMI] = ACTIONS(3118),
    [anon_sym_PIPE_AMP] = ACTIONS(3118),
    [anon_sym_AMP_AMP] = ACTIONS(3118),
    [anon_sym_PIPE_PIPE] = ACTIONS(3118),
    [anon_sym_LT] = ACTIONS(3118),
    [anon_sym_GT] = ACTIONS(3118),
    [anon_sym_GT_GT] = ACTIONS(3118),
    [anon_sym_AMP_GT] = ACTIONS(3118),
    [anon_sym_AMP_GT_GT] = ACTIONS(3118),
    [anon_sym_LT_AMP] = ACTIONS(3118),
    [anon_sym_GT_AMP] = ACTIONS(3118),
    [anon_sym_LT_LT] = ACTIONS(3118),
    [anon_sym_LT_LT_DASH] = ACTIONS(3118),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(3118),
    [anon_sym_LF] = ACTIONS(3118),
    [anon_sym_AMP] = ACTIONS(3118),
  },
  [1662] = {
    [sym_file_descriptor] = ACTIONS(3120),
    [sym__concat] = ACTIONS(3120),
    [anon_sym_PIPE] = ACTIONS(3122),
    [anon_sym_RPAREN] = ACTIONS(3122),
    [anon_sym_SEMI_SEMI] = ACTIONS(3122),
    [anon_sym_PIPE_AMP] = ACTIONS(3122),
    [anon_sym_AMP_AMP] = ACTIONS(3122),
    [anon_sym_PIPE_PIPE] = ACTIONS(3122),
    [anon_sym_LT] = ACTIONS(3122),
    [anon_sym_GT] = ACTIONS(3122),
    [anon_sym_GT_GT] = ACTIONS(3122),
    [anon_sym_AMP_GT] = ACTIONS(3122),
    [anon_sym_AMP_GT_GT] = ACTIONS(3122),
    [anon_sym_LT_AMP] = ACTIONS(3122),
    [anon_sym_GT_AMP] = ACTIONS(3122),
    [anon_sym_LT_LT] = ACTIONS(3122),
    [anon_sym_LT_LT_DASH] = ACTIONS(3122),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(3122),
    [anon_sym_LF] = ACTIONS(3122),
    [anon_sym_AMP] = ACTIONS(3122),
  },
  [1663] = {
    [anon_sym_RBRACE] = ACTIONS(3560),
    [sym_comment] = ACTIONS(46),
  },
  [1664] = {
    [anon_sym_RBRACE] = ACTIONS(3562),
    [sym_comment] = ACTIONS(46),
  },
  [1665] = {
    [sym__heredoc_middle] = ACTIONS(2726),
    [sym__heredoc_end] = ACTIONS(2726),
    [anon_sym_DOLLAR] = ACTIONS(3104),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2726),
    [sym_comment] = ACTIONS(46),
  },
  [1666] = {
    [sym__heredoc_middle] = ACTIONS(2730),
    [sym__heredoc_end] = ACTIONS(2730),
    [anon_sym_DOLLAR] = ACTIONS(3106),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2730),
    [sym_comment] = ACTIONS(46),
  },
  [1667] = {
    [sym__heredoc_middle] = ACTIONS(2734),
    [sym__heredoc_end] = ACTIONS(2734),
    [anon_sym_DOLLAR] = ACTIONS(3108),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2734),
    [sym_comment] = ACTIONS(46),
  },
  [1668] = {
    [sym__heredoc_middle] = ACTIONS(2738),
    [sym__heredoc_end] = ACTIONS(2738),
    [anon_sym_DOLLAR] = ACTIONS(3110),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2738),
    [sym_comment] = ACTIONS(46),
  },
  [1669] = {
    [sym_word] = ACTIONS(3116),
    [sym__concat] = ACTIONS(3116),
    [anon_sym_RPAREN] = ACTIONS(3116),
    [anon_sym_DQUOTE] = ACTIONS(3116),
    [sym_raw_string] = ACTIONS(3116),
    [anon_sym_DOLLAR] = ACTIONS(3375),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3116),
    [anon_sym_BQUOTE] = ACTIONS(3116),
    [anon_sym_LT_LPAREN] = ACTIONS(3116),
    [anon_sym_GT_LPAREN] = ACTIONS(3116),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3375),
  },
  [1670] = {
    [sym_word] = ACTIONS(3120),
    [sym__concat] = ACTIONS(3120),
    [anon_sym_RPAREN] = ACTIONS(3120),
    [anon_sym_DQUOTE] = ACTIONS(3120),
    [sym_raw_string] = ACTIONS(3120),
    [anon_sym_DOLLAR] = ACTIONS(3377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3120),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3120),
    [anon_sym_BQUOTE] = ACTIONS(3120),
    [anon_sym_LT_LPAREN] = ACTIONS(3120),
    [anon_sym_GT_LPAREN] = ACTIONS(3120),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3377),
  },
  [1671] = {
    [sym_word] = ACTIONS(3116),
    [sym__concat] = ACTIONS(3116),
    [anon_sym_SEMI_SEMI] = ACTIONS(3118),
    [anon_sym_DQUOTE] = ACTIONS(3118),
    [sym_raw_string] = ACTIONS(3118),
    [anon_sym_DOLLAR] = ACTIONS(3118),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3118),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3118),
    [anon_sym_BQUOTE] = ACTIONS(3118),
    [anon_sym_LT_LPAREN] = ACTIONS(3118),
    [anon_sym_GT_LPAREN] = ACTIONS(3118),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(3118),
    [anon_sym_SEMI] = ACTIONS(3118),
    [anon_sym_LF] = ACTIONS(3118),
    [anon_sym_AMP] = ACTIONS(3118),
  },
  [1672] = {
    [sym_word] = ACTIONS(3120),
    [sym__concat] = ACTIONS(3120),
    [anon_sym_SEMI_SEMI] = ACTIONS(3122),
    [anon_sym_DQUOTE] = ACTIONS(3122),
    [sym_raw_string] = ACTIONS(3122),
    [anon_sym_DOLLAR] = ACTIONS(3122),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3122),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3122),
    [anon_sym_BQUOTE] = ACTIONS(3122),
    [anon_sym_LT_LPAREN] = ACTIONS(3122),
    [anon_sym_GT_LPAREN] = ACTIONS(3122),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(3122),
    [anon_sym_SEMI] = ACTIONS(3122),
    [anon_sym_LF] = ACTIONS(3122),
    [anon_sym_AMP] = ACTIONS(3122),
  },
  [1673] = {
    [anon_sym_RBRACE] = ACTIONS(3564),
    [sym_comment] = ACTIONS(46),
  },
  [1674] = {
    [anon_sym_RBRACE] = ACTIONS(3566),
    [sym_comment] = ACTIONS(46),
  },
  [1675] = {
    [sym__concat] = ACTIONS(2726),
    [anon_sym_PIPE] = ACTIONS(2728),
    [anon_sym_RPAREN] = ACTIONS(2728),
    [anon_sym_SEMI_SEMI] = ACTIONS(2728),
    [anon_sym_PIPE_AMP] = ACTIONS(2728),
    [anon_sym_AMP_AMP] = ACTIONS(2728),
    [anon_sym_PIPE_PIPE] = ACTIONS(2728),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2728),
    [anon_sym_LF] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(2728),
  },
  [1676] = {
    [sym__concat] = ACTIONS(2730),
    [anon_sym_PIPE] = ACTIONS(2732),
    [anon_sym_RPAREN] = ACTIONS(2732),
    [anon_sym_SEMI_SEMI] = ACTIONS(2732),
    [anon_sym_PIPE_AMP] = ACTIONS(2732),
    [anon_sym_AMP_AMP] = ACTIONS(2732),
    [anon_sym_PIPE_PIPE] = ACTIONS(2732),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2732),
    [anon_sym_LF] = ACTIONS(2732),
    [anon_sym_AMP] = ACTIONS(2732),
  },
  [1677] = {
    [sym__concat] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2736),
    [anon_sym_RPAREN] = ACTIONS(2736),
    [anon_sym_SEMI_SEMI] = ACTIONS(2736),
    [anon_sym_PIPE_AMP] = ACTIONS(2736),
    [anon_sym_AMP_AMP] = ACTIONS(2736),
    [anon_sym_PIPE_PIPE] = ACTIONS(2736),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2736),
    [anon_sym_LF] = ACTIONS(2736),
    [anon_sym_AMP] = ACTIONS(2736),
  },
  [1678] = {
    [sym__concat] = ACTIONS(2738),
    [anon_sym_PIPE] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [anon_sym_SEMI_SEMI] = ACTIONS(2740),
    [anon_sym_PIPE_AMP] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_PIPE_PIPE] = ACTIONS(2740),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym_LF] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2740),
  },
  [1679] = {
    [sym_word] = ACTIONS(3116),
    [sym__concat] = ACTIONS(3116),
    [sym_variable_name] = ACTIONS(3116),
    [anon_sym_PIPE] = ACTIONS(3118),
    [anon_sym_RPAREN] = ACTIONS(3118),
    [anon_sym_SEMI_SEMI] = ACTIONS(3118),
    [anon_sym_PIPE_AMP] = ACTIONS(3118),
    [anon_sym_AMP_AMP] = ACTIONS(3118),
    [anon_sym_PIPE_PIPE] = ACTIONS(3118),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(3118),
    [anon_sym_SEMI] = ACTIONS(3118),
    [anon_sym_LF] = ACTIONS(3118),
    [anon_sym_AMP] = ACTIONS(3118),
  },
  [1680] = {
    [sym_word] = ACTIONS(3120),
    [sym__concat] = ACTIONS(3120),
    [sym_variable_name] = ACTIONS(3120),
    [anon_sym_PIPE] = ACTIONS(3122),
    [anon_sym_RPAREN] = ACTIONS(3122),
    [anon_sym_SEMI_SEMI] = ACTIONS(3122),
    [anon_sym_PIPE_AMP] = ACTIONS(3122),
    [anon_sym_AMP_AMP] = ACTIONS(3122),
    [anon_sym_PIPE_PIPE] = ACTIONS(3122),
    [sym_comment] = ACTIONS(60),
    [sym_identifier] = ACTIONS(3122),
    [anon_sym_SEMI] = ACTIONS(3122),
    [anon_sym_LF] = ACTIONS(3122),
    [anon_sym_AMP] = ACTIONS(3122),
  },
  [1681] = {
    [sym_file_descriptor] = ACTIONS(3116),
    [sym_word] = ACTIONS(3116),
    [sym__concat] = ACTIONS(3116),
    [sym_variable_name] = ACTIONS(3116),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_RPAREN] = ACTIONS(3116),
    [anon_sym_PIPE_AMP] = ACTIONS(3116),
    [anon_sym_AMP_AMP] = ACTIONS(3116),
    [anon_sym_PIPE_PIPE] = ACTIONS(3116),
    [anon_sym_LT] = ACTIONS(3375),
    [anon_sym_GT] = ACTIONS(3375),
    [anon_sym_GT_GT] = ACTIONS(3116),
    [anon_sym_AMP_GT] = ACTIONS(3375),
    [anon_sym_AMP_GT_GT] = ACTIONS(3116),
    [anon_sym_LT_AMP] = ACTIONS(3116),
    [anon_sym_GT_AMP] = ACTIONS(3116),
    [anon_sym_DQUOTE] = ACTIONS(3116),
    [sym_raw_string] = ACTIONS(3116),
    [anon_sym_DOLLAR] = ACTIONS(3375),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3116),
    [anon_sym_BQUOTE] = ACTIONS(3116),
    [anon_sym_LT_LPAREN] = ACTIONS(3116),
    [anon_sym_GT_LPAREN] = ACTIONS(3116),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3375),
  },
  [1682] = {
    [sym_file_descriptor] = ACTIONS(3120),
    [sym_word] = ACTIONS(3120),
    [sym__concat] = ACTIONS(3120),
    [sym_variable_name] = ACTIONS(3120),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_RPAREN] = ACTIONS(3120),
    [anon_sym_PIPE_AMP] = ACTIONS(3120),
    [anon_sym_AMP_AMP] = ACTIONS(3120),
    [anon_sym_PIPE_PIPE] = ACTIONS(3120),
    [anon_sym_LT] = ACTIONS(3377),
    [anon_sym_GT] = ACTIONS(3377),
    [anon_sym_GT_GT] = ACTIONS(3120),
    [anon_sym_AMP_GT] = ACTIONS(3377),
    [anon_sym_AMP_GT_GT] = ACTIONS(3120),
    [anon_sym_LT_AMP] = ACTIONS(3120),
    [anon_sym_GT_AMP] = ACTIONS(3120),
    [anon_sym_DQUOTE] = ACTIONS(3120),
    [sym_raw_string] = ACTIONS(3120),
    [anon_sym_DOLLAR] = ACTIONS(3377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3120),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3120),
    [anon_sym_BQUOTE] = ACTIONS(3120),
    [anon_sym_LT_LPAREN] = ACTIONS(3120),
    [anon_sym_GT_LPAREN] = ACTIONS(3120),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3377),
  },
  [1683] = {
    [anon_sym_RBRACK] = ACTIONS(3568),
    [sym_comment] = ACTIONS(46),
  },
  [1684] = {
    [anon_sym_RBRACK] = ACTIONS(3570),
    [sym_comment] = ACTIONS(46),
  },
  [1685] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3572),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1686] = {
    [sym__concat] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2696),
    [anon_sym_RPAREN] = ACTIONS(2205),
    [anon_sym_PIPE_AMP] = ACTIONS(2205),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_PIPE_PIPE] = ACTIONS(2205),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [sym_comment] = ACTIONS(46),
  },
  [1687] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3574),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1688] = {
    [sym__concat] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2700),
    [anon_sym_RPAREN] = ACTIONS(2211),
    [anon_sym_PIPE_AMP] = ACTIONS(2211),
    [anon_sym_AMP_AMP] = ACTIONS(2211),
    [anon_sym_PIPE_PIPE] = ACTIONS(2211),
    [anon_sym_BQUOTE] = ACTIONS(2211),
    [sym_comment] = ACTIONS(46),
  },
  [1689] = {
    [anon_sym_RBRACE] = ACTIONS(3572),
    [sym_comment] = ACTIONS(46),
  },
  [1690] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3576),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1691] = {
    [sym__concat] = ACTIONS(2217),
    [anon_sym_PIPE] = ACTIONS(2704),
    [anon_sym_RPAREN] = ACTIONS(2217),
    [anon_sym_PIPE_AMP] = ACTIONS(2217),
    [anon_sym_AMP_AMP] = ACTIONS(2217),
    [anon_sym_PIPE_PIPE] = ACTIONS(2217),
    [anon_sym_BQUOTE] = ACTIONS(2217),
    [sym_comment] = ACTIONS(46),
  },
  [1692] = {
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [sym_word] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(3578),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(1270),
  },
  [1693] = {
    [sym__concat] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2708),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_PIPE_AMP] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_BQUOTE] = ACTIONS(2223),
    [sym_comment] = ACTIONS(46),
  },
  [1694] = {
    [anon_sym_RBRACE] = ACTIONS(3576),
    [sym_comment] = ACTIONS(46),
  },
  [1695] = {
    [anon_sym_RBRACE] = ACTIONS(3580),
    [sym_comment] = ACTIONS(46),
  },
  [1696] = {
    [anon_sym_RBRACE] = ACTIONS(3582),
    [sym_comment] = ACTIONS(46),
  },
  [1697] = {
    [sym_word] = ACTIONS(2726),
    [sym__concat] = ACTIONS(2726),
    [sym_variable_name] = ACTIONS(2726),
    [anon_sym_PIPE] = ACTIONS(3104),
    [anon_sym_RPAREN] = ACTIONS(2726),
    [anon_sym_PIPE_AMP] = ACTIONS(2726),
    [anon_sym_AMP_AMP] = ACTIONS(2726),
    [anon_sym_PIPE_PIPE] = ACTIONS(2726),
    [anon_sym_BQUOTE] = ACTIONS(2726),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3104),
  },
  [1698] = {
    [sym_word] = ACTIONS(2730),
    [sym__concat] = ACTIONS(2730),
    [sym_variable_name] = ACTIONS(2730),
    [anon_sym_PIPE] = ACTIONS(3106),
    [anon_sym_RPAREN] = ACTIONS(2730),
    [anon_sym_PIPE_AMP] = ACTIONS(2730),
    [anon_sym_AMP_AMP] = ACTIONS(2730),
    [anon_sym_PIPE_PIPE] = ACTIONS(2730),
    [anon_sym_BQUOTE] = ACTIONS(2730),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3106),
  },
  [1699] = {
    [sym_word] = ACTIONS(2734),
    [sym__concat] = ACTIONS(2734),
    [sym_variable_name] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(3108),
    [anon_sym_RPAREN] = ACTIONS(2734),
    [anon_sym_PIPE_AMP] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2734),
    [anon_sym_PIPE_PIPE] = ACTIONS(2734),
    [anon_sym_BQUOTE] = ACTIONS(2734),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3108),
  },
  [1700] = {
    [sym_word] = ACTIONS(2738),
    [sym__concat] = ACTIONS(2738),
    [sym_variable_name] = ACTIONS(2738),
    [anon_sym_PIPE] = ACTIONS(3110),
    [anon_sym_RPAREN] = ACTIONS(2738),
    [anon_sym_PIPE_AMP] = ACTIONS(2738),
    [anon_sym_AMP_AMP] = ACTIONS(2738),
    [anon_sym_PIPE_PIPE] = ACTIONS(2738),
    [anon_sym_BQUOTE] = ACTIONS(2738),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3110),
  },
  [1701] = {
    [sym_file_descriptor] = ACTIONS(3116),
    [sym__concat] = ACTIONS(3116),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_RPAREN] = ACTIONS(3116),
    [anon_sym_PIPE_AMP] = ACTIONS(3116),
    [anon_sym_AMP_AMP] = ACTIONS(3116),
    [anon_sym_PIPE_PIPE] = ACTIONS(3116),
    [anon_sym_LT] = ACTIONS(3375),
    [anon_sym_GT] = ACTIONS(3375),
    [anon_sym_GT_GT] = ACTIONS(3116),
    [anon_sym_AMP_GT] = ACTIONS(3375),
    [anon_sym_AMP_GT_GT] = ACTIONS(3116),
    [anon_sym_LT_AMP] = ACTIONS(3116),
    [anon_sym_GT_AMP] = ACTIONS(3116),
    [anon_sym_LT_LT] = ACTIONS(3375),
    [anon_sym_LT_LT_DASH] = ACTIONS(3116),
    [anon_sym_BQUOTE] = ACTIONS(3116),
    [sym_comment] = ACTIONS(46),
  },
  [1702] = {
    [sym_file_descriptor] = ACTIONS(3120),
    [sym__concat] = ACTIONS(3120),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_RPAREN] = ACTIONS(3120),
    [anon_sym_PIPE_AMP] = ACTIONS(3120),
    [anon_sym_AMP_AMP] = ACTIONS(3120),
    [anon_sym_PIPE_PIPE] = ACTIONS(3120),
    [anon_sym_LT] = ACTIONS(3377),
    [anon_sym_GT] = ACTIONS(3377),
    [anon_sym_GT_GT] = ACTIONS(3120),
    [anon_sym_AMP_GT] = ACTIONS(3377),
    [anon_sym_AMP_GT_GT] = ACTIONS(3120),
    [anon_sym_LT_AMP] = ACTIONS(3120),
    [anon_sym_GT_AMP] = ACTIONS(3120),
    [anon_sym_LT_LT] = ACTIONS(3377),
    [anon_sym_LT_LT_DASH] = ACTIONS(3120),
    [anon_sym_BQUOTE] = ACTIONS(3120),
    [sym_comment] = ACTIONS(46),
  },
  [1703] = {
    [sym__heredoc_middle] = ACTIONS(3116),
    [sym__heredoc_end] = ACTIONS(3116),
    [anon_sym_DOLLAR] = ACTIONS(3375),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3116),
    [sym_comment] = ACTIONS(46),
  },
  [1704] = {
    [sym__heredoc_middle] = ACTIONS(3120),
    [sym__heredoc_end] = ACTIONS(3120),
    [anon_sym_DOLLAR] = ACTIONS(3377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3120),
    [sym_comment] = ACTIONS(46),
  },
  [1705] = {
    [sym__concat] = ACTIONS(3116),
    [anon_sym_PIPE] = ACTIONS(3118),
    [anon_sym_RPAREN] = ACTIONS(3118),
    [anon_sym_SEMI_SEMI] = ACTIONS(3118),
    [anon_sym_PIPE_AMP] = ACTIONS(3118),
    [anon_sym_AMP_AMP] = ACTIONS(3118),
    [anon_sym_PIPE_PIPE] = ACTIONS(3118),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(3118),
    [anon_sym_LF] = ACTIONS(3118),
    [anon_sym_AMP] = ACTIONS(3118),
  },
  [1706] = {
    [sym__concat] = ACTIONS(3120),
    [anon_sym_PIPE] = ACTIONS(3122),
    [anon_sym_RPAREN] = ACTIONS(3122),
    [anon_sym_SEMI_SEMI] = ACTIONS(3122),
    [anon_sym_PIPE_AMP] = ACTIONS(3122),
    [anon_sym_AMP_AMP] = ACTIONS(3122),
    [anon_sym_PIPE_PIPE] = ACTIONS(3122),
    [sym_comment] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(3122),
    [anon_sym_LF] = ACTIONS(3122),
    [anon_sym_AMP] = ACTIONS(3122),
  },
  [1707] = {
    [anon_sym_RBRACE] = ACTIONS(3584),
    [sym_comment] = ACTIONS(46),
  },
  [1708] = {
    [anon_sym_RBRACE] = ACTIONS(3586),
    [sym_comment] = ACTIONS(46),
  },
  [1709] = {
    [sym__concat] = ACTIONS(2726),
    [anon_sym_PIPE] = ACTIONS(3104),
    [anon_sym_RPAREN] = ACTIONS(2726),
    [anon_sym_PIPE_AMP] = ACTIONS(2726),
    [anon_sym_AMP_AMP] = ACTIONS(2726),
    [anon_sym_PIPE_PIPE] = ACTIONS(2726),
    [anon_sym_BQUOTE] = ACTIONS(2726),
    [sym_comment] = ACTIONS(46),
  },
  [1710] = {
    [sym__concat] = ACTIONS(2730),
    [anon_sym_PIPE] = ACTIONS(3106),
    [anon_sym_RPAREN] = ACTIONS(2730),
    [anon_sym_PIPE_AMP] = ACTIONS(2730),
    [anon_sym_AMP_AMP] = ACTIONS(2730),
    [anon_sym_PIPE_PIPE] = ACTIONS(2730),
    [anon_sym_BQUOTE] = ACTIONS(2730),
    [sym_comment] = ACTIONS(46),
  },
  [1711] = {
    [sym__concat] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(3108),
    [anon_sym_RPAREN] = ACTIONS(2734),
    [anon_sym_PIPE_AMP] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2734),
    [anon_sym_PIPE_PIPE] = ACTIONS(2734),
    [anon_sym_BQUOTE] = ACTIONS(2734),
    [sym_comment] = ACTIONS(46),
  },
  [1712] = {
    [sym__concat] = ACTIONS(2738),
    [anon_sym_PIPE] = ACTIONS(3110),
    [anon_sym_RPAREN] = ACTIONS(2738),
    [anon_sym_PIPE_AMP] = ACTIONS(2738),
    [anon_sym_AMP_AMP] = ACTIONS(2738),
    [anon_sym_PIPE_PIPE] = ACTIONS(2738),
    [anon_sym_BQUOTE] = ACTIONS(2738),
    [sym_comment] = ACTIONS(46),
  },
  [1713] = {
    [sym_word] = ACTIONS(3116),
    [sym__concat] = ACTIONS(3116),
    [sym_variable_name] = ACTIONS(3116),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_RPAREN] = ACTIONS(3116),
    [anon_sym_PIPE_AMP] = ACTIONS(3116),
    [anon_sym_AMP_AMP] = ACTIONS(3116),
    [anon_sym_PIPE_PIPE] = ACTIONS(3116),
    [anon_sym_BQUOTE] = ACTIONS(3116),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3375),
  },
  [1714] = {
    [sym_word] = ACTIONS(3120),
    [sym__concat] = ACTIONS(3120),
    [sym_variable_name] = ACTIONS(3120),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_RPAREN] = ACTIONS(3120),
    [anon_sym_PIPE_AMP] = ACTIONS(3120),
    [anon_sym_AMP_AMP] = ACTIONS(3120),
    [anon_sym_PIPE_PIPE] = ACTIONS(3120),
    [anon_sym_BQUOTE] = ACTIONS(3120),
    [sym_comment] = ACTIONS(46),
    [sym_identifier] = ACTIONS(3377),
  },
  [1715] = {
    [sym__concat] = ACTIONS(3116),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_RPAREN] = ACTIONS(3116),
    [anon_sym_PIPE_AMP] = ACTIONS(3116),
    [anon_sym_AMP_AMP] = ACTIONS(3116),
    [anon_sym_PIPE_PIPE] = ACTIONS(3116),
    [anon_sym_BQUOTE] = ACTIONS(3116),
    [sym_comment] = ACTIONS(46),
  },
  [1716] = {
    [sym__concat] = ACTIONS(3120),
    [anon_sym_PIPE] = ACTIONS(3377),
    [anon_sym_RPAREN] = ACTIONS(3120),
    [anon_sym_PIPE_AMP] = ACTIONS(3120),
    [anon_sym_AMP_AMP] = ACTIONS(3120),
    [anon_sym_PIPE_PIPE] = ACTIONS(3120),
    [anon_sym_BQUOTE] = ACTIONS(3120),
    [sym_comment] = ACTIONS(46),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false, .depends_on_lookahead = false},
  [1] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(),
  [3] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, RECOVER(),
  [5] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, SHIFT_EXTRA(), RECOVER(),
  [8] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2),
  [10] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(3),
  [12] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(4),
  [14] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_program, 0),
  [16] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(5),
  [18] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(6),
  [20] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(7),
  [22] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(8),
  [24] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(9),
  [26] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(10),
  [28] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(11),
  [30] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(12),
  [32] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(12),
  [34] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(13),
  [36] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(14),
  [38] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(15),
  [40] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(16),
  [42] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(17),
  [44] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(18),
  [46] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT_EXTRA(),
  [48] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(19),
  [50] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(30),
  [52] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(30),
  [54] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1),
  [56] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(31),
  [58] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1),
  [60] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT_EXTRA(),
  [62] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(33),
  [64] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(34),
  [66] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(36),
  [68] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(41),
  [70] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(42),
  [72] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(43),
  [74] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(44),
  [76] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(45),
  [78] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(46),
  [80] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(47),
  [82] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(48),
  [84] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(50),
  [86] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(51),
  [88] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(52),
  [90] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(53),
  [92] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(54),
  [94] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(55),
  [96] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(62),
  [98] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(63),
  [100] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_declaration_command, 1),
  [102] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(64),
  [104] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(67),
  [106] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(68),
  [108] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(69),
  [110] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(70),
  [112] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(71),
  [114] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(72),
  [116] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(73),
  [118] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(74),
  [120] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(76),
  [122] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(77),
  [124] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(78),
  [126] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(79),
  [128] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(80),
  [130] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(81),
  [132] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(83),
  [134] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(84),
  [136] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(83),
  [138] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(86),
  [140] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(87),
  [142] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(88),
  [144] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(86),
  [146] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(90),
  [148] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(91),
  [150] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(92),
  [152] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(93),
  [154] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(94),
  [156] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(95),
  [158] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(96),
  [160] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(97),
  [162] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(98),
  [164] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(99),
  [166] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(100),
  [168] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(101),
  [170] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(102),
  [172] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(103),
  [174] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(104),
  [176] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(105),
  [178] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(112),
  [180] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(113),
  [182] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(114),
  [184] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(115),
  [186] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(116),
  [188] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [190] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [192] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(124),
  [194] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, ACCEPT_INPUT(),
  [196] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 1),
  [198] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 1),
  [200] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 1),
  [202] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(126),
  [204] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(127),
  [206] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(128),
  [208] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(129),
  [210] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(130),
  [212] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 1),
  [214] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(131),
  [216] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(132),
  [218] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(13),
  [220] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(130),
  [222] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(14),
  [224] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(15),
  [226] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(16),
  [228] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(17),
  [230] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(18),
  [232] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(133),
  [234] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true),
  [236] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true),
  [238] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true),
  [240] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_program, 1),
  [242] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(139),
  [244] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(140),
  [246] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(144),
  [248] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(145),
  [250] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(147),
  [252] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(148),
  [254] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_concatenation, 2),
  [256] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_concatenation, 2),
  [258] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(150),
  [260] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(151),
  [262] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(152),
  [264] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(153),
  [266] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(154),
  [268] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(155),
  [270] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(156),
  [272] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(157),
  [274] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(158),
  [276] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(159),
  [278] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(160),
  [280] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(161),
  [282] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(162),
  [284] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(163),
  [286] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(164),
  [288] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(165),
  [290] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(166),
  [292] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(167),
  [294] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_variable_assignment, 2),
  [296] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_variable_assignment, 2),
  [298] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(169),
  [300] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(170),
  [302] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(172),
  [304] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(173),
  [306] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(174),
  [308] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(175),
  [310] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(176),
  [312] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(178),
  [314] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(180),
  [316] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(181),
  [318] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(180),
  [320] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(183),
  [322] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(184),
  [324] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(192),
  [326] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(193),
  [328] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(195),
  [330] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(196),
  [332] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(199),
  [334] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(200),
  [336] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(201),
  [338] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(204),
  [340] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(206),
  [342] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(207),
  [344] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(208),
  [346] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(209),
  [348] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(210),
  [350] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(211),
  [352] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(212),
  [354] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(211),
  [356] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(213),
  [358] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(219),
  [360] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [362] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [364] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(221),
  [366] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 2),
  [368] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 2),
  [370] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_declaration_command, 2),
  [372] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2),
  [374] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(224),
  [376] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_file_redirect, 2),
  [378] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(226),
  [380] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(228),
  [382] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(229),
  [384] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(228),
  [386] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(231),
  [388] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(232),
  [390] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 3),
  [392] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 3),
  [394] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_string, 2),
  [396] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 2),
  [398] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 1),
  [400] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(241),
  [402] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(242),
  [404] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(241),
  [406] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(244),
  [408] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(245),
  [410] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(251),
  [412] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_special_variable_name, 1),
  [414] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_special_variable_name, 1),
  [416] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 4),
  [418] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 4),
  [420] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2),
  [422] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2),
  [424] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_special_variable_name, 1),
  [426] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(253),
  [428] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(255),
  [430] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(256),
  [432] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(257),
  [434] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(256),
  [436] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(258),
  [438] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(259),
  [440] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(260),
  [442] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(259),
  [444] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(261),
  [446] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command_name, 1),
  [448] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(263),
  [450] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(265),
  [452] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(268),
  [454] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(269),
  [456] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(271),
  [458] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(275),
  [460] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(276),
  [462] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_declaration_command, 1),
  [464] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_declaration_command, 1),
  [466] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(277),
  [468] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(280),
  [470] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(282),
  [472] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(283),
  [474] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(282),
  [476] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(285),
  [478] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(286),
  [480] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [482] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(294),
  [484] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(296),
  [486] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(297),
  [488] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(296),
  [490] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(298),
  [492] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(299),
  [494] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(300),
  [496] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 1),
  [498] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 1),
  [500] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(301),
  [502] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(301),
  [504] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(302),
  [506] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(302),
  [508] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(303),
  [510] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(308),
  [512] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(311),
  [514] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(312),
  [516] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(313),
  [518] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(316),
  [520] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(318),
  [522] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(318),
  [524] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(319),
  [526] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(320),
  [528] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(321),
  [530] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(322),
  [532] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(322),
  [534] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(323),
  [536] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(326),
  [538] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(328),
  [540] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(329),
  [542] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_concatenation, 2, .alias_sequence_id = 1),
  [544] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_concatenation, 2, .alias_sequence_id = 1),
  [546] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2),
  [548] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym__terminated_statement, 2),
  [550] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2),
  [552] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(334),
  [554] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(334),
  [556] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [558] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [560] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(335),
  [562] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(336),
  [564] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(337),
  [566] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(338),
  [568] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(339),
  [570] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(340),
  [572] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(341),
  [574] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(342),
  [576] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(344),
  [578] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(345),
  [580] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [582] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [584] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 1),
  [586] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 1),
  [588] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 2),
  [590] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2),
  [593] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3),
  [596] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4),
  [599] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2),
  [601] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5),
  [604] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(6),
  [607] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(7),
  [610] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(8),
  [613] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(9),
  [616] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(10),
  [619] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(11),
  [622] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(12),
  [625] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(12),
  [628] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(13),
  [631] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(14),
  [634] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(15),
  [637] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(16),
  [640] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(17),
  [643] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(18),
  [646] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(19),
  [649] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(350),
  [651] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(2),
  [654] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 2),
  [656] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(139),
  [659] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(12),
  [662] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(12),
  [665] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat1, 2),
  [667] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 3),
  [669] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_file_redirect, 3),
  [671] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 5),
  [673] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 5),
  [675] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [677] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [679] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2, .alias_sequence_id = 3),
  [681] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2, .alias_sequence_id = 3),
  [683] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(31),
  [686] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym__assignment, 2),
  [688] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(353),
  [690] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym__assignment, 2),
  [692] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(355),
  [694] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(356),
  [696] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(357),
  [698] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(358),
  [700] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(359),
  [702] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(360),
  [704] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(361),
  [706] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(362),
  [708] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(363),
  [710] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(366),
  [712] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(368),
  [714] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(369),
  [716] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(368),
  [718] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(371),
  [720] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(372),
  [722] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym__assignment, 2, .alias_sequence_id = 3),
  [724] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym__assignment, 2, .alias_sequence_id = 3),
  [726] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(381),
  [728] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(382),
  [730] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(384),
  [732] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(386),
  [734] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(387),
  [736] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(386),
  [738] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(389),
  [740] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(390),
  [742] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(398),
  [744] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(400),
  [746] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(401),
  [748] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(402),
  [750] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(403),
  [752] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(404),
  [754] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(405),
  [756] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(406),
  [758] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(407),
  [760] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(410),
  [762] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_while_statement, 3),
  [764] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(415),
  [766] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(416),
  [768] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(417),
  [770] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(425),
  [772] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(426),
  [774] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(427),
  [776] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(428),
  [778] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(430),
  [780] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(431),
  [782] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(433),
  [784] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(434),
  [786] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(435),
  [788] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(434),
  [790] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(436),
  [792] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(437),
  [794] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(438),
  [796] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(437),
  [798] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(439),
  [800] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(440),
  [802] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(441),
  [804] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(442),
  [806] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(443),
  [808] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(444),
  [810] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(446),
  [812] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 3, .alias_sequence_id = 4),
  [814] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(447),
  [816] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(450),
  [818] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(451),
  [820] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(452),
  [822] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(454),
  [824] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(456),
  [826] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 3),
  [828] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(457),
  [830] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(460),
  [832] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(460),
  [834] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(461),
  [836] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(462),
  [838] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(457),
  [840] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(466),
  [842] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(468),
  [844] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(469),
  [846] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(470),
  [848] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(471),
  [850] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(472),
  [852] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(473),
  [854] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(474),
  [856] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(475),
  [858] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(476),
  [860] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(477),
  [862] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(62),
  [865] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(63),
  [868] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [870] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(64),
  [873] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(478),
  [875] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(479),
  [877] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_concatenation, 2),
  [879] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_string, 2),
  [881] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(481),
  [883] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 4),
  [885] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_simple_expansion, 2),
  [887] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(482),
  [889] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(484),
  [891] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(485),
  [893] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(486),
  [895] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(485),
  [897] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(487),
  [899] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(488),
  [901] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(489),
  [903] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(488),
  [905] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(490),
  [907] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(491),
  [909] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_concatenation, 2, .alias_sequence_id = 1),
  [911] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(492),
  [913] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(494),
  [915] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(495),
  [917] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(496),
  [919] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(495),
  [921] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(497),
  [923] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(498),
  [925] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(499),
  [927] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(498),
  [929] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(500),
  [931] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_string, 3),
  [933] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 3),
  [935] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2),
  [937] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(77),
  [940] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(78),
  [943] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(79),
  [946] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(80),
  [949] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(81),
  [952] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(501),
  [954] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(502),
  [956] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(503),
  [958] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(504),
  [960] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 4),
  [962] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 4),
  [964] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(505),
  [966] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(506),
  [968] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(507),
  [970] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(509),
  [972] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3),
  [974] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3),
  [976] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(510),
  [978] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(511),
  [980] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(513),
  [982] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(514),
  [984] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(515),
  [986] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(517),
  [988] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(518),
  [990] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(519),
  [992] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(520),
  [994] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(521),
  [996] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(522),
  [998] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(523),
  [1000] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(524),
  [1002] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(525),
  [1004] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(526),
  [1006] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_variable_assignment, 2),
  [1008] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(527),
  [1010] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(528),
  [1012] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(530),
  [1014] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(531),
  [1016] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(532),
  [1018] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(533),
  [1020] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(534),
  [1022] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(535),
  [1024] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(536),
  [1026] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(538),
  [1028] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(539),
  [1030] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [1032] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(542),
  [1034] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 2),
  [1036] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_declaration_command, 2),
  [1038] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_declaration_command, 2),
  [1040] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(545),
  [1042] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(546),
  [1044] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(548),
  [1046] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(549),
  [1048] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(550),
  [1050] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(549),
  [1052] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(551),
  [1054] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(552),
  [1056] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(553),
  [1058] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(552),
  [1060] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(554),
  [1062] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(555),
  [1064] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(556),
  [1066] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3),
  [1068] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3),
  [1070] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(561),
  [1072] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(561),
  [1074] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [1076] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(562),
  [1078] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(563),
  [1080] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(564),
  [1082] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(565),
  [1084] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(566),
  [1086] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(567),
  [1088] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(568),
  [1090] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(569),
  [1092] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(571),
  [1094] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(572),
  [1096] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [1098] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat2, 1),
  [1100] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 2),
  [1102] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 2),
  [1104] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(579),
  [1106] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(580),
  [1108] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(581),
  [1110] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(583),
  [1112] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(585),
  [1114] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(589),
  [1116] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(589),
  [1118] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(590),
  [1120] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(591),
  [1122] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_process_substitution, 3),
  [1124] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_process_substitution, 3),
  [1126] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3),
  [1128] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_list, 3, .fragile = true),
  [1130] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(597),
  [1132] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(598),
  [1134] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(600),
  [1136] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2),
  [1138] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(602),
  [1140] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(604),
  [1142] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(605),
  [1144] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(604),
  [1146] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(607),
  [1148] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(608),
  [1150] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 3),
  [1152] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 1),
  [1154] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 1),
  [1156] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(617),
  [1158] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(618),
  [1160] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(619),
  [1162] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(620),
  [1164] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc_redirect, 2),
  [1166] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc_redirect, 2),
  [1168] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [1170] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(130),
  [1173] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [1175] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(13),
  [1178] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(130),
  [1181] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(14),
  [1184] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(15),
  [1187] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(16),
  [1190] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(17),
  [1193] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(18),
  [1196] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(133),
  [1199] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 3),
  [1201] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(129),
  [1204] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2),
  [1206] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(131),
  [1209] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(132),
  [1212] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(622),
  [1214] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(623),
  [1216] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(624),
  [1218] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(625),
  [1220] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(627),
  [1222] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(628),
  [1224] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(630),
  [1226] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_array, 2),
  [1228] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_array, 2),
  [1230] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(632),
  [1232] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(634),
  [1234] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(635),
  [1236] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(634),
  [1238] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(637),
  [1240] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(638),
  [1242] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(647),
  [1244] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(649),
  [1246] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(650),
  [1248] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(652),
  [1250] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(653),
  [1252] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(654),
  [1254] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(653),
  [1256] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(655),
  [1258] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(656),
  [1260] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(657),
  [1262] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(656),
  [1264] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(658),
  [1266] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(659),
  [1268] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(660),
  [1270] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(661),
  [1272] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subscript, 4),
  [1274] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(663),
  [1276] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(664),
  [1278] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(666),
  [1280] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(667),
  [1282] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(668),
  [1284] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(667),
  [1286] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(669),
  [1288] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(670),
  [1290] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(671),
  [1292] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(670),
  [1294] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(672),
  [1296] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(673),
  [1298] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subscript, 4, .alias_sequence_id = 5),
  [1300] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(674),
  [1302] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(676),
  [1304] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(678),
  [1306] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(679),
  [1308] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(678),
  [1310] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(681),
  [1312] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(682),
  [1314] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(691),
  [1316] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(401),
  [1318] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(400),
  [1320] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(402),
  [1322] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(403),
  [1324] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(404),
  [1326] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(405),
  [1328] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(406),
  [1330] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(407),
  [1332] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_do_group, 2),
  [1334] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(693),
  [1336] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(694),
  [1338] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 4),
  [1340] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_else_clause, 1),
  [1342] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(701),
  [1344] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_if_statement_repeat1, 1),
  [1346] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(702),
  [1348] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(702),
  [1350] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(416),
  [1352] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(417),
  [1354] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(707),
  [1356] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(708),
  [1358] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(709),
  [1360] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(713),
  [1362] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(174),
  [1365] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(714),
  [1367] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(715),
  [1369] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(716),
  [1371] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(717),
  [1373] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(718),
  [1375] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(719),
  [1377] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(720),
  [1379] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(722),
  [1381] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(723),
  [1383] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(724),
  [1385] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(726),
  [1387] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(727),
  [1389] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(729),
  [1391] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 2),
  [1393] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 2),
  [1395] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(731),
  [1397] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(733),
  [1399] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(733),
  [1401] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(734),
  [1403] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(735),
  [1405] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(736),
  [1407] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(737),
  [1409] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(738),
  [1411] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(739),
  [1413] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(740),
  [1415] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(741),
  [1417] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 4, .alias_sequence_id = 4),
  [1419] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(745),
  [1421] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(746),
  [1423] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(747),
  [1425] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(748),
  [1427] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(749),
  [1429] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(201),
  [1432] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 4),
  [1434] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(751),
  [1436] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(752),
  [1438] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(211),
  [1441] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(211),
  [1444] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(213),
  [1447] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(210),
  [1450] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(212),
  [1453] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(755),
  [1455] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(757),
  [1457] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(759),
  [1459] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(761),
  [1461] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(763),
  [1463] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(764),
  [1465] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(763),
  [1467] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(766),
  [1469] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(767),
  [1471] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1473] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_concatenation_repeat1, 2, .alias_sequence_id = 3),
  [1475] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(224),
  [1478] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_string, 3),
  [1480] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(776),
  [1482] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(777),
  [1484] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(778),
  [1486] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(779),
  [1488] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 3, .alias_sequence_id = 4),
  [1490] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(780),
  [1492] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(781),
  [1494] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(782),
  [1496] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(784),
  [1498] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 3),
  [1500] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(785),
  [1502] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(786),
  [1504] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(788),
  [1506] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command_substitution, 3),
  [1508] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_process_substitution, 3),
  [1510] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(789),
  [1512] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(790),
  [1514] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(791),
  [1516] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(792),
  [1518] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(793),
  [1520] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(794),
  [1522] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(795),
  [1524] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(797),
  [1526] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(798),
  [1528] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(799),
  [1530] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(801),
  [1532] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 6),
  [1534] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 6),
  [1536] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(802),
  [1538] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4),
  [1540] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4),
  [1542] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(803),
  [1544] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(804),
  [1546] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(805),
  [1548] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 4),
  [1550] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 4),
  [1552] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(807),
  [1554] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(808),
  [1556] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(810),
  [1558] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(811),
  [1560] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(812),
  [1562] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(813),
  [1564] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(814),
  [1566] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(815),
  [1568] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(261),
  [1571] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(816),
  [1573] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym__assignment, 2),
  [1575] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(818),
  [1577] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(820),
  [1579] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(822),
  [1581] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(823),
  [1583] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(822),
  [1585] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(825),
  [1587] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(826),
  [1589] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym__assignment, 2, .alias_sequence_id = 3),
  [1591] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(836),
  [1593] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_while_statement, 3),
  [1595] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_while_statement, 3),
  [1597] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(838),
  [1599] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(842),
  [1601] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(843),
  [1603] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(844),
  [1605] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(845),
  [1607] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(846),
  [1609] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(847),
  [1611] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(849),
  [1613] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 3, .alias_sequence_id = 4),
  [1615] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 3, .alias_sequence_id = 4),
  [1617] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(850),
  [1619] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(850),
  [1621] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subshell, 3),
  [1623] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subshell, 3),
  [1625] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(852),
  [1627] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(852),
  [1629] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(853),
  [1631] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(854),
  [1633] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(855),
  [1635] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(856),
  [1637] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(857),
  [1639] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(858),
  [1641] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(859),
  [1643] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(860),
  [1645] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(861),
  [1647] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(862),
  [1649] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(863),
  [1651] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(275),
  [1654] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(276),
  [1657] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [1659] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [1661] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(277),
  [1664] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(864),
  [1666] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(865),
  [1668] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(866),
  [1670] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(867),
  [1672] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(868),
  [1674] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(869),
  [1676] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(870),
  [1678] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(872),
  [1680] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(873),
  [1682] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(874),
  [1684] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(876),
  [1686] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_pipeline, 3),
  [1688] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3),
  [1690] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_list, 3, .fragile = true),
  [1692] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(878),
  [1694] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(879),
  [1696] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(881),
  [1698] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(883),
  [1700] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(885),
  [1702] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(886),
  [1704] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(885),
  [1706] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(888),
  [1708] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(889),
  [1710] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc, 1),
  [1712] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(898),
  [1714] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc_redirect, 2),
  [1716] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(300),
  [1719] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [1721] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(99),
  [1724] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(100),
  [1727] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(101),
  [1730] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(102),
  [1733] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(103),
  [1736] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(104),
  [1739] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(303),
  [1742] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 3),
  [1744] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 3),
  [1746] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(299),
  [1749] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat2, 2),
  [1751] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2),
  [1753] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(301),
  [1756] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(301),
  [1759] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(302),
  [1762] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(302),
  [1765] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(903),
  [1767] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(904),
  [1769] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(905),
  [1771] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(905),
  [1773] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(906),
  [1775] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(907),
  [1777] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(313),
  [1780] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(909),
  [1782] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(910),
  [1784] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(321),
  [1787] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(323),
  [1790] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(320),
  [1793] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(322),
  [1796] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(322),
  [1799] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 4, .alias_sequence_id = 2),
  [1801] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 3),
  [1803] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 5),
  [1805] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(915),
  [1807] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(916),
  [1809] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(918),
  [1811] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(919),
  [1813] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(921),
  [1815] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(922),
  [1817] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(923),
  [1819] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(922),
  [1821] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(924),
  [1823] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(925),
  [1825] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(926),
  [1827] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(925),
  [1829] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(927),
  [1831] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(928),
  [1833] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 1),
  [1835] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_heredoc_repeat1, 1),
  [1837] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 2),
  [1839] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 2),
  [1841] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(929),
  [1843] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(930),
  [1845] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(929),
  [1847] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(932),
  [1849] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(933),
  [1851] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(935),
  [1853] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(937),
  [1855] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 4),
  [1857] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(353),
  [1860] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(939),
  [1862] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(940),
  [1864] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(942),
  [1866] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(943),
  [1868] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(945),
  [1870] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(946),
  [1872] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(947),
  [1874] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(946),
  [1876] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(948),
  [1878] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(949),
  [1880] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(950),
  [1882] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(949),
  [1884] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(951),
  [1886] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(952),
  [1888] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_array, 3),
  [1890] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_array, 3),
  [1892] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(355),
  [1895] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(357),
  [1898] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(358),
  [1901] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(359),
  [1904] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(360),
  [1907] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(361),
  [1910] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(362),
  [1913] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(363),
  [1916] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(953),
  [1918] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(954),
  [1920] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(955),
  [1922] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(956),
  [1924] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(957),
  [1926] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(958),
  [1928] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(959),
  [1930] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(961),
  [1932] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(962),
  [1934] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(963),
  [1936] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(965),
  [1938] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(381),
  [1941] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(966),
  [1943] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(967),
  [1945] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(968),
  [1947] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(969),
  [1949] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(970),
  [1951] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(971),
  [1953] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(972),
  [1955] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(974),
  [1957] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(975),
  [1959] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(976),
  [1961] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(978),
  [1963] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(979),
  [1965] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(980),
  [1967] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(982),
  [1969] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(983),
  [1971] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(985),
  [1973] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(986),
  [1975] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(987),
  [1977] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(986),
  [1979] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(988),
  [1981] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(989),
  [1983] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(990),
  [1985] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(989),
  [1987] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(991),
  [1989] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(992),
  [1991] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(400),
  [1994] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(401),
  [1997] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(400),
  [2000] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(402),
  [2003] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(403),
  [2006] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(404),
  [2009] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(405),
  [2012] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(406),
  [2015] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(407),
  [2018] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_do_group, 3),
  [2020] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2),
  [2022] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(994),
  [2024] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(995),
  [2026] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_else_clause, 2),
  [2028] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 5),
  [2030] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(997),
  [2032] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [2034] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(416),
  [2037] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(999),
  [2039] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1000),
  [2041] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5),
  [2043] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1003),
  [2045] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 1),
  [2047] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_case_statement_repeat1, 1),
  [2049] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 1),
  [2051] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1006),
  [2053] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1009),
  [2055] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1010),
  [2057] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1011),
  [2059] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1012),
  [2061] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1013),
  [2063] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1014),
  [2065] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1015),
  [2067] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1016),
  [2069] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1017),
  [2071] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1018),
  [2073] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1019),
  [2075] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1020),
  [2077] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 3),
  [2079] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1021),
  [2081] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 5, .alias_sequence_id = 4),
  [2083] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 3),
  [2085] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 3),
  [2087] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1024),
  [2089] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1025),
  [2091] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1027),
  [2093] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1029),
  [2095] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1031),
  [2097] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1032),
  [2099] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1031),
  [2101] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1034),
  [2103] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1035),
  [2105] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1046),
  [2107] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1046),
  [2109] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1047),
  [2111] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1048),
  [2113] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 5),
  [2115] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1052),
  [2117] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1053),
  [2119] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1055),
  [2121] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1056),
  [2123] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1057),
  [2125] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1059),
  [2127] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1060),
  [2129] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1061),
  [2131] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1060),
  [2133] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1062),
  [2135] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1063),
  [2137] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1064),
  [2139] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1063),
  [2141] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1065),
  [2143] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1066),
  [2145] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 6),
  [2147] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1067),
  [2149] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 4),
  [2151] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1068),
  [2153] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1069),
  [2155] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1070),
  [2157] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 4),
  [2159] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1071),
  [2161] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1072),
  [2163] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1073),
  [2165] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1074),
  [2167] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1075),
  [2169] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1076),
  [2171] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1077),
  [2173] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1078),
  [2175] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1079),
  [2177] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1080),
  [2179] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1081),
  [2181] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1082),
  [2183] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1083),
  [2185] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1084),
  [2187] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1085),
  [2189] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1086),
  [2191] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1087),
  [2193] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1088),
  [2195] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1089),
  [2197] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1090),
  [2199] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1091),
  [2201] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1092),
  [2203] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1093),
  [2205] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 4),
  [2207] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 4),
  [2209] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1095),
  [2211] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 7),
  [2213] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 7),
  [2215] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1096),
  [2217] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5),
  [2219] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5),
  [2221] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1097),
  [2223] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 8),
  [2225] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 8),
  [2227] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1098),
  [2229] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1099),
  [2231] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_array, 2),
  [2233] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1101),
  [2235] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1102),
  [2237] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1103),
  [2239] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1105),
  [2241] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1106),
  [2243] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1107),
  [2245] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1106),
  [2247] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1108),
  [2249] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1109),
  [2251] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1110),
  [2253] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1109),
  [2255] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1111),
  [2257] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1112),
  [2259] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1113),
  [2261] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_do_group, 2),
  [2263] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_do_group, 2),
  [2265] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1114),
  [2267] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 4),
  [2269] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 4),
  [2271] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1115),
  [2273] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1115),
  [2275] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1118),
  [2277] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1120),
  [2279] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1121),
  [2281] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1123),
  [2283] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_compound_statement, 2),
  [2285] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1125),
  [2287] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1126),
  [2289] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1126),
  [2291] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1127),
  [2293] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1128),
  [2295] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1129),
  [2297] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1130),
  [2299] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1131),
  [2301] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1132),
  [2303] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1133),
  [2305] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1134),
  [2307] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 4, .alias_sequence_id = 4),
  [2309] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 4, .alias_sequence_id = 4),
  [2311] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subshell, 4),
  [2313] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subshell, 4),
  [2315] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1136),
  [2317] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1137),
  [2319] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1139),
  [2321] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1141),
  [2323] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1143),
  [2325] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1144),
  [2327] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1143),
  [2329] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1146),
  [2331] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1147),
  [2333] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1156),
  [2335] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1157),
  [2337] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1158),
  [2339] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1159),
  [2341] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1160),
  [2343] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1161),
  [2345] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1162),
  [2347] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1163),
  [2349] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1164),
  [2351] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1165),
  [2353] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1166),
  [2355] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1167),
  [2357] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 4, .alias_sequence_id = 2),
  [2359] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 4, .alias_sequence_id = 2),
  [2361] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1169),
  [2363] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1170),
  [2365] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1172),
  [2367] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1173),
  [2369] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1175),
  [2371] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1176),
  [2373] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1177),
  [2375] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1176),
  [2377] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1178),
  [2379] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1179),
  [2381] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1180),
  [2383] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1179),
  [2385] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1181),
  [2387] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1182),
  [2389] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc, 2),
  [2391] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1183),
  [2393] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 4),
  [2395] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 4),
  [2397] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1186),
  [2399] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1186),
  [2401] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1187),
  [2403] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1188),
  [2405] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 5, .alias_sequence_id = 2),
  [2407] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(600),
  [2410] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1192),
  [2412] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1193),
  [2414] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1194),
  [2416] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1195),
  [2418] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1196),
  [2420] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1197),
  [2422] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1198),
  [2424] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1200),
  [2426] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1201),
  [2428] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1202),
  [2430] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1204),
  [2432] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1205),
  [2434] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1207),
  [2436] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1208),
  [2438] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1209),
  [2440] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1208),
  [2442] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1210),
  [2444] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1211),
  [2446] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1212),
  [2448] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1211),
  [2450] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 3),
  [2452] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 3),
  [2454] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 2), SHIFT_REPEAT(617),
  [2457] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 2),
  [2459] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_heredoc_repeat1, 2), SHIFT_REPEAT(619),
  [2462] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 2), SHIFT_REPEAT(620),
  [2465] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1213),
  [2467] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(630),
  [2470] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1214),
  [2472] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1215),
  [2474] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1216),
  [2476] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1217),
  [2478] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1218),
  [2480] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1219),
  [2482] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1220),
  [2484] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1222),
  [2486] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1223),
  [2488] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1224),
  [2490] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1226),
  [2492] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1227),
  [2494] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1228),
  [2496] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1229),
  [2498] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1230),
  [2500] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1231),
  [2502] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1232),
  [2504] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1233),
  [2506] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1234),
  [2508] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1235),
  [2510] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1236),
  [2512] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1237),
  [2514] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1238),
  [2516] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1239),
  [2518] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1240),
  [2520] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1241),
  [2522] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1242),
  [2524] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1243),
  [2526] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1244),
  [2528] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1245),
  [2530] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1246),
  [2532] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1247),
  [2534] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1248),
  [2536] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1249),
  [2538] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1250),
  [2540] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(674),
  [2543] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1251),
  [2545] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1252),
  [2547] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1253),
  [2549] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1254),
  [2551] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1255),
  [2553] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1256),
  [2555] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1257),
  [2557] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1259),
  [2559] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1260),
  [2561] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1261),
  [2563] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1263),
  [2565] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_for_statement, 6, .alias_sequence_id = 4),
  [2567] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 3),
  [2569] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 6),
  [2571] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1265),
  [2573] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1266),
  [2575] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1267),
  [2577] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1269),
  [2579] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1274),
  [2581] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1277),
  [2583] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1279),
  [2585] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6),
  [2587] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(707),
  [2590] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_case_statement_repeat1, 2),
  [2592] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(161),
  [2595] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(162),
  [2598] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(163),
  [2601] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(164),
  [2604] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(165),
  [2607] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(166),
  [2610] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(709),
  [2613] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1280),
  [2615] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1281),
  [2617] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1282),
  [2619] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1283),
  [2621] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1284),
  [2623] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1285),
  [2625] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1286),
  [2627] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 3),
  [2629] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1287),
  [2631] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 6, .alias_sequence_id = 4),
  [2633] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1288),
  [2635] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1289),
  [2637] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1291),
  [2639] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1292),
  [2641] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1294),
  [2643] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1295),
  [2645] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1296),
  [2647] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1295),
  [2649] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1297),
  [2651] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1298),
  [2653] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1299),
  [2655] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1298),
  [2657] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1300),
  [2659] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1301),
  [2661] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1302),
  [2663] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1303),
  [2665] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(757),
  [2668] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1307),
  [2670] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1308),
  [2672] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1309),
  [2674] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1310),
  [2676] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1311),
  [2678] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1312),
  [2680] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1313),
  [2682] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1315),
  [2684] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1316),
  [2686] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1317),
  [2688] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1319),
  [2690] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1320),
  [2692] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1321),
  [2694] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1322),
  [2696] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 4),
  [2698] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1323),
  [2700] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 7),
  [2702] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1324),
  [2704] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 5),
  [2706] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1325),
  [2708] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 8),
  [2710] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1326),
  [2712] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1327),
  [2714] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1328),
  [2716] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1329),
  [2718] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1330),
  [2720] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1331),
  [2722] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1332),
  [2724] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1333),
  [2726] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 4),
  [2728] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 4),
  [2730] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 7),
  [2732] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 7),
  [2734] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6),
  [2736] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6),
  [2738] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 8),
  [2740] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 8),
  [2742] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(816),
  [2745] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_array, 3),
  [2747] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1334),
  [2749] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1335),
  [2751] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1336),
  [2753] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1337),
  [2755] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1338),
  [2757] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1339),
  [2759] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1340),
  [2761] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1342),
  [2763] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1343),
  [2765] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1344),
  [2767] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1346),
  [2769] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_do_group, 3),
  [2771] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_do_group, 3),
  [2773] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 5),
  [2775] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 5),
  [2777] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1348),
  [2779] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 5),
  [2781] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5),
  [2783] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1350),
  [2785] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 3),
  [2787] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 3),
  [2789] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1352),
  [2791] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 5, .alias_sequence_id = 4),
  [2793] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 5, .alias_sequence_id = 4),
  [2795] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_compound_statement, 3),
  [2797] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1355),
  [2799] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1356),
  [2801] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1358),
  [2803] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1360),
  [2805] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1362),
  [2807] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1363),
  [2809] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1362),
  [2811] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1365),
  [2813] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1366),
  [2815] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subshell, 5),
  [2817] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subshell, 5),
  [2819] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1375),
  [2821] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1376),
  [2823] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1378),
  [2825] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1379),
  [2827] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1380),
  [2829] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1382),
  [2831] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1383),
  [2833] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1384),
  [2835] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1383),
  [2837] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1385),
  [2839] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1386),
  [2841] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1387),
  [2843] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1386),
  [2845] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1388),
  [2847] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1389),
  [2849] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1390),
  [2851] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1391),
  [2853] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1392),
  [2855] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1393),
  [2857] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1394),
  [2859] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1395),
  [2861] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 5, .alias_sequence_id = 2),
  [2863] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 5, .alias_sequence_id = 2),
  [2865] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(881),
  [2868] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1396),
  [2870] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1397),
  [2872] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1398),
  [2874] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1399),
  [2876] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1400),
  [2878] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1401),
  [2880] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1402),
  [2882] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1404),
  [2884] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1405),
  [2886] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1406),
  [2888] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1408),
  [2890] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc, 3),
  [2892] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1409),
  [2894] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1410),
  [2896] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1414),
  [2898] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1415),
  [2900] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1416),
  [2902] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1417),
  [2904] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1418),
  [2906] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1419),
  [2908] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1420),
  [2910] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1421),
  [2912] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1422),
  [2914] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1423),
  [2916] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1424),
  [2918] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1425),
  [2920] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1426),
  [2922] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1427),
  [2924] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1428),
  [2926] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1429),
  [2928] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1430),
  [2930] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1431),
  [2932] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1432),
  [2934] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1434),
  [2936] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1435),
  [2938] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1436),
  [2940] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1438),
  [2942] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1439),
  [2944] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1440),
  [2946] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1441),
  [2948] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1442),
  [2950] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1443),
  [2952] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1444),
  [2954] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1445),
  [2956] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1446),
  [2958] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1447),
  [2960] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1448),
  [2962] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1449),
  [2964] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1450),
  [2966] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1451),
  [2968] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1452),
  [2970] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1453),
  [2972] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1454),
  [2974] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1455),
  [2976] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1456),
  [2978] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1457),
  [2980] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1458),
  [2982] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1459),
  [2984] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1460),
  [2986] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1461),
  [2988] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1462),
  [2990] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1463),
  [2992] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1464),
  [2994] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1465),
  [2996] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1466),
  [2998] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1467),
  [3000] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1468),
  [3002] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1469),
  [3004] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1470),
  [3006] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1471),
  [3008] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1472),
  [3010] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1473),
  [3012] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1474),
  [3014] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 4),
  [3016] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 7),
  [3018] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_item_repeat1, 2),
  [3020] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_item_repeat1, 2, .alias_sequence_id = 3),
  [3022] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 3),
  [3024] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 3),
  [3026] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 3),
  [3028] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1475),
  [3030] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1476),
  [3032] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_item_repeat1, 2), SHIFT_REPEAT(999),
  [3035] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [3037] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [3039] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [3041] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1479),
  [3043] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 7),
  [3045] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1481),
  [3047] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1482),
  [3049] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 3),
  [3051] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1027),
  [3054] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1483),
  [3056] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1484),
  [3058] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1485),
  [3060] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1486),
  [3062] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1487),
  [3064] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1488),
  [3066] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1489),
  [3068] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1491),
  [3070] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1492),
  [3072] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1493),
  [3074] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1495),
  [3076] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1497),
  [3078] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1498),
  [3080] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1499),
  [3082] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1500),
  [3084] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1501),
  [3086] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1502),
  [3088] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1503),
  [3090] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1504),
  [3092] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1505),
  [3094] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1506),
  [3096] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1507),
  [3098] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1508),
  [3100] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1509),
  [3102] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1510),
  [3104] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 4),
  [3106] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 7),
  [3108] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 6),
  [3110] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 8),
  [3112] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1511),
  [3114] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1512),
  [3116] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 6),
  [3118] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 6),
  [3120] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 7),
  [3122] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 7),
  [3124] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1513),
  [3126] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1514),
  [3128] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1515),
  [3130] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1516),
  [3132] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1517),
  [3134] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1518),
  [3136] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1519),
  [3138] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1520),
  [3140] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1521),
  [3142] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1522),
  [3144] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1523),
  [3146] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1524),
  [3148] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_for_statement, 6, .alias_sequence_id = 4),
  [3150] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_for_statement, 6, .alias_sequence_id = 4),
  [3152] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 6),
  [3154] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 6),
  [3156] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1525),
  [3158] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 6),
  [3160] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6),
  [3162] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1526),
  [3164] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 3),
  [3166] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 3),
  [3168] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1527),
  [3170] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 6, .alias_sequence_id = 4),
  [3172] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 6, .alias_sequence_id = 4),
  [3174] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1528),
  [3176] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1529),
  [3178] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1531),
  [3180] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1532),
  [3182] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1534),
  [3184] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1535),
  [3186] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1536),
  [3188] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1535),
  [3190] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1537),
  [3192] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1538),
  [3194] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1539),
  [3196] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1538),
  [3198] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1540),
  [3200] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1541),
  [3202] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1137),
  [3205] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1542),
  [3207] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1543),
  [3209] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1544),
  [3211] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1545),
  [3213] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1546),
  [3215] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1547),
  [3217] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1548),
  [3219] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1550),
  [3221] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1551),
  [3223] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1552),
  [3225] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1554),
  [3227] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1555),
  [3229] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1556),
  [3231] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1557),
  [3233] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1558),
  [3235] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1559),
  [3237] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1560),
  [3239] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1561),
  [3241] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1562),
  [3243] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1563),
  [3245] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1564),
  [3247] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1565),
  [3249] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1566),
  [3251] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1567),
  [3253] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1568),
  [3255] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1570),
  [3257] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1571),
  [3259] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1572),
  [3261] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1573),
  [3263] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1574),
  [3265] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1575),
  [3267] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1576),
  [3269] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1577),
  [3271] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1578),
  [3273] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1579),
  [3275] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1580),
  [3277] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1581),
  [3279] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1582),
  [3281] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1583),
  [3283] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1584),
  [3285] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1585),
  [3287] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1586),
  [3289] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1587),
  [3291] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1588),
  [3293] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1589),
  [3295] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1590),
  [3297] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1591),
  [3299] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1592),
  [3301] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1593),
  [3303] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1594),
  [3305] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1595),
  [3307] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1596),
  [3309] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1597),
  [3311] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1598),
  [3313] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1599),
  [3315] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1600),
  [3317] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1601),
  [3319] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1602),
  [3321] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1603),
  [3323] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 4),
  [3325] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 4),
  [3327] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 4),
  [3329] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1604),
  [3331] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [3333] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [3335] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [3337] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1605),
  [3339] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1606),
  [3341] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1607),
  [3343] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1608),
  [3345] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1609),
  [3347] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1610),
  [3349] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1611),
  [3351] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1612),
  [3353] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1613),
  [3355] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1614),
  [3357] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1615),
  [3359] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1616),
  [3361] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1617),
  [3363] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1618),
  [3365] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1619),
  [3367] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1620),
  [3369] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1621),
  [3371] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1622),
  [3373] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1623),
  [3375] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 7, .alias_sequence_id = 6),
  [3377] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 7),
  [3379] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1624),
  [3381] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1625),
  [3383] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1626),
  [3385] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1627),
  [3387] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1628),
  [3389] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1629),
  [3391] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 7),
  [3393] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 7),
  [3395] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 7),
  [3397] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 7),
  [3399] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 3),
  [3401] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 3),
  [3403] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1358),
  [3406] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1630),
  [3408] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1631),
  [3410] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1632),
  [3412] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1633),
  [3414] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1634),
  [3416] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1635),
  [3418] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1636),
  [3420] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1638),
  [3422] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1639),
  [3424] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1640),
  [3426] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1642),
  [3428] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1643),
  [3430] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1644),
  [3432] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1645),
  [3434] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1646),
  [3436] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1647),
  [3438] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1648),
  [3440] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1649),
  [3442] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1650),
  [3444] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1651),
  [3446] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1652),
  [3448] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1653),
  [3450] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1654),
  [3452] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1655),
  [3454] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1656),
  [3456] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1657),
  [3458] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1658),
  [3460] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1659),
  [3462] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1660),
  [3464] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1661),
  [3466] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1662),
  [3468] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1663),
  [3470] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1664),
  [3472] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1665),
  [3474] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1666),
  [3476] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1667),
  [3478] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1668),
  [3480] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1669),
  [3482] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1670),
  [3484] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1671),
  [3486] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1672),
  [3488] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 5),
  [3490] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 5),
  [3492] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 5),
  [3494] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [3496] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [3498] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [3500] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1673),
  [3502] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1674),
  [3504] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1675),
  [3506] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1676),
  [3508] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1677),
  [3510] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1678),
  [3512] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1679),
  [3514] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1680),
  [3516] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1681),
  [3518] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1682),
  [3520] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1683),
  [3522] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1684),
  [3524] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1685),
  [3526] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1686),
  [3528] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1687),
  [3530] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1688),
  [3532] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1689),
  [3534] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1690),
  [3536] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1691),
  [3538] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1692),
  [3540] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1693),
  [3542] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1694),
  [3544] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1695),
  [3546] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1696),
  [3548] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1697),
  [3550] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1698),
  [3552] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1699),
  [3554] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1700),
  [3556] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1701),
  [3558] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1702),
  [3560] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1703),
  [3562] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1704),
  [3564] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1705),
  [3566] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1706),
  [3568] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1707),
  [3570] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1708),
  [3572] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1709),
  [3574] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1710),
  [3576] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1711),
  [3578] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1712),
  [3580] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1713),
  [3582] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1714),
  [3584] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1715),
  [3586] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1716),
};

void *tree_sitter_bash_external_scanner_create();
void tree_sitter_bash_external_scanner_destroy(void *);
bool tree_sitter_bash_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_bash_external_scanner_serialize(void *, char *);
void tree_sitter_bash_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_bash() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_bash_external_scanner_create,
      tree_sitter_bash_external_scanner_destroy,
      tree_sitter_bash_external_scanner_scan,
      tree_sitter_bash_external_scanner_serialize,
      tree_sitter_bash_external_scanner_deserialize,
    },
  };
  return &language;
}
